SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;


CREATE TABLE `additional_pages_krypto` (
  `id_additional_pages` int(11) NOT NULL,
  `name_additional_pages` varchar(50) NOT NULL,
  `url_additional_pages` text NOT NULL,
  `icon_additional_pages` varchar(255) NOT NULL,
  `svg_additional_pages` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `balance_krypto` (
  `id_balance` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `type_balance` varchar(20) NOT NULL,
  `created_balance` varchar(12) NOT NULL,
  `active_balance` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `banktransfert_accountavailable_krypto` (
  `id_banktransfert_accountavailable` int(11) NOT NULL,
  `bank_name__banktransfert_accountavailable` varchar(255) NOT NULL,
  `currency_banktransfert_accountavailable` varchar(50) NOT NULL,
  `iban_banktransfert_accountavailable` text NOT NULL,
  `bic_banktransfert_accountavailable` text NOT NULL,
  `address_banktransfert_accountavailable` text NOT NULL,
  `accountowner_banktransfert_accountavailable` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `banktransfert_krypto` (
  `id_banktransfert` int(11) NOT NULL,
  `uref_banktransfert` varchar(255) NOT NULL,
  `id_user` int(11) NOT NULL,
  `bankref_banktransfert` varchar(255) NOT NULL,
  `currency_banktransfert` varchar(20) NOT NULL,
  `created_date_banktransfert` varchar(15) NOT NULL,
  `status_banktransfert` int(11) NOT NULL DEFAULT '0',
  `update_date_banktransfert` varchar(15) NOT NULL,
  `amount_banktransfert` varchar(50) NOT NULL,
  `proecessed_banktransfert` int(11) NOT NULL DEFAULT '0',
  `bankaccount_banktransfert` int(11) DEFAULT NULL,
  `wallet_receive_banktransfert` varchar(255) NOT NULL DEFAULT 'USD',
  `amount_wallet_received_banktransfert` varchar(255) NOT NULL DEFAULT '0',
  `fees_wallet_banktransfert` varchar(255) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `banktransfert_proof_krypto` (
  `id_banktransfert_proof` int(11) NOT NULL,
  `id_banktransfert` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `url_banktransfert_proof` text NOT NULL,
  `date_banktransfert_proof` varchar(15) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `binance_krypto` (
  `id_binance` int(11) NOT NULL,
  `key_binance` longtext NOT NULL,
  `secret_binance` longtext NOT NULL,
  `id_user` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `bitbank_krypto` (
  `id_bitbank` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_bitbank` text NOT NULL,
  `secret_bitbank` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `bitmex_krypto` (
  `id_bitmex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_bitmex` text NOT NULL,
  `secret_bitmex` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `bittrex_krypto` (
  `id_bittrex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `api_key_bittrex` longtext NOT NULL,
  `api_secret_bittrex` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `blocked_user_chat_krypto` (
  `id_blocked_user_chat` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `id_user_blocked` int(11) NOT NULL,
  `date_blocked_user_chat` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `blockfolio_krypto` (
  `id_blockfolio` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `symbol_blockfolio` varchar(15) NOT NULL,
  `currency_blockfolio` varchar(15) NOT NULL,
  `market_blockfolio` varchar(50) NOT NULL DEFAULT 'CCCAGG'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `blockonomics_address_krypto` (
  `id_blockonomics_trs` int(11) NOT NULL,
  `id_user` varchar(50) NOT NULL,
  `address_blockonomics_trs` text NOT NULL,
  `date_blockonomics_trs` varchar(15) NOT NULL,
  `symbol_blockonomics_address` varchar(50) NOT NULL DEFAULT 'BTC'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `blockonomics_transactions_krypto` (
  `id_blockonomics_transactions` int(11) NOT NULL,
  `address_blockonomics_transactions` text NOT NULL,
  `id_user` varchar(25) NOT NULL,
  `txid_blockonomics_transactions` text NOT NULL,
  `date_blockonomics_transactions` varchar(15) NOT NULL,
  `status_blockonomics_transactions` int(11) NOT NULL DEFAULT '2'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `btcmarket_krypto` (
  `id_btcmarket` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_btcmarket` text NOT NULL,
  `secret_btcmarket` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `cache_krypto` (
  `id_cache` int(11) NOT NULL,
  `service_cache` longtext NOT NULL,
  `value_cache` longtext NOT NULL,
  `last_update_cache` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `cex_krypto` (
  `id_cex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_cex` longtext NOT NULL,
  `secret_cex` longtext NOT NULL,
  `uid_cex` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `charges_krypto` (
  `id_charges` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_charges` text,
  `date_charges` varchar(12) NOT NULL,
  `status_charges` varchar(10) NOT NULL,
  `ndays_charges` int(11) NOT NULL,
  `type_payment` varchar(20) DEFAULT NULL,
  `data_payment` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `coinex_krypto` (
  `id_coinex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_coinex` text NOT NULL,
  `secret_coinex` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `coinlist_krypto` (
  `id_coinlist` int(11) NOT NULL,
  `currencyid_coinlist` int(11) NOT NULL,
  `symbol_coinlist` varchar(8) NOT NULL,
  `fullname_coinlist` varchar(50) NOT NULL,
  `coinname_coinlist` varchar(50) NOT NULL,
  `order_coinlist` int(11) NOT NULL,
  `algorithm_coinlist` varchar(12) NOT NULL,
  `prooftype_coinlist` varchar(12) NOT NULL,
  `url_coinlist` varchar(60) NOT NULL,
  `status_coinslist` int(11) NOT NULL DEFAULT '1',
  `source_coinlist` varchar(50) NOT NULL DEFAULT 'cryptocompare'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(1, 4321, '42', '42 Coin (42)', '42 Coin', 34, 'Scrypt', 'PoW/PoS', '/coins/42/overview', 1, 'cryptocompare'),
(2, 749869, '300', '300 token (300)', '300 token', 2212, 'N/A', 'N/A', '/coins/300/overview', 1, 'cryptocompare'),
(3, 33639, '365', '365Coin (365)', '365Coin', 916, 'X11', 'PoW/PoS', '/coins/365/overview', 1, 'cryptocompare'),
(4, 21227, '404', '404Coin (404)', '404Coin', 602, 'Scrypt', 'PoW/PoS', '/coins/404/overview', 1, 'cryptocompare'),
(5, 20909, '611', 'SixEleven (611)', 'SixEleven', 586, 'SHA256', 'PoW', '/coins/611/overview', 1, 'cryptocompare'),
(6, 28223, '808', '808 (808)', '808', 750, 'SHA256', 'PoW/PoS', '/coins/808/overview', 1, 'cryptocompare'),
(7, 29462, '888', 'Octocoin (888)', 'Octocoin', 811, 'N/A', 'PoW', '/coins/888/overview', 1, 'cryptocompare'),
(8, 20824, '1337', '1337 (1337)', '1337', 577, 'X13', 'PoW/PoS', '/coins/1337/overview', 1, 'cryptocompare'),
(9, 3744, '2015', '2015 coin (2015)', '2015 coin', 33, 'X11', 'PoW/PoS', '/coins/2015/overview', 1, 'cryptocompare'),
(10, 1182, 'BTC', 'Bitcoin (BTC)', 'Bitcoin', 1, 'SHA256', 'PoW', '/coins/btc/overview', 1, 'cryptocompare'),
(11, 7605, 'ETH', 'Ethereum (ETH)', 'Ethereum', 2, 'Ethash', 'PoW', '/coins/eth/overview', 1, 'cryptocompare'),
(12, 3808, 'LTC', 'Litecoin (LTC)', 'Litecoin', 3, 'Scrypt', 'PoW', '/coins/ltc/overview', 1, 'cryptocompare'),
(13, 3807, 'DASH', 'Dash (DASH)', 'Dash', 4, 'X11', 'PoW/PoS', '/coins/dash/overview', 1, 'cryptocompare'),
(14, 5038, 'XMR', 'Monero (XMR)', 'Monero', 5, 'CryptoNight-', 'PoW', '/coins/xmr/overview', 1, 'cryptocompare'),
(15, 1183, 'NXT', 'Nxt (NXT)', 'Nxt', 6, 'PoS', 'PoS/LPoS', '/coins/nxt/overview', 1, 'cryptocompare'),
(16, 4432, 'DOGE', 'Dogecoin (DOGE)', 'Dogecoin', 8, 'Scrypt', 'PoW', '/coins/doge/overview', 1, 'cryptocompare'),
(17, 24854, 'ZEC', 'ZCash (ZEC)', 'ZCash', 9, 'Equihash', 'PoW', '/coins/zec/overview', 1, 'cryptocompare'),
(18, 5039, 'BTS', 'Bitshares (BTS)', 'Bitshares', 10, 'SHA-512', 'PoS', '/coins/bts/overview', 1, 'cryptocompare'),
(19, 4430, 'DGB', 'DigiByte (DGB)', 'DigiByte', 11, 'Multiple', 'PoW', '/coins/dgb/overview', 1, 'cryptocompare'),
(20, 5031, 'XRP', 'XRP (XRP)', 'XRP', 12, 'N/A', 'N/A', '/coins/xrp/overview', 1, 'cryptocompare'),
(21, 4400, 'BTCD', 'BitcoinDark (BTCD)', 'BitcoinDark', 13, 'SHA256', 'PoW/PoS', '/coins/btcd/overview', 1, 'cryptocompare'),
(22, 2349, 'PPC', 'PeerCoin (PPC)', 'PeerCoin', 14, 'N/A', 'N/A', '/coins/ppc/overview', 1, 'cryptocompare'),
(23, 4425, 'CRAIG', 'CraigsCoin (CRAIG)', 'CraigsCoin', 15, 'X11', 'PoS', '/coins/craig/overview', 1, 'cryptocompare'),
(24, 5023, 'XBS', 'Bitstake (XBS)', 'Bitstake', 16, 'X11', 'PoW/PoS', '/coins/xbs/overview', 1, 'cryptocompare'),
(25, 5030, 'XPY', 'PayCoin (XPY)', 'PayCoin', 17, 'SHA256', 'PoS', '/coins/xpy/overview', 1, 'cryptocompare'),
(26, 3638, 'PRC', 'ProsperCoin (PRC)', 'ProsperCoin', 18, 'Scrypt', 'PoW', '/coins/prc/overview', 1, 'cryptocompare'),
(27, 3639, 'YBC', 'YbCoin (YBC)', 'YbCoin', 19, 'Multiple', 'N/A', '/coins/ybc/overview', 1, 'cryptocompare'),
(28, 3640, 'DANK', 'DarkKush (DANK)', 'DarkKush', 20, 'X13', 'PoW/PoS', '/coins/dank/overview', 1, 'cryptocompare'),
(29, 3641, 'GIVE', 'GiveCoin (GIVE)', 'GiveCoin', 21, 'X11', 'PoW', '/coins/give/overview', 1, 'cryptocompare'),
(30, 3642, 'KOBO', 'KoboCoin (KOBO)', 'KoboCoin', 22, 'X15', 'PoW/PoS', '/coins/kobo/overview', 1, 'cryptocompare'),
(31, 3643, 'DT', 'DarkToken (DT)', 'DarkToken', 23, 'NIST5', 'PoW/PoS', '/coins/dt/overview', 1, 'cryptocompare'),
(32, 3644, 'CETI', 'CETUS Coin (CETI)', 'CETUS Coin', 24, 'Scrypt', 'PoW/PoS', '/coins/ceti/overview', 1, 'cryptocompare'),
(33, 3645, 'SUP', 'Supcoin (SUP)', 'Supcoin', 25, 'N/A', 'PoW', '/coins/sup/overview', 1, 'cryptocompare'),
(34, 3646, 'XPD', 'PetroDollar (XPD)', 'PetroDollar', 26, 'SHA256D', 'N/A', '/coins/xpd/overview', 1, 'cryptocompare'),
(35, 3647, 'GEO', 'GeoCoin (GEO)', 'GeoCoin', 27, 'Scrypt', 'N/A', '/coins/geo/overview', 1, 'cryptocompare'),
(36, 3648, 'CHASH', 'CleverHash (CHASH)', 'CleverHash', 28, 'N/A', 'N/A', '/coins/chash/overview', 1, 'cryptocompare'),
(37, 3649, 'SPR', 'Spreadcoin (SPR)', 'Spreadcoin', 29, 'X11', 'PoW', '/coins/spr/overview', 1, 'cryptocompare'),
(38, 3650, 'NXTI', 'NXTI (NXTI)', 'NXTI', 30, 'N/A', 'N/A', '/coins/nxti/overview', 1, 'cryptocompare'),
(39, 3653, 'WOLF', 'Insanity Coin (WOLF)', 'Insanity Coin', 31, 'X11', 'PoW', '/coins/wolf/overview', 1, 'cryptocompare'),
(40, 3655, 'XDP', 'DogeParty (XDP)', 'DogeParty', 32, 'N/A', 'N/A', '/coins/xdp/overview', 1, 'cryptocompare'),
(41, 4322, 'AC', 'Asia Coin (AC)', 'Asia Coin', 35, 'Scrypt', 'PoS', '/coins/ac/overview', 1, 'cryptocompare'),
(42, 4323, 'ACOIN', 'ACoin (ACOIN)', 'ACoin', 36, 'SHA256', 'PoW', '/coins/acoin/overview', 1, 'cryptocompare'),
(43, 4324, 'AERO', 'Aero Coin (AERO)', 'Aero Coin', 37, 'X13', 'PoS', '/coins/aero/overview', 1, 'cryptocompare'),
(44, 4325, 'ALF', 'AlphaCoin (ALF)', 'AlphaCoin', 38, 'Scrypt', 'PoW', '/coins/alf/overview', 1, 'cryptocompare'),
(45, 4326, 'AGS', 'Aegis (AGS)', 'Aegis', 39, 'X13', 'PoS', '/coins/ags/overview', 1, 'cryptocompare'),
(46, 4327, 'AMC', 'AmericanCoin (AMC)', 'AmericanCoin', 40, 'Scrypt', 'PoW', '/coins/amc/overview', 1, 'cryptocompare'),
(47, 4328, 'ALN', 'AlienCoin (ALN)', 'AlienCoin', 41, 'Scrypt', 'PoW', '/coins/aln/overview', 1, 'cryptocompare'),
(48, 4330, 'APEX', 'ApexCoin (APEX)', 'ApexCoin', 43, 'X13', 'PoW/PoS', '/coins/apex/overview', 1, 'cryptocompare'),
(49, 4331, 'ARCH', 'ArchCoin (ARCH)', 'ArchCoin', 44, 'Scrypt', 'PoS', '/coins/arch/overview', 1, 'cryptocompare'),
(50, 4371, 'ARG', 'Argentum (ARG)', 'Argentum', 45, 'Scrypt', 'PoW', '/coins/arg/overview', 1, 'cryptocompare'),
(51, 4332, 'ARI', 'AriCoin (ARI)', 'AriCoin', 46, 'Scrypt', 'PoW', '/coins/ari/overview', 1, 'cryptocompare'),
(52, 4333, 'AUR', 'Aurora Coin (AUR)', 'Aurora Coin', 47, 'Scrypt', 'PoW/PoS', '/coins/aur/overview', 1, 'cryptocompare'),
(53, 4334, 'AXR', 'AXRON (AXR)', 'AXRON', 48, 'N/A', 'N/A', '/coins/axr/overview', 1, 'cryptocompare'),
(54, 4335, 'BCX', 'BattleCoin (BCX)', 'BattleCoin', 49, 'SHA256', 'PoS', '/coins/bcx/overview', 1, 'cryptocompare'),
(55, 4336, 'BEN*', 'Benjamins (BEN*)', 'Benjamins', 50, 'SHA256', 'PoW', '/coins/benstar/overview', 1, 'cryptocompare'),
(56, 4337, 'BET', 'BetaCoin (BET)', 'BetaCoin', 51, 'SHA256', 'PoW', '/coins/bet/overview', 1, 'cryptocompare'),
(57, 4338, 'BITB', 'BitBean (BITB)', 'BitBean', 52, 'SHA256', 'PoW/PoS', '/coins/bitb/overview', 1, 'cryptocompare'),
(58, 4340, 'BLU', 'BlueCoin (BLU)', 'BlueCoin', 53, 'X11', 'PoW/PoS', '/coins/blu/overview', 1, 'cryptocompare'),
(59, 4339, 'BLK', 'BlackCoin (BLK)', 'BlackCoin', 54, 'Scrypt', 'PoS', '/coins/blk/overview', 1, 'cryptocompare'),
(60, 4342, 'BOST', 'BoostCoin (BOST)', 'BoostCoin', 56, 'X13', 'PoW/PoS', '/coins/bost/overview', 1, 'cryptocompare'),
(61, 4343, 'BQC', 'BQCoin (BQC)', 'BQCoin', 57, 'Scrypt', 'PoW', '/coins/bqc/overview', 1, 'cryptocompare'),
(62, 4345, 'XMY', 'MyriadCoin (XMY)', 'MyriadCoin', 58, 'Multiple', 'PoW', '/coins/xmy/overview', 1, 'cryptocompare'),
(63, 4346, 'MOON', 'MoonCoin (MOON)', 'MoonCoin', 59, 'Scrypt', 'PoW', '/coins/moon/overview', 1, 'cryptocompare'),
(64, 4347, 'ZET', 'ZetaCoin (ZET)', 'ZetaCoin', 60, 'SHA256', 'PoW', '/coins/zet/overview', 1, 'cryptocompare'),
(65, 4348, 'SXC', 'SexCoin (SXC)', 'SexCoin', 61, 'Scrypt', 'PoW', '/coins/sxc/overview', 1, 'cryptocompare'),
(66, 4349, 'QTL', 'Quatloo (QTL)', 'Quatloo', 62, 'Scrypt', 'PoW', '/coins/qtl/overview', 1, 'cryptocompare'),
(67, 4350, 'ENRG', 'EnergyCoin (ENRG)', 'EnergyCoin', 63, 'Scrypt', 'PoW/PoS', '/coins/enrg/overview', 1, 'cryptocompare'),
(68, 4351, 'QRK', 'QuarkCoin (QRK)', 'QuarkCoin', 64, 'Multiple', 'PoW', '/coins/qrk/overview', 1, 'cryptocompare'),
(69, 4352, 'RIC', 'Riecoin (RIC)', 'Riecoin', 65, 'Groestl', 'PoW', '/coins/ric/overview', 1, 'cryptocompare'),
(70, 4353, 'DGC', 'DigiCoin (DGC)', 'DigiCoin', 66, 'Scrypt', 'PoW', '/coins/dgc/overview', 1, 'cryptocompare'),
(71, 4354, 'LIMX', 'LimeCoinX (LIMX)', 'LimeCoinX', 67, 'X11', 'PoW', '/coins/limx/overview', 1, 'cryptocompare'),
(72, 4399, 'BTB', 'BitBar (BTB)', 'BitBar', 69, 'Scrypt', 'PoW/PoS', '/coins/btb/overview', 1, 'cryptocompare'),
(73, 4406, 'CAIX', 'CAIx (CAIx)', 'CAIx', 70, 'Scrypt', 'PoS', '/coins/caix/overview', 1, 'cryptocompare'),
(74, 4401, 'BTE', 'ByteCoin (BTE)', 'ByteCoin', 71, 'SHA256', 'PoW', '/coins/bte/overview', 1, 'cryptocompare'),
(75, 4402, 'BTG*', 'BitGem (BTG*)', 'BitGem', 72, 'Scrypt', 'PoW/PoS', '/coins/btgstar/overview', 1, 'cryptocompare'),
(76, 4403, 'BTM', 'BitMark (BTM)', 'BitMark', 73, 'Scrypt', 'PoW', '/coins/btm/overview', 1, 'cryptocompare'),
(77, 4404, 'BUK', 'CryptoBuk (BUK)', 'CryptoBuk', 74, 'Scrypt', 'PoW/PoS', '/coins/buk/overview', 1, 'cryptocompare'),
(78, 4405, 'CACH', 'Cachecoin (CACH)', 'Cachecoin', 75, 'Scrypt', 'PoW', '/coins/cach/overview', 1, 'cryptocompare'),
(79, 4407, 'CANN', 'CannabisCoin (CANN)', 'CannabisCoin', 76, 'X11', 'PoW', '/coins/cann/overview', 1, 'cryptocompare'),
(80, 4408, 'CAP', 'BottleCaps (CAP)', 'BottleCaps', 77, 'Scrypt', 'PoW/PoS', '/coins/cap/overview', 1, 'cryptocompare'),
(81, 4409, 'CASH', 'CashCoin (CASH)', 'CashCoin', 78, 'Scrypt', 'PoW/PoS', '/coins/cash/overview', 1, 'cryptocompare'),
(82, 4410, 'CAT1', 'Catcoin (CAT1)', 'Catcoin', 79, 'Scrypt', 'PoW', '/coins/cat1/overview', 1, 'cryptocompare'),
(83, 4411, 'CBX', 'CryptoBullion (CBX)', 'CryptoBullion', 80, 'Scrypt', 'PoW/PoS', '/coins/cbx/overview', 1, 'cryptocompare'),
(84, 4412, 'CCN', 'CannaCoin (CCN)', 'CannaCoin', 81, 'Scrypt', 'PoW', '/coins/ccn/overview', 1, 'cryptocompare'),
(85, 4413, 'CIN', 'CinderCoin (CIN)', 'CinderCoin', 82, 'Multiple', 'PoW/PoS', '/coins/cin/overview', 1, 'cryptocompare'),
(86, 4414, 'CINNI', 'CINNICOIN (CINNI)', 'CINNICOIN', 83, 'Scrypt', 'PoW', '/coins/cinni/overview', 1, 'cryptocompare'),
(87, 4415, 'CXC', 'CheckCoin (CXC)', 'CheckCoin', 84, 'N/A', 'PoS', '/coins/cxc/overview', 1, 'cryptocompare'),
(88, 4416, 'CLAM', 'CLAMS (CLAM)', 'CLAMS', 85, 'N/A', 'PoW', '/coins/clam/overview', 1, 'cryptocompare'),
(89, 4417, 'CLOAK', 'CloakCoin (CLOAK)', 'CloakCoin', 86, 'X13', 'PoW/PoS', '/coins/cloak/overview', 1, 'cryptocompare'),
(90, 4418, 'CLR', 'CopperLark (CLR)', 'CopperLark', 87, 'SHA256', 'PoW', '/coins/clr/overview', 1, 'cryptocompare'),
(91, 4419, 'CMC', 'CosmosCoin (CMC)', 'CosmosCoin', 88, 'Scrypt', 'PoW/PoS', '/coins/cmc/overview', 1, 'cryptocompare'),
(92, 4420, 'CNC', 'ChinaCoin (CNC)', 'ChinaCoin', 89, 'Scrypt', 'PoW', '/coins/cnc/overview', 1, 'cryptocompare'),
(93, 4421, 'CNL', 'ConcealCoin (CNL)', 'ConcealCoin', 90, 'X11', 'PoW', '/coins/cnl/overview', 1, 'cryptocompare'),
(94, 4422, 'COMM', 'Community Coin (COMM)', 'Community Coin', 91, 'Scrypt', 'PoW/PoS', '/coins/comm/overview', 1, 'cryptocompare'),
(95, 4423, 'COOL', 'CoolCoin (COOL)', 'CoolCoin', 92, 'Scrypt', 'PoS', '/coins/cool/overview', 1, 'cryptocompare'),
(96, 4424, 'CRACK', 'CrackCoin (CRACK)', 'CrackCoin', 93, 'X11', 'PoW', '/coins/crack/overview', 1, 'cryptocompare'),
(97, 4426, 'CRC*', 'CraftCoin (CRC*)', 'CraftCoin', 94, 'Scrypt', 'PoW', '/coins/crcstar/overview', 1, 'cryptocompare'),
(98, 4427, 'CRYPT', 'CryptCoin (CRYPT)', 'CryptCoin', 95, 'X11', 'PoW', '/coins/crypt/overview', 1, 'cryptocompare'),
(99, 4428, 'CSC', 'CasinoCoin (CSC)', 'CasinoCoin', 96, 'N/A', 'PoC', '/coins/csc/overview', 1, 'cryptocompare'),
(100, 4429, 'DEM', 'eMark (DEM)', 'eMark', 97, 'SHA256', 'PoW/PoS', '/coins/dem/overview', 1, 'cryptocompare'),
(101, 4431, 'DMD', 'Diamond (DMD)', 'Diamond', 98, 'Groestl', 'PoW/PoS', '/coins/dmd/overview', 1, 'cryptocompare'),
(102, 4433, 'XVG', 'Verge (XVG)', 'Verge', 99, 'Multiple', 'PoW', '/coins/xvg/overview', 1, 'cryptocompare'),
(103, 4434, 'DRKC', 'DarkCash (DRKC)', 'DarkCash', 100, 'X11', 'PoW/PoS', '/coins/drkc/overview', 1, 'cryptocompare'),
(104, 4435, 'DSB', 'DarkShibe (DSB)', 'DarkShibe', 101, 'Scrypt', 'PoW', '/coins/dsb/overview', 1, 'cryptocompare'),
(105, 4436, 'DVC', 'DevCoin (DVC)', 'DevCoin', 102, 'SHA256', 'PoW', '/coins/dvc/overview', 1, 'cryptocompare'),
(106, 4437, 'EAC', 'EarthCoin (EAC)', 'EarthCoin', 103, 'Scrypt', 'PoW', '/coins/eac/overview', 1, 'cryptocompare'),
(107, 4438, 'EFL', 'E-Gulden (EFL)', 'E-Gulden', 104, 'Scrypt', 'PoW', '/coins/efl/overview', 1, 'cryptocompare'),
(108, 4439, 'ELC', 'Elacoin (ELC)', 'Elacoin', 105, 'Scrypt', 'PoW', '/coins/elc/overview', 1, 'cryptocompare'),
(109, 4440, 'EMC2', 'Einsteinium (EMC2)', 'Einsteinium', 106, 'Scrypt', 'PoW', '/coins/emc2/overview', 1, 'cryptocompare'),
(110, 4441, 'EMD', 'Emerald (EMD)', 'Emerald', 107, 'Scrypt', 'PoW', '/coins/emd/overview', 1, 'cryptocompare'),
(111, 4442, 'EXCL', 'Exclusive Coin (EXCL)', 'Exclusive Coin', 108, 'PoS', 'PoS', '/coins/excl/overview', 1, 'cryptocompare'),
(112, 4443, 'EXE', 'ExeCoin (EXE)', 'ExeCoin', 109, 'Scrypt', 'PoW', '/coins/exe/overview', 1, 'cryptocompare'),
(113, 4444, 'EZC', 'EZCoin (EZC)', 'EZCoin', 110, 'Scrypt', 'PoW', '/coins/ezc/overview', 1, 'cryptocompare'),
(114, 4445, 'FLAP', 'Flappy Coin (FLAP)', 'Flappy Coin', 111, 'Scrypt', 'PoW', '/coins/flap/overview', 1, 'cryptocompare'),
(115, 4446, 'FC2', 'Fuel2Coin (FC2)', 'Fuel2Coin', 112, 'X11', 'PoS', '/coins/fc2/overview', 1, 'cryptocompare'),
(116, 4447, 'FFC', 'FireflyCoin (FFC)', 'FireflyCoin', 113, 'SHA256', 'PoW', '/coins/ffc/overview', 1, 'cryptocompare'),
(117, 4448, 'FIBRE', 'FIBRE (FIBRE)', 'FIBRE', 114, 'NIST5', 'PoW/PoS', '/coins/fibre/overview', 1, 'cryptocompare'),
(118, 4521, 'FRC', 'FireRoosterCoin (FRC)', 'FireRoosterCoin', 115, 'SHA256', 'PoW', '/coins/frc/overview', 1, 'cryptocompare'),
(119, 4449, 'FLT', 'FlutterCoin (FLT)', 'FlutterCoin', 116, 'Scrypt', 'PoS/PoW/PoT', '/coins/flt/overview', 1, 'cryptocompare'),
(120, 4522, 'FRK', 'Franko (FRK)', 'Franko', 117, 'Scrypt', 'PoW', '/coins/frk/overview', 1, 'cryptocompare'),
(121, 4450, 'FRAC', 'FractalCoin (FRAC)', 'FractalCoin', 118, 'X11', 'PoW', '/coins/frac/overview', 1, 'cryptocompare'),
(122, 4523, 'FST', 'FastCoin (FST)', 'FastCoin', 119, 'Scrypt', 'PoW', '/coins/fst/overview', 1, 'cryptocompare'),
(123, 4524, 'FTC', 'FeatherCoin (FTC)', 'FeatherCoin', 120, 'NeoScrypt', 'PoW', '/coins/ftc/overview', 1, 'cryptocompare'),
(124, 4526, 'GDC', 'GrandCoin (GDC)', 'GrandCoin', 122, 'Scrypt', 'PoW', '/coins/gdc/overview', 1, 'cryptocompare'),
(125, 4527, 'GLC', 'GlobalCoin (GLC)', 'GlobalCoin', 123, 'Scrypt', 'PoW', '/coins/glc/overview', 1, 'cryptocompare'),
(126, 4528, 'GLD', 'GoldCoin (GLD)', 'GoldCoin', 124, 'Scrypt', 'PoW', '/coins/gld/overview', 1, 'cryptocompare'),
(127, 4529, 'GLX', 'GalaxyCoin (GLX)', 'GalaxyCoin', 125, 'Scrypt', 'PoW/PoS', '/coins/glx/overview', 1, 'cryptocompare'),
(128, 4530, 'GLYPH', 'GlyphCoin (GLYPH)', 'GlyphCoin', 126, 'X11', 'PoW/PoS', '/coins/glyph/overview', 1, 'cryptocompare'),
(129, 4531, 'GML', 'GameLeagueCoin (GML)', 'GameLeagueCoin', 127, 'Scrypt', 'PoW/PoS', '/coins/gml/overview', 1, 'cryptocompare'),
(130, 4532, 'GUE', 'GuerillaCoin (GUE)', 'GuerillaCoin', 128, 'X11', 'PoW/PoS', '/coins/gue/overview', 1, 'cryptocompare'),
(131, 4533, 'HAL', 'Halcyon (HAL)', 'Halcyon', 129, 'X15', 'PoW/PoS', '/coins/hal/overview', 1, 'cryptocompare'),
(132, 4534, 'HBN', 'HoboNickels (HBN)', 'HoboNickels', 130, 'Scrypt', 'PoW/PoS', '/coins/hbn/overview', 1, 'cryptocompare'),
(133, 4535, 'HUC', 'HunterCoin (HUC)', 'HunterCoin', 131, 'Multiple', 'PoW', '/coins/huc/overview', 1, 'cryptocompare'),
(134, 4536, 'HVC', 'HeavyCoin (HVC)', 'HeavyCoin', 132, 'Multiple', 'PoW', '/coins/hvc/overview', 1, 'cryptocompare'),
(135, 4537, 'HYP', 'Hyperstake (HYP)', 'Hyperstake', 133, 'X11', 'PoW/PoS', '/coins/hyp/overview', 1, 'cryptocompare'),
(136, 4538, 'ICB', 'IceBergCoin (ICB)', 'IceBergCoin', 134, 'NIST5', 'PoW/PoS', '/coins/icb/overview', 1, 'cryptocompare'),
(137, 4539, 'IFC', 'Infinite Coin (IFC)', 'Infinite Coin', 135, 'Scrypt', 'PoW', '/coins/ifc/overview', 1, 'cryptocompare'),
(138, 4540, 'IOC', 'IOCoin (IOC)', 'IOCoin', 136, 'X11', 'PoW/PoS', '/coins/ioc/overview', 1, 'cryptocompare'),
(139, 4541, 'IXC', 'IXcoin (IXC)', 'IXcoin', 137, 'SHA256', 'PoW', '/coins/ixc/overview', 1, 'cryptocompare'),
(140, 4542, 'JBS', 'JumBucks Coin (JBS)', 'JumBucks Coin', 138, 'X11', 'PoW/PoS', '/coins/jbs/overview', 1, 'cryptocompare'),
(141, 4543, 'JKC', 'JunkCoin (JKC)', 'JunkCoin', 139, 'Scrypt', 'PoW', '/coins/jkc/overview', 1, 'cryptocompare'),
(142, 4544, 'JUDGE', 'JudgeCoin (JUDGE)', 'JudgeCoin', 140, 'X13', 'PoW/PoS', '/coins/judge/overview', 1, 'cryptocompare'),
(143, 4545, 'KDC', 'Klondike Coin (KDC)', 'Klondike Coin', 141, 'Scrypt', 'PoW', '/coins/kdc/overview', 1, 'cryptocompare'),
(144, 4546, 'KEY*', 'KeyCoin (KEY*)', 'KeyCoin', 142, 'X13', 'PoW/PoS', '/coins/keystar/overview', 1, 'cryptocompare'),
(145, 4547, 'KGC', 'KrugerCoin (KGC)', 'KrugerCoin', 143, 'Scrypt', 'PoW', '/coins/kgc/overview', 1, 'cryptocompare'),
(146, 4548, 'LAB*', 'CoinWorksCoin (LAB*)', 'CoinWorksCoin', 144, 'Multiple', 'PoW', '/coins/labstar/overview', 1, 'cryptocompare'),
(147, 4549, 'LGD*', 'Legendary Coin (LGD*)', 'Legendary Coin', 145, 'Scrypt', 'PoW/PoS', '/coins/lgdstar/overview', 1, 'cryptocompare'),
(148, 4550, 'LK7', 'Lucky7Coin (LK7)', 'Lucky7Coin', 146, 'Scrypt', 'PoW/PoS', '/coins/lk7/overview', 1, 'cryptocompare'),
(149, 4551, 'LKY', 'LuckyCoin (LKY)', 'LuckyCoin', 147, 'Scrypt', 'PoW', '/coins/lky/overview', 1, 'cryptocompare'),
(150, 4552, 'LSD', 'LightSpeedCoin (LSD)', 'LightSpeedCoin', 148, 'NIST5', 'PoW/PoS', '/coins/lsd/overview', 1, 'cryptocompare'),
(151, 4553, 'LTB', 'Litebar  (LTB)', 'Litebar ', 149, 'Scrypt', 'PoW', '/coins/ltb/overview', 1, 'cryptocompare'),
(152, 4554, 'LTCD', 'LitecoinDark (LTCD)', 'LitecoinDark', 150, 'Scrypt', 'PoW', '/coins/ltcd/overview', 1, 'cryptocompare'),
(153, 4555, 'LTCX', 'LitecoinX (LTCX)', 'LitecoinX', 151, 'X11', 'PoW', '/coins/ltcx/overview', 1, 'cryptocompare'),
(154, 4556, 'LXC', 'LibrexCoin (LXC)', 'LibrexCoin', 152, 'X11', 'PoW/PoS', '/coins/lxc/overview', 1, 'cryptocompare'),
(155, 4557, 'LYC', 'LycanCoin (LYC)', 'LycanCoin', 153, 'Scrypt', 'PoW', '/coins/lyc/overview', 1, 'cryptocompare'),
(156, 4558, 'MAX', 'MaxCoin (MAX)', 'MaxCoin', 154, 'SHA3', 'PoW/PoS', '/coins/max/overview', 1, 'cryptocompare'),
(157, 4559, 'MEC', 'MegaCoin (MEC)', 'MegaCoin', 155, 'Scrypt', 'PoW', '/coins/mec/overview', 1, 'cryptocompare'),
(158, 4560, 'MED', 'MediterraneanCoin (MED)', 'MediterraneanCoin', 156, 'HybridScrypt', 'PoW', '/coins/med/overview', 1, 'cryptocompare'),
(159, 4561, 'MIN', 'Minerals Coin (MIN)', 'Minerals Coin', 157, 'X11', 'PoW/PoS', '/coins/min/overview', 1, 'cryptocompare'),
(160, 4562, 'MINT', 'MintCoin (MINT)', 'MintCoin', 158, 'Scrypt', 'PoS', '/coins/mint/overview', 1, 'cryptocompare'),
(161, 4563, 'MN', 'Cryptsy Mining Contract (MN)', 'Cryptsy Mining Contract', 159, 'SHA256', 'PoW', '/coins/mn/overview', 1, 'cryptocompare'),
(162, 4564, 'MNC', 'MinCoin (MNC)', 'MinCoin', 160, 'Scrypt', 'PoW', '/coins/mnc/overview', 1, 'cryptocompare'),
(163, 4566, 'MRY', 'MurrayCoin (MRY)', 'MurrayCoin', 162, 'Scrypt', 'PoW', '/coins/mry/overview', 1, 'cryptocompare'),
(164, 4567, 'MYST*', 'MysteryCoin (MYST*)', 'MysteryCoin', 163, 'X11', 'PoW', '/coins/myststar/overview', 1, 'cryptocompare'),
(165, 4568, 'MZC', 'MazaCoin (MZC)', 'MazaCoin', 164, 'SHA256', 'PoW/PoS', '/coins/mzc/overview', 1, 'cryptocompare'),
(166, 4569, 'NAN', 'NanoToken (NAN)', 'NanoToken', 165, 'Scrypt', 'PoW', '/coins/nan/overview', 1, 'cryptocompare'),
(167, 4570, 'NAUT', 'Nautilus Coin (NAUT)', 'Nautilus Coin', 166, 'Scrypt', 'PoS', '/coins/naut/overview', 1, 'cryptocompare'),
(168, 4571, 'NAV', 'NavCoin (NAV)', 'NavCoin', 167, 'X13', 'PoW/PoS', '/coins/nav/overview', 1, 'cryptocompare'),
(169, 4572, 'NBL', 'Nybble (NBL)', 'Nybble', 168, 'Scrypt', 'PoW', '/coins/nbl/overview', 1, 'cryptocompare'),
(170, 4573, 'NEC', 'NeoCoin (NEC)', 'NeoCoin', 169, 'Scrypt', 'PoW/PoS', '/coins/nec/overview', 1, 'cryptocompare'),
(171, 4574, 'NET', 'NetCoin (NET)', 'NetCoin', 170, 'Scrypt', 'PoW', '/coins/net/overview', 1, 'cryptocompare'),
(172, 4575, 'NMB', 'Nimbus Coin (NMB)', 'Nimbus Coin', 171, 'X15', 'PoW/PoS', '/coins/nmb/overview', 1, 'cryptocompare'),
(173, 4576, 'NRB', 'NoirBits (NRB)', 'NoirBits', 172, 'SHA256', 'PoW', '/coins/nrb/overview', 1, 'cryptocompare'),
(174, 4577, 'NOBL', 'NobleCoin (NOBL)', 'NobleCoin', 173, 'Scrypt', 'PoW', '/coins/nobl/overview', 1, 'cryptocompare'),
(175, 4578, 'NRS', 'NoirShares (NRS)', 'NoirShares', 174, 'Scrypt', 'PoW/PoS', '/coins/nrs/overview', 1, 'cryptocompare'),
(176, 4579, 'NVC', 'NovaCoin (NVC)', 'NovaCoin', 175, 'Scrypt', 'PoW/PoS', '/coins/nvc/overview', 1, 'cryptocompare'),
(177, 4580, 'NMC', 'Namecoin (NMC)', 'Namecoin', 176, 'SHA256', 'PoW', '/coins/nmc/overview', 1, 'cryptocompare'),
(178, 4581, 'NYAN', 'NyanCoin (NYAN)', 'NyanCoin', 177, 'Scrypt', 'PoW', '/coins/nyan/overview', 1, 'cryptocompare'),
(179, 4582, 'OPAL', 'OpalCoin (OPAL)', 'OpalCoin', 178, 'X13', 'PoW/PoS', '/coins/opal/overview', 1, 'cryptocompare'),
(180, 4583, 'ORB', 'Orbitcoin (ORB)', 'Orbitcoin', 179, 'NeoScrypt', 'PoW/PoS', '/coins/orb/overview', 1, 'cryptocompare'),
(181, 4584, 'OSC', 'OpenSourceCoin (OSC)', 'OpenSourceCoin', 180, 'SHA256', 'PoW/PoS', '/coins/osc/overview', 1, 'cryptocompare'),
(182, 4585, 'PHS', 'PhilosophersStone (PHS)', 'PhilosophersStone', 181, 'Scrypt', 'PoW', '/coins/phs/overview', 1, 'cryptocompare'),
(183, 4586, 'POINTS', 'Cryptsy Points (POINTS)', 'Cryptsy Points', 182, 'N/A', 'N/A', '/coins/points/overview', 1, 'cryptocompare'),
(184, 4587, 'POT', 'PotCoin (POT)', 'PotCoin', 183, 'Scrypt', 'PoW', '/coins/pot/overview', 1, 'cryptocompare'),
(185, 4588, 'PSEUD', 'PseudoCash (PSEUD)', 'PseudoCash', 184, 'X13', 'PoW/PoS', '/coins/pseud/overview', 1, 'cryptocompare'),
(186, 4589, 'PTS*', 'Protoshares (PTS*)', 'Protoshares', 185, 'SHA256', 'PoW', '/coins/ptsstar/overview', 1, 'cryptocompare'),
(187, 4590, 'PXC', 'PhoenixCoin (PXC)', 'PhoenixCoin', 186, 'Scrypt', 'PoW/PoS', '/coins/pxc/overview', 1, 'cryptocompare'),
(188, 4591, 'PYC', 'PayCoin (PYC)', 'PayCoin', 187, 'Scrypt', 'PoW/PoS', '/coins/pyc/overview', 1, 'cryptocompare'),
(189, 4592, 'RDD', 'Reddcoin (RDD)', 'Reddcoin', 188, 'Scrypt', 'PoW/PoS', '/coins/rdd/overview', 1, 'cryptocompare'),
(190, 4593, 'RIPO', 'RipOffCoin (RIPO)', 'RipOffCoin', 189, 'Scrypt', 'PoW', '/coins/ripo/overview', 1, 'cryptocompare'),
(191, 4594, 'RPC', 'RonPaulCoin (RPC)', 'RonPaulCoin', 190, 'Scrypt', 'PoW', '/coins/rpc/overview', 1, 'cryptocompare'),
(192, 4595, 'RT2', 'RotoCoin (RT2)', 'RotoCoin', 191, 'Scrypt-n', 'PoW/PoS', '/coins/rt2/overview', 1, 'cryptocompare'),
(193, 4596, 'RYC', 'RoyalCoin (RYC)', 'RoyalCoin', 192, 'Scrypt', 'PoW', '/coins/ryc/overview', 1, 'cryptocompare'),
(194, 4597, 'RZR', 'RazorCoin (RZR)', 'RazorCoin', 193, 'Scrypt', 'PoW', '/coins/rzr/overview', 1, 'cryptocompare'),
(195, 4598, 'SAT2', 'Saturn2Coin (SAT2)', 'Saturn2Coin', 194, 'Scrypt', 'PoW', '/coins/sat2/overview', 1, 'cryptocompare'),
(196, 4599, 'SBC', 'StableCoin (SBC)', 'StableCoin', 195, 'Scrypt', 'PoW', '/coins/sbc/overview', 1, 'cryptocompare'),
(197, 4600, 'SDC', 'ShadowCash (SDC)', 'ShadowCash', 196, 'Scrypt', 'PoW/PoS', '/coins/sdc/overview', 1, 'cryptocompare'),
(198, 4601, 'SFR', 'SaffronCoin (SFR)', 'SaffronCoin', 197, 'Multiple', 'PoW', '/coins/sfr/overview', 1, 'cryptocompare'),
(199, 4602, 'SHADE', 'ShadeCoin (SHADE)', 'ShadeCoin', 198, 'Scrypt', 'PoW/PoS', '/coins/shade/overview', 1, 'cryptocompare'),
(200, 4603, 'SHLD', 'ShieldCoin (SHLD)', 'ShieldCoin', 199, 'X15', 'PoW/PoS', '/coins/shld/overview', 1, 'cryptocompare'),
(201, 4604, 'SILK', 'SilkCoin (SILK)', 'SilkCoin', 200, 'Scrypt', 'PoW/PoS', '/coins/silk/overview', 1, 'cryptocompare'),
(202, 4605, 'SLG', 'SterlingCoin (SLG)', 'SterlingCoin', 201, 'X13', 'PoS', '/coins/slg/overview', 1, 'cryptocompare'),
(203, 4606, 'SMC', 'SmartCoin (SMC)', 'SmartCoin', 202, 'Scrypt', 'PoW', '/coins/smc/overview', 1, 'cryptocompare'),
(204, 4607, 'SOLE', 'SoleCoin (SOLE)', 'SoleCoin', 203, 'X15', 'PoW/PoS', '/coins/sole/overview', 1, 'cryptocompare'),
(205, 4608, 'SPA', 'SpainCoin (SPA)', 'SpainCoin', 204, 'Scrypt-n', 'PoW', '/coins/spa/overview', 1, 'cryptocompare'),
(206, 4609, 'SPT', 'Spots (SPT)', 'Spots', 205, 'Scrypt', 'PoW', '/coins/spt/overview', 1, 'cryptocompare'),
(207, 4611, 'SRC', 'SecureCoin (SRC)', 'SecureCoin', 206, 'Scrypt', 'PoW', '/coins/src/overview', 1, 'cryptocompare'),
(208, 4613, 'SSV', 'SSVCoin (SSV)', 'SSVCoin', 207, 'X13', 'PoW', '/coins/ssv/overview', 1, 'cryptocompare'),
(209, 4614, 'XLM', 'Stellar (XLM)', 'Stellar', 208, 'N/A', 'N/A', '/coins/xlm/overview', 1, 'cryptocompare'),
(210, 4615, 'SUPER', 'SuperCoin (SUPER)', 'SuperCoin', 209, 'X11', 'PoS', '/coins/super/overview', 1, 'cryptocompare'),
(211, 4616, 'SWIFT', 'BitSwift (SWIFT)', 'BitSwift', 210, 'Scrypt', 'PoW/PoS', '/coins/swift/overview', 1, 'cryptocompare'),
(212, 4617, 'SYNC', 'SyncCoin (SYNC)', 'SyncCoin', 211, 'X11', 'PoW/PoS', '/coins/sync/overview', 1, 'cryptocompare'),
(213, 4618, 'SYS', 'SysCoin (SYS)', 'SysCoin', 212, 'SHA256', 'PoW', '/coins/sys/overview', 1, 'cryptocompare'),
(214, 4619, 'TAG', 'TagCoin (TAG)', 'TagCoin', 213, 'Scrypt', 'PoW/PoS', '/coins/tag/overview', 1, 'cryptocompare'),
(215, 4620, 'TAK', 'TakCoin (TAK)', 'TakCoin', 214, 'SHA256', 'PoW/PoS', '/coins/tak/overview', 1, 'cryptocompare'),
(216, 4622, 'TES', 'TeslaCoin (TES)', 'TeslaCoin', 215, 'Multiple', 'PoW/PoS', '/coins/tes/overview', 1, 'cryptocompare'),
(217, 4623, 'TGC', 'TigerCoin (TGC)', 'TigerCoin', 216, 'SHA256', 'PoW', '/coins/tgc/overview', 1, 'cryptocompare'),
(218, 4624, 'TIT', 'TitCoin (TIT)', 'TitCoin', 217, 'SHA256', 'PoW', '/coins/tit/overview', 1, 'cryptocompare'),
(219, 4625, 'TOR', 'TorCoin (TOR)', 'TorCoin', 218, 'X11', 'PoW/PoS', '/coins/tor/overview', 1, 'cryptocompare'),
(220, 4626, 'TRC', 'TerraCoin (TRC)', 'TerraCoin', 219, 'SHA256', 'PoW', '/coins/trc/overview', 1, 'cryptocompare'),
(221, 4627, 'TTC', 'TittieCoin (TTC)', 'TittieCoin', 220, 'Scrypt', 'PoW', '/coins/ttc/overview', 1, 'cryptocompare'),
(222, 4628, 'ULTC', 'Umbrella (ULTC)', 'Umbrella', 221, 'SHA256', 'PoW', '/coins/ultc/overview', 1, 'cryptocompare'),
(223, 4629, 'UNB', 'UnbreakableCoin (UNB)', 'UnbreakableCoin', 222, 'SHA256', 'PoW', '/coins/unb/overview', 1, 'cryptocompare'),
(224, 4630, 'UNO', 'Unobtanium (UNO)', 'Unobtanium', 223, 'SHA256', 'PoW', '/coins/uno/overview', 1, 'cryptocompare'),
(225, 4631, 'URO', 'UroCoin (URO)', 'UroCoin', 224, 'X11', 'PoW', '/coins/uro/overview', 1, 'cryptocompare'),
(226, 5011, 'USDE', 'UnitaryStatus Dollar (USDE)', 'UnitaryStatus Dollar', 225, 'Scrypt', 'PoW/PoS', '/coins/usde/overview', 1, 'cryptocompare'),
(227, 5012, 'UTC', 'UltraCoin (UTC)', 'UltraCoin', 226, 'Scrypt', 'PoW/PoS', '/coins/utc/overview', 1, 'cryptocompare'),
(228, 5013, 'UTIL', 'Utility Coin (UTIL)', 'Utility Coin', 227, 'X13', 'PoW/PoS', '/coins/util/overview', 1, 'cryptocompare'),
(229, 5014, 'VDO', 'VidioCoin (VDO)', 'VidioCoin', 228, 'X11', 'PoW/PoS', '/coins/vdo/overview', 1, 'cryptocompare'),
(230, 5015, 'VIA', 'ViaCoin (VIA)', 'ViaCoin', 229, 'Scrypt', 'PoW', '/coins/via/overview', 1, 'cryptocompare'),
(231, 5016, 'VOOT', 'VootCoin (VOOT)', 'VootCoin', 230, 'X11', 'PoW', '/coins/voot/overview', 1, 'cryptocompare'),
(232, 5017, 'VRC', 'VeriCoin (VRC)', 'VeriCoin', 231, 'Scrypt', 'PoST', '/coins/vrc/overview', 1, 'cryptocompare'),
(233, 5019, 'WC', 'WhiteCoin (WC)', 'WhiteCoin', 233, 'Scrypt', 'PoW/PoS', '/coins/wc/overview', 1, 'cryptocompare'),
(234, 5020, 'WDC', 'WorldCoin (WDC)', 'WorldCoin', 234, 'Scrypt', 'PoW', '/coins/wdc/overview', 1, 'cryptocompare'),
(235, 5021, 'XAI', 'SapienceCoin (XAI)', 'SapienceCoin', 235, 'X11', 'PoB/PoS', '/coins/xai/overview', 1, 'cryptocompare'),
(236, 5022, 'XBOT', 'SocialXbotCoin (XBOT)', 'SocialXbotCoin', 236, 'Scrypt', 'PoW/PoS', '/coins/xbot/overview', 1, 'cryptocompare'),
(237, 5024, 'XC', 'X11 Coin (XC)', 'X11 Coin', 237, 'X11', 'PoW/PoS', '/coins/xc/overview', 1, 'cryptocompare'),
(238, 5025, 'XCASH', 'Xcash (XCASH)', 'Xcash', 238, 'Scrypt', 'PoW/PoS', '/coins/xcash/overview', 1, 'cryptocompare'),
(239, 5026, 'XCR', 'Crypti (XCR)', 'Crypti', 239, 'Multiple', 'PoS', '/coins/xcr/overview', 1, 'cryptocompare'),
(240, 5027, 'XJO', 'JouleCoin (XJO)', 'JouleCoin', 240, 'SHA256', 'PoW', '/coins/xjo/overview', 1, 'cryptocompare'),
(241, 5028, 'XLB', 'LibertyCoin (XLB)', 'LibertyCoin', 241, 'X11', 'PoW/PoS', '/coins/xlb/overview', 1, 'cryptocompare'),
(242, 5029, 'XPM', 'PrimeCoin (XPM)', 'PrimeCoin', 242, 'Multiple', 'PoW', '/coins/xpm/overview', 1, 'cryptocompare'),
(243, 5032, 'XST', 'StealthCoin (XST)', 'StealthCoin', 243, 'X13', 'PoW/PoS', '/coins/xst/overview', 1, 'cryptocompare'),
(244, 5033, 'XXX', 'XXXCoin (XXX)', 'XXXCoin', 244, 'Scrypt', 'PoW/PoS', '/coins/xxx/overview', 1, 'cryptocompare'),
(245, 5034, 'YAC', 'YAcCoin (YAC)', 'YAcCoin', 245, 'Scrypt', 'PoW', '/coins/yac/overview', 1, 'cryptocompare'),
(246, 5035, 'ZCC', 'ZCC Coin (ZCC)', 'ZCC Coin', 246, 'Scrypt', 'PoW', '/coins/zcc/overview', 1, 'cryptocompare'),
(247, 5036, 'ZED', 'ZedCoins (ZED)', 'ZedCoins', 247, 'Scrypt', 'PoW', '/coins/zed/overview', 1, 'cryptocompare'),
(248, 5037, 'ZRC*', 'ZiftrCoin (ZRC*)', 'ZiftrCoin', 248, 'X11', 'PoW', '/coins/zrcstar/overview', 1, 'cryptocompare'),
(249, 5280, 'BCN', 'ByteCoin (BCN)', 'ByteCoin', 249, 'CryptoNight', 'PoW', '/coins/bcn/overview', 1, 'cryptocompare'),
(250, 5281, 'EKN', 'Elektron (EKN)', 'Elektron', 250, 'X13', 'PoW/PoS', '/coins/ekn/overview', 1, 'cryptocompare'),
(251, 5282, 'XDN', 'DigitalNote  (XDN)', 'DigitalNote ', 251, 'CryptoNight', 'PoW', '/coins/xdn/overview', 1, 'cryptocompare'),
(252, 5283, 'XAU', 'XauCoin (XAU)', 'XauCoin', 252, 'SHA256', 'PoW', '/coins/xau/overview', 1, 'cryptocompare'),
(253, 5284, 'TMC', 'TimesCoin (TMC)', 'TimesCoin', 253, 'N/A', 'N/A', '/coins/tmc/overview', 1, 'cryptocompare'),
(254, 5285, 'XEM', 'NEM (XEM)', 'NEM', 254, 'N/A', 'PoI', '/coins/xem/overview', 1, 'cryptocompare'),
(255, 5286, 'BURST', 'BurstCoin (BURST)', 'BurstCoin', 255, 'Shabal256', 'PoC', '/coins/burst/overview', 1, 'cryptocompare'),
(256, 5287, 'NBT', 'NuBits (NBT)', 'NuBits', 256, 'SHA256', 'PoS', '/coins/nbt/overview', 1, 'cryptocompare'),
(257, 5288, 'SJCX', 'StorjCoin (SJCX)', 'StorjCoin', 257, 'Counterparty', 'PoS', '/coins/sjcx/overview', 1, 'cryptocompare'),
(258, 5289, 'START', 'StartCoin (START)', 'StartCoin', 258, 'X11', 'PoW', '/coins/start/overview', 1, 'cryptocompare'),
(259, 5290, 'HUGE', 'BigCoin (HUGE)', 'BigCoin', 259, 'Blake', 'PoW', '/coins/huge/overview', 1, 'cryptocompare'),
(260, 5292, 'XCP', 'CounterParty (XCP)', 'CounterParty', 261, 'N/A', 'PoW', '/coins/xcp/overview', 1, 'cryptocompare'),
(261, 5293, 'MAID', 'MaidSafe Coin (MAID)', 'MaidSafe Coin', 262, 'N/A', 'N/A', '/coins/maid/overview', 1, 'cryptocompare'),
(262, 5294, '007', '007 coin (007)', '007 coin', 263, 'Scrypt', 'PoW', '/coins/007/overview', 1, 'cryptocompare'),
(263, 5295, 'NSR', 'NuShares (NSR)', 'NuShares', 264, 'N/A', 'PoS', '/coins/nsr/overview', 1, 'cryptocompare'),
(264, 5296, 'MONA', 'MonaCoin (MONA)', 'MonaCoin', 265, 'Scrypt', 'PoW', '/coins/mona/overview', 1, 'cryptocompare'),
(265, 5297, 'CELL', 'SolarFarm (CELL)', 'SolarFarm', 266, 'N/A', 'PoW', '/coins/cell/overview', 1, 'cryptocompare'),
(266, 5298, 'TEK', 'TekCoin (TEK)', 'TekCoin', 267, 'SHA256', 'PoW/PoS', '/coins/tek/overview', 1, 'cryptocompare'),
(267, 5299, 'TRON', 'Positron (TRON)', 'Positron', 268, 'SHA256', 'PoW/PoS', '/coins/tron/overview', 1, 'cryptocompare'),
(268, 5300, 'BAY', 'BitBay (BAY)', 'BitBay', 269, 'N/A', 'PoS', '/coins/bay/overview', 1, 'cryptocompare'),
(269, 5301, 'NTRN', 'Neutron (NTRN)', 'Neutron', 270, 'SHA256', 'PoW/PoS', '/coins/ntrn/overview', 1, 'cryptocompare'),
(270, 5302, 'SLING', 'Sling Coin (SLING)', 'Sling Coin', 271, 'SHA256', 'PoW', '/coins/sling/overview', 1, 'cryptocompare'),
(271, 5303, 'XVC', 'Vcash (XVC)', 'Vcash', 272, 'Whirlpool', 'PoS', '/coins/xvc/overview', 1, 'cryptocompare'),
(272, 5304, 'CRAVE', 'CraveCoin (CRAVE)', 'CraveCoin', 273, 'Scrypt', 'PoW/PoS', '/coins/crave/overview', 1, 'cryptocompare'),
(273, 5305, 'BLOCK', 'BlockNet (BLOCK)', 'BlockNet', 274, 'N/A', 'PoW/PoS', '/coins/block/overview', 1, 'cryptocompare'),
(274, 5306, 'XSI', 'Stability Shares (XSI)', 'Stability Shares', 275, 'Scrypt', 'PoW/PoS', '/coins/xsi/overview', 1, 'cryptocompare'),
(275, 5307, 'GHS*', 'Giga Hash (GHS*)', 'Giga Hash', 276, 'N/A', 'N/A', '/coins/ghsstar/overview', 1, 'cryptocompare'),
(276, 5308, 'BYC', 'ByteCent (BYC)', 'ByteCent', 277, 'N/A', 'PoW', '/coins/byc/overview', 1, 'cryptocompare'),
(277, 5309, 'GRC', 'GridCoin (GRC)', 'GridCoin', 278, 'Scrypt', 'DPoR', '/coins/grc/overview', 1, 'cryptocompare'),
(278, 5310, 'GEMZ', 'Gemz Social (GEMZ)', 'Gemz Social', 279, 'N/A', 'PoW', '/coins/gemz/overview', 1, 'cryptocompare'),
(279, 5311, 'KTK', 'KryptCoin (KTK)', 'KryptCoin', 280, 'Scrypt', 'PoS', '/coins/ktk/overview', 1, 'cryptocompare'),
(280, 5312, 'HZ', 'Horizon (HZ)', 'Horizon', 281, 'N/A', 'PoS', '/coins/hz/overview', 1, 'cryptocompare'),
(281, 5313, 'FAIR', 'FairCoin (FAIR)', 'FairCoin', 282, 'Groestl', 'PoW/PoS', '/coins/fair/overview', 1, 'cryptocompare'),
(282, 5314, 'QORA', 'QoraCoin (QORA)', 'QoraCoin', 283, 'N/A', 'PoS', '/coins/qora/overview', 1, 'cryptocompare'),
(283, 5315, 'NLG', 'Gulden (NLG)', 'Gulden', 284, 'Scrypt', 'PoW', '/coins/nlg/overview', 1, 'cryptocompare'),
(284, 5316, 'RBY', 'RubyCoin (RBY)', 'RubyCoin', 285, 'Scrypt', 'PoS', '/coins/rby/overview', 1, 'cryptocompare'),
(285, 5317, 'PTC', 'PesetaCoin (PTC)', 'PesetaCoin', 286, 'Scrypt', 'PoW', '/coins/ptc/overview', 1, 'cryptocompare'),
(286, 5318, 'KORE', 'Kore (KORE)', 'Kore', 287, 'X13', 'PoW/PoS', '/coins/kore/overview', 1, 'cryptocompare'),
(287, 5319, 'WBB', 'Wild Beast Coin (WBB)', 'Wild Beast Coin', 288, 'Scrypt', 'PoW', '/coins/wbb/overview', 1, 'cryptocompare'),
(288, 5320, 'SSD', 'Sonic Screw Driver Coin (SSD)', 'Sonic Screw Driver Coin', 289, 'SHA256', 'PoW/PoS', '/coins/ssd/overview', 1, 'cryptocompare'),
(289, 5321, 'XTC', 'TileCoin (XTC)', 'TileCoin', 290, 'N/A', 'N/A', '/coins/xtc/overview', 1, 'cryptocompare'),
(290, 5322, 'NOTE', 'Dnotes (NOTE)', 'Dnotes', 291, 'X13', 'PoS', '/coins/note/overview', 1, 'cryptocompare'),
(291, 5323, 'GRID*', 'GridPay (GRID*)', 'GridPay', 292, 'N/A', 'N/A', '/coins/gridstar/overview', 1, 'cryptocompare'),
(292, 5325, 'FLO', 'FlorinCoin (FLO)', 'FlorinCoin', 293, 'Scrypt', 'PoW', '/coins/flo/overview', 1, 'cryptocompare'),
(293, 5326, 'MMXIV', 'MaieutiCoin (MMXIV)', 'MaieutiCoin', 294, 'SHA256', 'PoS', '/coins/mmxiv/overview', 1, 'cryptocompare'),
(294, 5327, '8BIT', '8BIT Coin (8BIT)', '8BIT Coin', 295, 'Scrypt', 'PoW/PoS', '/coins/8bit/overview', 1, 'cryptocompare'),
(295, 5328, 'STV', 'Sativa Coin (STV)', 'Sativa Coin', 296, 'X13', 'PoW/PoS', '/coins/stv/overview', 1, 'cryptocompare'),
(296, 5329, 'EBS', 'EbolaShare (EBS)', 'EbolaShare', 297, 'N/A', 'PoS', '/coins/ebs/overview', 1, 'cryptocompare'),
(297, 5330, 'AM', 'AeroMe (AM)', 'AeroMe', 298, 'X13', 'PoW/PoS', '/coins/am/overview', 1, 'cryptocompare'),
(298, 5331, 'XMG', 'Coin Magi (XMG)', 'Coin Magi', 299, 'M7M', 'PoW/PoM/PoSI', '/coins/xmg/overview', 1, 'cryptocompare'),
(299, 5332, 'AMBER', 'AmberCoin (AMBER)', 'AmberCoin', 300, 'X11', 'PoW/PoS', '/coins/amber/overview', 1, 'cryptocompare'),
(300, 5333, 'JPC*', 'JackPotCoin (JPC*)', 'JackPotCoin', 301, 'SHA3', 'PoW/PoS', '/coins/jpcstar/overview', 1, 'cryptocompare'),
(301, 5334, 'NKT', 'NakomotoDark (NKT)', 'NakomotoDark', 302, 'X11', 'PoW/PoS', '/coins/nkt/overview', 1, 'cryptocompare'),
(302, 5335, 'J', 'JoinCoin (J)', 'JoinCoin', 303, 'Multiple', 'PoW', '/coins/j/overview', 1, 'cryptocompare'),
(303, 5336, 'GHC', 'GhostCoin (GHC)', 'GhostCoin', 304, 'Scrypt', 'PoW/PoS', '/coins/ghc/overview', 1, 'cryptocompare'),
(304, 5337, 'DTC*', 'DayTrader Coin (DTC)', 'DayTrader Coin', 305, 'X13', 'PoW/PoS', '/coins/dtc/overview', 1, 'cryptocompare'),
(305, 5338, 'ABY', 'ArtByte (ABY)', 'ArtByte', 306, 'Scrypt', 'PoW', '/coins/aby/overview', 1, 'cryptocompare'),
(306, 5339, 'LDOGE', 'LiteDoge (LDOGE)', 'LiteDoge', 307, 'Scrypt', 'PoW/PoS', '/coins/ldoge/overview', 1, 'cryptocompare'),
(307, 5340, 'MTR', 'MasterTraderCoin (MTR)', 'MasterTraderCoin', 308, 'X11', 'PoW/PoS', '/coins/mtr/overview', 1, 'cryptocompare'),
(308, 5341, 'TRI', 'Triangles Coin (TRI)', 'Triangles Coin', 309, 'X13', 'PoW/PoS', '/coins/tri/overview', 1, 'cryptocompare'),
(309, 5342, 'SWARM', 'SwarmCoin (SWARM)', 'SwarmCoin', 310, 'N/A', 'N/A', '/coins/swarm/overview', 1, 'cryptocompare'),
(310, 5343, 'BBR', 'Boolberry (BBR)', 'Boolberry', 311, 'X11', 'PoW', '/coins/bbr/overview', 1, 'cryptocompare'),
(311, 5344, 'BTCRY', 'BitCrystal (BTCRY)', 'BitCrystal', 312, 'N/A', 'N/A', '/coins/btcry/overview', 1, 'cryptocompare'),
(312, 5345, 'BCR', 'BitCredit (BCR)', 'BitCredit', 313, 'Momentum', 'PoW', '/coins/bcr/overview', 1, 'cryptocompare'),
(313, 5346, 'XPB', 'Pebble Coin (XPB)', 'Pebble Coin', 314, 'CryptoNight', 'PoW', '/coins/xpb/overview', 1, 'cryptocompare'),
(314, 5347, 'XDQ', 'Dirac Coin (XDQ)', 'Dirac Coin', 315, 'Blake', 'PoW', '/coins/xdq/overview', 1, 'cryptocompare'),
(315, 5348, 'FLDC', 'Folding Coin (FLDC)', 'Folding Coin', 316, 'Stanford Fol', 'PoW', '/coins/fldc/overview', 1, 'cryptocompare'),
(316, 5349, 'SLR', 'SolarCoin (SLR)', 'SolarCoin', 317, 'Scrypt', 'PoW', '/coins/slr/overview', 1, 'cryptocompare'),
(317, 5350, 'SMAC', 'Social Media Coin (SMAC)', 'Social Media Coin', 318, 'X11', 'PoW/PoS', '/coins/smac/overview', 1, 'cryptocompare'),
(318, 5351, 'TRK', 'TruckCoin (TRK)', 'TruckCoin', 319, 'X11', 'PoW/PoS', '/coins/trk/overview', 1, 'cryptocompare'),
(319, 5352, 'U', 'Ucoin (U)', 'Ucoin', 320, 'X11', 'PoS', '/coins/u/overview', 1, 'cryptocompare'),
(320, 5353, 'UIS', 'Unitus (UIS)', 'Unitus', 321, 'Multiple', 'PoW', '/coins/uis/overview', 1, 'cryptocompare'),
(321, 5354, 'CYP', 'CypherPunkCoin (CYP)', 'CypherPunkCoin', 322, 'QuBit', 'PoW', '/coins/cyp/overview', 1, 'cryptocompare'),
(322, 5355, 'UFO', 'UFO Coin (UFO)', 'UFO Coin', 323, 'NeoScrypt', 'PoW', '/coins/ufo/overview', 1, 'cryptocompare'),
(323, 5356, 'ASN', 'Ascension Coin (ASN)', 'Ascension Coin', 324, 'QuBit', 'PoW/PoS', '/coins/asn/overview', 1, 'cryptocompare'),
(324, 5357, 'OC', 'OrangeCoin (OC)', 'OrangeCoin', 325, 'Scrypt', 'PoW/PoS', '/coins/oc/overview', 1, 'cryptocompare'),
(325, 5358, 'GSM', 'GSM Coin (GSM)', 'GSM Coin', 326, 'X11', 'PoW/PoS', '/coins/gsm/overview', 1, 'cryptocompare'),
(326, 5359, 'FSC', 'FriendshipCoin (FSC)', 'FriendshipCoin', 327, 'NeoScrypt', 'PoW/PoS', '/coins/fsc/overview', 1, 'cryptocompare'),
(327, 5360, 'NXTTY', 'NXTTY (NXTTY)', 'NXTTY', 328, 'N/A', 'N/A', '/coins/nxtty/overview', 1, 'cryptocompare'),
(328, 5361, 'QBK', 'QuBuck Coin (QBK)', 'QuBuck Coin', 329, 'X13', 'PoS/PoB', '/coins/qbk/overview', 1, 'cryptocompare'),
(329, 5362, 'BLC', 'BlakeCoin (BLC)', 'BlakeCoin', 330, 'Blake', 'PoW', '/coins/blc/overview', 1, 'cryptocompare'),
(330, 5363, 'MARYJ', 'MaryJane Coin (MARYJ)', 'MaryJane Coin', 331, 'X15', 'PoW/PoS', '/coins/maryj/overview', 1, 'cryptocompare'),
(331, 5365, 'OMC', 'OmniCron (OMC)', 'OmniCron', 333, 'Scrypt', 'PoW', '/coins/omc/overview', 1, 'cryptocompare'),
(332, 5366, 'GIG', 'GigCoin (GIG)', 'GigCoin', 334, 'X11', 'PoW', '/coins/gig/overview', 1, 'cryptocompare'),
(333, 5367, 'CC', 'CyberCoin (CC)', 'CyberCoin', 335, 'Scrypt', 'PoW/PoS', '/coins/cc/overview', 1, 'cryptocompare'),
(334, 5368, 'BITS', 'BitstarCoin (BITS)', 'BitstarCoin', 336, 'Scrypt', 'PoW/PoS', '/coins/bits/overview', 1, 'cryptocompare'),
(335, 5369, 'LTBC', 'LTBCoin (LTBC)', 'LTBCoin', 337, 'N/A', 'PoP/PoV/PoQ', '/coins/ltbc/overview', 1, 'cryptocompare'),
(336, 5370, 'NEOS', 'NeosCoin (NEOS)', 'NeosCoin', 338, 'SHA256', 'PoS', '/coins/neos/overview', 1, 'cryptocompare'),
(337, 5371, 'HYPER', 'HyperCoin (HYPER)', 'HyperCoin', 339, 'Scrypt', 'PoW/PoS', '/coins/hyper/overview', 1, 'cryptocompare'),
(338, 5372, 'VTR', 'Vtorrent (VTR)', 'Vtorrent', 340, 'Scrypt', 'PoW/PoS', '/coins/vtr/overview', 1, 'cryptocompare'),
(339, 5373, 'METAL', 'MetalCoin (METAL)', 'MetalCoin', 341, 'Scrypt', 'PoW', '/coins/metal/overview', 1, 'cryptocompare'),
(340, 5374, 'PINK', 'PinkCoin (PINK)', 'PinkCoin', 342, 'X11', 'PoW/PoS', '/coins/pink/overview', 1, 'cryptocompare'),
(341, 5375, 'GRE', 'GreenCoin (GRE)', 'GreenCoin', 343, 'Scrypt', 'PoW', '/coins/gre/overview', 1, 'cryptocompare'),
(342, 5376, 'XG', 'XG Sports (XG)', 'XG Sports', 344, 'XG Hash', 'PoW/PoS', '/coins/xg/overview', 1, 'cryptocompare'),
(343, 5377, 'CHILD', 'ChildCoin (CHILD)', 'ChildCoin', 345, 'X11', 'PoW', '/coins/child/overview', 1, 'cryptocompare'),
(344, 5379, 'MINE', 'Instamine Nuggets (MINE)', 'Instamine Nuggets', 347, 'Scrypt', 'PoW', '/coins/mine/overview', 1, 'cryptocompare'),
(345, 5380, 'ROS', 'ROS Coin (ROS)', 'ROS Coin', 348, 'X11', 'PoW/PoS', '/coins/ros/overview', 1, 'cryptocompare'),
(346, 5381, 'UNAT', 'Unattanium (UNAT)', 'Unattanium', 349, 'SHA256', 'PoW', '/coins/unat/overview', 1, 'cryptocompare'),
(347, 5382, 'SLM', 'SlimCoin (SLM)', 'SlimCoin', 350, 'N/A', 'PoB', '/coins/slm/overview', 1, 'cryptocompare'),
(348, 5383, 'GAIA', 'GAIA Platform (GAIA)', 'GAIA Platform', 351, 'X11', 'PoS', '/coins/gaia/overview', 1, 'cryptocompare'),
(349, 5384, 'TRUST', 'TrustPlus (TRUST)', 'TrustPlus', 352, 'X11', 'PoW/PoS', '/coins/trust/overview', 1, 'cryptocompare'),
(350, 5385, 'FCN', 'FantomCoin  (FCN)', 'FantomCoin ', 353, 'CryptoNight', 'PoW', '/coins/fcn/overview', 1, 'cryptocompare'),
(351, 5386, 'XCN', 'Cryptonite (XCN)', 'Cryptonite', 354, 'M7 POW', 'PoW', '/coins/xcn/overview', 1, 'cryptocompare'),
(352, 5387, 'CURE', 'Curecoin (CURE)', 'Curecoin', 355, 'Scrypt', 'PoW', '/coins/cure/overview', 1, 'cryptocompare'),
(353, 5388, 'GMC', 'Gridmaster (GMC)', 'Gridmaster', 356, 'Scrypt', 'PoW', '/coins/gmc/overview', 1, 'cryptocompare'),
(354, 5389, 'MMC', 'MemoryCoin (MMC)', 'MemoryCoin', 357, 'Multiple', 'PoW', '/coins/mmc/overview', 1, 'cryptocompare'),
(355, 5391, 'XBC', 'BitcoinPlus (XBC)', 'BitcoinPlus', 359, 'Scrypt', 'PoW/PoS', '/coins/xbc/overview', 1, 'cryptocompare'),
(356, 5392, 'CYC', 'ConSpiracy Coin  (CYC)', 'ConSpiracy Coin ', 360, 'X11', 'PoW', '/coins/cyc/overview', 1, 'cryptocompare'),
(357, 5393, 'OCTO', 'OctoCoin (OCTO)', 'OctoCoin', 361, 'N/A', 'N/A', '/coins/octo/overview', 1, 'cryptocompare'),
(358, 5394, 'MSC', 'MasterCoin (MSC)', 'MasterCoin', 362, 'Scrypt', 'PoW', '/coins/msc/overview', 1, 'cryptocompare'),
(359, 5395, 'EGG', 'EggCoin (EGG)', 'EggCoin', 363, 'Scrypt', 'PoW/PoS', '/coins/egg/overview', 1, 'cryptocompare'),
(360, 5396, 'C2', 'Coin.2 (C2)', 'Coin.2', 364, 'Scrypt', 'PoW/PoS', '/coins/c2/overview', 1, 'cryptocompare'),
(361, 5397, 'GSX', 'GlowShares (GSX)', 'GlowShares', 365, 'N/A', 'PoS', '/coins/gsx/overview', 1, 'cryptocompare'),
(362, 5398, 'CAM', 'Camcoin (CAM)', 'Camcoin', 366, 'X11', 'PoW/PoS', '/coins/cam/overview', 1, 'cryptocompare'),
(363, 5399, 'RBR', 'Ribbit Rewards (RBR)', 'Ribbit Rewards', 367, 'Multiple', 'PoW', '/coins/rbr/overview', 1, 'cryptocompare'),
(364, 5400, 'XQN', 'Quotient (XQN)', 'Quotient', 368, 'Scrypt', 'PoW/PoS', '/coins/xqn/overview', 1, 'cryptocompare'),
(365, 5401, 'ICASH', 'ICASH (ICASH)', 'ICASH', 369, 'X11', 'PoW', '/coins/icash/overview', 1, 'cryptocompare'),
(366, 5402, 'NODE', 'Node (NODE)', 'Node', 370, 'Curve25519', 'PoA', '/coins/node/overview', 1, 'cryptocompare'),
(367, 5403, 'SOON', 'SoonCoin (SOON)', 'SoonCoin', 371, 'SHA256', 'PoW', '/coins/soon/overview', 1, 'cryptocompare'),
(368, 5404, 'BTMI', 'BitMiles (BTMI)', 'BitMiles', 372, 'Scrypt', 'PoW', '/coins/btmi/overview', 1, 'cryptocompare'),
(369, 5405, 'EVENT', 'Event Token (EVENT)', 'Event Token', 373, 'Scrypt', 'PoW/PoS', '/coins/event/overview', 1, 'cryptocompare'),
(370, 5406, '1CR', '1Credit (1CR)', '1Credit', 374, 'Scrypt', 'PoW', '/coins/1cr/overview', 1, 'cryptocompare'),
(371, 5407, 'VIOR', 'ViorCoin (VIOR)', 'ViorCoin', 375, 'Scrypt', 'PoW/PoS', '/coins/vior/overview', 1, 'cryptocompare'),
(372, 5408, 'XCO', 'XCoin (XCO)', 'XCoin', 376, 'SHA256', 'PoW/PoS', '/coins/xco/overview', 1, 'cryptocompare'),
(373, 5409, 'VMC', 'VirtualMining Coin (VMC)', 'VirtualMining Coin', 377, 'Scrypt-n', 'PoW', '/coins/vmc/overview', 1, 'cryptocompare'),
(374, 5410, 'MRS', 'MarsCoin (MRS)', 'MarsCoin', 378, 'X11', 'PoW', '/coins/mrs/overview', 1, 'cryptocompare'),
(375, 6088, 'VIRAL', 'Viral Coin (VIRAL)', 'Viral Coin', 379, 'Scrypt', 'PoS', '/coins/viral/overview', 1, 'cryptocompare'),
(376, 6093, 'EQM', 'Equilibrium Coin (EQM)', 'Equilibrium Coin', 380, 'SHA256', 'PoW/PoS', '/coins/eqm/overview', 1, 'cryptocompare'),
(377, 6094, 'ISL', 'IslaCoin (ISL)', 'IslaCoin', 381, 'X11', 'PoW/PoS', '/coins/isl/overview', 1, 'cryptocompare'),
(378, 6095, 'QSLV', 'Quicksilver coin (QSLV)', 'Quicksilver coin', 382, 'X11', 'PoW', '/coins/qslv/overview', 1, 'cryptocompare'),
(379, 6096, 'XWT', 'World Trade Funds (XWT)', 'World Trade Funds', 383, 'X15', 'PoW/PoS', '/coins/xwt/overview', 1, 'cryptocompare'),
(380, 6097, 'XNA', 'DeOxyRibose (XNA)', 'DeOxyRibose', 384, 'X11', 'PoS', '/coins/xna/overview', 1, 'cryptocompare'),
(381, 6098, 'RDN', 'RadonPay (RDN)', 'RadonPay', 385, 'N/A', 'PoS', '/coins/rdn/overview', 1, 'cryptocompare'),
(382, 6099, 'SKB', 'SkullBuzz (SKB)', 'SkullBuzz', 386, 'SHA256', 'PoS', '/coins/skb/overview', 1, 'cryptocompare'),
(383, 6100, 'BSTY', 'GlobalBoost (BSTY)', 'GlobalBoost', 387, 'Yescript', 'PoW', '/coins/bsty/overview', 1, 'cryptocompare'),
(384, 6101, 'FCS', 'CryptoFocus (FCS)', 'CryptoFocus', 388, 'X11', 'PoW/PoS', '/coins/fcs/overview', 1, 'cryptocompare'),
(385, 6102, 'GAM', 'Gambit coin (GAM)', 'Gambit coin', 389, 'Scrypt', 'PoW/PoS', '/coins/gam/overview', 1, 'cryptocompare'),
(386, 6103, 'NXS', 'Nexus (NXS)', 'Nexus', 390, 'SHA3', 'PoW/nPoS', '/coins/nxs/overview', 1, 'cryptocompare'),
(387, 6104, 'CESC', 'Crypto Escudo (CESC)', 'Crypto Escudo', 391, 'Scrypt', 'PoW', '/coins/cesc/overview', 1, 'cryptocompare'),
(388, 6105, 'TWLV', 'Twelve Coin (TWLV)', 'Twelve Coin', 392, 'T-Inside', 'PoW/PoS', '/coins/twlv/overview', 1, 'cryptocompare'),
(389, 6106, 'EAGS', 'EagsCoin (EAGS)', 'EagsCoin', 393, 'X11', 'PoW/PoS', '/coins/eags/overview', 1, 'cryptocompare'),
(390, 6107, 'MWC', 'MultiWallet Coin (MWC)', 'MultiWallet Coin', 394, 'X11', 'PoW/PoS', '/coins/mwc/overview', 1, 'cryptocompare'),
(391, 6108, 'ADC', 'AudioCoin (ADC)', 'AudioCoin', 395, 'Scrypt', 'PoW/PoS', '/coins/adc/overview', 1, 'cryptocompare'),
(392, 6109, 'MARS', 'MarsCoin  (MARS)', 'MarsCoin ', 396, 'X11', 'PoW', '/coins/mars/overview', 1, 'cryptocompare'),
(393, 6110, 'XMS', 'Megastake (XMS)', 'Megastake', 397, 'X11', 'PoW/PoS', '/coins/xms/overview', 1, 'cryptocompare'),
(394, 6111, 'SPHR', 'Sphere Coin (SPHR)', 'Sphere Coin', 398, 'Scrypt', 'PoW/PoS', '/coins/sphr/overview', 1, 'cryptocompare'),
(395, 6112, 'SIGU', 'Singular (SIGU)', 'Singular', 399, 'Scrypt', 'PoW/PoS', '/coins/sigu/overview', 1, 'cryptocompare'),
(396, 6113, 'BTX*', 'BitcoinTX (BTX*)', 'BitcoinTX', 400, 'X11', 'PoS', '/coins/btxstar/overview', 1, 'cryptocompare'),
(397, 6114, 'DCC', 'DarkCrave (DCC)', 'DarkCrave', 401, 'SHA256', 'PoW/PoS', '/coins/dcc/overview', 1, 'cryptocompare'),
(398, 6115, 'M1', 'SupplyShock (M1)', 'SupplyShock', 402, 'X13', 'PoW/PoS', '/coins/m1/overview', 1, 'cryptocompare'),
(399, 6116, 'DB', 'DarkBit (DB)', 'DarkBit', 403, 'Scrypt', 'PoW/PoS', '/coins/db/overview', 1, 'cryptocompare'),
(400, 6117, 'CTO', 'Crypto (CTO)', 'Crypto', 404, 'Lyra2RE', 'PoW', '/coins/cto/overview', 1, 'cryptocompare'),
(401, 6339, 'EDGE', 'EdgeCoin (EDGE)', 'EdgeCoin', 405, 'SHA256', 'PoW/HiPoS', '/coins/edge/overview', 1, 'cryptocompare'),
(402, 6341, 'LUX*', 'BitLux (LUX*)', 'BitLux', 406, 'X11', 'PoW/PoS', '/coins/luxstar/overview', 1, 'cryptocompare'),
(403, 6343, 'FUTC', 'FutCoin (FUTC)', 'FutCoin', 407, 'X13', 'PoW/PoS', '/coins/futc/overview', 1, 'cryptocompare'),
(404, 6393, 'GLOBE', 'Global (GLOBE)', 'Global', 408, 'N/A', 'PoS', '/coins/globe/overview', 1, 'cryptocompare'),
(405, 6411, 'TAM', 'TamaGucci (TAM)', 'TamaGucci', 409, 'Scrypt', 'PoW/PoS/PoC', '/coins/tam/overview', 1, 'cryptocompare'),
(406, 6412, 'MRP', 'MorpheusCoin (MRP)', 'MorpheusCoin', 410, 'X11', 'PoW', '/coins/mrp/overview', 1, 'cryptocompare'),
(407, 6451, 'CREVA', 'Creva Coin (CREVA)', 'Creva Coin', 411, 'X11', 'N/A', '/coins/creva/overview', 1, 'cryptocompare'),
(408, 6452, 'XFC', 'Forever Coin (XFC)', 'Forever Coin', 412, 'X11', 'PoS', '/coins/xfc/overview', 1, 'cryptocompare'),
(409, 6453, 'NANAS', 'BananaBits (NANAS)', 'BananaBits', 413, 'Scrypt', 'PoW/PoS', '/coins/nanas/overview', 1, 'cryptocompare'),
(410, 6454, 'LOG', 'Wood Coin (LOG)', 'Wood Coin', 414, 'N/A', 'PoW', '/coins/log/overview', 1, 'cryptocompare'),
(411, 6455, 'XCE', 'Cerium (XCE)', 'Cerium', 415, 'SHA256', 'PoW/PoS', '/coins/xce/overview', 1, 'cryptocompare'),
(412, 6476, 'ACP', 'Anarchists Prime (ACP)', 'Anarchists Prime', 416, 'SHA256', 'PoW', '/coins/acp/overview', 1, 'cryptocompare'),
(413, 7480, 'DRZ', 'Droidz (DRZ)', 'Droidz', 417, 'QUAIT', 'PoW/PoS', '/coins/drz/overview', 1, 'cryptocompare'),
(414, 7481, 'BUCKS*', 'GorillaBucks (BUCKS*)', 'GorillaBucks', 418, 'N/A', 'PoS', '/coins/bucksstar/overview', 1, 'cryptocompare'),
(415, 7482, 'BSC', 'BowsCoin (BSC)', 'BowsCoin', 419, 'X11', 'PoW', '/coins/bsc/overview', 1, 'cryptocompare'),
(416, 7483, 'DRKT', 'DarkTron (DRKT)', 'DarkTron', 420, 'SHA256', 'PoW/PoS', '/coins/drkt/overview', 1, 'cryptocompare'),
(417, 7484, 'CIRC', 'CryptoCircuits (CIRC)', 'CryptoCircuits', 421, 'vDPOS', 'PoS', '/coins/circ/overview', 1, 'cryptocompare'),
(418, 7559, 'NKA', 'IncaKoin (NKA)', 'IncaKoin', 422, 'SHA256', 'PoW/PoS', '/coins/nka/overview', 1, 'cryptocompare'),
(419, 7562, 'VERSA', 'Versa Token (VERSA)', 'Versa Token', 423, 'N/A', 'PoS', '/coins/versa/overview', 1, 'cryptocompare'),
(420, 7564, 'EPY', 'Empyrean (EPY)', 'Empyrean', 424, 'Scrypt', 'PoW', '/coins/epy/overview', 1, 'cryptocompare'),
(421, 7565, 'SQL', 'Squall Coin (SQL)', 'Squall Coin', 425, 'X11', 'PoS/PoW', '/coins/sql/overview', 1, 'cryptocompare'),
(422, 7567, 'POLY', 'PolyBit (POLY)', 'PolyBit', 426, 'Scrypt', 'PoW', '/coins/poly/overview', 1, 'cryptocompare'),
(423, 7577, 'PIGGY', 'Piggy Coin (PIGGY)', 'Piggy Coin', 427, 'X11', 'PoW/PoS', '/coins/piggy/overview', 1, 'cryptocompare'),
(424, 7580, 'CHA', 'Charity Coin (CHA)', 'Charity Coin', 428, 'Scrypt', 'PoW', '/coins/cha/overview', 1, 'cryptocompare'),
(425, 7581, 'MIL', 'Milllionaire Coin (MIL)', 'Milllionaire Coin', 429, 'X11', 'PoW/PoS', '/coins/mil/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(426, 7586, 'CRW', 'Crown Coin (CRW)', 'Crown Coin', 430, 'SHA256', 'PoW', '/coins/crw/overview', 1, 'cryptocompare'),
(427, 7588, 'GEN', 'Genstake (GEN*)', 'Genstake', 431, 'Scrypt', 'PoW/PoS', '/coins/genstar/overview', 1, 'cryptocompare'),
(428, 7590, 'XPH', 'PharmaCoin (XPH)', 'PharmaCoin', 432, 'N/A', 'N/A', '/coins/xph/overview', 1, 'cryptocompare'),
(429, 7592, 'GRM', 'GridMaster (GRM)', 'GridMaster', 433, 'N/A', 'N/A', '/coins/grm/overview', 1, 'cryptocompare'),
(430, 7595, 'QTZ', 'Quartz (QTZ)', 'Quartz', 434, 'SHA256', 'PoW/PoS', '/coins/qtz/overview', 1, 'cryptocompare'),
(431, 7599, 'ARB', 'Arbit Coin (ARB)', 'Arbit Coin', 435, 'N/A', 'PoW/PoS', '/coins/arb/overview', 1, 'cryptocompare'),
(432, 7600, 'LTS', 'Litestar Coin (LTS)', 'Litestar Coin', 436, 'N/A', 'PoW/PoS', '/coins/lts/overview', 1, 'cryptocompare'),
(433, 7624, 'SPC', 'SpinCoin (SPC)', 'SpinCoin', 437, 'NIST5', 'PoW/PoS', '/coins/spc/overview', 1, 'cryptocompare'),
(434, 7625, 'GP', 'GoldPieces (GP)', 'GoldPieces', 438, 'X11', 'PoW/PoS', '/coins/gp/overview', 1, 'cryptocompare'),
(435, 7626, 'BITZ', 'Bitz Coin (BITZ)', 'Bitz Coin', 439, 'N/A', 'PoS', '/coins/bitz/overview', 1, 'cryptocompare'),
(436, 7627, 'DUB', 'DubCoin (DUB)', 'DubCoin', 440, 'X15', 'PoW/PoS', '/coins/dub/overview', 1, 'cryptocompare'),
(437, 7634, 'GRAV', 'Graviton (GRAV)', 'Graviton', 441, 'SHA256', 'PoW/PoS', '/coins/grav/overview', 1, 'cryptocompare'),
(438, 7635, 'BOB*', 'Bob Coin (BOB*)', 'Bob Coin', 442, 'Scrypt', 'PoW', '/coins/bobstar/overview', 1, 'cryptocompare'),
(439, 7636, 'MCN', 'MonetaVerde (MCN)', 'MonetaVerde', 443, 'CryptoNight', 'PoW', '/coins/mcn/overview', 1, 'cryptocompare'),
(440, 7650, 'QCN', 'Quazar Coin (QCN)', 'Quazar Coin', 444, 'CryptoNight', 'PoW', '/coins/qcn/overview', 1, 'cryptocompare'),
(441, 7653, 'HEDG', 'Hedgecoin (HEDG)', 'Hedgecoin', 445, 'X13', 'PoW', '/coins/hedg/overview', 1, 'cryptocompare'),
(442, 8682, 'SONG', 'Song Coin (SONG)', 'Song Coin', 446, 'Scrypt', 'PoW', '/coins/song/overview', 1, 'cryptocompare'),
(443, 8683, 'XSEED', 'BitSeeds (XSEED)', 'BitSeeds', 447, 'SHA256', 'PoW/PoS', '/coins/xseed/overview', 1, 'cryptocompare'),
(444, 8692, 'CRE', 'Credits (CRE)', 'Credits', 448, 'SHA256', 'PoW/PoS', '/coins/cre/overview', 1, 'cryptocompare'),
(445, 8693, 'AXIOM', 'Axiom Coin (AXIOM)', 'Axiom Coin', 449, 'N/A', 'PoW/PoS', '/coins/axiom/overview', 1, 'cryptocompare'),
(446, 8694, 'SMLY', 'SmileyCoin (SMLY)', 'SmileyCoin', 450, 'Scrypt', 'PoW', '/coins/smly/overview', 1, 'cryptocompare'),
(447, 8695, 'RBT', 'Rimbit (RBT)', 'Rimbit', 451, 'N/A', 'N/A', '/coins/rbt/overview', 1, 'cryptocompare'),
(448, 8696, 'CHIP', 'Chip (CHIP)', 'Chip', 452, 'X11', 'PoW', '/coins/chip/overview', 1, 'cryptocompare'),
(449, 8716, 'SPEC', 'SpecCoin (SPEC)', 'SpecCoin', 453, 'Scrypt', 'PoW', '/coins/spec/overview', 1, 'cryptocompare'),
(450, 8760, 'UNC', 'UnCoin (UNC)', 'UnCoin', 455, 'X11', 'N/A', '/coins/unc/overview', 1, 'cryptocompare'),
(451, 8761, 'SPRTS', 'Sprouts (SPRTS)', 'Sprouts', 456, 'SHA256', 'PoW/PoS', '/coins/sprts/overview', 1, 'cryptocompare'),
(452, 8762, 'ZNY', 'BitZeny (ZNY)', 'BitZeny', 457, 'Scrypt', 'PoW', '/coins/zny/overview', 1, 'cryptocompare'),
(453, 8763, 'BTQ', 'BitQuark (BTQ)', 'BitQuark', 458, 'Multiple', 'PoW', '/coins/btq/overview', 1, 'cryptocompare'),
(454, 8764, 'PKB', 'ParkByte (PKB)', 'ParkByte', 459, 'SHA256', 'PoW/PoS', '/coins/pkb/overview', 1, 'cryptocompare'),
(455, 8767, 'STR*', 'StarCoin (STR*)', 'StarCoin', 460, 'Scrypt', 'PoW/PoS', '/coins/strstar/overview', 1, 'cryptocompare'),
(456, 8825, 'SNRG', 'Synergy (SNRG)', 'Synergy', 461, 'X11', 'PoW/PoS', '/coins/snrg/overview', 1, 'cryptocompare'),
(457, 8832, 'GHOUL', 'Ghoul Coin (GHOUL)', 'Ghoul Coin', 462, 'N/A', 'PoW/PoS', '/coins/ghoul/overview', 1, 'cryptocompare'),
(458, 8846, 'HNC', 'Hellenic Coin (HNC)', 'Hellenic Coin', 463, 'Scrypt', 'PoW', '/coins/hnc/overview', 1, 'cryptocompare'),
(459, 12192, 'DIGS', 'Diggits (DIGS)', 'Diggits', 464, 'Scrypt', 'PoS', '/coins/digs/overview', 1, 'cryptocompare'),
(460, 12194, 'EXP', 'Expanse (EXP)', 'Expanse', 465, 'Ethash', 'PoW', '/coins/exp/overview', 1, 'cryptocompare'),
(461, 12217, 'GCR', 'Global Currency Reserve (GCR)', 'Global Currency Reserve', 466, 'N/A', 'PoS', '/coins/gcr/overview', 1, 'cryptocompare'),
(462, 12223, 'MAPC', 'MapCoin (MAPC)', 'MapCoin', 467, 'X11', 'PoS', '/coins/mapc/overview', 1, 'cryptocompare'),
(463, 12225, 'MI', 'XiaoMiCoin (MI)', 'XiaoMiCoin', 468, 'Scrypt', 'PoW/PoS', '/coins/mi/overview', 1, 'cryptocompare'),
(464, 12985, 'CON', 'Paycon (CON_)', 'Paycon', 469, 'X13', 'PoW/PoS', '/coins/con_/overview', 1, 'cryptocompare'),
(465, 13044, 'NEU*', 'NeuCoin (NEU*)', 'NeuCoin', 470, 'N/A', 'PoS', '/coins/neustar/overview', 1, 'cryptocompare'),
(466, 13045, 'TX', 'Transfer (TX)', 'Transfer', 471, 'X11', 'PoW/PoS', '/coins/tx/overview', 1, 'cryptocompare'),
(467, 13070, 'GRS', 'Groestlcoin  (GRS)', 'Groestlcoin ', 472, 'Groestl', 'PoW', '/coins/grs/overview', 1, 'cryptocompare'),
(468, 13072, 'SC', 'Siacoin (SC)', 'Siacoin', 473, 'Blake2b', 'PoW', '/coins/sc/overview', 1, 'cryptocompare'),
(469, 13074, 'CLV', 'CleverCoin (CLV)', 'CleverCoin', 474, 'N/A', 'PoS/PoW', '/coins/clv/overview', 1, 'cryptocompare'),
(470, 13280, 'FCT', 'Factoids (FCT)', 'Factoids', 475, 'N/A', 'N/A', '/coins/fct/overview', 1, 'cryptocompare'),
(471, 13281, 'LYB', 'LyraBar (LYB)', 'LyraBar', 476, 'Lyra2RE', 'PoW/PoS', '/coins/lyb/overview', 1, 'cryptocompare'),
(472, 15272, 'BST', 'BitStone (BST)', 'BitStone', 477, 'X11', 'PoW/PoS', '/coins/bst/overview', 1, 'cryptocompare'),
(473, 15274, 'PXI', 'Prime-X1 (PXI)', 'Prime-X1', 478, 'X11', 'PoW', '/coins/pxi/overview', 1, 'cryptocompare'),
(474, 15282, 'CPC', 'CapriCoin (CPC)', 'CapriCoin', 479, 'X11', 'PoW/PoS', '/coins/cpc/overview', 1, 'cryptocompare'),
(475, 15284, 'AMS', 'Amsterdam Coin (AMS)', 'Amsterdam Coin', 480, 'Quark', 'PoW/PoS', '/coins/ams/overview', 1, 'cryptocompare'),
(476, 15323, 'OBITS', 'Obits Coin (OBITS)', 'Obits Coin', 481, 'N/A', 'N/A', '/coins/obits/overview', 1, 'cryptocompare'),
(477, 15869, 'CLUB', ' ClubCoin (CLUB)', ' ClubCoin', 482, 'Scrypt', 'PoW/PoS', '/coins/club/overview', 1, 'cryptocompare'),
(478, 15870, 'RADS', 'Radium (RADS)', 'Radium', 483, 'N/A', 'PoS', '/coins/rads/overview', 1, 'cryptocompare'),
(479, 15876, 'EMC', 'Emercoin (EMC)', 'Emercoin', 484, 'SHA256', 'PoW/PoS', '/coins/emc/overview', 1, 'cryptocompare'),
(480, 15879, 'BLITZ', 'BlitzCoin (BLITZ)', 'BlitzCoin', 485, 'X13', 'PoS', '/coins/blitz/overview', 1, 'cryptocompare'),
(481, 15882, 'HIRE*', 'BitHIRE (HIRE*)', 'BitHIRE', 486, 'Scrypt', 'PoS', '/coins/hirestar/overview', 1, 'cryptocompare'),
(482, 15885, 'EGC', 'EverGreenCoin (EGC)', 'EverGreenCoin', 487, 'X15', 'PoW/PoS', '/coins/egc/overview', 1, 'cryptocompare'),
(483, 15888, 'MND', 'MindCoin (MND)', 'MindCoin', 488, 'X11', 'PoW', '/coins/mnd/overview', 1, 'cryptocompare'),
(484, 16123, 'I0C', 'I0coin (I0C)', 'I0coin', 489, 'SHA256', 'PoW', '/coins/i0c/overview', 1, 'cryptocompare'),
(485, 16125, 'BTA', 'Bata (BTA)', 'Bata', 490, 'Scrypt', 'PoW', '/coins/bta/overview', 1, 'cryptocompare'),
(486, 16127, 'KARMA', 'Karmacoin (KARMA)', 'Karmacoin', 491, 'Scrypt', 'PoW', '/coins/karma/overview', 1, 'cryptocompare'),
(487, 16713, 'DCR', 'Decred (DCR)', 'Decred', 492, 'BLAKE256', 'PoW/PoS', '/coins/dcr/overview', 1, 'cryptocompare'),
(488, 16717, 'NAS2', 'Nas2Coin (NAS2)', 'Nas2Coin', 493, 'N/A', 'PoS', '/coins/nas2/overview', 1, 'cryptocompare'),
(489, 17006, 'PAK', 'Pakcoin (PAK)', 'Pakcoin', 494, 'Scrypt', 'PoW', '/coins/pak/overview', 1, 'cryptocompare'),
(490, 17547, 'CRB', 'Creditbit  (CRB)', 'Creditbit ', 495, 'N/A', 'N/A', '/coins/crb/overview', 1, 'cryptocompare'),
(491, 17549, 'DOGED', 'DogeCoinDark (DOGED)', 'DogeCoinDark', 496, 'Scrypt', 'PoW', '/coins/doged/overview', 1, 'cryptocompare'),
(492, 17778, 'REP', 'Augur (REP)', 'Augur', 498, 'N/A', 'N/A', '/coins/rep/overview', 1, 'cryptocompare'),
(493, 17857, 'OK', 'OKCash (OK)', 'OKCash', 499, 'N/A', 'PoW/PoS', '/coins/ok/overview', 1, 'cryptocompare'),
(494, 18180, 'RVR', 'Revolution VR (RVR)', 'Revolution VR', 500, 'Scrypt', 'PoW', '/coins/rvr/overview', 1, 'cryptocompare'),
(495, 18244, 'AMP', 'Synereo (AMP)', 'Synereo', 501, 'N/A', 'Pow/PoSC', '/coins/amp/overview', 1, 'cryptocompare'),
(496, 18670, 'HODL', 'HOdlcoin (HODL)', 'HOdlcoin', 502, '1GB AES Patt', 'PoW', '/coins/hodl/overview', 1, 'cryptocompare'),
(497, 18907, 'DGD', 'Digix DAO (DGD)', 'Digix DAO', 503, 'N/A', 'N/A', '/coins/dgd/overview', 1, 'cryptocompare'),
(498, 19051, 'EDRC', 'EDRCoin (EDRC)', 'EDRCoin', 504, 'SHA256', 'PoW/PoS', '/coins/edrc/overview', 1, 'cryptocompare'),
(499, 19745, 'LSK', 'Lisk (LSK)', 'Lisk', 506, 'DPoS', 'DPoS', '/coins/lsk/overview', 1, 'cryptocompare'),
(500, 20131, 'WAVES', 'Waves (WAVES)', 'Waves', 507, 'Leased POS', 'LPoS', '/coins/waves/overview', 1, 'cryptocompare'),
(501, 20153, 'HTC', 'Hitcoin (HTC)', 'Hitcoin', 508, 'X11', 'PoW/PoS', '/coins/htc/overview', 1, 'cryptocompare'),
(502, 20157, 'GAME', 'Gamecredits (GAME)', 'Gamecredits', 509, 'Scrypt', 'PoW', '/coins/game/overview', 1, 'cryptocompare'),
(503, 20196, 'DSH', 'Dashcoin (DSH)', 'Dashcoin', 510, 'CryptoNight', 'PoW', '/coins/dsh/overview', 1, 'cryptocompare'),
(504, 20198, 'DBIC', 'DubaiCoin (DBIC)', 'DubaiCoin', 511, 'SHA256', 'PoW/PoS', '/coins/dbic/overview', 1, 'cryptocompare'),
(505, 20202, 'XHI', 'HiCoin (XHI)', 'HiCoin', 512, 'Scrypt', 'PoS', '/coins/xhi/overview', 1, 'cryptocompare'),
(506, 20205, 'SPOTS', 'Spots (SPOTS)', 'Spots', 513, 'N/A', 'PoW/PoS', '/coins/spots/overview', 1, 'cryptocompare'),
(507, 20209, 'BIOS', 'BiosCrypto (BIOS)', 'BiosCrypto', 514, 'Quark', 'PoW/PoS', '/coins/bios/overview', 1, 'cryptocompare'),
(508, 20212, 'CAB', 'CabbageUnit (CAB)', 'CabbageUnit', 516, 'N/A', 'PoS', '/coins/cab/overview', 1, 'cryptocompare'),
(509, 20213, 'DIEM', 'CarpeDiemCoin (DIEM)', 'CarpeDiemCoin', 517, 'SHA256', 'PoW', '/coins/diem/overview', 1, 'cryptocompare'),
(510, 20214, 'GBT', 'GameBetCoin (GBT)', 'GameBetCoin', 518, 'POS 3.0', 'PoS', '/coins/gbt/overview', 1, 'cryptocompare'),
(511, 20215, 'SAR*', 'SARCoin (SAR*)', 'SARCoin', 519, 'SHA256', 'PoS', '/coins/sarstar/overview', 1, 'cryptocompare'),
(512, 20218, 'RCX', 'RedCrowCoin (RCX)', 'RedCrowCoin', 520, 'Scrypt', 'PoW/PoS', '/coins/rcx/overview', 1, 'cryptocompare'),
(513, 20236, 'PWR', 'PWR Coin (PWR)', 'PWR Coin', 521, 'NIST5', 'PoW/PoS', '/coins/pwr/overview', 1, 'cryptocompare'),
(514, 20270, 'TRUMP', 'TrumpCoin (TRUMP)', 'TrumpCoin', 522, 'Blake', 'PoS', '/coins/trump/overview', 1, 'cryptocompare'),
(515, 20304, 'PRM', 'PrismChain (PRM)', 'PrismChain', 523, 'SHA256', 'PoW/PoS', '/coins/prm/overview', 1, 'cryptocompare'),
(516, 20315, 'BCY', 'BitCrystals (BCY)', 'BitCrystals', 524, 'Counterparty', 'N/A', '/coins/bcy/overview', 1, 'cryptocompare'),
(517, 20320, 'RBIES', 'Rubies (RBIES)', 'Rubies', 525, 'N/A', 'PoS', '/coins/rbies/overview', 1, 'cryptocompare'),
(518, 20333, 'STEEM', 'Steem (STEEM)', 'Steem', 526, 'N/A', 'PoW', '/coins/steem/overview', 1, 'cryptocompare'),
(519, 20336, 'BLRY', 'BillaryCoin (BLRY)', 'BillaryCoin', 527, 'Scrypt', 'PoW/PoS', '/coins/blry/overview', 1, 'cryptocompare'),
(520, 20338, 'XWC', 'WhiteCoin (XWC)', 'WhiteCoin', 528, 'Scrypt', 'PoW/PoS', '/coins/xwc/overview', 1, 'cryptocompare'),
(521, 20339, 'DOT', 'Dotcoin (DOT)', 'Dotcoin', 529, 'Scrypt', 'PoW', '/coins/dot/overview', 1, 'cryptocompare'),
(522, 20342, 'SCOT', 'Scotcoin (SCOT)', 'Scotcoin', 530, 'Counterparty', 'N/A', '/coins/scot/overview', 1, 'cryptocompare'),
(523, 20346, 'DNET', 'Darknet (DNET)', 'Darknet', 531, 'Quark', 'Pow/PoS', '/coins/dnet/overview', 1, 'cryptocompare'),
(524, 20348, 'BAC', 'BitalphaCoin (BAC)', 'BitalphaCoin', 532, 'N/A', 'PoW', '/coins/bac/overview', 1, 'cryptocompare'),
(525, 20387, 'XID*', 'International Diamond Coin (XID*)', 'International Diamond Coin', 533, 'N/A', 'PoW', '/coins/xidstar/overview', 1, 'cryptocompare'),
(526, 20441, 'TCR', 'Thecreed (TCR)', 'Thecreed', 536, 'QuBit', 'PoW/PoS', '/coins/tcr/overview', 1, 'cryptocompare'),
(527, 20444, 'POST', 'PostCoin (POST)', 'PostCoin', 537, 'N/A', 'PoS', '/coins/post/overview', 1, 'cryptocompare'),
(528, 20446, 'INFX', 'Influxcoin (INFX)', 'Influxcoin', 538, 'X11', 'PoW/PoS', '/coins/infx/overview', 1, 'cryptocompare'),
(529, 20448, 'ETHS', 'EthereumScrypt (ETHS)', 'EthereumScrypt', 539, 'Scrypt', 'PoW/PoS', '/coins/eths/overview', 1, 'cryptocompare'),
(530, 20580, 'PXL', 'Phalanx (PXL)', 'Phalanx', 540, 'SHA256', 'PoW', '/coins/pxl/overview', 1, 'cryptocompare'),
(531, 20583, 'NUM', 'NumbersCoin (NUM)', 'NumbersCoin', 541, 'Scrypt', 'PoW/PoS', '/coins/num/overview', 1, 'cryptocompare'),
(532, 20585, 'SOUL', 'SoulCoin (SOUL)', 'SoulCoin', 542, 'Scrypt', 'PoW/PoS', '/coins/soul/overview', 1, 'cryptocompare'),
(533, 20591, 'ION', 'Ionomy (ION)', 'Ionomy', 543, 'N/A', 'PoS', '/coins/ion/overview', 1, 'cryptocompare'),
(534, 20600, 'GROW', 'GrownCoin (GROW)', 'GrownCoin', 544, 'N/A', 'PoW/PoS', '/coins/grow/overview', 1, 'cryptocompare'),
(535, 20635, 'UNITY', 'SuperNET (UNITY)', 'SuperNET', 545, 'N/A', 'N/A', '/coins/unity/overview', 1, 'cryptocompare'),
(536, 20640, 'OLDSF', 'OldSafeCoin (OLDSF)', 'OldSafeCoin', 546, 'N/A', 'PoS', '/coins/oldsf/overview', 1, 'cryptocompare'),
(537, 20644, 'SSTC', 'SunShotCoin (SSTC)', 'SunShotCoin', 547, 'X11', 'PoW', '/coins/sstc/overview', 1, 'cryptocompare'),
(538, 20647, 'NETC', 'NetworkCoin (NETC)', 'NetworkCoin', 548, 'X13', 'PoW/PoS', '/coins/netc/overview', 1, 'cryptocompare'),
(539, 20650, 'GPU', 'GPU Coin (GPU)', 'GPU Coin', 549, 'Scrypt', 'PoS', '/coins/gpu/overview', 1, 'cryptocompare'),
(540, 20652, 'TAGR', 'Think And Get Rich Coin (TAGR)', 'Think And Get Rich Coin', 550, 'X15', 'PoW/PoS', '/coins/tagr/overview', 1, 'cryptocompare'),
(541, 20655, 'HMP', 'HempCoin (HMP)', 'HempCoin', 551, 'Scrypt-n', 'PoW', '/coins/hmp/overview', 1, 'cryptocompare'),
(542, 20656, 'ADZ', 'Adzcoin (ADZ)', 'Adzcoin', 552, 'X11', 'PoW', '/coins/adz/overview', 1, 'cryptocompare'),
(543, 20659, 'GAP', 'Gapcoin (GAP)', 'Gapcoin', 553, 'Scrypt', 'PoW/PoS', '/coins/gap/overview', 1, 'cryptocompare'),
(544, 20661, 'MYC', 'MayaCoin (MYC)', 'MayaCoin', 554, 'Scrypt', 'PoW/PoS', '/coins/myc/overview', 1, 'cryptocompare'),
(545, 20679, 'IVZ', 'InvisibleCoin (IVZ)', 'InvisibleCoin', 555, 'N/A', 'PoS', '/coins/ivz/overview', 1, 'cryptocompare'),
(546, 20680, 'VTA', 'VirtaCoin (VTA)', 'VirtaCoin', 556, 'Scrypt', 'PoW', '/coins/vta/overview', 1, 'cryptocompare'),
(547, 20681, 'SLS', 'SaluS (SLS)', 'SaluS', 557, 'Scrypt', 'PoW/PoS', '/coins/sls/overview', 1, 'cryptocompare'),
(548, 20685, 'SOIL', 'SoilCoin (SOIL)', 'SoilCoin', 558, 'Dagger', 'PoW', '/coins/soil/overview', 1, 'cryptocompare'),
(549, 20688, 'CUBE', 'DigiCube (CUBE)', 'DigiCube', 559, 'N/A', 'PoS', '/coins/cube/overview', 1, 'cryptocompare'),
(550, 20691, 'YOC', 'YoCoin (YOC)', 'YoCoin', 560, 'Scrypt', 'PoW', '/coins/yoc/overview', 1, 'cryptocompare'),
(551, 20714, 'COIN*', 'Coin (COIN*)', 'Coin', 561, 'SHA256', 'PoW', '/coins/coinstar/overview', 1, 'cryptocompare'),
(552, 20718, 'VPRC', 'VapersCoin (VPRC)', 'VapersCoin', 562, 'Scrypt', 'PoW', '/coins/vprc/overview', 1, 'cryptocompare'),
(553, 20722, 'APC', 'AlpaCoin (APC)', 'AlpaCoin', 563, 'N/A', 'PoW', '/coins/apc/overview', 1, 'cryptocompare'),
(554, 20724, 'STEPS', 'Steps (STEPS)', 'Steps', 564, 'N/A', 'PoS', '/coins/steps/overview', 1, 'cryptocompare'),
(555, 20726, 'DBTC', 'DebitCoin (DBTC)', 'DebitCoin', 565, 'Scrypt', 'PoW', '/coins/dbtc/overview', 1, 'cryptocompare'),
(556, 20728, 'UNIT', 'Universal Currency (UNIT)', 'Universal Currency', 566, 'SHA256', 'PoW/PoS', '/coins/unit/overview', 1, 'cryptocompare'),
(557, 20730, 'AEON', 'AEON (AEON)', 'AEON', 567, 'CryptoNight-', 'PoW', '/coins/aeon/overview', 1, 'cryptocompare'),
(558, 20744, 'MOIN', 'MoinCoin (MOIN)', 'MoinCoin', 568, 'N/A', 'PoW/PoS', '/coins/moin/overview', 1, 'cryptocompare'),
(559, 20745, 'SIB', 'SibCoin (SIB)', 'SibCoin', 569, 'X11GOST', 'PoW', '/coins/sib/overview', 1, 'cryptocompare'),
(560, 20748, 'ERC', 'EuropeCoin (ERC)', 'EuropeCoin', 570, 'X11', 'PoW/PoS', '/coins/erc/overview', 1, 'cryptocompare'),
(561, 20806, 'AIB', 'AdvancedInternetBlock (AIB)', 'AdvancedInternetBlock', 571, 'Scrypt', 'PoW', '/coins/aib/overview', 1, 'cryptocompare'),
(562, 20814, 'PRIME', 'PrimeChain (PRIME)', 'PrimeChain', 572, 'N/A', 'PoS', '/coins/prime/overview', 1, 'cryptocompare'),
(563, 20817, 'BERN', 'BERNcash (BERN)', 'BERNcash', 573, 'X14', 'PoW/PoS', '/coins/bern/overview', 1, 'cryptocompare'),
(564, 20819, 'BIGUP', 'BigUp (BIGUP)', 'BigUp', 574, 'N/A', 'PoS', '/coins/bigup/overview', 1, 'cryptocompare'),
(565, 20822, 'KR', 'Krypton (KR)', 'Krypton', 575, 'Dagger-Hashi', 'PoW', '/coins/kr/overview', 1, 'cryptocompare'),
(566, 20823, 'XRE', 'RevolverCoin (XRE)', 'RevolverCoin', 576, 'X11Evo', 'PoW', '/coins/xre/overview', 1, 'cryptocompare'),
(567, 20825, 'MEME', 'Pepe (MEME)', 'Pepe', 578, 'X11', 'PoW/PoS', '/coins/meme/overview', 1, 'cryptocompare'),
(568, 20826, 'XDB', 'DragonSphere (XDB)', 'DragonSphere', 579, 'X11', 'PoW/PoS', '/coins/xdb/overview', 1, 'cryptocompare'),
(569, 20828, 'ANTI', 'Anti Bitcoin (ANTI)', 'Anti Bitcoin', 580, 'SHA256', 'PoW', '/coins/anti/overview', 1, 'cryptocompare'),
(570, 20892, 'BRK', 'BreakoutCoin (BRK)', 'BreakoutCoin', 581, 'SHA256', 'PoW/PoS', '/coins/brk/overview', 1, 'cryptocompare'),
(571, 20903, 'COLX', 'ColossusCoinXT (COLX)', 'ColossusCoinXT', 582, 'X11', 'PoS', '/coins/colx/overview', 1, 'cryptocompare'),
(572, 20905, 'MNM', 'Mineum (MNM)', 'Mineum', 583, 'X13', 'PoW/PoS', '/coins/mnm/overview', 1, 'cryptocompare'),
(573, 20907, 'ADCN', 'Asiadigicoin (ADCN)', 'Asiadigicoin', 584, 'Scrypt', 'PoW', '/coins/adcn/overview', 1, 'cryptocompare'),
(574, 20908, 'ZEIT', 'ZeitCoin (ZEIT)', 'ZeitCoin', 585, 'PoS', 'PoS', '/coins/zeit/overview', 1, 'cryptocompare'),
(575, 20910, '2GIVE', '2GiveCoin (2GIVE)', '2GiveCoin', 587, 'Scrypt', 'PoW/PoS', '/coins/2give/overview', 1, 'cryptocompare'),
(576, 20911, 'CGA', 'Cryptographic Anomaly (CGA)', 'Cryptographic Anomaly', 588, 'Scrypt', 'PoW', '/coins/cga/overview', 1, 'cryptocompare'),
(577, 20920, 'SWING', 'SwingCoin (SWING)', 'SwingCoin', 589, 'SHA256', 'PoW/PoS', '/coins/swing/overview', 1, 'cryptocompare'),
(578, 20594, 'SAFEX', 'SafeExchangeCoin (SAFEX)', 'SafeExchangeCoin', 590, 'Scrypt', 'PoC', '/coins/safex/overview', 1, 'cryptocompare'),
(579, 20980, 'NEBU', 'Nebuchadnezzar (NEBU)', 'Nebuchadnezzar', 591, 'PoS', 'PoS', '/coins/nebu/overview', 1, 'cryptocompare'),
(580, 20986, 'AEC', 'AcesCoin (AEC)', 'AcesCoin', 592, 'X11', 'PoS', '/coins/aec/overview', 1, 'cryptocompare'),
(581, 20991, 'FRN', 'Francs (FRN)', 'Francs', 593, 'Scrypt', 'PoW', '/coins/frn/overview', 1, 'cryptocompare'),
(582, 21007, 'ADN', 'Aiden (ADN)', 'Aiden', 594, 'ScryptOG', 'PoW', '/coins/adn/overview', 1, 'cryptocompare'),
(583, 21012, 'PULSE', 'Pulse (PULSE)', 'Pulse', 595, 'SHA256D', 'PoS', '/coins/pulse/overview', 1, 'cryptocompare'),
(584, 21017, 'N7', 'Number7 (N7)', 'Number7', 596, 'Scrypt', 'PoW', '/coins/n7/overview', 1, 'cryptocompare'),
(585, 21213, 'CYG', 'Cygnus (CYG)', 'Cygnus', 597, 'X11', 'PoW/PoS', '/coins/cyg/overview', 1, 'cryptocompare'),
(586, 21215, 'LGBTQ', 'LGBTQoin (LGBTQ)', 'LGBTQoin', 598, 'X11', 'PoW', '/coins/lgbtq/overview', 1, 'cryptocompare'),
(587, 21219, 'UTH', 'Uther (UTH)', 'Uther', 599, 'Dagger', 'PoW', '/coins/uth/overview', 1, 'cryptocompare'),
(588, 21222, 'MPRO', 'MediumProject (MPRO)', 'MediumProject', 600, 'PoS', 'PoW', '/coins/mpro/overview', 1, 'cryptocompare'),
(589, 21224, 'KAT', 'KATZcoin (KAT)', 'KATZcoin', 601, 'SHA256D', 'PoW/PoS', '/coins/kat/overview', 1, 'cryptocompare'),
(590, 21229, 'SPM', 'Supreme (SPM)', 'Supreme', 603, 'Scrypt', 'PoW/PoS', '/coins/spm/overview', 1, 'cryptocompare'),
(591, 21232, 'MOJO', 'Mojocoin (MOJO)', 'Mojocoin', 604, 'PoS', 'PoS', '/coins/mojo/overview', 1, 'cryptocompare'),
(592, 21239, 'BELA', 'Bela (BELA)', 'Bela', 605, 'N/A', 'N/A', '/coins/bela/overview', 1, 'cryptocompare'),
(593, 21244, 'FLX', 'Flash (FLX)', 'Flash', 606, 'Scrypt', 'PoW/PoS', '/coins/flx/overview', 1, 'cryptocompare'),
(594, 21357, 'BOLI', 'BolivarCoin (BOLI)', 'BolivarCoin', 607, 'X11', 'PoW', '/coins/boli/overview', 1, 'cryptocompare'),
(595, 21359, 'CLUD', 'CludCoin (CLUD)', 'CludCoin', 608, 'Scrypt', 'PoW', '/coins/clud/overview', 1, 'cryptocompare'),
(596, 21365, 'DIME', 'DimeCoin (DIME)', 'DimeCoin', 609, 'Quark', 'PoW', '/coins/dime/overview', 1, 'cryptocompare'),
(597, 21370, 'FLY', 'FlyCoin (FLY)', 'FlyCoin', 610, 'X13', 'PoS', '/coins/fly/overview', 1, 'cryptocompare'),
(598, 21374, 'HVCO', 'High Voltage Coin (HVCO)', 'High Voltage Coin', 611, 'SHA256', 'PoW/PoS', '/coins/hvco/overview', 1, 'cryptocompare'),
(599, 21378, 'GIZ', 'GIZMOcoin (GIZ)', 'GIZMOcoin', 612, 'X11', 'PoW/PoS', '/coins/giz/overview', 1, 'cryptocompare'),
(600, 21380, 'GREXIT', 'GrexitCoin (GREXIT)', 'GrexitCoin', 613, 'N/A', 'PoS', '/coins/grexit/overview', 1, 'cryptocompare'),
(601, 21382, 'CARBON', 'Carboncoin (CARBON)', 'Carboncoin', 614, 'Scrypt', 'PoW', '/coins/carbon/overview', 1, 'cryptocompare'),
(602, 21384, 'DEUR', 'DigiEuro (DEUR)', 'DigiEuro', 615, 'Scrypt', 'PoW', '/coins/deur/overview', 1, 'cryptocompare'),
(603, 21626, 'TUR', 'Turron (TUR)', 'Turron', 616, 'N/A', 'PoS', '/coins/tur/overview', 1, 'cryptocompare'),
(604, 21641, 'LEMON', 'LemonCoin (LEMON)', 'LemonCoin', 617, 'N/A', 'PoW', '/coins/lemon/overview', 1, 'cryptocompare'),
(605, 21650, 'STS', 'STRESScoin (STS)', 'STRESScoin', 618, 'X13', 'PoW/PoS', '/coins/sts/overview', 1, 'cryptocompare'),
(606, 21652, 'DISK', 'Dark Lisk (DISK)', 'Dark Lisk', 619, 'X11', 'PoW/PoS', '/coins/disk/overview', 1, 'cryptocompare'),
(607, 21669, 'NEVA', 'NevaCoin (NEVA)', 'NevaCoin', 620, 'N/A', 'PoW/PoS', '/coins/neva/overview', 1, 'cryptocompare'),
(608, 21706, 'CYT', 'Cryptokenz (CYT)', 'Cryptokenz', 621, 'PoS', 'PoS', '/coins/cyt/overview', 1, 'cryptocompare'),
(609, 21708, 'FUZZ', 'Fuzzballs (FUZZ)', 'Fuzzballs', 622, 'Scrypt', 'PoW', '/coins/fuzz/overview', 1, 'cryptocompare'),
(610, 21710, 'NKC', 'Nukecoinz (NKC)', 'Nukecoinz', 623, 'Scrypt', 'PoW', '/coins/nkc/overview', 1, 'cryptocompare'),
(611, 21760, 'SCRT', 'SecretCoin (SCRT)', 'SecretCoin', 624, 'X11', 'PoW/PoS', '/coins/scrt/overview', 1, 'cryptocompare'),
(612, 21770, 'XRA', 'Ratecoin (XRA)', 'Ratecoin', 625, 'X11', 'PoW/PoS', '/coins/xra/overview', 1, 'cryptocompare'),
(613, 21773, 'XNX', 'XanaxCoin (XNX)', 'XanaxCoin', 626, 'Scrypt', 'PoW', '/coins/xnx/overview', 1, 'cryptocompare'),
(614, 21775, 'STAR*', 'StarCoin (STAR*)', 'StarCoin', 627, 'Scrypt', 'PoW/PoS', '/coins/starstar/overview', 1, 'cryptocompare'),
(615, 21833, 'STHR', 'Stakerush (STHR)', 'Stakerush', 628, 'PoS', 'PoS', '/coins/sthr/overview', 1, 'cryptocompare'),
(616, 21859, 'DBG', 'Digital Bullion Gold (DBG)', 'Digital Bullion Gold', 629, 'PoS', 'PoS', '/coins/dbg/overview', 1, 'cryptocompare'),
(617, 21869, 'BON', 'BonesCoin (BON*)', 'BonesCoin', 630, 'Scrypt', 'PoS', '/coins/bonstar/overview', 1, 'cryptocompare'),
(618, 21871, 'WMC', 'WMCoin (WMC)', 'WMCoin', 631, 'X11', 'PoS', '/coins/wmc/overview', 1, 'cryptocompare'),
(619, 21875, 'GOTX', 'GothicCoin (GOTX)', 'GothicCoin', 632, 'Scrypt', 'PoW', '/coins/gotx/overview', 1, 'cryptocompare'),
(620, 21878, 'FLVR', 'FlavorCoin (FLVR)', 'FlavorCoin', 633, 'SHA256', 'PoW/PoS', '/coins/flvr/overview', 1, 'cryptocompare'),
(621, 21907, 'SHREK', 'ShrekCoin (SHREK)', 'ShrekCoin', 634, 'Scrypt', 'PoW/PoS', '/coins/shrek/overview', 1, 'cryptocompare'),
(622, 21981, 'STA*', 'Stakers (STA*)', 'Stakers', 635, 'PoS', 'PoS', '/coins/stastar/overview', 1, 'cryptocompare'),
(623, 22015, 'RISE', 'Rise (RISE)', 'Rise', 636, 'DPoS', 'PoS', '/coins/rise/overview', 1, 'cryptocompare'),
(624, 22169, 'REV', 'Revenu (REV)', 'Revenu', 637, 'SHA256', 'PoW/PoS', '/coins/rev/overview', 1, 'cryptocompare'),
(625, 22171, 'PBC', 'PabyosiCoin (PBC)', 'PabyosiCoin', 638, 'X11', 'PoW/PoS', '/coins/pbc/overview', 1, 'cryptocompare'),
(626, 22177, 'OBS', 'Obscurebay (OBS)', 'Obscurebay', 639, 'X11', 'PoW/PoS', '/coins/obs/overview', 1, 'cryptocompare'),
(627, 22180, 'EXIT', 'ExitCoin (EXIT)', 'ExitCoin', 640, 'Scrypt', 'PoW/PoS', '/coins/exit/overview', 1, 'cryptocompare'),
(628, 22185, 'EDC', 'EducoinV (EDC)', 'EducoinV', 641, 'Scrypt', 'PoW/PoS', '/coins/edc/overview', 1, 'cryptocompare'),
(629, 22191, 'CLINT', 'Clinton (CLINT)', 'Clinton', 642, 'SHA256', 'PoW', '/coins/clint/overview', 1, 'cryptocompare'),
(630, 22207, 'CKC', 'Clockcoin (CKC)', 'Clockcoin', 643, 'SHA256', 'PoW/PoS', '/coins/ckc/overview', 1, 'cryptocompare'),
(631, 22212, 'VIP', 'VIP Tokens (VIP)', 'VIP Tokens', 644, 'NIST5', 'PoW/PoS', '/coins/vip/overview', 1, 'cryptocompare'),
(632, 22240, 'NXE', 'NXEcoin (NXE)', 'NXEcoin', 645, 'NIST5', 'PoW/PoS', '/coins/nxe/overview', 1, 'cryptocompare'),
(633, 22245, 'ZOOM', 'ZoomCoin (ZOOM)', 'ZoomCoin', 646, 'Lyra2RE', 'PoW', '/coins/zoom/overview', 1, 'cryptocompare'),
(634, 22248, 'DRACO', 'DT Token (DRACO)', 'DT Token', 647, 'N/A', 'N/A', '/coins/draco/overview', 1, 'cryptocompare'),
(635, 22254, 'YOVI', 'YobitVirtualCoin (YOVI)', 'YobitVirtualCoin', 648, 'SHA256', 'PoS', '/coins/yovi/overview', 1, 'cryptocompare'),
(636, 22258, 'ORLY', 'OrlyCoin (ORLY)', 'OrlyCoin', 649, 'X15', 'PoW/PoS', '/coins/orly/overview', 1, 'cryptocompare'),
(637, 22262, 'KUBO', 'KubosCoin (KUBO)', 'KubosCoin', 650, 'Scrypt', 'PoW/PoS', '/coins/kubo/overview', 1, 'cryptocompare'),
(638, 22264, 'INCP', 'InceptionCoin (INCP)', 'InceptionCoin', 651, 'X11', 'PoW/PoS', '/coins/incp/overview', 1, 'cryptocompare'),
(639, 22268, 'SAK', 'SharkCoin (SAK)', 'SharkCoin', 652, 'SHA256', 'PoW', '/coins/sak/overview', 1, 'cryptocompare'),
(640, 22272, 'EVIL', 'EvilCoin (EVIL)', 'EvilCoin', 653, 'X11', 'PoW/PoS', '/coins/evil/overview', 1, 'cryptocompare'),
(641, 22280, 'OMA', 'OmegaCoin (OMA)', 'OmegaCoin', 654, 'X15', 'PoW/PoS', '/coins/oma/overview', 1, 'cryptocompare'),
(642, 22325, 'MUE', 'MonetaryUnit (MUE)', 'MonetaryUnit', 655, 'Quark', 'PoW', '/coins/mue/overview', 1, 'cryptocompare'),
(643, 22326, 'COX', 'CobraCoin (COX)', 'CobraCoin', 656, 'Scrypt', 'PoW/PoS', '/coins/cox/overview', 1, 'cryptocompare'),
(644, 22327, 'BNT', 'Bancor Network Token (BNT)', 'Bancor Network Token', 657, 'N/A', 'N/A', '/coins/bnt/overview', 1, 'cryptocompare'),
(645, 22330, 'DES', 'Destiny (DES)', 'Destiny', 660, 'Scrypt', 'PoW/PoS', '/coins/des/overview', 1, 'cryptocompare'),
(646, 22333, 'BIT16', '16BitCoin (BIT16)', '16BitCoin', 661, 'NIST5', 'PoW/PoS', '/coins/bit16/overview', 1, 'cryptocompare'),
(647, 22352, 'PDC', 'Project Decorum (PDC)', 'Project Decorum', 662, 'N/A', 'N/A', '/coins/pdc/overview', 1, 'cryptocompare'),
(648, 22354, 'CMT', 'CometCoin (CMT)', 'CometCoin', 663, 'Scrypt', 'PoW', '/coins/cmt/overview', 1, 'cryptocompare'),
(649, 22407, 'CHESS', 'ChessCoin (CHESS)', 'ChessCoin', 665, 'Scrypt', 'PoW/PoS', '/coins/chess/overview', 1, 'cryptocompare'),
(650, 22410, 'SPACE', 'SpaceCoin (SPACE)', 'SpaceCoin', 666, 'Scrypt', 'PoW/PoS', '/coins/space/overview', 1, 'cryptocompare'),
(651, 22418, 'REE', 'ReeCoin (REE)', 'ReeCoin', 667, 'Scrypt', 'PoW/PoS', '/coins/ree/overview', 1, 'cryptocompare'),
(652, 22422, 'LQD', 'Liquid (LQD)', 'Liquid', 668, 'N/A', 'N/A', '/coins/lqd/overview', 1, 'cryptocompare'),
(653, 22428, 'MARV', 'Marvelous (MARV)', 'Marvelous', 669, 'Scrypt', 'PoW', '/coins/marv/overview', 1, 'cryptocompare'),
(654, 22430, 'XDE2', 'XDE II (XDE2)', 'XDE II', 670, 'SHA256', 'PoS', '/coins/xde2/overview', 1, 'cryptocompare'),
(655, 22434, 'VEC2', 'VectorCoin 2.0  (VEC2)', 'VectorCoin 2.0 ', 671, 'Dagger-Hashi', 'PoW', '/coins/vec2/overview', 1, 'cryptocompare'),
(656, 22441, 'OMNI', 'Omni (OMNI)', 'Omni', 672, 'Scrypt', 'PoW', '/coins/omni/overview', 1, 'cryptocompare'),
(657, 22453, 'GSY', 'GenesysCoin (GSY)', 'GenesysCoin', 673, 'SHA256', 'PoW/PoS', '/coins/gsy/overview', 1, 'cryptocompare'),
(658, 22458, 'TKN*', 'TrollTokens (TKN*)', 'TrollTokens', 674, 'SHA256', 'PoW/PoS', '/coins/tknstar/overview', 1, 'cryptocompare'),
(659, 23423, 'LIR', 'Let it Ride (LIR)', 'Let it Ride', 675, 'POS 3.0', 'PoS', '/coins/lir/overview', 1, 'cryptocompare'),
(660, 23425, 'MMNXT', 'MMNXT  (MMNXT)', 'MMNXT ', 676, 'N/A', 'N/A', '/coins/mmnxt/overview', 1, 'cryptocompare'),
(661, 23429, 'SCRPT', 'ScryptCoin (SCRPT)', 'ScryptCoin', 677, 'Scrypt', 'PoW', '/coins/scrpt/overview', 1, 'cryptocompare'),
(662, 23432, 'LBC', 'LBRY Credits (LBC)', 'LBRY Credits', 678, 'N/A', 'N/A', '/coins/lbc/overview', 1, 'cryptocompare'),
(663, 23435, 'SPX', 'Specie (SPX*)', 'Specie', 679, 'PoS', 'PoS', '/coins/spxstar/overview', 1, 'cryptocompare'),
(664, 23728, 'SBD*', 'Steem Backed Dollars (SBD*)', 'Steem Backed Dollars', 680, 'N/A', 'N/A', '/coins/sbdstar/overview', 1, 'cryptocompare'),
(665, 23734, 'CJ', 'CryptoJacks (CJ)', 'CryptoJacks', 681, 'X13', 'PoW/PoS', '/coins/cj/overview', 1, 'cryptocompare'),
(666, 23737, 'PUT', 'PutinCoin (PUT)', 'PutinCoin', 682, 'Scrypt', 'PoW/PoS', '/coins/put/overview', 1, 'cryptocompare'),
(667, 23741, 'KRAK', 'Kraken (KRAK)', 'Kraken', 683, 'SHA256', 'PoW/PoS', '/coins/krak/overview', 1, 'cryptocompare'),
(668, 23743, 'DLISK', 'Dlisk (DLISK)', 'Dlisk', 684, 'N/A', 'DPoS', '/coins/dlisk/overview', 1, 'cryptocompare'),
(669, 23745, 'IBANK', 'iBankCoin (IBANK)', 'iBankCoin', 685, 'Scrypt', 'PoW/PoS', '/coins/ibank/overview', 1, 'cryptocompare'),
(670, 24294, 'STRAT', 'Stratis (STRAT)', 'Stratis', 687, 'X13', 'PoW/PoS', '/coins/strat/overview', 1, 'cryptocompare'),
(671, 24305, 'VOYA', 'Voyacoin (VOYA)', 'Voyacoin', 688, 'N/A', 'PoW', '/coins/voya/overview', 1, 'cryptocompare'),
(672, 24307, 'ENTER', 'EnterCoin (ENTER) (ENTER)', 'EnterCoin (ENTER)', 689, 'Scrypt', 'PoW/PoS', '/coins/enter/overview', 1, 'cryptocompare'),
(673, 24402, 'WGC', 'World Gold Coin (WGC)', 'World Gold Coin', 690, 'SHA256', 'PoW', '/coins/wgc/overview', 1, 'cryptocompare'),
(674, 24405, 'BM', 'BitMoon (BM)', 'BitMoon', 691, 'X13', 'PoS', '/coins/bm/overview', 1, 'cryptocompare'),
(675, 24866, 'FRWC', 'Frankywillcoin (FRWC)', 'Frankywillcoin', 692, 'Scrypt', 'PoW/PoS', '/coins/frwc/overview', 1, 'cryptocompare'),
(676, 24871, 'PSY', 'Psilocybin (PSY)', 'Psilocybin', 693, 'SHA256D', 'PoW/PoS', '/coins/psy/overview', 1, 'cryptocompare'),
(677, 24885, 'XT', 'ExtremeCoin (XT)', 'ExtremeCoin', 694, 'Scrypt', 'PoW/PoS', '/coins/xt/overview', 1, 'cryptocompare'),
(678, 24887, 'RUST', 'RustCoin (RUST)', 'RustCoin', 695, 'Scrypt', 'PoW/PoS', '/coins/rust/overview', 1, 'cryptocompare'),
(679, 24892, 'NZC', 'NewZealandCoin (NZC)', 'NewZealandCoin', 696, 'Scrypt', 'PoW', '/coins/nzc/overview', 1, 'cryptocompare'),
(680, 24926, 'SNGLS', 'SingularDTV (SNGLS)', 'SingularDTV', 697, 'N/A', 'N/A', '/coins/sngls/overview', 1, 'cryptocompare'),
(681, 25082, 'XAUR', 'Xaurum (XAUR)', 'Xaurum', 698, 'N/A', 'N/A', '/coins/xaur/overview', 1, 'cryptocompare'),
(682, 25238, 'BFX', 'BitFinex Tokens (BFX)', 'BitFinex Tokens', 699, 'N/A', 'N/A', '/coins/bfx/overview', 1, 'cryptocompare'),
(683, 25594, 'UNIQ', 'Uniqredit (UNIQ)', 'Uniqredit', 700, 'SHA256D', 'PoW', '/coins/uniq/overview', 1, 'cryptocompare'),
(684, 25613, 'CRX', 'ChronosCoin (CRX)', 'ChronosCoin', 701, 'Scrypt', 'PoW/PoS', '/coins/crx/overview', 1, 'cryptocompare'),
(685, 25721, 'DCT', 'Decent (DCT)', 'Decent', 702, 'N/A', 'PoS', '/coins/dct/overview', 1, 'cryptocompare'),
(686, 25817, 'XPOKE', 'PokeChain (XPOKE)', 'PokeChain', 703, 'X13', 'PoS', '/coins/xpoke/overview', 1, 'cryptocompare'),
(687, 25820, 'MUDRA', 'MudraCoin (MUDRA)', 'MudraCoin', 704, 'X13', 'PoS', '/coins/mudra/overview', 1, 'cryptocompare'),
(688, 25822, 'WARP', 'WarpCoin (WARP)', 'WarpCoin', 705, 'PoS', 'PoS', '/coins/warp/overview', 1, 'cryptocompare'),
(689, 25825, 'CNMT', 'Coinomat (CNMT)', 'Coinomat', 706, 'N/A', 'N/A', '/coins/cnmt/overview', 1, 'cryptocompare'),
(690, 25830, 'PIZZA', 'PizzaCoin (PIZZA)', 'PizzaCoin', 707, 'X11', 'PoW', '/coins/pizza/overview', 1, 'cryptocompare'),
(691, 25916, 'LC', 'Lutetium Coin (LC)', 'Lutetium Coin', 708, 'X11', 'PoS', '/coins/lc/overview', 1, 'cryptocompare'),
(692, 25917, 'HEAT', 'Heat Ledger (HEAT)', 'Heat Ledger', 709, 'N/A', 'PoS/PoP', '/coins/heat/overview', 1, 'cryptocompare'),
(693, 25921, 'ICN', 'Iconomi (ICN)', 'Iconomi', 710, 'N/A', 'N/A', '/coins/icn/overview', 1, 'cryptocompare'),
(694, 25925, 'EXB', 'ExaByte (EXB) (EXB)', 'ExaByte (EXB)', 711, 'SHA256', 'PoW', '/coins/exb/overview', 1, 'cryptocompare'),
(695, 25946, 'WINGS', 'Wings DAO (WINGS)', 'Wings DAO', 712, 'N/A', 'N/A', '/coins/wings/overview', 1, 'cryptocompare'),
(696, 26113, 'CDX*', 'Cryptodex (CDX*)', 'Cryptodex', 713, 'N/A', 'N/A', '/coins/cdxstar/overview', 1, 'cryptocompare'),
(697, 26121, 'RBIT', 'ReturnBit (RBIT)', 'ReturnBit', 714, 'Scrypt', 'PoW', '/coins/rbit/overview', 1, 'cryptocompare'),
(698, 26129, 'DCS.', 'deCLOUDs (DCS)', 'deCLOUDs', 715, 'N/A', 'PoS', '/coins/dcs/overview', 1, 'cryptocompare'),
(699, 26132, 'KMD', 'Komodo (KMD)', 'Komodo', 716, 'Equihash', 'dPoW/PoW', '/coins/kmd/overview', 1, 'cryptocompare'),
(700, 26194, 'GB', 'GoldBlocks (GB)', 'GoldBlocks', 717, 'X11', 'PoW/PoS', '/coins/gb/overview', 1, 'cryptocompare'),
(701, 27368, 'NEO', 'NEO (NEO)', 'NEO', 718, 'N/A', 'N/A', '/coins/neo/overview', 1, 'cryptocompare'),
(702, 27370, 'ANC', 'Anoncoin (ANC)', 'Anoncoin', 719, 'N/A', 'PoW', '/coins/anc/overview', 1, 'cryptocompare'),
(703, 27591, 'SYNX', 'Syndicate (SYNX)', 'Syndicate', 720, 'X11', 'PoW/PoS', '/coins/synx/overview', 1, 'cryptocompare'),
(704, 27594, 'MC', 'Mass Coin (MC)', 'Mass Coin', 721, 'N/A', 'N/A', '/coins/mc/overview', 1, 'cryptocompare'),
(705, 27634, 'EDR', 'E-Dinar Coin (EDR)', 'E-Dinar Coin', 722, 'X11', 'DPoS', '/coins/edr/overview', 1, 'cryptocompare'),
(706, 27674, 'JWL', 'Jewels (JWL)', 'Jewels', 723, 'POS 3.0', 'N/A', '/coins/jwl/overview', 1, 'cryptocompare'),
(707, 27681, 'WAY', 'WayCoin (WAY)', 'WayCoin', 724, 'X11', 'PoS', '/coins/way/overview', 1, 'cryptocompare'),
(708, 27993, 'TAB', 'MollyCoin (TAB)', 'MollyCoin', 725, 'Scrypt', 'PoW/PoS', '/coins/tab/overview', 1, 'cryptocompare'),
(709, 27996, 'TRIG', 'Trigger (TRIG)', 'Trigger', 726, 'N/A', 'N/A', '/coins/trig/overview', 1, 'cryptocompare'),
(710, 28019, 'BITCNY', 'bitCNY (BITCNY)', 'bitCNY', 727, 'N/A', 'N/A', '/coins/bitcny/overview', 1, 'cryptocompare'),
(711, 28021, 'BITUSD', 'bitUSD (BITUSD)', 'bitUSD', 728, 'N/A', 'N/A', '/coins/bitusd/overview', 1, 'cryptocompare'),
(712, 28023, 'ATM*', 'Autumncoin (ATM*)', 'Autumncoin', 729, 'X11', 'PoW/PoS', '/coins/atmstar/overview', 1, 'cryptocompare'),
(713, 28025, 'STO', 'Save The Ocean (STO)', 'Save The Ocean', 730, 'X11', 'PoW/PoS', '/coins/sto/overview', 1, 'cryptocompare'),
(714, 28027, 'SNS', 'Sense (SNS)', 'Sense', 731, 'N/A', 'N/A', '/coins/sns/overview', 1, 'cryptocompare'),
(715, 28081, 'FSN*', 'Fusion (FSN*)', 'Fusion', 732, 'SHA256', 'PoW', '/coins/fsnstar/overview', 1, 'cryptocompare'),
(716, 28083, 'CTC', 'CarterCoin (CTC)', 'CarterCoin', 733, 'Scrypt', 'PoW/PoS', '/coins/ctc/overview', 1, 'cryptocompare'),
(717, 28087, 'TOT', 'TotCoin (TOT)', 'TotCoin', 734, 'Scrypt', 'PoW/PoS', '/coins/tot/overview', 1, 'cryptocompare'),
(718, 28089, 'BTD', 'Bitcloud (BTD)', 'Bitcloud', 735, 'Scrypt', 'PoW/PoS', '/coins/btd/overview', 1, 'cryptocompare'),
(719, 28125, 'BOTS', 'ArkDAO (BOTS)', 'ArkDAO', 736, 'N/A', 'N/A', '/coins/bots/overview', 1, 'cryptocompare'),
(720, 28128, 'MDC', 'MedicCoin (MDC)', 'MedicCoin', 737, 'Scrypt', 'PoW/PoS', '/coins/mdc/overview', 1, 'cryptocompare'),
(721, 28131, 'FTP', 'FuturePoints (FTP)', 'FuturePoints', 738, 'X11', 'PoS', '/coins/ftp/overview', 1, 'cryptocompare'),
(722, 28136, 'ZET2', 'Zeta2Coin (ZET2)', 'Zeta2Coin', 739, 'Quark', 'PoW/PoS', '/coins/zet2/overview', 1, 'cryptocompare'),
(723, 28151, 'COV*', 'CovenCoin (COV*)', 'CovenCoin', 740, 'SHA256', 'PoW/PoS', '/coins/covstar/overview', 1, 'cryptocompare'),
(724, 28154, 'KRB', 'Karbo (KRB)', 'Karbo', 741, 'CryptoNight', 'PoW', '/coins/krb/overview', 1, 'cryptocompare'),
(725, 28172, 'TELL', 'Tellurion (TELL)', 'Tellurion', 742, 'X11', 'PoW/PoS', '/coins/tell/overview', 1, 'cryptocompare'),
(726, 28174, 'ENE', 'EneCoin (ENE)', 'EneCoin', 743, 'X13', 'PoW/PoS', '/coins/ene/overview', 1, 'cryptocompare'),
(727, 28176, 'TDFB', 'TDFB (TDFB)', 'TDFB', 744, 'SHA256D', 'PoW/PoS', '/coins/tdfb/overview', 1, 'cryptocompare'),
(728, 28204, 'BLOCKPAY', 'BlockPay (BLOCKPAY)', 'BlockPay', 745, 'N/A', 'N/A', '/coins/blockpay/overview', 1, 'cryptocompare'),
(729, 28208, 'BXT', 'BitTokens (BXT)', 'BitTokens', 746, 'SHA256', 'PoW/PoS', '/coins/bxt/overview', 1, 'cryptocompare'),
(730, 28216, 'ZYD', 'ZayedCoin (ZYD)', 'ZayedCoin', 747, 'SHA256', 'PoW', '/coins/zyd/overview', 1, 'cryptocompare'),
(731, 28219, 'MST', 'MustangCoin (MST)', 'MustangCoin', 748, 'X11', 'PoW/PoS', '/coins/mst/overview', 1, 'cryptocompare'),
(732, 28221, 'GOON', 'Goonies (GOON)', 'Goonies', 749, 'Scrypt', 'PoW', '/coins/goon/overview', 1, 'cryptocompare'),
(733, 28225, 'VLT', 'Veltor (VLT)', 'Veltor', 751, 'N/A', 'PoW', '/coins/vlt/overview', 1, 'cryptocompare'),
(734, 28227, 'ZNE', 'ZoneCoin (ZNE)', 'ZoneCoin', 752, 'Scrypt', 'PoW/PoS', '/coins/zne/overview', 1, 'cryptocompare'),
(735, 28229, 'DCK', 'DickCoin (DCK)', 'DickCoin', 753, 'X11', 'PoW/PoS', '/coins/dck/overview', 1, 'cryptocompare'),
(736, 28276, 'COVAL', 'Circuits of Value (COVAL)', 'Circuits of Value', 754, 'Multiple', 'PoW', '/coins/coval/overview', 1, 'cryptocompare'),
(737, 28278, 'DGDC', 'DarkGold (DGDC)', 'DarkGold', 755, 'X13', 'PoW/PoS', '/coins/dgdc/overview', 1, 'cryptocompare'),
(738, 28317, 'TODAY', 'TodayCoin (TODAY)', 'TodayCoin', 756, 'Scrypt', 'PoW', '/coins/today/overview', 1, 'cryptocompare'),
(739, 28323, 'VRM', 'Verium (VRM)', 'Verium', 757, 'N/A', 'PoWT', '/coins/vrm/overview', 1, 'cryptocompare'),
(740, 28326, 'ROOT', 'RootCoin (ROOT)', 'RootCoin', 758, 'Scrypt', 'PoW/PoS', '/coins/root/overview', 1, 'cryptocompare'),
(741, 28328, '1ST', 'FirstBlood (1ST)', 'FirstBlood', 759, 'N/A', 'N/A', '/coins/1st/overview', 1, 'cryptocompare'),
(742, 28330, 'GPL', 'Gold Pressed Latinum (GPL)', 'Gold Pressed Latinum', 760, 'N/A', 'PoW/PoS', '/coins/gpl/overview', 1, 'cryptocompare'),
(743, 28332, 'DOPE', 'DopeCoin (DOPE)', 'DopeCoin', 761, 'Scrypt', 'PoW', '/coins/dope/overview', 1, 'cryptocompare'),
(744, 28333, 'B3', 'B3 Coin (B3)', 'B3 Coin', 762, 'X11', 'PoW/PoS', '/coins/b3/overview', 1, 'cryptocompare'),
(745, 28336, 'FX', 'FCoin (FX)', 'FCoin', 763, 'Scrypt', 'PoW/PoS', '/coins/fx/overview', 1, 'cryptocompare'),
(746, 28342, 'PIO', 'Pioneershares (PIO)', 'Pioneershares', 764, 'X11', 'PoW/PoS', '/coins/pio/overview', 1, 'cryptocompare'),
(747, 28431, 'PROUD', 'PROUD Money (PROUD)', 'PROUD Money', 765, 'X11', 'PoW/PoS', '/coins/proud/overview', 1, 'cryptocompare'),
(748, 28650, 'SMSR', 'Samsara Coin (SMSR)', 'Samsara Coin', 766, 'QuBit', 'PoW/PoS', '/coins/smsr/overview', 1, 'cryptocompare'),
(749, 28652, 'UBIQ', 'Ubiqoin (UBIQ)', 'Ubiqoin', 767, 'Progressive-', 'PoS', '/coins/ubiq/overview', 1, 'cryptocompare'),
(750, 28654, 'ARM', 'Armory Coin (ARM)', 'Armory Coin', 768, 'Scrypt', 'PoW/PoS', '/coins/arm/overview', 1, 'cryptocompare'),
(751, 28657, 'RING', 'RingCoin (RING)', 'RingCoin', 769, 'Scrypt', 'PoW/PoS', '/coins/ring/overview', 1, 'cryptocompare'),
(752, 28665, 'ERB', 'ERBCoin (ERB)', 'ERBCoin', 770, 'Scrypt', 'N/A', '/coins/erb/overview', 1, 'cryptocompare'),
(753, 28700, 'LAZ', 'Lazarus (LAZ)', 'Lazarus', 771, 'DPoS', 'DPoS', '/coins/laz/overview', 1, 'cryptocompare'),
(754, 28703, 'FONZ', 'FonzieCoin (FONZ)', 'FonzieCoin', 772, 'SHA256', 'PoW/PoS', '/coins/fonz/overview', 1, 'cryptocompare'),
(755, 28764, 'BTCR', 'BitCurrency (BTCR)', 'BitCurrency', 773, 'Scrypt', 'PoS', '/coins/btcr/overview', 1, 'cryptocompare'),
(756, 28767, 'DROP*', 'FaucetCoin (DROP*)', 'FaucetCoin', 774, 'X13', 'PoS', '/coins/dropstar/overview', 1, 'cryptocompare'),
(757, 28770, 'SANDG', 'Save and Gain (SANDG)', 'Save and Gain', 775, 'SHA256', 'PoW', '/coins/sandg/overview', 1, 'cryptocompare'),
(758, 28772, 'PNK', 'SteamPunk (PNK)', 'SteamPunk', 776, 'PoS', 'PoS', '/coins/pnk/overview', 1, 'cryptocompare'),
(759, 28774, 'MOOND', 'Dark Moon (MOOND)', 'Dark Moon', 777, 'Scrypt', 'PoW/PoS', '/coins/moond/overview', 1, 'cryptocompare'),
(760, 28776, 'DLC', 'DollarCoin (DLC)', 'DollarCoin', 778, 'SHA256', 'PoW', '/coins/dlc/overview', 1, 'cryptocompare'),
(761, 28778, 'SEN', 'Sentaro (SEN)', 'Sentaro', 779, 'Scrypt', 'PoW/PoS', '/coins/sen/overview', 1, 'cryptocompare'),
(762, 28880, 'SCN', 'Swiscoin (SCN)', 'Swiscoin', 781, 'Scrypt', 'PoW/PoW', '/coins/scn/overview', 1, 'cryptocompare'),
(763, 28882, 'WEX', 'Wexcoin (WEX)', 'Wexcoin', 782, 'N/A', 'PoS', '/coins/wex/overview', 1, 'cryptocompare'),
(764, 28885, 'LTH', 'Lathaan (LTH)', 'Lathaan', 783, 'PoS', 'N/A', '/coins/lth/overview', 1, 'cryptocompare'),
(765, 28888, 'BRONZ', 'BitBronze (BRONZ)', 'BitBronze', 784, 'Scrypt', 'PoW', '/coins/bronz/overview', 1, 'cryptocompare'),
(766, 28890, 'SH', 'Shilling (SH)', 'Shilling', 785, 'Scrypt', 'PoW', '/coins/sh/overview', 1, 'cryptocompare'),
(767, 28893, 'BUZZ', 'BuzzCoin (BUZZ)', 'BuzzCoin', 786, 'SHA256D', 'PoW/PoS', '/coins/buzz/overview', 1, 'cryptocompare'),
(768, 29001, 'MG', 'Mind Gene (MG)', 'Mind Gene', 788, 'SHA256', 'PoW/PoS', '/coins/mg/overview', 1, 'cryptocompare'),
(769, 29004, 'PSI', 'PSIcoin (PSI)', 'PSIcoin', 789, 'X11', 'PoS', '/coins/psi/overview', 1, 'cryptocompare'),
(770, 29008, 'XPO', 'Opair (XPO)', 'Opair', 790, 'PoS', 'PoS', '/coins/xpo/overview', 1, 'cryptocompare'),
(771, 29010, 'NLC', 'NoLimitCoin (NLC)', 'NoLimitCoin', 791, 'SHA256D', 'PoW/PoS', '/coins/nlc/overview', 1, 'cryptocompare'),
(772, 29041, 'PSB', 'PesoBit (PSB)', 'PesoBit', 792, 'Scrypt', 'PoW/PoS', '/coins/psb/overview', 1, 'cryptocompare'),
(773, 29131, 'XBTS', 'Beats (XBTS)', 'Beats', 793, 'X11', 'PoW/PoS', '/coins/xbts/overview', 1, 'cryptocompare'),
(774, 29133, 'FIT', 'Fitcoin (FIT)', 'Fitcoin', 794, 'X11', 'PoW/PoS', '/coins/fit/overview', 1, 'cryptocompare'),
(775, 29193, 'PINKX', 'PantherCoin (PINKX)', 'PantherCoin', 796, 'Scrypt', 'PoW/PoS', '/coins/pinkx/overview', 1, 'cryptocompare'),
(776, 29196, 'FIRE', 'FireCoin (FIRE)', 'FireCoin', 797, 'X15', 'PoW/PoS', '/coins/fire/overview', 1, 'cryptocompare'),
(777, 29198, 'UNF', 'Unfed Coin (UNF)', 'Unfed Coin', 798, 'Scrypt', 'PoW', '/coins/unf/overview', 1, 'cryptocompare'),
(778, 29200, 'SPORT', 'SportsCoin (SPORT)', 'SportsCoin', 799, 'X11', 'PoS', '/coins/sport/overview', 1, 'cryptocompare'),
(779, 29348, 'PPY', 'Peerplays (PPY)', 'Peerplays', 801, 'N/A', 'N/A', '/coins/ppy/overview', 1, 'cryptocompare'),
(780, 29366, 'NTC', 'NineElevenTruthCoin (NTC)', 'NineElevenTruthCoin', 802, 'Scrypt', 'PoW/PoS', '/coins/ntc/overview', 1, 'cryptocompare'),
(781, 29368, 'EGO', 'EGOcoin (EGO)', 'EGOcoin', 803, 'PoS', 'PoS', '/coins/ego/overview', 1, 'cryptocompare'),
(782, 29370, 'BTCL*', 'BitluckCoin (BTCL*)', 'BitluckCoin', 804, 'Scrypt', 'PoS', '/coins/btclstar/overview', 1, 'cryptocompare'),
(783, 29374, 'RCN*', 'RCoin (RCN*)', 'RCoin', 805, 'SHA256', 'N/A', '/coins/rcnstar/overview', 1, 'cryptocompare'),
(784, 29376, 'X2', 'X2Coin (X2)', 'X2Coin', 806, 'N/A', 'N/A', '/coins/x2/overview', 1, 'cryptocompare'),
(785, 29378, 'MT', 'Mycelium Token (MT)', 'Mycelium Token', 807, 'N/A', 'N/A', '/coins/mt/overview', 1, 'cryptocompare'),
(786, 29455, 'TIA', 'Tianhe (TIA)', 'Tianhe', 808, 'Lyra2RE', 'N/A', '/coins/tia/overview', 1, 'cryptocompare'),
(787, 29458, 'GBRC', 'GBR Coin (GBRC)', 'GBR Coin', 809, 'Scrypt', 'PoW', '/coins/gbrc/overview', 1, 'cryptocompare'),
(788, 29460, 'XUP', 'UPcoin (XUP)', 'UPcoin', 810, 'X13', 'PoS', '/coins/xup/overview', 1, 'cryptocompare'),
(789, 29552, 'HALLO', 'Halloween Coin (HALLO)', 'Halloween Coin', 812, 'X11', 'PoW/PoS', '/coins/hallo/overview', 1, 'cryptocompare'),
(790, 29554, 'BBCC', 'BaseballCardCoin (BBCC)', 'BaseballCardCoin', 813, 'Scrypt', 'PoW/PoS', '/coins/bbcc/overview', 1, 'cryptocompare'),
(791, 29556, 'EMIGR', 'EmiratesGoldCoin (EMIGR)', 'EmiratesGoldCoin', 814, 'SHA256', 'PoW', '/coins/emigr/overview', 1, 'cryptocompare'),
(792, 29559, 'BHC', 'BighanCoin (BHC)', 'BighanCoin', 815, 'Quark', 'PoW', '/coins/bhc/overview', 1, 'cryptocompare'),
(793, 29711, 'CRAFT', 'Craftcoin (CRAFT)', 'Craftcoin', 816, 'Scrypt', 'PoW/PoS', '/coins/craft/overview', 1, 'cryptocompare'),
(794, 29713, 'INV', 'Invictus (INV)', 'Invictus', 817, 'X11', 'PoW/PoS', '/coins/inv/overview', 1, 'cryptocompare'),
(795, 29715, 'OLYMP', 'OlympCoin (OLYMP)', 'OlympCoin', 818, 'X11', 'PoW/PoS', '/coins/olymp/overview', 1, 'cryptocompare'),
(796, 29718, 'DPAY', 'DelightPay (DPAY)', 'DelightPay', 819, 'X13', 'PoW/PoS', '/coins/dpay/overview', 1, 'cryptocompare'),
(797, 29721, 'ATOM', 'Atomic Coin (ATOM)', 'Atomic Coin', 820, 'Scrypt', 'PoW/PoS', '/coins/atom/overview', 1, 'cryptocompare'),
(798, 29733, 'HKG', 'Hacker Gold (HKG)', 'Hacker Gold', 821, 'N/A', 'N/A', '/coins/hkg/overview', 1, 'cryptocompare'),
(799, 29758, 'ANTC', 'AntiLitecoin (ANTC)', 'AntiLitecoin', 822, 'Scrypt', 'PoW', '/coins/antc/overview', 1, 'cryptocompare'),
(800, 29762, 'JOBS', 'JobsCoin (JOBS)', 'JobsCoin', 823, 'X11', 'PoW/PoS', '/coins/jobs/overview', 1, 'cryptocompare'),
(801, 29904, 'DGORE', 'DogeGoreCoin (DGORE)', 'DogeGoreCoin', 824, 'X11', 'PoW/PoS', '/coins/dgore/overview', 1, 'cryptocompare'),
(802, 29924, 'THC', 'The Hempcoin (THC)', 'The Hempcoin', 825, 'Scrypt', 'PoW/PoS', '/coins/thc/overview', 1, 'cryptocompare'),
(803, 29926, 'TRA', 'Tetra (TRA)', 'Tetra', 826, 'Scrypt', 'PoW', '/coins/tra/overview', 1, 'cryptocompare'),
(804, 29928, 'RMS', 'Resumeo Shares (RMS)', 'Resumeo Shares', 827, 'NIST5', 'PoS', '/coins/rms/overview', 1, 'cryptocompare'),
(805, 29935, 'FJC', 'FujiCoin (FJC)', 'FujiCoin', 828, 'Scrypt-n', 'PoW', '/coins/fjc/overview', 1, 'cryptocompare'),
(806, 30016, 'VAPOR', 'Vaporcoin (VAPOR)', 'Vaporcoin', 829, 'SHA256', 'PoW/PoS', '/coins/vapor/overview', 1, 'cryptocompare'),
(807, 30019, 'SDP', 'SydPakCoin (SDP)', 'SydPakCoin', 830, 'X13', 'PoW/PoS', '/coins/sdp/overview', 1, 'cryptocompare'),
(808, 30020, 'RRT', 'Recovery Right Tokens (RRT)', 'Recovery Right Tokens', 831, 'N/A', 'N/A', '/coins/rrt/overview', 1, 'cryptocompare'),
(809, 30022, 'XZC', 'ZCoin (XZC)', 'ZCoin', 832, 'Lyra2Z', 'PoW', '/coins/xzc/overview', 1, 'cryptocompare'),
(810, 30024, 'PRE', 'Premium (PRE)', 'Premium', 833, 'Scrypt', 'PoW', '/coins/pre/overview', 1, 'cryptocompare'),
(811, 30029, 'CALC', 'CaliphCoin (CALC)', 'CaliphCoin', 834, 'SHA256', 'PoW', '/coins/calc/overview', 1, 'cryptocompare'),
(812, 30117, 'LEA', 'LeaCoin (LEA)', 'LeaCoin', 835, 'SHA256', 'PoW', '/coins/lea/overview', 1, 'cryptocompare'),
(813, 30119, 'CF', 'Californium (CF)', 'Californium', 836, 'SHA256', 'PoW', '/coins/cf/overview', 1, 'cryptocompare'),
(814, 30121, 'CRNK', 'CrankCoin (CRNK)', 'CrankCoin', 837, 'X11', 'PoS/PoW', '/coins/crnk/overview', 1, 'cryptocompare'),
(815, 30123, 'CFC', 'CoffeeCoin (CFC)', 'CoffeeCoin', 838, 'PoS', 'PoS', '/coins/cfc/overview', 1, 'cryptocompare'),
(816, 30126, 'VTY', 'Victoriouscoin (VTY)', 'Victoriouscoin', 839, 'Scrypt', 'PoW/PoS', '/coins/vty/overview', 1, 'cryptocompare'),
(817, 30169, 'SFE', 'Safecoin (SFE)', 'Safecoin', 841, 'N/A', 'PoW/PoS', '/coins/sfe/overview', 1, 'cryptocompare'),
(818, 30173, 'ARDR', 'Ardor (ARDR)', 'Ardor', 842, 'N/A', 'PoS', '/coins/ardr/overview', 1, 'cryptocompare'),
(819, 30175, 'BS', 'BlackShadowCoin (BS)', 'BlackShadowCoin', 843, 'X11', 'PoW/PoS', '/coins/bs/overview', 1, 'cryptocompare'),
(820, 30177, 'JIF', 'JiffyCoin (JIF)', 'JiffyCoin', 844, 'SHA256D', 'PoW', '/coins/jif/overview', 1, 'cryptocompare'),
(821, 30179, 'CRAB', 'CrabCoin (CRAB)', 'CrabCoin', 845, 'X15', 'PoW/PoS', '/coins/crab/overview', 1, 'cryptocompare'),
(822, 30182, 'AIR*', 'Aircoin (AIR*)', 'Aircoin', 846, 'Scrypt', 'PoW/PoS', '/coins/airstar/overview', 1, 'cryptocompare'),
(823, 30359, 'HILL', 'President Clinton (HILL)', 'President Clinton', 847, 'N/A', 'N/A', '/coins/hill/overview', 1, 'cryptocompare'),
(824, 30361, 'FOREX', 'ForexCoin (FOREX)', 'ForexCoin', 848, 'X15', 'PoW/PoS', '/coins/forex/overview', 1, 'cryptocompare'),
(825, 30364, 'MONETA', 'Moneta (MONETA)', 'Moneta', 849, 'Scrypt', 'PoW', '/coins/moneta/overview', 1, 'cryptocompare'),
(826, 30367, 'EC', 'Eclipse (EC)', 'Eclipse', 850, 'SHA256D', 'PoW/PoS', '/coins/ec/overview', 1, 'cryptocompare'),
(827, 30369, 'RUBIT', 'Rublebit (RUBIT)', 'Rublebit', 851, 'Scrypt', 'PoW', '/coins/rubit/overview', 1, 'cryptocompare'),
(828, 30371, 'HCC', 'HappyCreatorCoin  (HCC)', 'HappyCreatorCoin ', 852, 'Scrypt', 'PoW', '/coins/hcc/overview', 1, 'cryptocompare'),
(829, 30373, 'BRAIN', 'BrainCoin (BRAIN)', 'BrainCoin', 853, 'X11', 'PoW/PoS', '/coins/brain/overview', 1, 'cryptocompare'),
(830, 30377, 'VTX', 'Vertex (VTX)', 'Vertex', 854, 'SHA256', 'PoW/PoS', '/coins/vtx/overview', 1, 'cryptocompare'),
(831, 30379, 'KRC', 'KRCoin (KRC)', 'KRCoin', 855, 'X11', 'PoW', '/coins/krc/overview', 1, 'cryptocompare'),
(832, 30386, 'ROYAL', 'RoyalCoin (ROYAL)', 'RoyalCoin', 856, 'X13', 'PoS', '/coins/royal/overview', 1, 'cryptocompare'),
(833, 30388, 'LFC', 'BigLifeCoin (LFC)', 'BigLifeCoin', 857, 'X11', 'PoW', '/coins/lfc/overview', 1, 'cryptocompare'),
(834, 30391, 'ZUR', 'Zurcoin (ZUR)', 'Zurcoin', 858, 'Quark', 'PoW', '/coins/zur/overview', 1, 'cryptocompare'),
(835, 30393, 'NUBIS', 'NubisCoin (NUBIS)', 'NubisCoin', 859, 'SHA256D', 'PoW/PoS', '/coins/nubis/overview', 1, 'cryptocompare'),
(836, 30421, 'TENNET', 'Tennet (TENNET)', 'Tennet', 860, 'SHA256D', 'PoW/PoS', '/coins/tennet/overview', 1, 'cryptocompare'),
(837, 30423, 'PEC', 'PeaceCoin (PEC)', 'PeaceCoin', 861, 'X11', 'PoW', '/coins/pec/overview', 1, 'cryptocompare'),
(838, 30424, 'GMX', 'Goldmaxcoin (GMX)', 'Goldmaxcoin', 862, 'Scrypt', 'PoW', '/coins/gmx/overview', 1, 'cryptocompare'),
(839, 30428, '32BIT', '32Bitcoin (32BIT)', '32Bitcoin', 863, 'X11', 'PoW/PoS', '/coins/32bit/overview', 1, 'cryptocompare'),
(840, 30521, 'GNJ', 'GanjaCoin V2 (GNJ)', 'GanjaCoin V2', 864, 'X14', 'PoW/PoS', '/coins/gnj/overview', 1, 'cryptocompare'),
(841, 30523, 'TEAM', 'TeamUP (TEAM)', 'TeamUP', 865, 'PoS', 'PoS', '/coins/team/overview', 1, 'cryptocompare'),
(842, 30536, 'SCT', 'ScryptToken (SCT)', 'ScryptToken', 866, 'Scrypt', 'PoW/PoS', '/coins/sct/overview', 1, 'cryptocompare'),
(843, 30544, 'LANA', 'LanaCoin (LANA)', 'LanaCoin', 867, 'SHA256D', 'PoW/PoS', '/coins/lana/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(844, 30550, 'ELE', 'Elementrem (ELE)', 'Elementrem', 868, 'Ethash', 'PoW', '/coins/ele/overview', 1, 'cryptocompare'),
(845, 30566, 'GCC', 'GuccioneCoin (GCC)', 'GuccioneCoin', 869, 'Scrypt', 'PoW', '/coins/gcc/overview', 1, 'cryptocompare'),
(846, 30568, 'AND', 'AndromedaCoin (AND)', 'AndromedaCoin', 870, 'X11', 'PoW/PoS', '/coins/and/overview', 1, 'cryptocompare'),
(847, 30736, 'GBYTE', 'Byteball (GBYTE)', 'Byteball', 871, 'N/A', 'N/A', '/coins/gbyte/overview', 1, 'cryptocompare'),
(848, 30883, 'EQUAL', 'EqualCoin (EQUAL)', 'EqualCoin', 872, 'X13', 'PoW/PoS', '/coins/equal/overview', 1, 'cryptocompare'),
(849, 30887, 'SWEET', 'SweetStake (SWEET)', 'SweetStake', 873, 'PoS', 'N/A', '/coins/sweet/overview', 1, 'cryptocompare'),
(850, 30912, '2BACCO', '2BACCO Coin (2BACCO)', '2BACCO Coin', 874, 'Scrypt', 'PoW/PoS', '/coins/2bacco/overview', 1, 'cryptocompare'),
(851, 30920, 'DKC', 'DarkKnightCoin (DKC)', 'DarkKnightCoin', 875, 'Scrypt', 'PoW/PoS', '/coins/dkc/overview', 1, 'cryptocompare'),
(852, 30925, 'COC', 'Community Coin (COC)', 'Community Coin', 876, 'SHA256', 'PoW', '/coins/coc/overview', 1, 'cryptocompare'),
(853, 31002, 'CHOOF', 'ChoofCoin (CHOOF)', 'ChoofCoin', 877, 'Scrypt', 'PoW/PoS', '/coins/choof/overview', 1, 'cryptocompare'),
(854, 31004, 'CSH', 'CashOut (CSH)', 'CashOut', 878, 'SHA256', 'PoW', '/coins/csh/overview', 1, 'cryptocompare'),
(855, 32544, 'ZCL', 'ZClassic (ZCL)', 'ZClassic', 879, 'Equihash', 'PoW', '/coins/zcl/overview', 1, 'cryptocompare'),
(856, 32548, 'RYCN', 'RoyalCoin 2.0 (RYCN)', 'RoyalCoin 2.0', 880, 'X13', 'PoS', '/coins/rycn/overview', 1, 'cryptocompare'),
(857, 32686, 'PCS', 'Pabyosi Coin (PCS)', 'Pabyosi Coin', 881, 'X11', 'PoW/PoS', '/coins/pcs/overview', 1, 'cryptocompare'),
(858, 32688, 'NBIT', 'NetBit (NBIT)', 'NetBit', 882, 'Scrypt', 'PoW/PoS', '/coins/nbit/overview', 1, 'cryptocompare'),
(859, 32691, 'WINE', 'WineCoin (WINE)', 'WineCoin', 883, 'Scrypt', 'PoW/PoS', '/coins/wine/overview', 1, 'cryptocompare'),
(860, 32694, 'DAR', 'Darcrus (DAR)', 'Darcrus', 884, 'N/A', 'N/A', '/coins/dar/overview', 1, 'cryptocompare'),
(861, 32699, 'ARK', 'ARK (ARK)', 'ARK', 885, 'DPoS', 'DPoS', '/coins/ark/overview', 1, 'cryptocompare'),
(862, 32775, 'IFLT', 'InflationCoin (IFLT)', 'InflationCoin', 886, 'X11', 'PoW/PoS', '/coins/iflt/overview', 1, 'cryptocompare'),
(863, 32777, 'ZECD', 'ZCashDarkCoin (ZECD)', 'ZCashDarkCoin', 887, 'Scrypt', 'PoW', '/coins/zecd/overview', 1, 'cryptocompare'),
(864, 32785, 'ZXT', 'Zcrypt (ZXT)', 'Zcrypt', 888, 'N/A', 'PoW/PoZ', '/coins/zxt/overview', 1, 'cryptocompare'),
(865, 32870, 'WASH', 'WashingtonCoin (WASH)', 'WashingtonCoin', 889, 'X11', 'PoW/PoS', '/coins/wash/overview', 1, 'cryptocompare'),
(866, 32873, 'TESLA', 'TeslaCoilCoin (TESLA)', 'TeslaCoilCoin', 890, 'N/A', 'N/A', '/coins/tesla/overview', 1, 'cryptocompare'),
(867, 32875, 'LUCKY', 'LuckyBlocks (LUCKY)', 'LuckyBlocks', 891, 'PoS', 'PoS', '/coins/lucky/overview', 1, 'cryptocompare'),
(868, 32880, 'VSL', 'vSlice (VSL)', 'vSlice', 892, 'N/A', 'N/A', '/coins/vsl/overview', 1, 'cryptocompare'),
(869, 32882, 'TPG', 'Troll Payment (TPG)', 'Troll Payment', 893, 'PoS', 'N/A', '/coins/tpg/overview', 1, 'cryptocompare'),
(870, 33001, 'LEO', 'LEOcoin (LEO)', 'LEOcoin', 894, 'Scrypt', 'PoW', '/coins/leo/overview', 1, 'cryptocompare'),
(871, 33004, 'MDT', 'Midnight (MDT)', 'Midnight', 895, 'SHA256', 'PoW/PoS', '/coins/mdt/overview', 1, 'cryptocompare'),
(872, 33008, 'CBD', 'CBD Crystals (CBD)', 'CBD Crystals', 896, 'PoS', 'N/A', '/coins/cbd/overview', 1, 'cryptocompare'),
(873, 33010, 'PEX', 'PosEx (PEX)', 'PosEx', 897, 'SHA256D', 'N/A', '/coins/pex/overview', 1, 'cryptocompare'),
(874, 33017, 'INSANE', 'InsaneCoin (INSANE)', 'InsaneCoin', 898, 'X11', 'PoW/PoS', '/coins/insane/overview', 1, 'cryptocompare'),
(875, 33022, 'GNT', 'Golem Network Token (GNT)', 'Golem Network Token', 900, 'N/A', 'N/A', '/coins/gnt/overview', 1, 'cryptocompare'),
(876, 33127, 'PEN*', 'PenCoin (PEN*)', 'PenCoin', 901, 'Scrypt', 'PoW', '/coins/penstar/overview', 1, 'cryptocompare'),
(877, 33129, 'BASH', 'LuckChain (BASH)', 'LuckChain', 902, 'Scrypt', 'PoW/PoS', '/coins/bash/overview', 1, 'cryptocompare'),
(878, 33268, 'FAME', 'FameCoin (FAME)', 'FameCoin', 903, 'QuBit', 'PoW/PoS', '/coins/fame/overview', 1, 'cryptocompare'),
(879, 33271, 'LIV', 'LiviaCoin (LIV)', 'LiviaCoin', 904, 'Scrypt', 'PoW/PoS', '/coins/liv/overview', 1, 'cryptocompare'),
(880, 33332, 'SP', 'Sex Pistols (SP)', 'Sex Pistols', 905, 'Scrypt', 'PoW/PoS', '/coins/sp/overview', 1, 'cryptocompare'),
(881, 33393, 'MEGA', 'MegaFlash (MEGA)', 'MegaFlash', 906, 'N/A', 'N/A', '/coins/mega/overview', 1, 'cryptocompare'),
(882, 33399, 'VRS', 'Veros (VRS)', 'Veros', 907, 'N/A', 'N/A', '/coins/vrs/overview', 1, 'cryptocompare'),
(883, 33401, 'ALC', 'Arab League Coin (ALC)', 'Arab League Coin', 908, 'X13', 'PoW', '/coins/alc/overview', 1, 'cryptocompare'),
(884, 33403, 'DOGETH', 'EtherDoge (DOGETH)', 'EtherDoge', 909, 'X11', 'PoW/PoS', '/coins/dogeth/overview', 1, 'cryptocompare'),
(885, 33405, 'KLC', 'KiloCoin (KLC)', 'KiloCoin', 910, 'Scrypt', 'PoW', '/coins/klc/overview', 1, 'cryptocompare'),
(886, 33460, 'HUSH', 'Hush (HUSH)', 'Hush', 911, 'Equihash', 'PoW', '/coins/hush/overview', 1, 'cryptocompare'),
(887, 33522, 'BTLC', 'BitLuckCoin (BTLC)', 'BitLuckCoin', 912, 'PoS', 'PoS', '/coins/btlc/overview', 1, 'cryptocompare'),
(888, 33524, 'DRM8', 'Dream8Coin (DRM8)', 'Dream8Coin', 913, 'Scrypt', 'PoW', '/coins/drm8/overview', 1, 'cryptocompare'),
(889, 33526, 'FIST', 'FistBump (FIST)', 'FistBump', 914, 'X13', 'PoW/PoS', '/coins/fist/overview', 1, 'cryptocompare'),
(890, 33636, 'EBZ', 'Ebitz (EBZ)', 'Ebitz', 915, 'PoS', 'PoS', '/coins/ebz/overview', 1, 'cryptocompare'),
(891, 33645, 'DRS', 'Digital Rupees (DRS)', 'Digital Rupees', 917, 'Scrypt', 'PoS ', '/coins/drs/overview', 1, 'cryptocompare'),
(892, 33866, 'FGZ', 'Free Game Zone (FGZ)', 'Free Game Zone', 918, 'Scrypt', 'PoW', '/coins/fgz/overview', 1, 'cryptocompare'),
(893, 33869, 'BOSON', 'BosonCoin (BOSON)', 'BosonCoin', 919, 'X11', 'PoW/PoS', '/coins/boson/overview', 1, 'cryptocompare'),
(894, 33871, 'ATX', 'ArtexCoin (ATX)', 'ArtexCoin', 920, 'X11', 'PoW', '/coins/atx/overview', 1, 'cryptocompare'),
(895, 33873, 'PNC', 'PlatiniumCoin (PNC)', 'PlatiniumCoin', 921, 'SHA256', 'PoW', '/coins/pnc/overview', 1, 'cryptocompare'),
(896, 33875, 'BRDD', 'BeardDollars (BRDD)', 'BeardDollars', 922, 'Scrypt', 'PoW/PoS', '/coins/brdd/overview', 1, 'cryptocompare'),
(897, 33914, 'TIME', 'Time (TIME)', 'Time', 923, 'N/A', 'N/A', '/coins/time/overview', 1, 'cryptocompare'),
(898, 33936, 'BIP', 'BipCoin (BIP)', 'BipCoin', 924, 'CryptoNight', 'PoW', '/coins/bip/overview', 1, 'cryptocompare'),
(899, 33939, 'XNC', 'XenCoin (XNC)', 'XenCoin', 925, 'Scrypt', 'PoW', '/coins/xnc/overview', 1, 'cryptocompare'),
(900, 33942, 'EMB', 'EmberCoin (EMB)', 'EmberCoin', 926, 'X13', 'PoW/PoS', '/coins/emb/overview', 1, 'cryptocompare'),
(901, 33945, 'BTTF', 'Coin to the Future (BTTF)', 'Coin to the Future', 927, 'PoS', 'PoS', '/coins/bttf/overview', 1, 'cryptocompare'),
(902, 34213, 'DLR', 'DollarOnline (DLR)', 'DollarOnline', 928, 'X11', 'PoW/PoS', '/coins/dlr/overview', 1, 'cryptocompare'),
(903, 34215, 'CSMIC', 'Cosmic (CSMIC)', 'Cosmic', 929, 'SHA256D', 'PoW/PoS', '/coins/csmic/overview', 1, 'cryptocompare'),
(904, 34223, 'FIRST', 'FirstCoin (FIRST)', 'FirstCoin', 930, 'Scrypt', 'PoW/PoS', '/coins/first/overview', 1, 'cryptocompare'),
(905, 34225, 'SCASH', 'SpaceCash (SCASH)', 'SpaceCash', 931, 'X13', 'PoW/PoS', '/coins/scash/overview', 1, 'cryptocompare'),
(906, 34324, 'XEN', 'XenixCoin (XEN)', 'XenixCoin', 932, 'X11', 'PoW/PoS', '/coins/xen/overview', 1, 'cryptocompare'),
(907, 34332, 'JIO', 'JIO Token (JIO)', 'JIO Token', 933, 'N/A', 'N/A', '/coins/jio/overview', 1, 'cryptocompare'),
(908, 34334, 'IW', 'iWallet (IW)', 'iWallet', 934, 'X11', 'PoW/PoS', '/coins/iw/overview', 1, 'cryptocompare'),
(909, 34440, 'JNS', 'Janus (JNS)', 'Janus', 935, 'N/A', 'N/A', '/coins/jns/overview', 1, 'cryptocompare'),
(910, 34483, 'TRICK', 'TrickyCoin (TRICK)', 'TrickyCoin', 936, 'PoS', 'PoS', '/coins/trick/overview', 1, 'cryptocompare'),
(911, 34487, 'DCRE', 'DeltaCredits (DCRE)', 'DeltaCredits', 937, 'N/A', 'PoS', '/coins/dcre/overview', 1, 'cryptocompare'),
(912, 34489, 'FRE', 'FreeCoin (FRE)', 'FreeCoin', 938, 'PoS', 'PoS', '/coins/fre/overview', 1, 'cryptocompare'),
(913, 34491, 'NPC', 'NPCcoin (NPC)', 'NPCcoin', 939, 'SHA256D', 'PoW/PoS', '/coins/npc/overview', 1, 'cryptocompare'),
(914, 34493, 'PLNC', 'PLNCoin (PLNC)', 'PLNCoin', 940, 'Scrypt', 'PoW/PoS', '/coins/plnc/overview', 1, 'cryptocompare'),
(915, 34496, 'DGMS', 'Digigems (DGMS)', 'Digigems', 941, 'Scrypt', 'PoW', '/coins/dgms/overview', 1, 'cryptocompare'),
(916, 34499, 'ICOB', 'Icobid (ICOB)', 'Icobid', 942, 'Scrypt', 'PoW/PoS', '/coins/icob/overview', 1, 'cryptocompare'),
(917, 34506, 'ARCO', 'AquariusCoin (ARCO)', 'AquariusCoin', 943, 'Scrypt', 'PoW/PoS', '/coins/arco/overview', 1, 'cryptocompare'),
(918, 34602, 'KURT', 'Kurrent (KURT)', 'Kurrent', 944, 'X11', 'PoW', '/coins/kurt/overview', 1, 'cryptocompare'),
(919, 34604, 'XCRE', 'Creatio (XCRE)', 'Creatio', 945, 'PoS', 'PoS', '/coins/xcre/overview', 1, 'cryptocompare'),
(920, 34609, 'ENT', 'Eternity (ENT)', 'Eternity', 946, 'X11', 'PoW/PoS', '/coins/ent/overview', 1, 'cryptocompare'),
(921, 34750, 'UR', 'UR (UR)', 'UR', 948, 'Dagger', 'PoW', '/coins/ur/overview', 1, 'cryptocompare'),
(922, 34754, 'MTLM3', 'Metal Music v3 (MTLM3)', 'Metal Music v3', 949, 'Scrypt', 'PoW/PoS', '/coins/mtlm3/overview', 1, 'cryptocompare'),
(923, 34847, 'ODNT', 'Old Dogs New Tricks (ODNT)', 'Old Dogs New Tricks', 950, 'SHA256D', 'PoW/PoS', '/coins/odnt/overview', 1, 'cryptocompare'),
(924, 34849, 'EUC', 'Eurocoin (EUC)', 'Eurocoin', 951, 'SHA256', 'PoW/PoS', '/coins/euc/overview', 1, 'cryptocompare'),
(925, 34851, 'CCX', 'CoolDarkCoin (CCX)', 'CoolDarkCoin', 952, 'Scrypt', 'PoW/PoS', '/coins/ccx/overview', 1, 'cryptocompare'),
(926, 34854, 'BCF', 'BitcoinFast (BCF)', 'BitcoinFast', 953, 'Scrypt', 'PoW/PoS', '/coins/bcf/overview', 1, 'cryptocompare'),
(927, 35027, 'SEEDS', 'SeedShares (SEEDS)', 'SeedShares', 954, 'SHA256D', 'PoW/PoS', '/coins/seeds/overview', 1, 'cryptocompare'),
(928, 35030, 'XSN', 'Stakenet (XSN)', 'Stakenet', 955, 'X11', 'TPoS', '/coins/xsn/overview', 1, 'cryptocompare'),
(929, 35124, 'TKS', 'Tokes (TKS)', 'Tokes', 956, 'N/A', 'N/A', '/coins/tks/overview', 1, 'cryptocompare'),
(930, 35165, 'BCCOIN', 'BitConnect Coin (BCCOIN)', 'BitConnect Coin', 957, 'Scrypt', 'PoW/PoS', '/coins/bccoin/overview', 1, 'cryptocompare'),
(931, 35226, 'SHORTY', 'ShortyCoin (SHORTY)', 'ShortyCoin', 959, 'PoS', 'PoS', '/coins/shorty/overview', 1, 'cryptocompare'),
(932, 35228, 'PCM', 'Procom (PCM)', 'Procom', 960, 'Scrypt', 'PoW', '/coins/pcm/overview', 1, 'cryptocompare'),
(933, 35230, 'KC', 'Kernalcoin (KC)', 'Kernalcoin', 961, 'SHA256', 'PoW', '/coins/kc/overview', 1, 'cryptocompare'),
(934, 35232, 'CORAL', 'CoralPay (CORAL)', 'CoralPay', 962, 'X13', 'PoS', '/coins/coral/overview', 1, 'cryptocompare'),
(935, 35407, 'BamitCoi', 'BAM (BAM)', 'BAM', 963, 'X11', 'PoW/PoS', '/coins/bam/overview', 1, 'cryptocompare'),
(936, 35678, 'NXC', 'Nexium (NXC)', 'Nexium', 964, 'N/A', 'N/A', '/coins/nxc/overview', 1, 'cryptocompare'),
(937, 35681, 'MONEY', 'MoneyCoin (MONEY)', 'MoneyCoin', 965, 'Scrypt', 'PoW/PoS', '/coins/money/overview', 1, 'cryptocompare'),
(938, 35684, 'BSTAR', 'Blackstar (BSTAR)', 'Blackstar', 966, 'X11', 'PoS', '/coins/bstar/overview', 1, 'cryptocompare'),
(939, 35687, 'HSP', 'Horse Power (HSP)', 'Horse Power', 967, 'Scrypt', 'PoW', '/coins/hsp/overview', 1, 'cryptocompare'),
(940, 35811, 'HZT', 'HazMatCoin (HZT)', 'HazMatCoin', 968, 'Scrypt', 'PoW/PoS', '/coins/hzt/overview', 1, 'cryptocompare'),
(941, 35813, 'CS', 'CryptoSpots (CS)', 'CryptoSpots', 969, 'DPoS', 'DPoS', '/coins/cs/overview', 1, 'cryptocompare'),
(942, 35816, 'XSP', 'PoolStamp (XSP)', 'PoolStamp', 970, 'X13', 'PoW/PoS', '/coins/xsp/overview', 1, 'cryptocompare'),
(943, 35818, 'CCRB', 'CryptoCarbon (CCRB)', 'CryptoCarbon', 971, 'N/A', 'N/A', '/coins/ccrb/overview', 1, 'cryptocompare'),
(944, 35821, 'BULLS', 'BullshitCoin (BULLS)', 'BullshitCoin', 972, 'Scrypt', 'PoW/PoS', '/coins/bulls/overview', 1, 'cryptocompare'),
(945, 35823, 'INCNT', 'Incent (INCNT)', 'Incent', 973, 'N/A', 'N/A', '/coins/incnt/overview', 1, 'cryptocompare'),
(946, 35825, 'ICON', 'Iconic (ICON)', 'Iconic', 974, 'PoS', 'PoS', '/coins/icon/overview', 1, 'cryptocompare'),
(947, 35947, 'NIC', 'NewInvestCoin (NIC)', 'NewInvestCoin', 975, 'PoS', 'PoS', '/coins/nic/overview', 1, 'cryptocompare'),
(948, 35949, 'ACN', 'AvonCoin (ACN)', 'AvonCoin', 976, 'PoS', 'PoS', '/coins/acn/overview', 1, 'cryptocompare'),
(949, 35953, 'XNG', 'Enigma (XNG)', 'Enigma', 977, 'X11', 'PoW/PoS', '/coins/xng/overview', 1, 'cryptocompare'),
(950, 35955, 'XCI', 'Cannabis Industry Coin (XCI)', 'Cannabis Industry Coin', 978, 'CryptoNight', 'PoW', '/coins/xci/overview', 1, 'cryptocompare'),
(951, 36984, 'LOOK', 'LookCoin (LOOK)', 'LookCoin', 979, 'X11', 'PoW/PoS', '/coins/look/overview', 1, 'cryptocompare'),
(952, 36988, 'LOC', 'Loco (LOC)', 'Loco', 980, 'Quark', 'PoW/PoS', '/coins/loc/overview', 1, 'cryptocompare'),
(953, 36992, 'MMXVI', 'MMXVI (MMXVI)', 'MMXVI', 981, 'N/A', 'PoW', '/coins/mmxvi/overview', 1, 'cryptocompare'),
(954, 37040, 'TRST', 'TrustCoin (TRST)', 'TrustCoin', 983, 'N/A', 'N/A', '/coins/trst/overview', 1, 'cryptocompare'),
(955, 37190, 'MIS', 'MIScoin (MIS)', 'MIScoin', 984, 'X11', 'PoW/PoS', '/coins/mis/overview', 1, 'cryptocompare'),
(956, 37191, 'WOP', 'WorldPay (WOP)', 'WorldPay', 985, 'X11', 'PoW/PoS', '/coins/wop/overview', 1, 'cryptocompare'),
(957, 37195, 'CQST', 'ConquestCoin (CQST)', 'ConquestCoin', 986, 'X13', 'PoW/PoS', '/coins/cqst/overview', 1, 'cryptocompare'),
(958, 37204, 'IMPS', 'Impulse Coin (IMPS)', 'Impulse Coin', 987, 'X13', 'PoW/PoS', '/coins/imps/overview', 1, 'cryptocompare'),
(959, 37210, 'IN', 'InCoin (IN)', 'InCoin', 988, 'X11', 'PoW/PoS', '/coins/in/overview', 1, 'cryptocompare'),
(960, 37214, 'CHIEF', 'TheChiefCoin (CHIEF)', 'TheChiefCoin', 989, 'Scrypt', 'PoW/PoS', '/coins/chief/overview', 1, 'cryptocompare'),
(961, 37356, 'GOAT', 'Goat (GOAT)', 'Goat', 990, 'Scrypt', 'PoW/PoS', '/coins/goat/overview', 1, 'cryptocompare'),
(962, 37359, 'ANAL', 'AnalCoin (ANAL)', 'AnalCoin', 991, 'SHA256', 'N/A', '/coins/anal/overview', 1, 'cryptocompare'),
(963, 37361, 'RC', 'Russiacoin (RC)', 'Russiacoin', 992, 'Scrypt', 'PoW/PoS', '/coins/rc/overview', 1, 'cryptocompare'),
(964, 37366, 'PND', 'PandaCoin (PND)', 'PandaCoin', 993, 'Scrypt', 'PoS', '/coins/pnd/overview', 1, 'cryptocompare'),
(965, 37370, 'PX', 'PXcoin (PX)', 'PXcoin', 994, 'SHA256', 'PoW/PoS', '/coins/px/overview', 1, 'cryptocompare'),
(966, 37746, 'CND*', 'Canada eCoin (CND*)', 'Canada eCoin', 995, 'Scrypt', 'PoW', '/coins/cndstar/overview', 1, 'cryptocompare'),
(967, 37749, 'OPTION', 'OptionCoin (OPTION)', 'OptionCoin', 996, 'X11', 'PoS', '/coins/option/overview', 1, 'cryptocompare'),
(968, 38026, 'AV', 'Avatar Coin (AV)', 'Avatar Coin', 997, 'PoS', 'PoS', '/coins/av/overview', 1, 'cryptocompare'),
(969, 38030, 'LTD', 'Limited Coin (LTD)', 'Limited Coin', 998, 'PoS', 'PoS', '/coins/ltd/overview', 1, 'cryptocompare'),
(970, 38032, 'UNITS', 'GameUnits (UNITS)', 'GameUnits', 999, 'Scrypt', 'PoW/PoS', '/coins/units/overview', 1, 'cryptocompare'),
(971, 38035, 'HEEL', 'HeelCoin (HEEL)', 'HeelCoin', 1000, 'PoS', 'PoS', '/coins/heel/overview', 1, 'cryptocompare'),
(972, 38277, 'GAKH', 'GAKHcoin (GAKH)', 'GAKHcoin', 1001, 'Scrypt', 'PoW/PoS', '/coins/gakh/overview', 1, 'cryptocompare'),
(973, 38307, 'SHIFT', 'Shift (SHIFT)', 'Shift', 1003, 'DPoS', 'DPoS', '/coins/shift/overview', 1, 'cryptocompare'),
(974, 38310, 'S8C', 'S88 Coin (S8C)', 'S88 Coin', 1004, 'Scrypt', 'PoW/PoS', '/coins/s8c/overview', 1, 'cryptocompare'),
(975, 38312, 'LVG', 'Leverage Coin (LVG)', 'Leverage Coin', 1005, 'N/A', 'N/A', '/coins/lvg/overview', 1, 'cryptocompare'),
(976, 38360, 'DRA', 'DraculaCoin (DRA)', 'DraculaCoin', 1006, 'Scrypt', 'PoW', '/coins/dra/overview', 1, 'cryptocompare'),
(977, 38367, 'ASAFE2', 'Allsafe (ASAFE2)', 'Allsafe', 1007, 'Scrypt', 'PoS', '/coins/asafe2/overview', 1, 'cryptocompare'),
(978, 38370, 'LTCR', 'LiteCreed (LTCR)', 'LiteCreed', 1008, 'QuBit', 'PoW/PoS', '/coins/ltcr/overview', 1, 'cryptocompare'),
(979, 38371, 'QBC', 'Quebecoin (QBC)', 'Quebecoin', 1009, 'X11', 'N/A', '/coins/qbc/overview', 1, 'cryptocompare'),
(980, 38380, 'XPRO', 'ProCoin (XPRO)', 'ProCoin', 1010, 'X15', 'PoW/PoS', '/coins/xpro/overview', 1, 'cryptocompare'),
(981, 38959, 'AST*', 'Astral (AST*)', 'Astral', 1011, 'X13', 'PoW/PoS', '/coins/aststar/overview', 1, 'cryptocompare'),
(982, 38962, 'GIFT', 'GiftNet (GIFT)', 'GiftNet', 1012, 'X13', 'PoW', '/coins/gift/overview', 1, 'cryptocompare'),
(983, 38964, 'VIDZ', 'PureVidz (VIDZ)', 'PureVidz', 1013, 'PoS', 'PoS', '/coins/vidz/overview', 1, 'cryptocompare'),
(984, 38967, 'INC', 'Incrementum (INC)', 'Incrementum', 1014, 'PoS', 'PoS', '/coins/inc/overview', 1, 'cryptocompare'),
(985, 39698, 'PTA', 'PentaCoin (PTA)', 'PentaCoin', 1015, 'SHA256', 'PoW/PoS', '/coins/pta/overview', 1, 'cryptocompare'),
(986, 39700, 'ACID', 'AcidCoin (ACID)', 'AcidCoin', 1016, 'SHA256', 'PoW', '/coins/acid/overview', 1, 'cryptocompare'),
(987, 39704, 'ZLQ', 'ZLiteQubit (ZLQ)', 'ZLiteQubit', 1017, 'QuBit', 'N/A', '/coins/zlq/overview', 1, 'cryptocompare'),
(988, 39707, 'RADI', 'RadicalCoin (RADI)', 'RadicalCoin', 1018, 'X13', 'PoS', '/coins/radi/overview', 1, 'cryptocompare'),
(989, 39710, 'RNC', 'ReturnCoin (RNC)', 'ReturnCoin', 1019, 'X11', 'PoS', '/coins/rnc/overview', 1, 'cryptocompare'),
(990, 40806, 'GOLOS', 'Golos (GOLOS)', 'Golos', 1020, 'N/A', 'PoW', '/coins/golos/overview', 1, 'cryptocompare'),
(991, 40811, 'PASC', 'Pascal Coin (PASC)', 'Pascal Coin', 1021, 'N/A', 'N/A', '/coins/pasc/overview', 1, 'cryptocompare'),
(992, 40839, 'TWIST', 'TwisterCoin (TWIST)', 'TwisterCoin', 1022, 'X11', 'PoW/PoS', '/coins/twist/overview', 1, 'cryptocompare'),
(993, 40842, 'PAYP', 'PayPeer (PAYP)', 'PayPeer', 1023, 'X11', 'PoW/PoS', '/coins/payp/overview', 1, 'cryptocompare'),
(994, 40845, 'DETH', 'DarkEther (DETH)', 'DarkEther', 1024, 'X11', 'N/A', '/coins/deth/overview', 1, 'cryptocompare'),
(995, 40847, 'YAY', 'YAYcoin (YAY)', 'YAYcoin', 1025, 'Scrypt', 'PoW/PoS', '/coins/yay/overview', 1, 'cryptocompare'),
(996, 40990, 'YES', 'YesCoin (YES)', 'YesCoin', 1027, 'Scrypt', 'PoW/PoS', '/coins/yes/overview', 1, 'cryptocompare'),
(997, 40992, 'LENIN', 'LeninCoin (LENIN)', 'LeninCoin', 1028, 'SHA256D', 'PoW', '/coins/lenin/overview', 1, 'cryptocompare'),
(998, 41116, 'MRSA', 'MrsaCoin (MRSA)', 'MrsaCoin', 1029, 'X13', 'PoW/PoS', '/coins/mrsa/overview', 1, 'cryptocompare'),
(999, 41122, 'OS76', 'OsmiumCoin (OS76)', 'OsmiumCoin', 1030, 'Scrypt', 'PoW', '/coins/os76/overview', 1, 'cryptocompare'),
(1000, 41125, 'BOSS', 'BitBoss (BOSS)', 'BitBoss', 1031, 'SHA256', 'PoW/PoS', '/coins/boss/overview', 1, 'cryptocompare'),
(1001, 41192, 'MKR', 'Maker (MKR)', 'Maker', 1032, 'N/A', 'N/A', '/coins/mkr/overview', 1, 'cryptocompare'),
(1002, 41587, 'BIC', 'Bikercoins (BIC)', 'Bikercoins', 1033, 'CryptoNight', 'PoW', '/coins/bic/overview', 1, 'cryptocompare'),
(1003, 41590, 'CRPS', 'CryptoPennies (CRPS)', 'CryptoPennies', 1034, 'X11', 'PoS', '/coins/crps/overview', 1, 'cryptocompare'),
(1004, 41592, 'MOTO', 'Motocoin (MOTO)', 'Motocoin', 1035, 'N/A', 'PoP', '/coins/moto/overview', 1, 'cryptocompare'),
(1005, 41819, 'NTCC', 'NeptuneClassic (NTCC)', 'NeptuneClassic', 1036, 'X11', 'PoW/PoS', '/coins/ntcc/overview', 1, 'cryptocompare'),
(1006, 41866, 'XNC*', 'Numismatic Collections (XNC*)', 'Numismatic Collections', 1037, 'X13', 'PoW/PoS', '/coins/xncstar/overview', 1, 'cryptocompare'),
(1007, 41868, 'HXX', 'HexxCoin (HXX)', 'HexxCoin', 1038, 'Lyra2RE', 'PoW', '/coins/hxx/overview', 1, 'cryptocompare'),
(1008, 41871, 'SPKTR', 'Ghost Coin (SPKTR)', 'Ghost Coin', 1039, 'SHA256', 'PoW/PoS', '/coins/spktr/overview', 1, 'cryptocompare'),
(1009, 41962, 'MAC', 'MachineCoin (MAC)', 'MachineCoin', 1040, 'Time Travel', 'PoW', '/coins/mac/overview', 1, 'cryptocompare'),
(1010, 41967, 'SEL', 'SelenCoin (SEL)', 'SelenCoin', 1041, 'PoS', 'PoS', '/coins/sel/overview', 1, 'cryptocompare'),
(1011, 41971, 'NOO', 'Noocoin (NOO)', 'Noocoin', 1042, 'PoS', 'PoS', '/coins/noo/overview', 1, 'cryptocompare'),
(1012, 41974, 'CHAO', '23 Skidoo (CHAO)', '23 Skidoo', 1043, 'SHA256D', 'PoW', '/coins/chao/overview', 1, 'cryptocompare'),
(1013, 41989, 'XGB', 'GoldenBird (XGB)', 'GoldenBird', 1044, 'X13', 'PoW/PoS', '/coins/xgb/overview', 1, 'cryptocompare'),
(1014, 42099, 'YMC', 'YamahaCoin (YMC)', 'YamahaCoin', 1045, 'Scrypt', 'PoW', '/coins/ymc/overview', 1, 'cryptocompare'),
(1015, 42101, 'JOK', 'JokerCoin (JOK)', 'JokerCoin', 1046, 'Scrypt', 'PoW/PoS', '/coins/jok/overview', 1, 'cryptocompare'),
(1016, 42103, 'GBIT', 'GravityBit (GBIT)', 'GravityBit', 1047, 'Scrypt', 'PoW/PoS', '/coins/gbit/overview', 1, 'cryptocompare'),
(1017, 42106, 'TEC', 'TeCoin (TEC)', 'TeCoin', 1048, 'Multiple', 'PoW', '/coins/tec/overview', 1, 'cryptocompare'),
(1018, 42110, 'BOMB', 'BombCoin (BOMB)', 'BombCoin', 1049, 'Scrypt', 'PoW/PoS', '/coins/bomb/overview', 1, 'cryptocompare'),
(1019, 42344, 'RIDE', 'Ride My Car (RIDE)', 'Ride My Car', 1050, 'PoS', 'PoS', '/coins/ride/overview', 1, 'cryptocompare'),
(1020, 42433, 'PIVX', 'Private Instant Verified Transaction (PIVX)', 'Private Instant Verified Transaction', 1051, 'Quark', 'PoW/PoS', '/coins/pivx/overview', 1, 'cryptocompare'),
(1021, 42435, 'KED', 'Klingon Empire Darsek (KED)', 'Klingon Empire Darsek', 1052, 'Scrypt', 'PoW/PoS', '/coins/ked/overview', 1, 'cryptocompare'),
(1022, 42438, 'CNO', 'Coino (CNO)', 'Coino', 1053, 'Scrypt', 'PoW', '/coins/cno/overview', 1, 'cryptocompare'),
(1023, 42440, 'WEALTH', 'WealthCoin (WEALTH)', 'WealthCoin', 1054, 'DPoS', 'PoS', '/coins/wealth/overview', 1, 'cryptocompare'),
(1024, 42596, 'IOP', 'Internet of People (IOP)', 'Internet of People', 1055, 'SHA256', 'PoW/PoS', '/coins/iop/overview', 1, 'cryptocompare'),
(1025, 42598, 'XSPEC', 'Spectre (XSPEC)', 'Spectre', 1056, 'POS 3.0', 'PoS', '/coins/xspec/overview', 1, 'cryptocompare'),
(1026, 42663, 'PEPECASH', 'Pepe Cash (PEPECASH)', 'Pepe Cash', 1057, 'N/A', 'N/A', '/coins/pepecash/overview', 1, 'cryptocompare'),
(1027, 42680, 'CLICK', 'Clickcoin (CLICK)', 'Clickcoin', 1058, 'PoS', 'PoS', '/coins/click/overview', 1, 'cryptocompare'),
(1028, 42685, 'ELS', 'Elysium (ELS)', 'Elysium', 1059, 'Scrypt', 'PoW', '/coins/els/overview', 1, 'cryptocompare'),
(1029, 42687, 'KUSH', 'KushCoin (KUSH)', 'KushCoin', 1060, 'X11', 'PoW/PoS', '/coins/kush/overview', 1, 'cryptocompare'),
(1030, 42694, 'ERY', 'Eryllium (ERY)', 'Eryllium', 1061, 'X11', 'PoW/PoS', '/coins/ery/overview', 1, 'cryptocompare'),
(1031, 42837, 'PLU', 'Pluton (PLU)', 'Pluton', 1062, 'N/A', 'N/A', '/coins/plu/overview', 1, 'cryptocompare'),
(1032, 42841, 'PRES', 'President Trump (PRES)', 'President Trump', 1063, 'N/A', 'N/A', '/coins/pres/overview', 1, 'cryptocompare'),
(1033, 42843, 'BTZ', 'BitzCoin (BTZ)', 'BitzCoin', 1064, 'X11', 'PoW/PoS', '/coins/btz/overview', 1, 'cryptocompare'),
(1034, 42850, 'OPES', 'Opes (OPES)', 'Opes', 1065, 'Argon2', 'PoW', '/coins/opes/overview', 1, 'cryptocompare'),
(1035, 43042, 'WCT', 'Waves Community Token (WCT)', 'Waves Community Token', 1066, 'N/A', 'N/A', '/coins/wct/overview', 1, 'cryptocompare'),
(1036, 43044, 'UBQ', 'Ubiq (UBQ)', 'Ubiq', 1067, 'Dagger-Hashi', 'PoW', '/coins/ubq/overview', 1, 'cryptocompare'),
(1037, 43046, 'RATIO', 'Ratio (RATIO)', 'Ratio', 1068, 'PoS', 'PoS', '/coins/ratio/overview', 1, 'cryptocompare'),
(1038, 43247, 'BAN', 'Babes and Nerds (BAN)', 'Babes and Nerds', 1069, 'PoS', 'N/A', '/coins/ban/overview', 1, 'cryptocompare'),
(1039, 43253, 'NICE', 'NiceCoin (NICE)', 'NiceCoin', 1070, 'Scrypt', 'PoW', '/coins/nice/overview', 1, 'cryptocompare'),
(1040, 43257, 'SMF', 'SmurfCoin (SMF)', 'SmurfCoin', 1071, 'Scrypt', 'PoW/PoS', '/coins/smf/overview', 1, 'cryptocompare'),
(1041, 43265, 'CWXT', 'CryptoWorldXToken (CWXT)', 'CryptoWorldXToken', 1072, 'N/A', 'PoW/PoS', '/coins/cwxt/overview', 1, 'cryptocompare'),
(1042, 43595, 'TECH', 'TechCoin (TECH)', 'TechCoin', 1073, 'X13', 'PoW/PoS', '/coins/tech/overview', 1, 'cryptocompare'),
(1043, 43598, 'CIR', 'CircuitCoin (CIR)', 'CircuitCoin', 1074, 'SHA256D', 'PoW/PoS', '/coins/cir/overview', 1, 'cryptocompare'),
(1044, 43602, 'LEPEN', 'LePenCoin (LEPEN)', 'LePenCoin', 1075, 'SHA256', 'PoS', '/coins/lepen/overview', 1, 'cryptocompare'),
(1045, 43604, 'ROUND', 'RoundCoin (ROUND)', 'RoundCoin', 1076, 'N/A', 'N/A', '/coins/round/overview', 1, 'cryptocompare'),
(1046, 43814, 'MAR', 'MarijuanaCoin (MAR)', 'MarijuanaCoin', 1077, 'X11', 'PoW/PoS', '/coins/mar/overview', 1, 'cryptocompare'),
(1047, 43818, 'MARX', 'MarxCoin (MARX)', 'MarxCoin', 1078, 'X11', 'PoW', '/coins/marx/overview', 1, 'cryptocompare'),
(1048, 43933, 'TAT', 'Tatiana Coin (TAT)', 'Tatiana Coin', 1079, 'N/A', 'N/A', '/coins/tat/overview', 1, 'cryptocompare'),
(1049, 43937, 'HAZE', 'HazeCoin (HAZE)', 'HazeCoin', 1080, 'Scrypt', 'PoW', '/coins/haze/overview', 1, 'cryptocompare'),
(1050, 43998, 'PRX', 'Printerium (PRX)', 'Printerium', 1081, 'Scrypt', 'PoW/PoS', '/coins/prx/overview', 1, 'cryptocompare'),
(1051, 44001, 'NRC', 'Neurocoin (NRC)', 'Neurocoin', 1082, 'PoS', 'PoS', '/coins/nrc/overview', 1, 'cryptocompare'),
(1052, 44003, 'PAC', 'PacCoin (PAC)', 'PacCoin', 1083, 'X11', 'PoW', '/coins/pac/overview', 1, 'cryptocompare'),
(1053, 44007, 'IMPCH', 'Impeach (IMPCH)', 'Impeach', 1084, 'Scrypt', 'PoW/PoS', '/coins/impch/overview', 1, 'cryptocompare'),
(1054, 44749, 'ERR', 'ErrorCoin (ERR)', 'ErrorCoin', 1085, 'Scrypt', 'PoW', '/coins/err/overview', 1, 'cryptocompare'),
(1055, 44752, 'TIC', 'TrueInvestmentCoin (TIC)', 'TrueInvestmentCoin', 1086, 'Scrypt', 'PoW/PoS', '/coins/tic/overview', 1, 'cryptocompare'),
(1056, 44799, 'NUKE', 'NukeCoin (NUKE)', 'NukeCoin', 1087, 'PoS', 'PoS', '/coins/nuke/overview', 1, 'cryptocompare'),
(1057, 44803, 'EOC', 'EveryonesCoin (EOC)', 'EveryonesCoin', 1088, 'Scrypt', 'PoW/PoS', '/coins/eoc/overview', 1, 'cryptocompare'),
(1058, 44952, 'SFC', 'Solarflarecoin (SFC)', 'Solarflarecoin', 1089, 'Scrypt', 'PoW', '/coins/sfc/overview', 1, 'cryptocompare'),
(1059, 44955, 'JANE', 'JaneCoin (JANE)', 'JaneCoin', 1090, 'X11', 'PoW/PoS', '/coins/jane/overview', 1, 'cryptocompare'),
(1060, 44957, 'PARA', 'ParanoiaCoin (PARA)', 'ParanoiaCoin', 1091, 'Scrypt', 'PoW', '/coins/para/overview', 1, 'cryptocompare'),
(1061, 44959, 'MM', 'MasterMint (MM)', 'MasterMint', 1092, 'X11', 'PoS', '/coins/mm/overview', 1, 'cryptocompare'),
(1062, 45031, 'CTL', 'Citadel (CTL)', 'Citadel', 1093, 'CryptoNight-', 'PoW', '/coins/ctl/overview', 1, 'cryptocompare'),
(1063, 45044, 'NDOGE', 'NinjaDoge (NDOGE)', 'NinjaDoge', 1094, 'X11', 'PoW/PoS', '/coins/ndoge/overview', 1, 'cryptocompare'),
(1064, 45250, 'ZBC', 'Zilbercoin (ZBC)', 'Zilbercoin', 1095, 'Scrypt', 'PoS', '/coins/zbc/overview', 1, 'cryptocompare'),
(1065, 45253, 'MLN', 'Melon (MLN)', 'Melon', 1096, 'N/A', 'N/A', '/coins/mln/overview', 1, 'cryptocompare'),
(1066, 45258, 'FRST', 'FirstCoin (FRST)', 'FirstCoin', 1097, 'Scrypt', 'PoW/PoS ', '/coins/frst/overview', 1, 'cryptocompare'),
(1067, 45260, 'PAY', 'TenX (PAY)', 'TenX', 1098, 'N/A', 'N/A', '/coins/pay/overview', 1, 'cryptocompare'),
(1068, 45262, 'ORO', 'OroCoin (ORO)', 'OroCoin', 1099, 'Scrypt', 'PoW', '/coins/oro/overview', 1, 'cryptocompare'),
(1069, 45607, 'ALEX', 'Alexandrite (ALEX)', 'Alexandrite', 1100, 'SHA256', 'PoW/PoS', '/coins/alex/overview', 1, 'cryptocompare'),
(1070, 45609, 'TBCX', 'TrashBurn (TBCX)', 'TrashBurn', 1101, 'SHA256D', 'PoS', '/coins/tbcx/overview', 1, 'cryptocompare'),
(1071, 45612, 'MCAR', 'MasterCar (MCAR)', 'MasterCar', 1102, 'Scrypt', 'PoW/PoS', '/coins/mcar/overview', 1, 'cryptocompare'),
(1072, 45615, 'THS', 'TechShares (THS)', 'TechShares', 1103, 'DPoS', 'DPoS', '/coins/ths/overview', 1, 'cryptocompare'),
(1073, 45617, 'ACES', 'AcesCoin (ACES)', 'AcesCoin', 1104, 'X13', 'PoS', '/coins/aces/overview', 1, 'cryptocompare'),
(1074, 45816, 'UAEC', 'United Arab Emirates Coin (UAEC)', 'United Arab Emirates Coin', 1105, 'X11', 'PoW/PoS', '/coins/uaec/overview', 1, 'cryptocompare'),
(1075, 45821, 'EA', 'EagleCoin (EA)', 'EagleCoin', 1106, 'SHA256', 'PoW', '/coins/ea/overview', 1, 'cryptocompare'),
(1076, 45832, 'PIE', 'Persistent Information Exchange (PIE)', 'Persistent Information Exchange', 1107, 'PoS', 'PoS', '/coins/pie/overview', 1, 'cryptocompare'),
(1077, 48787, 'CREA', 'CreativeChain (CREA)', 'CreativeChain', 1109, 'Keccak', 'PoW', '/coins/crea/overview', 1, 'cryptocompare'),
(1078, 48794, 'WISC', 'WisdomCoin (WISC)', 'WisdomCoin', 1110, 'Scrypt', 'PoW/PoS', '/coins/wisc/overview', 1, 'cryptocompare'),
(1079, 48800, 'BVC', 'BeaverCoin (BVC)', 'BeaverCoin', 1111, 'Scrypt', 'PoW', '/coins/bvc/overview', 1, 'cryptocompare'),
(1080, 48807, 'FIND', 'FindCoin (FIND)', 'FindCoin', 1112, 'X13', 'PoS', '/coins/find/overview', 1, 'cryptocompare'),
(1081, 49600, 'MLITE', 'MeLite (MLITE)', 'MeLite', 1113, 'SHA256D', 'PoW/PoS', '/coins/mlite/overview', 1, 'cryptocompare'),
(1082, 49605, 'STALIN', 'StalinCoin (STALIN)', 'StalinCoin', 1114, 'X11', 'PoW/PoS', '/coins/stalin/overview', 1, 'cryptocompare'),
(1083, 49610, 'TSE', 'TattooCoin (TSE)', 'TattooCoin', 1115, 'Scrypt', 'PoW/PoS', '/coins/tse/overview', 1, 'cryptocompare'),
(1084, 50730, 'VLTC', 'VaultCoin (VLTC)', 'VaultCoin', 1116, 'X11', 'PoW', '/coins/vltc/overview', 1, 'cryptocompare'),
(1085, 50734, 'BIOB', 'BioBar (BIOB)', 'BioBar', 1117, 'SHA256D', 'PoW/PoS', '/coins/biob/overview', 1, 'cryptocompare'),
(1086, 50741, 'SWT', 'Swarm City Token (SWT)', 'Swarm City Token', 1118, 'N/A', 'N/A', '/coins/swt/overview', 1, 'cryptocompare'),
(1087, 50754, 'PASL', 'Pascal Lite (PASL)', 'Pascal Lite', 1119, 'SHA256', 'PoW/PoS', '/coins/pasl/overview', 1, 'cryptocompare'),
(1088, 51845, 'ZER', 'Zero (ZER)', 'Zero', 1122, 'Equihash', 'PoW', '/coins/zer/overview', 1, 'cryptocompare'),
(1089, 52008, 'CHAT', 'OpenChat (CHAT)', 'OpenChat', 1123, 'Scrypt', 'PoW/PoS', '/coins/chat/overview', 1, 'cryptocompare'),
(1090, 52015, 'CDN', 'Canada eCoin (CDN)', 'Canada eCoin', 1124, 'Scrypt', 'PoW', '/coins/cdn/overview', 1, 'cryptocompare'),
(1091, 53174, 'NETKO', 'Netko (NETKO)', 'Netko', 1126, 'Blake', 'N/A', '/coins/netko/overview', 1, 'cryptocompare'),
(1092, 53178, 'ZOI', 'Zoin (ZOI)', 'Zoin', 1127, 'Lyra2RE', 'PoW', '/coins/zoi/overview', 1, 'cryptocompare'),
(1093, 53915, 'HONEY', 'Honey (HONEY)', 'Honey', 1128, 'Blake2S', 'PoW/PoS', '/coins/honey/overview', 1, 'cryptocompare'),
(1094, 53944, 'MXT', 'MartexCoin (MXT)', 'MartexCoin', 1129, 'X13', ' PoW/PoS', '/coins/mxt/overview', 1, 'cryptocompare'),
(1095, 53950, 'MUSIC', 'Musicoin (MUSIC)', 'Musicoin', 1130, 'Ethash', 'PoW', '/coins/music/overview', 1, 'cryptocompare'),
(1096, 55540, 'DTB', 'Databits (DTB)', 'Databits', 1131, 'N/A', 'N/A', '/coins/dtb/overview', 1, 'cryptocompare'),
(1097, 55544, 'VEG', 'BitVegan (VEG)', 'BitVegan', 1132, 'PoS', 'PoS', '/coins/veg/overview', 1, 'cryptocompare'),
(1098, 55547, 'MBIT', 'Mbitbooks (MBIT)', 'Mbitbooks', 1133, 'Scrypt', 'PoW', '/coins/mbit/overview', 1, 'cryptocompare'),
(1099, 55553, 'VOLT', 'BitVolt (VOLT)', 'BitVolt', 1134, 'PoS', 'PoS', '/coins/volt/overview', 1, 'cryptocompare'),
(1100, 55676, 'EDG', 'Edgeless (EDG)', 'Edgeless', 1136, 'N/A', 'N/A', '/coins/edg/overview', 1, 'cryptocompare'),
(1101, 56078, 'B@', 'BankCoin (B@)', 'BankCoin', 1137, 'N/A', 'N/A', '/coins/b/overview', 1, 'cryptocompare'),
(1102, 56246, 'BEST', 'BestChain (BEST)', 'BestChain', 1138, 'Scrypt', 'PoW/PoS ', '/coins/best/overview', 1, 'cryptocompare'),
(1103, 56249, 'CHC', 'ChainCoin (CHC)', 'ChainCoin', 1139, 'N/A', 'N/A', '/coins/chc/overview', 1, 'cryptocompare'),
(1104, 56253, 'ZENI', 'Zennies (ZENI)', 'Zennies', 1140, 'Scrypt', 'PoS', '/coins/zeni/overview', 1, 'cryptocompare'),
(1105, 56654, 'PLANET', 'PlanetCoin (PLANET)', 'PlanetCoin', 1141, 'Scrypt', 'PoW/PoS', '/coins/planet/overview', 1, 'cryptocompare'),
(1106, 56678, 'DUCK', 'DuckDuckCoin (DUCK)', 'DuckDuckCoin', 1142, 'Scrypt', 'PoW', '/coins/duck/overview', 1, 'cryptocompare'),
(1107, 56682, 'BNX', 'BnrtxCoin (BNX)', 'BnrtxCoin', 1143, 'X11', 'PoW', '/coins/bnx/overview', 1, 'cryptocompare'),
(1108, 57466, 'BSTK', 'BattleStake (BSTK)', 'BattleStake', 1144, 'PoS', 'PoS', '/coins/bstk/overview', 1, 'cryptocompare'),
(1109, 57471, 'RNS', 'RenosCoin (RNS)', 'RenosCoin', 1145, 'Scrypt', 'PoS', '/coins/rns/overview', 1, 'cryptocompare'),
(1110, 57481, 'DBIX', 'DubaiCoin (DBIX)', 'DubaiCoin', 1146, 'Dagger-Hashi', 'PoW', '/coins/dbix/overview', 1, 'cryptocompare'),
(1111, 57676, 'AMIS', 'AMIS (AMIS)', 'AMIS', 1147, 'N/A', 'N/A', '/coins/amis/overview', 1, 'cryptocompare'),
(1112, 57705, 'KAYI', 'Kayı (KAYI)', 'Kayı', 1148, 'N/A', 'N/A', '/coins/kayi/overview', 1, 'cryptocompare'),
(1113, 57734, 'XVP', 'VirtacoinPlus (XVP)', 'VirtacoinPlus', 1149, 'X11', 'PoW/PoS', '/coins/xvp/overview', 1, 'cryptocompare'),
(1114, 57742, 'BOAT', 'Doubloon (BOAT)', 'Doubloon', 1150, '536', 'PoW/PoS', '/coins/boat/overview', 1, 'cryptocompare'),
(1115, 57750, 'TAJ', 'TajCoin (TAJ)', 'TajCoin', 1151, 'Blake2S', 'PoW/PoS', '/coins/taj/overview', 1, 'cryptocompare'),
(1116, 58121, 'IMX', 'Impact (IMX)', 'Impact', 1152, 'X11', 'PoW/PoS', '/coins/imx/overview', 1, 'cryptocompare'),
(1117, 58125, 'CJC', 'CryptoJournal (CJC)', 'CryptoJournal', 1153, 'PoS', 'PoS', '/coins/cjc/overview', 1, 'cryptocompare'),
(1118, 59304, 'AMY', 'Amygws (AMY)', 'Amygws', 1154, 'Scrypt', 'PoW', '/coins/amy/overview', 1, 'cryptocompare'),
(1119, 59317, 'QBT', 'Cubits (QBT)', 'Cubits', 1155, 'SHA256', 'PoW/PoS', '/coins/qbt/overview', 1, 'cryptocompare'),
(1120, 59966, 'SRC*', 'StarCredits (SRC*)', 'StarCredits', 1156, 'N/A', 'N/A', '/coins/srcstar/overview', 1, 'cryptocompare'),
(1121, 59968, 'EB3', 'EB3coin (EB3)', 'EB3coin', 1157, 'Scrypt', 'PoW', '/coins/eb3/overview', 1, 'cryptocompare'),
(1122, 59973, 'XVE', 'The Vegan Initiative (XVE)', 'The Vegan Initiative', 1158, 'PoS', 'PoS', '/coins/xve/overview', 1, 'cryptocompare'),
(1123, 60409, 'FAZZ', 'FazzCoin (FAZZ)', 'FazzCoin', 1159, 'PoS', 'PoS', '/coins/fazz/overview', 1, 'cryptocompare'),
(1124, 60419, 'APT', 'Aptcoin (APT)', 'Aptcoin', 1160, 'Scrypt-n', 'PoW', '/coins/apt/overview', 1, 'cryptocompare'),
(1125, 60424, 'BLAZR', 'BlazerCoin (BLAZR)', 'BlazerCoin', 1161, 'Scrypt', 'PoW', '/coins/blazr/overview', 1, 'cryptocompare'),
(1126, 60618, 'ARPA', 'ArpaCoin (ARPA)', 'ArpaCoin', 1162, 'SHA256D', 'PoW/PoS', '/coins/arpa/overview', 1, 'cryptocompare'),
(1127, 60622, 'BNB*', 'Boats and Bitches (BNB*)', 'Boats and Bitches', 1163, 'X11', 'PoS', '/coins/bnbstar/overview', 1, 'cryptocompare'),
(1128, 60631, 'UNI', 'Universe (UNI)', 'Universe', 1164, 'Scrypt', 'PoS', '/coins/uni/overview', 1, 'cryptocompare'),
(1129, 61047, 'ECO', 'ECOcoin (ECO)', 'ECOcoin', 1165, 'Scrypt', 'PoW/PoS', '/coins/eco/overview', 1, 'cryptocompare'),
(1130, 61061, 'XLR', 'Solaris (XLR)', 'Solaris', 1166, 'XEVAN', 'PoW/PoS', '/coins/xlr/overview', 1, 'cryptocompare'),
(1131, 61066, 'DARK', 'Dark (DARK)', 'Dark', 1167, 'SHA256', 'PoW/PoS', '/coins/dark/overview', 1, 'cryptocompare'),
(1132, 61073, 'DON', 'DonationCoin (DON)', 'DonationCoin', 1168, 'Scrypt', 'PoW', '/coins/don/overview', 1, 'cryptocompare'),
(1133, 61138, 'MER', 'Mercury (MER)', 'Mercury', 1169, 'N/A', 'N/A', '/coins/mer/overview', 1, 'cryptocompare'),
(1134, 61667, 'WGO', 'WavesGO (WGO)', 'WavesGO', 1170, 'N/A', 'N/A', '/coins/wgo/overview', 1, 'cryptocompare'),
(1135, 61877, 'RLC', 'iEx.ec (RLC)', 'iEx.ec', 1171, 'N/A', 'N/A', '/coins/rlc/overview', 1, 'cryptocompare'),
(1136, 61902, 'ATMOS', 'Atmos (ATMOS)', 'Atmos', 1172, 'PoS', 'PoS', '/coins/atmos/overview', 1, 'cryptocompare'),
(1137, 61912, 'INPAY', 'InPay (INPAY)', 'InPay', 1173, 'N/A', 'N/A', '/coins/inpay/overview', 1, 'cryptocompare'),
(1138, 62529, 'ETT', 'EncryptoTel (ETT)', 'EncryptoTel', 1174, 'N/A', 'N/A', '/coins/ett/overview', 1, 'cryptocompare'),
(1139, 62640, 'WBTC*', 'wBTC (WBTC*)', 'wBTC', 1175, 'N/A', 'N/A', '/coins/wbtcstar/overview', 1, 'cryptocompare'),
(1140, 62648, 'VISIO', 'Visio (VISIO)', 'Visio', 1176, 'X13', 'PoW/PoS', '/coins/visio/overview', 1, 'cryptocompare'),
(1141, 62659, 'HPC', 'HappyCoin (HPC)', 'HappyCoin', 1177, 'X11', 'PoW/PoS', '/coins/hpc/overview', 1, 'cryptocompare'),
(1142, 63304, 'GOT', 'Giotto Coin (GOT)', 'Giotto Coin', 1178, 'Scrypt', 'PoW/PoS', '/coins/got/overview', 1, 'cryptocompare'),
(1143, 63308, 'CXT', 'Coinonat (CXT)', 'Coinonat', 1179, 'NIST5', 'PoW', '/coins/cxt/overview', 1, 'cryptocompare'),
(1144, 63312, 'EMPC', 'EmporiumCoin (EMPC)', 'EmporiumCoin', 1180, 'X11', 'PoW/PoS', '/coins/empc/overview', 1, 'cryptocompare'),
(1145, 66193, 'GNO', 'Gnosis (GNO)', 'Gnosis', 1181, 'N/A', 'N/A', '/coins/gno/overview', 1, 'cryptocompare'),
(1146, 66259, 'LGD', 'Legends Cryptocurrency (LGD)', 'Legends Cryptocurrency', 1182, 'N/A', 'N/A', '/coins/lgd/overview', 1, 'cryptocompare'),
(1147, 66270, 'TAAS', 'Token as a Service (TAAS)', 'Token as a Service', 1183, 'N/A', 'N/A', '/coins/taas/overview', 1, 'cryptocompare'),
(1148, 66685, 'BUCKS', 'SwagBucks (BUCKS)', 'SwagBucks', 1184, 'Scrypt', 'PoW/PoS', '/coins/bucks/overview', 1, 'cryptocompare'),
(1149, 66694, 'XBY', 'XtraBYtes (XBY)', 'XtraBYtes', 1185, 'N/A', 'PoSign', '/coins/xby/overview', 1, 'cryptocompare'),
(1150, 67096, 'GUP', 'Guppy (GUP)', 'Guppy', 1186, 'N/A', 'N/A', '/coins/gup/overview', 1, 'cryptocompare'),
(1151, 67430, 'MCRN', 'MacronCoin (MCRN)', 'MacronCoin', 1187, 'PoS', 'PoS', '/coins/mcrn/overview', 1, 'cryptocompare'),
(1152, 67447, 'LUN', 'Lunyr (LUN)', 'Lunyr', 1188, 'N/A', 'N/A', '/coins/lun/overview', 1, 'cryptocompare'),
(1153, 67462, 'RAIN', 'Condensate (RAIN)', 'Condensate', 1189, 'X11', 'PoW/PoS', '/coins/rain/overview', 1, 'cryptocompare'),
(1154, 68084, 'WSX', 'WeAreSatoshi (WSX)', 'WeAreSatoshi', 1190, 'X11', 'PoW/PoS', '/coins/wsx/overview', 1, 'cryptocompare'),
(1155, 68088, 'IEC', 'IvugeoEvolutionCoin (IEC)', 'IvugeoEvolutionCoin', 1191, 'Scrypt', 'PoW', '/coins/iec/overview', 1, 'cryptocompare'),
(1156, 68093, 'IMS', 'Independent Money System (IMS)', 'Independent Money System', 1192, 'Scrypt', 'PoW/PoS', '/coins/ims/overview', 1, 'cryptocompare'),
(1157, 70352, 'ARGUS', 'ArgusCoin (ARGUS)', 'ArgusCoin', 1194, 'Scrypt', 'PoW/PoS', '/coins/argus/overview', 1, 'cryptocompare'),
(1158, 70365, 'CNT', 'Centurion (CNT)', 'Centurion', 1195, 'X11', 'PoW/PoS', '/coins/cnt/overview', 1, 'cryptocompare'),
(1159, 70469, 'LMC', 'LomoCoin (LMC)', 'LomoCoin', 1196, 'Scrypt', 'PoW/PoS', '/coins/lmc/overview', 1, 'cryptocompare'),
(1160, 71077, 'TKN', 'TokenCard   (TKN)', 'TokenCard  ', 1197, 'N/A', 'N/A', '/coins/tkn/overview', 1, 'cryptocompare'),
(1161, 71321, 'BTCS', 'Bitcoin Scrypt (BTCS)', 'Bitcoin Scrypt', 1198, 'Scrypt', 'PoW', '/coins/btcs/overview', 1, 'cryptocompare'),
(1162, 71334, 'PROC', 'ProCurrency (PROC)', 'ProCurrency', 1199, 'SHA256', 'PoS', '/coins/proc/overview', 1, 'cryptocompare'),
(1163, 71862, 'XGR', 'GoldReserve (XGR)', 'GoldReserve', 1200, 'X11', 'PoW/PoS', '/coins/xgr/overview', 1, 'cryptocompare'),
(1164, 71873, 'WRC*', 'WarCoin (WRC*)', 'WarCoin', 1201, 'Scrypt', 'PoW/PoS', '/coins/wrcstar/overview', 1, 'cryptocompare'),
(1165, 71884, 'BENJI', 'BenjiRolls (BENJI)', 'BenjiRolls', 1202, 'Scrypt', 'PoW', '/coins/benji/overview', 1, 'cryptocompare'),
(1166, 72438, 'HMQ', 'Humaniq (HMQ)', 'Humaniq', 1203, 'N/A', 'N/A', '/coins/hmq/overview', 1, 'cryptocompare'),
(1167, 72955, 'BCAP', 'Blockchain Capital (BCAP)', 'Blockchain Capital', 1204, 'N/A', 'N/A', '/coins/bcap/overview', 1, 'cryptocompare'),
(1168, 73132, 'DUO', 'ParallelCoin (DUO)', 'ParallelCoin', 1205, 'Scrypt', 'PoW', '/coins/duo/overview', 1, 'cryptocompare'),
(1169, 73143, 'RBX', 'RiptoBuX (RBX)', 'RiptoBuX', 1206, 'N/A', 'N/A', '/coins/rbx/overview', 1, 'cryptocompare'),
(1170, 74894, 'GRW', 'GrowthCoin (GRW)', 'GrowthCoin', 1207, 'Scrypt', 'PoS', '/coins/grw/overview', 1, 'cryptocompare'),
(1171, 74912, 'APX', 'Apx (APX)', 'Apx', 1208, 'N/A', 'N/A', '/coins/apx/overview', 1, 'cryptocompare'),
(1172, 74924, 'MILO', 'MiloCoin (MILO)', 'MiloCoin', 1209, 'Scrypt', 'PoW/PoS', '/coins/milo/overview', 1, 'cryptocompare'),
(1173, 75285, 'OLV', 'OldV (OLV)', 'OldV', 1210, 'Scrypt', 'PoW/PoS', '/coins/olv/overview', 1, 'cryptocompare'),
(1174, 75440, 'ILC', 'ILCoin (ILC)', 'ILCoin', 1211, 'SHA256', 'PoW', '/coins/ilc/overview', 1, 'cryptocompare'),
(1175, 75475, 'MRT', 'MinersReward (MRT)', 'MinersReward', 1212, 'N/A', 'N/A', '/coins/mrt/overview', 1, 'cryptocompare'),
(1176, 77286, 'IOU', 'IOU1 (IOU)', 'IOU1', 1213, 'N/A', 'N/A', '/coins/iou/overview', 1, 'cryptocompare'),
(1177, 77306, 'PZM', 'Prizm (PZM)', 'Prizm', 1214, 'SHA256', 'PoS', '/coins/pzm/overview', 1, 'cryptocompare'),
(1178, 77337, 'PHR', 'Phreak (PHR)', 'Phreak', 1215, 'PoS', 'PoS', '/coins/phr/overview', 1, 'cryptocompare'),
(1179, 78152, 'ANT', 'Aragon (ANT)', 'Aragon', 1216, 'N/A', 'N/A', '/coins/ant/overview', 1, 'cryptocompare'),
(1180, 78172, 'PUPA', 'PupaCoin (PUPA)', 'PupaCoin', 1217, 'Blake2S', 'PoW/PoS', '/coins/pupa/overview', 1, 'cryptocompare'),
(1181, 78190, 'RICE', 'RiceCoin (RICE)', 'RiceCoin', 1218, 'X13', 'PoW/PoS', '/coins/rice/overview', 1, 'cryptocompare'),
(1182, 78227, 'XCT', 'C-Bits (XCT)', 'C-Bits', 1219, 'SHA256', 'PoW', '/coins/xct/overview', 1, 'cryptocompare'),
(1183, 79849, 'DEA', 'Degas Coin (DEA)', 'Degas Coin', 1220, 'Scrypt', 'PoW/PoS', '/coins/dea/overview', 1, 'cryptocompare'),
(1184, 79864, 'RED', 'Redcoin (RED)', 'Redcoin', 1221, 'Scrypt', 'PoW', '/coins/red/overview', 1, 'cryptocompare'),
(1185, 79875, 'ZSE', 'ZSEcoin (ZSE)', 'ZSEcoin', 1222, 'X11', 'PoW/PoS', '/coins/zse/overview', 1, 'cryptocompare'),
(1186, 79887, 'CTIC', 'Coinmatic (CTIC)', 'Coinmatic', 1223, 'N/A', 'N/A', '/coins/ctic/overview', 1, 'cryptocompare'),
(1187, 81403, 'TAP', 'TappingCoin (TAP)', 'TappingCoin', 1224, 'X11', 'PoW/PoS', '/coins/tap/overview', 1, 'cryptocompare'),
(1188, 81445, 'BITOK', 'BitOKX (BITOK)', 'BitOKX', 1225, 'Scrypt', 'PoS', '/coins/bitok/overview', 1, 'cryptocompare'),
(1189, 84232, 'PBT', 'Primalbase (PBT)', 'Primalbase', 1226, 'N/A', 'N/A', '/coins/pbt/overview', 1, 'cryptocompare'),
(1190, 84247, 'MUU', 'MilkCoin (MUU)', 'MilkCoin', 1227, 'SHA256', 'PoW/PoS ', '/coins/muu/overview', 1, 'cryptocompare'),
(1191, 84262, 'INF8', 'Infinium-8 (INF8)', 'Infinium-8', 1228, 'HybridScrypt', 'PoW', '/coins/inf8/overview', 1, 'cryptocompare'),
(1192, 84752, 'HTML5', 'HTML5 Coin (HTML5)', 'HTML5 Coin', 1229, 'X15', 'PoW/PoS', '/coins/html5/overview', 1, 'cryptocompare'),
(1193, 84831, 'MNE', 'Minereum (MNE)', 'Minereum', 1230, 'N/A', 'N/A', '/coins/mne/overview', 1, 'cryptocompare'),
(1194, 89572, 'DICE', 'Etheroll (DICE)', 'Etheroll', 1231, 'N/A', 'N/A', '/coins/dice/overview', 1, 'cryptocompare'),
(1195, 100944, 'SUB*', 'Subscriptio (SUB*)', 'Subscriptio', 1232, 'PoS', 'PoS', '/coins/substar/overview', 1, 'cryptocompare'),
(1196, 100954, 'USC', 'Ultimate Secure Cash (USC)', 'Ultimate Secure Cash', 1233, 'SHA256', 'PoS', '/coins/usc/overview', 1, 'cryptocompare'),
(1197, 105206, 'DUX', 'DuxCoin (DUX)', 'DuxCoin', 1234, 'Scrypt', 'PoW/PoS', '/coins/dux/overview', 1, 'cryptocompare'),
(1198, 105220, 'XPS', 'PoisonIvyCoin (XPS)', 'PoisonIvyCoin', 1235, 'Scrypt', 'PoW/PoS', '/coins/xps/overview', 1, 'cryptocompare'),
(1199, 105263, 'EQT', 'EquiTrader (EQT)', 'EquiTrader', 1236, 'Scrypt', 'PoW', '/coins/eqt/overview', 1, 'cryptocompare'),
(1200, 105284, 'INSN', 'Insane Coin (INSN)', 'Insane Coin', 1237, 'X11', 'PoW/PoS', '/coins/insn/overview', 1, 'cryptocompare'),
(1201, 107672, 'BAT', 'Basic Attention Token (BAT)', 'Basic Attention Token', 1238, 'N/A', 'N/A', '/coins/bat/overview', 1, 'cryptocompare'),
(1202, 108094, 'MAT*', 'Manet Coin (MAT*)', 'Manet Coin', 1239, 'Scrypt', 'PoW/PoS', '/coins/matstar/overview', 1, 'cryptocompare'),
(1203, 108099, 'F16', 'F16Coin (F16)', 'F16Coin', 1240, 'Scrypt', 'PoW/PoS', '/coins/f16/overview', 1, 'cryptocompare'),
(1204, 112363, 'HAMS', 'HamsterCoin (HAMS)', 'HamsterCoin', 1241, 'Scrypt', 'PoW', '/coins/hams/overview', 1, 'cryptocompare'),
(1205, 112392, 'QTUM', 'QTUM (QTUM)', 'QTUM', 1242, 'POS 3.0', 'PoS', '/coins/qtum/overview', 1, 'cryptocompare'),
(1206, 112405, 'NEF', 'NefariousCoin (NEF)', 'NefariousCoin', 1243, 'Scrypt', 'PoW/PoS', '/coins/nef/overview', 1, 'cryptocompare'),
(1207, 116180, 'ZEN', 'ZenCash (ZEN)', 'ZenCash', 1244, 'Equihash', 'PoW', '/coins/zen/overview', 1, 'cryptocompare'),
(1208, 116384, 'BOS', 'BOScoin (BOS)', 'BOScoin', 1245, 'N/A', 'mFBA', '/coins/bos/overview', 1, 'cryptocompare'),
(1209, 116425, 'QWARK', 'Qwark (QWARK)', 'Qwark', 1246, 'N/A', 'N/A', '/coins/qwark/overview', 1, 'cryptocompare'),
(1210, 127356, 'IOT', 'IOTA (IOT)', 'IOTA', 1247, 'N/A', 'Tangle', '/coins/iot/overview', 1, 'cryptocompare'),
(1211, 127667, 'QRL', 'Quantum Resistant Ledger (QRL)', 'Quantum Resistant Ledger', 1248, 'CryptoNight-', 'PoW', '/coins/qrl/overview', 1, 'cryptocompare'),
(1212, 127738, 'ADL', 'Adelphoi (ADL)', 'Adelphoi', 1249, 'N/A', 'N/A', '/coins/adl/overview', 1, 'cryptocompare'),
(1213, 129013, 'ECC*', 'E-CurrencyCoin (ECC*)', 'E-CurrencyCoin', 1250, 'Scrypt', 'PoW/PoS', '/coins/eccstar/overview', 1, 'cryptocompare'),
(1214, 129035, 'PTOY', 'Patientory (PTOY)', 'Patientory', 1251, 'N/A', 'N/A', '/coins/ptoy/overview', 1, 'cryptocompare'),
(1215, 129604, 'ZRC', 'ZrCoin (ZRC)', 'ZrCoin', 1252, 'N/A', 'N/A', '/coins/zrc/overview', 1, 'cryptocompare'),
(1216, 130939, 'LKK', 'Lykke (LKK)', 'Lykke', 1253, 'N/A', 'N/A', '/coins/lkk/overview', 1, 'cryptocompare'),
(1217, 130951, 'ESP', 'Espers (ESP)', 'Espers', 1254, '536', 'PoW/PoS', '/coins/esp/overview', 1, 'cryptocompare'),
(1218, 131079, 'MAD*', 'SatoshiMadness (MAD*)', 'SatoshiMadness', 1255, 'PoS', 'PoS', '/coins/madstar/overview', 1, 'cryptocompare'),
(1219, 131111, 'DYN', 'Dynamic (DYN)', 'Dynamic', 1256, 'Argon2', 'PoW', '/coins/dyn/overview', 1, 'cryptocompare'),
(1220, 131112, 'SEQ', 'Sequence (SEQ)', 'Sequence', 1257, 'Scrypt', 'PoW/PoS', '/coins/seq/overview', 1, 'cryptocompare'),
(1221, 131154, 'MCAP', 'MCAP (MCAP)', 'MCAP', 1258, 'N/A', 'N/A', '/coins/mcap/overview', 1, 'cryptocompare'),
(1222, 136190, 'MYST', 'Mysterium (MYST)', 'Mysterium', 1259, 'N/A', 'N/A', '/coins/myst/overview', 1, 'cryptocompare'),
(1223, 136211, 'VERI', 'Veritaseum (VERI)', 'Veritaseum', 1260, 'N/A', 'N/A', '/coins/veri/overview', 1, 'cryptocompare'),
(1224, 136244, 'SNM', 'SONM (SNM)', 'SONM', 1261, 'N/A', 'N/A', '/coins/snm/overview', 1, 'cryptocompare'),
(1225, 136269, 'SKY', 'Skycoin (SKY)', 'Skycoin', 1262, 'N/A', 'N/A', '/coins/sky/overview', 1, 'cryptocompare'),
(1226, 136984, 'CFI', 'Cofound.it (CFI)', 'Cofound.it', 1263, 'N/A', 'N/A', '/coins/cfi/overview', 1, 'cryptocompare'),
(1227, 137013, 'SNT', 'Status Network Token (SNT)', 'Status Network Token', 1264, 'N/A', 'N/A', '/coins/snt/overview', 1, 'cryptocompare'),
(1228, 138642, 'AVT', 'AventCoin (AVT)', 'AventCoin', 1265, 'N/A', 'N/A', '/coins/avt/overview', 1, 'cryptocompare'),
(1229, 139467, 'CVC', 'Civic (CVC)', 'Civic', 1266, 'N/A', 'N/A', '/coins/cvc/overview', 1, 'cryptocompare'),
(1230, 141171, 'IXT', 'iXledger (IXT)', 'iXledger', 1267, 'N/A', 'N/A', '/coins/ixt/overview', 1, 'cryptocompare'),
(1231, 141331, 'DENT', 'Dent (DENT)', 'Dent', 1268, 'N/A', 'N/A', '/coins/dent/overview', 1, 'cryptocompare'),
(1232, 141464, 'ETHOS', 'Ethos (ETHOS)', 'Ethos', 1269, 'N/A', 'N/A', '/coins/ethos/overview', 1, 'cryptocompare'),
(1233, 150519, 'STA', 'Starta (STA)', 'Starta', 1270, 'N/A', 'N/A', '/coins/sta/overview', 1, 'cryptocompare'),
(1234, 150545, 'TFL', 'True Flip Lottery (TFL)', 'True Flip Lottery', 1271, 'N/A', 'N/A', '/coins/tfl/overview', 1, 'cryptocompare'),
(1235, 165555, 'EFYT', 'Ergo (EFYT)', 'Ergo', 1272, 'N/A', 'N/A', '/coins/efyt/overview', 1, 'cryptocompare'),
(1236, 166390, 'XTZ', 'Tezos (XTZ)', 'Tezos', 1273, 'N/A', 'DPoS', '/coins/xtz/overview', 1, 'cryptocompare'),
(1237, 166503, 'EOS', 'EOS (EOS)', 'EOS', 1274, 'DPoS', 'DPoS', '/coins/eos/overview', 1, 'cryptocompare'),
(1238, 166548, 'MCO', 'MCO (MCO)', 'MCO', 1275, 'N/A', 'N/A', '/coins/mco/overview', 1, 'cryptocompare'),
(1239, 166594, 'NMR', 'Numeraire (NMR)', 'Numeraire', 1276, 'N/A', 'N/A', '/coins/nmr/overview', 1, 'cryptocompare'),
(1240, 170452, 'ADX', 'AdEx (ADX)', 'AdEx', 1277, 'N/A', 'N/A', '/coins/adx/overview', 1, 'cryptocompare'),
(1241, 170958, 'QAU', 'Quantum (QAU)', 'Quantum', 1278, 'N/A', 'N/A', '/coins/qau/overview', 1, 'cryptocompare'),
(1242, 171390, 'ECOB', 'EcoBit (ECOB)', 'EcoBit', 1279, 'N/A', 'N/A', '/coins/ecob/overview', 1, 'cryptocompare'),
(1243, 171884, 'PLBT', 'Polybius (PLBT)', 'Polybius', 1280, 'N/A', 'N/A', '/coins/plbt/overview', 1, 'cryptocompare'),
(1244, 171986, 'USDT', 'Tether (USDT)', 'Tether', 1281, 'N/A', 'N/A', '/coins/usdt/overview', 1, 'cryptocompare'),
(1245, 172091, 'NANO', 'Nano (NANO)', 'Nano', 1282, 'Blake2b', 'PoW', '/coins/nano/overview', 1, 'cryptocompare'),
(1246, 175611, 'AHT', 'Ahoolee (AHT)', 'Ahoolee', 1283, 'Ethash', 'PoW', '/coins/aht/overview', 1, 'cryptocompare'),
(1247, 175618, 'ATB', 'ATB coin (ATB)', 'ATB coin', 1284, 'SHA256', 'PoW', '/coins/atb/overview', 1, 'cryptocompare'),
(1248, 175671, 'TIX', 'Blocktix (TIX)', 'Blocktix', 1285, 'N/A', 'N/A', '/coins/tix/overview', 1, 'cryptocompare'),
(1249, 175683, 'CHAN', 'ChanCoin (CHAN)', 'ChanCoin', 1286, 'Cloverhash', 'PoW', '/coins/chan/overview', 1, 'cryptocompare'),
(1250, 176004, 'CMP', 'Compcoin (CMP)', 'Compcoin', 1287, 'N/A', 'N/A', '/coins/cmp/overview', 1, 'cryptocompare'),
(1251, 176280, 'RVT', 'Rivetz (RVT)', 'Rivetz', 1288, 'N/A', 'N/A', '/coins/rvt/overview', 1, 'cryptocompare'),
(1252, 176336, 'HRB', 'Harbour DAO (HRB)', 'Harbour DAO', 1289, 'N/A', 'N/A', '/coins/hrb/overview', 1, 'cryptocompare'),
(1253, 176669, 'NIM', 'Nimiq  (NIM)', 'Nimiq ', 1290, 'N/A', 'PoW', '/coins/nim/overview', 1, 'cryptocompare'),
(1254, 177124, '8BT', '8 Circuit Studios (8BT)', '8 Circuit Studios', 1291, 'N/A', 'N/A', '/coins/8bt/overview', 1, 'cryptocompare'),
(1255, 177139, 'CDT', 'Blox (CDT)', 'Blox', 1292, 'N/A', 'N/A', '/coins/cdt/overview', 1, 'cryptocompare'),
(1256, 177157, 'ACT', 'ACT (ACT)', 'ACT', 1293, 'N/A', 'N/A', '/coins/act/overview', 1, 'cryptocompare'),
(1257, 177175, 'DNT', 'district0x (DNT)', 'district0x', 1294, 'N/A', 'N/A', '/coins/dnt/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(1258, 177462, 'SUR', 'Suretly (SUR)', 'Suretly', 1295, 'N/A', 'N/A', '/coins/sur/overview', 1, 'cryptocompare'),
(1259, 177503, 'PING', 'CryptoPing (PING)', 'CryptoPing', 1296, 'N/A', 'N/A', '/coins/ping/overview', 1, 'cryptocompare'),
(1260, 177759, 'MIV', 'MakeItViral (MIV)', 'MakeItViral', 1297, 'Scrypt', 'PoW/PoS', '/coins/miv/overview', 1, 'cryptocompare'),
(1261, 177831, 'BET*', 'DAO.casino (BET*)', 'DAO.casino', 1298, 'N/A', 'N/A', '/coins/betstar/overview', 1, 'cryptocompare'),
(1262, 177863, 'SAN', 'Santiment (SAN)', 'Santiment', 1299, 'N/A', 'N/A', '/coins/san/overview', 1, 'cryptocompare'),
(1263, 177918, 'KIN', 'Kin (KIN)', 'Kin', 1300, 'N/A', 'N/A', '/coins/kin/overview', 1, 'cryptocompare'),
(1264, 178467, 'WGR', 'Wagerr (WGR)', 'Wagerr', 1301, 'PoS', 'N/A', '/coins/wgr/overview', 1, 'cryptocompare'),
(1265, 178861, 'XEL', 'Elastic (XEL)', 'Elastic', 1302, 'N/A', 'PoW', '/coins/xel/overview', 1, 'cryptocompare'),
(1266, 178885, 'NVST', 'NVO (NVST)', 'NVO', 1303, 'N/A', 'N/A', '/coins/nvst/overview', 1, 'cryptocompare'),
(1267, 178978, 'FUN', 'FunFair (FUN)', 'FunFair', 1304, 'N/A', 'N/A', '/coins/fun/overview', 1, 'cryptocompare'),
(1268, 179018, 'FUNC', 'FunCoin (FUNC)', 'FunCoin', 1305, 'N/A', 'N/A', '/coins/func/overview', 1, 'cryptocompare'),
(1269, 179077, 'PQT', 'PAquarium (PQT)', 'PAquarium', 1306, 'N/A', 'N/A', '/coins/pqt/overview', 1, 'cryptocompare'),
(1270, 179109, 'WTT', 'Giga Watt (WTT)', 'Giga Watt', 1307, 'N/A', 'N/A', '/coins/wtt/overview', 1, 'cryptocompare'),
(1271, 179164, 'MTL', 'Metal (MTL)', 'Metal', 1308, 'N/A', 'PoPP', '/coins/mtl/overview', 1, 'cryptocompare'),
(1272, 179329, 'HVN', 'Hive Project (HVN)', 'Hive Project', 1309, 'N/A', 'N/A', '/coins/hvn/overview', 1, 'cryptocompare'),
(1273, 179345, 'MYB', 'MyBit (MYB)', 'MyBit', 1310, 'N/A', 'N/A', '/coins/myb/overview', 1, 'cryptocompare'),
(1274, 179896, 'PPT', 'Populous (PPT)', 'Populous', 1311, 'N/A', 'N/A', '/coins/ppt/overview', 1, 'cryptocompare'),
(1275, 179926, 'SNC', 'SunContract (SNC)', 'SunContract', 1312, 'N/A', 'N/A', '/coins/snc/overview', 1, 'cryptocompare'),
(1276, 179947, 'STAR', 'Starbase (STAR)', 'Starbase', 1314, 'N/A', 'N/A', '/coins/star/overview', 1, 'cryptocompare'),
(1277, 179980, 'COR', 'Corion (COR)', 'Corion', 1316, 'N/A', 'N/A', '/coins/cor/overview', 1, 'cryptocompare'),
(1278, 179990, 'XRL', 'Rialto.AI (XRL)', 'Rialto.AI', 1317, 'N/A', 'N/A', '/coins/xrl/overview', 1, 'cryptocompare'),
(1279, 180001, 'OROC', 'Orocrypt (OROC)', 'Orocrypt', 1318, 'N/A', 'N/A', '/coins/oroc/overview', 1, 'cryptocompare'),
(1280, 180013, 'OAX', 'OpenANX (OAX)', 'OpenANX', 1319, 'N/A', 'N/A', '/coins/oax/overview', 1, 'cryptocompare'),
(1281, 180539, 'MBI', 'Monster Byte Inc (MBI)', 'Monster Byte Inc', 1320, 'N/A', 'N/A', '/coins/mbi/overview', 1, 'cryptocompare'),
(1282, 180595, 'DDF', 'Digital Developers Fund (DDF)', 'Digital Developers Fund', 1321, 'N/A', 'N/A', '/coins/ddf/overview', 1, 'cryptocompare'),
(1283, 180678, 'DIM', 'DIMCOIN (DIM)', 'DIMCOIN', 1322, 'N/A', 'N/A', '/coins/dim/overview', 1, 'cryptocompare'),
(1284, 180716, 'GGS', 'Gilgam (GGS)', 'Gilgam', 1323, 'N/A', 'N/A', '/coins/ggs/overview', 1, 'cryptocompare'),
(1285, 180804, 'DNA', 'EncrypGen (DNA)', 'EncrypGen', 1324, 'N/A', 'N/A', '/coins/dna/overview', 1, 'cryptocompare'),
(1286, 180820, 'FYN', 'FundYourselfNow (FYN)', 'FundYourselfNow', 1325, 'N/A', 'N/A', '/coins/fyn/overview', 1, 'cryptocompare'),
(1287, 180840, 'FND', 'FundRequest (FND)', 'FundRequest', 1326, 'N/A', 'N/A', '/coins/fnd/overview', 1, 'cryptocompare'),
(1288, 181373, 'DCY', 'Dinastycoin (DCY)', 'Dinastycoin', 1327, 'CryptoNight', 'PoW', '/coins/dcy/overview', 1, 'cryptocompare'),
(1289, 182258, 'CFT', 'CryptoForecast (CFT)', 'CryptoForecast', 1328, 'N/A', 'N/A', '/coins/cft/overview', 1, 'cryptocompare'),
(1290, 182288, 'DNR', 'Denarius (DNR)', 'Denarius', 1329, 'NIST5', 'PoW/PoS', '/coins/dnr/overview', 1, 'cryptocompare'),
(1291, 182325, 'DP', 'DigitalPrice (DP)', 'DigitalPrice', 1330, 'X11', 'PoW', '/coins/dp/overview', 1, 'cryptocompare'),
(1292, 182340, 'VUC', 'Virta Unique Coin (VUC)', 'Virta Unique Coin', 1331, 'NIST5', 'PoW/PoS', '/coins/vuc/overview', 1, 'cryptocompare'),
(1293, 182346, 'BTPL', 'Bitcoin Planet (BTPL)', 'Bitcoin Planet', 1332, 'Skein', 'PoW/PoS', '/coins/btpl/overview', 1, 'cryptocompare'),
(1294, 182364, 'UNIFY', 'Unify (UNIFY)', 'Unify', 1333, 'Scrypt', 'PoW', '/coins/unify/overview', 1, 'cryptocompare'),
(1295, 182396, 'IPC', 'ImperialCoin (IPC)', 'ImperialCoin', 1334, 'NeoScrypt', 'PoW', '/coins/ipc/overview', 1, 'cryptocompare'),
(1296, 182416, 'BRIT', 'BritCoin (BRIT)', 'BritCoin', 1335, 'X13', 'PoW/PoS', '/coins/brit/overview', 1, 'cryptocompare'),
(1297, 182463, 'AMMO', 'Ammo Rewards (AMMO)', 'Ammo Rewards', 1336, 'N/A', 'PoS', '/coins/ammo/overview', 1, 'cryptocompare'),
(1298, 183189, 'SOCC', 'SocialCoin (SOCC)', 'SocialCoin', 1337, 'Scrypt', 'PoW', '/coins/socc/overview', 1, 'cryptocompare'),
(1299, 184135, 'MASS', 'Mass.Cloud (MASS)', 'Mass.Cloud', 1339, 'N/A', 'N/A', '/coins/mass/overview', 1, 'cryptocompare'),
(1300, 184163, 'LA', 'LATOKEN (LA)', 'LATOKEN', 1340, 'N/A', 'N/A', '/coins/la/overview', 1, 'cryptocompare'),
(1301, 184187, 'IML', 'IMMLA (IML)', 'IMMLA', 1341, 'N/A', 'N/A', '/coins/iml/overview', 1, 'cryptocompare'),
(1302, 184221, 'XUC', 'Exchange Union (XUC)', 'Exchange Union', 1342, 'N/A', 'N/A', '/coins/xuc/overview', 1, 'cryptocompare'),
(1303, 184237, 'STU', 'BitJob (STU)', 'BitJob', 1343, 'N/A', 'N/A', '/coins/stu/overview', 1, 'cryptocompare'),
(1304, 184298, 'PLR', 'Pillar (PLR)', 'Pillar', 1344, 'N/A', 'N/A', '/coins/plr/overview', 1, 'cryptocompare'),
(1305, 185625, 'GUNS', 'GeoFunders (GUNS)', 'GeoFunders', 1345, 'N/A', 'N/A', '/coins/guns/overview', 1, 'cryptocompare'),
(1306, 185669, 'IFT', 'InvestFeed (IFT)', 'InvestFeed', 1346, 'N/A', 'N/A', '/coins/ift/overview', 1, 'cryptocompare'),
(1307, 185689, 'CAT*', 'BitClave (CAT)', 'BitClave', 1347, 'N/A', 'N/A', '/coins/cat/overview', 1, 'cryptocompare'),
(1308, 185695, 'PRO', 'Propy (PRO)', 'Propy', 1348, 'N/A', 'N/A', '/coins/pro/overview', 1, 'cryptocompare'),
(1309, 185873, 'SYC', 'SynchroCoin (SYC)', 'SynchroCoin', 1349, 'N/A', 'N/A', '/coins/syc/overview', 1, 'cryptocompare'),
(1310, 185953, 'IND', 'Indorse (IND)', 'Indorse', 1350, 'N/A', 'N/A', '/coins/ind/overview', 1, 'cryptocompare'),
(1311, 186064, 'AHT*', 'Bowhead Health (AHT*)', 'Bowhead Health', 1351, 'N/A', 'N/A', '/coins/ahtstar/overview', 1, 'cryptocompare'),
(1312, 186253, 'TRIBE', 'TribeToken (TRIBE)', 'TribeToken', 1352, 'N/A', 'N/A', '/coins/tribe/overview', 1, 'cryptocompare'),
(1313, 186277, 'ZRX', '0x (ZRX)', '0x', 1353, 'N/A', 'N/A', '/coins/zrx/overview', 1, 'cryptocompare'),
(1314, 186309, 'TNT', 'Tierion (TNT)', 'Tierion', 1354, 'N/A', 'N/A', '/coins/tnt/overview', 1, 'cryptocompare'),
(1315, 186331, 'PRE*', 'Presearch (PRE*)', 'Presearch', 1355, 'N/A', 'N/A', '/coins/prestar/overview', 1, 'cryptocompare'),
(1316, 186335, 'COSS', 'COSS (COSS)', 'COSS', 1356, 'N/A', 'N/A', '/coins/coss/overview', 1, 'cryptocompare'),
(1317, 186875, 'STORM', 'Storm (STORM)', 'Storm', 1357, 'N/A', 'N/A', '/coins/storm/overview', 1, 'cryptocompare'),
(1318, 187015, 'NPX', 'Napoleon X (NPX)', 'Napoleon X', 1359, 'N/A', 'N/A', '/coins/npx/overview', 1, 'cryptocompare'),
(1319, 187347, 'STORJ', 'Storj (STORJ)', 'Storj', 1360, 'N/A', 'N/A', '/coins/storj/overview', 1, 'cryptocompare'),
(1320, 187431, 'SCORE', 'Scorecoin (SCORE)', 'Scorecoin', 1361, 'Scrypt', 'PoW', '/coins/score/overview', 1, 'cryptocompare'),
(1321, 187440, 'OMG', 'OmiseGo (OMG)', 'OmiseGo', 1362, 'N/A', 'PoS', '/coins/omg/overview', 1, 'cryptocompare'),
(1322, 188294, 'OTX', 'Octanox (OTX)', 'Octanox', 1364, 'X11', 'PoW/PoS', '/coins/otx/overview', 1, 'cryptocompare'),
(1323, 188300, 'EQB', 'Equibit (EQB)', 'Equibit', 1365, 'N/A', 'N/A', '/coins/eqb/overview', 1, 'cryptocompare'),
(1324, 188352, 'VOISE', 'Voise (VOISE)', 'Voise', 1366, 'N/A', 'N/A', '/coins/voise/overview', 1, 'cryptocompare'),
(1325, 188394, 'ETBS', 'EthBits (ETBS)', 'EthBits', 1367, 'N/A', 'N/A', '/coins/etbs/overview', 1, 'cryptocompare'),
(1326, 188400, 'CVCOIN', 'Crypviser (CVCOIN)', 'Crypviser', 1368, 'N/A', 'N/A', '/coins/cvcoin/overview', 1, 'cryptocompare'),
(1327, 188523, 'DRP', 'DCORP (DRP)', 'DCORP', 1369, 'N/A', 'N/A', '/coins/drp/overview', 1, 'cryptocompare'),
(1328, 188615, 'ARC', 'ArcticCoin (ARC)', 'ArcticCoin', 1370, 'X11', 'PoW', '/coins/arc/overview', 1, 'cryptocompare'),
(1329, 188677, 'BOG', 'Bogcoin (BOG)', 'Bogcoin', 1371, 'SHA256', 'PoW', '/coins/bog/overview', 1, 'cryptocompare'),
(1330, 188787, 'NDC', 'NeverDie (NDC)', 'NeverDie', 1372, 'N/A', 'N/A', '/coins/ndc/overview', 1, 'cryptocompare'),
(1331, 188811, 'POE', 'Po.et (POE)', 'Po.et', 1373, 'N/A', 'N/A', '/coins/poe/overview', 1, 'cryptocompare'),
(1332, 188858, 'ADT', 'AdToken (ADT)', 'AdToken', 1374, 'N/A', 'N/A', '/coins/adt/overview', 1, 'cryptocompare'),
(1333, 190978, 'AE', 'Aeternity (AE)', 'Aeternity', 1375, 'N/A', 'PoW/PoS', '/coins/ae/overview', 1, 'cryptocompare'),
(1334, 191037, 'UET', 'Useless Ethereum Token (UET)', 'Useless Ethereum Token', 1376, 'N/A', 'N/A', '/coins/uet/overview', 1, 'cryptocompare'),
(1335, 191116, 'PART', 'Particl (PART)', 'Particl', 1377, 'PoS', 'PoS', '/coins/part/overview', 1, 'cryptocompare'),
(1336, 191142, 'AGRS', 'Agoras Token (AGRS)', 'Agoras Token', 1378, 'N/A', 'N/A', '/coins/agrs/overview', 1, 'cryptocompare'),
(1337, 188652, 'SAND', 'BeachCoin (SAND)', 'BeachCoin', 1379, 'X11', 'PoW', '/coins/sand/overview', 1, 'cryptocompare'),
(1338, 191228, 'XAI*', 'AICoin (XAI*)', 'AICoin', 1380, 'N/A', 'N/A', '/coins/xaistar/overview', 1, 'cryptocompare'),
(1339, 192400, 'DMT', 'DMarket (DMT)', 'DMarket', 1381, 'N/A', 'N/A', '/coins/dmt/overview', 1, 'cryptocompare'),
(1340, 194399, 'DAS', 'DAS (DAS)', 'DAS', 1382, 'X11', 'PoW', '/coins/das/overview', 1, 'cryptocompare'),
(1341, 194530, 'ADST', 'Adshares (ADST)', 'Adshares', 1383, 'N/A', 'N/A', '/coins/adst/overview', 1, 'cryptocompare'),
(1342, 194567, 'CAT', 'BlockCAT (CAT*)', 'BlockCAT', 1384, 'N/A', 'N/A', '/coins/catstar/overview', 1, 'cryptocompare'),
(1343, 194689, 'XCJ', 'CoinJob (XCJ)', 'CoinJob', 1385, 'N/A', 'N/A', '/coins/xcj/overview', 1, 'cryptocompare'),
(1344, 194924, 'RKC', 'Royal Kingdom Coin (RKC)', 'Royal Kingdom Coin', 1386, 'N/A', 'N/A', '/coins/rkc/overview', 1, 'cryptocompare'),
(1345, 195018, 'NLC2', 'NoLimitCoin (NLC2)', 'NoLimitCoin', 1387, 'PoS', 'PoS', '/coins/nlc2/overview', 1, 'cryptocompare'),
(1346, 196541, 'LINDA', 'Linda (LINDA)', 'Linda', 1388, 'Scrypt', 'PoW/PoS', '/coins/linda/overview', 1, 'cryptocompare'),
(1347, 196560, 'KING', 'King93 (KING)', 'King93', 1390, 'N/A', 'N/A', '/coins/king/overview', 1, 'cryptocompare'),
(1348, 196572, 'ANCP', 'Anacrypt (ANCP)', 'Anacrypt', 1391, 'N/A', 'N/A', '/coins/ancp/overview', 1, 'cryptocompare'),
(1349, 196591, 'RCC', 'Reality Clash (RCC)', 'Reality Clash', 1392, 'Ethash', 'PoW', '/coins/rcc/overview', 1, 'cryptocompare'),
(1350, 194906, 'ROOTS', 'RootProject (ROOTS)', 'RootProject', 1393, 'N/A', 'N/A', '/coins/roots/overview', 1, 'cryptocompare'),
(1351, 196612, 'SNK', 'Sosnovkino (SNK)', 'Sosnovkino', 1394, 'N/A', 'N/A', '/coins/snk/overview', 1, 'cryptocompare'),
(1352, 196986, 'CABS', 'CryptoABS (CABS)', 'CryptoABS', 1395, 'N/A', 'N/A', '/coins/cabs/overview', 1, 'cryptocompare'),
(1353, 197054, 'OPT', 'Opus (OPT)', 'Opus', 1396, 'N/A', 'N/A', '/coins/opt/overview', 1, 'cryptocompare'),
(1354, 197886, 'ZNT', 'OpenZen (ZNT)', 'OpenZen', 1397, 'N/A', 'N/A', '/coins/znt/overview', 1, 'cryptocompare'),
(1355, 198251, 'BITSD', 'Bits Digit (BITSD)', 'Bits Digit', 1398, 'N/A', 'N/A', '/coins/bitsd/overview', 1, 'cryptocompare'),
(1356, 198337, 'XLC', 'LeviarCoin (XLC)', 'LeviarCoin', 1399, 'CryptoNight', 'PoW', '/coins/xlc/overview', 1, 'cryptocompare'),
(1357, 198369, 'SKIN', 'Skincoin (SKIN)', 'Skincoin', 1400, 'N/A', 'N/A', '/coins/skin/overview', 1, 'cryptocompare'),
(1358, 198408, 'MSP', 'Mothership (MSP)', 'Mothership', 1401, 'N/A', 'N/A', '/coins/msp/overview', 1, 'cryptocompare'),
(1359, 198458, 'HIRE', 'HireMatch (HIRE)', 'HireMatch', 1402, 'N/A', 'N/A', '/coins/hire/overview', 1, 'cryptocompare'),
(1360, 198490, 'REAL', 'REAL (REAL)', 'REAL', 1404, 'N/A', 'N/A', '/coins/real/overview', 1, 'cryptocompare'),
(1361, 198693, 'DFBT', 'DentalFix (DFBT)', 'DentalFix', 1405, 'N/A', 'N/A', '/coins/dfbt/overview', 1, 'cryptocompare'),
(1362, 198698, 'EQ', 'EQUI (EQ)', 'EQUI', 1406, 'N/A', 'N/A', '/coins/eq/overview', 1, 'cryptocompare'),
(1363, 198703, 'WLK', 'Wolk (WLK)', 'Wolk', 1407, 'N/A', 'N/A', '/coins/wlk/overview', 1, 'cryptocompare'),
(1364, 198710, 'VIB', 'Viberate (VIB)', 'Viberate', 1408, 'N/A', 'N/A', '/coins/vib/overview', 1, 'cryptocompare'),
(1365, 198967, 'ONION', 'DeepOnion (ONION)', 'DeepOnion', 1409, 'X13', 'PoW/PoS', '/coins/onion/overview', 1, 'cryptocompare'),
(1366, 198983, 'BTX', 'Bitcore (BTX)', 'Bitcore', 1410, 'Time Travel', 'PoW', '/coins/btx/overview', 1, 'cryptocompare'),
(1367, 199004, 'ICE', 'iDice (ICE)', 'iDice', 1411, 'N/A', 'N/A', '/coins/ice/overview', 1, 'cryptocompare'),
(1368, 199026, 'XID', 'Sphre AIR (XID)', 'Sphre AIR', 1412, 'N/A', 'N/A', '/coins/xid/overview', 1, 'cryptocompare'),
(1369, 199065, 'GCN', 'gCn Coin (GCN)', 'gCn Coin', 1413, 'Scrypt', 'PoW', '/coins/gcn/overview', 1, 'cryptocompare'),
(1370, 199107, 'ATOM*', 'Cosmos (ATOM*)', 'Cosmos', 1414, 'PoS', 'N/A', '/coins/atomstar/overview', 1, 'cryptocompare'),
(1371, 199148, 'MANA', 'Decentraland (MANA)', 'Decentraland', 1415, 'N/A', 'N/A', '/coins/mana/overview', 1, 'cryptocompare'),
(1372, 199363, 'ICOO', 'ICO OpenLedger (ICOO)', 'ICO OpenLedger', 1416, 'N/A', 'N/A', '/coins/icoo/overview', 1, 'cryptocompare'),
(1373, 199887, 'TME', 'Timereum (TME)', 'Timereum', 1417, 'N/A', 'N/A', '/coins/tme/overview', 1, 'cryptocompare'),
(1374, 199901, 'SMART', 'SmartCash (SMART)', 'SmartCash', 1418, 'Keccak', 'PoW', '/coins/smart/overview', 1, 'cryptocompare'),
(1375, 200941, 'SIGT', 'Signatum (SIGT)', 'Signatum', 1419, 'SkunkHash v2', 'PoS', '/coins/sigt/overview', 1, 'cryptocompare'),
(1376, 201676, 'ONX', 'Onix (ONX)', 'Onix', 1420, 'X11', 'PoW', '/coins/onx/overview', 1, 'cryptocompare'),
(1377, 201701, 'COE', 'CoEval (COE)', 'CoEval', 1421, 'N/A', 'N/A', '/coins/coe/overview', 1, 'cryptocompare'),
(1378, 201896, 'ARENA', 'Arena (ARENA)', 'Arena', 1422, 'N/A', 'N/A', '/coins/arena/overview', 1, 'cryptocompare'),
(1379, 201962, 'WINK', 'Wink (WINK)', 'Wink', 1423, 'PoS', 'PoS', '/coins/wink/overview', 1, 'cryptocompare'),
(1380, 202049, 'CRM', 'Cream (CRM)', 'Cream', 1424, 'X11', 'PoW/PoS', '/coins/crm/overview', 1, 'cryptocompare'),
(1381, 202330, 'BCH', 'Bitcoin Cash (BCH)', 'Bitcoin Cash', 1425, 'SHA256', 'PoW', '/coins/bch/overview', 1, 'cryptocompare'),
(1382, 202696, 'DGPT', 'DigiPulse (DGPT)', 'DigiPulse', 1426, 'N/A', 'N/A', '/coins/dgpt/overview', 1, 'cryptocompare'),
(1383, 202706, 'MOBI', 'Mobius (MOBI)', 'Mobius', 1427, 'N/A', 'N/A', '/coins/mobi/overview', 1, 'cryptocompare'),
(1384, 202714, 'CSNO', 'BitDice (CSNO)', 'BitDice', 1428, 'N/A', 'N/A', '/coins/csno/overview', 1, 'cryptocompare'),
(1385, 202849, 'KICK', 'KickCoin (KICK)', 'KickCoin', 1429, 'N/A', 'N/A', '/coins/kick/overview', 1, 'cryptocompare'),
(1386, 203183, 'SDAO', 'Solar DAO (SDAO)', 'Solar DAO', 1430, 'N/A', 'N/A', '/coins/sdao/overview', 1, 'cryptocompare'),
(1387, 204716, 'STX', 'Stox (STX)', 'Stox', 1431, 'N/A', 'N/A', '/coins/stx/overview', 1, 'cryptocompare'),
(1388, 204788, 'BNB', 'Binance Coin (BNB)', 'Binance Coin', 1432, 'N/A', 'N/A', '/coins/bnb/overview', 1, 'cryptocompare'),
(1389, 205549, 'CORE', 'Core Group Asset (CORE)', 'Core Group Asset', 1433, 'N/A', 'N/A', '/coins/core/overview', 1, 'cryptocompare'),
(1390, 205967, 'KEN', 'Kencoin (KEN)', 'Kencoin', 1434, 'N/A', 'N/A', '/coins/ken/overview', 1, 'cryptocompare'),
(1391, 205980, 'QVT', 'Qvolta (QVT)', 'Qvolta', 1435, 'N/A', 'N/A', '/coins/qvt/overview', 1, 'cryptocompare'),
(1392, 205991, 'TIE', 'Ties Network (TIE)', 'Ties Network', 1436, 'N/A', 'N/A', '/coins/tie/overview', 1, 'cryptocompare'),
(1393, 206001, 'AUT', 'Autoria (AUT)', 'Autoria', 1437, 'N/A', 'N/A', '/coins/aut/overview', 1, 'cryptocompare'),
(1394, 206009, 'CTT', 'CodeTract (CTT)', 'CodeTract', 1438, 'N/A', 'N/A', '/coins/ctt/overview', 1, 'cryptocompare'),
(1395, 207931, 'GRWI', 'Growers International (GRWI)', 'Growers International', 1439, 'DPoS', 'N/A', '/coins/grwi/overview', 1, 'cryptocompare'),
(1396, 208001, 'MNY', 'Monkey (MNY)', 'Monkey', 1440, 'N/A', 'N/A', '/coins/mny/overview', 1, 'cryptocompare'),
(1397, 208914, 'MTH', 'Monetha (MTH)', 'Monetha', 1441, 'N/A', 'N/A', '/coins/mth/overview', 1, 'cryptocompare'),
(1398, 210595, 'CCC', 'CCCoin (CCC)', 'CCCoin', 1442, 'N/A', 'N/A', '/coins/ccc/overview', 1, 'cryptocompare'),
(1399, 213100, 'UMC', 'Umbrella Coin (UMC)', 'Umbrella Coin', 1443, 'N/A', 'N/A', '/coins/umc/overview', 1, 'cryptocompare'),
(1400, 213113, 'BMXT', 'Bitmxittz (BMXT)', 'Bitmxittz', 1444, 'Scrypt', 'PoW/PoS', '/coins/bmxt/overview', 1, 'cryptocompare'),
(1401, 213532, 'GAS', 'Gas (GAS)', 'Gas', 1445, 'N/A', 'N/A', '/coins/gas/overview', 1, 'cryptocompare'),
(1402, 213663, 'FIL', 'FileCoin (FIL)', 'FileCoin', 1446, 'N/A', 'N/A', '/coins/fil/overview', 1, 'cryptocompare'),
(1403, 214738, 'OCL', 'Oceanlab (OCL)', 'Oceanlab', 1447, 'N/A', 'DPoS/LPoS', '/coins/ocl/overview', 1, 'cryptocompare'),
(1404, 215570, 'BNC', 'Benjacoin (BNC)', 'Benjacoin', 1448, 'N/A', 'N/A', '/coins/bnc/overview', 1, 'cryptocompare'),
(1405, 215602, 'TOM', 'Tomahawkcoin (TOM)', 'Tomahawkcoin', 1449, 'N/A', 'N/A', '/coins/tom/overview', 1, 'cryptocompare'),
(1406, 218008, 'BTM*', 'Bytom (BTM*)', 'Bytom', 1450, 'N/A', 'N/A', '/coins/btmstar/overview', 1, 'cryptocompare'),
(1407, 218107, 'XAS', 'Asch (XAS)', 'Asch', 1451, 'N/A', 'N/A', '/coins/xas/overview', 1, 'cryptocompare'),
(1408, 218221, 'SMNX', 'SMNX (SMNX)', 'SMNX', 1452, 'N/A', 'N/A', '/coins/smnx/overview', 1, 'cryptocompare'),
(1409, 218906, 'DCN', 'Dentacoin (DCN)', 'Dentacoin', 1453, 'N/A', 'N/A', '/coins/dcn/overview', 1, 'cryptocompare'),
(1410, 220204, 'DLT', 'Agrello Delta (DLT)', 'Agrello Delta', 1454, 'N/A', 'N/A', '/coins/dlt/overview', 1, 'cryptocompare'),
(1411, 221349, 'MRV', 'Macroverse (MRV)', 'Macroverse', 1455, 'N/A', 'N/A', '/coins/mrv/overview', 1, 'cryptocompare'),
(1412, 221350, 'MBRS', 'Embers (MBRS)', 'Embers', 1456, 'N/A', 'N/A', '/coins/mbrs/overview', 1, 'cryptocompare'),
(1413, 221463, 'SUB', 'Substratum Network (SUB)', 'Substratum Network', 1457, 'N/A', 'N/A', '/coins/sub/overview', 1, 'cryptocompare'),
(1414, 221605, 'MET', 'Memessenger (MET)', 'Memessenger', 1458, 'N/A', 'N/A', '/coins/met/overview', 1, 'cryptocompare'),
(1415, 222085, 'NEBL', 'Neblio (NEBL)', 'Neblio', 1460, 'N/A', 'N/A', '/coins/nebl/overview', 1, 'cryptocompare'),
(1416, 222125, 'PGL', 'Prospectors (PGL)', 'Prospectors', 1461, 'N/A', 'N/A', '/coins/pgl/overview', 1, 'cryptocompare'),
(1417, 222133, 'XMCC', 'Monoeci (XMCC)', 'Monoeci', 1462, 'X11', 'PoW/PoS', '/coins/xmcc/overview', 1, 'cryptocompare'),
(1418, 222200, 'AUN', 'Authoreon (AUN)', 'Authoreon', 1463, 'N/A', 'N/A', '/coins/aun/overview', 1, 'cryptocompare'),
(1419, 222436, 'CASH*', 'Cash Poker Pro (CASH*)', 'Cash Poker Pro', 1464, 'N/A', 'N/A', '/coins/cashstar/overview', 1, 'cryptocompare'),
(1420, 228090, 'CMPCO', 'CampusCoin (CMPCO)', 'CampusCoin', 1465, 'Scrypt', 'PoW', '/coins/cmpco/overview', 1, 'cryptocompare'),
(1421, 223644, 'DTCT', 'DetectorToken (DTCT)', 'DetectorToken', 1466, 'N/A', 'N/A', '/coins/dtct/overview', 1, 'cryptocompare'),
(1422, 225277, 'CTR', 'Centra (CTR)', 'Centra', 1467, 'N/A', 'N/A', '/coins/ctr/overview', 1, 'cryptocompare'),
(1423, 206512, 'WNET', 'Wavesnode.net (WNET)', 'Wavesnode.net', 1468, 'N/A', 'N/A', '/coins/wnet/overview', 1, 'cryptocompare'),
(1424, 225764, 'PRG', 'Paragon (PRG)', 'Paragon', 1469, 'N/A', 'N/A', '/coins/prg/overview', 1, 'cryptocompare'),
(1425, 228146, 'THNX', 'ThankYou (THNX)', 'ThankYou', 1470, 'N/A', 'N/A', '/coins/thnx/overview', 1, 'cryptocompare'),
(1426, 228162, 'WORM', 'HealthyWorm (WORM)', 'HealthyWorm', 1471, 'PoS', 'PoS', '/coins/worm/overview', 1, 'cryptocompare'),
(1427, 229060, 'FUCK', 'Fuck Token (FUCK)', 'Fuck Token', 1472, 'N/A', 'N/A', '/coins/fuck/overview', 1, 'cryptocompare'),
(1428, 229307, 'VNT', 'Veredictum (VNT)', 'Veredictum', 1473, 'N/A', 'N/A', '/coins/vnt/overview', 1, 'cryptocompare'),
(1429, 229420, 'SIFT', 'Smart Investment Fund Token (SIFT)', 'Smart Investment Fund Token', 1474, 'N/A', 'N/A', '/coins/sift/overview', 1, 'cryptocompare'),
(1430, 231674, 'IGNIS', 'Ignis (IGNIS)', 'Ignis', 1475, 'N/A', 'N/A', '/coins/ignis/overview', 1, 'cryptocompare'),
(1431, 232556, 'IWT', 'IwToken (IWT)', 'IwToken', 1476, 'N/A', 'N/A', '/coins/iwt/overview', 1, 'cryptocompare'),
(1432, 232607, 'JDC', 'JustDatingSite (JDC)', 'JustDatingSite', 1477, 'N/A', 'N/A', '/coins/jdc/overview', 1, 'cryptocompare'),
(1433, 232678, 'ITT', 'Intelligent Trading (ITT)', 'Intelligent Trading', 1478, 'N/A', 'N/A', '/coins/itt/overview', 1, 'cryptocompare'),
(1434, 223246, 'LNC', 'BlockLancer (LNC)', 'BlockLancer', 1482, 'N/A', 'N/A', '/coins/lnc/overview', 1, 'cryptocompare'),
(1435, 187030, 'AIX', 'Aigang (AIX)', 'Aigang', 1483, 'N/A', 'N/A', '/coins/aix/overview', 1, 'cryptocompare'),
(1436, 194883, 'EVX', 'Everex (EVX)', 'Everex', 1484, 'N/A', 'N/A', '/coins/evx/overview', 1, 'cryptocompare'),
(1437, 206539, 'XEC', 'Eternal Coin (XEC)', 'Eternal Coin', 1486, 'N/A', 'N/A', '/coins/xec/overview', 1, 'cryptocompare'),
(1438, 207891, 'ENTRP', 'Entropy Token (ENTRP)', 'Entropy Token', 1488, 'N/A', 'N/A', '/coins/entrp/overview', 1, 'cryptocompare'),
(1439, 207775, 'ICOS', 'ICOBox (ICOS)', 'ICOBox', 1490, 'N/A', 'N/A', '/coins/icos/overview', 1, 'cryptocompare'),
(1440, 223283, 'PIX', 'Lampix (PIX)', 'Lampix', 1493, 'N/A', 'N/A', '/coins/pix/overview', 1, 'cryptocompare'),
(1441, 233044, 'MEDI', 'MediBond (MEDI)', 'MediBond', 1495, 'N/A', 'N/A', '/coins/medi/overview', 1, 'cryptocompare'),
(1442, 234508, 'HGT', 'Hello Gold (HGT)', 'Hello Gold', 1496, 'N/A', 'N/A', '/coins/hgt/overview', 1, 'cryptocompare'),
(1443, 234526, 'LTA', 'Litra (LTA)', 'Litra', 1497, 'N/A', 'N/A', '/coins/lta/overview', 1, 'cryptocompare'),
(1444, 234596, 'NIMFA', 'Nimfamoney (NIMFA)', 'Nimfamoney', 1498, 'N/A', 'N/A', '/coins/nimfa/overview', 1, 'cryptocompare'),
(1445, 234659, 'SCOR', 'Scorista (SCOR)', 'Scorista', 1499, 'N/A', 'N/A', '/coins/scor/overview', 1, 'cryptocompare'),
(1446, 234707, 'MLS', 'CPROP (MLS)', 'CPROP', 1500, 'N/A', 'N/A', '/coins/mls/overview', 1, 'cryptocompare'),
(1447, 234766, 'KEX', 'KexCoin (KEX)', 'KexCoin', 1501, 'N/A', 'N/A', '/coins/kex/overview', 1, 'cryptocompare'),
(1448, 234811, 'COB', 'Cobinhood (COB)', 'Cobinhood', 1502, 'N/A', 'N/A', '/coins/cob/overview', 1, 'cryptocompare'),
(1449, 234982, 'BRO', 'Bitradio (BRO)', 'Bitradio', 1503, 'PoS', 'PoS', '/coins/bro/overview', 1, 'cryptocompare'),
(1450, 235021, 'MINEX', 'Minex (MINEX)', 'Minex', 1504, 'N/A', 'N/A', '/coins/minex/overview', 1, 'cryptocompare'),
(1451, 235213, 'ATL', 'ATLANT (ATL)', 'ATLANT', 1505, 'N/A', 'N/A', '/coins/atl/overview', 1, 'cryptocompare'),
(1452, 235993, 'MAG*', 'Magos (MAG*)', 'Magos', 1507, 'N/A', 'N/A', '/coins/magstar/overview', 1, 'cryptocompare'),
(1453, 236039, 'DFT', 'Draftcoin (DFT)', 'Draftcoin', 1508, 'Scrypt', 'PoS', '/coins/dft/overview', 1, 'cryptocompare'),
(1454, 236131, 'VET', 'Vechain (VET)', 'Vechain', 1509, 'N/A', 'N/A', '/coins/vet/overview', 1, 'cryptocompare'),
(1455, 236358, 'UTK', 'Utrust (UTK)', 'Utrust', 1510, 'N/A', 'N/A', '/coins/utk/overview', 1, 'cryptocompare'),
(1456, 237269, 'LAT', 'Latium (LAT)', 'Latium', 1511, 'N/A', 'N/A', '/coins/lat/overview', 1, 'cryptocompare'),
(1457, 237385, 'SOJ', 'Sojourn Coin (SOJ)', 'Sojourn Coin', 1512, 'Scrypt', 'PoW', '/coins/soj/overview', 1, 'cryptocompare'),
(1458, 237407, 'HDG', 'Hedge Token (HDG)', 'Hedge Token', 1513, 'N/A', 'N/A', '/coins/hdg/overview', 1, 'cryptocompare'),
(1459, 237428, 'STCN', 'Stakecoin (STCN)', 'Stakecoin', 1514, 'PoS', 'PoS', '/coins/stcn/overview', 1, 'cryptocompare'),
(1460, 237448, 'SQP', 'SqPay (SQP)', 'SqPay', 1515, 'N/A', 'N/A', '/coins/sqp/overview', 1, 'cryptocompare'),
(1461, 238571, 'RIYA', 'Etheriya (RIYA)', 'Etheriya', 1516, 'N/A', 'N/A', '/coins/riya/overview', 1, 'cryptocompare'),
(1462, 238622, 'LNK', 'Ethereum.Link (LNK)', 'Ethereum.Link', 1517, 'N/A', 'N/A', '/coins/lnk/overview', 1, 'cryptocompare'),
(1463, 238733, 'AMB', 'Ambrosus (AMB)', 'Ambrosus', 1518, 'N/A', 'N/A', '/coins/amb/overview', 1, 'cryptocompare'),
(1464, 240142, 'WAN', 'Wanchain (WAN)', 'Wanchain', 1519, 'N/A', 'PoS', '/coins/wan/overview', 1, 'cryptocompare'),
(1465, 240322, 'MNTP', 'GoldMint (MNTP)', 'GoldMint', 1520, 'N/A', 'N/A', '/coins/mntp/overview', 1, 'cryptocompare'),
(1466, 240439, 'ALTOCAR', 'AltoCar (ALTOCAR)', 'AltoCar', 1522, 'N/A', 'N/A', '/coins/altocar/overview', 1, 'cryptocompare'),
(1467, 241536, 'CFT*', 'Credo (CFT*)', 'Credo', 1523, 'N/A', 'N/A', '/coins/cftstar/overview', 1, 'cryptocompare'),
(1468, 241634, 'BLX', 'Blockchain Index (BLX)', 'Blockchain Index', 1524, 'N/A', 'N/A', '/coins/blx/overview', 1, 'cryptocompare'),
(1469, 241757, 'BKX', 'BANKEX (BKX)', 'BANKEX', 1525, 'N/A', 'N/A', '/coins/bkx/overview', 1, 'cryptocompare'),
(1470, 241804, 'BOU', 'Boulle (BOU)', 'Boulle', 1526, 'N/A', 'N/A', '/coins/bou/overview', 1, 'cryptocompare'),
(1471, 242873, 'OXY', 'Oxycoin (OXY)', 'Oxycoin', 1527, 'DPoS', 'DPoS', '/coins/oxy/overview', 1, 'cryptocompare'),
(1472, 243013, 'TTT', 'Tap Project (TTT)', 'Tap Project', 1528, 'N/A', 'N/A', '/coins/ttt/overview', 1, 'cryptocompare'),
(1473, 243045, 'AMT', 'Acumen (AMT)', 'Acumen', 1529, 'N/A', 'N/A', '/coins/amt/overview', 1, 'cryptocompare'),
(1474, 243079, 'GIM', 'Gimli (GIM)', 'Gimli', 1530, 'N/A', 'N/A', '/coins/gim/overview', 1, 'cryptocompare'),
(1475, 247232, 'NYC', 'NewYorkCoin (NYC)', 'NewYorkCoin', 1532, 'Scrypt', 'PoW', '/coins/nyc/overview', 1, 'cryptocompare'),
(1476, 247246, 'LBTC', 'LiteBitcoin (LBTC)', 'LiteBitcoin', 1533, 'Scrypt', 'PoW', '/coins/lbtc/overview', 1, 'cryptocompare'),
(1477, 247259, 'FRAZ', 'FrazCoin (FRAZ)', 'FrazCoin', 1534, 'Scrypt', 'PoW', '/coins/fraz/overview', 1, 'cryptocompare'),
(1478, 247322, 'EMT', 'EasyMine (EMT)', 'EasyMine', 1535, 'N/A', 'N/A', '/coins/emt/overview', 1, 'cryptocompare'),
(1479, 247350, 'GXC', 'Gx Coin (GXC)', 'Gx Coin', 1536, 'N/A', 'N/A', '/coins/gxc/overview', 1, 'cryptocompare'),
(1480, 247391, 'HBT', 'Hubii Network (HBT)', 'Hubii Network', 1537, 'N/A', 'N/A', '/coins/hbt/overview', 1, 'cryptocompare'),
(1481, 247703, 'KRONE', 'Kronecoin (KRONE)', 'Kronecoin', 1538, 'Scrypt', 'PoW', '/coins/krone/overview', 1, 'cryptocompare'),
(1482, 248243, 'SRT', 'Scrypto (SRT)', 'Scrypto', 1539, 'N/A', 'N/A', '/coins/srt/overview', 1, 'cryptocompare'),
(1483, 248300, 'AVA', 'Avalon (AVA)', 'Avalon', 1540, 'N/A', 'N/A', '/coins/ava/overview', 1, 'cryptocompare'),
(1484, 249784, 'BT', 'BuildTeam (BT)', 'BuildTeam', 1541, 'N/A', 'N/A', '/coins/bt/overview', 1, 'cryptocompare'),
(1485, 249821, 'ACC', 'AdCoin (ACC)', 'AdCoin', 1542, 'Scrypt', 'PoW', '/coins/acc/overview', 1, 'cryptocompare'),
(1486, 251598, 'AR*', 'Ar.cash (AR*)', 'Ar.cash', 1543, 'SHA256', 'PoW', '/coins/arstar/overview', 1, 'cryptocompare'),
(1487, 252359, 'Z2', 'Z2 Coin (Z2)', 'Z2 Coin', 1544, 'SHA256', 'PoW', '/coins/z2/overview', 1, 'cryptocompare'),
(1488, 253667, 'LINX', 'Linx (LINX)', 'Linx', 1545, 'Scrypt', 'PoW', '/coins/linx/overview', 1, 'cryptocompare'),
(1489, 253688, 'XCXT', 'CoinonatX (XCXT)', 'CoinonatX', 1546, 'Scrypt', 'PoW/PoS', '/coins/xcxt/overview', 1, 'cryptocompare'),
(1490, 253707, 'BLAS', 'BlakeStar (BLAS)', 'BlakeStar', 1547, 'Blake2S', 'PoW/PoS', '/coins/blas/overview', 1, 'cryptocompare'),
(1491, 253766, 'GOOD', 'GoodCoin (GOOD)', 'GoodCoin', 1548, 'Scrypt', 'PoW/PoS', '/coins/good/overview', 1, 'cryptocompare'),
(1492, 255254, 'SCL', 'Sociall (SCL)', 'Sociall', 1549, 'N/A', 'N/A', '/coins/scl/overview', 1, 'cryptocompare'),
(1493, 255293, 'TRV', 'Travel Coin (TRV)', 'Travel Coin', 1550, 'N/A', 'N/A', '/coins/trv/overview', 1, 'cryptocompare'),
(1494, 255489, 'CRTM', 'Cryptum (CRTM)', 'Cryptum', 1551, 'N/A', 'Proof of Own', '/coins/crtm/overview', 1, 'cryptocompare'),
(1495, 255546, 'EON', 'Exscudo (EON)', 'Exscudo', 1552, 'N/A', 'DPoS', '/coins/eon/overview', 1, 'cryptocompare'),
(1496, 255777, 'PST', 'Primas (PST)', 'Primas', 1553, 'N/A', 'N/A', '/coins/pst/overview', 1, 'cryptocompare'),
(1497, 257110, 'MTX', 'Matryx (MTX)', 'Matryx', 1554, 'N/A', 'N/A', '/coins/mtx/overview', 1, 'cryptocompare'),
(1498, 257772, 'PRIX', 'Privatix (PRIX)', 'Privatix', 1555, 'N/A', 'N/A', '/coins/prix/overview', 1, 'cryptocompare'),
(1499, 278056, 'CTX', 'CarTaxi (CTX)', 'CarTaxi', 1556, 'N/A', 'N/A', '/coins/ctx/overview', 1, 'cryptocompare'),
(1500, 283116, 'ENJ', 'Enjin Coin (ENJ)', 'Enjin Coin', 1561, 'N/A', 'N/A', '/coins/enj/overview', 1, 'cryptocompare'),
(1501, 289715, 'CNX', 'Cryptonex (CNX)', 'Cryptonex', 1562, 'N/A', 'N/A', '/coins/cnx/overview', 1, 'cryptocompare'),
(1502, 290053, 'DRC', 'Dropcoin (DRC)', 'Dropcoin', 1563, 'N/A', 'PoS', '/coins/drc/overview', 1, 'cryptocompare'),
(1503, 292748, 'FUEL', 'Etherparty (FUEL)', 'Etherparty', 1564, 'N/A', 'N/A', '/coins/fuel/overview', 1, 'cryptocompare'),
(1504, 294364, 'ACE', 'TokenStars (ACE)', 'TokenStars', 1565, 'N/A', 'N/A', '/coins/ace/overview', 1, 'cryptocompare'),
(1505, 296844, 'WRC', 'Worldcore (WRC)', 'Worldcore', 1566, 'N/A', 'N/A', '/coins/wrc/overview', 1, 'cryptocompare'),
(1506, 299397, 'WTC', 'Waltonchain (WTC)', 'Waltonchain', 1567, 'Ethash', 'N/A', '/coins/wtc/overview', 1, 'cryptocompare'),
(1507, 299415, 'BRX', 'Breakout Stake (BRX)', 'Breakout Stake', 1568, 'N/A', 'PoW/PoS', '/coins/brx/overview', 1, 'cryptocompare'),
(1508, 299774, 'UCASH', 'U.CASH (UCASH)', 'U.CASH', 1569, 'N/A', 'N/A', '/coins/ucash/overview', 1, 'cryptocompare'),
(1509, 299811, 'WRT', 'WRTcoin (WRT)', 'WRTcoin', 1570, 'X11', 'PoW', '/coins/wrt/overview', 1, 'cryptocompare'),
(1510, 301112, 'ORME', 'Ormeus Coin (ORME)', 'Ormeus Coin', 1571, 'N/A', 'N/A', '/coins/orme/overview', 1, 'cryptocompare'),
(1511, 301119, 'DEEP', 'Deep Gold (DEEP)', 'Deep Gold', 1572, 'N/A', 'N/A', '/coins/deep/overview', 1, 'cryptocompare'),
(1512, 301150, 'TMT*', 'ToTheMoon (TMT*)', 'ToTheMoon', 1573, 'N/A', 'N/A', '/coins/tmtstar/overview', 1, 'cryptocompare'),
(1513, 301191, 'CCT', 'Crystal Clear Token  (CCT)', 'Crystal Clear Token ', 1574, 'N/A', 'N/A', '/coins/cct/overview', 1, 'cryptocompare'),
(1514, 301216, 'WSH', 'Wish Finance (WSH)', 'Wish Finance', 1575, 'N/A', 'N/A', '/coins/wsh/overview', 1, 'cryptocompare'),
(1515, 303888, 'ARNA*', 'ARNA Panacea (ARNA)', 'ARNA Panacea', 1576, 'N/A', 'N/A', '/coins/arna/overview', 1, 'cryptocompare'),
(1516, 303943, 'ABC', 'AB-Chain (ABC)', 'AB-Chain', 1577, 'N/A', 'N/A', '/coins/abc/overview', 1, 'cryptocompare'),
(1517, 304147, 'PRP', 'Papyrus (PRP)', 'Papyrus', 1578, 'N/A', 'N/A', '/coins/prp/overview', 1, 'cryptocompare'),
(1518, 304184, 'BMC', 'Blackmoon Crypto (BMC)', 'Blackmoon Crypto', 1579, 'N/A', 'N/A', '/coins/bmc/overview', 1, 'cryptocompare'),
(1519, 304605, 'SKR*', 'Skrilla Token (SKR*)', 'Skrilla Token', 1580, 'N/A', 'N/A', '/coins/skrstar/overview', 1, 'cryptocompare'),
(1520, 304693, '3DES', '3DES (3DES)', '3DES', 1581, 'N/A', 'N/A', '/coins/3des/overview', 1, 'cryptocompare'),
(1521, 304833, 'PYN', 'Paycentos (PYN)', 'Paycentos', 1582, 'N/A', 'N/A', '/coins/pyn/overview', 1, 'cryptocompare'),
(1522, 305047, 'KAPU', 'Kapu (KAPU)', 'Kapu', 1583, 'DPoS', 'DPoS', '/coins/kapu/overview', 1, 'cryptocompare'),
(1523, 305252, 'SENSE', 'Sense Token (SENSE)', 'Sense Token', 1584, 'N/A', 'N/A', '/coins/sense/overview', 1, 'cryptocompare'),
(1524, 306304, 'CAPP', 'Cappasity (CAPP)', 'Cappasity', 1585, 'N/A', 'N/A', '/coins/capp/overview', 1, 'cryptocompare'),
(1525, 306482, 'VEE', 'BLOCKv (VEE)', 'BLOCKv', 1586, 'N/A', 'N/A', '/coins/vee/overview', 1, 'cryptocompare'),
(1526, 307112, 'FC', 'Facecoin (FC)', 'Facecoin', 1587, 'N/A', 'N/A', '/coins/fc/overview', 1, 'cryptocompare'),
(1527, 307219, 'RCN', 'Ripio (RCN)', 'Ripio', 1588, 'N/A', 'PoW', '/coins/rcn/overview', 1, 'cryptocompare'),
(1528, 307406, 'NRN', 'Doc.ai Neuron (NRN)', 'Doc.ai Neuron', 1589, 'N/A', 'N/A', '/coins/nrn/overview', 1, 'cryptocompare'),
(1529, 308072, 'EVC', 'Eventchain (EVC)', 'Eventchain', 1590, 'N/A', 'N/A', '/coins/evc/overview', 1, 'cryptocompare'),
(1530, 309621, 'LINK', 'ChainLink (LINK)', 'ChainLink', 1591, 'N/A', 'N/A', '/coins/link/overview', 1, 'cryptocompare'),
(1531, 310052, 'WIZ', 'Crowdwiz (WIZ)', 'Crowdwiz', 1592, 'N/A', 'PoS', '/coins/wiz/overview', 1, 'cryptocompare'),
(1532, 310297, 'EDO', 'Eidoo (EDO)', 'Eidoo', 1593, 'N/A', 'N/A', '/coins/edo/overview', 1, 'cryptocompare'),
(1533, 310392, 'ATKN', 'A-Token (ATKN)', 'A-Token', 1594, 'N/A', 'N/A', '/coins/atkn/overview', 1, 'cryptocompare'),
(1534, 310497, 'KNC', 'Kyber Network (KNC)', 'Kyber Network', 1595, 'N/A', 'N/A', '/coins/knc/overview', 1, 'cryptocompare'),
(1535, 310553, 'RUSTBITS', 'Rustbits (RUSTBITS)', 'Rustbits', 1596, 'N/A', 'N/A', '/coins/rustbits/overview', 1, 'cryptocompare'),
(1536, 310589, 'REX', 'Imbrex (REX)', 'Imbrex', 1597, 'N/A', 'N/A', '/coins/rex/overview', 1, 'cryptocompare'),
(1537, 310754, 'ETHD', 'Ethereum Dark (ETHD)', 'Ethereum Dark', 1598, 'Scrypt', 'PoW/PoS', '/coins/ethd/overview', 1, 'cryptocompare'),
(1538, 310812, 'SUMO', 'Sumokoin (SUMO)', 'Sumokoin', 1599, 'CryptoNight', 'PoW', '/coins/sumo/overview', 1, 'cryptocompare'),
(1539, 310829, 'TRX', 'Tronix (TRX)', 'Tronix', 1600, 'N/A', 'N/A', '/coins/trx/overview', 1, 'cryptocompare'),
(1540, 310867, 'H2O', 'Hydrominer (H2O)', 'Hydrominer', 1602, 'N/A', 'N/A', '/coins/h2o/overview', 1, 'cryptocompare'),
(1541, 311176, 'TKT', 'Crypto Tickets (TKT)', 'Crypto Tickets', 1603, 'N/A', 'N/A', '/coins/tkt/overview', 1, 'cryptocompare'),
(1542, 311516, 'RHEA', 'Rhea (RHEA)', 'Rhea', 1604, 'N/A', 'N/A', '/coins/rhea/overview', 1, 'cryptocompare'),
(1543, 311558, 'ART', 'Maecenas (ART)', 'Maecenas', 1605, 'N/A', 'N/A', '/coins/art/overview', 1, 'cryptocompare'),
(1544, 311829, 'DRT', 'DomRaider (DRT)', 'DomRaider', 1606, 'N/A', 'N/A', '/coins/drt/overview', 1, 'cryptocompare'),
(1545, 311853, 'SNOV', 'Snovio (SNOV)', 'Snovio', 1607, 'N/A', 'N/A', '/coins/snov/overview', 1, 'cryptocompare'),
(1546, 313176, 'DREAM', 'DreamTeam Token (DREAM)', 'DreamTeam Token', 1608, 'N/A', 'N/A', '/coins/dream/overview', 1, 'cryptocompare'),
(1547, 313967, 'MTN', 'TrackNetToken (MTN)', 'TrackNetToken', 1609, 'N/A', 'N/A', '/coins/mtn/overview', 1, 'cryptocompare'),
(1548, 313988, 'STOCKBET', 'StockBet (STOCKBET)', 'StockBet', 1610, 'N/A', 'N/A', '/coins/stockbet/overview', 1, 'cryptocompare'),
(1549, 314331, 'PLM', 'Algo.Land (PLM)', 'Algo.Land', 1611, 'N/A', 'PoS', '/coins/plm/overview', 1, 'cryptocompare'),
(1550, 314580, 'SALT', 'Salt Lending (SALT)', 'Salt Lending', 1613, 'N/A', 'N/A', '/coins/salt/overview', 1, 'cryptocompare'),
(1551, 314865, 'SND', 'Sandcoin (SND)', 'Sandcoin', 1614, 'N/A', 'N/A', '/coins/snd/overview', 1, 'cryptocompare'),
(1552, 318154, 'XP', 'Experience Points (XP)', 'Experience Points', 1616, 'SHA256', 'PoW/PoS', '/coins/xp/overview', 1, 'cryptocompare'),
(1553, 318169, 'LRC', 'Loopring (LRC)', 'Loopring', 1617, 'N/A', 'N/A', '/coins/lrc/overview', 1, 'cryptocompare'),
(1554, 318199, 'HSR', 'Hshare (HSR)', 'Hshare', 1618, 'N/A', 'PoW/PoS', '/coins/hsr/overview', 1, 'cryptocompare'),
(1555, 318704, 'GLA', 'Gladius (GLA)', 'Gladius', 1619, 'N/A', 'N/A', '/coins/gla/overview', 1, 'cryptocompare'),
(1556, 318794, 'ZNA', 'Zenome (ZNA)', 'Zenome', 1620, 'N/A', 'N/A', '/coins/zna/overview', 1, 'cryptocompare'),
(1557, 319029, 'EZM', 'EZMarket (EZM)', 'EZMarket', 1621, 'N/A', 'N/A', '/coins/ezm/overview', 1, 'cryptocompare'),
(1558, 319075, 'ODN', 'Obsidian (ODN)', 'Obsidian', 1622, 'SHA-512', 'PoS', '/coins/odn/overview', 1, 'cryptocompare'),
(1559, 319130, 'POLL', 'ClearPoll (POLL)', 'ClearPoll', 1623, 'N/A', 'N/A', '/coins/poll/overview', 1, 'cryptocompare'),
(1560, 319238, 'MTK', 'Moya Token (MTK)', 'Moya Token', 1624, 'N/A', 'N/A', '/coins/mtk/overview', 1, 'cryptocompare'),
(1561, 319254, 'CAS', 'Cashaa (CAS)', 'Cashaa', 1625, 'N/A', 'N/A', '/coins/cas/overview', 1, 'cryptocompare'),
(1562, 320036, 'MAT', 'MiniApps (MAT)', 'MiniApps', 1626, 'N/A', 'PoW', '/coins/mat/overview', 1, 'cryptocompare'),
(1563, 320412, 'GJC', 'Global Jobcoin (GJC)', 'Global Jobcoin', 1628, 'N/A', 'N/A', '/coins/gjc/overview', 1, 'cryptocompare'),
(1564, 320551, 'WIC', 'Wi Coin (WIC)', 'Wi Coin', 1629, 'N/A', 'N/A', '/coins/wic/overview', 1, 'cryptocompare'),
(1565, 320596, 'WEB', 'Webcoin (WEB)', 'Webcoin', 1630, 'N/A', 'N/A', '/coins/web/overview', 1, 'cryptocompare'),
(1566, 320621, 'WAND', 'WandX (WAND)', 'WandX', 1631, 'N/A', 'N/A', '/coins/wand/overview', 1, 'cryptocompare'),
(1567, 321177, 'ELIX', 'Elixir (ELIX)', 'Elixir', 1632, 'N/A', 'N/A', '/coins/elix/overview', 1, 'cryptocompare'),
(1568, 321189, 'EBTC', 'eBitcoin (EBTC)', 'eBitcoin', 1633, 'N/A', 'N/A', '/coins/ebtc/overview', 1, 'cryptocompare'),
(1569, 321347, 'HAC', 'Hackspace Capital (HAC)', 'Hackspace Capital', 1634, 'N/A', 'N/A', '/coins/hac/overview', 1, 'cryptocompare'),
(1570, 321992, 'ADA', 'Cardano (ADA)', 'Cardano', 1635, 'Ouroboros', 'PoS', '/coins/ada/overview', 1, 'cryptocompare'),
(1571, 322002, 'YOYOW', 'Yoyow (YOYOW)', 'Yoyow', 1636, 'N/A', 'N/A', '/coins/yoyow/overview', 1, 'cryptocompare'),
(1572, 322013, 'REC', 'Regalcoin (REC)', 'Regalcoin', 1637, 'X11', 'PoW/PoS', '/coins/rec/overview', 1, 'cryptocompare'),
(1573, 322963, 'BIS', 'Bismuth (BIS)', 'Bismuth', 1638, 'N/A', 'PoW', '/coins/bis/overview', 1, 'cryptocompare'),
(1574, 323787, 'OPP', 'Opporty (OPP)', 'Opporty', 1639, 'N/A', 'N/A', '/coins/opp/overview', 1, 'cryptocompare'),
(1575, 323817, 'ROCK2', 'Ice Rock Mining (ROCK2)', 'Ice Rock Mining', 1640, 'N/A', 'N/A', '/coins/rock2/overview', 1, 'cryptocompare'),
(1576, 324012, 'EARTH', 'Earth Token (EARTH)', 'Earth Token', 1641, 'N/A', 'N/A', '/coins/earth/overview', 1, 'cryptocompare'),
(1577, 324068, 'ICX', 'ICON Project (ICX)', 'ICON Project', 1642, 'N/A', 'LFT', '/coins/icx/overview', 1, 'cryptocompare'),
(1578, 325279, 'VSX', 'Vsync (VSX)', 'Vsync', 1643, 'X13', 'PoW/PoS', '/coins/vsx/overview', 1, 'cryptocompare'),
(1579, 326082, 'WISH*', 'WishFinance (WISH*)', 'WishFinance', 1644, 'N/A', 'N/A', '/coins/wishstar/overview', 1, 'cryptocompare'),
(1580, 326222, 'FLASH', 'FLASH coin (FLASH)', 'FLASH coin', 1645, 'N/A', 'N/A', '/coins/flash/overview', 1, 'cryptocompare'),
(1581, 326286, 'GRFT', 'Graft Blockchain (GRFT)', 'Graft Blockchain', 1646, 'CryptoNight', 'PoW/PoS', '/coins/grft/overview', 1, 'cryptocompare'),
(1582, 327184, 'BTCZ', 'BitcoinZ (BTCZ)', 'BitcoinZ', 1647, 'Equihash', 'PoW', '/coins/btcz/overview', 1, 'cryptocompare'),
(1583, 327250, 'CZC', 'Crazy Coin (CZC)', 'Crazy Coin', 1648, 'N/A', 'N/A', '/coins/czc/overview', 1, 'cryptocompare'),
(1584, 327500, 'PPP', 'PayPie (PPP)', 'PayPie', 1649, 'N/A', 'N/A', '/coins/ppp/overview', 1, 'cryptocompare'),
(1585, 327608, 'GUESS', 'Peerguess (GUESS)', 'Peerguess', 1650, 'N/A', 'N/A', '/coins/guess/overview', 1, 'cryptocompare'),
(1586, 327632, 'CAN', 'CanYaCoin (CAN)', 'CanYaCoin', 1651, 'N/A', 'N/A', '/coins/can/overview', 1, 'cryptocompare'),
(1587, 328639, 'ETP', 'Metaverse (ETP)', 'Metaverse', 1652, 'Ethash', 'N/A', '/coins/etp/overview', 1, 'cryptocompare'),
(1588, 328667, 'CIX', 'Cryptonetix (CIX)', 'Cryptonetix', 1653, 'N/A', 'N/A', '/coins/cix/overview', 1, 'cryptocompare'),
(1589, 328784, 'ERT', 'Esports.com (ERT)', 'Esports.com', 1654, 'N/A', 'N/A', '/coins/ert/overview', 1, 'cryptocompare'),
(1590, 329507, 'BAC*', 'LakeBanker (BAC*)', 'LakeBanker', 1655, 'N/A', 'N/A', '/coins/bacstar/overview', 1, 'cryptocompare'),
(1591, 329562, 'FLIK', 'FLiK (FLIK)', 'FLiK', 1656, 'N/A', 'N/A', '/coins/flik/overview', 1, 'cryptocompare'),
(1592, 329767, 'TRIP', 'Trippki (TRIP)', 'Trippki', 1657, 'N/A', 'N/A', '/coins/trip/overview', 1, 'cryptocompare'),
(1593, 330003, 'MBT', 'Multibot (MBT)', 'Multibot', 1658, 'N/A', 'N/A', '/coins/mbt/overview', 1, 'cryptocompare'),
(1594, 331207, 'JVY', 'Javvy (JVY)', 'Javvy', 1659, 'N/A', 'N/A', '/coins/jvy/overview', 1, 'cryptocompare'),
(1595, 331603, 'ALIS', 'ALISmedia (ALIS)', 'ALISmedia', 1660, 'N/A', 'N/A', '/coins/alis/overview', 1, 'cryptocompare'),
(1596, 332804, 'LEV', 'Leverj (LEV)', 'Leverj', 1661, 'N/A', 'N/A', '/coins/lev/overview', 1, 'cryptocompare'),
(1597, 334856, 'ARBI', 'Arbi (ARBI)', 'Arbi', 1663, 'Ethash', 'N/A', '/coins/arbi/overview', 1, 'cryptocompare'),
(1598, 334997, 'ELT', 'Eloplay (ELT)', 'Eloplay', 1664, 'N/A', 'N/A', '/coins/elt/overview', 1, 'cryptocompare'),
(1599, 335059, 'REQ', 'Request Network (REQ)', 'Request Network', 1665, 'N/A', 'N/A', '/coins/req/overview', 1, 'cryptocompare'),
(1600, 335127, 'ARN', 'Aeron (ARN)', 'Aeron', 1666, 'N/A', 'N/A', '/coins/arn/overview', 1, 'cryptocompare'),
(1601, 335505, 'DAT', 'Datum (DAT)', 'Datum', 1667, 'N/A', 'N/A', '/coins/dat/overview', 1, 'cryptocompare'),
(1602, 336538, 'VIBE', 'VIBEHub (VIBE)', 'VIBEHub', 1668, 'N/A', 'N/A', '/coins/vibe/overview', 1, 'cryptocompare'),
(1603, 336556, 'ROK', 'Rockchain (ROK)', 'Rockchain', 1669, 'N/A', 'N/A', '/coins/rok/overview', 1, 'cryptocompare'),
(1604, 336594, 'XRED', 'X Real Estate Development (XRED)', 'X Real Estate Development', 1670, 'N/A', 'N/A', '/coins/xred/overview', 1, 'cryptocompare'),
(1605, 336705, 'DAY', 'Chronologic (DAY)', 'Chronologic', 1671, 'N/A', 'N/A', '/coins/day/overview', 1, 'cryptocompare'),
(1606, 337162, 'AST', 'AirSwap (AST)', 'AirSwap', 1673, 'N/A', 'N/A', '/coins/ast/overview', 1, 'cryptocompare'),
(1607, 337863, 'FLP', 'Gameflip (FLP)', 'Gameflip', 1674, 'N/A', 'N/A', '/coins/flp/overview', 1, 'cryptocompare'),
(1608, 338018, 'HXT', 'HextraCoin (HXT)', 'HextraCoin', 1675, 'Scrypt', 'N/A', '/coins/hxt/overview', 1, 'cryptocompare'),
(1609, 338070, 'CND', 'Cindicator (CND)', 'Cindicator', 1676, 'N/A', 'N/A', '/coins/cnd/overview', 1, 'cryptocompare'),
(1610, 338140, 'VRP*', 'Prosense.tv (VRP)', 'Prosense.tv', 1677, 'N/A', 'N/A', '/coins/vrp/overview', 1, 'cryptocompare'),
(1611, 338156, 'NTM', 'NetM (NTM)', 'NetM', 1678, 'Scrypt', 'PoW', '/coins/ntm/overview', 1, 'cryptocompare'),
(1612, 338180, 'TZC', 'TrezarCoin (TZC)', 'TrezarCoin', 1679, 'NeoScrypt', 'PoW/PoS', '/coins/tzc/overview', 1, 'cryptocompare'),
(1613, 338335, 'ENG', 'Enigma (ENG)', 'Enigma', 1680, 'N/A', 'N/A', '/coins/eng/overview', 1, 'cryptocompare'),
(1614, 338415, 'MCI', 'Musiconomi (MCI)', 'Musiconomi', 1681, 'N/A', 'N/A', '/coins/mci/overview', 1, 'cryptocompare'),
(1615, 338426, 'COV', 'Covesting (COV)', 'Covesting', 1682, 'N/A', 'N/A', '/coins/cov/overview', 1, 'cryptocompare'),
(1616, 338541, 'WAX', 'Worldwide Asset eXchange (WAX)', 'Worldwide Asset eXchange', 1683, 'N/A', 'N/A', '/coins/wax/overview', 1, 'cryptocompare'),
(1617, 338555, 'AIR', 'AirToken (AIR)', 'AirToken', 1684, 'N/A', 'N/A', '/coins/air/overview', 1, 'cryptocompare'),
(1618, 339406, 'NTO', 'Fujinto (NTO)', 'Fujinto', 1685, 'N/A', 'N/A', '/coins/nto/overview', 1, 'cryptocompare'),
(1619, 339419, 'ATCC', 'ATC Coin (ATCC)', 'ATC Coin', 1686, 'Scrypt', 'PoW', '/coins/atcc/overview', 1, 'cryptocompare'),
(1620, 339431, 'KOLION', 'Kolion (KOLION)', 'Kolion', 1687, 'N/A', 'N/A', '/coins/kolion/overview', 1, 'cryptocompare'),
(1621, 339533, 'WILD', 'Wild Crypto (WILD)', 'Wild Crypto', 1688, 'N/A', 'N/A', '/coins/wild/overview', 1, 'cryptocompare'),
(1622, 339581, 'ELTC2', 'eLTC (ELTC2)', 'eLTC', 1689, 'N/A', 'N/A', '/coins/eltc2/overview', 1, 'cryptocompare'),
(1623, 339598, 'ILCT', 'ILCoin Token (ILCT)', 'ILCoin Token', 1690, 'SHA256', 'PoW', '/coins/ilct/overview', 1, 'cryptocompare'),
(1624, 339617, 'POWR', 'Power Ledger (POWR)', 'Power Ledger', 1691, 'N/A', 'N/A', '/coins/powr/overview', 1, 'cryptocompare'),
(1625, 339632, 'C20', 'Crypto20 (C20)', 'Crypto20', 1692, 'N/A', 'N/A', '/coins/c20/overview', 1, 'cryptocompare'),
(1626, 339804, 'RYZ', 'Anryze (RYZ)', 'Anryze', 1693, 'N/A', 'N/A', '/coins/ryz/overview', 1, 'cryptocompare'),
(1627, 339847, 'GXC*', 'GenXCoin (GXC*)', 'GenXCoin', 1694, 'X15', 'PoW/PoS', '/coins/gxcstar/overview', 1, 'cryptocompare'),
(1628, 339933, 'ELM', 'Elements (ELM)', 'Elements', 1696, 'X11', 'PoW', '/coins/elm/overview', 1, 'cryptocompare'),
(1629, 340067, 'TER', 'TerraNovaCoin (TER)', 'TerraNovaCoin', 1697, 'Scrypt', 'PoW/PoS', '/coins/ter/overview', 1, 'cryptocompare'),
(1630, 340112, 'XCS', 'CybCSec Coin (XCS)', 'CybCSec Coin', 1698, 'POS 3.0', 'PoS', '/coins/xcs/overview', 1, 'cryptocompare'),
(1631, 340125, 'BQ', 'Bitqy (BQ)', 'Bitqy', 1699, 'N/A', 'N/A', '/coins/bq/overview', 1, 'cryptocompare'),
(1632, 340776, 'CAV', 'Caviar (CAV)', 'Caviar', 1700, 'N/A', 'N/A', '/coins/cav/overview', 1, 'cryptocompare'),
(1633, 340816, 'CLOUT', 'Clout (CLOUT)', 'Clout', 1701, 'N/A', 'N/A', '/coins/clout/overview', 1, 'cryptocompare'),
(1634, 340872, 'PTC*', 'Propthereum (PTC*)', 'Propthereum', 1702, 'N/A', 'N/A', '/coins/ptcstar/overview', 1, 'cryptocompare'),
(1635, 340940, 'WABI', 'WaBi (WABI)', 'WaBi', 1703, 'N/A', 'N/A', '/coins/wabi/overview', 1, 'cryptocompare'),
(1636, 340966, 'EVR', 'Everus (EVR)', 'Everus', 1704, 'N/A', 'N/A', '/coins/evr/overview', 1, 'cryptocompare'),
(1637, 341019, 'TOA', 'TOA Coin (TOA)', 'TOA Coin', 1705, 'Scrypt', 'PoW/PoS', '/coins/toa/overview', 1, 'cryptocompare'),
(1638, 341059, 'MNZ', 'Monaize (MNZ)', 'Monaize', 1706, 'Equihash', 'PoW/DPoW', '/coins/mnz/overview', 1, 'cryptocompare'),
(1639, 341205, 'VIVO', 'VIVO Coin (VIVO)', 'VIVO Coin', 1707, 'NeoScrypt', 'PoW', '/coins/vivo/overview', 1, 'cryptocompare'),
(1640, 341267, 'PHX', 'Red Pulse Phoenix (PHX)', 'Red Pulse Phoenix', 1708, 'N/A', 'N/A', '/coins/phx/overview', 1, 'cryptocompare'),
(1641, 341279, 'MDA', 'Moeda (MDA)', 'Moeda', 1709, 'N/A', 'N/A', '/coins/mda/overview', 1, 'cryptocompare'),
(1642, 341328, 'ZSC', 'Zeusshield (ZSC)', 'Zeusshield', 1710, 'N/A', 'N/A', '/coins/zsc/overview', 1, 'cryptocompare'),
(1643, 341400, 'AURS', 'Aureus (AURS)', 'Aureus', 1711, 'Scrypt', 'N/A', '/coins/aurs/overview', 1, 'cryptocompare'),
(1644, 341422, 'CAG', 'Change (CAG)', 'Change', 1712, 'N/A', 'N/A', '/coins/cag/overview', 1, 'cryptocompare'),
(1645, 344086, 'PKT', 'Playkey (PKT)', 'Playkey', 1713, 'N/A', 'N/A', '/coins/pkt/overview', 1, 'cryptocompare'),
(1646, 344097, 'SMT**', 'Social Media Market (SMT)', 'Social Media Market', 1714, 'N/A', 'N/A', '/coins/smt/overview', 1, 'cryptocompare'),
(1647, 344337, 'ECHT', 'e-Chat (ECHT)', 'e-Chat', 1715, 'N/A', 'N/A', '/coins/echt/overview', 1, 'cryptocompare'),
(1648, 344988, 'INXT', 'Internxt (INXT)', 'Internxt', 1716, 'N/A', 'N/A', '/coins/inxt/overview', 1, 'cryptocompare'),
(1649, 345017, 'ATS', 'Authorship (ATS)', 'Authorship', 1717, 'N/A', 'N/A', '/coins/ats/overview', 1, 'cryptocompare'),
(1650, 345065, 'RGC', 'RG Coin (RGC)', 'RG Coin', 1718, 'NIST5', 'PoW/PoS', '/coins/rgc/overview', 1, 'cryptocompare'),
(1651, 345159, 'EBET', 'EthBet (EBET)', 'EthBet', 1719, 'N/A', 'N/A', '/coins/ebet/overview', 1, 'cryptocompare'),
(1652, 345420, 'R', 'Revain (R)', 'Revain', 1720, 'N/A', 'N/A', '/coins/r/overview', 1, 'cryptocompare'),
(1653, 345510, 'MOD', 'Modum (MOD)', 'Modum', 1721, 'N/A', 'N/A', '/coins/mod/overview', 1, 'cryptocompare'),
(1654, 345544, 'BM*', 'Bitcomo (BM*)', 'Bitcomo', 1722, 'N/A', 'N/A', '/coins/bmstar/overview', 1, 'cryptocompare'),
(1655, 345674, 'CPAY', 'CryptoPay (CPAY)', 'CryptoPay', 1723, 'N/A', 'N/A', '/coins/cpay/overview', 1, 'cryptocompare'),
(1656, 345801, 'RUP', 'Rupee (RUP)', 'Rupee', 1724, 'Lyra2REv2', 'PoS', '/coins/rup/overview', 1, 'cryptocompare'),
(1657, 346775, 'BON*', 'Bonpay (BON)', 'Bonpay', 1725, 'N/A', 'N/A', '/coins/bon/overview', 1, 'cryptocompare'),
(1658, 346812, 'APPC', 'AppCoins (APPC)', 'AppCoins', 1726, 'N/A', 'N/A', '/coins/appc/overview', 1, 'cryptocompare'),
(1659, 347067, 'WHL', 'WhaleCoin (WHL)', 'WhaleCoin', 1727, 'Ethash', 'PoW', '/coins/whl/overview', 1, 'cryptocompare'),
(1660, 347235, 'BTG', 'Bitcoin Gold (BTG)', 'Bitcoin Gold', 1729, 'Equihash', 'PoW', '/coins/btg/overview', 1, 'cryptocompare'),
(1661, 347247, 'UP', 'UpToken (UP)', 'UpToken', 1730, 'N/A', 'N/A', '/coins/up/overview', 1, 'cryptocompare'),
(1662, 347450, 'ETG', 'Ethereum Gold (ETG)', 'Ethereum Gold', 1731, 'N/A', 'N/A', '/coins/etg/overview', 1, 'cryptocompare'),
(1663, 348068, 'WOMEN', 'WomenCoin (WOMEN)', 'WomenCoin', 1732, 'Scrypt', 'PoW/PoS', '/coins/women/overview', 1, 'cryptocompare'),
(1664, 348094, 'MAY', 'Theresa May Coin (MAY)', 'Theresa May Coin', 1733, 'SHA256', 'PoW/PoS', '/coins/may/overview', 1, 'cryptocompare'),
(1665, 348131, 'RNDR', 'Render Token (RNDR)', 'Render Token', 1734, 'N/A', 'N/A', '/coins/rndr/overview', 1, 'cryptocompare'),
(1666, 348256, 'EDDIE', 'Eddie coin (EDDIE)', 'Eddie coin', 1735, 'Scrypt', 'PoW/PoS', '/coins/eddie/overview', 1, 'cryptocompare'),
(1667, 348278, 'SCT*', 'Soma (SCT*)', 'Soma', 1736, 'N/A', 'N/A', '/coins/sctstar/overview', 1, 'cryptocompare'),
(1668, 348289, 'NAMO', 'NamoCoin (NAMO)', 'NamoCoin', 1737, 'NIST5', 'PoW/PoS', '/coins/namo/overview', 1, 'cryptocompare'),
(1669, 348628, 'KCS', 'Kucoin (KCS)', 'Kucoin', 1738, 'N/A', 'N/A', '/coins/kcs/overview', 1, 'cryptocompare'),
(1670, 349487, 'GAT', 'GATCOIN (GAT)', 'GATCOIN', 1739, 'N/A', 'N/A', '/coins/gat/overview', 1, 'cryptocompare'),
(1671, 350048, 'BLUE', 'Ethereum Blue (BLUE)', 'Ethereum Blue', 1740, 'N/A', 'N/A', '/coins/blue/overview', 1, 'cryptocompare'),
(1672, 350394, 'FLLW', 'Follow Coin (FLLW)', 'Follow Coin', 1742, 'N/A', 'N/A', '/coins/fllw/overview', 1, 'cryptocompare'),
(1673, 350395, 'WYR', 'Wyrify (WYR)', 'Wyrify', 1743, 'N/A', 'N/A', '/coins/wyr/overview', 1, 'cryptocompare'),
(1674, 350476, 'VZT', 'Vezt (VZT)', 'Vezt', 1744, 'N/A', 'PoW', '/coins/vzt/overview', 1, 'cryptocompare'),
(1675, 351078, 'INDI', 'IndiCoin (INDI)', 'IndiCoin', 1745, 'N/A', 'PoW', '/coins/indi/overview', 1, 'cryptocompare'),
(1676, 351720, 'LUX', 'LUXCoin (LUX)', 'LUXCoin', 1748, 'PHI1612', 'PoW/PoS', '/coins/lux/overview', 1, 'cryptocompare'),
(1677, 354771, 'BAR', 'TBIS token (BAR)', 'TBIS token', 1749, 'N/A', 'N/A', '/coins/bar/overview', 1, 'cryptocompare'),
(1678, 355019, 'PIRL', 'Pirl (PIRL)', 'Pirl', 1750, 'Dagger', 'PoW', '/coins/pirl/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(1679, 355117, 'ECASH', 'Ethereum Cash (ECASH)', 'Ethereum Cash', 1751, 'N/A', 'N/A', '/coins/ecash/overview', 1, 'cryptocompare'),
(1680, 355242, 'WPR', 'WePower (WPR)', 'WePower', 1752, 'N/A', 'N/A', '/coins/wpr/overview', 1, 'cryptocompare'),
(1681, 355702, 'DRGN', 'Dragonchain (DRGN)', 'Dragonchain', 1753, 'N/A', 'N/A', '/coins/drgn/overview', 1, 'cryptocompare'),
(1682, 357404, 'ODMC', 'ODMCoin (ODMC)', 'ODMCoin', 1754, 'N/A', 'N/A', '/coins/odmc/overview', 1, 'cryptocompare'),
(1683, 357413, 'CABS*', 'CyberTrust (CABS*)', 'CyberTrust', 1755, 'N/A', 'N/A', '/coins/cabsstar/overview', 1, 'cryptocompare'),
(1684, 357734, 'BRAT', 'BROTHER (BRAT)', 'BROTHER', 1756, 'N/A', 'N/A', '/coins/brat/overview', 1, 'cryptocompare'),
(1685, 360063, 'DTR', 'Dynamic Trading Rights (DTR)', 'Dynamic Trading Rights', 1757, 'N/A', 'N/A', '/coins/dtr/overview', 1, 'cryptocompare'),
(1686, 360229, 'TKR', 'CryptoInsight (TKR)', 'CryptoInsight', 1758, 'N/A', 'N/A', '/coins/tkr/overview', 1, 'cryptocompare'),
(1687, 360299, 'KEY', 'SelfKey (KEY)', 'SelfKey', 1759, 'N/A', 'N/A', '/coins/key/overview', 1, 'cryptocompare'),
(1688, 360657, 'ELITE', 'EthereumLite (ELITE)', 'EthereumLite', 1760, 'N/A', 'N/A', '/coins/elite/overview', 1, 'cryptocompare'),
(1689, 360740, 'XIOS', 'Xios (XIOS)', 'Xios', 1761, 'Scrypt', 'PoW/PoS', '/coins/xios/overview', 1, 'cryptocompare'),
(1690, 360827, 'DOV', 'DOVU (DOV)', 'DOVU', 1762, 'N/A', 'N/A', '/coins/dov/overview', 1, 'cryptocompare'),
(1691, 361881, 'ETN', 'Electroneum (ETN)', 'Electroneum', 1763, 'N/A', 'PoW', '/coins/etn/overview', 1, 'cryptocompare'),
(1692, 362039, 'REA', 'Realisto (REA)', 'Realisto', 1764, 'N/A', 'N/A', '/coins/rea/overview', 1, 'cryptocompare'),
(1693, 362627, 'AVE', 'Avesta (AVE)', 'Avesta', 1765, 'Avesta hash', 'PoW', '/coins/ave/overview', 1, 'cryptocompare'),
(1694, 362769, 'XNN', 'Xenon (XNN)', 'Xenon', 1766, 'N/A', 'N/A', '/coins/xnn/overview', 1, 'cryptocompare'),
(1695, 362846, 'BTDX', 'Bitcloud 2.0 (BTDX)', 'Bitcloud 2.0', 1767, 'Quark', 'PoW/PoS', '/coins/btdx/overview', 1, 'cryptocompare'),
(1696, 363006, 'LOAN*', 'Lendoit (LOAN)', 'Lendoit', 1768, 'N/A', 'N/A', '/coins/loan/overview', 1, 'cryptocompare'),
(1697, 363066, 'DTT*', 'Data Trading (DTT*)', 'Data Trading', 1769, 'N/A', 'N/A', '/coins/dttstar/overview', 1, 'cryptocompare'),
(1698, 363992, 'ZAB', 'ZABERcoin (ZAB)', 'ZABERcoin', 1770, 'N/A', 'N/A', '/coins/zab/overview', 1, 'cryptocompare'),
(1699, 364051, 'MDL*', 'Modulum (MDL*)', 'Modulum', 1771, 'N/A', 'N/A', '/coins/mdlstar/overview', 1, 'cryptocompare'),
(1700, 364317, 'BT1', 'Bitfinex Bitcoin Future (BT1)', 'Bitfinex Bitcoin Future', 1772, 'N/A', 'N/A', '/coins/bt1/overview', 1, 'cryptocompare'),
(1701, 364348, 'BT2', 'Bitcoin SegWit2X (BT2)', 'Bitcoin SegWit2X', 1773, 'N/A', 'N/A', '/coins/bt2/overview', 1, 'cryptocompare'),
(1702, 364472, 'SHP*', 'Sharpe Capital (SHP*)', 'Sharpe Capital', 1774, 'N/A', 'N/A', '/coins/shpstar/overview', 1, 'cryptocompare'),
(1703, 364747, 'JCR', 'Jincor (JCR)', 'Jincor', 1775, 'N/A', 'N/A', '/coins/jcr/overview', 1, 'cryptocompare'),
(1704, 364846, 'XSB', 'Extreme Sportsbook (XSB)', 'Extreme Sportsbook', 1776, 'X11', 'PoS', '/coins/xsb/overview', 1, 'cryptocompare'),
(1705, 368694, 'ATM', 'ATMChain (ATM)', 'ATMChain', 1777, 'N/A', 'N/A', '/coins/atm/overview', 1, 'cryptocompare'),
(1706, 368732, 'EBST', 'eBoost (EBST)', 'eBoost', 1778, 'Scrypt', 'PoW', '/coins/ebst/overview', 1, 'cryptocompare'),
(1707, 368743, 'KEK', 'KekCoin (KEK)', 'KekCoin', 1779, 'POS 2.0', 'PoS', '/coins/kek/overview', 1, 'cryptocompare'),
(1708, 368770, 'AID', 'AidCoin (AID)', 'AidCoin', 1780, 'N/A', 'N/A', '/coins/aid/overview', 1, 'cryptocompare'),
(1709, 369029, 'BHC*', 'BlackholeCoin (BHC*)', 'BlackholeCoin', 1781, 'Scrypt', 'PoW/PoS', '/coins/bhcstar/overview', 1, 'cryptocompare'),
(1710, 369110, 'ALTCOM', 'AltCommunity Coin (ALTCOM)', 'AltCommunity Coin', 1782, 'SkunkHash', 'PoW/PoS', '/coins/altcom/overview', 1, 'cryptocompare'),
(1711, 369132, 'OST', 'Simple Token (OST)', 'Simple Token', 1783, 'N/A', 'N/A', '/coins/ost/overview', 1, 'cryptocompare'),
(1712, 369151, 'DATA', 'Streamr DATAcoin (DATA)', 'Streamr DATAcoin', 1784, 'N/A', 'N/A', '/coins/data/overview', 1, 'cryptocompare'),
(1713, 369179, 'UGC', 'ugChain (UGC)', 'ugChain', 1785, 'N/A', 'N/A', '/coins/ugc/overview', 1, 'cryptocompare'),
(1714, 369209, 'DTC', 'Datacoin (DTC*)', 'Datacoin', 1786, 'Multiple', 'PoW', '/coins/dtcstar/overview', 1, 'cryptocompare'),
(1715, 369251, 'PLAY', 'HEROcoin (PLAY)', 'HEROcoin', 1787, 'N/A', 'N/A', '/coins/play/overview', 1, 'cryptocompare'),
(1716, 370535, 'PURE', 'Pure (PURE)', 'Pure', 1788, 'X11', 'PoW/PoS', '/coins/pure/overview', 1, 'cryptocompare'),
(1717, 370606, 'CLD', 'Cloud (CLD)', 'Cloud', 1789, 'N/A', 'N/A', '/coins/cld/overview', 1, 'cryptocompare'),
(1718, 370726, 'OTN', 'Open Trading Network (OTN)', 'Open Trading Network', 1790, 'N/A', 'N/A', '/coins/otn/overview', 1, 'cryptocompare'),
(1719, 370825, 'POS', 'PoSToken (POS)', 'PoSToken', 1791, 'N/A', 'PoS', '/coins/pos/overview', 1, 'cryptocompare'),
(1720, 370889, 'REBL', 'REBL (REBL)', 'REBL', 1792, 'N/A', 'N/A', '/coins/rebl/overview', 1, 'cryptocompare'),
(1721, 370947, 'NEOG', 'NEO Gold (NEOG)', 'NEO Gold', 1793, 'N/A', 'N/A', '/coins/neog/overview', 1, 'cryptocompare'),
(1722, 370961, 'EXN', 'ExchangeN (EXN)', 'ExchangeN', 1794, 'N/A', 'N/A', '/coins/exn/overview', 1, 'cryptocompare'),
(1723, 370973, 'INS', 'INS Ecosystem (INS)', 'INS Ecosystem', 1795, 'N/A', 'N/A', '/coins/ins/overview', 1, 'cryptocompare'),
(1724, 371004, 'TRCT', 'Tracto (TRCT)', 'Tracto', 1796, 'N/A', 'N/A', '/coins/trct/overview', 1, 'cryptocompare'),
(1725, 371005, 'UKG', 'UnikoinGold (UKG)', 'UnikoinGold', 1797, 'N/A', 'N/A', '/coins/ukg/overview', 1, 'cryptocompare'),
(1726, 371064, 'BTCRED', 'Bitcoin Red (BTCRED)', 'Bitcoin Red', 1798, 'N/A', 'N/A', '/coins/btcred/overview', 1, 'cryptocompare'),
(1727, 371902, 'JTX', 'Project J (JTX)', 'Project J', 1800, 'N/A', 'N/A', '/coins/jtx/overview', 1, 'cryptocompare'),
(1728, 372029, 'AXT', 'AIX (AXT)', 'AIX', 1801, 'N/A', 'N/A', '/coins/axt/overview', 1, 'cryptocompare'),
(1729, 372369, 'RDN*', 'Raiden Network (RDN*)', 'Raiden Network', 1802, 'N/A', 'N/A', '/coins/rdnstar/overview', 1, 'cryptocompare'),
(1730, 372377, 'NEU', 'Neumark (NEU)', 'Neumark', 1803, 'N/A', 'N/A', '/coins/neu/overview', 1, 'cryptocompare'),
(1731, 372608, 'RUPX', 'Rupaya (RUPX)', 'Rupaya', 1804, 'Scrypt', 'PoW/PoS', '/coins/rupx/overview', 1, 'cryptocompare'),
(1732, 372637, 'BDR', 'BlueDragon (BDR)', 'BlueDragon', 1805, 'N/A', 'N/A', '/coins/bdr/overview', 1, 'cryptocompare'),
(1733, 372654, 'XIN', 'Infinity Economics (XIN)', 'Infinity Economics', 1806, 'SHA256', 'PoS', '/coins/xin/overview', 1, 'cryptocompare'),
(1734, 372748, 'DUTCH', 'Dutch Coin (DUTCH)', 'Dutch Coin', 1807, 'Scrypt', 'PoW/PoS', '/coins/dutch/overview', 1, 'cryptocompare'),
(1735, 372812, 'TIO', 'Trade.io (TIO)', 'Trade.io', 1808, 'N/A', 'N/A', '/coins/tio/overview', 1, 'cryptocompare'),
(1736, 373880, 'HNC*', 'Huncoin (HNC*)', 'Huncoin', 1809, 'X13', 'PoW', '/coins/hncstar/overview', 1, 'cryptocompare'),
(1737, 373980, 'MDC*', 'MadCoin (MDC*)', 'MadCoin', 1811, 'Scrypt', 'PoW', '/coins/mdcstar/overview', 1, 'cryptocompare'),
(1738, 374031, 'PURA', 'Pura (PURA)', 'Pura', 1812, 'X11', 'PoW', '/coins/pura/overview', 1, 'cryptocompare'),
(1739, 374211, 'INN', 'Innova (INN)', 'Innova', 1813, 'NeoScrypt', 'PoW', '/coins/inn/overview', 1, 'cryptocompare'),
(1740, 374246, 'HST', 'Decision Token (HST)', 'Decision Token', 1814, 'N/A', 'N/A', '/coins/hst/overview', 1, 'cryptocompare'),
(1741, 374281, 'BCPT', 'BlockMason Credit Protocol (BCPT)', 'BlockMason Credit Protocol', 1815, 'N/A', 'N/A', '/coins/bcpt/overview', 1, 'cryptocompare'),
(1742, 374294, 'BDL', 'Bitdeal (BDL)', 'Bitdeal', 1816, 'Scrypt', 'PoW', '/coins/bdl/overview', 1, 'cryptocompare'),
(1743, 374358, 'CMS', 'COMSA (CMS)', 'COMSA', 1817, 'N/A', 'N/A', '/coins/cms/overview', 1, 'cryptocompare'),
(1744, 375352, 'XBL', 'Billionaire Token (XBL)', 'Billionaire Token', 1818, 'N/A', 'N/A', '/coins/xbl/overview', 1, 'cryptocompare'),
(1745, 375396, 'ZEPH', 'Project Zephyr (ZEPH)', 'Project Zephyr', 1819, 'N/A', 'N/A', '/coins/zeph/overview', 1, 'cryptocompare'),
(1746, 375855, 'ATFS', 'ATFS Project (ATFS)', 'ATFS Project', 1820, 'N/A', 'N/A', '/coins/atfs/overview', 1, 'cryptocompare'),
(1747, 377508, 'GES', 'Galaxy eSolutions (GES)', 'Galaxy eSolutions', 1822, 'N/A', 'N/A', '/coins/ges/overview', 1, 'cryptocompare'),
(1748, 377792, 'NULS', 'Nuls (NULS)', 'Nuls', 1823, 'N/A', 'N/A', '/coins/nuls/overview', 1, 'cryptocompare'),
(1749, 377831, 'PHR*', 'Phore (PHR*)', 'Phore', 1824, 'POS 3.0', 'N/A', '/coins/phrstar/overview', 1, 'cryptocompare'),
(1750, 378830, 'LCASH', 'LitecoinCash (LCASH)', 'LitecoinCash', 1825, 'N/A', 'N/A', '/coins/lcash/overview', 1, 'cryptocompare'),
(1751, 379232, 'CFD', 'Confido (CFD)', 'Confido', 1826, 'N/A', 'N/A', '/coins/cfd/overview', 1, 'cryptocompare'),
(1752, 379248, 'SPHTX', 'SophiaTX (SPHTX)', 'SophiaTX', 1827, 'N/A', 'N/A', '/coins/sphtx/overview', 1, 'cryptocompare'),
(1753, 380571, 'PLC', 'PlusCoin (PLC)', 'PlusCoin', 1828, 'N/A', 'N/A', '/coins/plc/overview', 1, 'cryptocompare'),
(1754, 380641, 'SRN', 'SirinLabs (SRN)', 'SirinLabs', 1829, 'N/A', 'N/A', '/coins/srn/overview', 1, 'cryptocompare'),
(1755, 380671, 'WSC', 'WiserCoin (WSC)', 'WiserCoin', 1830, 'Scrypt', 'PoW', '/coins/wsc/overview', 1, 'cryptocompare'),
(1756, 380712, 'DBET', 'Decent.bet (DBET)', 'Decent.bet', 1831, 'N/A', 'N/A', '/coins/dbet/overview', 1, 'cryptocompare'),
(1757, 380754, 'XGOX', 'Go! (xGOx)', 'Go!', 1832, 'Scrypt', 'PoW/PoS', '/coins/xgox/overview', 1, 'cryptocompare'),
(1758, 380794, 'NEWB', 'Newbium (NEWB)', 'Newbium', 1833, 'N/A', 'N/A', '/coins/newb/overview', 1, 'cryptocompare'),
(1759, 381189, 'LIFE', 'LIFE (LIFE)', 'LIFE', 1834, 'N/A', 'N/A', '/coins/life/overview', 1, 'cryptocompare'),
(1760, 381323, 'RMC', 'Russian Mining Coin (RMC)', 'Russian Mining Coin', 1836, 'N/A', 'N/A', '/coins/rmc/overview', 1, 'cryptocompare'),
(1761, 382450, 'CREDO', 'Credo (CREDO)', 'Credo', 1837, 'N/A', 'N/A', '/coins/credo/overview', 1, 'cryptocompare'),
(1762, 382536, 'MSR', 'Masari (MSR)', 'Masari', 1838, 'CryptoNight', 'PoW', '/coins/msr/overview', 1, 'cryptocompare'),
(1763, 382617, 'CJT', 'ConnectJob Token (CJT)', 'ConnectJob Token', 1839, 'N/A', 'PoS', '/coins/cjt/overview', 1, 'cryptocompare'),
(1764, 383878, 'ESC*', 'Ethersportcoin (ESC)', 'Ethersportcoin', 1841, 'N/A', 'N/A', '/coins/esc/overview', 1, 'cryptocompare'),
(1765, 383953, 'EVN', 'Envion (EVN)', 'Envion', 1842, 'N/A', 'N/A', '/coins/evn/overview', 1, 'cryptocompare'),
(1766, 384605, 'BNK', 'Bankera (BNK)', 'Bankera', 1843, 'N/A', 'N/A', '/coins/bnk/overview', 1, 'cryptocompare'),
(1767, 384651, 'ELLA', 'Ellaism (ELLA)', 'Ellaism', 1844, 'Ethash', 'PoW', '/coins/ella/overview', 1, 'cryptocompare'),
(1768, 384729, 'BPL', 'BlockPool (BPL)', 'BlockPool', 1845, 'DPoS', 'N/A', '/coins/bpl/overview', 1, 'cryptocompare'),
(1769, 384859, 'COIN', 'Coinvest (COIN)', 'Coinvest', 1846, 'N/A', 'N/A', '/coins/coin/overview', 1, 'cryptocompare'),
(1770, 384950, 'ROCK*', 'RocketCoin  (ROCK*)', 'RocketCoin ', 1847, 'N/A', 'N/A', '/coins/rockstar/overview', 1, 'cryptocompare'),
(1771, 384953, 'DRXNE', 'Droxne (DRXNE)', 'Droxne', 1848, 'PoS', 'PoS', '/coins/drxne/overview', 1, 'cryptocompare'),
(1772, 385866, 'SKR', 'Sakuracoin (SKR)', 'Sakuracoin', 1849, 'Scrypt', 'PoW', '/coins/skr/overview', 1, 'cryptocompare'),
(1773, 385907, 'GRID', 'Grid+ (GRID)', 'Grid+', 1850, 'N/A', 'N/A', '/coins/grid/overview', 1, 'cryptocompare'),
(1774, 385933, 'XPTX', 'PlatinumBAR (XPTX)', 'PlatinumBAR', 1851, 'Quark', 'PoW/PoS', '/coins/xptx/overview', 1, 'cryptocompare'),
(1775, 385952, 'GVT', 'Genesis Vision (GVT)', 'Genesis Vision', 1852, 'N/A', 'N/A', '/coins/gvt/overview', 1, 'cryptocompare'),
(1776, 385960, 'ETK', 'Energi Token (ETK)', 'Energi Token', 1853, 'N/A', 'N/A', '/coins/etk/overview', 1, 'cryptocompare'),
(1777, 387875, 'ASTRO', 'Astronaut (ASTRO)', 'Astronaut', 1854, 'N/A', 'N/A', '/coins/astro/overview', 1, 'cryptocompare'),
(1778, 388042, 'GMT', 'Mercury Protocol (GMT)', 'Mercury Protocol', 1855, 'N/A', 'N/A', '/coins/gmt/overview', 1, 'cryptocompare'),
(1779, 388076, 'EPY*', 'Emphy (EPY*)', 'Emphy', 1856, 'N/A', 'N/A', '/coins/epystar/overview', 1, 'cryptocompare'),
(1780, 388145, 'SOAR', 'Soarcoin (SOAR)', 'Soarcoin', 1857, 'N/A', 'N/A', '/coins/soar/overview', 1, 'cryptocompare'),
(1781, 388493, 'EXY', 'Experty (EXY)', 'Experty', 1858, 'N/A', 'N/A', '/coins/exy/overview', 1, 'cryptocompare'),
(1782, 389808, 'HOLD*', 'Interstellar Holdings (HOLD*)', 'Interstellar Holdings', 1859, 'Scrypt', 'PoS', '/coins/holdstar/overview', 1, 'cryptocompare'),
(1783, 389849, 'MNX', 'MinexCoin (MNX)', 'MinexCoin', 1860, 'Mars', 'N/A', '/coins/mnx/overview', 1, 'cryptocompare'),
(1784, 392253, 'CRDS', 'Credits (CRDS)', 'Credits', 1861, 'Argon2', 'N/A', '/coins/crds/overview', 1, 'cryptocompare'),
(1785, 393656, 'VIU', 'Viuly (VIU)', 'Viuly', 1862, 'N/A', 'N/A', '/coins/viu/overview', 1, 'cryptocompare'),
(1786, 393742, 'SCR*', 'Scorum (SCR*)', 'Scorum', 1863, 'DPoS', 'DPoS', '/coins/scrstar/overview', 1, 'cryptocompare'),
(1787, 394055, 'DBR', 'Düber (DBR)', 'Düber', 1864, 'N/A', 'N/A', '/coins/dbr/overview', 1, 'cryptocompare'),
(1788, 394056, 'ABT', 'Advanced Browsing Token (ABT*)', 'Advanced Browsing Token', 1865, 'N/A', 'N/A', '/coins/abtstar/overview', 1, 'cryptocompare'),
(1789, 394121, 'GFT', 'Giftcoin (GFT)', 'Giftcoin', 1866, 'N/A', 'N/A', '/coins/gft/overview', 1, 'cryptocompare'),
(1790, 396716, 'STAC', 'STAC (STAC)', 'STAC', 1867, 'N/A', 'N/A', '/coins/stac/overview', 1, 'cryptocompare'),
(1791, 397757, 'QSP', 'Quantstamp (QSP)', 'Quantstamp', 1868, 'N/A', 'N/A', '/coins/qsp/overview', 1, 'cryptocompare'),
(1792, 398126, 'RIPT', 'RiptideCoin (RIPT)', 'RiptideCoin', 1869, 'N/A', 'N/A', '/coins/ript/overview', 1, 'cryptocompare'),
(1793, 398648, 'BBT', 'BitBoost (BBT)', 'BitBoost', 1870, 'N/A', 'N/A', '/coins/bbt/overview', 1, 'cryptocompare'),
(1794, 398705, 'GBX', 'GoByte (GBX)', 'GoByte', 1871, 'NeoScrypt', 'PoW', '/coins/gbx/overview', 1, 'cryptocompare'),
(1795, 400432, 'CSTL', 'Castle (CSTL)', 'Castle', 1872, 'X11', 'PoW/PoS', '/coins/cstl/overview', 1, 'cryptocompare'),
(1796, 400693, 'ICC', 'Insta Cash Coin (ICC)', 'Insta Cash Coin', 1875, 'SHA256', 'PoW', '/coins/icc/overview', 1, 'cryptocompare'),
(1797, 400702, 'JNT', 'Jibrel Network Token (JNT)', 'Jibrel Network Token', 1876, 'N/A', 'N/A', '/coins/jnt/overview', 1, 'cryptocompare'),
(1798, 402714, 'QASH', 'Quoine Liquid (QASH)', 'Quoine Liquid', 1877, 'N/A', 'N/A', '/coins/qash/overview', 1, 'cryptocompare'),
(1799, 402782, 'ALQO', 'Alqo (ALQO)', 'Alqo', 1878, 'Quark', 'PoW/PoS', '/coins/alqo/overview', 1, 'cryptocompare'),
(1800, 402805, 'KNC**', 'KingN Coin (KNC**)', 'KingN Coin', 1879, 'Scrypt', 'PoW/PoS', '/coins/kncstarstar/overview', 1, 'cryptocompare'),
(1801, 402884, 'TRIA', 'Triaconta (TRIA)', 'Triaconta', 1880, 'N/A', 'N/A', '/coins/tria/overview', 1, 'cryptocompare'),
(1802, 402980, 'PBL', 'Pebbles (PBL)', 'Pebbles', 1881, 'N/A', 'N/A', '/coins/pbl/overview', 1, 'cryptocompare'),
(1803, 404752, 'MAG', 'Magnet (MAG)', 'Magnet', 1882, 'X11', 'PoW/PoS', '/coins/mag/overview', 1, 'cryptocompare'),
(1804, 404775, 'STEX', 'STEX (STEX)', 'STEX', 1883, 'N/A', 'N/A', '/coins/stex/overview', 1, 'cryptocompare'),
(1805, 404806, 'UFR', 'Upfiring (UFR)', 'Upfiring', 1884, 'N/A', 'N/A', '/coins/ufr/overview', 1, 'cryptocompare'),
(1806, 404890, 'LOCI', 'LociCoin (LOCI)', 'LociCoin', 1885, 'N/A', 'N/A', '/coins/loci/overview', 1, 'cryptocompare'),
(1807, 405291, 'TAU', 'Lamden Tau (TAU)', 'Lamden Tau', 1886, 'DPoS', 'DPoS', '/coins/tau/overview', 1, 'cryptocompare'),
(1808, 405343, 'LAB', 'Labrys (LAB)', 'Labrys', 1887, 'N/A', 'N/A', '/coins/lab/overview', 1, 'cryptocompare'),
(1809, 408765, 'DEB', 'Debitum Token (DEB)', 'Debitum Token', 1888, 'N/A', 'N/A', '/coins/deb/overview', 1, 'cryptocompare'),
(1810, 408849, 'FLIXX', 'Flixxo (FLIXX)', 'Flixxo', 1889, 'N/A', 'N/A', '/coins/flixx/overview', 1, 'cryptocompare'),
(1811, 409128, 'FRD', 'Farad (FRD)', 'Farad', 1890, 'N/A', 'N/A', '/coins/frd/overview', 1, 'cryptocompare'),
(1812, 409155, 'PFR', 'PayFair (PFR)', 'PayFair', 1891, 'N/A', 'N/A', '/coins/pfr/overview', 1, 'cryptocompare'),
(1813, 409249, 'ECA', 'Electra (ECA)', 'Electra', 1892, 'NIST5', 'PoW/PoS', '/coins/eca/overview', 1, 'cryptocompare'),
(1814, 409363, 'LDM', 'Ludum token (LDM)', 'Ludum token', 1893, 'N/A', 'N/A', '/coins/ldm/overview', 1, 'cryptocompare'),
(1815, 409422, 'LTG', 'LiteCoin Gold (LTG)', 'LiteCoin Gold', 1894, 'N/A', 'N/A', '/coins/ltg/overview', 1, 'cryptocompare'),
(1816, 409492, 'BCD', 'Bitcoin Diamond (BCD)', 'Bitcoin Diamond', 1895, 'X13', 'PoW/PoS', '/coins/bcd/overview', 1, 'cryptocompare'),
(1817, 411271, 'STP', 'StashPay (STP)', 'StashPay', 1896, 'N/A', 'N/A', '/coins/stp/overview', 1, 'cryptocompare'),
(1818, 411496, 'SPANK', 'SpankChain (SPANK)', 'SpankChain', 1897, 'N/A', 'N/A', '/coins/spank/overview', 1, 'cryptocompare'),
(1819, 411620, 'WISH', 'MyWish (WISH)', 'MyWish', 1898, 'N/A', 'N/A', '/coins/wish/overview', 1, 'cryptocompare'),
(1820, 411647, 'AERM', 'Aerium (AERM)', 'Aerium', 1899, 'SkunkHash', 'PoW/PoS', '/coins/aerm/overview', 1, 'cryptocompare'),
(1821, 412081, 'PLX', 'PlexCoin (PLX)', 'PlexCoin', 1900, 'N/A', 'N/A', '/coins/plx/overview', 1, 'cryptocompare'),
(1822, 412112, 'NIO*', 'Autonio (NIO*)', 'Autonio', 1901, 'N/A', 'N/A', '/coins/niostar/overview', 1, 'cryptocompare'),
(1823, 412197, 'ETHB', 'EtherBTC (ETHB)', 'EtherBTC', 1902, 'N/A', 'N/A', '/coins/ethb/overview', 1, 'cryptocompare'),
(1824, 412267, 'CDX', 'Commodity Ad Network (CDX)', 'Commodity Ad Network', 1903, 'N/A', 'N/A', '/coins/cdx/overview', 1, 'cryptocompare'),
(1825, 413886, 'FOOD', 'FoodCoin (FOOD)', 'FoodCoin', 1904, 'N/A', 'N/A', '/coins/food/overview', 1, 'cryptocompare'),
(1826, 417510, 'DEC', 'Darico (DEC)', 'Darico', 1905, 'N/A', '240000000', '/coins/dec/overview', 1, 'cryptocompare'),
(1827, 418671, 'VOT', 'Votecoin (VOT)', 'Votecoin', 1906, 'Equihash', 'PoW', '/coins/vot/overview', 1, 'cryptocompare'),
(1828, 418694, 'UQC', 'Uquid Coin (UQC)', 'Uquid Coin', 1907, 'N/A', 'N/A', '/coins/uqc/overview', 1, 'cryptocompare'),
(1829, 418778, 'LEND', 'EthLend (LEND)', 'EthLend', 1908, 'N/A', 'N/A', '/coins/lend/overview', 1, 'cryptocompare'),
(1830, 419209, 'SETH', 'Sether (SETH)', 'Sether', 1909, 'N/A', 'N/A', '/coins/seth/overview', 1, 'cryptocompare'),
(1831, 419579, 'TIO*', 'Tio Tour Guides (TIO*)', 'Tio Tour Guides', 1910, 'N/A', 'N/A', '/coins/tiostar/overview', 1, 'cryptocompare'),
(1832, 419711, 'ABYSS', 'The Abyss (ABYSS)', 'The Abyss', 1911, 'N/A', 'N/A', '/coins/abyss/overview', 1, 'cryptocompare'),
(1833, 419814, 'XSH', 'SHIELD (XSH)', 'SHIELD', 1912, 'Multiple', 'PoW', '/coins/xsh/overview', 1, 'cryptocompare'),
(1834, 419930, 'BCD*', 'BitCAD (BCD*)', 'BitCAD', 1913, 'N/A', 'N/A', '/coins/bcdstar/overview', 1, 'cryptocompare'),
(1835, 421896, 'GEA', 'Goldea (GEA)', 'Goldea', 1914, 'N/A', 'N/A', '/coins/gea/overview', 1, 'cryptocompare'),
(1836, 422188, 'BCO*', 'BridgeCoin (BCO)', 'BridgeCoin', 1915, 'Scrypt', 'PoW', '/coins/bco/overview', 1, 'cryptocompare'),
(1837, 423297, 'DSR', 'Desire (DSR)', 'Desire', 1916, 'NeoScrypt', 'PoW', '/coins/dsr/overview', 1, 'cryptocompare'),
(1838, 423754, 'BDG', 'BitDegree (BDG)', 'BitDegree', 1917, 'N/A', 'N/A', '/coins/bdg/overview', 1, 'cryptocompare'),
(1839, 428300, 'ONG', 'SoMee.Social (ONG)', 'SoMee.Social', 1918, 'N/A', 'N/A', '/coins/ong/overview', 1, 'cryptocompare'),
(1840, 429355, 'PRL', 'Oyster Pearl (PRL)', 'Oyster Pearl', 1919, 'N/A', 'N/A', '/coins/prl/overview', 1, 'cryptocompare'),
(1841, 429400, 'BTCM', 'BTCMoon (BTCM)', 'BTCMoon', 1920, 'N/A', 'N/A', '/coins/btcm/overview', 1, 'cryptocompare'),
(1842, 431142, 'ETBT', 'Ethereum Black (ETBT)', 'Ethereum Black', 1922, 'N/A', 'N/A', '/coins/etbt/overview', 1, 'cryptocompare'),
(1843, 431170, 'ZCG', 'ZCashGOLD (ZCG)', 'ZCashGOLD', 1923, 'N/A', 'N/A', '/coins/zcg/overview', 1, 'cryptocompare'),
(1844, 431229, 'MUT', 'Mutual Coin (MUT)', 'Mutual Coin', 1924, 'Scrypt', 'PoW/PoS', '/coins/mut/overview', 1, 'cryptocompare'),
(1845, 431235, 'AION', 'Aion (AION)', 'Aion', 1925, 'N/A', 'N/A', '/coins/aion/overview', 1, 'cryptocompare'),
(1846, 431370, 'MEOW', 'Kittehcoin (MEOW)', 'Kittehcoin', 1926, 'Scrypt', 'PoW', '/coins/meow/overview', 1, 'cryptocompare'),
(1847, 431413, 'DIVX', 'Divi (DIVX)', 'Divi', 1927, 'N/A', 'N/A', '/coins/divx/overview', 1, 'cryptocompare'),
(1848, 431621, 'CNBC', 'Cash & Back Coin (CNBC)', 'Cash & Back Coin', 1928, 'Scrypt', 'PoW/PoS', '/coins/cnbc/overview', 1, 'cryptocompare'),
(1849, 434666, 'RHOC', 'RChain (RHOC)', 'RChain', 1929, 'N/A', 'N/A', '/coins/rhoc/overview', 1, 'cryptocompare'),
(1850, 435659, 'ARC*', ' Arcade City (ARC*)', ' Arcade City', 1930, 'N/A', 'N/A', '/coins/arcstar/overview', 1, 'cryptocompare'),
(1851, 436007, 'XUN', 'UltraNote (XUN)', 'UltraNote', 1931, 'CryptoNight', 'PoW', '/coins/xun/overview', 1, 'cryptocompare'),
(1852, 436162, 'RFL', 'RAFL (RFL)', 'RAFL', 1932, 'N/A', 'N/A', '/coins/rfl/overview', 1, 'cryptocompare'),
(1853, 436320, 'COFI', 'CoinFi (COFI)', 'CoinFi', 1933, 'N/A', 'N/A', '/coins/cofi/overview', 1, 'cryptocompare'),
(1854, 438867, 'ELTCOIN', 'ELTCOIN (ELTCOIN)', 'ELTCOIN', 1934, 'N/A', 'N/A', '/coins/eltcoin/overview', 1, 'cryptocompare'),
(1855, 439136, 'GRX', 'Gold Reward Token (GRX)', 'Gold Reward Token', 1935, 'N/A', 'N/A', '/coins/grx/overview', 1, 'cryptocompare'),
(1856, 439180, 'NTK', 'Neurotoken (NTK)', 'Neurotoken', 1936, 'N/A', 'N/A', '/coins/ntk/overview', 1, 'cryptocompare'),
(1857, 439579, 'ERO', 'Eroscoin (ERO)', 'Eroscoin', 1937, 'N/A', 'N/A', '/coins/ero/overview', 1, 'cryptocompare'),
(1858, 439963, 'CMT*', 'CyberMiles (CMT*)', 'CyberMiles', 1938, 'N/A', 'N/A', '/coins/cmtstar/overview', 1, 'cryptocompare'),
(1859, 441616, 'RLX', 'Relex (RLX)', 'Relex', 1939, 'N/A', 'N/A', '/coins/rlx/overview', 1, 'cryptocompare'),
(1860, 446051, 'MAN', 'People (MAN)', 'People', 1940, 'Scrypt', 'PoW', '/coins/man/overview', 1, 'cryptocompare'),
(1861, 446121, 'CWV', 'CryptoWave (CWV)', 'CryptoWave', 1941, 'N/A', 'N/A', '/coins/cwv/overview', 1, 'cryptocompare'),
(1862, 446372, 'ACT*', 'Achain (ACT*)', 'Achain', 1942, 'DPoS', 'DPoS', '/coins/actstar/overview', 1, 'cryptocompare'),
(1863, 447315, 'NRO', 'Neuro (NRO)', 'Neuro', 1943, 'SHA256', 'PoW/PoS', '/coins/nro/overview', 1, 'cryptocompare'),
(1864, 449573, 'SEND', 'Social Send (SEND)', 'Social Send', 1944, 'Quark', 'PoW/PoS', '/coins/send/overview', 1, 'cryptocompare'),
(1865, 449614, 'GLT', 'GlobalToken (GLT)', 'GlobalToken', 1945, 'SHA256', 'PoW', '/coins/glt/overview', 1, 'cryptocompare'),
(1866, 450337, 'X8X', 'X8Currency (X8X)', 'X8Currency', 1946, 'N/A', 'N/A', '/coins/x8x/overview', 1, 'cryptocompare'),
(1867, 453581, 'COAL', 'BitCoal (COAL)', 'BitCoal', 1947, 'CryptoNight', 'PoW', '/coins/coal/overview', 1, 'cryptocompare'),
(1868, 453647, 'DAXX', 'DaxxCoin (DAXX)', 'DaxxCoin', 1948, 'Ethash', 'PoW', '/coins/daxx/overview', 1, 'cryptocompare'),
(1869, 453855, 'BWK', 'Bulwark (BWK)', 'Bulwark', 1949, 'NIST5', 'PoW/PoS', '/coins/bwk/overview', 1, 'cryptocompare'),
(1870, 453943, 'FNTB', 'FinTab (FNTB)', 'FinTab', 1950, 'N/A', 'N/A', '/coins/fntb/overview', 1, 'cryptocompare'),
(1871, 463101, 'XMRG', 'Monero Gold (XMRG)', 'Monero Gold', 1951, 'N/A', 'N/A', '/coins/xmrg/overview', 1, 'cryptocompare'),
(1872, 463700, 'BTCE', 'EthereumBitcoin (BTCE)', 'EthereumBitcoin', 1952, 'N/A', 'N/A', '/coins/btce/overview', 1, 'cryptocompare'),
(1873, 464920, 'FYP', 'FlypMe (FYP)', 'FlypMe', 1953, 'N/A', 'N/A', '/coins/fyp/overview', 1, 'cryptocompare'),
(1874, 465681, 'BOXY', 'BoxyCoin (BOXY)', 'BoxyCoin', 1954, 'Scrypt', 'PoW', '/coins/boxy/overview', 1, 'cryptocompare'),
(1875, 466339, 'NGC', 'NagaCoin (NGC)', 'NagaCoin', 1955, 'N/A', 'N/A', '/coins/ngc/overview', 1, 'cryptocompare'),
(1876, 466492, 'UTN', 'Universa (UTN)', 'Universa', 1956, 'N/A', 'N/A', '/coins/utn/overview', 1, 'cryptocompare'),
(1877, 466786, 'EGAS', 'ETHGAS (EGAS)', 'ETHGAS', 1957, 'N/A', 'N/A', '/coins/egas/overview', 1, 'cryptocompare'),
(1878, 466977, 'DPP', 'Digital Assets Power Play (DPP)', 'Digital Assets Power Play', 1958, 'N/A', 'N/A', '/coins/dpp/overview', 1, 'cryptocompare'),
(1879, 468052, 'ADB', 'Adbank (ADB)', 'Adbank', 1959, 'N/A', 'N/A', '/coins/adb/overview', 1, 'cryptocompare'),
(1880, 472769, 'TGT', 'TargetCoin (TGT)', 'TargetCoin', 1960, 'N/A', 'N/A', '/coins/tgt/overview', 1, 'cryptocompare'),
(1881, 477743, 'XDCE', 'XinFin Coin (XDCE)', 'XinFin Coin', 1961, 'N/A', 'N/A', '/coins/xdce/overview', 1, 'cryptocompare'),
(1882, 481737, 'BMT', 'BMChain (BMT)', 'BMChain', 1962, 'N/A', 'N/A', '/coins/bmt/overview', 1, 'cryptocompare'),
(1883, 484355, 'BIO', 'Biocoin (BIO)', 'Biocoin', 1963, 'N/A', 'N/A', '/coins/bio/overview', 1, 'cryptocompare'),
(1884, 484742, 'MTRC', 'ModulTrade (MTRC)', 'ModulTrade', 1965, 'N/A', 'N/A', '/coins/mtrc/overview', 1, 'cryptocompare'),
(1885, 486837, 'BTCL', 'BTC Lite (BTCL)', 'BTC Lite', 1966, 'N/A', 'N/A', '/coins/btcl/overview', 1, 'cryptocompare'),
(1886, 486886, 'PCN', 'PeepCoin (PCN)', 'PeepCoin', 1967, 'N/A', 'PoW/PoS', '/coins/pcn/overview', 1, 'cryptocompare'),
(1887, 491325, 'PYP', 'PayPro (PYP)', 'PayPro', 1969, 'N/A', 'N/A', '/coins/pyp/overview', 1, 'cryptocompare'),
(1888, 491479, 'RBTC', 'Bitcoin Revolution (RBTC)', 'Bitcoin Revolution', 1970, 'N/A', 'N/A', '/coins/rbtc/overview', 1, 'cryptocompare'),
(1889, 502301, 'CRED', 'Verify (CRED)', 'Verify', 1971, 'N/A', 'N/A', '/coins/cred/overview', 1, 'cryptocompare'),
(1890, 516982, 'SBTC', 'Super Bitcoin (SBTC)', 'Super Bitcoin', 1972, 'SHA256', 'PoW', '/coins/sbtc/overview', 1, 'cryptocompare'),
(1891, 517193, 'KLKS', 'Kalkulus (KLKS)', 'Kalkulus', 1973, 'Quark', 'PoS', '/coins/klks/overview', 1, 'cryptocompare'),
(1892, 517389, 'AC3', 'AC3 (AC3)', 'AC3', 1974, 'X11', 'PoW', '/coins/ac3/overview', 1, 'cryptocompare'),
(1893, 517477, 'GTO', 'GIFTO (GTO)', 'GIFTO', 1975, 'N/A', 'N/A', '/coins/gto/overview', 1, 'cryptocompare'),
(1894, 517483, 'TNB', 'Time New Bank (TNB)', 'Time New Bank', 1976, 'N/A', 'N/A', '/coins/tnb/overview', 1, 'cryptocompare'),
(1895, 517603, 'CHIPS*', 'CHIPS (CHIPS)', 'CHIPS', 1977, 'SHA256', 'PoW', '/coins/chips/overview', 1, 'cryptocompare'),
(1896, 517775, 'HKN', 'Hacken (HKN)', 'Hacken', 1978, 'N/A', 'N/A', '/coins/hkn/overview', 1, 'cryptocompare'),
(1897, 517795, 'B2B', 'B2BX (B2B)', 'B2BX', 1979, 'N/A', 'N/A', '/coins/b2b/overview', 1, 'cryptocompare'),
(1898, 517896, 'LOC*', 'LockTrip (LOC*)', 'LockTrip', 1980, 'N/A', 'N/A', '/coins/locstar/overview', 1, 'cryptocompare'),
(1899, 521417, 'MNT*', 'Media Network Coin (MNT*)', 'Media Network Coin', 1981, 'N/A', 'N/A', '/coins/mntstar/overview', 1, 'cryptocompare'),
(1900, 522090, 'ITNS', 'IntenseCoin (ITNS)', 'IntenseCoin', 1982, 'CryptoNight', 'PoW', '/coins/itns/overview', 1, 'cryptocompare'),
(1901, 524113, 'SMT*', 'SmartMesh (SMT*)', 'SmartMesh', 1984, 'N/A', 'N/A', '/coins/smtstar/overview', 1, 'cryptocompare'),
(1902, 531089, 'GER', 'GermanCoin (GER)', 'GermanCoin', 1985, 'Scrypt', 'PoW/PoS', '/coins/ger/overview', 1, 'cryptocompare'),
(1903, 531408, 'LTCU', 'LiteCoin Ultra (LTCU)', 'LiteCoin Ultra', 1986, 'Scrypt', 'PoW/PoS', '/coins/ltcu/overview', 1, 'cryptocompare'),
(1904, 531559, 'BTCA', 'Bitair (BTCA)', 'Bitair', 1988, 'N/A', 'N/A', '/coins/btca/overview', 1, 'cryptocompare'),
(1905, 535054, 'HQX', 'HOQU (HQX)', 'HOQU', 1989, 'N/A', 'N/A', '/coins/hqx/overview', 1, 'cryptocompare'),
(1906, 536137, 'ETF', 'EthereumFog (ETF)', 'EthereumFog', 1990, 'Ethash', 'PoW', '/coins/etf/overview', 1, 'cryptocompare'),
(1907, 536213, 'BCX*', 'BitcoinX (BCX*)', 'BitcoinX', 1991, 'DPoS', 'DPoS', '/coins/bcxstar/overview', 1, 'cryptocompare'),
(1908, 536278, 'LUX**', 'Luxmi Coin (LUX**)', 'Luxmi Coin', 1992, 'N/A', 'PoW/PoS', '/coins/luxstarstar/overview', 1, 'cryptocompare'),
(1909, 536279, 'STAK', 'Straks (STAK)', 'Straks', 1993, 'Lyra2REv2', 'PoW', '/coins/stak/overview', 1, 'cryptocompare'),
(1910, 536905, 'BCOIN', 'BannerCoin (BCOIN)', 'BannerCoin', 1994, 'N/A', 'N/A', '/coins/bcoin/overview', 1, 'cryptocompare'),
(1911, 542140, 'MED*', 'MediBloc (MED*)', 'MediBloc', 1995, 'N/A', 'N/A', '/coins/medstar/overview', 1, 'cryptocompare'),
(1912, 542719, 'CCOS', 'CrowdCoinage (CCOS)', 'CrowdCoinage', 1996, 'N/A', 'N/A', '/coins/ccos/overview', 1, 'cryptocompare'),
(1913, 543363, 'BNTY', 'Bounty0x (BNTY)', 'Bounty0x', 1997, 'N/A', 'N/A', '/coins/bnty/overview', 1, 'cryptocompare'),
(1914, 543502, 'BRD', 'Bread token (BRD)', 'Bread token', 1998, 'N/A', 'N/A', '/coins/brd/overview', 1, 'cryptocompare'),
(1915, 563196, 'HAT', 'Hawala.Exchange (HAT)', 'Hawala.Exchange', 1999, 'N/A', 'N/A', '/coins/hat/overview', 1, 'cryptocompare'),
(1916, 571314, 'ELF', 'aelf (ELF)', 'aelf', 2000, 'N/A', 'N/A', '/coins/elf/overview', 1, 'cryptocompare'),
(1917, 579189, 'VLR', 'Valorem (VLR)', 'Valorem', 2001, 'N/A', 'N/A', '/coins/vlr/overview', 1, 'cryptocompare'),
(1918, 584861, 'CWX', 'Crypto-X (CWX)', 'Crypto-X', 2002, 'N/A', 'N/A', '/coins/cwx/overview', 1, 'cryptocompare'),
(1919, 586088, 'DBC', 'DeepBrain Chain (DBC)', 'DeepBrain Chain', 2003, 'N/A', 'N/A', '/coins/dbc/overview', 1, 'cryptocompare'),
(1920, 586160, 'ZEN*', 'Zen Protocol (ZEN*)', 'Zen Protocol', 2004, 'N/A', 'N/A', '/coins/zenstar/overview', 1, 'cryptocompare'),
(1921, 586409, 'POP', 'PopularCoin (POP)', 'PopularCoin', 2005, 'Scrypt', 'PoW', '/coins/pop/overview', 1, 'cryptocompare'),
(1922, 586482, 'CRC***', 'CrowdCoin (CRC***)', 'CrowdCoin', 2006, 'NeoScrypt', 'PoW', '/coins/crcstarstarstar/overview', 1, 'cryptocompare'),
(1923, 586567, 'PNX', 'PhantomX (PNX)', 'PhantomX', 2007, 'X11', 'PoW/PoS', '/coins/pnx/overview', 1, 'cryptocompare'),
(1924, 586638, 'BAS', 'BitAsean (BAS)', 'BitAsean', 2008, 'N/A', 'N/A', '/coins/bas/overview', 1, 'cryptocompare'),
(1925, 587261, 'UTT', 'United Traders Token (UTT)', 'United Traders Token', 2009, 'N/A', 'N/A', '/coins/utt/overview', 1, 'cryptocompare'),
(1926, 589829, 'HBC', 'HomeBlockCoin (HBC)', 'HomeBlockCoin', 2010, 'X11', 'PoW/PoS', '/coins/hbc/overview', 1, 'cryptocompare'),
(1927, 589881, 'AMM', 'MicroMoney (AMM)', 'MicroMoney', 2011, 'N/A', 'N/A', '/coins/amm/overview', 1, 'cryptocompare'),
(1928, 596972, 'DAV', 'DavorCoin (DAV)', 'DavorCoin', 2012, 'Scrypt', 'N/A', '/coins/dav/overview', 1, 'cryptocompare'),
(1929, 597029, 'XCPO', 'Copico (XCPO)', 'Copico', 2013, 'PoS', 'N/A', '/coins/xcpo/overview', 1, 'cryptocompare'),
(1930, 597181, 'GET', 'Guaranteed Entrance Token (GET)', 'Guaranteed Entrance Token', 2014, 'N/A', 'N/A', '/coins/get/overview', 1, 'cryptocompare'),
(1931, 597540, 'ERC20', 'Index ERC20 (ERC20)', 'Index ERC20', 2015, 'N/A', 'N/A', '/coins/erc20/overview', 1, 'cryptocompare'),
(1932, 597629, 'ITC', 'IoT Chain (ITC)', 'IoT Chain', 2016, 'N/A', 'N/A', '/coins/itc/overview', 1, 'cryptocompare'),
(1933, 598428, 'HTML', 'HTML Coin (HTML)', 'HTML Coin', 2017, 'SHA256', 'PoW/PoS', '/coins/html/overview', 1, 'cryptocompare'),
(1934, 600395, 'GENE', 'PARKGENE (GENE)', 'PARKGENE', 2018, 'N/A', 'N/A', '/coins/gene/overview', 1, 'cryptocompare'),
(1935, 607521, 'NMS', 'Numus (NMS)', 'Numus', 2019, 'Skein', 'PoW/PoS', '/coins/nms/overview', 1, 'cryptocompare'),
(1936, 608140, 'PHO', 'Photon (PHO)', 'Photon', 2020, 'BLAKE256', 'PoW', '/coins/pho/overview', 1, 'cryptocompare'),
(1937, 608756, 'XTRA', 'ExtraCredit (XTRA)', 'ExtraCredit', 2021, 'N/A', 'N/A', '/coins/xtra/overview', 1, 'cryptocompare'),
(1938, 616471, 'HION', 'Handelion (HION)', 'Handelion', 2022, 'N/A', 'N/A', '/coins/hion/overview', 1, 'cryptocompare'),
(1939, 616932, 'NTWK', 'Network Token (NTWK)', 'Network Token', 2023, 'N/A', 'N/A', '/coins/ntwk/overview', 1, 'cryptocompare'),
(1940, 617055, 'SUCR', 'Sucre (SUCR)', 'Sucre', 2024, 'X11', 'PoW', '/coins/sucr/overview', 1, 'cryptocompare'),
(1941, 617177, 'SMART*', 'SmartBillions (SMART*)', 'SmartBillions', 2025, 'N/A', 'N/A', '/coins/smartstar/overview', 1, 'cryptocompare'),
(1942, 619375, 'GNX', 'Genaro Network (GNX)', 'Genaro Network', 2026, 'N/A', 'N/A', '/coins/gnx/overview', 1, 'cryptocompare'),
(1943, 619555, 'NAS', 'Nebulas (NAS)', 'Nebulas', 2027, 'N/A', 'N/A', '/coins/nas/overview', 1, 'cryptocompare'),
(1944, 619929, 'ACCO', 'Accolade (ACCO)', 'Accolade', 2028, 'Scrypt', 'PoW/PoS', '/coins/acco/overview', 1, 'cryptocompare'),
(1945, 620037, 'BTH', 'Bytether  (BTH)', 'Bytether ', 2029, 'N/A', 'N/A', '/coins/bth/overview', 1, 'cryptocompare'),
(1946, 625010, 'REM', 'REMME (REM)', 'REMME', 2030, 'N/A', 'N/A', '/coins/rem/overview', 1, 'cryptocompare'),
(1947, 625173, 'TOK', 'TokugawaCoin (TOK)', 'TokugawaCoin', 2031, 'Scrypt', 'PoW', '/coins/tok/overview', 1, 'cryptocompare'),
(1948, 625216, 'EREAL', 'eREAL (EREAL)', 'eREAL', 2032, 'N/A', 'N/A', '/coins/ereal/overview', 1, 'cryptocompare'),
(1949, 625381, 'CPN', 'CompuCoin (CPN)', 'CompuCoin', 2033, 'Scrypt', 'PoW', '/coins/cpn/overview', 1, 'cryptocompare'),
(1950, 625458, 'XFT', 'Fantasy Cash (XFT)', 'Fantasy Cash', 2034, 'Scrypt', 'PoW/PoS', '/coins/xft/overview', 1, 'cryptocompare'),
(1951, 637681, 'QLC', 'QLC Chain (QLC)', 'QLC Chain', 2035, 'N/A', 'N/A', '/coins/qlc/overview', 1, 'cryptocompare'),
(1952, 637960, 'BTSE', 'BitSerial (BTE*)', 'BitSerial', 2036, 'N/A', 'N/A', '/coins/btestar/overview', 1, 'cryptocompare'),
(1953, 638142, 'OMGC', 'OmiseGO Classic (OMGC)', 'OmiseGO Classic', 2037, 'Scrypt', 'PoW/PoS', '/coins/omgc/overview', 1, 'cryptocompare'),
(1954, 638297, 'Q2C', 'QubitCoin (Q2C)', 'QubitCoin', 2038, 'QuBit', 'N/A', '/coins/q2c/overview', 1, 'cryptocompare'),
(1955, 638634, 'BLT', 'Bloom Token (BLT)', 'Bloom Token', 2039, 'N/A', 'N/A', '/coins/blt/overview', 1, 'cryptocompare'),
(1956, 639943, 'SPF', 'SportyCo (SPF)', 'SportyCo', 2040, 'N/A', 'N/A', '/coins/spf/overview', 1, 'cryptocompare'),
(1957, 640916, 'TDS', 'TokenDesk (TDS)', 'TokenDesk', 2041, 'N/A', 'N/A', '/coins/tds/overview', 1, 'cryptocompare'),
(1958, 645766, 'ORE', 'Galactrum (ORE)', 'Galactrum', 2042, 'Lyra2REv2', 'PoW/PoS', '/coins/ore/overview', 1, 'cryptocompare'),
(1959, 645791, 'SPK', 'Sparks (SPK)', 'Sparks', 2043, 'NeoScrypt', 'PoW', '/coins/spk/overview', 1, 'cryptocompare'),
(1960, 645830, 'GOA', 'GoaCoin (GOA)', 'GoaCoin', 2044, 'NeoScrypt', 'PoW', '/coins/goa/overview', 1, 'cryptocompare'),
(1961, 645879, 'FLS', 'Fuloos Coin (FLS)', 'Fuloos Coin', 2045, 'N/A', 'PoW/PoS', '/coins/fls/overview', 1, 'cryptocompare'),
(1962, 645913, 'WAGE', 'Digiwage (WAGE)', 'Digiwage', 2046, 'Quark', 'PoS', '/coins/wage/overview', 1, 'cryptocompare'),
(1963, 645936, 'GUN', 'GunCoin (GUN)', 'GunCoin', 2047, 'NeoScrypt', 'PoW', '/coins/gun/overview', 1, 'cryptocompare'),
(1964, 646897, 'DFS', 'DFSCoin (DFS)', 'DFSCoin', 2048, 'Scrypt', 'PoW/PoS', '/coins/dfs/overview', 1, 'cryptocompare'),
(1965, 653274, 'POLIS', 'PolisPay (POLIS)', 'PolisPay', 2050, 'X11', 'PoW', '/coins/polis/overview', 1, 'cryptocompare'),
(1966, 653806, 'WELL', 'Well (WELL)', 'Well', 2051, 'N/A', 'N/A', '/coins/well/overview', 1, 'cryptocompare'),
(1967, 654118, 'FLOT', 'FireLotto (FLOT)', 'FireLotto', 2052, 'N/A', 'N/A', '/coins/flot/overview', 1, 'cryptocompare'),
(1968, 659393, 'CL', 'CoinLancer (CL)', 'CoinLancer', 2053, 'N/A', 'N/A', '/coins/cl/overview', 1, 'cryptocompare'),
(1969, 659488, 'SHND', 'StrongHands (SHND)', 'StrongHands', 2054, 'SHA256D', 'PoW/PoS', '/coins/shnd/overview', 1, 'cryptocompare'),
(1970, 659663, 'AUA', 'ArubaCoin (AUA)', 'ArubaCoin', 2055, 'N/A', 'N/A', '/coins/aua/overview', 1, 'cryptocompare'),
(1971, 659681, 'DNN', 'DNN Token (DNN)', 'DNN Token', 2056, 'N/A', 'N/A', '/coins/dnn/overview', 1, 'cryptocompare'),
(1972, 659724, 'SAGA', 'SagaCoin (SAGA)', 'SagaCoin', 2057, 'Scrypt', 'PoW/PoS', '/coins/saga/overview', 1, 'cryptocompare'),
(1973, 659770, 'GXS', 'GXChain (GXS)', 'GXChain', 2058, 'N/A', 'DPoS', '/coins/gxs/overview', 1, 'cryptocompare'),
(1974, 659973, 'TSL', 'Energo (TSL)', 'Energo', 2059, 'N/A', 'N/A', '/coins/tsl/overview', 1, 'cryptocompare'),
(1975, 660438, 'IRL', 'IrishCoin (IRL)', 'IrishCoin', 2060, 'Scrypt', 'PoW', '/coins/irl/overview', 1, 'cryptocompare'),
(1976, 660947, 'BOT', 'Bodhi (BOT)', 'Bodhi', 2061, 'N/A', 'N/A', '/coins/bot/overview', 1, 'cryptocompare'),
(1977, 661398, 'PMA', 'PumaPay (PMA)', 'PumaPay', 2062, 'N/A', 'N/A', '/coins/pma/overview', 1, 'cryptocompare'),
(1978, 661619, 'TROLL', 'Trollcoin (TROLL)', 'Trollcoin', 2063, 'Scrypt', 'PoW/PoS', '/coins/troll/overview', 1, 'cryptocompare'),
(1979, 661719, 'FOR', 'Force Coin (FOR)', 'Force Coin', 2064, 'N/A', 'PoS', '/coins/for/overview', 1, 'cryptocompare'),
(1980, 661777, 'SGR', 'Sugar Exchange (SGR)', 'Sugar Exchange', 2065, 'N/A', 'N/A', '/coins/sgr/overview', 1, 'cryptocompare'),
(1981, 666891, 'JET', 'Jetcoin (JET)', 'Jetcoin', 2066, 'N/A', 'N/A', '/coins/jet/overview', 1, 'cryptocompare'),
(1982, 667050, 'MDS', 'MediShares (MDS)', 'MediShares', 2067, 'N/A', 'N/A', '/coins/mds/overview', 1, 'cryptocompare'),
(1983, 667139, 'LCP', 'Litecoin Plus (LCP)', 'Litecoin Plus', 2068, 'Scrypt', 'PoW/PoS', '/coins/lcp/overview', 1, 'cryptocompare'),
(1984, 667239, 'GTC', 'Game (GTC)', 'Game', 2069, 'N/A', 'N/A', '/coins/gtc/overview', 1, 'cryptocompare'),
(1985, 667344, 'IETH', 'iEthereum (IETH)', 'iEthereum', 2070, 'N/A', 'N/A', '/coins/ieth/overview', 1, 'cryptocompare'),
(1986, 667444, 'GCC*', 'TheGCCcoin (GCC*)', 'TheGCCcoin', 2071, 'X13', 'PoW/PoS', '/coins/gccstar/overview', 1, 'cryptocompare'),
(1987, 674829, 'SDRN', 'Senderon (SDRN)', 'Senderon', 2072, 'N/A', 'N/A', '/coins/sdrn/overview', 1, 'cryptocompare'),
(1988, 674918, 'INK', 'Ink (INK)', 'Ink', 2074, 'N/A', 'N/A', '/coins/ink/overview', 1, 'cryptocompare'),
(1989, 674980, 'KBR', 'Kubera Coin (KBR)', 'Kubera Coin', 2075, 'N/A', 'N/A', '/coins/kbr/overview', 1, 'cryptocompare'),
(1990, 675053, 'HPB', 'High Performance Blockchain (HPB)', 'High Performance Blockchain', 2076, 'DPoS', 'N/A', '/coins/hpb/overview', 1, 'cryptocompare'),
(1991, 675134, 'MONK', 'Monkey Project (MONK)', 'Monkey Project', 2078, 'X11', 'PoW/PoS', '/coins/monk/overview', 1, 'cryptocompare'),
(1992, 675359, 'JINN', 'Jinn (JINN)', 'Jinn', 2079, 'N/A', 'N/A', '/coins/jinn/overview', 1, 'cryptocompare'),
(1993, 675692, 'SET', 'Setcoin (SET)', 'Setcoin', 2080, 'N/A', 'N/A', '/coins/set/overview', 1, 'cryptocompare'),
(1994, 675758, 'MGN', 'MagnaCoin (MGN)', 'MagnaCoin', 2081, 'Quark', 'N/A', '/coins/mgn/overview', 1, 'cryptocompare'),
(1995, 675995, 'KZC', 'KZCash (KZC)', 'KZCash', 2082, 'X11', 'PoW', '/coins/kzc/overview', 1, 'cryptocompare'),
(1996, 676163, 'GNR', 'Gainer (GNR)', 'Gainer', 2084, 'N/A', 'PoS', '/coins/gnr/overview', 1, 'cryptocompare'),
(1997, 677648, 'LWF', 'Local World Forwarders (LWF)', 'Local World Forwarders', 2086, 'DPoS', 'DPoS', '/coins/lwf/overview', 1, 'cryptocompare'),
(1998, 679231, 'BRC', 'BrightCoin (BRC)', 'BrightCoin', 2087, 'N/A', 'N/A', '/coins/brc/overview', 1, 'cryptocompare'),
(1999, 679479, 'WCG', 'World Crypto Gold (WCG)', 'World Crypto Gold', 2088, 'SHA256', 'Proof of Sta', '/coins/wcg/overview', 1, 'cryptocompare'),
(2000, 679566, 'HIVE', 'Hive (HIVE)', 'Hive', 2089, 'N/A', 'N/A', '/coins/hive/overview', 1, 'cryptocompare'),
(2001, 679646, 'GX', 'GameX (GX)', 'GameX', 2090, 'N/A', 'N/A', '/coins/gx/overview', 1, 'cryptocompare'),
(2002, 680484, 'LCK', 'Luckbox (LCK)', 'Luckbox', 2091, 'N/A', 'N/A', '/coins/lck/overview', 1, 'cryptocompare'),
(2003, 683500, 'MFG', 'SyncFab (MFG)', 'SyncFab', 2092, 'N/A', 'N/A', '/coins/mfg/overview', 1, 'cryptocompare'),
(2004, 683789, 'ETL', 'EtherLite (ETL)', 'EtherLite', 2093, 'N/A', 'N/A', '/coins/etl/overview', 1, 'cryptocompare'),
(2005, 683827, 'TEL', 'Telcoin (TEL)', 'Telcoin', 2094, 'N/A', 'N/A', '/coins/tel/overview', 1, 'cryptocompare'),
(2006, 683927, 'DRG', 'Dragon Coin (DRG)', 'Dragon Coin', 2095, 'N/A', 'N/A', '/coins/drg/overview', 1, 'cryptocompare'),
(2007, 683943, 'BRC*', 'BinaryCoin (BRC*)', 'BinaryCoin', 2096, 'N/A', 'N/A', '/coins/brcstar/overview', 1, 'cryptocompare'),
(2008, 683963, 'SPX*', 'Sp8de (SPX)', 'Sp8de', 2097, 'N/A', 'N/A', '/coins/spx/overview', 1, 'cryptocompare'),
(2009, 684364, 'ONL', 'On.Live (ONL)', 'On.Live', 2098, 'N/A', 'N/A', '/coins/onl/overview', 1, 'cryptocompare'),
(2010, 684747, 'ZAP', 'Zap (ZAP)', 'Zap', 2099, 'N/A', 'N/A', '/coins/zap/overview', 1, 'cryptocompare'),
(2011, 684818, 'AIDOC', 'AI Doctor (AIDOC)', 'AI Doctor', 2100, 'N/A', 'N/A', '/coins/aidoc/overview', 1, 'cryptocompare'),
(2012, 685098, 'ECC', 'ECC (ECC)', 'ECC', 2101, 'Scrypt', 'PoS', '/coins/ecc/overview', 1, 'cryptocompare'),
(2013, 685306, 'ET4', 'Eticket4 (ET4)', 'Eticket4', 2102, 'N/A', 'N/A', '/coins/et4/overview', 1, 'cryptocompare'),
(2014, 688295, 'LCT', 'LendConnect (LCT)', 'LendConnect', 2103, 'N/A', 'N/A', '/coins/lct/overview', 1, 'cryptocompare'),
(2015, 692707, 'EBC', 'EBCoin (EBC)', 'EBCoin', 2104, 'N/A', 'N/A', '/coins/ebc/overview', 1, 'cryptocompare'),
(2016, 692727, 'VST', 'Vestarin (VST)', 'Vestarin', 2105, 'N/A', 'N/A', '/coins/vst/overview', 1, 'cryptocompare'),
(2017, 692839, 'INT', 'Internet Node Token (INT)', 'Internet Node Token', 2106, 'N/A', 'N/A', '/coins/int/overview', 1, 'cryptocompare'),
(2018, 692869, 'CPY', 'COPYTRACK (CPY)', 'COPYTRACK', 2107, 'N/A', 'N/A', '/coins/cpy/overview', 1, 'cryptocompare'),
(2019, 692879, 'STN', 'Steneum Coin (STN)', 'Steneum Coin', 2108, 'Scrypt', 'PoW', '/coins/stn/overview', 1, 'cryptocompare'),
(2020, 693690, 'SFU', 'Saifu (SFU)', 'Saifu', 2109, 'N/A', 'PoS', '/coins/sfu/overview', 1, 'cryptocompare'),
(2021, 694199, 'PCOIN', 'Pioneer Coin (PCOIN)', 'Pioneer Coin', 2110, 'X11', 'PoW', '/coins/pcoin/overview', 1, 'cryptocompare'),
(2022, 694303, 'BLN*', 'Bolenum (BLN*)', 'Bolenum', 2111, 'N/A', 'N/A', '/coins/blnstar/overview', 1, 'cryptocompare'),
(2023, 694313, 'LUC', 'Play 2 Live (LUC)', 'Play 2 Live', 2112, 'N/A', 'N/A', '/coins/luc/overview', 1, 'cryptocompare'),
(2024, 698092, 'EDT', 'EtherDelta (EDT)', 'EtherDelta', 2113, 'N/A', 'N/A', '/coins/edt/overview', 1, 'cryptocompare'),
(2025, 698206, 'CYDER', 'Cyder Coin (CYDER)', 'Cyder Coin', 2114, 'PoS', 'N/A', '/coins/cyder/overview', 1, 'cryptocompare'),
(2026, 698269, 'SRNT', 'Serenity (SRNT)', 'Serenity', 2115, 'N/A', 'N/A', '/coins/srnt/overview', 1, 'cryptocompare'),
(2027, 698425, 'MLT', 'MultiGames (MLT)', 'MultiGames', 2116, 'N/A', 'N/A', '/coins/mlt/overview', 1, 'cryptocompare'),
(2028, 704135, 'EKO', 'EchoLink (EKO)', 'EchoLink', 2117, 'N/A', 'N/A', '/coins/eko/overview', 1, 'cryptocompare'),
(2029, 706900, 'UBTC', 'UnitedBitcoin (UBTC)', 'UnitedBitcoin', 2118, 'SHA256', 'PoW', '/coins/ubtc/overview', 1, 'cryptocompare'),
(2030, 707507, 'BTO', 'Bottos (BTO)', 'Bottos', 2119, 'N/A', 'N/A', '/coins/bto/overview', 1, 'cryptocompare'),
(2031, 707515, 'DOC', 'Doc Coin (DOC)', 'Doc Coin', 2120, 'N/A', 'N/A', '/coins/doc/overview', 1, 'cryptocompare'),
(2032, 707530, 'ARCT', 'ArbitrageCT (ARCT)', 'ArbitrageCT', 2121, 'N/A', 'N/A', '/coins/arct/overview', 1, 'cryptocompare'),
(2033, 708401, 'IMV', 'ImmVRse (IMV)', 'ImmVRse', 2122, 'N/A', 'N/A', '/coins/imv/overview', 1, 'cryptocompare'),
(2034, 708404, 'AURA', 'Aurora (AURA)', 'Aurora', 2123, 'N/A', 'N/A', '/coins/aura/overview', 1, 'cryptocompare'),
(2035, 708873, 'IDH', 'IndaHash (IDH)', 'IndaHash', 2124, 'N/A', 'N/A', '/coins/idh/overview', 1, 'cryptocompare'),
(2036, 709053, 'CBT', 'CommerceBlock Token (CBT)', 'CommerceBlock Token', 2125, 'N/A', 'N/A', '/coins/cbt/overview', 1, 'cryptocompare'),
(2037, 709089, 'ITZ', 'Interzone (ITZ)', 'Interzone', 2126, 'C11', 'PoW', '/coins/itz/overview', 1, 'cryptocompare'),
(2038, 710087, 'XBP', 'Black Pearl Coin (XBP)', 'Black Pearl Coin', 2127, 'X13', 'PoW/PoS', '/coins/xbp/overview', 1, 'cryptocompare'),
(2039, 710098, 'EXRN', 'EXRNchain (EXRN)', 'EXRNchain', 2128, 'N/A', 'N/A', '/coins/exrn/overview', 1, 'cryptocompare'),
(2040, 710156, 'AGI', 'SingularityNET (AGI)', 'SingularityNET', 2129, 'N/A', 'N/A', '/coins/agi/overview', 1, 'cryptocompare'),
(2041, 710240, 'BFT', 'BF Token (BFT)', 'BF Token', 2130, 'N/A', 'N/A', '/coins/bft/overview', 1, 'cryptocompare'),
(2042, 710370, 'LGO', 'Legolas Exchange (LGO)', 'Legolas Exchange', 2131, 'N/A', 'N/A', '/coins/lgo/overview', 1, 'cryptocompare'),
(2043, 710597, 'CRPT', 'Crypterium (CRPT)', 'Crypterium', 2132, 'N/A', 'N/A', '/coins/crpt/overview', 1, 'cryptocompare'),
(2044, 711086, 'SGL', 'Sigil (SGL)', 'Sigil', 2133, 'NeoScrypt', 'PoW', '/coins/sgl/overview', 1, 'cryptocompare'),
(2045, 711252, 'TNC', 'Trinity Network Credit (TNC)', 'Trinity Network Credit', 2134, 'N/A', 'N/A', '/coins/tnc/overview', 1, 'cryptocompare'),
(2046, 711359, 'FSBT', 'Forty Seven Bank (FSBT)', 'Forty Seven Bank', 2135, 'N/A', 'N/A', '/coins/fsbt/overview', 1, 'cryptocompare'),
(2047, 711418, 'CFTY', 'Crafty (CFTY)', 'Crafty', 2136, 'N/A', 'N/A', '/coins/cfty/overview', 1, 'cryptocompare'),
(2048, 713186, 'DTA', 'Data (DTA)', 'Data', 2137, 'N/A', 'N/A', '/coins/dta/overview', 1, 'cryptocompare'),
(2049, 713925, 'CV', 'CarVertical (CV)', 'CarVertical', 2138, 'N/A', 'N/A', '/coins/cv/overview', 1, 'cryptocompare'),
(2050, 713947, 'DTX', 'DataBroker DAO (DTX)', 'DataBroker DAO', 2139, 'N/A', 'N/A', '/coins/dtx/overview', 1, 'cryptocompare'),
(2051, 714167, 'MCU', 'MediChain (MCU)', 'MediChain', 2140, 'N/A', 'N/A', '/coins/mcu/overview', 1, 'cryptocompare'),
(2052, 714255, 'OCN', 'Odyssey (OCN)', 'Odyssey', 2141, 'N/A', 'N/A', '/coins/ocn/overview', 1, 'cryptocompare'),
(2053, 714811, 'THETA', 'Theta (THETA)', 'Theta', 2142, 'N/A', 'N/A', '/coins/theta/overview', 1, 'cryptocompare'),
(2054, 714866, 'MDT*', 'Measurable Data Token  (MDT*)', 'Measurable Data Token ', 2143, 'N/A', 'N/A', '/coins/mdtstar/overview', 1, 'cryptocompare'),
(2055, 715622, 'PRPS', 'Purpose (PRPS)', 'Purpose', 2144, 'N/A', 'N/A', '/coins/prps/overview', 1, 'cryptocompare'),
(2056, 715640, 'DUBI', 'Decentralized Universal Basic Income (DUBI)', 'Decentralized Universal Basic Income', 2145, 'N/A', 'N/A', '/coins/dubi/overview', 1, 'cryptocompare'),
(2057, 715749, 'BPT', 'Blockport (BPT)', 'Blockport', 2146, 'N/A', 'N/A', '/coins/bpt/overview', 1, 'cryptocompare'),
(2058, 715817, 'SGN', 'Signals Network (SGN)', 'Signals Network', 2147, 'N/A', 'N/A', '/coins/sgn/overview', 1, 'cryptocompare'),
(2059, 716522, 'IOST', 'IOS token (IOST)', 'IOS token', 2148, 'N/A', 'N/A', '/coins/iost/overview', 1, 'cryptocompare'),
(2060, 716574, 'TCT', 'TokenClub  (TCT)', 'TokenClub ', 2149, 'N/A', 'N/A', '/coins/tct/overview', 1, 'cryptocompare'),
(2061, 716641, 'TRAC', 'OriginTrail (TRAC)', 'OriginTrail', 2150, 'N/A', 'N/A', '/coins/trac/overview', 1, 'cryptocompare'),
(2062, 716659, 'MOT', 'Olympus Labs (MOT)', 'Olympus Labs', 2151, 'N/A', 'N/A', '/coins/mot/overview', 1, 'cryptocompare'),
(2063, 716725, 'ZIL', 'Zilliqa (ZIL)', 'Zilliqa', 2152, 'N/A', 'N/A', '/coins/zil/overview', 1, 'cryptocompare'),
(2064, 716736, 'HORSE', 'Ethorse  (HORSE)', 'Ethorse ', 2153, 'N/A', 'N/A', '/coins/horse/overview', 1, 'cryptocompare'),
(2065, 716767, 'QUN', 'QunQun (QUN)', 'QunQun', 2154, 'N/A', 'N/A', '/coins/qun/overview', 1, 'cryptocompare'),
(2066, 716795, 'QBT*', 'Qbao (QBT*)', 'Qbao', 2155, 'N/A', 'N/A', '/coins/qbtstar/overview', 1, 'cryptocompare'),
(2067, 716854, 'ACC*', 'Accelerator Network (ACC*)', 'Accelerator Network', 2156, 'N/A', 'N/A', '/coins/accstar/overview', 1, 'cryptocompare'),
(2068, 718353, 'SWFTC', 'SwftCoin (SWFTC)', 'SwftCoin', 2157, 'N/A', 'N/A', '/coins/swftc/overview', 1, 'cryptocompare'),
(2069, 718363, 'SENT', 'Sentinel (SENT)', 'Sentinel', 2158, 'N/A', 'N/A', '/coins/sent/overview', 1, 'cryptocompare'),
(2070, 718398, 'IPL', 'InsurePal (IPL)', 'InsurePal', 2159, 'N/A', 'N/A', '/coins/ipl/overview', 1, 'cryptocompare'),
(2071, 718435, 'OPC', 'OP Coin (OPC)', 'OP Coin', 2160, 'Scrypt', 'PoW/PoS', '/coins/opc/overview', 1, 'cryptocompare'),
(2072, 718463, 'SAF', 'Safinus (SAF)', 'Safinus', 2161, 'N/A', 'N/A', '/coins/saf/overview', 1, 'cryptocompare'),
(2073, 718565, 'SHA', 'Shacoin (SHA)', 'Shacoin', 2162, 'SHA256', 'PoS', '/coins/sha/overview', 1, 'cryptocompare'),
(2074, 718673, 'PYLNT', 'Pylon Network (PYLNT)', 'Pylon Network', 2163, 'N/A', 'N/A', '/coins/pylnt/overview', 1, 'cryptocompare'),
(2075, 718975, 'GRLC', 'Garlicoin (GRLC)', 'Garlicoin', 2164, 'N/A', 'Scrypt-adapt', '/coins/grlc/overview', 1, 'cryptocompare'),
(2076, 719223, 'EVE', 'Devery (EVE)', 'Devery', 2166, 'N/A', 'N/A', '/coins/eve/overview', 1, 'cryptocompare'),
(2077, 719272, 'YEE', 'Yee (YEE)', 'Yee', 2167, 'N/A', 'N/A', '/coins/yee/overview', 1, 'cryptocompare'),
(2078, 719307, 'REPUX', 'Repux (REPUX)', 'Repux', 2168, 'N/A', 'N/A', '/coins/repux/overview', 1, 'cryptocompare'),
(2079, 719361, 'JOY', 'JoyToken (JOY)', 'JoyToken', 2169, 'N/A', 'N/A', '/coins/joy/overview', 1, 'cryptocompare'),
(2080, 719426, 'GTC*', 'Global Tour Coin (GTC*)', 'Global Tour Coin', 2170, 'Scrypt', 'N/A', '/coins/gtcstar/overview', 1, 'cryptocompare'),
(2081, 726598, 'XCD*', 'Capdax (XCD*)', 'Capdax', 2171, 'N/A', 'N/A', '/coins/xcdstar/overview', 1, 'cryptocompare'),
(2082, 727150, 'BTW', 'BitWhite (BTW)', 'BitWhite', 2172, 'DPoS', 'DPoS', '/coins/btw/overview', 1, 'cryptocompare'),
(2083, 727769, 'AXPR', 'aXpire (AXPR)', 'aXpire', 2173, 'N/A', 'N/A', '/coins/axpr/overview', 1, 'cryptocompare'),
(2084, 729627, 'FOTA', 'Fortuna (FOTA)', 'Fortuna', 2174, 'N/A', 'N/A', '/coins/fota/overview', 1, 'cryptocompare'),
(2085, 729809, 'DDD', 'Scry.info (DDD)', 'Scry.info', 2175, 'N/A', 'N/A', '/coins/ddd/overview', 1, 'cryptocompare'),
(2086, 730988, 'CPC*', 'CPChain (CPC*)', 'CPChain', 2176, 'N/A', 'N/A', '/coins/cpcstar/overview', 1, 'cryptocompare'),
(2087, 731042, 'SPEND', 'Spend (SPEND)', 'Spend', 2177, 'N/A', 'N/A', '/coins/spend/overview', 1, 'cryptocompare'),
(2088, 731516, 'NPXS', 'Pundi X (NPXS)', 'Pundi X', 2178, 'N/A', 'N/A', '/coins/npxs/overview', 1, 'cryptocompare'),
(2089, 731559, 'ZPT', 'Zeepin (ZPT)', 'Zeepin', 2179, 'N/A', 'N/A', '/coins/zpt/overview', 1, 'cryptocompare'),
(2090, 731596, 'CROAT', 'Croat (CROAT)', 'Croat', 2180, 'CryptoNight', 'PoW', '/coins/croat/overview', 1, 'cryptocompare'),
(2091, 731629, 'REF', 'RefToken (REF)', 'RefToken', 2181, 'N/A', 'N/A', '/coins/ref/overview', 1, 'cryptocompare'),
(2092, 731917, 'SXDT', 'SPECTRE Dividend Token (SXDT)', 'SPECTRE Dividend Token', 2182, 'N/A', 'N/A', '/coins/sxdt/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(2093, 731943, 'SXUT', 'SPECTRE Utility Token (SXUT)', 'SPECTRE Utility Token', 2183, 'N/A', 'N/A', '/coins/sxut/overview', 1, 'cryptocompare'),
(2094, 732021, 'LDC', 'LeadCoin (LDC)', 'LeadCoin', 2184, 'N/A', 'N/A', '/coins/ldc/overview', 1, 'cryptocompare'),
(2095, 732098, 'FAIR*', 'FairGame (FAIR*)', 'FairGame', 2185, 'N/A', 'N/A', '/coins/fairstar/overview', 1, 'cryptocompare'),
(2096, 732147, 'VAL', 'Valorbit (VAL)', 'Valorbit', 2186, 'Scrypt', 'PoW/PoS', '/coins/val/overview', 1, 'cryptocompare'),
(2097, 732161, 'MAN*', 'Matrix AI Network (MAN*)', 'Matrix AI Network', 2187, 'N/A', 'N/A', '/coins/manstar/overview', 1, 'cryptocompare'),
(2098, 732197, 'BCDN', 'BlockCDN  (BCDN)', 'BlockCDN ', 2188, 'N/A', 'N/A', '/coins/bcdn/overview', 1, 'cryptocompare'),
(2099, 734584, 'STK', 'STK Token (STK)', 'STK Token', 2189, 'N/A', 'N/A', '/coins/stk/overview', 1, 'cryptocompare'),
(2100, 736230, 'MZX', 'Mosaic Network (MZX)', 'Mosaic Network', 2190, 'N/A', 'N/A', '/coins/mzx/overview', 1, 'cryptocompare'),
(2101, 737393, 'CRC**', 'CryCash (CRC**)', 'CryCash', 2191, 'N/A', 'N/A', '/coins/crcstarstar/overview', 1, 'cryptocompare'),
(2102, 737883, 'SPICE', 'SPiCE Venture Capital  (SPICE)', 'SPiCE Venture Capital ', 2192, 'N/A', 'N/A', '/coins/spice/overview', 1, 'cryptocompare'),
(2103, 740271, 'Q1S', 'Quantum1Net (Q1S)', 'Quantum1Net', 2193, 'N/A', 'N/A', '/coins/q1s/overview', 1, 'cryptocompare'),
(2104, 744820, 'POLY*', 'Polymath Network (POLY*)', 'Polymath Network', 2194, 'N/A', 'N/A', '/coins/polystar/overview', 1, 'cryptocompare'),
(2105, 744880, 'XTO', 'Tao (XTO)', 'Tao', 2195, 'X11', 'PoW/PoS', '/coins/xto/overview', 1, 'cryptocompare'),
(2106, 744910, 'RUFF', 'Ruff (RUFF)', 'Ruff', 2196, 'N/A', 'N/A', '/coins/ruff/overview', 1, 'cryptocompare'),
(2107, 744987, 'ELA', 'Elastos (ELA)', 'Elastos', 2197, 'N/A', 'N/A', '/coins/ela/overview', 1, 'cryptocompare'),
(2108, 745017, 'TPAY*', 'TokenPay (TPAY*)', 'TokenPay', 2198, 'POS 3.0', 'PoS', '/coins/tpaystar/overview', 1, 'cryptocompare'),
(2109, 745054, 'CXO', 'CargoX (CXO)', 'CargoX', 2199, 'N/A', 'N/A', '/coins/cxo/overview', 1, 'cryptocompare'),
(2110, 746288, 'WT', 'WeToken (WT)', 'WeToken', 2201, 'N/A', 'N/A', '/coins/wt/overview', 1, 'cryptocompare'),
(2111, 746316, 'HGS', 'HashGains (HGS)', 'HashGains', 2202, 'N/A', 'N/A', '/coins/hgs/overview', 1, 'cryptocompare'),
(2112, 748858, 'SISA', 'Strategic Investments in Significant Areas (SISA)', 'Strategic Investments in Significant Areas', 2203, 'N/A', 'N/A', '/coins/sisa/overview', 1, 'cryptocompare'),
(2113, 748907, 'EBIT', 'eBit (EBIT)', 'eBit', 2204, 'N/A', 'N/A', '/coins/ebit/overview', 1, 'cryptocompare'),
(2114, 749006, 'RCT', 'RealChain (RCT)', 'RealChain', 2206, 'N/A', 'N/A', '/coins/rct/overview', 1, 'cryptocompare'),
(2115, 749450, 'CUZ', 'Cool Cousin (CUZ)', 'Cool Cousin', 2209, 'N/A', 'N/A', '/coins/cuz/overview', 1, 'cryptocompare'),
(2116, 749620, 'HLC', 'Halal-Chain (HLC)', 'Halal-Chain', 2210, 'N/A', 'N/A', '/coins/hlc/overview', 1, 'cryptocompare'),
(2117, 749857, 'BETR', 'BetterBetting (BETR)', 'BetterBetting', 2211, 'N/A', 'N/A', '/coins/betr/overview', 1, 'cryptocompare'),
(2118, 750091, 'GMR', 'Gimmer (GMR)', 'Gimmer', 2213, 'N/A', 'N/A', '/coins/gmr/overview', 1, 'cryptocompare'),
(2119, 750134, 'ING', 'Iungo (ING)', 'Iungo', 2214, 'N/A', 'N/A', '/coins/ing/overview', 1, 'cryptocompare'),
(2120, 750272, 'LHC', 'LHCoin (LHC)', 'LHCoin', 2215, 'N/A', 'N/A', '/coins/lhc/overview', 1, 'cryptocompare'),
(2121, 752710, 'BLZ', 'Bluzelle (BLZ)', 'Bluzelle', 2216, 'N/A', 'N/A', '/coins/blz/overview', 1, 'cryptocompare'),
(2122, 752863, 'HALAL', 'Halal (HALAL)', 'Halal', 2217, 'N/A', 'N/A', '/coins/halal/overview', 1, 'cryptocompare'),
(2123, 752942, 'CRAVE*', 'Crave-NG (CRAVE*)', 'Crave-NG', 2218, 'SHA256', 'PoS', '/coins/cravestar/overview', 1, 'cryptocompare'),
(2124, 752993, 'CHSB', 'SwissBorg (CHSB)', 'SwissBorg', 2219, 'N/A', 'N/A', '/coins/chsb/overview', 1, 'cryptocompare'),
(2125, 753333, 'EQUI', 'EQUI Token (EQUI)', 'EQUI Token', 2220, 'N/A', 'N/A', '/coins/equi/overview', 1, 'cryptocompare'),
(2126, 753511, 'MCT', '1717 Masonic Commemorative Token (MCT)', '1717 Masonic Commemorative Token', 2221, 'Ethash', 'PoS', '/coins/mct/overview', 1, 'cryptocompare'),
(2127, 753658, 'HHEM', 'Healthureum (HHEM)', 'Healthureum', 2222, 'N/A', 'N/A', '/coins/hhem/overview', 1, 'cryptocompare'),
(2128, 753690, 'CWIS', 'Crypto Wisdom Coin (CWIS)', 'Crypto Wisdom Coin', 2223, 'Scrypt', 'PoW', '/coins/cwis/overview', 1, 'cryptocompare'),
(2129, 753824, 'MBC', 'My Big Coin (MBC)', 'My Big Coin', 2224, 'Scrypt', 'PoW and PoS', '/coins/mbc/overview', 1, 'cryptocompare'),
(2130, 755352, 'GRO', 'Gron Digital (GRO)', 'Gron Digital', 2225, 'N/A', 'N/A', '/coins/gro/overview', 1, 'cryptocompare'),
(2131, 755563, 'SWM', 'Swarm Fund (SWM)', 'Swarm Fund', 2226, 'N/A', 'N/A', '/coins/swm/overview', 1, 'cryptocompare'),
(2132, 755707, 'MTN*', 'Medicalchain (MTN*)', 'Medicalchain', 2227, 'N/A', 'N/A', '/coins/mtnstar/overview', 1, 'cryptocompare'),
(2133, 756132, 'WBTC', 'WorldBTC (WBTC)', 'WorldBTC', 2229, 'Scrypt', 'PoW/PoS', '/coins/wbtc/overview', 1, 'cryptocompare'),
(2134, 756639, 'DNO', 'Denaro (DNO)', 'Denaro', 2231, 'N/A', 'N/A', '/coins/dno/overview', 1, 'cryptocompare'),
(2135, 756726, 'eFIC', 'FIC Network (eFIC)', 'FIC Network', 2232, 'N/A', 'N/A', '/coins/efic/overview', 1, 'cryptocompare'),
(2136, 757542, 'TKY', 'THEKEY Token (TKY)', 'THEKEY Token', 2235, 'NeoScrypt', 'N/A', '/coins/tky/overview', 1, 'cryptocompare'),
(2137, 757568, 'BANCA', 'BANCA (BANCA)', 'BANCA', 2236, 'N/A', 'N/A', '/coins/banca/overview', 1, 'cryptocompare'),
(2138, 757589, 'TRTL', 'TurtleCoin (TRTL)', 'TurtleCoin', 2237, 'CryptoNight', 'PoW', '/coins/trtl/overview', 1, 'cryptocompare'),
(2139, 757969, 'BIX', 'BiboxCoin (BIX)', 'BiboxCoin', 2240, 'N/A', 'N/A', '/coins/bix/overview', 1, 'cryptocompare'),
(2140, 758055, 'ABT*', 'ArcBlock (ABT)', 'ArcBlock', 2241, 'N/A', 'N/A', '/coins/abt/overview', 1, 'cryptocompare'),
(2141, 758066, 'HBZ', 'Helbiz (HBZ)', 'Helbiz', 2242, 'N/A', 'N/A', '/coins/hbz/overview', 1, 'cryptocompare'),
(2142, 760878, 'CARE*', 'Care Token (CARE*)', 'Care Token', 2243, 'N/A', 'N/A', '/coins/carestar/overview', 1, 'cryptocompare'),
(2143, 763535, 'DRPU', 'DRP Utility (DRPU)', 'DRP Utility', 2244, 'N/A', 'N/A', '/coins/drpu/overview', 1, 'cryptocompare'),
(2144, 763639, 'DOR', 'Dorado (DOR)', 'Dorado', 2245, 'Ethash', 'N/A', '/coins/dor/overview', 1, 'cryptocompare'),
(2145, 763700, 'PRFT', 'Proof Suite Token (PRFT)', 'Proof Suite Token', 2246, 'N/A', 'PoS', '/coins/prft/overview', 1, 'cryptocompare'),
(2146, 763768, 'PARETO', 'Pareto Network Token (PARETO)', 'Pareto Network Token', 2247, 'N/A', 'N/A', '/coins/pareto/overview', 1, 'cryptocompare'),
(2147, 764096, 'DTRC', 'Datarius (DTRC)', 'Datarius', 2252, 'N/A', 'N/A', '/coins/dtrc/overview', 1, 'cryptocompare'),
(2148, 764104, 'IQB', 'Intelligence Quotient Benefit (IQB)', 'Intelligence Quotient Benefit', 2253, 'N/A', 'N/A', '/coins/iqb/overview', 1, 'cryptocompare'),
(2149, 764255, 'NDC*', 'NeedleCoin (NDC*)', 'NeedleCoin', 2256, 'X11', 'PoS/PoW', '/coins/ndcstar/overview', 1, 'cryptocompare'),
(2150, 764334, 'BEE', 'Bee Token (BEE)', 'Bee Token', 2258, 'N/A', 'N/A', '/coins/bee/overview', 1, 'cryptocompare'),
(2151, 764438, 'MUN', 'MUNcoin (MUN)', 'MUNcoin', 2259, 'SkunkHash', 'PoW', '/coins/mun/overview', 1, 'cryptocompare'),
(2152, 765383, 'TIG', 'Tigereum (TIG)', 'Tigereum', 2260, 'N/A', 'N/A', '/coins/tig/overview', 1, 'cryptocompare'),
(2153, 765465, 'LYK', 'Loyakk Vega (LYK)', 'Loyakk Vega', 2261, 'N/A', 'N/A', '/coins/lyk/overview', 1, 'cryptocompare'),
(2154, 765701, 'NYX', 'NYXCOIN (NYX)', 'NYXCOIN', 2263, 'NeoScrypt', 'PoW', '/coins/nyx/overview', 1, 'cryptocompare'),
(2155, 765943, 'DXT', 'DataWallet (DXT)', 'DataWallet', 2267, 'N/A', 'N/A', '/coins/dxt/overview', 1, 'cryptocompare'),
(2156, 766212, 'SAT', 'Satisfaction Token (SAT)', 'Satisfaction Token', 2271, 'N/A', 'N/A', '/coins/sat/overview', 1, 'cryptocompare'),
(2157, 766461, 'CRL', 'Cryptelo Coin (CRL)', 'Cryptelo Coin', 2273, 'N/A', 'N/A', '/coins/crl/overview', 1, 'cryptocompare'),
(2158, 766681, 'ORI', 'Origami (ORI)', 'Origami', 2274, 'N/A', 'N/A', '/coins/ori/overview', 1, 'cryptocompare'),
(2159, 767260, 'LYM', 'Lympo (LYM)', 'Lympo', 2275, 'N/A', 'N/A', '/coins/lym/overview', 1, 'cryptocompare'),
(2160, 767334, 'USX', 'Unified Society USDEX (USX)', 'Unified Society USDEX', 2276, 'Scrypt', 'PoW/PoS', '/coins/usx/overview', 1, 'cryptocompare'),
(2161, 767363, 'LGR', 'Logarithm (LGR)', 'Logarithm', 2277, 'Ethash', 'N/A', '/coins/lgr/overview', 1, 'cryptocompare'),
(2162, 767384, 'BCA', 'Bitcoin Atom (BCA)', 'Bitcoin Atom', 2278, 'SHA256', 'PoW/PoS', '/coins/bca/overview', 1, 'cryptocompare'),
(2163, 767409, 'B2X', 'SegWit2x (B2X)', 'SegWit2x', 2279, 'X11', 'PoW/PoS', '/coins/b2x/overview', 1, 'cryptocompare'),
(2164, 767755, 'EXMR', 'eXMR Monero (EXMR)', 'eXMR Monero', 2281, 'N/A', 'PoW/PoS', '/coins/exmr/overview', 1, 'cryptocompare'),
(2165, 768219, 'FSN', 'Fusion (FSN)', 'Fusion', 2283, 'N/A', 'N/A', '/coins/fsn/overview', 1, 'cryptocompare'),
(2166, 769367, 'UETL', 'Useless Eth Token Lite (UETL)', 'Useless Eth Token Lite', 2284, 'N/A', 'N/A', '/coins/uetl/overview', 1, 'cryptocompare'),
(2167, 769415, 'NBR', 'Niobio Cash (NBR)', 'Niobio Cash', 2285, 'CryptoNight', 'PoW', '/coins/nbr/overview', 1, 'cryptocompare'),
(2168, 769416, 'ARY', 'Block Array (ARY)', 'Block Array', 2286, 'N/A', 'N/A', '/coins/ary/overview', 1, 'cryptocompare'),
(2169, 769460, 'RAVE', 'Ravelous (RAVE)', 'Ravelous', 2287, 'N/A', 'N/A', '/coins/rave/overview', 1, 'cryptocompare'),
(2170, 769483, 'ILT', 'iOlite (ILT)', 'iOlite', 2288, 'Ethash', 'PoW', '/coins/ilt/overview', 1, 'cryptocompare'),
(2171, 769499, 'SCOOBY', 'Scooby coin (SCOOBY)', 'Scooby coin', 2289, 'Scrypt', 'PoW/PoS', '/coins/scooby/overview', 1, 'cryptocompare'),
(2172, 769546, 'DAI', 'Dai (DAI)', 'Dai', 2290, 'N/A', 'N/A', '/coins/dai/overview', 1, 'cryptocompare'),
(2173, 769708, 'CEFS', 'CryptopiaFeeShares (CEFS)', 'CryptopiaFeeShares', 2291, 'N/A', 'N/A', '/coins/cefs/overview', 1, 'cryptocompare'),
(2174, 769735, 'MINT*', 'Mineable Token (MINT*)', 'Mineable Token', 2292, 'Ethash', 'N/A', '/coins/mintstar/overview', 1, 'cryptocompare'),
(2175, 769759, 'BUN', 'BunnyCoin (BUN)', 'BunnyCoin', 2293, 'Scrypt', 'PoW', '/coins/bun/overview', 1, 'cryptocompare'),
(2176, 769824, 'BSR', 'BitSoar Coin (BSR)', 'BitSoar Coin', 2295, 'X11', 'PoS', '/coins/bsr/overview', 1, 'cryptocompare'),
(2177, 769855, 'SKULL', 'Pirate Blocks (SKULL)', 'Pirate Blocks', 2296, 'X11', 'PoW/PoS', '/coins/skull/overview', 1, 'cryptocompare'),
(2178, 769862, 'TRDT', 'Trident (TRDT)', 'Trident', 2297, 'N/A', 'N/A', '/coins/trdt/overview', 1, 'cryptocompare'),
(2179, 769965, 'XBTY', 'Bounty (XBTY)', 'Bounty', 2299, 'N/A', 'N/A', '/coins/xbty/overview', 1, 'cryptocompare'),
(2180, 770043, 'JC', 'JesusCoin (JC)', 'JesusCoin', 2300, 'N/A', 'N/A', '/coins/jc/overview', 1, 'cryptocompare'),
(2181, 770095, 'BTCP', 'Bitcoin Private (BTCP)', 'Bitcoin Private', 2301, 'Equihash', 'PoW', '/coins/btcp/overview', 1, 'cryptocompare'),
(2182, 770118, 'SKC', 'Skeincoin (SKC)', 'Skeincoin', 2302, 'Skein', 'PoW', '/coins/skc/overview', 1, 'cryptocompare'),
(2183, 770254, 'MWAT', 'RED MegaWatt (MWAT)', 'RED MegaWatt', 2303, 'N/A', 'N/A', '/coins/mwat/overview', 1, 'cryptocompare'),
(2184, 771061, 'JEW', 'Shekel (JEW)', 'Shekel', 2304, 'Quark', 'PoS', '/coins/jew/overview', 1, 'cryptocompare'),
(2185, 771092, 'ERT*', 'Eristica (ERT*)', 'Eristica', 2305, 'N/A', 'N/A', '/coins/ertstar/overview', 1, 'cryptocompare'),
(2186, 771553, 'KRM', 'Karma (KRM)', 'Karma', 2307, 'Groestl', 'PoS', '/coins/krm/overview', 1, 'cryptocompare'),
(2187, 771595, 'HT', 'Huobi Token (HT)', 'Huobi Token', 2308, 'N/A', 'N/A', '/coins/ht/overview', 1, 'cryptocompare'),
(2188, 771678, 'CDY', 'Bitcoin Candy (CDY)', 'Bitcoin Candy', 2309, 'Equihash', 'PoW', '/coins/cdy/overview', 1, 'cryptocompare'),
(2189, 771723, 'SSS', 'ShareChain (SSS)', 'ShareChain', 2310, 'Scrypt', 'PoW', '/coins/sss/overview', 1, 'cryptocompare'),
(2190, 771782, 'CRDNC', 'Credence Coin (CRDNC)', 'Credence Coin', 2311, 'SHA256', 'PoW/PoS', '/coins/crdnc/overview', 1, 'cryptocompare'),
(2191, 771805, 'BIFI', 'BitcoinFile (BIFI)', 'BitcoinFile', 2312, 'N/A', 'PoS', '/coins/bifi/overview', 1, 'cryptocompare'),
(2192, 776803, 'CAN*', 'Content and AD Network (CAN*)', 'Content and AD Network', 2314, 'N/A', 'N/A', '/coins/canstar/overview', 1, 'cryptocompare'),
(2193, 776828, 'BTF', 'Blockchain Traded Fund (BTF)', 'Blockchain Traded Fund', 2315, 'N/A', 'N/A', '/coins/btf/overview', 1, 'cryptocompare'),
(2194, 776863, 'IPC*', 'IPChain (IPC*)', 'IPChain', 2316, 'N/A', 'PoS', '/coins/ipcstar/overview', 1, 'cryptocompare'),
(2195, 776896, 'SHOW', 'ShowCoin (SHOW)', 'ShowCoin', 2317, 'N/A', 'PoS', '/coins/show/overview', 1, 'cryptocompare'),
(2196, 776935, 'STC', 'StarChain (STC)', 'StarChain', 2318, 'N/A', 'N/A', '/coins/stc/overview', 1, 'cryptocompare'),
(2197, 777007, 'NEC*', 'Ethfinex Nectar Token (NEC*)', 'Ethfinex Nectar Token', 2320, 'N/A', 'N/A', '/coins/necstar/overview', 1, 'cryptocompare'),
(2198, 777027, 'AIT', 'AIChain Token (AIT)', 'AIChain Token', 2321, 'N/A', 'N/A', '/coins/ait/overview', 1, 'cryptocompare'),
(2199, 777187, 'STQ', 'Storiqa Token (STQ)', 'Storiqa Token', 2322, 'N/A', 'N/A', '/coins/stq/overview', 1, 'cryptocompare'),
(2200, 777330, 'ALT', 'ALTcoin (ALT)', 'ALTcoin', 2323, 'SHA256', 'N/A', '/coins/alt/overview', 1, 'cryptocompare'),
(2201, 777368, 'TRF', 'Travelflex (TRF)', 'Travelflex', 2324, 'Dagger', 'PoW', '/coins/trf/overview', 1, 'cryptocompare'),
(2202, 777407, 'KB3', 'B3Coin (KB3)', 'B3Coin', 2325, 'X11', 'PoS/PoD', '/coins/kb3/overview', 1, 'cryptocompare'),
(2203, 777557, 'FDX', 'fidentiaX (FDX)', 'fidentiaX', 2327, 'N/A', 'PoS', '/coins/fdx/overview', 1, 'cryptocompare'),
(2204, 777643, 'KREDS', 'KREDS (KREDS)', 'KREDS', 2329, 'Lyra2REv2', 'PoW', '/coins/kreds/overview', 1, 'cryptocompare'),
(2205, 777667, 'EQL', 'EQUAL (EQL)', 'EQUAL', 2330, 'N/A', 'N/A', '/coins/eql/overview', 1, 'cryptocompare'),
(2206, 777701, 'GAI', 'GraphGrail AI (GAI)', 'GraphGrail AI', 2331, 'N/A', 'N/A', '/coins/gai/overview', 1, 'cryptocompare'),
(2207, 777717, 'VULC', 'Vulcano (VULC)', 'Vulcano', 2332, 'Scrypt', 'PoS/PoW', '/coins/vulc/overview', 1, 'cryptocompare'),
(2208, 777990, 'CRE*', 'Creditcoin (CRE*)', 'Creditcoin', 2333, 'N/A', 'N/A', '/coins/crestar/overview', 1, 'cryptocompare'),
(2209, 778908, 'DTC**', 'DivotyCoin (DTC**)', 'DivotyCoin', 2335, 'Scrypt', 'PoW/PoS', '/coins/dtcstarstar/overview', 1, 'cryptocompare'),
(2210, 778953, 'DADI', 'DADI (DADI)', 'DADI', 2336, 'N/A', 'N/A', '/coins/dadi/overview', 1, 'cryptocompare'),
(2211, 778961, 'MAG**', 'Maggie Token (MAG**)', 'Maggie Token', 2337, 'N/A', 'N/A', '/coins/magstarstar/overview', 1, 'cryptocompare'),
(2212, 779014, 'TOKC', 'Tokyo Coin (TOKC)', 'Tokyo Coin', 2338, 'X13', 'PoS', '/coins/tokc/overview', 1, 'cryptocompare'),
(2213, 779032, 'UNRC', 'UniversalRoyalCoin (UNRC)', 'UniversalRoyalCoin', 2339, 'SHA256', 'PoS', '/coins/unrc/overview', 1, 'cryptocompare'),
(2214, 779041, 'BBP', 'BiblePay (BBP)', 'BiblePay', 2340, 'Proof-of-Bib', 'POBh', '/coins/bbp/overview', 1, 'cryptocompare'),
(2215, 779335, 'NOX', 'NITRO (NOX)', 'NITRO', 2342, 'N/A', 'N/A', '/coins/nox/overview', 1, 'cryptocompare'),
(2216, 779488, 'HYS', 'Heiss Shares (HYS)', 'Heiss Shares', 2344, 'N/A', 'N/A', '/coins/hys/overview', 1, 'cryptocompare'),
(2217, 779599, 'LCWP', 'LiteCoinW Plus (LCWP)', 'LiteCoinW Plus', 2345, 'N/A', 'N/A', '/coins/lcwp/overview', 1, 'cryptocompare'),
(2218, 780767, 'NAVI', 'NaviAddress (NAVI)', 'NaviAddress', 2346, 'N/A', 'N/A', '/coins/navi/overview', 1, 'cryptocompare'),
(2219, 780883, 'ADI', 'Aditus (ADI)', 'Aditus', 2347, 'N/A', 'N/A', '/coins/adi/overview', 1, 'cryptocompare'),
(2220, 780891, 'TEN', 'Tokenomy (TEN)', 'Tokenomy', 2348, 'N/A', 'N/A', '/coins/ten/overview', 1, 'cryptocompare'),
(2221, 781071, 'FLX*', 'BitFlux (FLX*)', 'BitFlux', 2350, 'N/A', 'N/A', '/coins/flxstar/overview', 1, 'cryptocompare'),
(2222, 781079, 'VVI', 'VV Coin (VVI)', 'VV Coin', 2351, 'N/A', 'N/A', '/coins/vvi/overview', 1, 'cryptocompare'),
(2223, 781308, 'ANK', 'Ankorus Token (ANK)', 'Ankorus Token', 2353, 'N/A', 'N/A', '/coins/ank/overview', 1, 'cryptocompare'),
(2224, 781729, 'HLP', 'Purpose Coin (HLP)', 'Purpose Coin', 2357, 'N/A', 'N/A', '/coins/hlp/overview', 1, 'cryptocompare'),
(2225, 782929, 'VIN', 'VinChain (VIN)', 'VinChain', 2358, 'N/A', 'N/A', '/coins/vin/overview', 1, 'cryptocompare'),
(2226, 782954, 'SHPING', 'Shping Coin (SHPING)', 'Shping Coin', 2359, 'N/A', 'N/A', '/coins/shping/overview', 1, 'cryptocompare'),
(2227, 783293, 'PTR', 'Petro (PTR)', 'Petro', 2360, 'N/A', 'N/A', '/coins/ptr/overview', 1, 'cryptocompare'),
(2228, 784396, 'BCR*', 'Bitcoin Royal (BCR*)', 'Bitcoin Royal', 2364, 'N/A', 'N/A', '/coins/bcrstar/overview', 1, 'cryptocompare'),
(2229, 784462, 'VANY', 'Vanywhere (VANY)', 'Vanywhere', 2365, 'N/A', 'N/A', '/coins/vany/overview', 1, 'cryptocompare'),
(2230, 784553, 'TFD', 'TE-FOOD (TFD)', 'TE-FOOD', 2366, 'N/A', 'N/A', '/coins/tfd/overview', 1, 'cryptocompare'),
(2231, 784589, 'NBX', 'Noxbox (NBX)', 'Noxbox', 2367, 'N/A', 'N/A', '/coins/nbx/overview', 1, 'cryptocompare'),
(2232, 784595, 'BAX', 'BABB (BAX)', 'BABB', 2368, 'N/A', 'N/A', '/coins/bax/overview', 1, 'cryptocompare'),
(2233, 784762, 'BERRY', 'Rentberry (BERRY)', 'Rentberry', 2369, 'N/A', 'N/A', '/coins/berry/overview', 1, 'cryptocompare'),
(2234, 784821, 'SPC*', 'SpaceChain (SPC*)', 'SpaceChain', 2370, 'N/A', 'N/A', '/coins/spcstar/overview', 1, 'cryptocompare'),
(2235, 784981, 'FLIP', 'BitFlip (FLIP)', 'BitFlip', 2371, 'Scrypt', 'PoW', '/coins/flip/overview', 1, 'cryptocompare'),
(2236, 785910, 'CLIN', 'Clinicoin (CLIN)', 'Clinicoin', 2372, 'N/A', 'N/A', '/coins/clin/overview', 1, 'cryptocompare'),
(2237, 786661, 'DHT', 'DeHedge Token (DHT)', 'DeHedge Token', 2373, 'N/A', 'N/A', '/coins/dht/overview', 1, 'cryptocompare'),
(2238, 787620, 'GOOD*', 'Goodomy (GOOD*)', 'Goodomy', 2374, 'N/A', 'N/A', '/coins/goodstar/overview', 1, 'cryptocompare'),
(2239, 787669, 'ENK', 'Enkidu (ENK)', 'Enkidu', 2375, 'N/A', 'N/A', '/coins/enk/overview', 1, 'cryptocompare'),
(2240, 787696, 'ALX', 'ALAX (ALX)', 'ALAX', 2376, 'DPoS', 'DPoS', '/coins/alx/overview', 1, 'cryptocompare'),
(2241, 788239, 'REN', 'Republic Token (REN)', 'Republic Token', 2377, 'N/A', 'N/A', '/coins/ren/overview', 1, 'cryptocompare'),
(2242, 788387, 'DTH', 'Dether (DTH)', 'Dether', 2378, 'N/A', 'N/A', '/coins/dth/overview', 1, 'cryptocompare'),
(2243, 788409, 'SOC', 'All Sports Coin (SOC)', 'All Sports Coin', 2379, 'N/A', 'N/A', '/coins/soc/overview', 1, 'cryptocompare'),
(2244, 788468, 'TDX', 'Tidex Token (TDX)', 'Tidex Token', 2380, 'N/A', 'N/A', '/coins/tdx/overview', 1, 'cryptocompare'),
(2245, 789006, 'LOT', 'LottoCoin (LOT)', 'LottoCoin', 2381, 'Scrypt', 'PoW', '/coins/lot/overview', 1, 'cryptocompare'),
(2246, 789115, 'FUNK', 'Cypherfunks Coin (FUNK)', 'Cypherfunks Coin', 2382, 'Scrypt', 'PoW', '/coins/funk/overview', 1, 'cryptocompare'),
(2247, 789144, 'LEAF', 'LeafCoin (LEAF)', 'LeafCoin', 2383, 'Scrypt', 'PoW', '/coins/leaf/overview', 1, 'cryptocompare'),
(2248, 789170, 'COMP', 'Compound Coin (COMP)', 'Compound Coin', 2384, 'X11', 'PoW/PoS', '/coins/comp/overview', 1, 'cryptocompare'),
(2249, 789256, 'BITCAR', 'BitCar (BITCAR)', 'BitCar', 2385, 'N/A', 'N/A', '/coins/bitcar/overview', 1, 'cryptocompare'),
(2250, 789504, 'CLN', 'Colu Local Network (CLN)', 'Colu Local Network', 2386, 'N/A', 'N/A', '/coins/cln/overview', 1, 'cryptocompare'),
(2251, 789789, 'NIHL', 'Nihilo Coin (NIHL)', 'Nihilo Coin', 2387, 'NeoScrypt', 'PoW/PoS', '/coins/nihl/overview', 1, 'cryptocompare'),
(2252, 791041, 'BASHC', 'BashCoin (BASHC)', 'BashCoin', 2389, 'Skein', 'PoW/PoS', '/coins/bashc/overview', 1, 'cryptocompare'),
(2253, 791053, 'DIGIF', 'DigiFel (DIGIF)', 'DigiFel', 2390, 'X11', 'PoW', '/coins/digif/overview', 1, 'cryptocompare'),
(2254, 791119, 'DGM', 'DigiMoney (DGM)', 'DigiMoney', 2391, 'X11', 'PoW/PoS', '/coins/dgm/overview', 1, 'cryptocompare'),
(2255, 791176, 'CBS', 'Cerberus (CBS)', 'Cerberus', 2392, 'NeoScrypt', 'PoW', '/coins/cbs/overview', 1, 'cryptocompare'),
(2256, 791211, 'MNTS', 'Mint (MNTS)', 'Mint', 2393, 'N/A', 'N/A', '/coins/mnts/overview', 1, 'cryptocompare'),
(2257, 791268, 'TERN', 'Ternio (TERN)', 'Ternio', 2394, 'N/A', 'N/A', '/coins/tern/overview', 1, 'cryptocompare'),
(2258, 791282, 'SVD', 'Savedroid (SVD)', 'Savedroid', 2395, 'N/A', 'N/A', '/coins/svd/overview', 1, 'cryptocompare'),
(2259, 791305, 'PF', 'PROVER (PF)', 'PROVER', 2396, 'N/A', 'N/A', '/coins/pf/overview', 1, 'cryptocompare'),
(2260, 791324, 'BTCH', 'Bitcoin Hush (BTCH)', 'Bitcoin Hush', 2397, 'Equihash', 'PoW', '/coins/btch/overview', 1, 'cryptocompare'),
(2261, 791484, 'redBUX', 'redBUX (redBUX)', 'redBUX', 2398, 'N/A', 'N/A', '/coins/redbux/overview', 1, 'cryptocompare'),
(2262, 792023, 'AUC', 'Auctus (AUC)', 'Auctus', 2399, 'N/A', 'N/A', '/coins/auc/overview', 1, 'cryptocompare'),
(2263, 792136, 'LIZ', 'Lizus Payment (LIZ)', 'Lizus Payment', 2400, 'Skein', 'PoW/PoS', '/coins/liz/overview', 1, 'cryptocompare'),
(2264, 792268, 'CIF', 'Crypto Improvement Fund (CIF)', 'Crypto Improvement Fund', 2401, 'X11', 'PoW', '/coins/cif/overview', 1, 'cryptocompare'),
(2265, 792548, 'NCASH', 'Nucleus Vision (NCASH)', 'Nucleus Vision', 2402, 'N/A', 'N/A', '/coins/ncash/overview', 1, 'cryptocompare'),
(2266, 792725, 'SPD', 'Stipend (SPD)', 'Stipend', 2403, 'C11', 'PoW/PoS', '/coins/spd/overview', 1, 'cryptocompare'),
(2267, 793021, 'CMCT', 'Crowd Machine (CMCT)', 'Crowd Machine', 2404, 'N/A', 'N/A', '/coins/cmct/overview', 1, 'cryptocompare'),
(2268, 793802, 'PUT*', 'Robin8 Profile Utility Token (PUT*)', 'Robin8 Profile Utility Token', 2405, 'N/A', 'N/A', '/coins/putstar/overview', 1, 'cryptocompare'),
(2269, 793815, 'FILL', 'Fillit (FILL)', 'Fillit', 2406, 'N/A', 'N/A', '/coins/fill/overview', 1, 'cryptocompare'),
(2270, 793845, 'POA', 'Poa Network (POA)', 'Poa Network', 2407, 'Proof-of-Aut', 'PoA', '/coins/poa/overview', 1, 'cryptocompare'),
(2271, 794350, 'RVN', 'Ravencoin (RVN)', 'Ravencoin', 2411, 'X16R', 'N/A', '/coins/rvn/overview', 1, 'cryptocompare'),
(2272, 794362, 'XNK', 'Ink Protocol (XNK)', 'Ink Protocol', 2412, 'N/A', 'N/A', '/coins/xnk/overview', 1, 'cryptocompare'),
(2273, 795305, 'XYO', 'XY Oracle (XYO)', 'XY Oracle', 2414, 'N/A', 'N/A', '/coins/xyo/overview', 1, 'cryptocompare'),
(2274, 795662, 'RFR', 'Refereum (RFR)', 'Refereum', 2415, 'N/A', 'N/A', '/coins/rfr/overview', 1, 'cryptocompare'),
(2275, 796019, 'PROPS', 'Props (PROPS)', 'Props', 2417, 'N/A', 'N/A', '/coins/props/overview', 1, 'cryptocompare'),
(2276, 797331, 'CEDEX', 'CEDEX Coin (CEDEX)', 'CEDEX Coin', 2418, 'N/A', 'N/A', '/coins/cedex/overview', 1, 'cryptocompare'),
(2277, 797481, 'FUND', 'Fund Platform (FUND)', 'Fund Platform', 2419, 'N/A', 'N/A', '/coins/fund/overview', 1, 'cryptocompare'),
(2278, 799472, 'CEL', 'Celsius Network (CEL)', 'Celsius Network', 2420, 'N/A', 'N/A', '/coins/cel/overview', 1, 'cryptocompare'),
(2279, 799597, 'CS*', 'Credits (CS*)', 'Credits', 2421, 'N/A', 'N/A', '/coins/csstar/overview', 1, 'cryptocompare'),
(2280, 799869, 'PUSHI', 'Pushi (PUSHI)', 'Pushi', 2422, 'X11', 'PoW/PoS', '/coins/pushi/overview', 1, 'cryptocompare'),
(2281, 799897, 'BINS', 'Bitsense (BINS)', 'Bitsense', 2423, 'N/A', 'N/A', '/coins/bins/overview', 1, 'cryptocompare'),
(2282, 799922, 'POKER', 'PokerCoin (POKER)', 'PokerCoin', 2424, 'Scrypt', 'PoS/PoW', '/coins/poker/overview', 1, 'cryptocompare'),
(2283, 799948, 'AXYS', 'Axys (AXYS)', 'Axys', 2425, 'N/A', 'N/A', '/coins/axys/overview', 1, 'cryptocompare'),
(2284, 800022, 'EVN*', 'EvenCoin (EVN*)', 'EvenCoin', 2426, 'N/A', 'PoW', '/coins/evnstar/overview', 1, 'cryptocompare'),
(2285, 800034, 'BOLD', 'Bold (BOLD)', 'Bold', 2427, 'N/A', 'N/A', '/coins/bold/overview', 1, 'cryptocompare'),
(2286, 800048, 'EXTN', 'Extensive Coin (EXTN)', 'Extensive Coin', 2428, 'Scrypt', 'PoS', '/coins/extn/overview', 1, 'cryptocompare'),
(2287, 800121, 'DIG', 'Dignity (DIG)', 'Dignity', 2429, 'N/A', 'N/A', '/coins/dig/overview', 1, 'cryptocompare'),
(2288, 800145, 'ETS', 'ETH Share (ETS)', 'ETH Share', 2430, 'N/A', 'N/A', '/coins/ets/overview', 1, 'cryptocompare'),
(2289, 800232, 'LIPC', 'LIpcoin (LIPC)', 'LIpcoin', 2431, 'Scrypt', 'PoW', '/coins/lipc/overview', 1, 'cryptocompare'),
(2290, 801234, 'HELL', 'HELL COIN (HELL)', 'HELL COIN', 2433, 'N/A', 'N/A', '/coins/hell/overview', 1, 'cryptocompare'),
(2291, 801286, 'ELP', 'Ellerium (ELP)', 'Ellerium', 2434, 'XEVAN', 'PoW/PoS', '/coins/elp/overview', 1, 'cryptocompare'),
(2292, 801364, 'ACAT', 'Alphacat (ACAT)', 'Alphacat', 2435, 'N/A', 'N/A', '/coins/acat/overview', 1, 'cryptocompare'),
(2293, 801429, 'RKT', 'Rock Token (RKT)', 'Rock Token', 2436, 'N/A', 'N/A', '/coins/rkt/overview', 1, 'cryptocompare'),
(2294, 801531, 'ELI', 'Eligma (ELI)', 'Eligma', 2437, 'N/A', 'N/A', '/coins/eli/overview', 1, 'cryptocompare'),
(2295, 802875, 'CO2', 'CO2 Token (CO2)', 'CO2 Token', 2438, 'N/A', 'N/A', '/coins/co2/overview', 1, 'cryptocompare'),
(2296, 803996, 'INVOX', 'Invox Finance (INVOX)', 'Invox Finance', 2439, 'N/A', 'N/A', '/coins/invox/overview', 1, 'cryptocompare'),
(2297, 804376, 'VLX', 'Velox (VLX)', 'Velox', 2440, 'Scrypt', 'PoS', '/coins/vlx/overview', 1, 'cryptocompare'),
(2298, 808094, 'ACTN', 'Action Coin (ACTN)', 'Action Coin', 2441, 'N/A', 'N/A', '/coins/actn/overview', 1, 'cryptocompare'),
(2299, 808190, 'LTCH', 'Litecoin Cash (LTCH)', 'Litecoin Cash', 2442, 'N/A', 'N/A', '/coins/ltch/overview', 1, 'cryptocompare'),
(2300, 808252, 'ZUP', 'Zupply Token (ZUP)', 'Zupply Token', 2443, 'N/A', 'N/A', '/coins/zup/overview', 1, 'cryptocompare'),
(2301, 808292, 'HMT', 'Hamster Marketplace Token (HMT)', 'Hamster Marketplace Token', 2444, 'N/A', 'N/A', '/coins/hmt/overview', 1, 'cryptocompare'),
(2302, 808364, 'MDX', 'Midex (MDX)', 'Midex', 2445, 'N/A', 'N/A', '/coins/mdx/overview', 1, 'cryptocompare'),
(2303, 810258, 'USDC', 'USCoin (USDC)', 'USCoin', 2447, 'Scrypt', 'PoW', '/coins/usdc/overview', 1, 'cryptocompare'),
(2304, 810719, 'CBC*', 'CashBagCoin (CBC*)', 'CashBagCoin', 2448, 'N/A', 'N/A', '/coins/cbcstar/overview', 1, 'cryptocompare'),
(2305, 810794, 'KIND', 'Kind Ads (KIND)', 'Kind Ads', 2449, 'N/A', 'N/A', '/coins/kind/overview', 1, 'cryptocompare'),
(2306, 810848, 'BCT', 'Blockchain Terminal (BCT)', 'Blockchain Terminal', 2450, 'N/A', 'N/A', '/coins/bct/overview', 1, 'cryptocompare'),
(2307, 811474, 'CLO', 'Callisto Network (CLO)', 'Callisto Network', 2451, 'Ethash', 'PoW', '/coins/clo/overview', 1, 'cryptocompare'),
(2308, 811480, 'CRU', 'Curium (CRU)', 'Curium', 2452, 'X11', 'PoW', '/coins/cru/overview', 1, 'cryptocompare'),
(2309, 811495, 'ELI*', 'Elicoin (ELI*)', 'Elicoin', 2453, 'YescryptR16', 'PoW', '/coins/elistar/overview', 1, 'cryptocompare'),
(2310, 811560, 'MOAT', 'Mother Of All Tokens (MOAT)', 'Mother Of All Tokens', 2454, 'N/A', 'N/A', '/coins/moat/overview', 1, 'cryptocompare'),
(2311, 811566, 'BBI', 'BelugaPay (BBI)', 'BelugaPay', 2455, 'N/A', 'N/A', '/coins/bbi/overview', 1, 'cryptocompare'),
(2312, 811575, 'BEZ', 'Bezop (BEZ)', 'Bezop', 2456, 'N/A', 'N/A', '/coins/bez/overview', 1, 'cryptocompare'),
(2313, 811654, 'ENTRC', 'ENTER COIN (ENTRC)', 'ENTER COIN', 2458, 'N/A', 'N/A', '/coins/entrc/overview', 1, 'cryptocompare'),
(2314, 811673, 'BTCGO', 'BitcoinGo (BTCGO)', 'BitcoinGo', 2459, 'N/A', 'PoS', '/coins/btcgo/overview', 1, 'cryptocompare'),
(2315, 811717, 'XTROPTIO', 'TROPTIONS (XTROPTIONS)', 'TROPTIONS', 2460, 'N/A', 'PoW', '/coins/xtroptions/overview', 1, 'cryptocompare'),
(2316, 812669, 'KNW', 'Knowledge  (KNW)', 'Knowledge ', 2461, 'N/A', 'N/A', '/coins/knw/overview', 1, 'cryptocompare'),
(2317, 812842, 'PGC', 'Pegascoin (PGC)', 'Pegascoin', 2462, 'Dagger-Hashi', 'PoW', '/coins/pgc/overview', 1, 'cryptocompare'),
(2318, 813335, 'BIT', 'BitRewards (BIT)', 'BitRewards', 2463, 'N/A', 'N/A', '/coins/bit/overview', 1, 'cryptocompare'),
(2319, 814081, 'DATX', 'DATx (DATX)', 'DATx', 2464, 'N/A', 'N/A', '/coins/datx/overview', 1, 'cryptocompare'),
(2320, 814149, 'PTC**', 'Plutocoin (PTC**)', 'Plutocoin', 2465, 'Scrypt', 'PoW/PoS', '/coins/ptcstarstar/overview', 1, 'cryptocompare'),
(2321, 814191, 'PKC', 'Pikciochain (PKC)', 'Pikciochain', 2466, 'N/A', 'N/A', '/coins/pkc/overview', 1, 'cryptocompare'),
(2322, 814361, 'SQOIN', 'StasyQ (SQOIN)', 'StasyQ', 2467, 'N/A', 'N/A', '/coins/sqoin/overview', 1, 'cryptocompare'),
(2323, 815247, 'TBAR', 'Titanium BAR (TBAR)', 'Titanium BAR', 2468, 'N/A', 'N/A', '/coins/tbar/overview', 1, 'cryptocompare'),
(2324, 815269, 'TKLN', 'Taklimakan (TKLN)', 'Taklimakan', 2469, 'N/A', 'N/A', '/coins/tkln/overview', 1, 'cryptocompare'),
(2325, 815308, 'CPL', 'CoinPlace Token (CPL)', 'CoinPlace Token', 2470, 'N/A', 'N/A', '/coins/cpl/overview', 1, 'cryptocompare'),
(2326, 815372, 'TUBE', 'BitTube (TUBE)', 'BitTube', 2471, 'CryptoNight', 'PoW', '/coins/tube/overview', 1, 'cryptocompare'),
(2327, 815399, 'AUTO', 'Cube (AUTO)', 'Cube', 2472, 'N/A', 'N/A', '/coins/auto/overview', 1, 'cryptocompare'),
(2328, 815543, 'OMX', 'Project Shivom (OMX)', 'Project Shivom', 2474, 'N/A', 'N/A', '/coins/omx/overview', 1, 'cryptocompare'),
(2329, 815627, 'TRCK', 'Truckcoin (TRCK)', 'Truckcoin', 2475, 'CryptoNight', 'PoW', '/coins/trck/overview', 1, 'cryptocompare'),
(2330, 816635, 'HAV', 'Havven (HAV)', 'Havven', 2476, 'N/A', 'N/A', '/coins/hav/overview', 1, 'cryptocompare'),
(2331, 816702, 'TOMO', 'TomoChain (TOMO)', 'TomoChain', 2477, 'N/A', 'N/A', '/coins/tomo/overview', 1, 'cryptocompare'),
(2332, 816745, 'CHI', 'XAYA (CHI)', 'XAYA', 2478, 'N/A', 'PoW', '/coins/chi/overview', 1, 'cryptocompare'),
(2333, 817013, 'CHF*', 'MobileBridge Momentum (CHF*)', 'MobileBridge Momentum', 2479, 'N/A', 'N/A', '/coins/chfstar/overview', 1, 'cryptocompare'),
(2334, 819601, 'INV*', 'Invacio (INV*)', 'Invacio', 2480, 'N/A', 'N/A', '/coins/invstar/overview', 1, 'cryptocompare'),
(2335, 819663, 'W3C', 'W3Coin (W3C)', 'W3Coin', 2481, 'N/A', 'N/A', '/coins/w3c/overview', 1, 'cryptocompare'),
(2336, 819678, 'DIN', 'Dinero (DIN)', 'Dinero', 2482, 'NeoScrypt', 'PoW', '/coins/din/overview', 1, 'cryptocompare'),
(2337, 819702, 'INSTAR', 'Insights Network (INSTAR)', 'Insights Network', 2483, 'N/A', 'N/A', '/coins/instar/overview', 1, 'cryptocompare'),
(2338, 819737, 'CHP', 'CoinPoker Token (CHP)', 'CoinPoker Token', 2484, 'N/A', 'N/A', '/coins/chp/overview', 1, 'cryptocompare'),
(2339, 819787, 'PSD', 'Poseidon (PSD)', 'Poseidon', 2485, 'Scrypt', 'PoW', '/coins/psd/overview', 1, 'cryptocompare'),
(2340, 819799, 'J8T', 'JET8 (J8T)', 'JET8', 2486, 'N/A', 'N/A', '/coins/j8t/overview', 1, 'cryptocompare'),
(2341, 820526, 'LELE', 'Lelecoin (LELE)', 'Lelecoin', 2487, 'Curve25519', 'PoS', '/coins/lele/overview', 1, 'cryptocompare'),
(2342, 820902, 'DROP', 'Dropil (DROP)', 'Dropil', 2488, 'N/A', 'N/A', '/coins/drop/overview', 1, 'cryptocompare'),
(2343, 820940, 'VEGA*', 'VEGA (VEGA)', 'VEGA', 2489, 'N/A', 'PoS', '/coins/vega/overview', 1, 'cryptocompare'),
(2344, 830940, 'AKA', 'Akroma (AKA)', 'Akroma', 2490, 'Ethash', 'PoW', '/coins/aka/overview', 1, 'cryptocompare'),
(2345, 830983, 'SHIP', 'ShipChain (SHIP)', 'ShipChain', 2491, 'N/A', 'N/A', '/coins/ship/overview', 1, 'cryptocompare'),
(2346, 831814, 'IHT', 'I-House Token (IHT)', 'I-House Token', 2492, 'N/A', 'N/A', '/coins/iht/overview', 1, 'cryptocompare'),
(2347, 831841, 'LCS', 'LocalCoinSwap (LCS)', 'LocalCoinSwap', 2493, 'N/A', 'N/A', '/coins/lcs/overview', 1, 'cryptocompare'),
(2348, 831848, 'LALA', 'LaLa World (LALA)', 'LaLa World', 2494, 'N/A', 'N/A', '/coins/lala/overview', 1, 'cryptocompare'),
(2349, 831932, 'LEDU', 'Education Ecosystem (LEDU)', 'Education Ecosystem', 2496, 'N/A', 'N/A', '/coins/ledu/overview', 1, 'cryptocompare'),
(2350, 832078, 'FOXT', 'Fox Trading (FOXT)', 'Fox Trading', 2497, 'N/A', 'N/A', '/coins/foxt/overview', 1, 'cryptocompare'),
(2351, 832079, 'ETKN', 'EasyToken (ETKN)', 'EasyToken', 2498, 'N/A', 'N/A', '/coins/etkn/overview', 1, 'cryptocompare'),
(2352, 832783, 'ROX', 'Robotina (ROX)', 'Robotina', 2499, 'N/A', 'N/A', '/coins/rox/overview', 1, 'cryptocompare'),
(2353, 833028, 'ADM', 'Adamant (ADM)', 'Adamant', 2500, 'DPoS', 'DPoS', '/coins/adm/overview', 1, 'cryptocompare'),
(2354, 835125, 'AMBT', 'AMBT Token (AMBT)', 'AMBT Token', 2501, 'N/A', 'N/A', '/coins/ambt/overview', 1, 'cryptocompare'),
(2355, 836048, 'LVL*', 'LevelNet Token (LVL*)', 'LevelNet Token', 2502, 'N/A', 'N/A', '/coins/lvlstar/overview', 1, 'cryptocompare'),
(2356, 836124, 'MEE', 'CoinMeet (MEE)', 'CoinMeet', 2503, 'N/A', 'N/A', '/coins/mee/overview', 1, 'cryptocompare'),
(2357, 836186, 'BTRM', 'Betrium Token (BTRM)', 'Betrium Token', 2504, 'N/A', 'N/A', '/coins/btrm/overview', 1, 'cryptocompare'),
(2358, 836189, 'MANNA', 'Manna (MANNA)', 'Manna', 2505, 'SHA256', 'PoW', '/coins/manna/overview', 1, 'cryptocompare'),
(2359, 836220, 'PROD', 'Darenta (PROD)', 'Darenta', 2506, 'N/A', 'N/A', '/coins/prod/overview', 1, 'cryptocompare'),
(2360, 836266, 'ePRX', 'eProxy (ePRX)', 'eProxy', 2507, 'N/A', 'N/A', '/coins/eprx/overview', 1, 'cryptocompare'),
(2361, 836331, 'HMC', 'Hi Mutual Society (HMC)', 'Hi Mutual Society', 2508, 'N/A', 'N/A', '/coins/hmc/overview', 1, 'cryptocompare'),
(2362, 836415, 'ZIX', 'ZIX Token (ZIX)', 'ZIX Token', 2509, 'N/A', 'N/A', '/coins/zix/overview', 1, 'cryptocompare'),
(2363, 836445, 'ELEC', 'Electrify.Asia (ELEC)', 'Electrify.Asia', 2510, 'N/A', 'N/A', '/coins/elec/overview', 1, 'cryptocompare'),
(2364, 836456, 'ORGT', 'Organic Token (ORGT)', 'Organic Token', 2511, 'N/A', 'N/A', '/coins/orgt/overview', 1, 'cryptocompare'),
(2365, 836492, 'LOOM', 'Loom Network (LOOM)', 'Loom Network', 2512, 'N/A', 'N/A', '/coins/loom/overview', 1, 'cryptocompare'),
(2366, 837419, 'PAN', 'Pantos (PAN)', 'Pantos', 2513, 'N/A', 'N/A', '/coins/pan/overview', 1, 'cryptocompare'),
(2367, 838249, 'BOTC', 'BotChain (BOTC)', 'BotChain', 2514, 'N/A', 'N/A', '/coins/botc/overview', 1, 'cryptocompare'),
(2368, 838328, 'GO', 'GoChain (GO)', 'GoChain', 2515, 'N/A', 'N/A', '/coins/go/overview', 1, 'cryptocompare'),
(2369, 838344, 'VIEW', 'Viewly (VIEW)', 'Viewly', 2516, 'N/A', 'N/A', '/coins/view/overview', 1, 'cryptocompare'),
(2370, 839311, 'OKOIN', 'OKOIN (OKOIN)', 'OKOIN', 2517, 'N/A', 'N/A', '/coins/okoin/overview', 1, 'cryptocompare'),
(2371, 841767, 'ADK', 'Aidos Kuneen (ADK)', 'Aidos Kuneen', 2518, 'IMesh', 'PoW', '/coins/adk/overview', 1, 'cryptocompare'),
(2372, 842123, 'GRAM', 'Telegram Open Network (GRAM)', 'Telegram Open Network', 2519, 'N/A', 'N/A', '/coins/gram/overview', 1, 'cryptocompare'),
(2373, 842171, 'ESS', 'Essentia (ESS)', 'Essentia', 2520, 'N/A', 'N/A', '/coins/ess/overview', 1, 'cryptocompare'),
(2374, 842430, 'VIT', 'Vice Industry Token (VIT)', 'Vice Industry Token', 2521, 'N/A', 'N/A', '/coins/vit/overview', 1, 'cryptocompare'),
(2375, 842468, 'SERA', 'Seraph (SERA)', 'Seraph', 2522, 'PHI1612', 'PoW/PoS', '/coins/sera/overview', 1, 'cryptocompare'),
(2376, 843275, 'AET', 'AfterEther (AET)', 'AfterEther', 2524, 'Ethash', 'PoW', '/coins/aet/overview', 1, 'cryptocompare'),
(2377, 843278, 'CMOS', 'Cosmo (CMOS)', 'Cosmo', 2525, 'Quark', 'PoW', '/coins/cmos/overview', 1, 'cryptocompare'),
(2378, 843333, 'PGN', 'Pigeoncoin (PGN)', 'Pigeoncoin', 2526, 'N/A', 'PoW', '/coins/pgn/overview', 1, 'cryptocompare'),
(2379, 843515, 'BMH', 'BlockMesh (BMH)', 'BlockMesh', 2528, 'N/A', 'N/A', '/coins/bmh/overview', 1, 'cryptocompare'),
(2380, 843543, 'TT', 'TravelChain (TT)', 'TravelChain', 2529, 'SHA-512', 'DPoS', '/coins/tt/overview', 1, 'cryptocompare'),
(2381, 843556, 'REDN', 'Reden (REDN)', 'Reden', 2530, 'X16S', 'PoW', '/coins/redn/overview', 1, 'cryptocompare'),
(2382, 843567, 'TLP', 'TulipCoin (TLP)', 'TulipCoin', 2531, 'Scrypt', 'PoW/PoS', '/coins/tlp/overview', 1, 'cryptocompare'),
(2383, 843576, 'GEN*', 'DAOstack (GEN)', 'DAOstack', 2532, 'N/A', 'N/A', '/coins/gen/overview', 1, 'cryptocompare'),
(2384, 843586, 'BSX', 'Bitspace (BSX)', 'Bitspace', 2533, 'NIST5', 'PoW/PoS', '/coins/bsx/overview', 1, 'cryptocompare'),
(2385, 843597, 'BTCE*', 'BitcoinEX (BTCE*)', 'BitcoinEX', 2534, 'Scrypt', 'PoW', '/coins/btcestar/overview', 1, 'cryptocompare'),
(2386, 843613, 'BBN', 'BBNCOIN (BBN)', 'BBNCOIN', 2535, 'N/A', 'PoW', '/coins/bbn/overview', 1, 'cryptocompare'),
(2387, 843631, 'TDZ', 'Tradelize (TDZ)', 'Tradelize', 2536, 'N/A', 'N/A', '/coins/tdz/overview', 1, 'cryptocompare'),
(2388, 843642, 'PAVO', 'Pavocoin (PAVO)', 'Pavocoin', 2537, 'N/A', 'N/A', '/coins/pavo/overview', 1, 'cryptocompare'),
(2389, 844139, 'TUSD', 'True USD (TUSD)', 'True USD', 2538, 'N/A', 'N/A', '/coins/tusd/overview', 1, 'cryptocompare'),
(2390, 844279, 'LDN', 'Lydiancoin (LDN)', 'Lydiancoin', 2539, 'N/A', 'N/A', '/coins/ldn/overview', 1, 'cryptocompare'),
(2391, 844325, 'BUBO', 'Budbo (BUBO)', 'Budbo', 2540, 'N/A', 'N/A', '/coins/bubo/overview', 1, 'cryptocompare'),
(2392, 844436, 'USOAMIC', 'USOAMIC (USOAMIC)', 'USOAMIC', 2542, 'N/A', 'PoS', '/coins/usoamic/overview', 1, 'cryptocompare'),
(2393, 844476, 'FLUZ', 'FluzFluz (FLUZ)', 'FluzFluz', 2543, 'N/A', 'PoS', '/coins/fluz/overview', 1, 'cryptocompare'),
(2394, 844540, 'IPSX', 'IP Exchange (IPSX)', 'IP Exchange', 2544, 'N/A', 'N/A', '/coins/ipsx/overview', 1, 'cryptocompare'),
(2395, 845211, 'MIO', 'Miner One token (MIO)', 'Miner One token', 2545, 'N/A', 'N/A', '/coins/mio/overview', 1, 'cryptocompare'),
(2396, 845270, 'ZSC*', 'ZeroState (ZSC*)', 'ZeroState', 2546, 'N/A', 'N/A', '/coins/zscstar/overview', 1, 'cryptocompare'),
(2397, 847135, 'AIC', 'AI Crypto (AIC)', 'AI Crypto', 2547, 'N/A', 'N/A', '/coins/aic/overview', 1, 'cryptocompare'),
(2398, 847172, 'MITH', 'Mithril (MITH)', 'Mithril', 2548, 'N/A', 'PoS', '/coins/mith/overview', 1, 'cryptocompare'),
(2399, 847177, 'BBN*', 'Banyan Network (BBN*)', 'Banyan Network', 2549, 'N/A', 'N/A', '/coins/bbnstar/overview', 1, 'cryptocompare'),
(2400, 847305, 'SPD*', 'Spindle (SPD*)', 'Spindle', 2550, 'N/A', 'N/A', '/coins/spdstar/overview', 1, 'cryptocompare'),
(2401, 847312, 'FNO', 'Fonero (FNO)', 'Fonero', 2551, 'PHI1612', 'PoW', '/coins/fno/overview', 1, 'cryptocompare'),
(2402, 847347, 'GST', 'Gostcoin (GST)', 'Gostcoin', 2552, 'GOST_R_3410_', 'PoW', '/coins/gst/overview', 1, 'cryptocompare'),
(2403, 847381, 'PAS', 'Passive Coin (PAS)', 'Passive Coin', 2553, 'N/A', 'PoS', '/coins/pas/overview', 1, 'cryptocompare'),
(2404, 847395, 'XSG', 'Snowgem (XSG)', 'Snowgem', 2554, 'Equihash', 'PoW', '/coins/xsg/overview', 1, 'cryptocompare'),
(2405, 847402, 'CVTC', 'CavatCoin (CVTC)', 'CavatCoin', 2555, 'DPoS', 'DPoS', '/coins/cvtc/overview', 1, 'cryptocompare'),
(2406, 847420, 'PLMT', 'Pallium (PLMT)', 'Pallium', 2556, 'N/A', 'N/A', '/coins/plmt/overview', 1, 'cryptocompare'),
(2407, 847476, 'FARM', 'FARM Coin (FARM)', 'FARM Coin', 2558, 'N/A', 'PoS', '/coins/farm/overview', 1, 'cryptocompare'),
(2408, 848051, 'NEXT', 'Next.exchange Token (NEXT)', 'Next.exchange Token', 2559, 'N/A', 'N/A', '/coins/next/overview', 1, 'cryptocompare'),
(2409, 848115, 'RNTB', 'BitRent (RNTB)', 'BitRent', 2560, 'N/A', 'N/A', '/coins/rntb/overview', 1, 'cryptocompare'),
(2410, 848134, 'XCLR', 'ClearCoin (XCLR)', 'ClearCoin', 2561, 'N/A', 'N/A', '/coins/xclr/overview', 1, 'cryptocompare'),
(2411, 848148, 'XBP*', 'BlitzPredict (XBP*)', 'BlitzPredict', 2562, 'N/A', 'N/A', '/coins/xbpstar/overview', 1, 'cryptocompare'),
(2412, 848257, 'DBC*', 'Debit Coin (DBC*)', 'Debit Coin', 2563, 'N/A', 'N/A', '/coins/dbcstar/overview', 1, 'cryptocompare'),
(2413, 848774, 'SWTH', 'Switcheo (SWTH)', 'Switcheo', 2564, 'N/A', 'N/A', '/coins/swth/overview', 1, 'cryptocompare'),
(2414, 848819, 'FDZ', 'Friendz (FDZ)', 'Friendz', 2565, 'N/A', 'N/A', '/coins/fdz/overview', 1, 'cryptocompare'),
(2415, 848860, 'VTN', 'Voltroon (VTN)', 'Voltroon', 2566, 'N/A', 'N/A', '/coins/vtn/overview', 1, 'cryptocompare'),
(2416, 848906, 'LION', 'CoinLion (LION)', 'CoinLion', 2567, 'N/A', 'N/A', '/coins/lion/overview', 1, 'cryptocompare'),
(2417, 849711, 'MASP', 'Market.space (MASP)', 'Market.space', 2569, 'N/A', 'N/A', '/coins/masp/overview', 1, 'cryptocompare'),
(2418, 849722, 'XTL', 'Stellite (XTL)', 'Stellite', 2570, 'CryptoNight', 'PoW', '/coins/xtl/overview', 1, 'cryptocompare'),
(2419, 849732, 'UCN', 'UC Coin (UCN)', 'UC Coin', 2571, 'N/A', 'N/A', '/coins/ucn/overview', 1, 'cryptocompare'),
(2420, 849743, 'HUR', 'Hurify (HUR)', 'Hurify', 2572, 'N/A', 'N/A', '/coins/hur/overview', 1, 'cryptocompare'),
(2421, 849782, 'BRIA', 'Briacoin (BRIA)', 'Briacoin', 2573, 'Scrypt', 'PoW/PoS', '/coins/bria/overview', 1, 'cryptocompare'),
(2422, 849815, 'IC', 'Ignition (IC)', 'Ignition', 2574, 'Scrypt', 'PoW/PoS', '/coins/ic/overview', 1, 'cryptocompare'),
(2423, 849939, 'LATX', 'LatiumX (LATX)', 'LatiumX', 2575, 'N/A', 'N/A', '/coins/latx/overview', 1, 'cryptocompare'),
(2424, 849992, 'ROI', 'ROIcoin (ROI)', 'ROIcoin', 2576, '1GB AES Patt', 'PoS', '/coins/roi/overview', 1, 'cryptocompare'),
(2425, 850066, 'ETHPR', 'Ethereum Premium (ETHPR)', 'Ethereum Premium', 2577, 'N/A', 'N/A', '/coins/ethpr/overview', 1, 'cryptocompare'),
(2426, 850772, 'MNB', 'MoneyBag (MNB)', 'MoneyBag', 2578, 'X11', 'PoS', '/coins/mnb/overview', 1, 'cryptocompare'),
(2427, 850785, 'ACH', 'AchieveCoin (ACH)', 'AchieveCoin', 2579, 'Equihash', 'PoW', '/coins/ach/overview', 1, 'cryptocompare'),
(2428, 850816, 'BTL', 'Bitrolium (BTL)', 'Bitrolium', 2580, 'Equihash', 'PoW', '/coins/btl/overview', 1, 'cryptocompare'),
(2429, 850825, 'GOAL', 'Goal Bonanza (GOAL)', 'Goal Bonanza', 2581, 'N/A', 'N/A', '/coins/goal/overview', 1, 'cryptocompare'),
(2430, 850831, 'RAC', 'RAcoin (RAC)', 'RAcoin', 2582, 'N/A', 'N/A', '/coins/rac/overview', 1, 'cryptocompare'),
(2431, 850836, 'BEX', 'BEX token (BEX)', 'BEX token', 2583, 'N/A', 'N/A', '/coins/bex/overview', 1, 'cryptocompare'),
(2432, 850875, 'HOLD', 'HOLD (HOLD)', 'HOLD', 2584, 'N/A', 'N/A', '/coins/hold/overview', 1, 'cryptocompare'),
(2433, 850994, 'EZT', 'EZToken (EZT)', 'EZToken', 2586, 'N/A', 'N/A', '/coins/ezt/overview', 1, 'cryptocompare'),
(2434, 851021, 'SOL', 'Sola (SOL)', 'Sola', 2588, 'N/A', 'N/A', '/coins/sol/overview', 1, 'cryptocompare'),
(2435, 851066, 'VIC', 'Victorium (VIC)', 'Victorium', 2590, 'Dagger-Hashi', 'PoW', '/coins/vic/overview', 1, 'cryptocompare'),
(2436, 851104, 'XCM', 'CoinMetro (XCM)', 'CoinMetro', 2591, 'N/A', 'N/A', '/coins/xcm/overview', 1, 'cryptocompare'),
(2437, 851117, 'NFN', 'Nafen (NFN)', 'Nafen', 2592, 'N/A', 'N/A', '/coins/nfn/overview', 1, 'cryptocompare'),
(2438, 853825, 'CEEK', 'CEEK Smart VR Token (CEEK)', 'CEEK Smart VR Token', 2593, 'N/A', 'N/A', '/coins/ceek/overview', 1, 'cryptocompare'),
(2439, 855136, 'WIIX', 'Wiix (WIIX)', 'Wiix', 2594, 'N/A', 'N/A', '/coins/wiix/overview', 1, 'cryptocompare'),
(2440, 855289, 'EOSDAC', 'eosDAC (EOSDAC)', 'eosDAC', 2595, 'N/A', 'N/A', '/coins/eosdac/overview', 1, 'cryptocompare'),
(2441, 855539, 'BCI', 'Bitcoin Interest (BCI)', 'Bitcoin Interest', 2596, 'Equihash', 'PoW', '/coins/bci/overview', 1, 'cryptocompare'),
(2442, 855870, 'MEDIC', 'MedicCoin (MEDIC)', 'MedicCoin', 2597, 'Scrypt', 'PoS', '/coins/medic/overview', 1, 'cryptocompare'),
(2443, 856119, 'BBC', 'TraDove (BBC)', 'TraDove', 2598, 'N/A', 'N/A', '/coins/bbc/overview', 1, 'cryptocompare'),
(2444, 856128, 'KWH', 'KWHCoin (KWH)', 'KWHCoin', 2599, 'N/A', 'N/A', '/coins/kwh/overview', 1, 'cryptocompare'),
(2445, 856139, 'CTXC', 'Cortex (CTXC)', 'Cortex', 2600, 'N/A', 'N/A', '/coins/ctxc/overview', 1, 'cryptocompare'),
(2446, 856890, 'VLD', 'Valid (VLD)', 'Valid', 2602, 'N/A', 'N/A', '/coins/vld/overview', 1, 'cryptocompare'),
(2447, 856962, 'FTX', 'FintruX (FTX)', 'FintruX', 2603, 'N/A', 'N/A', '/coins/ftx/overview', 1, 'cryptocompare'),
(2448, 858189, 'GSI', 'Globex SCI (GSI)', 'Globex SCI', 2604, 'N/A', 'N/A', '/coins/gsi/overview', 1, 'cryptocompare'),
(2449, 858205, 'BDP', 'Bidipass (BDP)', 'Bidipass', 2605, 'N/A', 'N/A', '/coins/bdp/overview', 1, 'cryptocompare'),
(2450, 859637, 'FLM', 'FOLM coin (FLM)', 'FOLM coin', 2606, 'PHI1612', 'PoW', '/coins/flm/overview', 1, 'cryptocompare'),
(2451, 859662, 'ALPS', 'Alpenschillling (ALPS)', 'Alpenschillling', 2607, 'Lyra2Z', 'PoW', '/coins/alps/overview', 1, 'cryptocompare'),
(2452, 859692, 'ZEL', 'Zelcash (ZEL)', 'Zelcash', 2608, 'Equihash', 'PoW/PoS', '/coins/zel/overview', 1, 'cryptocompare'),
(2453, 860049, 'BKC', 'Balkancoin (BKC)', 'Balkancoin', 2609, 'CryptoNight', 'PoW', '/coins/bkc/overview', 1, 'cryptocompare'),
(2454, 860065, 'BITG', 'Bitcoin Green (BITG)', 'Bitcoin Green', 2610, 'Green Protoc', 'PoS', '/coins/bitg/overview', 1, 'cryptocompare'),
(2455, 860154, 'DEV', 'Deviant Coin (DEV)', 'Deviant Coin', 2612, 'PoS', 'PoS', '/coins/dev/overview', 1, 'cryptocompare'),
(2456, 860166, 'CHT', 'Countinghouse Fund (CHT)', 'Countinghouse Fund', 2614, 'N/A', 'N/A', '/coins/cht/overview', 1, 'cryptocompare'),
(2457, 860192, 'GEX', 'GreenX (GEX)', 'GreenX', 2615, 'N/A', 'N/A', '/coins/gex/overview', 1, 'cryptocompare'),
(2458, 860230, 'ABJ', 'Abjcoin (ABJ)', 'Abjcoin', 2616, 'Scrypt', 'PoW/PoS', '/coins/abj/overview', 1, 'cryptocompare'),
(2459, 860320, 'FTW', 'FutureWorks (FTW)', 'FutureWorks', 2618, 'N/A', 'N/A', '/coins/ftw/overview', 1, 'cryptocompare'),
(2460, 860887, 'RAP', 'Rapture (RAP)', 'Rapture', 2619, 'NeoScrypt', 'PoW', '/coins/rap/overview', 1, 'cryptocompare'),
(2461, 860889, 'ARTE', 'Artemine (ARTE)', 'Artemine', 2620, 'N/A', 'N/A', '/coins/arte/overview', 1, 'cryptocompare'),
(2462, 860930, 'ANI', 'Animecoin (ANI)', 'Animecoin', 2621, 'Quark', 'PoW', '/coins/ani/overview', 1, 'cryptocompare'),
(2463, 860938, 'PHC', 'Profit Hunters Coin (PHC)', 'Profit Hunters Coin', 2622, 'Scrypt', 'PoW/PoS', '/coins/phc/overview', 1, 'cryptocompare'),
(2464, 860990, 'ETHM', 'Ethereum Meta (ETHM)', 'Ethereum Meta', 2623, 'N/A', 'N/A', '/coins/ethm/overview', 1, 'cryptocompare'),
(2465, 861115, 'UBC', 'Ubcoin (UBC)', 'Ubcoin', 2624, 'N/A', 'N/A', '/coins/ubc/overview', 1, 'cryptocompare'),
(2466, 861276, 'NOKU', 'NOKU Master token (NOKU)', 'NOKU Master token', 2626, 'N/A', 'N/A', '/coins/noku/overview', 1, 'cryptocompare'),
(2467, 861301, 'RAC*', 'RoboAdvisorCoin (RAC*)', 'RoboAdvisorCoin', 2627, 'N/A', 'N/A', '/coins/racstar/overview', 1, 'cryptocompare'),
(2468, 861348, 'SENC', 'Sentinel Chain (SENC)', 'Sentinel Chain', 2628, 'N/A', 'N/A', '/coins/senc/overview', 1, 'cryptocompare'),
(2469, 862146, 'PAT', 'PATRON (PAT)', 'PATRON', 2629, 'N/A', 'N/A', '/coins/pat/overview', 1, 'cryptocompare'),
(2470, 862380, 'LIGER', 'Ligercoin (LIGER)', 'Ligercoin', 2630, 'N/A', 'N/A', '/coins/liger/overview', 1, 'cryptocompare'),
(2471, 862873, 'CHFN', 'NOKU CHF (CHFN)', 'NOKU CHF', 2631, 'N/A', 'N/A', '/coins/chfn/overview', 1, 'cryptocompare'),
(2472, 862884, 'EURN', 'NOKU EUR (EURN)', 'NOKU EUR', 2632, 'N/A', 'N/A', '/coins/eurn/overview', 1, 'cryptocompare'),
(2473, 862968, 'LEU', 'CryptoLEU (LEU)', 'CryptoLEU', 2633, 'N/A', 'N/A', '/coins/leu/overview', 1, 'cryptocompare'),
(2474, 863074, 'SWC', 'Scanetchain Token (SWC)', 'Scanetchain Token', 2634, 'N/A', 'N/A', '/coins/swc/overview', 1, 'cryptocompare'),
(2475, 863166, 'AVL', 'Avalanche (AVL)', 'Avalanche', 2635, 'N/A', 'N/A', '/coins/avl/overview', 1, 'cryptocompare'),
(2476, 863174, 'ORS', 'ORS Group (ORS)', 'ORS Group', 2636, 'N/A', 'PoW', '/coins/ors/overview', 1, 'cryptocompare'),
(2477, 863210, 'SEM', 'Semux (SEM)', 'Semux', 2638, 'Semux BFT co', 'DPoS', '/coins/sem/overview', 1, 'cryptocompare'),
(2478, 863225, 'DARX', 'Bitdaric (DARX)', 'Bitdaric', 2639, 'Scrypt', 'PoW', '/coins/darx/overview', 1, 'cryptocompare'),
(2479, 863235, 'BBK', 'BitBlocks (BBK)', 'BitBlocks', 2640, 'Scrypt', 'PoW/PoS', '/coins/bbk/overview', 1, 'cryptocompare'),
(2480, 863251, 'RAC**', 'RoBET (RAC**)', 'RoBET', 2641, 'N/A', 'N/A', '/coins/racstarstar/overview', 1, 'cryptocompare'),
(2481, 864038, 'NCT', 'PolySwarm (NCT)', 'PolySwarm', 2642, 'N/A', 'N/A', '/coins/nct/overview', 1, 'cryptocompare'),
(2482, 866283, 'UWC', 'Uwezocoin (UWC)', 'Uwezocoin', 2643, 'Scrypt', 'PoW', '/coins/uwc/overview', 1, 'cryptocompare'),
(2483, 866334, 'UUU', 'U Network (UUU)', 'U Network', 2644, 'N/A', 'N/A', '/coins/uuu/overview', 1, 'cryptocompare'),
(2484, 866346, 'XHV', 'Haven Protocol (XHV)', 'Haven Protocol', 2645, 'CryptoNight ', 'PoW', '/coins/xhv/overview', 1, 'cryptocompare'),
(2485, 866357, 'CPX', 'Apex Token (CPX)', 'Apex Token', 2646, 'N/A', 'DPoS', '/coins/cpx/overview', 1, 'cryptocompare'),
(2486, 866363, 'DOCK', 'Dock.io (DOCK)', 'Dock.io', 2647, 'N/A', 'N/A', '/coins/dock/overview', 1, 'cryptocompare'),
(2487, 866454, 'ADH', 'Adhive (ADH)', 'Adhive', 2652, 'N/A', 'N/A', '/coins/adh/overview', 1, 'cryptocompare'),
(2488, 866472, 'ZLA', 'Zilla (ZLA)', 'Zilla', 2653, 'N/A', 'N/A', '/coins/zla/overview', 1, 'cryptocompare'),
(2489, 866491, 'LIF', 'Winding Tree (LIF)', 'Winding Tree', 2654, 'N/A', 'N/A', '/coins/lif/overview', 1, 'cryptocompare'),
(2490, 866525, 'EFX', 'The EFFECT Network (EFX)', 'The EFFECT Network', 2657, 'N/A', 'N/A', '/coins/efx/overview', 1, 'cryptocompare'),
(2491, 866546, 'LND', 'Lendingblock (LND)', 'Lendingblock', 2658, 'N/A', 'N/A', '/coins/lnd/overview', 1, 'cryptocompare'),
(2492, 866622, 'MRP*', 'MoneyRebel (MRP*)', 'MoneyRebel', 2660, 'N/A', 'N/A', '/coins/mrpstar/overview', 1, 'cryptocompare'),
(2493, 866629, 'FTO', 'FuturoCoin (FTO)', 'FuturoCoin', 2661, 'X11', 'PoW', '/coins/fto/overview', 1, 'cryptocompare'),
(2494, 866749, 'HPAY', 'HadePay (HPAY)', 'HadePay', 2662, 'N/A', 'N/A', '/coins/hpay/overview', 1, 'cryptocompare'),
(2495, 867303, 'SIG', 'Signal (SIG)', 'Signal', 2663, 'N/A', 'N/A', '/coins/sig/overview', 1, 'cryptocompare'),
(2496, 867550, 'CARE', 'Carebit (CARE)', 'Carebit', 2664, 'Quark', 'PoW/PoS', '/coins/care/overview', 1, 'cryptocompare'),
(2497, 867958, 'NZL', 'Zealium (NZL)', 'Zealium', 2665, 'PoS', 'PoS', '/coins/nzl/overview', 1, 'cryptocompare'),
(2498, 867980, 'TBT', 'T-BOT (TBT)', 'T-BOT', 2666, 'N/A', 'N/A', '/coins/tbt/overview', 1, 'cryptocompare'),
(2499, 868276, 'HOT*', 'Holo (HOT*)', 'Holo', 2668, 'N/A', 'N/A', '/coins/hotstar/overview', 1, 'cryptocompare'),
(2500, 869101, 'OAK', 'Acorn Collective (OAK)', 'Acorn Collective', 2669, 'N/A', 'N/A', '/coins/oak/overview', 1, 'cryptocompare'),
(2501, 869896, 'DML', 'Decentralized Machine Learning (DML)', 'Decentralized Machine Learning', 2670, 'N/A', 'N/A', '/coins/dml/overview', 1, 'cryptocompare'),
(2502, 870119, 'GEM', 'Gems (GEM)', 'Gems', 2671, 'N/A', 'N/A', '/coins/gem/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(2503, 870188, 'TIPS', 'FedoraCoin (TIPS)', 'FedoraCoin', 2672, 'Scrypt', 'PoW', '/coins/tips/overview', 1, 'cryptocompare'),
(2504, 876007, 'MOS', 'MOS Coin (MOS)', 'MOS Coin', 2673, 'N/A', 'N/A', '/coins/mos/overview', 1, 'cryptocompare'),
(2505, 876072, 'TBX', 'Tokenbox (TBX)', 'Tokenbox', 2674, 'N/A', 'N/A', '/coins/tbx/overview', 1, 'cryptocompare'),
(2506, 876093, 'PNT', 'Penta (PNT)', 'Penta', 2675, 'N/A', 'N/A', '/coins/pnt/overview', 1, 'cryptocompare'),
(2507, 876102, 'WIN', 'WCoin (WIN)', 'WCoin', 2676, 'N/A', 'N/A', '/coins/win/overview', 1, 'cryptocompare'),
(2508, 876241, 'CHARM', 'Charm Coin (CHARM)', 'Charm Coin', 2677, 'NeoScrypt', 'PoW', '/coins/charm/overview', 1, 'cryptocompare'),
(2509, 876257, 'PROTON', 'Proton (PROTON)', 'Proton', 2678, 'X16R', 'PoS', '/coins/proton/overview', 1, 'cryptocompare'),
(2510, 876290, 'CRS', 'Cryptoreal (CRS)', 'Cryptoreal', 2679, 'Lyra2Z', 'N/A', '/coins/crs/overview', 1, 'cryptocompare'),
(2511, 876324, 'DERO', 'Dero (DERO)', 'Dero', 2680, 'CryptoNight', 'PoW', '/coins/dero/overview', 1, 'cryptocompare'),
(2512, 876352, 'DEAL', 'iDealCash (DEAL)', 'iDealCash', 2681, 'Scrypt', 'PoW/PoS', '/coins/deal/overview', 1, 'cryptocompare'),
(2513, 876359, 'JUMP', 'Jumpcoin (JUMP)', 'Jumpcoin', 2682, 'NIST5', 'PoW', '/coins/jump/overview', 1, 'cryptocompare'),
(2514, 876390, 'ZCO', 'Zebi Coin (ZCO)', 'Zebi Coin', 2683, 'N/A', 'N/A', '/coins/zco/overview', 1, 'cryptocompare'),
(2515, 877048, 'KRL', 'Kryll (KRL)', 'Kryll', 2684, 'N/A', 'N/A', '/coins/krl/overview', 1, 'cryptocompare'),
(2516, 877052, 'TMT**', 'Traxia Membership Token (TMT**)', 'Traxia Membership Token', 2685, 'N/A', 'N/A', '/coins/tmtstarstar/overview', 1, 'cryptocompare'),
(2517, 877073, 'NEXO', 'NEXO (NEXO)', 'NEXO', 2686, 'N/A', 'N/A', '/coins/nexo/overview', 1, 'cryptocompare'),
(2518, 877266, 'SRC**', 'SwissRealCoin (SRC**)', 'SwissRealCoin', 2688, 'N/A', 'N/A', '/coins/srcstarstar/overview', 1, 'cryptocompare'),
(2519, 877303, 'SS', 'Sharder (SS)', 'Sharder', 2689, 'N/A', 'N/A', '/coins/ss/overview', 1, 'cryptocompare'),
(2520, 877310, 'IFX', 'Infinex (IFX)', 'Infinex', 2690, 'Lyra2RE', 'PoW', '/coins/ifx/overview', 1, 'cryptocompare'),
(2521, 877383, '0XBTC', '0xBitcoin (0xBTC)', '0xBitcoin', 2691, 'N/A', 'N/A', '/coins/0xbtc/overview', 1, 'cryptocompare'),
(2522, 878068, 'EDU', 'EduCoin (EDU)', 'EduCoin', 2695, 'N/A', 'N/A', '/coins/edu/overview', 1, 'cryptocompare'),
(2523, 878206, 'PCL', 'Peculium (PCL)', 'Peculium', 2696, 'N/A', 'N/A', '/coins/pcl/overview', 1, 'cryptocompare'),
(2524, 879004, 'MITX', 'Morpheus Infrastructure Token (MITX)', 'Morpheus Infrastructure Token', 2698, 'N/A', 'N/A', '/coins/mitx/overview', 1, 'cryptocompare'),
(2525, 879031, 'APH', 'Aphelion (APH)', 'Aphelion', 2699, 'N/A', 'N/A', '/coins/aph/overview', 1, 'cryptocompare'),
(2526, 879035, 'NBAI', 'Nebula AI (NBAI)', 'Nebula AI', 2700, 'N/A', 'N/A', '/coins/nbai/overview', 1, 'cryptocompare'),
(2527, 879044, 'CVT', 'CyberVein (CVT)', 'CyberVein', 2701, 'N/A', 'N/A', '/coins/cvt/overview', 1, 'cryptocompare'),
(2528, 879102, 'TUT', 'Tutellus (TUT)', 'Tutellus', 2702, 'N/A', 'N/A', '/coins/tut/overview', 1, 'cryptocompare'),
(2529, 879856, 'BETT', 'Bettium (BETT)', 'Bettium', 2704, 'N/A', 'N/A', '/coins/bett/overview', 1, 'cryptocompare'),
(2530, 882302, 'NOAH', 'NOAHCOIN (NOAH)', 'NOAHCOIN', 2705, 'N/A', 'N/A', '/coins/noah/overview', 1, 'cryptocompare'),
(2531, 883061, 'PAL', 'PolicyPal Network (PAL)', 'PolicyPal Network', 2706, 'N/A', 'N/A', '/coins/pal/overview', 1, 'cryptocompare'),
(2532, 883094, 'ENU', 'Enumivo (ENU)', 'Enumivo', 2707, 'N/A', 'N/A', '/coins/enu/overview', 1, 'cryptocompare'),
(2533, 883311, 'BFDT', 'Befund (BFDT)', 'Befund', 2708, 'N/A', 'N/A', '/coins/bfdt/overview', 1, 'cryptocompare'),
(2534, 883514, 'KEP', 'Kepler (KEP)', 'Kepler', 2709, 'N/A', 'N/A', '/coins/kep/overview', 1, 'cryptocompare'),
(2535, 883748, 'RUBY', 'Rubius (RUBY)', 'Rubius', 2710, 'N/A', 'N/A', '/coins/ruby/overview', 1, 'cryptocompare'),
(2536, 883811, 'CTKN', 'Curaizon (CTKN)', 'Curaizon', 2711, 'N/A', 'N/A', '/coins/ctkn/overview', 1, 'cryptocompare'),
(2537, 884571, 'YUM', 'Yumerium (YUM)', 'Yumerium', 2712, 'N/A', 'N/A', '/coins/yum/overview', 1, 'cryptocompare'),
(2538, 884902, 'GSC', 'Global Social Chain (GSC)', 'Global Social Chain', 2713, 'N/A', 'N/A', '/coins/gsc/overview', 1, 'cryptocompare'),
(2539, 885400, 'DESI', 'Desico (DESI)', 'Desico', 2714, 'N/A', 'N/A', '/coins/desi/overview', 1, 'cryptocompare'),
(2540, 885403, 'FNP', 'FlipNpik (FNP)', 'FlipNpik', 2715, 'N/A', 'N/A', '/coins/fnp/overview', 1, 'cryptocompare'),
(2541, 885469, 'VLUX', 'VLUX (VLUX)', 'VLUX', 2716, 'N/A', 'N/A', '/coins/vlux/overview', 1, 'cryptocompare'),
(2542, 885599, 'MTC', 'DOCADEMIC (MTC)', 'DOCADEMIC', 2717, 'N/A', 'N/A', '/coins/mtc/overview', 1, 'cryptocompare'),
(2543, 885623, 'MT*', 'MyToken (MT*)', 'MyToken', 2718, 'N/A', 'N/A', '/coins/mtstar/overview', 1, 'cryptocompare'),
(2544, 885637, 'SSH', 'StreamSpace (SSH)', 'StreamSpace', 2719, 'N/A', 'N/A', '/coins/ssh/overview', 1, 'cryptocompare'),
(2545, 886928, 'XBI', 'Bitcoin Incognito (XBI)', 'Bitcoin Incognito', 2720, 'XEVAN', 'PoS/PoW', '/coins/xbi/overview', 1, 'cryptocompare'),
(2546, 886955, 'VRA', 'Verasity (VRA)', 'Verasity', 2721, 'N/A', 'PoW', '/coins/vra/overview', 1, 'cryptocompare'),
(2547, 887527, 'TRUE', 'True Chain (TRUE)', 'True Chain', 2722, 'N/A', 'N/A', '/coins/true/overview', 1, 'cryptocompare'),
(2548, 887531, 'MRK', 'MARK.SPACE (MRK)', 'MARK.SPACE', 2723, 'N/A', 'PoW', '/coins/mrk/overview', 1, 'cryptocompare'),
(2549, 887639, 'FRV', 'Fitrova (FRV)', 'Fitrova', 2724, 'N/A', 'N/A', '/coins/frv/overview', 1, 'cryptocompare'),
(2550, 887666, 'WINS', 'WinStars (WINS)', 'WinStars', 2725, 'N/A', 'N/A', '/coins/wins/overview', 1, 'cryptocompare'),
(2551, 887706, 'XES', 'Proxeus (XES)', 'Proxeus', 2726, 'N/A', 'N/A', '/coins/xes/overview', 1, 'cryptocompare'),
(2552, 887741, 'RTB', 'AB-CHAIN (RTB)', 'AB-CHAIN', 2727, 'N/A', 'N/A', '/coins/rtb/overview', 1, 'cryptocompare'),
(2553, 888262, 'FXT', 'FuzeX (FXT)', 'FuzeX', 2728, 'N/A', 'N/A', '/coins/fxt/overview', 1, 'cryptocompare'),
(2554, 888283, 'HYDRO', 'Hydrogen (HYDRO)', 'Hydrogen', 2729, 'N/A', 'N/A', '/coins/hydro/overview', 1, 'cryptocompare'),
(2555, 888318, 'DXC', 'DixiCoin (DXC)', 'DixiCoin', 2730, 'C11', 'PoW/PoS', '/coins/dxc/overview', 1, 'cryptocompare'),
(2556, 888499, 'CHBR', 'CryptoHub (CHBR)', 'CryptoHub', 2731, 'N/A', 'N/A', '/coins/chbr/overview', 1, 'cryptocompare'),
(2557, 889045, 'OWD', 'Owlstand (OWD)', 'Owlstand', 2732, 'N/A', 'N/A', '/coins/owd/overview', 1, 'cryptocompare'),
(2558, 889293, 'ELLI', 'ElliotCoin (ELLI)', 'ElliotCoin', 2733, 'XEVAN', 'PoW/PoS', '/coins/elli/overview', 1, 'cryptocompare'),
(2559, 889302, 'AXS', 'AXS (AXS)', 'AXS', 2734, 'C11', 'PoW/PoS', '/coins/axs/overview', 1, 'cryptocompare'),
(2560, 889339, 'DAN', 'Daneel (DAN)', 'Daneel', 2735, 'N/A', 'N/A', '/coins/dan/overview', 1, 'cryptocompare'),
(2561, 889870, 'UBT', 'UniBright (UBT)', 'UniBright', 2737, 'N/A', 'N/A', '/coins/ubt/overview', 1, 'cryptocompare'),
(2562, 889900, 'AMO', 'AMO Coin (AMO)', 'AMO Coin', 2738, 'N/A', 'N/A', '/coins/amo/overview', 1, 'cryptocompare'),
(2563, 889997, 'LBA', 'Libra Credit (LBA)', 'Libra Credit', 2741, 'N/A', 'N/A', '/coins/lba/overview', 1, 'cryptocompare'),
(2564, 890043, 'LIVE', 'Live Stars (LIVE)', 'Live Stars', 2742, 'N/A', 'N/A', '/coins/live/overview', 1, 'cryptocompare'),
(2565, 890044, 'GBG', 'Golos Gold (GBG)', 'Golos Gold', 2743, 'N/A', 'PoW', '/coins/gbg/overview', 1, 'cryptocompare'),
(2566, 890069, 'CNN', 'Content Neutrality Network (CNN)', 'Content Neutrality Network', 2744, 'N/A', 'N/A', '/coins/cnn/overview', 1, 'cryptocompare'),
(2567, 890083, 'SHL', 'Oyster Shell (SHL)', 'Oyster Shell', 2745, 'N/A', 'N/A', '/coins/shl/overview', 1, 'cryptocompare'),
(2568, 890114, 'ETZ', 'EtherZero (ETZ)', 'EtherZero', 2746, 'Ethash', 'PoW', '/coins/etz/overview', 1, 'cryptocompare'),
(2569, 890130, 'SKM', 'Skrumble Network (SKM)', 'Skrumble Network', 2747, 'N/A', 'N/A', '/coins/skm/overview', 1, 'cryptocompare'),
(2570, 890347, 'SHR', 'ShareRing (SHR)', 'ShareRing', 2748, 'N/A', 'N/A', '/coins/shr/overview', 1, 'cryptocompare'),
(2571, 890611, 'IVY', 'IvyKoin (IVY)', 'IvyKoin', 2750, 'N/A', 'N/A', '/coins/ivy/overview', 1, 'cryptocompare'),
(2572, 890623, 'KEC', 'KEYCO (KEC)', 'KEYCO', 2751, 'Tribus', 'PoW', '/coins/kec/overview', 1, 'cryptocompare'),
(2573, 890624, 'ODE', 'ODEM  (ODE)', 'ODEM ', 2752, 'N/A', 'N/A', '/coins/ode/overview', 1, 'cryptocompare'),
(2574, 890645, 'HOT', 'Hydro Protocol (HOT)', 'Hydro Protocol', 2753, 'N/A', 'N/A', '/coins/hot/overview', 1, 'cryptocompare'),
(2575, 890663, 'AMN', 'Amon (AMN)', 'Amon', 2754, 'N/A', 'N/A', '/coins/amn/overview', 1, 'cryptocompare'),
(2576, 890783, 'SABR', 'SABR Coin (SABR)', 'SABR Coin', 2755, 'Scrypt', 'PoW/PoS', '/coins/sabr/overview', 1, 'cryptocompare'),
(2577, 890817, 'HWC', 'HollyWoodCoin (HWC)', 'HollyWoodCoin', 2756, 'Scrypt', 'PoS', '/coins/hwc/overview', 1, 'cryptocompare'),
(2578, 890851, 'BITGOLD', 'bitGold (BITGOLD)', 'bitGold', 2757, 'N/A', 'N/A', '/coins/bitgold/overview', 1, 'cryptocompare'),
(2579, 892415, 'BITSILVE', 'bitSilver (BITSILVER)', 'bitSilver', 2758, 'N/A', 'N/A', '/coins/bitsilver/overview', 1, 'cryptocompare'),
(2580, 892475, 'GIN', 'GINcoin (GIN)', 'GINcoin', 2760, 'Lyra2Z', 'PoW', '/coins/gin/overview', 1, 'cryptocompare'),
(2581, 892524, 'OPEN', 'Open Platform (OPEN)', 'Open Platform', 2761, 'N/A', 'N/A', '/coins/open/overview', 1, 'cryptocompare'),
(2582, 892539, 'NLX', 'Nullex (NLX)', 'Nullex', 2762, 'N/A', 'PoS', '/coins/nlx/overview', 1, 'cryptocompare'),
(2583, 892657, 'LNC*', 'Linker Coin (LNC*)', 'Linker Coin', 2763, 'N/A', 'N/A', '/coins/lncstar/overview', 1, 'cryptocompare'),
(2584, 892684, 'FACE', 'Faceter  (FACE)', 'Faceter ', 2764, 'N/A', 'N/A', '/coins/face/overview', 1, 'cryptocompare'),
(2585, 892731, 'MRPH', 'Morpheus Network (MRPH)', 'Morpheus Network', 2765, 'N/A', 'N/A', '/coins/mrph/overview', 1, 'cryptocompare'),
(2586, 893122, 'IOTX', 'IoTeX Network (IOTX)', 'IoTeX Network', 2766, 'N/A', 'N/A', '/coins/iotx/overview', 1, 'cryptocompare'),
(2587, 893271, 'STM', 'Streamity (STM)', 'Streamity', 2769, 'N/A', 'N/A', '/coins/stm/overview', 1, 'cryptocompare'),
(2588, 893480, 'AITT', 'AITrading (AITT)', 'AITrading', 2776, 'N/A', 'N/A', '/coins/aitt/overview', 1, 'cryptocompare'),
(2589, 893485, 'ITM', 'intimate.io (ITM)', 'intimate.io', 2777, 'N/A', 'N/A', '/coins/itm/overview', 1, 'cryptocompare'),
(2590, 894052, 'VID', 'VideoCoin (VID)', 'VideoCoin', 2778, 'N/A', 'PoW/PoS', '/coins/vid/overview', 1, 'cryptocompare'),
(2591, 894138, 'UCT', 'UCOT (UCT)', 'UCOT', 2779, 'N/A', 'N/A', '/coins/uct/overview', 1, 'cryptocompare'),
(2592, 895370, 'SNTR', 'Silent Notary (SNTR)', 'Silent Notary', 2780, 'N/A', 'N/A', '/coins/sntr/overview', 1, 'cryptocompare'),
(2593, 895379, 'ZMR', 'Monero 0 (ZMR)', 'Monero 0', 2781, 'CryptoNight', 'PoW', '/coins/zmr/overview', 1, 'cryptocompare'),
(2594, 895447, 'XMV', 'MoneroV (XMV)', 'MoneroV', 2782, 'CryptoNight', 'PoW', '/coins/xmv/overview', 1, 'cryptocompare'),
(2595, 897496, 'NKN', 'NKN (NKN)', 'NKN', 2783, 'N/A', 'PoR', '/coins/nkn/overview', 1, 'cryptocompare'),
(2596, 897502, 'ELY', 'Elysian (ELY)', 'Elysian', 2784, 'N/A', 'N/A', '/coins/ely/overview', 1, 'cryptocompare'),
(2597, 897513, 'HER', 'Hero Node (HER)', 'Hero Node', 2785, 'N/A', 'N/A', '/coins/her/overview', 1, 'cryptocompare'),
(2598, 898215, 'PAR', 'Parlay (PAR)', 'Parlay', 2786, 'Scrypt', 'PoS', '/coins/par/overview', 1, 'cryptocompare'),
(2599, 898308, 'SLX', 'Slate (SLX)', 'Slate', 2788, 'Slatechain', 'PoW', '/coins/slx/overview', 1, 'cryptocompare'),
(2600, 898331, 'LTCC', 'Listerclassic Coin (LTCC)', 'Listerclassic Coin', 2789, 'Scrypt', 'PoW/PoS', '/coins/ltcc/overview', 1, 'cryptocompare'),
(2601, 898340, 'RST', 'REGA Risk Sharing Token (RST)', 'REGA Risk Sharing Token', 2790, 'N/A', 'N/A', '/coins/rst/overview', 1, 'cryptocompare'),
(2602, 898367, 'AMX', 'Amero (AMX)', 'Amero', 2792, 'NeoScrypt', 'PoW/PoS', '/coins/amx/overview', 1, 'cryptocompare'),
(2603, 898372, 'TFC', 'The Freedom Coin (TFC)', 'The Freedom Coin', 2793, 'X11', 'PoS', '/coins/tfc/overview', 1, 'cryptocompare'),
(2604, 898398, 'MSC*', 'MaisCoin (MSC*)', 'MaisCoin', 2794, 'N/A', 'PoW', '/coins/mscstar/overview', 1, 'cryptocompare'),
(2605, 898411, 'REPO', 'Repo Coin (REPO)', 'Repo Coin', 2795, 'N/A', 'N/A', '/coins/repo/overview', 1, 'cryptocompare'),
(2606, 898850, 'IRC', 'IRONCOIN (IRC)', 'IRONCOIN', 2796, 'N/A', 'N/A', '/coins/irc/overview', 1, 'cryptocompare'),
(2607, 898891, 'PLC*', 'PlatinCoin (PLC*)', 'PlatinCoin', 2798, 'CryptoNight', 'PoW', '/coins/plcstar/overview', 1, 'cryptocompare'),
(2608, 898898, 'OIO', 'Online (OIO)', 'Online', 2799, 'N/A', 'N/A', '/coins/oio/overview', 1, 'cryptocompare'),
(2609, 898977, 'ANGL', 'Angel Token (ANGL)', 'Angel Token', 2800, 'N/A', 'N/A', '/coins/angl/overview', 1, 'cryptocompare'),
(2610, 898986, 'ANTS', 'ANTS Reloaded (ANTS)', 'ANTS Reloaded', 2801, 'N/A', 'N/A', '/coins/ants/overview', 1, 'cryptocompare'),
(2611, 899007, 'KNG', 'BetKings (KNG)', 'BetKings', 2803, 'X11', 'PoS', '/coins/kng/overview', 1, 'cryptocompare'),
(2612, 899017, 'AUC*', 'AU-Coin (AUC*)', 'AU-Coin', 2804, 'N/A', 'N/A', '/coins/aucstar/overview', 1, 'cryptocompare'),
(2613, 899065, 'CMM', 'Commercium  (CMM)', 'Commercium ', 2808, 'Equihash', 'N/A', '/coins/cmm/overview', 1, 'cryptocompare'),
(2614, 899488, 'STT', 'Staramba (STT)', 'Staramba', 2809, 'N/A', 'N/A', '/coins/stt/overview', 1, 'cryptocompare'),
(2615, 899504, 'WYS', 'Wysker (WYS)', 'Wysker', 2810, 'N/A', 'N/A', '/coins/wys/overview', 1, 'cryptocompare'),
(2616, 899528, 'COG', 'Cognitio (COG)', 'Cognitio', 2811, 'SHA256D', 'PoW/PoS', '/coins/cog/overview', 1, 'cryptocompare'),
(2617, 899541, 'ZIPT', 'Zippie (ZIPT)', 'Zippie', 2812, 'N/A', 'N/A', '/coins/zipt/overview', 1, 'cryptocompare'),
(2618, 899553, 'QKC', 'QuarkChain (QKC)', 'QuarkChain', 2813, 'N/A', 'N/A', '/coins/qkc/overview', 1, 'cryptocompare'),
(2619, 899568, 'OSA', 'Optimal Shelf Availability Token (OSA)', 'Optimal Shelf Availability Token', 2814, 'N/A', 'N/A', '/coins/osa/overview', 1, 'cryptocompare'),
(2620, 899574, 'EXC', 'Eximchain (EXC)', 'Eximchain', 2815, 'N/A', 'N/A', '/coins/exc/overview', 1, 'cryptocompare'),
(2621, 899712, 'BEN', 'BitCOEN (BEN)', 'BitCOEN', 2819, 'SHA256', 'Limited Conf', '/coins/ben/overview', 1, 'cryptocompare'),
(2622, 900419, 'EDR*', 'Endor Protocol Token  (EDR*)', 'Endor Protocol Token ', 2820, 'N/A', 'N/A', '/coins/edrstar/overview', 1, 'cryptocompare'),
(2623, 900439, 'BCIO', 'Blockchain.io (BCIO)', 'Blockchain.io', 2821, 'N/A', 'N/A', '/coins/bcio/overview', 1, 'cryptocompare'),
(2624, 900577, 'BMK', 'Benchmark (BMK)', 'Benchmark', 2822, 'N/A', 'N/A', '/coins/bmk/overview', 1, 'cryptocompare'),
(2625, 901762, 'ROC', 'Rasputin Online Coin (ROC)', 'Rasputin Online Coin', 2823, 'N/A', 'N/A', '/coins/roc/overview', 1, 'cryptocompare'),
(2626, 901815, 'BZNT', 'Bezant (BZNT)', 'Bezant', 2826, 'N/A', 'N/A', '/coins/bznt/overview', 1, 'cryptocompare'),
(2627, 901834, 'LYL', 'LoyalCoin (LYL)', 'LoyalCoin', 2827, 'N/A', 'N/A', '/coins/lyl/overview', 1, 'cryptocompare'),
(2628, 901870, 'FT', 'Fabric Token (FT)', 'Fabric Token', 2828, 'N/A', 'N/A', '/coins/ft/overview', 1, 'cryptocompare'),
(2629, 901906, 'BMX', 'BitMart Coin (BMX)', 'BitMart Coin', 2829, 'N/A', 'N/A', '/coins/bmx/overview', 1, 'cryptocompare'),
(2630, 901929, 'PHI', 'PHI Token (PHI)', 'PHI Token', 2830, 'N/A', 'N/A', '/coins/phi/overview', 1, 'cryptocompare'),
(2631, 901954, 'PMNT', 'Paymon (PMNT)', 'Paymon', 2832, 'N/A', 'N/A', '/coins/pmnt/overview', 1, 'cryptocompare'),
(2632, 901978, 'BNTN', 'Blocnation (BNTN)', 'Blocnation', 2833, 'PoS', 'PoS', '/coins/bntn/overview', 1, 'cryptocompare'),
(2633, 901980, 'HYT', 'HoryouToken (HYT)', 'HoryouToken', 2834, 'N/A', 'PoW', '/coins/hyt/overview', 1, 'cryptocompare'),
(2634, 902442, 'SOUL*', 'Phantasma (SOUL*)', 'Phantasma', 2835, 'N/A', 'N/A', '/coins/soulstar/overview', 1, 'cryptocompare'),
(2635, 902463, 'GRMD', 'GreenMed (GRMD)', 'GreenMed', 2836, 'N/A', 'N/A', '/coins/grmd/overview', 1, 'cryptocompare'),
(2636, 902487, 'SSC', 'SelfSell (SSC)', 'SelfSell', 2837, 'DPoS', 'DPoS', '/coins/ssc/overview', 1, 'cryptocompare'),
(2637, 902527, 'LOKI', 'Loki (LOKI)', 'Loki', 2838, 'CryptoNight ', 'PoW', '/coins/loki/overview', 1, 'cryptocompare'),
(2638, 902577, 'BTT', 'Blocktrade token (BTT)', 'Blocktrade token', 2841, 'N/A', 'N/A', '/coins/btt/overview', 1, 'cryptocompare'),
(2639, 902616, 'NCP', 'Newton Coin (NCP)', 'Newton Coin', 2842, 'CryptoNight', 'PoW', '/coins/ncp/overview', 1, 'cryptocompare'),
(2640, 902715, 'MPT', 'Media Protocol Token (MPT)', 'Media Protocol Token', 2843, 'Ethash', 'PoW', '/coins/mpt/overview', 1, 'cryptocompare'),
(2641, 903091, 'STAX', 'Staxcoin (STAX)', 'Staxcoin', 2844, 'Scrypt', 'PoW/PoS', '/coins/stax/overview', 1, 'cryptocompare'),
(2642, 903256, 'MRN', 'Mercoin (MRN)', 'Mercoin', 2845, 'Scrypt', 'PoW/PoS', '/coins/mrn/overview', 1, 'cryptocompare'),
(2643, 903282, 'FOPA', 'Fopacoin (FOPA)', 'Fopacoin', 2846, 'N/A', 'N/A', '/coins/fopa/overview', 1, 'cryptocompare'),
(2644, 903295, 'UTNP', 'Universa Token (UTNP)', 'Universa Token', 2847, 'N/A', 'N/A', '/coins/utnp/overview', 1, 'cryptocompare'),
(2645, 903690, 'CBC', 'CashBet Coin (CBC)', 'CashBet Coin', 2848, 'N/A', 'N/A', '/coins/cbc/overview', 1, 'cryptocompare'),
(2646, 903703, 'OOT', 'Utrum (OOT)', 'Utrum', 2849, 'N/A', 'N/A', '/coins/oot/overview', 1, 'cryptocompare'),
(2647, 903748, 'NBC', 'Niobium (NBC)', 'Niobium', 2851, 'N/A', 'N/A', '/coins/nbc/overview', 1, 'cryptocompare'),
(2648, 903811, 'SIC', 'Swisscoin (SIC)', 'Swisscoin', 2852, 'Scrypt', 'PoW/PoS', '/coins/sic/overview', 1, 'cryptocompare'),
(2649, 903856, 'ALG', 'Algory (ALG)', 'Algory', 2853, 'N/A', 'N/A', '/coins/alg/overview', 1, 'cryptocompare'),
(2650, 903863, 'PAI', 'PCHAIN (PAI)', 'PCHAIN', 2854, 'N/A', 'N/A', '/coins/pai/overview', 1, 'cryptocompare'),
(2651, 904319, 'EXCC', 'ExchangeCoin (EXCC)', 'ExchangeCoin', 2855, 'Equihash', 'PoW', '/coins/excc/overview', 1, 'cryptocompare'),
(2652, 904410, 'REL', 'Reliance (REL)', 'Reliance', 2857, 'X11', 'PoS', '/coins/rel/overview', 1, 'cryptocompare'),
(2653, 905644, 'BTCN', 'BitcoiNote (BTCN)', 'BitcoiNote', 2858, 'CryptoNight', 'PoW', '/coins/btcn/overview', 1, 'cryptocompare'),
(2654, 905744, 'HERO', 'Hero (HERO)', 'Hero', 2859, 'N/A', 'N/A', '/coins/hero/overview', 1, 'cryptocompare'),
(2655, 906122, 'EJAC', 'EJA Coin (EJAC)', 'EJA Coin', 2861, 'N/A', 'N/A', '/coins/ejac/overview', 1, 'cryptocompare'),
(2656, 906171, 'APIS', 'APIS (APIS)', 'APIS', 2862, 'N/A', 'PoW', '/coins/apis/overview', 1, 'cryptocompare'),
(2657, 906271, 'UPP', 'Sentinel Protocol (UPP)', 'Sentinel Protocol', 2864, 'N/A', 'N/A', '/coins/upp/overview', 1, 'cryptocompare'),
(2658, 906635, 'XT3', 'Xt3ch (XT3)', 'Xt3ch', 2866, 'Scrypt', 'PoS', '/coins/xt3/overview', 1, 'cryptocompare'),
(2659, 907129, 'MGD', 'MassGrid (MGD)', 'MassGrid', 2868, 'Jump Consist', 'PoW', '/coins/mgd/overview', 1, 'cryptocompare'),
(2660, 907161, 'VIG', 'TheVig (VIG)', 'TheVig', 2869, 'SHA256D', 'PoW/PoS', '/coins/vig/overview', 1, 'cryptocompare'),
(2661, 907167, 'PLURA', 'PluraCoin (PLURA)', 'PluraCoin', 2870, 'CryptoNight', 'PoW', '/coins/plura/overview', 1, 'cryptocompare'),
(2662, 907177, 'SCX', 'Swachhcoin (SCX)', 'Swachhcoin', 2871, 'N/A', 'N/A', '/coins/scx/overview', 1, 'cryptocompare'),
(2663, 907205, 'NWCN', 'NowCoin (NWCN)', 'NowCoin', 2872, 'N/A', 'N/A', '/coins/nwcn/overview', 1, 'cryptocompare'),
(2664, 907227, 'AEC*', 'EmaratCoin (AEC*)', 'EmaratCoin', 2873, 'Scrypt', 'PoW/PoS', '/coins/aecstar/overview', 1, 'cryptocompare'),
(2665, 907238, 'BTF*', 'BitcoinFor (BTF*)', 'BitcoinFor', 2874, 'Scrypt', 'PoS', '/coins/btfstar/overview', 1, 'cryptocompare'),
(2666, 907251, 'GMC*', 'GMC Coin (GMC*)', 'GMC Coin', 2875, 'X11', 'PoW/PoS', '/coins/gmcstar/overview', 1, 'cryptocompare'),
(2667, 907268, 'ICST', 'ICST (ICST)', 'ICST', 2877, 'N/A', 'N/A', '/coins/icst/overview', 1, 'cryptocompare'),
(2668, 907296, 'PURK', 'Purk (PURK)', 'Purk', 2878, 'Wild Keccak', 'N/A', '/coins/purk/overview', 1, 'cryptocompare'),
(2669, 907306, 'ROE', 'Rover Coin (ROE)', 'Rover Coin', 2879, 'X11', 'PoW/PoS', '/coins/roe/overview', 1, 'cryptocompare'),
(2670, 907331, 'DKD', 'Dekado (DKD)', 'Dekado', 2881, 'X15', 'PoS', '/coins/dkd/overview', 1, 'cryptocompare'),
(2671, 907677, 'LYNX', 'Lynx (LYNX)', 'Lynx', 2882, 'Scrypt', 'HPoW', '/coins/lynx/overview', 1, 'cryptocompare'),
(2672, 907721, 'POSQ', 'Poseidon Quark (POSQ)', 'Poseidon Quark', 2884, 'Quark', 'PoS', '/coins/posq/overview', 1, 'cryptocompare'),
(2673, 907755, 'OCTO*', 'OctoBit Coin (OCTO*)', 'OctoBit Coin', 2887, 'Scrypt', 'PoS', '/coins/octostar/overview', 1, 'cryptocompare'),
(2674, 907824, 'YCE', 'MYCE (YCE)', 'MYCE', 2888, 'Scrypt', 'PoW/PoS', '/coins/yce/overview', 1, 'cryptocompare'),
(2675, 907847, 'OCC', 'Original Crypto Coin (OCC)', 'Original Crypto Coin', 2889, 'N/A', 'N/A', '/coins/occ/overview', 1, 'cryptocompare'),
(2676, 907868, 'ARO', 'Arionum (ARO)', 'Arionum', 2891, 'SHA-512', 'PoW', '/coins/aro/overview', 1, 'cryptocompare'),
(2677, 907885, 'BWS', 'BitcoinWSpectrum (BWS)', 'BitcoinWSpectrum', 2892, 'SHA256', 'PoS', '/coins/bws/overview', 1, 'cryptocompare'),
(2678, 908896, 'BTCC', 'Bitcoin Core (BTCC)', 'Bitcoin Core', 2894, 'SHA256', 'PoW', '/coins/btcc/overview', 1, 'cryptocompare'),
(2679, 909286, 'GOLF', 'GolfCoin (GOLF)', 'GolfCoin', 2895, 'SHA256D', 'PoW/PoS', '/coins/golf/overview', 1, 'cryptocompare'),
(2680, 909304, 'MUSE', 'Muse (MUSE)', 'Muse', 2896, 'DPoS', 'PoS', '/coins/muse/overview', 1, 'cryptocompare'),
(2681, 909342, 'OCT', 'OracleChain (OCT)', 'OracleChain', 2897, 'N/A', 'N/A', '/coins/oct/overview', 1, 'cryptocompare'),
(2682, 909375, 'XCEL', 'XcelTrip (XCEL)', 'XcelTrip', 2898, 'N/A', 'N/A', '/coins/xcel/overview', 1, 'cryptocompare'),
(2683, 909390, 'ECH', 'EthereCash (ECH)', 'EthereCash', 2899, 'N/A', 'N/A', '/coins/ech/overview', 1, 'cryptocompare'),
(2684, 909406, 'XMN', 'Motion (XMN)', 'Motion', 2900, 'X16R', 'PoW', '/coins/xmn/overview', 1, 'cryptocompare'),
(2685, 909414, 'PLUS1', 'PlusOneCoin (PLUS1)', 'PlusOneCoin', 2901, 'HMQ1725', 'PoW', '/coins/plus1/overview', 1, 'cryptocompare'),
(2686, 909713, 'COI', 'Coinnec (COI)', 'Coinnec', 2902, 'N/A', 'N/A', '/coins/coi/overview', 1, 'cryptocompare'),
(2687, 909733, 'CANDY', 'UnicornGo Candy (CANDY)', 'UnicornGo Candy', 2904, 'N/A', 'N/A', '/coins/candy/overview', 1, 'cryptocompare'),
(2688, 909821, 'GMCN', 'GambleCoin (GMCN)', 'GambleCoin', 2909, 'Scrypt', 'PoS', '/coins/gmcn/overview', 1, 'cryptocompare'),
(2689, 909861, 'TRVC', 'Trivecoin (TRVC)', 'Trivecoin', 2910, 'X11', 'PoW/PoS', '/coins/trvc/overview', 1, 'cryptocompare'),
(2690, 909913, 'KRX', 'RAVN Korrax  (KRX)', 'RAVN Korrax ', 2914, 'N/A', 'N/A', '/coins/krx/overview', 1, 'cryptocompare'),
(2691, 909956, 'BITX', 'BitScreener (BITX)', 'BitScreener', 2918, 'N/A', 'N/A', '/coins/bitx/overview', 1, 'cryptocompare'),
(2692, 910472, 'SKB*', 'Sakura Bloom (SKB*)', 'Sakura Bloom', 2919, 'N/A', 'N/A', '/coins/skbstar/overview', 1, 'cryptocompare'),
(2693, 910498, 'HFT', 'Hirefreehands (HFT)', 'Hirefreehands', 2920, 'N/A', 'N/A', '/coins/hft/overview', 1, 'cryptocompare'),
(2694, 910555, 'OPP*', 'OPP Open WiFi (OPP*)', 'OPP Open WiFi', 2922, 'N/A', 'N/A', '/coins/oppstar/overview', 1, 'cryptocompare'),
(2695, 910561, 'DTEM', 'Dystem (DTEM)', 'Dystem', 2923, 'Quark', 'PoS', '/coins/dtem/overview', 1, 'cryptocompare'),
(2696, 910663, 'TIP', 'Tip Blockchain (TIP)', 'Tip Blockchain', 2929, 'DPoS', 'PoS', '/coins/tip/overview', 1, 'cryptocompare'),
(2697, 910721, 'SOUND', 'Inmusik (SOUND)', 'Inmusik', 2931, 'N/A', 'N/A', '/coins/sound/overview', 1, 'cryptocompare'),
(2698, 911095, 'HB', 'HeartBout (HB)', 'HeartBout', 2935, 'N/A', 'N/A', '/coins/hb/overview', 1, 'cryptocompare'),
(2699, 911111, 'TRW', 'Triwer (TRW)', 'Triwer', 2937, 'N/A', 'N/A', '/coins/trw/overview', 1, 'cryptocompare'),
(2700, 911139, 'GIC', 'Giant (GIC)', 'Giant', 2940, 'Quark', 'PoW/PoS', '/coins/gic/overview', 1, 'cryptocompare'),
(2701, 911146, 'BGL', 'Buglab (BGL)', 'Buglab', 2941, 'N/A', 'PoW', '/coins/bgl/overview', 1, 'cryptocompare'),
(2702, 911229, 'EPIK', 'EPIK Token (EPIK)', 'EPIK Token', 2946, 'N/A', 'N/A', '/coins/epik/overview', 1, 'cryptocompare'),
(2703, 912878, 'ZMN', 'ZMINE (ZMN)', 'ZMINE', 2951, 'N/A', 'N/A', '/coins/zmn/overview', 1, 'cryptocompare'),
(2704, 912889, 'PNY', 'Peony Coin (PNY)', 'Peony Coin', 2952, 'Scrypt', 'PoS', '/coins/pny/overview', 1, 'cryptocompare'),
(2705, 912894, 'SAFE', 'SafeCoin (SAFE)', 'SafeCoin', 2953, 'Zhash', 'PoW/PoS', '/coins/safe/overview', 1, 'cryptocompare'),
(2706, 912904, 'COU', 'Couchain (COU)', 'Couchain', 2954, 'N/A', 'N/A', '/coins/cou/overview', 1, 'cryptocompare'),
(2707, 912933, 'BID', 'BidCoin (BID)', 'BidCoin', 2955, 'N/A', 'N/A', '/coins/bid/overview', 1, 'cryptocompare'),
(2708, 912943, 'ATH', 'Atheios (ATH)', 'Atheios', 2956, 'Dagger', 'PoW', '/coins/ath/overview', 1, 'cryptocompare'),
(2709, 912961, 'ABS', 'Absolute Coin (ABS)', 'Absolute Coin', 2957, 'Lyra2REv2', 'PoW/PoS', '/coins/abs/overview', 1, 'cryptocompare'),
(2710, 913054, 'JOY*', 'JOYSO (JOY*)', 'JOYSO', 2958, 'N/A', 'N/A', '/coins/joystar/overview', 1, 'cryptocompare'),
(2711, 913061, 'VITAE', 'Vitae (VITAE)', 'Vitae', 2959, 'Quark', 'PoS', '/coins/vitae/overview', 1, 'cryptocompare'),
(2712, 913066, 'XET', 'Eternal Token (XET)', 'Eternal Token', 2960, 'N/A', 'N/A', '/coins/xet/overview', 1, 'cryptocompare'),
(2713, 913090, '0xDIARY', 'The 0xDiary Token (0xDIARY)', 'The 0xDiary Token', 2961, 'N/A', 'N/A', '/coins/0xdiary/overview', 1, 'cryptocompare'),
(2714, 913109, 'BTCS*', 'Bitcoin Supreme (BTCS*)', 'Bitcoin Supreme', 2962, 'Scrypt', 'PoS', '/coins/btcsstar/overview', 1, 'cryptocompare'),
(2715, 913585, 'TDP', 'TrueDeck (TDP)', 'TrueDeck', 2963, 'N/A', 'N/A', '/coins/tdp/overview', 1, 'cryptocompare'),
(2716, 913606, 'XGS', 'GenesisX (XGS)', 'GenesisX', 2964, 'XEVAN', 'PoS', '/coins/xgs/overview', 1, 'cryptocompare'),
(2717, 913648, 'XUEZ', 'XUEZ (XUEZ)', 'XUEZ', 2965, 'XEVAN', 'N/A', '/coins/xuez/overview', 1, 'cryptocompare'),
(2718, 913676, 'BIM', 'BitminerCoin (BIM)', 'BitminerCoin', 2967, 'CryptoNight', 'PoW', '/coins/bim/overview', 1, 'cryptocompare'),
(2719, 913722, 'Dow', 'DowCoin (Dow)', 'DowCoin', 2969, 'N/A', 'N/A', '/coins/dow/overview', 1, 'cryptocompare'),
(2720, 913735, 'HEX', 'HexCoin (HEX)', 'HexCoin', 2970, 'Scrypt', 'PoW', '/coins/hex/overview', 1, 'cryptocompare'),
(2721, 914321, 'EMN', 'Eminent Token  (EMN)', 'Eminent Token ', 2971, 'N/A', 'N/A', '/coins/emn/overview', 1, 'cryptocompare'),
(2722, 914735, 'PYT', 'Payther (PYT)', 'Payther', 2973, 'N/A', 'N/A', '/coins/pyt/overview', 1, 'cryptocompare'),
(2723, 914753, 'DEI', 'Deimos (DEI)', 'Deimos', 2974, 'Scrypt', 'PoW', '/coins/dei/overview', 1, 'cryptocompare'),
(2724, 914756, 'TPC', 'TPCash (TPC)', 'TPCash', 2975, 'Scrypt', 'PoW/PoS', '/coins/tpc/overview', 1, 'cryptocompare'),
(2725, 914795, 'OYS', 'Oyster Platform (OYS)', 'Oyster Platform', 2976, 'X11', 'PoS', '/coins/oys/overview', 1, 'cryptocompare'),
(2726, 914812, 'WEB*', 'Webchain (WEB*)', 'Webchain', 2977, 'CryptoNight-', 'PoW', '/coins/webstar/overview', 1, 'cryptocompare'),
(2727, 914830, 'VIDT', 'V-ID (VIDT)', 'V-ID', 2978, 'N/A', 'N/A', '/coins/vidt/overview', 1, 'cryptocompare'),
(2728, 914930, 'JEX', 'JEX Token (JEX)', 'JEX Token', 2979, 'N/A', 'N/A', '/coins/jex/overview', 1, 'cryptocompare'),
(2729, 914975, 'ILK', 'Inlock (ILK)', 'Inlock', 2980, 'N/A', 'N/A', '/coins/ilk/overview', 1, 'cryptocompare'),
(2730, 915370, 'RYO', 'Ryo (RYO)', 'Ryo', 2981, 'CryptoNight ', 'PoW', '/coins/ryo/overview', 1, 'cryptocompare'),
(2731, 915377, 'MUSD', 'MUSDcoin (MUSD)', 'MUSDcoin', 2982, 'Scrypt', 'PoW/PoS', '/coins/musd/overview', 1, 'cryptocompare'),
(2732, 915386, 'MIC', 'Mindexcoin (MIC)', 'Mindexcoin', 2983, 'N/A', 'N/A', '/coins/mic/overview', 1, 'cryptocompare'),
(2733, 915401, 'URALS', 'Urals Coin (URALS)', 'Urals Coin', 2984, 'XEVAN', 'PoW', '/coins/urals/overview', 1, 'cryptocompare'),
(2734, 915412, 'QWC', 'Qwertycoin (QWC)', 'Qwertycoin', 2985, 'CryptoNight ', 'PoW', '/coins/qwc/overview', 1, 'cryptocompare'),
(2735, 915420, 'WAB', 'WABnetwork (WAB)', 'WABnetwork', 2986, 'N/A', 'N/A', '/coins/wab/overview', 1, 'cryptocompare'),
(2736, 915437, 'BTN', 'Bitcoin Nova (BTN)', 'Bitcoin Nova', 2987, 'CryptoNight', 'PoW', '/coins/btn/overview', 1, 'cryptocompare'),
(2737, 915444, 'ARE', 'ARENON (ARE)', 'ARENON', 2988, 'X11', 'PoS', '/coins/are/overview', 1, 'cryptocompare'),
(2738, 915449, 'DAC', 'DACash (DAC)', 'DACash', 2989, 'X11', 'PoW', '/coins/dac/overview', 1, 'cryptocompare'),
(2739, 915521, 'EUNO', 'EUNO (EUNO)', 'EUNO', 2990, 'X11', 'PoW/PoS', '/coins/euno/overview', 1, 'cryptocompare'),
(2740, 916694, 'KAAS', 'KAASY.AI (KAAS)', 'KAASY.AI', 2991, 'N/A', 'N/A', '/coins/kaas/overview', 1, 'cryptocompare'),
(2741, 916695, 'MMO', 'MMOCoin (MMO)', 'MMOCoin', 2992, 'Scrypt', 'PoS', '/coins/mmo/overview', 1, 'cryptocompare'),
(2742, 916702, 'MVP', 'Merculet (MVP)', 'Merculet', 2993, 'N/A', 'N/A', '/coins/mvp/overview', 1, 'cryptocompare'),
(2743, 916714, 'DASC', 'DasCoin (DASC)', 'DasCoin', 2994, 'DPoS', 'DPoS', '/coins/dasc/overview', 1, 'cryptocompare'),
(2744, 916728, 'EGT', 'Egretia (EGT)', 'Egretia', 2995, 'N/A', 'N/A', '/coins/egt/overview', 1, 'cryptocompare'),
(2745, 916769, 'MET*', 'Metronome (MET*)', 'Metronome', 2996, 'N/A', 'N/A', '/coins/metstar/overview', 1, 'cryptocompare'),
(2746, 916779, 'PGT', 'Puregold token (PGT)', 'Puregold token', 2997, 'N/A', 'N/A', '/coins/pgt/overview', 1, 'cryptocompare'),
(2747, 916795, 'MEDX', 'Mediblock (MEDX)', 'Mediblock', 2998, 'N/A', 'N/A', '/coins/medx/overview', 1, 'cryptocompare'),
(2748, 916813, 'CET', 'CoinEx token (CET)', 'CoinEx token', 2999, 'N/A', 'N/A', '/coins/cet/overview', 1, 'cryptocompare'),
(2749, 916818, 'SLT*', 'SmartLands (SLT*)', 'SmartLands', 3000, 'N/A', 'N/A', '/coins/sltstar/overview', 1, 'cryptocompare'),
(2750, 916828, 'TGAME', 'TrueGame (TGAME)', 'TrueGame', 3001, 'N/A', 'N/A', '/coins/tgame/overview', 1, 'cryptocompare'),
(2751, 916848, 'SPN*', 'Sapien Network (SPN*)', 'Sapien Network', 3002, 'N/A', 'N/A', '/coins/spnstar/overview', 1, 'cryptocompare'),
(2752, 916851, 'ZINC', 'ZINC (ZINC)', 'ZINC', 3003, 'N/A', 'N/A', '/coins/zinc/overview', 1, 'cryptocompare'),
(2753, 916860, 'KETAN', 'Ketan (KETAN)', 'Ketan', 3004, 'PoS', 'PoS', '/coins/ketan/overview', 1, 'cryptocompare'),
(2754, 916868, 'KBC', 'Karatgold coin (KBC)', 'Karatgold coin', 3005, 'N/A', 'N/A', '/coins/kbc/overview', 1, 'cryptocompare'),
(2755, 917211, 'MFT', 'Mainframe (MFT)', 'Mainframe', 3006, 'N/A', 'N/A', '/coins/mft/overview', 1, 'cryptocompare'),
(2756, 917238, 'INSUR', 'InsurChain Coin (INSUR)', 'InsurChain Coin', 3007, 'N/A', 'N/A', '/coins/insur/overview', 1, 'cryptocompare'),
(2757, 917249, 'NIX', 'NIX (NIX)', 'NIX', 3008, 'Lyra2REv2', 'PoW', '/coins/nix/overview', 1, 'cryptocompare'),
(2758, 917256, 'ZCN', '0chain (ZCN)', '0chain', 3009, 'N/A', 'N/A', '/coins/zcn/overview', 1, 'cryptocompare'),
(2759, 917303, 'FIN', 'Finom FIN Token (FIN)', 'Finom FIN Token', 3010, 'N/A', 'N/A', '/coins/fin/overview', 1, 'cryptocompare'),
(2760, 917365, 'RPM', 'Render Payment (RPM)', 'Render Payment', 3011, 'N/A', 'N/A', '/coins/rpm/overview', 1, 'cryptocompare'),
(2761, 917414, 'DGX', 'Digix Gold token (DGX)', 'Digix Gold token', 3012, 'N/A', 'N/A', '/coins/dgx/overview', 1, 'cryptocompare'),
(2762, 917423, 'ITA', 'Italocoin (ITA)', 'Italocoin', 3014, 'CryptoNight ', 'PoW', '/coins/ita/overview', 1, 'cryptocompare'),
(2763, 917426, 'NOM', 'Finom NOM Token (NOM)', 'Finom NOM Token', 3015, 'N/A', 'N/A', '/coins/nom/overview', 1, 'cryptocompare'),
(2764, 917819, 'XSTC', 'Safe Trade Coin (XSTC)', 'Safe Trade Coin', 3016, 'Scrypt', 'PoS', '/coins/xstc/overview', 1, 'cryptocompare'),
(2765, 918067, 'U42', 'You42 (U42)', 'You42', 3017, 'N/A', 'N/A', '/coins/u42/overview', 1, 'cryptocompare'),
(2766, 918374, 'EGCC', 'Engine (EGCC)', 'Engine', 3018, 'N/A', 'N/A', '/coins/egcc/overview', 1, 'cryptocompare'),
(2767, 918380, 'FREC', 'Freyrchain (FREC)', 'Freyrchain', 3019, 'N/A', 'N/A', '/coins/frec/overview', 1, 'cryptocompare'),
(2768, 918397, 'BITS*', 'Bitswift (BITS*)', 'Bitswift', 3020, 'N/A', 'N/A', '/coins/bitsstar/overview', 1, 'cryptocompare'),
(2769, 918483, 'DCC*', 'Distributed Credit Chain (DCC*)', 'Distributed Credit Chain', 3021, 'N/A', 'N/A', '/coins/dccstar/overview', 1, 'cryptocompare'),
(2770, 918501, 'AOA', 'Aurora  (AOA)', 'Aurora ', 3022, 'N/A', 'N/A', '/coins/aoa/overview', 1, 'cryptocompare'),
(2771, 918514, 'LET', 'LinkEye (LET)', 'LinkEye', 3023, 'N/A', 'N/A', '/coins/let/overview', 1, 'cryptocompare'),
(2772, 918535, 'MTN**', 'Motion (MTN**)', 'Motion', 3024, 'N/A', 'N/A', '/coins/mtnstarstar/overview', 1, 'cryptocompare'),
(2773, 918549, 'PAI*', 'Project Pai (PAI*)', 'Project Pai', 3025, 'SHA256', 'PoW', '/coins/paistar/overview', 1, 'cryptocompare'),
(2774, 918566, 'XIN*', 'Mixin (XIN*)', 'Mixin', 3026, 'N/A', 'N/A', '/coins/xinstar/overview', 1, 'cryptocompare'),
(2775, 918576, 'CRE**', 'Cybereits Token  (CRE**)', 'Cybereits Token ', 3027, 'N/A', 'N/A', '/coins/crestarstar/overview', 1, 'cryptocompare'),
(2776, 918953, 'MEET', 'CoinMeet (MEET)', 'CoinMeet', 3028, 'N/A', 'N/A', '/coins/meet/overview', 1, 'cryptocompare'),
(2777, 918968, 'BOE', 'Bodhi  (BOE)', 'Bodhi ', 3029, 'N/A', 'N/A', '/coins/boe/overview', 1, 'cryptocompare'),
(2778, 918974, 'RTE', 'Rate3  (RTE)', 'Rate3 ', 3030, 'N/A', 'N/A', '/coins/rte/overview', 1, 'cryptocompare'),
(2779, 918989, 'CAR', 'CarBlock  (CAR)', 'CarBlock ', 3031, 'N/A', 'N/A', '/coins/car/overview', 1, 'cryptocompare'),
(2780, 918997, 'CPT', 'Cryptaur (CPT)', 'Cryptaur', 3032, 'N/A', 'N/A', '/coins/cpt/overview', 1, 'cryptocompare'),
(2781, 919014, 'PCO', 'Pecunio (PCO)', 'Pecunio', 3033, 'N/A', 'N/A', '/coins/pco/overview', 1, 'cryptocompare'),
(2782, 919073, 'XPST', 'PokerSports (XPST)', 'PokerSports', 3034, 'N/A', 'N/A', '/coins/xpst/overview', 1, 'cryptocompare'),
(2783, 919094, 'HSC', 'HashCoin  (HSC)', 'HashCoin ', 3035, 'N/A', 'N/A', '/coins/hsc/overview', 1, 'cryptocompare'),
(2784, 920156, 'MCV', 'MCV Token (MCV)', 'MCV Token', 3037, 'N/A', 'N/A', '/coins/mcv/overview', 1, 'cryptocompare'),
(2785, 920190, 'SCRL', 'Scroll (SCRL)', 'Scroll', 3038, 'N/A', 'N/A', '/coins/scrl/overview', 1, 'cryptocompare'),
(2786, 920245, 'CONI', 'CoinBene (CONI)', 'CoinBene', 3039, 'N/A', 'N/A', '/coins/coni/overview', 1, 'cryptocompare'),
(2787, 920249, 'XPAT', 'Bitnation Pangea (XPAT)', 'Bitnation Pangea', 3040, 'N/A', 'N/A', '/coins/xpat/overview', 1, 'cryptocompare'),
(2788, 920276, 'MBLC', 'Mont Blanc (MBLC)', 'Mont Blanc', 3041, 'Scrypt', 'PoS', '/coins/mblc/overview', 1, 'cryptocompare'),
(2789, 920306, 'DIW', 'DIWtoken (DIW)', 'DIWtoken', 3042, 'N/A', 'N/A', '/coins/diw/overview', 1, 'cryptocompare'),
(2790, 920327, 'JOINT', 'Joint Ventures (JOINT)', 'Joint Ventures', 3043, 'N/A', 'N/A', '/coins/joint/overview', 1, 'cryptocompare'),
(2791, 920342, 'IDXM', 'IDEX Membership (IDXM)', 'IDEX Membership', 3044, 'N/A', 'N/A', '/coins/idxm/overview', 1, 'cryptocompare'),
(2792, 920734, 'CCO', 'Ccore (CCO)', 'Ccore', 3045, 'N/A', 'N/A', '/coins/cco/overview', 1, 'cryptocompare'),
(2793, 920748, 'ATMI', 'Atonomi (ATMI)', 'Atonomi', 3046, 'N/A', 'N/A', '/coins/atmi/overview', 1, 'cryptocompare'),
(2794, 920768, 'TKA', 'Tokia (TKA)', 'Tokia', 3047, 'N/A', 'N/A', '/coins/tka/overview', 1, 'cryptocompare'),
(2795, 920771, 'RMT', 'SureRemit (RMT)', 'SureRemit', 3048, 'N/A', 'N/A', '/coins/rmt/overview', 1, 'cryptocompare'),
(2796, 920779, 'OLT', 'OneLedger (OLT)', 'OneLedger', 3049, 'N/A', 'N/A', '/coins/olt/overview', 1, 'cryptocompare'),
(2797, 920794, 'GETX', 'Guaranteed Ethurance Token Extra (GETX)', 'Guaranteed Ethurance Token Extra', 3050, 'N/A', 'N/A', '/coins/getx/overview', 1, 'cryptocompare'),
(2798, 920805, 'IQ', 'Everipedia (IQ)', 'Everipedia', 3051, 'N/A', 'N/A', '/coins/iq/overview', 1, 'cryptocompare'),
(2799, 920817, 'BWT', 'Bittwatt (BWT)', 'Bittwatt', 3052, 'N/A', 'N/A', '/coins/bwt/overview', 1, 'cryptocompare'),
(2800, 920896, 'LST', 'Lendroid Support Token (LST)', 'Lendroid Support Token', 3053, 'N/A', 'N/A', '/coins/lst/overview', 1, 'cryptocompare'),
(2801, 920915, 'EMV', 'Ethereum Movie Venture (EMV)', 'Ethereum Movie Venture', 3055, 'N/A', 'N/A', '/coins/emv/overview', 1, 'cryptocompare'),
(2802, 920927, 'ESZ', 'EtherSportz (ESZ)', 'EtherSportz', 3056, 'N/A', 'N/A', '/coins/esz/overview', 1, 'cryptocompare'),
(2803, 920939, 'TRAK', 'TrakInvest (TRAK)', 'TrakInvest', 3057, 'N/A', 'N/A', '/coins/trak/overview', 1, 'cryptocompare'),
(2804, 920958, 'ZXC', 'Oxcert (ZXC)', 'Oxcert', 3058, 'N/A', 'N/A', '/coins/zxc/overview', 1, 'cryptocompare'),
(2805, 921356, 'BTRN', 'Biotron (BTRN)', 'Biotron', 3059, 'N/A', 'N/A', '/coins/btrn/overview', 1, 'cryptocompare'),
(2806, 921375, 'XMX', 'XMax (XMX)', 'XMax', 3060, 'N/A', 'N/A', '/coins/xmx/overview', 1, 'cryptocompare'),
(2807, 921401, 'VME', 'VeriME (VME)', 'VeriME', 3061, 'N/A', 'N/A', '/coins/vme/overview', 1, 'cryptocompare'),
(2808, 921524, 'VITE', 'VITE (VITE)', 'VITE', 3063, 'N/A', 'N/A', '/coins/vite/overview', 1, 'cryptocompare'),
(2809, 921526, 'RNT', 'OneRoot Network (RNT)', 'OneRoot Network', 3064, 'N/A', 'N/A', '/coins/rnt/overview', 1, 'cryptocompare'),
(2810, 921530, 'BBO', 'Bigbom (BBO)', 'Bigbom', 3065, 'N/A', 'N/A', '/coins/bbo/overview', 1, 'cryptocompare'),
(2811, 921549, 'YUP', 'Crowdholding (YUP)', 'Crowdholding', 3066, 'N/A', 'N/A', '/coins/yup/overview', 1, 'cryptocompare'),
(2812, 921575, 'SNIP', 'SnipCoin (SNIP)', 'SnipCoin', 3067, 'N/A', 'N/A', '/coins/snip/overview', 1, 'cryptocompare'),
(2813, 921608, 'XDNA', 'XDNA (XDNA)', 'XDNA', 3068, 'Keccak', 'PoW/PoS', '/coins/xdna/overview', 1, 'cryptocompare'),
(2814, 921680, 'SAL', 'SalPay (SAL)', 'SalPay', 3069, 'N/A', 'N/A', '/coins/sal/overview', 1, 'cryptocompare'),
(2815, 922018, 'CARD', 'Cardstack (CARD)', 'Cardstack', 3071, 'N/A', 'N/A', '/coins/card/overview', 1, 'cryptocompare'),
(2816, 922038, 'LIKE', 'LikeCoin (LIKE)', 'LikeCoin', 3072, 'N/A', 'N/A', '/coins/like/overview', 1, 'cryptocompare'),
(2817, 922054, 'THRT', 'ThriveToken (THRT)', 'ThriveToken', 3073, 'N/A', 'N/A', '/coins/thrt/overview', 1, 'cryptocompare'),
(2818, 922068, 'GOT*', 'GoToken (GOT*)', 'GoToken', 3074, 'N/A', 'N/A', '/coins/gotstar/overview', 1, 'cryptocompare'),
(2819, 922136, 'SKRP', 'Skraps (SKRP)', 'Skraps', 3075, 'N/A', 'N/A', '/coins/skrp/overview', 1, 'cryptocompare'),
(2820, 922140, 'AVH', 'Animation Vision Cash (AVH)', 'Animation Vision Cash', 3076, 'N/A', 'N/A', '/coins/avh/overview', 1, 'cryptocompare'),
(2821, 922214, 'SCC', 'StockChain Coin (SCC)', 'StockChain Coin', 3077, 'N/A', 'N/A', '/coins/scc/overview', 1, 'cryptocompare'),
(2822, 922220, 'HALO', 'Halo Platform (HALO)', 'Halo Platform', 3078, 'N/A', 'N/A', '/coins/halo/overview', 1, 'cryptocompare'),
(2823, 922258, 'BSTN', 'BitStation (BSTN)', 'BitStation', 3080, 'N/A', 'N/A', '/coins/bstn/overview', 1, 'cryptocompare'),
(2824, 922261, 'PITCH', 'PITCH (PITCH)', 'PITCH', 3081, 'N/A', 'N/A', '/coins/pitch/overview', 1, 'cryptocompare'),
(2825, 922271, 'NANJ', 'NANJCOIN (NANJ)', 'NANJCOIN', 3082, 'N/A', 'N/A', '/coins/nanj/overview', 1, 'cryptocompare'),
(2826, 922584, 'PAXEX', 'PAXEX (PAXEX)', 'PAXEX', 3085, 'X11', 'PoS', '/coins/paxex/overview', 1, 'cryptocompare'),
(2827, 922603, 'DIT', 'Ditcoin (DIT)', 'Ditcoin', 3086, 'CryptoNight', 'PoW', '/coins/dit/overview', 1, 'cryptocompare'),
(2828, 922608, 'AZART', 'Azart (AZART)', 'Azart', 3087, 'X11', 'PoW', '/coins/azart/overview', 1, 'cryptocompare'),
(2829, 922623, 'RDC', 'Ordocoin (RDC)', 'Ordocoin', 3089, 'N/A', 'N/A', '/coins/rdc/overview', 1, 'cryptocompare'),
(2830, 922632, 'FREE', 'FREE coin (FREE)', 'FREE coin', 3091, 'N/A', 'N/A', '/coins/free/overview', 1, 'cryptocompare'),
(2831, 922643, 'AOP', 'Averopay (AOP)', 'Averopay', 3092, 'Tribus', 'PoW/PoS', '/coins/aop/overview', 1, 'cryptocompare'),
(2832, 922654, 'XAP', 'Apollon (XAP)', 'Apollon', 3093, 'Quark', 'PoW/PoS', '/coins/xap/overview', 1, 'cryptocompare'),
(2833, 922710, 'INTO', 'Influ Token (INTO)', 'Influ Token', 3094, 'N/A', 'N/A', '/coins/into/overview', 1, 'cryptocompare'),
(2834, 922747, 'AIMS', 'HighCastle Token (AIMS)', 'HighCastle Token', 3096, 'N/A', 'N/A', '/coins/aims/overview', 1, 'cryptocompare'),
(2835, 922763, 'TSC', 'ThunderStake (TSC)', 'ThunderStake', 3097, 'Scrypt', 'PoW/PoS', '/coins/tsc/overview', 1, 'cryptocompare'),
(2836, 922774, 'SPLB', 'SimpleBank (SPLB)', 'SimpleBank', 3099, 'NeoScrypt', 'PoW/PoS', '/coins/splb/overview', 1, 'cryptocompare'),
(2837, 922779, 'CMZ', 'CRYPTOMAGZ (CMZ)', 'CRYPTOMAGZ', 3100, 'N/A', 'N/A', '/coins/cmz/overview', 1, 'cryptocompare'),
(2838, 924209, 'MHP', 'MedicoHealth (MHP)', 'MedicoHealth', 3106, 'N/A', 'N/A', '/coins/mhp/overview', 1, 'cryptocompare'),
(2839, 924215, 'HMD', 'Homelend (HMD)', 'Homelend', 3107, 'N/A', 'N/A', '/coins/hmd/overview', 1, 'cryptocompare'),
(2840, 924246, 'IMGZ', 'Imigize (IMGZ)', 'Imigize', 3109, 'N/A', 'N/A', '/coins/imgz/overview', 1, 'cryptocompare'),
(2841, 924307, 'NYN', 'NYNJA (NYN)', 'NYNJA', 3110, 'N/A', 'N/A', '/coins/nyn/overview', 1, 'cryptocompare'),
(2842, 924328, 'IAM', 'IAME Identity (IAM)', 'IAME Identity', 3111, 'N/A', 'N/A', '/coins/iam/overview', 1, 'cryptocompare'),
(2843, 924346, 'URB', 'Urbit Data (URB)', 'Urbit Data', 3112, 'N/A', 'N/A', '/coins/urb/overview', 1, 'cryptocompare'),
(2844, 924363, 'CHART', 'BetOnChart (CHART)', 'BetOnChart', 3113, 'N/A', 'N/A', '/coins/chart/overview', 1, 'cryptocompare'),
(2845, 924369, 'WHEN', 'WhenHub (WHEN)', 'WhenHub', 3114, 'N/A', 'N/A', '/coins/when/overview', 1, 'cryptocompare'),
(2846, 924677, 'SFT', 'SportsFix (SFT)', 'SportsFix', 3115, 'N/A', 'N/A', '/coins/sft/overview', 1, 'cryptocompare'),
(2847, 924683, 'CCC*', 'Blockshipping (CCC*)', 'Blockshipping', 3117, 'N/A', 'N/A', '/coins/cccstar/overview', 1, 'cryptocompare'),
(2848, 924688, 'ITR', 'INTRO (ITR)', 'INTRO', 3119, 'N/A', 'N/A', '/coins/itr/overview', 1, 'cryptocompare'),
(2849, 924690, 'CHE', 'Cache (CHE)', 'Cache', 3120, 'N/A', 'N/A', '/coins/che/overview', 1, 'cryptocompare'),
(2850, 924693, 'ZEEW', 'Zeew (ZEEW)', 'Zeew', 3121, 'N/A', 'N/A', '/coins/zeew/overview', 1, 'cryptocompare'),
(2851, 924696, 'EMT*', 'Memority (EMT*)', 'Memority', 3122, 'N/A', 'N/A', '/coins/emtstar/overview', 1, 'cryptocompare'),
(2852, 924699, 'QUA', 'Quasa (QUA)', 'Quasa', 3123, 'N/A', 'N/A', '/coins/qua/overview', 1, 'cryptocompare'),
(2853, 924701, 'RSC', 'Ronaldinho Soccer Coin (RSC)', 'Ronaldinho Soccer Coin', 3124, 'N/A', 'N/A', '/coins/rsc/overview', 1, 'cryptocompare'),
(2854, 924704, 'ENTRY', 'ENTRY (ENTRY)', 'ENTRY', 3125, 'N/A', 'N/A', '/coins/entry/overview', 1, 'cryptocompare'),
(2855, 924705, 'PHT', 'Photochain (PHT)', 'Photochain', 3126, 'N/A', 'N/A', '/coins/pht/overview', 1, 'cryptocompare'),
(2856, 924709, 'WORK', 'Aworker (WORK)', 'Aworker', 3127, 'N/A', 'N/A', '/coins/work/overview', 1, 'cryptocompare'),
(2857, 924710, 'ORC', 'Organicco (ORC)', 'Organicco', 3128, 'N/A', 'N/A', '/coins/orc/overview', 1, 'cryptocompare'),
(2858, 924715, 'ZAZA', 'ZAZA (ZAZA)', 'ZAZA', 3129, 'N/A', 'N/A', '/coins/zaza/overview', 1, 'cryptocompare'),
(2859, 924716, 'DNET*', 'DeNet (DNET*)', 'DeNet', 3130, 'N/A', 'N/A', '/coins/dnetstar/overview', 1, 'cryptocompare'),
(2860, 924718, 'IDAP', 'IDAP (IDAP)', 'IDAP', 3131, 'N/A', 'N/A', '/coins/idap/overview', 1, 'cryptocompare'),
(2861, 924722, 'HEAL', 'Etheal (HEAL)', 'Etheal', 3132, 'N/A', 'N/A', '/coins/heal/overview', 1, 'cryptocompare'),
(2862, 924723, 'OFCR', 'OfficerCoin (OFCR)', 'OfficerCoin', 3133, 'N/A', 'N/A', '/coins/ofcr/overview', 1, 'cryptocompare'),
(2863, 924725, 'SHPT', 'Shipit (SHPT)', 'Shipit', 3134, 'N/A', 'N/A', '/coins/shpt/overview', 1, 'cryptocompare'),
(2864, 924732, 'LED', 'Terawatt (LED)', 'Terawatt', 3135, 'N/A', 'N/A', '/coins/led/overview', 1, 'cryptocompare'),
(2865, 924737, 'PRLPAY', 'PearlPay (PRLPAY)', 'PearlPay', 3136, 'N/A', 'N/A', '/coins/prlpay/overview', 1, 'cryptocompare'),
(2866, 924750, 'SKYFT', 'SKYFchain (SKYFT)', 'SKYFchain', 3138, 'N/A', 'N/A', '/coins/skyft/overview', 1, 'cryptocompare'),
(2867, 924752, 'FLEX', 'TrustedCars FLEX (FLEX)', 'TrustedCars FLEX', 3139, 'N/A', 'N/A', '/coins/flex/overview', 1, 'cryptocompare'),
(2868, 924760, 'STRY', 'STRYKZ (STRY)', 'STRYKZ', 3141, 'N/A', 'N/A', '/coins/stry/overview', 1, 'cryptocompare'),
(2869, 924761, 'FAN', 'Fan360 (FAN)', 'Fan360', 3142, 'N/A', 'N/A', '/coins/fan/overview', 1, 'cryptocompare'),
(2870, 924766, 'GBTC', 'GigTricks (GBTC)', 'GigTricks', 3143, 'N/A', 'N/A', '/coins/gbtc/overview', 1, 'cryptocompare'),
(2871, 924767, 'NBOX', 'Unboxed (NBOX)', 'Unboxed', 3144, 'N/A', 'N/A', '/coins/nbox/overview', 1, 'cryptocompare'),
(2872, 924779, 'BUD', 'Buddy (BUD)', 'Buddy', 3145, 'N/A', 'N/A', '/coins/bud/overview', 1, 'cryptocompare'),
(2873, 924794, 'K2G', 'Kasko2go (K2G)', 'Kasko2go', 3147, 'N/A', 'N/A', '/coins/k2g/overview', 1, 'cryptocompare'),
(2874, 924796, 'ARR', 'ARROUND (ARR)', 'ARROUND', 3148, 'N/A', 'N/A', '/coins/arr/overview', 1, 'cryptocompare'),
(2875, 924800, 'GMB', 'GAMB (GMB)', 'GAMB', 3149, 'N/A', 'N/A', '/coins/gmb/overview', 1, 'cryptocompare'),
(2876, 924801, 'SPOT', 'Spotcoin (SPOT)', 'Spotcoin', 3150, 'N/A', 'N/A', '/coins/spot/overview', 1, 'cryptocompare'),
(2877, 924805, 'VTUUR', 'VTUUR (VTUUR)', 'VTUUR', 3151, 'N/A', 'N/A', '/coins/vtuur/overview', 1, 'cryptocompare'),
(2878, 924807, 'Pakka', 'NextPakk (Pakka)', 'NextPakk', 3152, 'N/A', 'N/A', '/coins/pakka/overview', 1, 'cryptocompare'),
(2879, 924811, 'ETI', 'EtherInc (ETI)', 'EtherInc', 3153, 'N/A', 'N/A', '/coins/eti/overview', 1, 'cryptocompare'),
(2880, 924815, 'FRECN', 'Freldo (FRECN)', 'Freldo', 3154, 'N/A', 'N/A', '/coins/frecn/overview', 1, 'cryptocompare'),
(2881, 924823, 'NOIA', 'NOIA Network (NOIA)', 'NOIA Network', 3155, 'N/A', 'N/A', '/coins/noia/overview', 1, 'cryptocompare'),
(2882, 924826, 'LAX', 'LAPO (LAX)', 'LAPO', 3156, 'Lyra2Z', 'PoW/PoS', '/coins/lax/overview', 1, 'cryptocompare'),
(2883, 924828, 'BST*', 'BOOSTO (BST*)', 'BOOSTO', 3157, 'N/A', 'N/A', '/coins/bststar/overview', 1, 'cryptocompare'),
(2884, 924831, 'DREAM*', 'DREAM (DREAM*)', 'DREAM', 3158, 'N/A', 'N/A', '/coins/dreamstar/overview', 1, 'cryptocompare'),
(2885, 924837, 'LPC', 'Little Phil (LPC)', 'Little Phil', 3160, 'N/A', 'N/A', '/coins/lpc/overview', 1, 'cryptocompare'),
(2886, 924847, 'DYNO', 'DYNO (DYNO)', 'DYNO', 3161, 'N/A', 'N/A', '/coins/dyno/overview', 1, 'cryptocompare'),
(2887, 924851, 'MFX', 'MFChain (MFX)', 'MFChain', 3162, 'N/A', 'N/A', '/coins/mfx/overview', 1, 'cryptocompare'),
(2888, 924857, 'NOIZ', 'NOIZ (NOIZ)', 'NOIZ', 3163, 'N/A', 'N/A', '/coins/noiz/overview', 1, 'cryptocompare'),
(2889, 924859, 'SPIKE', 'Spiking (SPIKE)', 'Spiking', 3164, 'N/A', 'N/A', '/coins/spike/overview', 1, 'cryptocompare'),
(2890, 924860, 'SGO', 'Selfie GO (SGO)', 'Selfie GO', 3165, 'N/A', 'N/A', '/coins/sgo/overview', 1, 'cryptocompare'),
(2891, 924864, 'RAWG', 'RAWG (RAWG)', 'RAWG', 3166, 'N/A', 'N/A', '/coins/rawg/overview', 1, 'cryptocompare'),
(2892, 924873, 'BDB', 'Big Data Block (BDB)', 'Big Data Block', 3167, 'N/A', 'N/A', '/coins/bdb/overview', 1, 'cryptocompare'),
(2893, 924875, 'MNR', 'Monoreto (MNR)', 'Monoreto', 3168, 'N/A', 'N/A', '/coins/mnr/overview', 1, 'cryptocompare'),
(2894, 924891, 'YBT', 'YellowBetter (YBT)', 'YellowBetter', 3170, 'N/A', 'N/A', '/coins/ybt/overview', 1, 'cryptocompare'),
(2895, 924896, 'OPET', 'ÕpetFoundation (OPET)', 'ÕpetFoundation', 3171, 'N/A', 'N/A', '/coins/opet/overview', 1, 'cryptocompare'),
(2896, 924897, 'PSK', 'Pool of Stake (PSK)', 'Pool of Stake', 3172, 'N/A', 'N/A', '/coins/psk/overview', 1, 'cryptocompare'),
(2897, 924899, 'KVT', 'Kinesis Velocity Token  (KVT)', 'Kinesis Velocity Token ', 3173, 'N/A', 'N/A', '/coins/kvt/overview', 1, 'cryptocompare'),
(2898, 924918, 'WPT', 'Worldopoly (WPT)', 'Worldopoly', 3175, 'N/A', 'N/A', '/coins/wpt/overview', 1, 'cryptocompare'),
(2899, 924922, 'ABELE', 'Abele (ABELE)', 'Abele', 3176, 'N/A', 'N/A', '/coins/abele/overview', 1, 'cryptocompare'),
(2900, 924924, 'XEP', 'ephelants360 (XEP)', 'ephelants360', 3177, 'N/A', 'N/A', '/coins/xep/overview', 1, 'cryptocompare'),
(2901, 924926, 'ARB*', 'ARBITRAGE (ARB*)', 'ARBITRAGE', 3178, 'N/A', 'N/A', '/coins/arbstar/overview', 1, 'cryptocompare'),
(2902, 924931, 'OMI', 'ECOMI (OMI)', 'ECOMI', 3180, 'N/A', 'N/A', '/coins/omi/overview', 1, 'cryptocompare'),
(2903, 924935, 'BILL', 'TillBilly (BILL)', 'TillBilly', 3181, 'N/A', 'N/A', '/coins/bill/overview', 1, 'cryptocompare'),
(2904, 924938, 'ST', 'Scienceroot (ST)', 'Scienceroot', 3182, 'N/A', 'N/A', '/coins/st/overview', 1, 'cryptocompare'),
(2905, 924953, 'XDT', 'Dataeum (XDT)', 'Dataeum', 3184, 'N/A', 'N/A', '/coins/xdt/overview', 1, 'cryptocompare'),
(2906, 924955, 'WPP', 'Green Energy Token (WPP)', 'Green Energy Token', 3185, 'N/A', 'N/A', '/coins/wpp/overview', 1, 'cryptocompare'),
(2907, 924963, 'ATX*', 'Aston (ATX*)', 'Aston', 3186, 'N/A', 'N/A', '/coins/atxstar/overview', 1, 'cryptocompare'),
(2908, 924971, 'SLT', 'Social Lending Network (SLT)', 'Social Lending Network', 3187, 'N/A', 'N/A', '/coins/slt/overview', 1, 'cryptocompare'),
(2909, 924973, 'APL', 'Apollo Currency (APL)', 'Apollo Currency', 3188, 'N/A', 'PoS', '/coins/apl/overview', 1, 'cryptocompare'),
(2910, 924976, 'MCB', 'MyCryptoBank (MCB)', 'MyCryptoBank', 3189, 'N/A', 'N/A', '/coins/mcb/overview', 1, 'cryptocompare'),
(2911, 924982, 'CCCX', 'Clipper Coin Capital (CCCX)', 'Clipper Coin Capital', 3191, 'N/A', 'N/A', '/coins/cccx/overview', 1, 'cryptocompare'),
(2912, 924986, 'VRH', 'Virtual Rehab (VRH)', 'Virtual Rehab', 3192, 'N/A', 'N/A', '/coins/vrh/overview', 1, 'cryptocompare'),
(2913, 924988, 'AEN', 'Aenco (AEN)', 'Aenco', 3193, 'N/A', 'N/A', '/coins/aen/overview', 1, 'cryptocompare'),
(2914, 924991, 'SOLID', 'Solidified (SOLID)', 'Solidified', 3194, 'N/A', 'N/A', '/coins/solid/overview', 1, 'cryptocompare'),
(2915, 924993, 'VANIG', 'VANIG (VANIG)', 'VANIG', 3195, 'N/A', 'N/A', '/coins/vanig/overview', 1, 'cryptocompare'),
(2916, 924996, 'AIRE', 'Tokenaire (AIRE)', 'Tokenaire', 3196, 'N/A', 'N/A', '/coins/aire/overview', 1, 'cryptocompare'),
(2917, 925007, 'GMA', 'Goldchip Mining Asset (GMA)', 'Goldchip Mining Asset', 3197, 'N/A', 'N/A', '/coins/gma/overview', 1, 'cryptocompare');
INSERT INTO `coinlist_krypto` (`id_coinlist`, `currencyid_coinlist`, `symbol_coinlist`, `fullname_coinlist`, `coinname_coinlist`, `order_coinlist`, `algorithm_coinlist`, `prooftype_coinlist`, `url_coinlist`, `status_coinslist`, `source_coinlist`) VALUES
(2918, 925009, 'WMB', 'WatermelonBlock (WMB)', 'WatermelonBlock', 3198, 'N/A', 'N/A', '/coins/wmb/overview', 1, 'cryptocompare'),
(2919, 925015, 'MVU', 'meVu (MVU)', 'meVu', 3199, 'N/A', 'N/A', '/coins/mvu/overview', 1, 'cryptocompare'),
(2920, 925018, 'GLDR', 'WAR FIELD (GLDR)', 'WAR FIELD', 3201, 'N/A', 'N/A', '/coins/gldr/overview', 1, 'cryptocompare'),
(2921, 925021, 'IMU', 'imusify (IMU)', 'imusify', 3202, 'N/A', 'N/A', '/coins/imu/overview', 1, 'cryptocompare'),
(2922, 925023, 'TRT', 'TuurnT (TRT)', 'TuurnT', 3203, 'N/A', 'N/A', '/coins/trt/overview', 1, 'cryptocompare'),
(2923, 925024, 'CRS*', 'CRYSTALS (CRS*)', 'CRYSTALS', 3204, 'N/A', 'N/A', '/coins/crsstar/overview', 1, 'cryptocompare'),
(2924, 925031, 'OLM', 'Olam (OLM)', 'Olam', 3205, 'N/A', 'N/A', '/coins/olm/overview', 1, 'cryptocompare'),
(2925, 925033, 'CST', 'Casper API (CST)', 'Casper API', 3206, 'N/A', 'N/A', '/coins/cst/overview', 1, 'cryptocompare'),
(2926, 925035, 'YON', 'YondoCoin (YON)', 'YondoCoin', 3207, 'N/A', 'N/A', '/coins/yon/overview', 1, 'cryptocompare'),
(2927, 925040, 'URT', 'Universal Recognition Token (URT)', 'Universal Recognition Token', 3208, 'N/A', 'N/A', '/coins/urt/overview', 1, 'cryptocompare'),
(2928, 925042, 'QCX', 'QuickX Protocol (QCX)', 'QuickX Protocol', 3209, 'N/A', 'N/A', '/coins/qcx/overview', 1, 'cryptocompare'),
(2929, 925049, 'DIP', 'Etherisc (DIP)', 'Etherisc', 3211, 'N/A', 'N/A', '/coins/dip/overview', 1, 'cryptocompare'),
(2930, 925071, 'REDC', 'RedCab (REDC)', 'RedCab', 3213, 'N/A', 'N/A', '/coins/redc/overview', 1, 'cryptocompare'),
(2931, 925073, 'ZCN*', 'Zichain (ZCN*)', 'Zichain', 3214, 'N/A', 'N/A', '/coins/zcnstar/overview', 1, 'cryptocompare'),
(2932, 925078, 'TTV', 'TV-TWO (TTV)', 'TV-TWO', 3215, 'N/A', 'N/A', '/coins/ttv/overview', 1, 'cryptocompare'),
(2933, 925081, 'OICOIN', 'Osmium Investment Coin (OICOIN)', 'Osmium Investment Coin', 3216, 'N/A', 'N/A', '/coins/oicoin/overview', 1, 'cryptocompare'),
(2934, 925083, 'ENQ', 'Enecuum (ENQ)', 'Enecuum', 3217, 'N/A', 'N/A', '/coins/enq/overview', 1, 'cryptocompare'),
(2935, 925085, 'EXPR', 'Expercoin (EXPR)', 'Expercoin', 3218, 'N/A', 'N/A', '/coins/expr/overview', 1, 'cryptocompare'),
(2936, 925087, 'DTN', 'Datareum (DTN)', 'Datareum', 3219, 'N/A', 'N/A', '/coins/dtn/overview', 1, 'cryptocompare'),
(2937, 925088, 'IDM', 'IDM (IDM)', 'IDM', 3220, 'N/A', 'N/A', '/coins/idm/overview', 1, 'cryptocompare'),
(2938, 925092, 'SIDT', 'SID Token (SIDT)', 'SID Token', 3221, 'N/A', 'N/A', '/coins/sidt/overview', 1, 'cryptocompare'),
(2939, 925095, 'CDPT', 'Creditor Data Platform (CDPT)', 'Creditor Data Platform', 3223, 'N/A', 'PoA', '/coins/cdpt/overview', 1, 'cryptocompare'),
(2940, 925097, 'CRGO', 'CargoCoin (CRGO)', 'CargoCoin', 3224, 'N/A', 'N/A', '/coins/crgo/overview', 1, 'cryptocompare'),
(2941, 925099, 'AXIS', 'LaneAxis (AXIS)', 'LaneAxis', 3225, 'N/A', 'N/A', '/coins/axis/overview', 1, 'cryptocompare'),
(2942, 925103, 'QRP', 'Cryptics (QRP)', 'Cryptics', 3226, 'N/A', 'N/A', '/coins/qrp/overview', 1, 'cryptocompare'),
(2943, 925107, 'TIIM', 'TriipMiles (TIIM)', 'TriipMiles', 3227, 'N/A', 'N/A', '/coins/tiim/overview', 1, 'cryptocompare'),
(2944, 925111, 'VRT', 'Virtual Reality Technology (VRT)', 'Virtual Reality Technology', 3229, 'N/A', 'N/A', '/coins/vrt/overview', 1, 'cryptocompare'),
(2945, 925113, 'NRG', 'Zero Carbon Project (NRG)', 'Zero Carbon Project', 3230, 'N/A', 'N/A', '/coins/nrg/overview', 1, 'cryptocompare'),
(2946, 925118, 'KRP', 'Kryptoin (KRP)', 'Kryptoin', 3231, 'N/A', 'PoS', '/coins/krp/overview', 1, 'cryptocompare'),
(2947, 925129, 'DAG', 'Constellation  (DAG)', 'Constellation ', 3232, 'N/A', 'N/A', '/coins/dag/overview', 1, 'cryptocompare'),
(2948, 925133, 'OLE', 'Olive (OLE)', 'Olive', 3233, 'N/A', 'N/A', '/coins/ole/overview', 1, 'cryptocompare'),
(2949, 925145, 'AMLT', 'AMLT (AMLT)', 'AMLT', 3235, 'N/A', 'N/A', '/coins/amlt/overview', 1, 'cryptocompare'),
(2950, 925148, 'HGO', 'HireGo (HGO)', 'HireGo', 3236, 'N/A', 'N/A', '/coins/hgo/overview', 1, 'cryptocompare'),
(2951, 925151, 'TCOIN', 'Talenthon (TCOIN)', 'Talenthon', 3237, 'N/A', 'N/A', '/coins/tcoin/overview', 1, 'cryptocompare'),
(2952, 925159, 'PRA', 'ProChain (PRA)', 'ProChain', 3239, 'N/A', 'N/A', '/coins/pra/overview', 1, 'cryptocompare'),
(2953, 925161, 'VLP', 'Volpo (VLP)', 'Volpo', 3240, 'N/A', 'N/A', '/coins/vlp/overview', 1, 'cryptocompare'),
(2954, 925163, 'PGC*', 'Paygine (PGC*)', 'Paygine', 3241, 'N/A', 'N/A', '/coins/pgcstar/overview', 1, 'cryptocompare'),
(2955, 925165, 'ZIP', 'Zipper (ZIP)', 'Zipper', 3242, 'DPoS', 'N/A', '/coins/zip/overview', 1, 'cryptocompare'),
(2956, 925183, 'BOS*', 'Bostoken (BOS*)', 'Bostoken', 3243, 'N/A', 'N/A', '/coins/bosstar/overview', 1, 'cryptocompare'),
(2957, 925195, 'KCASH', 'Kcash (KCASH)', 'Kcash', 3244, 'SHA-512', 'Zero-Knowled', '/coins/kcash/overview', 1, 'cryptocompare'),
(2958, 925200, '1WO', '1World (1WO)', '1World', 3245, 'N/A', 'N/A', '/coins/1wo/overview', 1, 'cryptocompare'),
(2959, 925212, 'BOUTS', 'BoutsPro (BOUTS)', 'BoutsPro', 3247, 'N/A', 'N/A', '/coins/bouts/overview', 1, 'cryptocompare'),
(2960, 925214, 'ORS*', 'OriginSport (ORS*)', 'OriginSport', 3248, 'N/A', 'N/A', '/coins/orsstar/overview', 1, 'cryptocompare'),
(2961, 925216, 'EST', 'ESports Chain (EST)', 'ESports Chain', 3249, 'N/A', 'PoC', '/coins/est/overview', 1, 'cryptocompare'),
(2962, 925229, 'MDX*', 'MODEX Token (MDX*)', 'MODEX Token', 3250, 'N/A', 'N/A', '/coins/mdxstar/overview', 1, 'cryptocompare'),
(2963, 925231, 'OGT', 'One Game (OGT)', 'One Game', 3251, 'N/A', 'N/A', '/coins/ogt/overview', 1, 'cryptocompare'),
(2964, 925240, 'PLA', 'PlayChip (PLA)', 'PlayChip', 3252, 'N/A', 'N/A', '/coins/pla/overview', 1, 'cryptocompare'),
(2965, 925242, 'NPER', 'NPER (NPER)', 'NPER', 3253, 'N/A', 'PoS', '/coins/nper/overview', 1, 'cryptocompare'),
(2966, 925249, 'EURS', 'STASIS EURS (EURS)', 'STASIS EURS', 3255, 'N/A', 'N/A', '/coins/eurs/overview', 1, 'cryptocompare'),
(2967, 925251, 'XCG', 'Xchange (XCG)', 'Xchange', 3256, 'X16R', 'PoW', '/coins/xcg/overview', 1, 'cryptocompare'),
(2968, 925253, 'BSC*', 'BOONSCoin (BSC*)', 'BOONSCoin', 3257, 'N/A', 'N/A', '/coins/bscstar/overview', 1, 'cryptocompare'),
(2969, 925256, 'PCH', 'PopChain (PCH)', 'PopChain', 3258, 'N/A', 'PoW', '/coins/pch/overview', 1, 'cryptocompare'),
(2970, 925260, 'ECOM', 'Omnitude (ECOM)', 'Omnitude', 3260, 'N/A', 'N/A', '/coins/ecom/overview', 1, 'cryptocompare'),
(2971, 925264, 'WIT', 'Witcoin (WIT)', 'Witcoin', 3261, 'N/A', 'PoW', '/coins/wit/overview', 1, 'cryptocompare'),
(2972, 925266, 'OPU', 'Opu Coin (OPU)', 'Opu Coin', 3262, 'N/A', 'N/A', '/coins/opu/overview', 1, 'cryptocompare'),
(2973, 925268, 'MOF', 'Molecular Future (MOF)', 'Molecular Future', 3263, 'N/A', 'N/A', '/coins/mof/overview', 1, 'cryptocompare'),
(2974, 925271, 'BOX', 'ContentBox (BOX)', 'ContentBox', 3264, 'N/A', 'PoS', '/coins/box/overview', 1, 'cryptocompare'),
(2975, 925272, 'COTI', 'COTI (COTI)', 'COTI', 3265, 'N/A', 'N/A', '/coins/coti/overview', 1, 'cryptocompare'),
(2976, 925275, 'ETALON', 'Etalon (ETALON)', 'Etalon', 3266, 'N/A', 'N/A', '/coins/etalon/overview', 1, 'cryptocompare'),
(2977, 925276, 'TICS', 'CargoConX (TICS)', 'CargoConX', 3267, 'N/A', 'N/A', '/coins/tics/overview', 1, 'cryptocompare'),
(2978, 925282, 'ZPR', 'ZPER (ZPR)', 'ZPER', 3268, 'N/A', 'N/A', '/coins/zpr/overview', 1, 'cryptocompare'),
(2979, 925284, 'EXT*', 'Experience Token (EXT*)', 'Experience Token', 3269, 'N/A', 'N/A', '/coins/extstar/overview', 1, 'cryptocompare'),
(2980, 925289, 'EOT*', 'EON (EOT*)', 'EON', 3270, 'N/A', 'N/A', '/coins/eotstar/overview', 1, 'cryptocompare'),
(2981, 925291, 'AAC', 'Acute Angle Cloud (AAC)', 'Acute Angle Cloud', 3271, 'N/A', 'PoW', '/coins/aac/overview', 1, 'cryptocompare'),
(2982, 925293, 'ELT*', 'ExtraLovers (ELT*)', 'ExtraLovers', 3272, 'N/A', 'N/A', '/coins/eltstar/overview', 1, 'cryptocompare'),
(2983, 925298, 'BLV', 'Blockvest (BLV)', 'Blockvest', 3274, 'N/A', 'N/A', '/coins/blv/overview', 1, 'cryptocompare'),
(2984, 925305, 'RRC', 'Recycling Regeneration Chain (RRC)', 'Recycling Regeneration Chain', 3275, 'N/A', 'N/A', '/coins/rrc/overview', 1, 'cryptocompare'),
(2985, 925313, 'DOM*', 'Dominium (DOM)', 'Dominium', 3276, 'N/A', 'PoS', '/coins/dom/overview', 1, 'cryptocompare'),
(2986, 925316, 'QNTU', 'Quanta (QNTU)', 'Quanta', 3277, 'N/A', 'N/A', '/coins/qntu/overview', 1, 'cryptocompare'),
(2987, 925318, 'IG', 'IG Token  (IG)', 'IG Token ', 3278, 'N/A', 'N/A', '/coins/ig/overview', 1, 'cryptocompare'),
(2988, 925321, 'FML', 'FormulA (FML)', 'FormulA', 3279, 'N/A', 'N/A', '/coins/fml/overview', 1, 'cryptocompare'),
(2989, 925322, 'TLU', 'Irene Energy (TLU)', 'Irene Energy', 3280, 'N/A', 'N/A', '/coins/tlu/overview', 1, 'cryptocompare'),
(2990, 925326, 'PSM', 'Prasm (PSM)', 'Prasm', 3281, 'N/A', 'N/A', '/coins/psm/overview', 1, 'cryptocompare'),
(2991, 925339, 'KAN', 'Bitkan (KAN)', 'Bitkan', 3284, 'N/A', 'N/A', '/coins/kan/overview', 1, 'cryptocompare'),
(2992, 925347, 'NMH', 'Namahe (NMH)', 'Namahe', 3286, 'N/A', 'N/A', '/coins/nmh/overview', 1, 'cryptocompare'),
(2993, 925349, 'KST', 'StarKST (KST)', 'StarKST', 3287, 'Scrypt', 'PoW', '/coins/kst/overview', 1, 'cryptocompare'),
(2994, 925351, 'DEL', 'DelChain (DEL)', 'DelChain', 3288, 'N/A', 'DPoS', '/coins/del/overview', 1, 'cryptocompare'),
(2995, 925358, 'HIT', 'HitChain (HIT)', 'HitChain', 3289, 'N/A', 'PoW', '/coins/hit/overview', 1, 'cryptocompare'),
(2996, 925360, 'PBLK', 'PayBlock (PBLK)', 'PayBlock', 3290, 'N/A', 'N/A', '/coins/pblk/overview', 1, 'cryptocompare'),
(2997, 925362, 'KVT*', 'Kvantor (KVT*)', 'Kvantor', 3291, 'N/A', 'N/A', '/coins/kvtstar/overview', 1, 'cryptocompare'),
(2998, 925364, 'PAX', 'MADANA (PAX)', 'MADANA', 3292, 'N/A', 'N/A', '/coins/pax/overview', 1, 'cryptocompare'),
(2999, 925371, 'TMTG', 'Digital Gold Exchange (TMTG)', 'Digital Gold Exchange', 3293, 'N/A', 'N/A', '/coins/tmtg/overview', 1, 'cryptocompare'),
(3000, 925373, 'SGC', 'Sudan Gold Coin (SGC)', 'Sudan Gold Coin', 3294, 'N/A', 'N/A', '/coins/sgc/overview', 1, 'cryptocompare'),
(3001, 925375, 'PRT', 'Papusha (PRT)', 'Papusha', 3295, 'N/A', 'N/A', '/coins/prt/overview', 1, 'cryptocompare'),
(3002, 925380, 'COSM', 'CosmoChain (COSM)', 'CosmoChain', 3297, 'N/A', 'N/A', '/coins/cosm/overview', 1, 'cryptocompare'),
(3003, 925382, 'GPPT', 'Pluto Project Coin (GPPT)', 'Pluto Project Coin', 3298, 'N/A', 'N/A', '/coins/gppt/overview', 1, 'cryptocompare'),
(3004, 925384, 'LNL', 'LunarLink (LNL)', 'LunarLink', 3299, 'N/A', 'N/A', '/coins/lnl/overview', 1, 'cryptocompare'),
(3005, 925389, 'VRN', 'Vernam (VRN)', 'Vernam', 3300, 'N/A', 'N/A', '/coins/vrn/overview', 1, 'cryptocompare'),
(3006, 925400, 'NEX', 'Neonexchange  (NEX)', 'Neonexchange ', 3301, 'N/A', 'N/A', '/coins/nex/overview', 1, 'cryptocompare'),
(3007, 925403, 'BRNX', 'Bronix (BRNX)', 'Bronix', 3302, 'N/A', 'N/A', '/coins/brnx/overview', 1, 'cryptocompare'),
(3008, 925406, 'RFT', 'RYFTS (RFT)', 'RYFTS', 3304, 'N/A', 'N/A', '/coins/rft/overview', 1, 'cryptocompare'),
(3009, 925411, 'ET', 'ENDO  (ET)', 'ENDO ', 3305, 'N/A', 'N/A', '/coins/et/overview', 1, 'cryptocompare'),
(3010, 925417, 'MMTM', 'Momentum (MMTM)', 'Momentum', 3306, 'N/A', 'N/A', '/coins/mmtm/overview', 1, 'cryptocompare'),
(3011, 925422, 'XGH', 'Golden Hash (XGH)', 'Golden Hash', 3307, 'N/A', 'N/A', '/coins/xgh/overview', 1, 'cryptocompare'),
(3012, 925427, 'FXP', 'FXPay (FXP)', 'FXPay', 3308, 'N/A', 'N/A', '/coins/fxp/overview', 1, 'cryptocompare'),
(3013, 925433, 'PASS', 'Blockpass (PASS)', 'Blockpass', 3310, 'N/A', 'N/A', '/coins/pass/overview', 1, 'cryptocompare'),
(3014, 925435, 'HRO', 'HEROIC.com (HRO)', 'HEROIC.com', 3311, 'N/A', 'N/A', '/coins/hro/overview', 1, 'cryptocompare'),
(3015, 925440, 'DGTX', 'Digitex Futures (DGTX)', 'Digitex Futures', 3312, 'N/A', 'N/A', '/coins/dgtx/overview', 1, 'cryptocompare'),
(3016, 925444, 'BSCH', 'BitSchool (BSCH)', 'BitSchool', 3313, 'N/A', 'N/A', '/coins/bsch/overview', 1, 'cryptocompare'),
(3017, 925447, 'PESA', 'Credible (PESA)', 'Credible', 3315, 'N/A', 'N/A', '/coins/pesa/overview', 1, 'cryptocompare'),
(3018, 925463, 'CLPX', 'Chynge.net (CLPX)', 'Chynge.net', 3316, 'N/A', 'N/A', '/coins/clpx/overview', 1, 'cryptocompare'),
(3019, 925467, 'GLN', 'Galion Token (GLN)', 'Galion Token', 3318, 'N/A', 'N/A', '/coins/gln/overview', 1, 'cryptocompare'),
(3020, 925244, 'ATON', 'Further Network (ATON)', 'Further Network', 3254, 'N/A', 'N/A', '/coins/aton/overview', 1, 'cryptocompare'),
(3021, 925504, 'UTS', 'UTEMIS (UTS)', 'UTEMIS', 3325, 'N/A', 'N/A', '/coins/uts/overview', 1, 'cryptocompare'),
(3022, 808414, 'ONT', 'Ontology (ONT)', 'Ontology', 2446, 'N/A', 'PoS', '/coins/ont/overview', 1, 'cryptocompare'),
(3023, 922838, 'NOBS', 'No BS Crypto ($NOBS)', 'No BS Crypto', 3104, 'N/A', 'N/A', '/coins/nobs/overview', 1, 'cryptocompare'),
(3024, 371095, 'CPEX', 'CoinPulseToken (CPEX)', 'CoinPulseToken', 1799, 'N/A', 'N/A', '/coins/cpex/overview', 1, 'cryptocompare'),
(3025, 5324, 'ETC', 'Ethereum Classic (ETC)', 'Ethereum Classic', 7, 'Ethash', 'PoW', '/coins/etc/overview', 1, 'cryptocompare'),
(3026, 925506, 'TRAID', 'Traid (TRAID)', 'Traid', 3326, 'Scrypt', 'PoW/PoS', '/coins/traid/overview', 1, 'cryptocompare'),
(3027, 890593, 'UBEX', 'Ubex (UBEX)', 'Ubex', 2749, 'N/A', 'PoS', '/coins/ubex/overview', 1, 'cryptocompare'),
(3028, 925469, 'AUK', 'Aukcecoin (AUK)', 'Aukcecoin', 3319, 'Scrypt', 'PoW/PoS', '/coins/auk/overview', 1, 'cryptocompare'),
(3029, 925067, 'PROD*', 'Productivist (PROD*)', 'Productivist', 3212, 'N/A', 'N/A', '/coins/prodstar/overview', 1, 'cryptocompare'),
(3030, 924686, 'ETT*', 'Eternal Trusts (ETT*)', 'Eternal Trusts', 3118, 'N/A', 'N/A', '/coins/ettstar/overview', 1, 'cryptocompare'),
(3031, 924231, 'JSE', 'JSEcoin (JSE)', 'JSEcoin', 3108, 'N/A', 'N/A', '/coins/jse/overview', 1, 'cryptocompare'),
(3032, 925296, 'ESTATE', 'AgentMile (ESTATE)', 'AgentMile', 3273, 'N/A', 'N/A', '/coins/estate/overview', 1, 'cryptocompare'),
(3033, 925046, 'CRON', 'Cryptocean (CRON)', 'Cryptocean', 3210, 'N/A', 'N/A', '/coins/cron/overview', 1, 'cryptocompare'),
(3034, 924678, 'ORBS', 'Orbis (ORBS)', 'Orbis', 3116, 'N/A', 'N/A', '/coins/orbs/overview', 1, 'cryptocompare'),
(3035, 924782, 'DBCCOIN', 'Datablockchain (DBCCOIN)', 'Datablockchain', 3146, 'N/A', 'N/A', '/coins/dbccoin/overview', 1, 'cryptocompare'),
(3036, 921439, 'PERU', 'PeruCoin (PERU)', 'PeruCoin', 3062, 'N/A', 'N/A', '/coins/peru/overview', 1, 'cryptocompare'),
(3037, 925328, 'MON', 'MilionCoin (MON)', 'MilionCoin', 3282, 'N/A', 'N/A', '/coins/mon/overview', 1, 'cryptocompare'),
(3038, 783320, 'LCC', 'LitecoinCash (LCC)', 'LitecoinCash', 2361, 'SHA256', 'N/A', '/coins/lcc/overview', 1, 'cryptocompare'),
(3039, 924940, 'WBBC', 'World Bit Bank (WBBC)', 'World Bit Bank', 3183, 'N/A', 'N/A', '/coins/wbbc/overview', 1, 'cryptocompare'),
(3040, 5018, 'VTC', 'Vertcoin (VTC)', 'Vertcoin', 232, 'Lyra2REv2', 'PoW', '/coins/vtc/overview', 1, 'cryptocompare'),
(3041, 910733, 'TRN', 'Ternion (TRN)', 'Ternion', 2933, 'N/A', 'N/A', '/coins/trn/overview', 1, 'cryptocompare'),
(3042, 22329, 'BSD', 'BitSend (BSD)', 'BitSend', 659, 'X11', 'PoW/PoS', '/coins/bsd/overview', 1, 'cryptocompare'),
(3043, 531426, 'MGO', 'MobileGo (MGO)', 'MobileGo', 1987, 'N/A', 'N/A', '/coins/mgo/overview', 1, 'cryptocompare'),
(3044, 898360, 'BBK*', 'BrickBlock (BBK*)', 'BrickBlock', 2791, 'N/A', 'PoA', '/coins/bbkstar/overview', 1, 'cryptocompare'),
(3045, 924916, 'COT', 'CoTrader (COT)', 'CoTrader', 3174, 'N/A', 'N/A', '/coins/cot/overview', 1, 'cryptocompare'),
(3046, 868229, 'XMC', 'Monero Classic (XMC)', 'Monero Classic', 2667, 'CryptoNight', 'PoW', '/coins/xmc/overview', 1, 'cryptocompare'),
(3047, 877397, 'XMO', 'Monero Original (XMO)', 'Monero Original', 2692, 'CryptoNight', 'PoW', '/coins/xmo/overview', 1, 'cryptocompare'),
(3048, 924979, 'HDAC', 'Hdac (HDAC)', 'Hdac', 3190, 'N/A', 'ePoW', '/coins/hdac/overview', 1, 'cryptocompare'),
(3049, 925093, 'ISR', 'Insureum (ISR)', 'Insureum', 3222, 'N/A', 'N/A', '/coins/isr/overview', 1, 'cryptocompare'),
(3050, 925016, 'TLNT', 'Talent Token (TLNT)', 'Talent Token', 3200, 'N/A', 'N/A', '/coins/tlnt/overview', 1, 'cryptocompare'),
(3051, 924742, 'RBDT', 'RoBust Defense Token (RBDT)', 'RoBust Defense Token', 3137, 'N/A', 'N/A', '/coins/rbdt/overview', 1, 'cryptocompare'),
(3052, 924833, 'PTI', 'Paytomat (PTI)', 'Paytomat', 3159, 'N/A', 'N/A', '/coins/pti/overview', 1, 'cryptocompare'),
(3053, 925342, 'AUD', 'Aussie Digital (AUD)', 'Aussie Digital', 3285, 'N/A', 'N/A', '/coins/aud/overview', 1, 'cryptocompare'),
(3054, 35407, 'BamitCoi', 'BAM (BAM)', 'BAM', 963, 'X11', 'PoW/PoS', '/coins/bam/overview', 1, 'cryptocompare'),
(3055, 811717, 'XTROPTIO', 'TROPTIONS (XTROPTIONS)', 'TROPTIONS', 2460, 'N/A', 'PoW', '/coins/xtroptions/overview', 1, 'cryptocompare'),
(3056, 892415, 'BITSILVE', 'bitSilver (BITSILVER)', 'bitSilver', 2758, 'N/A', 'N/A', '/coins/bitsilver/overview', 1, 'cryptocompare'),
(3057, 925154, 'BZ', 'Bit-Z (BZ)', 'Bit-Z', 3238, 'N/A', 'N/A', '/coins/bz/overview', 1, 'cryptocompare'),
(3058, 925479, 'PCCM', 'Poseidon Chain (PCCM)', 'Poseidon Chain', 3321, 'N/A', 'N/A', '/coins/pccm/overview', 1, 'cryptocompare'),
(3059, 925484, 'TOPC', 'Topchain (TOPC)', 'Topchain', 3322, 'N/A', 'N/A', '/coins/topc/overview', 1, 'cryptocompare'),
(3060, 925495, 'PLAN', 'Plancoin (PLAN)', 'Plancoin', 3323, 'Scrypt', 'PoW/PoS', '/coins/plan/overview', 1, 'cryptocompare'),
(3061, 925531, 'MIB', 'Mobile Integrated Blockchain (MIB)', 'Mobile Integrated Blockchain', 3331, 'N/A', 'PoW', '/coins/mib/overview', 1, 'cryptocompare'),
(3062, 925550, 'BAAS', 'BaaSid (BAAS)', 'BaaSid', 3332, 'N/A', 'N/A', '/coins/baas/overview', 1, 'cryptocompare'),
(3063, 925525, 'DPY', 'Delphy (DPY)', 'Delphy', 3329, 'N/A', 'N/A', '/coins/dpy/overview', 1, 'cryptocompare'),
(3064, 925519, 'BNTE', 'Bountie (BNTE)', 'Bountie', 3328, 'N/A', 'N/A', '/coins/bnte/overview', 1, 'cryptocompare'),
(3065, 925516, 'TRIO', 'Tripio (TRIO)', 'Tripio', 3327, 'N/A', 'N/A', '/coins/trio/overview', 1, 'cryptocompare'),
(3066, 925497, 'EVER', 'EverLife.AI (EVER)', 'EverLife.AI', 3324, 'N/A', 'N/A', '/coins/ever/overview', 1, 'cryptocompare'),
(3067, 924887, 'ZNAQ', 'ZNAQ (ZNAQ)', 'ZNAQ', 3169, 'N/A', 'N/A', '/coins/znaq/overview', 1, 'cryptocompare'),
(3068, 925404, 'SRCOIN', 'SRCoin (SRCOIN)', 'SRCoin', 3303, 'N/A', 'N/A', '/coins/srcoin/overview', 1, 'cryptocompare'),
(3069, 925445, 'TRVR', 'Trivver (TRVR)', 'Trivver', 3314, 'N/A', 'N/A', '/coins/trvr/overview', 1, 'cryptocompare'),
(3070, 925554, 'TOT*', 'Trecento Blockchain Capital (TOT*)', 'Trecento Blockchain Capital', 3334, 'N/A', 'N/A', '/coins/totstar/overview', 1, 'cryptocompare'),
(3071, 925552, 'LYNK', 'Lynked.World (LYNK)', 'Lynked.World', 3333, 'N/A', 'N/A', '/coins/lynk/overview', 1, 'cryptocompare'),
(3072, 925563, 'GUSD', 'Gemini Dollar (GUSD)', 'Gemini Dollar', 3335, 'N/A', 'N/A', '/coins/gusd/overview', 1, 'cryptocompare'),
(3073, 925566, 'CCL', 'CyClean (CCL)', 'CyClean', 3336, 'N/A', 'N/A', '/coins/ccl/overview', 1, 'cryptocompare'),
(3074, 925431, 'CET*', 'DICE Money (CET*)', 'DICE Money', 3309, 'N/A', 'N/A', '/coins/cetstar/overview', 1, 'cryptocompare'),
(3075, 925465, 'DXC*', 'Daox (DXC*)', 'Daox', 3317, 'N/A', 'N/A', '/coins/dxcstar/overview', 1, 'cryptocompare'),
(3076, 35407, 'BamitCoi', 'BAM (BAM)', 'BAM', 963, 'X11', 'PoW/PoS', '/coins/bam/overview', 1, 'cryptocompare'),
(3077, 811717, 'XTROPTIO', 'TROPTIONS (XTROPTIONS)', 'TROPTIONS', 2460, 'N/A', 'PoW', '/coins/xtroptions/overview', 1, 'cryptocompare'),
(3078, 892415, 'BITSILVE', 'bitSilver (BITSILVER)', 'bitSilver', 2758, 'N/A', 'N/A', '/coins/bitsilver/overview', 1, 'cryptocompare');

CREATE TABLE `coinspot_krypto` (
  `id_coinspot` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_coinspot` text NOT NULL,
  `secret_coinspot` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `converter_krypto` (
  `id_converter` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `list_converter` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `country_krypto` (
  `id_country` int(11) NOT NULL,
  `iso_country` varchar(10) NOT NULL,
  `name_country` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `country_krypto` (`id_country`, `iso_country`, `name_country`) VALUES
(1, 'AF', 'Afghanistan'),
(2, 'AL', 'Albania'),
(3, 'DZ', 'Algeria'),
(4, 'DS', 'American Samoa'),
(5, 'AD', 'Andorra'),
(6, 'AO', 'Angola'),
(7, 'AI', 'Anguilla'),
(8, 'AQ', 'Antarctica'),
(9, 'AG', 'Antigua and Barbuda'),
(10, 'AR', 'Argentina'),
(11, 'AM', 'Armenia'),
(12, 'AW', 'Aruba'),
(13, 'AU', 'Australia'),
(14, 'AT', 'Austria'),
(15, 'AZ', 'Azerbaijan'),
(16, 'BS', 'Bahamas'),
(17, 'BH', 'Bahrain'),
(18, 'BD', 'Bangladesh'),
(19, 'BB', 'Barbados'),
(20, 'BY', 'Belarus'),
(21, 'BE', 'Belgium'),
(22, 'BZ', 'Belize'),
(23, 'BJ', 'Benin'),
(24, 'BM', 'Bermuda'),
(25, 'BT', 'Bhutan'),
(26, 'BO', 'Bolivia'),
(27, 'BA', 'Bosnia and Herzegovina'),
(28, 'BW', 'Botswana'),
(29, 'BV', 'Bouvet Island'),
(30, 'BR', 'Brazil'),
(31, 'IO', 'British Indian Ocean Territory'),
(32, 'BN', 'Brunei Darussalam'),
(33, 'BG', 'Bulgaria'),
(34, 'BF', 'Burkina Faso'),
(35, 'BI', 'Burundi'),
(36, 'KH', 'Cambodia'),
(37, 'CM', 'Cameroon'),
(38, 'CA', 'Canada'),
(39, 'CV', 'Cape Verde'),
(40, 'KY', 'Cayman Islands'),
(41, 'CF', 'Central African Republic'),
(42, 'TD', 'Chad'),
(43, 'CL', 'Chile'),
(44, 'CN', 'China'),
(45, 'CX', 'Christmas Island'),
(46, 'CC', 'Cocos (Keeling) Islands'),
(47, 'CO', 'Colombia'),
(48, 'KM', 'Comoros'),
(49, 'CG', 'Congo'),
(50, 'CK', 'Cook Islands'),
(51, 'CR', 'Costa Rica'),
(52, 'HR', 'Croatia (Hrvatska)'),
(53, 'CU', 'Cuba'),
(54, 'CY', 'Cyprus'),
(55, 'CZ', 'Czech Republic'),
(56, 'DK', 'Denmark'),
(57, 'DJ', 'Djibouti'),
(58, 'DM', 'Dominica'),
(59, 'DO', 'Dominican Republic'),
(60, 'TP', 'East Timor'),
(61, 'EC', 'Ecuador'),
(62, 'EG', 'Egypt'),
(63, 'SV', 'El Salvador'),
(64, 'GQ', 'Equatorial Guinea'),
(65, 'ER', 'Eritrea'),
(66, 'EE', 'Estonia'),
(67, 'ET', 'Ethiopia'),
(68, 'FK', 'Falkland Islands (Malvinas)'),
(69, 'FO', 'Faroe Islands'),
(70, 'FJ', 'Fiji'),
(71, 'FI', 'Finland'),
(72, 'FR', 'France'),
(73, 'FX', 'France, Metropolitan'),
(74, 'GF', 'French Guiana'),
(75, 'PF', 'French Polynesia'),
(76, 'TF', 'French Southern Territories'),
(77, 'GA', 'Gabon'),
(78, 'GM', 'Gambia'),
(79, 'GE', 'Georgia'),
(80, 'DE', 'Germany'),
(81, 'GH', 'Ghana'),
(82, 'GI', 'Gibraltar'),
(83, 'GK', 'Guernsey'),
(84, 'GR', 'Greece'),
(85, 'GL', 'Greenland'),
(86, 'GD', 'Grenada'),
(87, 'GP', 'Guadeloupe'),
(88, 'GU', 'Guam'),
(89, 'GT', 'Guatemala'),
(90, 'GN', 'Guinea'),
(91, 'GW', 'Guinea-Bissau'),
(92, 'GY', 'Guyana'),
(93, 'HT', 'Haiti'),
(94, 'HM', 'Heard and Mc Donald Islands'),
(95, 'HN', 'Honduras'),
(96, 'HK', 'Hong Kong'),
(97, 'HU', 'Hungary'),
(98, 'IS', 'Iceland'),
(99, 'IN', 'India'),
(100, 'IM', 'Isle of Man'),
(101, 'ID', 'Indonesia'),
(102, 'IR', 'Iran (Islamic Republic of)'),
(103, 'IQ', 'Iraq'),
(104, 'IE', 'Ireland'),
(105, 'IL', 'Israel'),
(106, 'IT', 'Italy'),
(107, 'CI', 'Ivory Coast'),
(108, 'JE', 'Jersey'),
(109, 'JM', 'Jamaica'),
(110, 'JP', 'Japan'),
(111, 'JO', 'Jordan'),
(112, 'KZ', 'Kazakhstan'),
(113, 'KE', 'Kenya'),
(114, 'KI', 'Kiribati'),
(115, 'KP', 'Korea, Democratic People\'s Republic of'),
(116, 'KR', 'Korea, Republic of'),
(117, 'XK', 'Kosovo'),
(118, 'KW', 'Kuwait'),
(119, 'KG', 'Kyrgyzstan'),
(120, 'LA', 'Lao People\'s Democratic Republic'),
(121, 'LV', 'Latvia'),
(122, 'LB', 'Lebanon'),
(123, 'LS', 'Lesotho'),
(124, 'LR', 'Liberia'),
(125, 'LY', 'Libyan Arab Jamahiriya'),
(126, 'LI', 'Liechtenstein'),
(127, 'LT', 'Lithuania'),
(128, 'LU', 'Luxembourg'),
(129, 'MO', 'Macau'),
(130, 'MK', 'Macedonia'),
(131, 'MG', 'Madagascar'),
(132, 'MW', 'Malawi'),
(133, 'MY', 'Malaysia'),
(134, 'MV', 'Maldives'),
(135, 'ML', 'Mali'),
(136, 'MT', 'Malta'),
(137, 'MH', 'Marshall Islands'),
(138, 'MQ', 'Martinique'),
(139, 'MR', 'Mauritania'),
(140, 'MU', 'Mauritius'),
(141, 'TY', 'Mayotte'),
(142, 'MX', 'Mexico'),
(143, 'FM', 'Micronesia, Federated States of'),
(144, 'MD', 'Moldova, Republic of'),
(145, 'MC', 'Monaco'),
(146, 'MN', 'Mongolia'),
(147, 'ME', 'Montenegro'),
(148, 'MS', 'Montserrat'),
(149, 'MA', 'Morocco'),
(150, 'MZ', 'Mozambique'),
(151, 'MM', 'Myanmar'),
(152, 'NA', 'Namibia'),
(153, 'NR', 'Nauru'),
(154, 'NP', 'Nepal'),
(155, 'NL', 'Netherlands'),
(156, 'AN', 'Netherlands Antilles'),
(157, 'NC', 'New Caledonia'),
(158, 'NZ', 'New Zealand'),
(159, 'NI', 'Nicaragua'),
(160, 'NE', 'Niger'),
(161, 'NG', 'Nigeria'),
(162, 'NU', 'Niue'),
(163, 'NF', 'Norfolk Island'),
(164, 'MP', 'Northern Mariana Islands'),
(165, 'NO', 'Norway'),
(166, 'OM', 'Oman'),
(167, 'PK', 'Pakistan'),
(168, 'PW', 'Palau'),
(169, 'PS', 'Palestine'),
(170, 'PA', 'Panama'),
(171, 'PG', 'Papua New Guinea'),
(172, 'PY', 'Paraguay'),
(173, 'PE', 'Peru'),
(174, 'PH', 'Philippines'),
(175, 'PN', 'Pitcairn'),
(176, 'PL', 'Poland'),
(177, 'PT', 'Portugal'),
(178, 'PR', 'Puerto Rico'),
(179, 'QA', 'Qatar'),
(180, 'RE', 'Reunion'),
(181, 'RO', 'Romania'),
(182, 'RU', 'Russian Federation'),
(183, 'RW', 'Rwanda'),
(184, 'KN', 'Saint Kitts and Nevis'),
(185, 'LC', 'Saint Lucia'),
(186, 'VC', 'Saint Vincent and the Grenadines'),
(187, 'WS', 'Samoa'),
(188, 'SM', 'San Marino'),
(189, 'ST', 'Sao Tome and Principe'),
(190, 'SA', 'Saudi Arabia'),
(191, 'SN', 'Senegal'),
(192, 'RS', 'Serbia'),
(193, 'SC', 'Seychelles'),
(194, 'SL', 'Sierra Leone'),
(195, 'SG', 'Singapore'),
(196, 'SK', 'Slovakia'),
(197, 'SI', 'Slovenia'),
(198, 'SB', 'Solomon Islands'),
(199, 'SO', 'Somalia'),
(200, 'ZA', 'South Africa'),
(201, 'GS', 'South Georgia South Sandwich Islands'),
(202, 'SS', 'South Sudan'),
(203, 'ES', 'Spain'),
(204, 'LK', 'Sri Lanka'),
(205, 'SH', 'St. Helena'),
(206, 'PM', 'St. Pierre and Miquelon'),
(207, 'SD', 'Sudan'),
(208, 'SR', 'Suriname'),
(209, 'SJ', 'Svalbard and Jan Mayen Islands'),
(210, 'SZ', 'Swaziland'),
(211, 'SE', 'Sweden'),
(212, 'CH', 'Switzerland'),
(213, 'SY', 'Syrian Arab Republic'),
(214, 'TW', 'Taiwan'),
(215, 'TJ', 'Tajikistan'),
(216, 'TZ', 'Tanzania, United Republic of'),
(217, 'TH', 'Thailand'),
(218, 'TG', 'Togo'),
(219, 'TK', 'Tokelau'),
(220, 'TO', 'Tonga'),
(221, 'TT', 'Trinidad and Tobago'),
(222, 'TN', 'Tunisia'),
(223, 'TR', 'Turkey'),
(224, 'TM', 'Turkmenistan'),
(225, 'TC', 'Turks and Caicos Islands'),
(226, 'TV', 'Tuvalu'),
(227, 'UG', 'Uganda'),
(228, 'UA', 'Ukraine'),
(229, 'AE', 'United Arab Emirates'),
(230, 'GB', 'United Kingdom'),
(231, 'US', 'United States'),
(232, 'UM', 'United States minor outlying islands'),
(233, 'UY', 'Uruguay'),
(234, 'UZ', 'Uzbekistan'),
(235, 'VU', 'Vanuatu'),
(236, 'VA', 'Vatican City State'),
(237, 'VE', 'Venezuela'),
(238, 'VN', 'Vietnam'),
(239, 'VG', 'Virgin Islands (British)'),
(240, 'VI', 'Virgin Islands (U.S.)'),
(241, 'WF', 'Wallis and Futuna Islands'),
(242, 'EH', 'Western Sahara'),
(243, 'YE', 'Yemen'),
(244, 'ZR', 'Zaire'),
(245, 'ZM', 'Zambia'),
(246, 'ZW', 'Zimbabwe');

CREATE TABLE `cron_krypto` (
  `id_cron` int(11) NOT NULL,
  `page_cron` text NOT NULL,
  `last_update_cron` varchar(15) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `currency_krypto` (
  `id_currency` int(11) NOT NULL,
  `name_currency` varchar(50) NOT NULL,
  `code_iso_currency` varchar(10) NOT NULL,
  `symbol_currency` varchar(5) NOT NULL,
  `usd_rate_currency` varchar(50) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `currency_krypto` (`id_currency`, `name_currency`, `code_iso_currency`, `symbol_currency`, `usd_rate_currency`) VALUES
(1, 'Leke', 'ALL', 'Lek', '110.149881'),
(2, 'US Dollars', 'USD', '$', '1'),
(3, 'Afghanis', 'AFN', '؋', '73.097502'),
(4, 'Argentine Pesos', 'ARS', '$', '29.719876'),
(6, 'Australian Dollars', 'AUD', '$', '1.374955'),
(7, 'New Manats', 'AZN', 'ман', '1.7025'),
(8, 'Bahamian Dollars', 'BSD', '$', '0.999265'),
(9, 'Barbados Dollars', 'BBD', '$', '2.00015'),
(10, 'Belarussian Rubles', 'BYR', 'p.', '19600'),
(11, 'Euro', 'EUR', '€', '0.877645'),
(14, 'Bolivianos', 'BOB', '$b', '6.90495'),
(15, 'Convertible Marka', 'BAM', 'KM', '1.719798'),
(16, 'Pula', 'BWP', 'P', '10.803503'),
(17, 'Leva', 'BGN', 'лв', '1.71655'),
(18, 'Reais', 'BRL', 'R$', '3.9061'),
(19, 'Pounds Sterling', 'GBP', '£', '0.78646'),
(20, 'Brunei Dollars', 'BND', '$', '1.510655'),
(21, 'Riels', 'KHR', '៛', '4068.39501'),
(22, 'Canadian Dollars', 'CAD', '$', '1.314545'),
(24, 'Chilean Pesos', 'CLP', '$', '669.509586'),
(25, 'Yuan Renminbi', 'CNY', '¥', '6.879599'),
(26, 'Colombian Pesos', 'COP', '$', '3021.7'),
(27, 'Colón', 'CRC', '₡', '567.020161'),
(28, 'Kuna', 'HRK', 'kn', '6.510202'),
(30, 'Koruny', 'CZK', 'Kč', '22.586979'),
(31, 'Kroner', 'DKK', 'kr', '6.54534'),
(32, 'Dominican Pesos', 'DOP', 'RD$', '49.73504'),
(34, 'Egyptian Pounds', 'EGP', '£', '17.902965'),
(35, 'Colones', 'SVC', '$', '8.74415'),
(38, 'Cedis', 'GHC', '¢', '1'),
(39, 'Gibraltar Pounds', 'GIP', '£', '0.78998'),
(40, 'Quetzales', 'GTQ', 'Q', '7.48805'),
(41, 'Guernsey Pounds', 'GGP', '£', '0.786427'),
(43, 'Lempiras', 'HNL', 'L', '23.923496'),
(44, 'Hong Kong Dollars', 'HKD', '$', '7.84985'),
(45, 'Forint', 'HUF', 'Ft', '284.187971'),
(46, 'Kronur', 'ISK', 'kr', '108.129725'),
(47, 'Indian Rupees', 'INR', 'Rp', '70.095015'),
(48, 'Rupiahs', 'IDR', 'Rp', '14616'),
(49, 'Iranian Rials', 'IRR', '﷼', '47882.496076'),
(51, 'New Shekels', 'ILS', '₪', '3.669599'),
(52, 'Jamaican Dollars', 'JMD', 'J$', '136.194969'),
(53, 'Yen', 'JPY', '¥', '110.703248'),
(55, 'Tenge', 'KZT', 'лв', '359.95979'),
(57, 'Won', 'KRW', '₩', '1125.090441'),
(58, 'Soms', 'KGS', 'лв', '69.493427'),
(61, 'Lebanese Pounds', 'LBP', '£', '1511.950307'),
(63, 'Switzerland Francs', 'CHF', 'CHF', '0.99623'),
(66, 'Ringgits', 'MYR', 'RM', '4.1041'),
(67, 'Mauritius Rupees', 'MUR', '₨', '34.714503'),
(68, 'Mexican Pesos', 'MXN', '$', '19.0794'),
(70, 'Meticais', 'MZN', 'MT', '58.698045'),
(71, 'Namibia Dollars', 'NAD', '$', '14.619605'),
(72, 'Nepalese Rupees', 'NPR', '₨', '112.37498'),
(74, 'New Zealand Dollars', 'NZD', '$', '1.51485'),
(75, 'Cordobas', 'NIO', 'C$', '31.8355'),
(76, 'Nairas', 'NGN', '₦', '361.739975'),
(77, 'Krone', 'NOK', 'kr', '8.466275'),
(78, 'Rials Omani', 'OMR', '﷼', '0.385025'),
(79, 'Pakistan Rupees', 'PKR', '₨', '123.299915'),
(80, 'Balboa', 'PAB', 'B/.', '0.9993'),
(81, 'Guarani', 'PYG', 'Gs', '5749.288769'),
(82, 'Nuevos Soles', 'PEN', 'S/.', '3.31185'),
(83, 'Philippine Pesos', 'PHP', 'Php', '53.394501'),
(84, 'Zlotych', 'PLN', 'zł', '3.783565'),
(85, 'Qatari Rials', 'QAR', '﷼', '3.641101'),
(86, 'New Lei', 'RON', 'lei', '4.086499'),
(87, 'Russian Rubles', 'RUB', 'руб', '67.409031'),
(89, 'Riyals', 'SAR', '﷼', '3.750797'),
(90, 'Dinars', 'RSD', 'Дин.', '103.540316'),
(92, 'Singapore Dollars', 'SGD', '$', '1.374599'),
(93, 'Solomon Islands Dollars', 'SBD', '$', '7.959302'),
(95, 'Rand', 'ZAR', 'R', '14.948304'),
(96, 'Sri Lanka Rupees', 'LKR', '₨', '160.539809'),
(97, 'Kronor', 'SEK', 'kr', '9.18892'),
(100, 'New Dollars', 'TWD', 'NT$', '30.798965'),
(101, 'Baht', 'THB', '฿', '33.229503'),
(102, 'Trinidad and Tobago Dollars', 'TTD', 'TT$', '6.73505'),
(103, 'Lira', 'TRY', 'TL', '6.038215'),
(104, 'Liras', 'TRL', '£', '1'),
(106, 'Hryvnia', 'UAH', '₴', '27.689503'),
(107, 'Pesos Uruguayo', 'UYU', '$U', '31.294362'),
(108, 'Sums', 'UZS', 'лв', '7784.550277'),
(109, 'Bolivares Fuertes', 'VEF', 'Bs', '248550.000092'),
(110, 'Dong', 'VND', '₫', '23294');

CREATE TABLE `dashboard_krypto` (
  `id_dashboard` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `num_graph_dashboard` varchar(11) NOT NULL DEFAULT '3_tm_ll'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `deposit_history_krypto` (
  `id_deposit_history` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `amount_deposit_history` varchar(50) NOT NULL,
  `date_deposit_history` varchar(12) NOT NULL,
  `balance_deposit_history` int(11) NOT NULL,
  `payment_status_deposit_history` varchar(50) NOT NULL,
  `payment_type_deposit_history` varchar(50) NOT NULL,
  `payment_data_deposit_history` text NOT NULL,
  `description_deposit_history` varchar(250) NOT NULL,
  `fees_deposit_history` varchar(50) NOT NULL DEFAULT '0',
  `currency_deposit_history` varchar(50) NOT NULL DEFAULT 'USD',
  `wallet_deposit_history` varchar(50) DEFAULT 'USD',
  `wallet_convert_m_deposit_history` varchar(255) NOT NULL DEFAULT '1',
  `ref_deposit_history` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `deposit_history_proof_krypto` (
  `id_deposit_history_proof` int(11) NOT NULL,
  `id_deposit_history` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_deposit_history_proof` varchar(15) NOT NULL,
  `url_deposit_history_proof` text NOT NULL,
  `sended_deposit_history_proof` varchar(15) NOT NULL DEFAULT '',
  `reason__deposit_history_proof` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `ethfinex_krypto` (
  `id_ethfinex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_ethfinex` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `exchanges_krypto` (
  `id_exchanges` int(11) NOT NULL,
  `market_exchanges` varchar(50) NOT NULL,
  `symbol_exchanges` varchar(50) NOT NULL,
  `currency_exchanges` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


CREATE TABLE `exmo_krypto` (
  `id_exmo` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_exmo` text NOT NULL,
  `secret_exmo` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `gateio_krypto` (
  `id_gateio` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_gateio` text NOT NULL,
  `secret_gateio` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `gdax_krypto` (
  `id_gdax` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_gdax` text NOT NULL,
  `pass_gdax` text NOT NULL,
  `secret_gdax` text NOT NULL,
  `live_gdax` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `gemini_krypto` (
  `id_gemini` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_gemini` longtext NOT NULL,
  `secret_gemini` longtext NOT NULL,
  `live_gemini` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `googletfs_krypto` (
  `id_googletfs` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_googletfs` varchar(12) NOT NULL,
  `secret_googletfs` text NOT NULL,
  `status_googletfs` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `graph_krypto` (
  `id_graph` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_graph` varchar(25) NOT NULL,
  `type_graph` varchar(50) NOT NULL DEFAULT 'candlestick'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `histo_krypto` (
  `id_histo` int(11) NOT NULL,
  `coin_histo` varchar(50) NOT NULL,
  `currency_histo` varchar(50) NOT NULL,
  `type_histo` varchar(75) NOT NULL,
  `last_update_histo` varchar(20) NOT NULL,
  `data_histo` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `hitbtc2_krypto` (
  `id_hitbtc2` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_hitbtc2` text NOT NULL,
  `secret_hitbtc2` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `holding_krypto` (
  `id_holding` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `value_holding` varchar(200) NOT NULL,
  `type_holding` varchar(12) NOT NULL DEFAULT 'buy',
  `date_holding` varchar(12) NOT NULL,
  `price_holding` varchar(200) NOT NULL,
  `symbol_holding` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `identity_asset_krypto` (
  `id_identity_asset` int(11) NOT NULL,
  `id_identity` int(11) NOT NULL,
  `id_identity_step` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `value_identity_asset` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `identity_doclist_krypto` (
  `id_identity_doclist` int(11) NOT NULL,
  `name_identity_doclist` varchar(80) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `identity_krypto` (
  `id_identity` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_processed_identity` varchar(15) NOT NULL,
  `status_identity` int(11) NOT NULL DEFAULT '0',
  `lupdate_identity` varchar(15) NOT NULL,
  `document_identity` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `identity_step_krypto` (
  `id_identity_step` int(11) NOT NULL,
  `name_identity_step` varchar(255) NOT NULL,
  `type_identity_step` varchar(255) NOT NULL,
  `description_identity_step` text NOT NULL,
  `order_identity_step` int(11) NOT NULL,
  `allow_cam_identity_step` int(11) NOT NULL DEFAULT '1',
  `document_ratio_identity_step` varchar(50) NOT NULL DEFAULT '1/1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `indicators_krypto` (
  `id_indicators` int(11) NOT NULL,
  `key_graph` varchar(50) NOT NULL,
  `key_indicators` varchar(50) NOT NULL,
  `symbol_indicators` varchar(20) NOT NULL,
  `data_indicators` text NOT NULL,
  `title_indicators` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `internal_order_krypto` (
  `id_internal_order` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_internal_order` varchar(12) NOT NULL,
  `id_balance` int(11) NOT NULL,
  `thirdparty_internal_order` varchar(50) NOT NULL,
  `amount_internal_order` float NOT NULL DEFAULT '0',
  `usd_amount_internal_order` float NOT NULL DEFAULT '0',
  `symbol_internal_order` varchar(50) NOT NULL,
  `fees_internal_order` varchar(50) NOT NULL,
  `order_key_internal_order` text NOT NULL,
  `side_internal_order` varchar(20) NOT NULL DEFAULT 'BUY',
  `to_internal_order` varchar(50) NOT NULL DEFAULT 'USD',
  `ref_internal_order` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `kraken_krypto` (
  `id_kraken` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_kraken` longtext NOT NULL,
  `private_kraken` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `kucoin_krypto` (
  `id_kucoin` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_kucoin` longtext NOT NULL,
  `secret_kucoin` longtext NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `leader_board_krypto` (
  `id_leader_board` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `benef_leader_board` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `livecoin_krypto` (
  `id_livecoin` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_livecoin` text NOT NULL,
  `secret_livecoin` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `luno_krypto` (
  `id_luno` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_luno` text NOT NULL,
  `secret_luno` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `msg_room_chat_krypto` (
  `id_msg_room_chat` int(11) NOT NULL,
  `id_room_chat` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `type_msg_room_chat` varchar(20) NOT NULL DEFAULT 'text',
  `value_msg_room_chat` longtext NOT NULL,
  `date_msg_room_chat` varchar(12) NOT NULL,
  `control_key_msg_room_chat` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `notification_center_krypto` (
  `id_notification_center` int(11) NOT NULL,
  `title_notification_center` varchar(255) NOT NULL,
  `text_notification_center` text NOT NULL,
  `date_notification_center` varchar(12) NOT NULL,
  `icon_notification_center` text NOT NULL,
  `status_notification_center` double DEFAULT '0',
  `id_user` int(11) NOT NULL,
  `action_notification_center` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `notification_krypto` (
  `id_notification` int(11) NOT NULL,
  `symbol_notification` varchar(10) NOT NULL,
  `actual_value_notification` varchar(50) NOT NULL,
  `value_notification` varchar(50) NOT NULL,
  `compare_notififcation` int(11) NOT NULL DEFAULT '0',
  `status_notification` int(11) NOT NULL DEFAULT '0',
  `id_user` int(11) NOT NULL,
  `market_notification` varchar(50) NOT NULL DEFAULT 'CCCAGG',
  `currency_notification` varchar(50) NOT NULL DEFAULT 'USD'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `okcoinusd_krypto` (
  `id_okcoinusd` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_okcoinusd` text NOT NULL,
  `secret_okcoinusd` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `okex_krypto` (
  `id_okex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_okex` text NOT NULL,
  `secret_okex` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `order_krypto` (
  `id_order` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `time_order` varchar(50) NOT NULL,
  `type_order` varchar(5) NOT NULL DEFAULT 'BUY',
  `amount_order` varchar(50) NOT NULL,
  `symbol_order` varchar(20) NOT NULL,
  `currency_order` varchar(15) NOT NULL,
  `thirdparty_order` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `paygateway_krypto` (
  `id_paygateway` int(11) NOT NULL,
  `name_paygateway` varchar(255) NOT NULL,
  `arg_paygateway` varchar(255) NOT NULL,
  `val_paygateway` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `plan_krypto` (
  `id_plan` int(11) NOT NULL,
  `name_plan` varchar(50) NOT NULL,
  `price_plan` int(11) NOT NULL,
  `ndays_plan` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `plan_krypto` (`id_plan`, `name_plan`, `price_plan`, `ndays_plan`) VALUES
(4, '1 Month', 990, 31),
(5, '1 Year', 9504, 365);

CREATE TABLE `poloniex_krypto` (
  `id_poloniex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_poloniex` text NOT NULL,
  `secret_poloniex` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `quoinex_krypto` (
  `id_quoinex` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_quoinex` text NOT NULL,
  `secret_quoinex` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `referal_histo_krypto` (
  `referal_histo_id` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `code_referal` varchar(255) NOT NULL,
  `date_referal_histo` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `referal_krypto` (
  `id_referal` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `code_referal` varchar(200) NOT NULL,
  `date_referal` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `room_chat_krypto` (
  `id_room_chat` int(11) NOT NULL,
  `key_room_chat` varchar(50) NOT NULL,
  `date_created_room_chat` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `rssfeed_krypto` (
  `id_rssfeed` int(11) NOT NULL,
  `name_rssfeed` varchar(100) NOT NULL,
  `url_rssfeed` text NOT NULL,
  `date_rssfeed` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `rssfeed_krypto` (`id_rssfeed`, `name_rssfeed`, `url_rssfeed`, `date_rssfeed`) VALUES
(2, 'Cointelegraph', 'https://cointelegraph.com/feed', '555'),
(3, 'Block Chain', 'https://blog.blockchain.com/feed/', '555'),
(4, 'Reddit Bitcoin', 'https://www.reddit.com/r/Bitcoin/.rss?format=xml', '555'),
(5, 'Bitcoin news', 'https://news.bitcoin.com/feed/', '555'),
(6, 'cryptocurrencynews.com', 'https://cryptocurrencynews.com/feed/', '1521282485');

CREATE TABLE `settings_krypto` (
  `id_settings` int(11) NOT NULL,
  `key_settings` varchar(255) NOT NULL,
  `value_settings` text NOT NULL,
  `encrypted_settings` int(11) DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `settings_krypto` (`id_settings`, `key_settings`, `value_settings`, `encrypted_settings`) VALUES
(1, 'allow_signup', '1', 0),
(3, 'captcha_signup', '0', 0),
(4, 'google_oauth', '0', 0),
(5, 'title_app', 'Krypto', 0),
(6, 'description_app', 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse commodo in eros sit amet facilisis. Cras dapibus placerat nibh, vitae mollis elit malesuada eu. Cras porta id ligula eget molestie.', 0),
(7, 'google_analytic', '', 0),
(8, 'smtp_enabled', '0', 0),
(9, 'smtp_server', '', 0),
(10, 'smtp_user', '', 0),
(11, 'smtp_password', '', 1),
(12, 'smtp_port', '', 0),
(14, 'charge_trial_nbdays', '20', 0),
(15, 'premium_name', 'Premium', 0),
(16, 'charge_currency', 'USD', 0),
(17, 'premium_features', 'More than 2000 crypto currencies<br>\r\nBe alerted when an indicator grows or falls<br>\r\nResponsive on mobile and tablet<br>\r\nNews and social posts at the same place', 0),
(18, 'stripe_privatekey', '', 1),
(19, 'payment_success', 'Thank\'s to buy premium version !', 0),
(20, 'paypal_clientid', '', 1),
(21, 'paypal_secret', '', 1),
(23, 'paypal_enabled', '0', 0),
(25, 'subscription_enabled', '0', 0),
(26, 'freetrial_enabled', '1', 0),
(27, 'default_dashboard', '1_grid', 0),
(29, 'default_language', 'en', 0),
(30, 'google_app_id', '', 1),
(31, 'google_app_secret', '', 1),
(32, 'smtp_from', 'Nuvoo Exchange', 0),
(33, 'google_recaptcha_sitekey', '', 1),
(34, 'google_recaptcha_secretkey', '', 1),
(36, 'support_email', 'hello@ovrley.com', 0),
(37, 'send_welcomeemail', '0', 0),
(38, 'welcome_subject', 'Nuvoo Exchange - Welcome !', 0),
(39, 'creditcard_enabled', '0', 0),
(40, 'fortumo_secret', '', 1),
(41, 'fortumo_service', '', 1),
(42, 'fortumo_enabled', '0', 0),
(43, 'autodetect_language', '1', 0),
(44, 'paypal_live', '0', 0),
(45, 'coingate_enabled', '0', 0),
(46, 'coingate_live_mode', '0', 0),
(47, 'coingate_app_id', '', 1),
(48, 'coingate_api_key', '', 1),
(49, 'coingate_api_secret', '', 1),
(50, 'user_permissions', '{\"blockfolio\":\"1\",\"marketanalytic\":\"1\",\"news\":\"1\",\"social\":\"1\",\"tradinglive\":\"1\",\"notifications_phone\":\"1\",\"googleauthenticator\":\"1\",\"heat_map\":\"1\",\"calculator\":\"1\",\"livemarket\":\"1\",\"exportgraph\":\"1\"}', 0),
(51, 'smtp_security', '', 0),
(52, 'google_ad_enabled', '0', 0),
(53, 'google_ad_client', '', 0),
(54, 'google_ad_slot', '', 0),
(55, 'mollie_enabled', '0', 0),
(56, 'mollie_key', '', 1),
(57, 'buy_referal', 'https://changelly.com/?ref_id=6c63e9e3b6cd', 0),
(58, 'maintenance_mode', '0', 0),
(59, 'number_format', '\".\":\",\"', 0),
(60, 'user_activation_require', '0', 0),
(61, 'nb_days_subscription_needed', '4', 0),
(62, 'hidden_third_trading', '0', 0),
(63, 'hidden_third_trading_fee', '0.3', 0),
(64, 'hidden_third_trading_fee_mod', 'deposit', 0),
(65, 'hidden_third_trading_service', 'binance', 0),
(66, 'hidden_third_trading_service_cfg', '', 0),
(67, 'calendar_cliend_id', '', 1),
(68, 'calendar_client_secret', '', 1),
(69, 'widthdraw_processing_days', '2', 0),
(70, 'widthdraw_minimum', '20', 0),
(71, 'referall_win_amount', '5', 0),
(72, 'extra_page_enable', '0', 0),
(73, 'extra_page_newtab', '0', 0),
(74, 'extra_page_url', 'https://www.google.fr', 0),
(75, 'extra_page_name', 'Google', 0),
(76, 'extra_page_icon', 'lnr-cloud', 0),
(77, 'deposit_minimal', '20', 0),
(78, 'deposit_maximal', '10000', 0),
(80, 'deposit_fees', '2.5', 0),
(81, 'facebook_oauth', '0', 0),
(82, 'facebook_appid', '', 1),
(83, 'facebook_appsecret', '', 1),
(84, 'intro_list', '[{\"title\":\"Watching list\",\"text\":\"You can see on this pannel your watching list\",\"attach\":\".kr-wtchl left\"},{\"title\":\"Change theme\",\"text\":\"Switch your theme between dark & light\",\"attach\":\".kr-toggle-white top\"},{\"title\":\"News\",\"text\":\"What\'s new in Cryptocurrencies world ?\",\"attach\":\"[kr-side=\'kr-infosside\'] left\"},{\"title\":\"Order book\",\"text\":\"Know your history trading\",\"attach\":\"[kr-side=\'kr-orderbook\'] left\"},{\"title\":\"Be on time\",\"text\":\"Time\",\"attach\":\".kr-current-time top\"},{\"title\":\"More details here\",\"text\":\"Coin details\",\"attach\":\".kr-infoscurrencylf left\"}]', 0),
(85, 'intro_show', '1', 0),
(86, 'calendar_enable', '0', 0),
(87, 'calendar_enable_coin_enable', '0', 0),
(88, 'cookie_title', 'This website uses cookies', 0),
(89, 'cookie_text', 'Our website uses cookies to examine site traffic and user activity while on our site, for enhanced and effective user experience, marketing, and to provide social media functionality.', 0),
(90, 'cookie_advert_enable', '1', 0),
(91, 'widthdraw_fees', '3', 0),
(92, 'trading_maximum_free_deposit', '10000', 0),
(93, 'trading_enable_real_account', '1', 0),
(95, 'newspopup_show', '1', 0),
(96, 'newspopup_lastupdate', '150', 0),
(97, 'newspopup_video', 'G_WbeVhrk6k', 0),
(98, 'newspopup_title', 'Welcome to the new update 2.1', 0),
(99, 'newspopup_text', 'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure \r\n\r\ndolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\r\n\r\nLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, \r\n\r\nquis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.', 0),
(100, 'referal_enable', '0', 0),
(101, 'support_phone', '+33 6 73 71 XX XX', 0),
(102, 'support_address', 'krypto@ovrley.com', 0),
(103, 'dpo_email', 'hello@ovrley.com', 0),
(104, 'dpo_phone', '+33 6 73 71 XX XX', 0),
(105, 'tradingview_chart', '0', 0),
(106, 'banktransfert_prefix', 'KRYP', 0),
(107, 'banktransfert_enable', '0', 0),
(110, 'widthdraw_fee', '0.3', 0),
(111, 'blockonomics_enable', '0', 0),
(112, 'blockonomics_apikey', '', 1),
(114, 'show_balance_estimation_in', 'EUR', 0),
(115, 'coingate_authtoken', '', 1),
(116, 'payment_ref_pattern', 'KRYP-$**$-$$$$', 0),
(117, 'deposit_currency_real', '[\"USD\",\"EUR\"]', 0),
(118, 'deposit_convert_to_enable', '1', 0),
(119, 'deposit_convert_to', 'BTC', 0),
(120, 'coingate_paymentconvertion', 'BTC', 0),
(121, 'currencylayer_currency_rate_apikey', '', 0),
(122, 'payment_approve_needed', '1', 0),
(123, 'deposit_currency_notinbalance', 'ETH', 0),
(124, 'show_balance_estimation', '1', 0),
(125, 'payeer_enable', '0', 0),
(126, 'payeer_shopid', '', 1),
(127, 'payeer_apikey', '', 1),
(128, 'blacklisted_countries', 'null', 0),
(129, 'banktransfert_proof_enable', '1', 0),
(130, 'banktransfert_proof_max', '2', 0),
(131, 'banktransfert_max', '2', 0),
(132, 'raveflutterwave_enabled', '0', 0),
(133, 'raveflutterwave_sandbox', '0', 0),
(134, 'raveflutterwave_public_key', '', 1),
(135, 'raveflutterwave_secret_key', '', 1),
(136, 'raveflutterwave_title', 'Krypto V45', 0),
(137, 'raveflutterwave_prefix', 'KRYP', 0),
(138, 'coinbasecommerce_enabled', '0', 0),
(139, 'coinbasecommerce_apikey', '', 1),
(140, 'coinbasecommerce_paymentitle', 'KRYPTO', 0),
(141, 'show_balance_estimation_user_currency', '1', 0),
(142, 'coinpayments_enabled', '0', 0),
(143, 'coinpayments_publickey', '', 1),
(144, 'coinpayments_privatekey', '', 1),
(145, 'coinpayments_marchant_id', '', 1),
(146, 'coinpayment_ipn_secret', '', 1),
(147, 'trading_free_symbol', 'BTC', 0),
(148, 'allowswitch_chart', '1', 0),
(149, 'hidden_third_trading_pattern', 'ORDR-$**$-$$$$', 0),
(150, 'poeditor_enable', '0', 0),
(151, 'poeditor_apikey', '', 1),
(152, 'poeditor_project', '', 0),
(153, 'widthdraw_pattern', 'WIDRAW-$**$-****', 0),
(154, 'perfectmoney_payee_account', '', 0),
(155, 'perfectmoney_payee_name', 'OVRLEY', 0),
(156, 'perfectmoney_enabled', '0', 0),
(157, 'coingate_paymentconvertion', 'BTC', 0),
(158, 'bankwithdraw_alert', 'Attention! The price of cryptocurrencies is volatile and can change a lot while transaction of cryptocurrencies is fulfilled. After your bank transfer reaches us, you will be able to commit to your purchase at any time, with the amount of cryptocurrencies you would receive recalculated every 60 seconds, but you will not be able to refund your payment*. Please note that the amount of cryptocurrencies that you paid for may have changed at the moment of fulfillment.\r\n\r\nExample: if you wanted to buy 1 BTC for 100 EUR and sent us 100 EUR bank transfer, but at the time when you commit to your purchase BTC price has risen to 200 EUR, you will only be able to get 0.5 BTC; if the price has dropped to 50 EUR, you will be able to get 2 BTC.\r\n\r\n* If you do not commit to your purchase in 2 weeks, your payment will be automatically refunded to the bank account from which you sent the payment, minus any fees we had to pay to send it back to you and minus our 1% fee.', 0),
(159, 'bankwithdraw_allowed_cryptocurrencies', '[\"BTC\"]', 0),
(160, 'blockonomics_payment_fees', '', 0),
(161, 'fortumo_payment_fees', '11', 0),
(162, 'coingate_payment_fees', '12', 0),
(163, 'coinpayment_payment_fees', '13', 0),
(164, 'raveflutterwave_payment_fees', '14', 0),
(165, 'coinbasecommerce_payment_fees', '15', 0),
(166, 'mollie_payment_fees', '18', 0),
(167, 'payeer_payment_fees', '16', 0),
(168, 'banktransfert_payment_fees', '17', 0),
(169, 'bankdeposit_alert', 'Attention! The price of cryptocurrencies is volatile and can change a lot while transaction of cryptocurrencies is fulfilled. After your bank transfer reaches us, you will be able to commit to your purchase at any time, with the amount of cryptocurrencies you would receive recalculated every 60 seconds, but you will not be able to refund your payment*. Please note that the amount of cryptocurrencies that you paid for may have changed at the moment of fulfillment.\r\n\r\nExample: if you wanted to sell 1 BTC for 100 EUR and sent us 1 BTC , but at the time when you commit to your sale BTC price has dropped to 50 EUR, you will only be able to get 50 EUR; if the price has raised to 200 EUR, you will be able to get 200 EUR.', 0),
(170, 'chat_disabled', '0', 0),
(171, 'identity_enabled', '1', 0),
(172, 'identity_block_deposit', '0', 0),
(173, 'identity_block_trade', '0', 0),
(174, 'identity_block_withdraw', '0', 0),
(175, 'donation_enable', '1', 0),
(176, 'donation_list', 'BTC:1dazdazdazdazdaddazd\r\nETH:1JiFQeQs5N7xUUQ6dc4ehRMgSQACpCZcKr\r\nLTC:1JiFQeQs5N7xUUQ6dc4ehRMgSQACpCZcKr\r\nZEC:1JiFQeQs5N7xUUQ6dc4ehRMgSQACpCZcKr', 0),
(177, 'donation_text', 'PUT A SMILE ON OUR FACES AND SUPPORT US BY DONATING 2 :)', 0),
(178, 'leaderboard_enable', '1', 0),
(179, 'starting_pair', 'BINANCE:ETH/BTC', 0),
(180, 'starting_pair_watchinglist', 'BINANCE:ETH/BTC\r\nBINANCE:BTC/USDT\r\nBINANCE:EOS/USDT\r\nBINANCE:DASH/ETH', 0),
(181, 'hide_market', '0', 0),
(182, 'paygoal_serviceid', '', 1),
(183, 'paygoal_secret', '', 1),
(184, 'paygoal_enable', '0', 0),
(185, 'paygoal_fees', '10', 0);

CREATE TABLE `social_krypto` (
  `id_social` int(11) NOT NULL,
  `type_social` varchar(20) NOT NULL,
  `user_social` varchar(80) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `social_krypto` (`id_social`, `type_social`, `user_social`) VALUES
(7, 'twitter', 'cryptocurrency'),
(9, 'twitter', 'ethereumproject'),
(11, 'twitter', 'Bitcoin'),
(13, 'twitter', 'litecoinqueen');

CREATE TABLE `thirdparty_crypto_krypto` (
  `id_thirdparty_crypto` int(11) NOT NULL,
  `symbol_thirdparty_crypto` varchar(12) NOT NULL,
  `to_thirdparty_crypto` varchar(20) NOT NULL,
  `name_thirdparty_crypto` varchar(50) NOT NULL,
  `min_thirdparty_crypto` varchar(15) NOT NULL,
  `max_thirdparty_crypto` varchar(15) NOT NULL,
  `active_thirdparty_crypto` tinyint(1) NOT NULL DEFAULT '1',
  `precision_amount_thirdparty_crypto` varchar(11) NOT NULL DEFAULT '3'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(1, 'ETH', 'BTC', 'binance', '0.001', '100000', 1, '3'),
(2, 'LTC', 'BTC', 'binance', '0.01', '100000', 1, '2'),
(3, 'BNB', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(4, 'NEO', 'BTC', 'binance', '0.01', '100000', 1, '2'),
(5, 'QTUM', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(6, 'EOS', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(7, 'SNT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(8, 'BNT', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(9, 'BCH', 'BTC', 'binance', '0.001', '100000', 1, '3'),
(10, 'GAS', 'BTC', 'binance', '0.01', '100000', 1, '2'),
(11, 'BNB', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(12, 'BTC', 'USDT', 'binance', '1.0E-6', '10000000', 1, '6'),
(13, 'ETH', 'USDT', 'binance', '1.0E-5', '10000000', 1, '5'),
(14, 'HSR', 'BTC', 'binance', '0.01', '10000000', 0, '2'),
(15, 'OAX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(16, 'DNT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(17, 'MCO', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(18, 'ICN', 'ETH', 'binance', '1', '90000000', 1, '0'),
(19, 'MCO', 'BTC', 'binance', '0.01', '10000000', 1, '2'),
(20, 'WTC', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(21, 'WTC', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(22, 'LRC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(23, 'LRC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(24, 'QTUM', 'BTC', 'binance', '0.01', '10000000', 1, '2'),
(25, 'YOYOW', 'BTC', 'binance', '1', '90000000', 1, '0'),
(26, 'OMG', 'BTC', 'binance', '0.01', '10000000', 1, '2'),
(27, 'OMG', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(28, 'ZRX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(29, 'ZRX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(30, 'STRAT', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(31, 'STRAT', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(32, 'SNGLS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(33, 'SNGLS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(34, 'BQX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(35, 'BQX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(36, 'KNC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(37, 'KNC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(38, 'FUN', 'BTC', 'binance', '1', '90000000', 1, '0'),
(39, 'FUN', 'ETH', 'binance', '1', '90000000', 1, '0'),
(40, 'SNM', 'BTC', 'binance', '1', '90000000', 1, '0'),
(41, 'SNM', 'ETH', 'binance', '1', '90000000', 1, '0'),
(42, 'NEO', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(43, 'IOTA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(44, 'IOTA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(45, 'LINK', 'BTC', 'binance', '1', '90000000', 1, '0'),
(46, 'LINK', 'ETH', 'binance', '1', '90000000', 1, '0'),
(47, 'XVG', 'BTC', 'binance', '1', '90000000', 1, '0'),
(48, 'XVG', 'ETH', 'binance', '1', '90000000', 1, '0'),
(49, 'SALT', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(50, 'SALT', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(51, 'MDA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(52, 'MDA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(53, 'MTL', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(54, 'MTL', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(55, 'SUB', 'BTC', 'binance', '1', '90000000', 1, '0'),
(56, 'SUB', 'ETH', 'binance', '1', '90000000', 1, '0'),
(57, 'EOS', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(58, 'SNT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(59, 'ETC', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(60, 'ETC', 'BTC', 'binance', '0.01', '10000000', 1, '2'),
(61, 'MTH', 'BTC', 'binance', '1', '90000000', 1, '0'),
(62, 'MTH', 'ETH', 'binance', '1', '90000000', 1, '0'),
(63, 'ENG', 'BTC', 'binance', '1', '90000000', 1, '0'),
(64, 'ENG', 'ETH', 'binance', '1', '90000000', 1, '0'),
(65, 'DNT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(66, 'ZEC', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(67, 'ZEC', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(68, 'BNT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(69, 'AST', 'BTC', 'binance', '1', '90000000', 1, '0'),
(70, 'AST', 'ETH', 'binance', '1', '90000000', 1, '0'),
(71, 'DASH', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(72, 'DASH', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(73, 'OAX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(74, 'ICN', 'BTC', 'binance', '1', '90000000', 1, '0'),
(75, 'BTG', 'BTC', 'binance', '0.01', '10000000', 1, '2'),
(76, 'BTG', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(77, 'EVX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(78, 'EVX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(79, 'REQ', 'BTC', 'binance', '1', '90000000', 1, '0'),
(80, 'REQ', 'ETH', 'binance', '1', '90000000', 1, '0'),
(81, 'VIB', 'BTC', 'binance', '1', '90000000', 1, '0'),
(82, 'VIB', 'ETH', 'binance', '1', '90000000', 1, '0'),
(83, 'HSR', 'ETH', 'binance', '0.01', '90000000', 0, '2'),
(84, 'TRX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(85, 'TRX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(86, 'POWR', 'BTC', 'binance', '1', '90000000', 1, '0'),
(87, 'POWR', 'ETH', 'binance', '1', '90000000', 1, '0'),
(88, 'ARK', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(89, 'ARK', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(90, 'YOYOW', 'ETH', 'binance', '1', '90000000', 1, '0'),
(91, 'XRP', 'BTC', 'binance', '1', '90000000', 1, '0'),
(92, 'XRP', 'ETH', 'binance', '1', '90000000', 1, '0'),
(93, 'MOD', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(94, 'MOD', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(95, 'ENJ', 'BTC', 'binance', '1', '90000000', 1, '0'),
(96, 'ENJ', 'ETH', 'binance', '1', '90000000', 1, '0'),
(97, 'STORJ', 'BTC', 'binance', '1', '90000000', 1, '0'),
(98, 'STORJ', 'ETH', 'binance', '1', '90000000', 1, '0'),
(99, 'BNB', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(100, 'VEN', 'BNB', 'binance', '0.01', '10000000', 0, '2'),
(101, 'YOYOW', 'BNB', 'binance', '1', '90000000', 1, '0'),
(102, 'POWR', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(103, 'VEN', 'BTC', 'binance', '1', '90000000', 0, '0'),
(104, 'VEN', 'ETH', 'binance', '1', '90000000', 0, '0'),
(105, 'KMD', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(106, 'KMD', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(107, 'NULS', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(108, 'RCN', 'BTC', 'binance', '1', '90000000', 1, '0'),
(109, 'RCN', 'ETH', 'binance', '1', '90000000', 1, '0'),
(110, 'RCN', 'BNB', 'binance', '1', '90000000', 1, '0'),
(111, 'NULS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(112, 'NULS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(113, 'RDN', 'BTC', 'binance', '1', '90000000', 1, '0'),
(114, 'RDN', 'ETH', 'binance', '1', '90000000', 1, '0'),
(115, 'RDN', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(116, 'XMR', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(117, 'XMR', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(118, 'DLT', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(119, 'WTC', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(120, 'DLT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(121, 'DLT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(122, 'AMB', 'BTC', 'binance', '1', '90000000', 1, '0'),
(123, 'AMB', 'ETH', 'binance', '1', '90000000', 1, '0'),
(124, 'AMB', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(125, 'BCH', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(126, 'BCH', 'USDT', 'binance', '1.0E-5', '10000000', 1, '5'),
(127, 'BCH', 'BNB', 'binance', '1.0E-5', '10000000', 1, '5'),
(128, 'BAT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(129, 'BAT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(130, 'BAT', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(131, 'BCPT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(132, 'BCPT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(133, 'BCPT', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(134, 'ARN', 'BTC', 'binance', '1', '90000000', 1, '0'),
(135, 'ARN', 'ETH', 'binance', '1', '90000000', 1, '0'),
(136, 'GVT', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(137, 'GVT', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(138, 'CDT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(139, 'CDT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(140, 'GXS', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(141, 'GXS', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(142, 'NEO', 'USDT', 'binance', '0.001', '10000000', 1, '3'),
(143, 'NEO', 'BNB', 'binance', '0.001', '10000000', 1, '3'),
(144, 'POE', 'BTC', 'binance', '1', '90000000', 1, '0'),
(145, 'POE', 'ETH', 'binance', '1', '90000000', 1, '0'),
(146, 'QSP', 'BTC', 'binance', '1', '90000000', 1, '0'),
(147, 'QSP', 'ETH', 'binance', '1', '90000000', 1, '0'),
(148, 'QSP', 'BNB', 'binance', '1', '90000000', 1, '0'),
(149, 'BTS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(150, 'BTS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(151, 'BTS', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(152, 'XZC', 'BTC', 'binance', '0.01', '10000000', 1, '2'),
(153, 'XZC', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(154, 'XZC', 'BNB', 'binance', '0.001', '10000000', 1, '3'),
(155, 'LSK', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(156, 'LSK', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(157, 'LSK', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(158, 'TNT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(159, 'TNT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(160, 'FUEL', 'BTC', 'binance', '1', '90000000', 1, '0'),
(161, 'FUEL', 'ETH', 'binance', '1', '90000000', 1, '0'),
(162, 'MANA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(163, 'MANA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(164, 'BCD', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(165, 'BCD', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(166, 'DGD', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(167, 'DGD', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(168, 'IOTA', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(169, 'ADX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(170, 'ADX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(171, 'ADX', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(172, 'ADA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(173, 'ADA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(174, 'PPT', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(175, 'PPT', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(176, 'CMT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(177, 'CMT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(178, 'CMT', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(179, 'XLM', 'BTC', 'binance', '1', '90000000', 1, '0'),
(180, 'XLM', 'ETH', 'binance', '1', '90000000', 1, '0'),
(181, 'XLM', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(182, 'CND', 'BTC', 'binance', '1', '90000000', 1, '0'),
(183, 'CND', 'ETH', 'binance', '1', '90000000', 1, '0'),
(184, 'CND', 'BNB', 'binance', '1', '90000000', 1, '0'),
(185, 'LEND', 'BTC', 'binance', '1', '90000000', 1, '0'),
(186, 'LEND', 'ETH', 'binance', '1', '90000000', 1, '0'),
(187, 'WABI', 'BTC', 'binance', '1', '90000000', 1, '0'),
(188, 'WABI', 'ETH', 'binance', '1', '90000000', 1, '0'),
(189, 'WABI', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(190, 'LTC', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(191, 'LTC', 'USDT', 'binance', '1.0E-5', '10000000', 1, '5'),
(192, 'LTC', 'BNB', 'binance', '1.0E-5', '10000000', 1, '5'),
(193, 'TNB', 'BTC', 'binance', '1', '90000000', 1, '0'),
(194, 'TNB', 'ETH', 'binance', '1', '90000000', 1, '0'),
(195, 'WAVES', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(196, 'WAVES', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(197, 'WAVES', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(198, 'GTO', 'BTC', 'binance', '1', '90000000', 1, '0'),
(199, 'GTO', 'ETH', 'binance', '1', '90000000', 1, '0'),
(200, 'GTO', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(201, 'ICX', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(202, 'ICX', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(203, 'ICX', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(204, 'OST', 'BTC', 'binance', '1', '90000000', 1, '0'),
(205, 'OST', 'ETH', 'binance', '1', '90000000', 1, '0'),
(206, 'OST', 'BNB', 'binance', '1', '90000000', 1, '0'),
(207, 'ELF', 'BTC', 'binance', '1', '90000000', 1, '0'),
(208, 'ELF', 'ETH', 'binance', '1', '90000000', 1, '0'),
(209, 'AION', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(210, 'AION', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(211, 'AION', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(212, 'NEBL', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(213, 'NEBL', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(214, 'NEBL', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(215, 'BRD', 'BTC', 'binance', '1', '90000000', 1, '0'),
(216, 'BRD', 'ETH', 'binance', '1', '90000000', 1, '0'),
(217, 'BRD', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(218, 'MCO', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(219, 'EDO', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(220, 'EDO', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(221, 'WINGS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(222, 'WINGS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(223, 'NAV', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(224, 'NAV', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(225, 'NAV', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(226, 'LUN', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(227, 'LUN', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(228, 'TRIG', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(229, 'TRIG', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(230, 'TRIG', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(231, 'APPC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(232, 'APPC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(233, 'APPC', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(234, 'VIBE', 'BTC', 'binance', '1', '90000000', 1, '0'),
(235, 'VIBE', 'ETH', 'binance', '1', '90000000', 1, '0'),
(236, 'RLC', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(237, 'RLC', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(238, 'RLC', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(239, 'INS', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(240, 'INS', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(241, 'PIVX', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(242, 'PIVX', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(243, 'PIVX', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(244, 'IOST', 'BTC', 'binance', '1', '90000000', 1, '0'),
(245, 'IOST', 'ETH', 'binance', '1', '90000000', 1, '0'),
(246, 'CHAT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(247, 'CHAT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(248, 'STEEM', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(249, 'STEEM', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(250, 'STEEM', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(251, 'NANO', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(252, 'NANO', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(253, 'NANO', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(254, 'VIA', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(255, 'VIA', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(256, 'VIA', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(257, 'BLZ', 'BTC', 'binance', '1', '90000000', 1, '0'),
(258, 'BLZ', 'ETH', 'binance', '1', '90000000', 1, '0'),
(259, 'BLZ', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(260, 'AE', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(261, 'AE', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(262, 'AE', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(263, 'RPX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(264, 'RPX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(265, 'RPX', 'BNB', 'binance', '1', '90000000', 1, '0'),
(266, 'NCASH', 'BTC', 'binance', '1', '90000000', 1, '0'),
(267, 'NCASH', 'ETH', 'binance', '1', '90000000', 1, '0'),
(268, 'NCASH', 'BNB', 'binance', '1', '90000000', 1, '0'),
(269, 'POA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(270, 'POA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(271, 'POA', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(272, 'ZIL', 'BTC', 'binance', '1', '90000000', 1, '0'),
(273, 'ZIL', 'ETH', 'binance', '1', '90000000', 1, '0'),
(274, 'ZIL', 'BNB', 'binance', '1', '90000000', 1, '0'),
(275, 'ONT', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(276, 'ONT', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(277, 'ONT', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(278, 'STORM', 'BTC', 'binance', '1', '90000000', 1, '0'),
(279, 'STORM', 'ETH', 'binance', '1', '90000000', 1, '0'),
(280, 'STORM', 'BNB', 'binance', '1', '90000000', 1, '0'),
(281, 'QTUM', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(282, 'QTUM', 'USDT', 'binance', '0.001', '10000000', 1, '3'),
(283, 'XEM', 'BTC', 'binance', '1', '90000000', 1, '0'),
(284, 'XEM', 'ETH', 'binance', '1', '90000000', 1, '0'),
(285, 'XEM', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(286, 'WAN', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(287, 'WAN', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(288, 'WAN', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(289, 'WPR', 'BTC', 'binance', '1', '90000000', 1, '0'),
(290, 'WPR', 'ETH', 'binance', '1', '90000000', 1, '0'),
(291, 'QLC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(292, 'QLC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(293, 'SYS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(294, 'SYS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(295, 'SYS', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(296, 'QLC', 'BNB', 'binance', '1', '90000000', 1, '0'),
(297, 'GRS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(298, 'GRS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(299, 'ADA', 'USDT', 'binance', '0.1', '90000000', 1, '1'),
(300, 'ADA', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(301, 'CLOAK', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(302, 'CLOAK', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(303, 'GNT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(304, 'GNT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(305, 'GNT', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(306, 'LOOM', 'BTC', 'binance', '1', '90000000', 1, '0'),
(307, 'LOOM', 'ETH', 'binance', '1', '90000000', 1, '0'),
(308, 'LOOM', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(309, 'XRP', 'USDT', 'binance', '0.1', '90000000', 1, '1'),
(310, 'BCN', 'BTC', 'binance', '1', '90000000', 1, '0'),
(311, 'BCN', 'ETH', 'binance', '1', '90000000', 1, '0'),
(312, 'BCN', 'BNB', 'binance', '1', '90000000', 1, '0'),
(313, 'REP', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(314, 'REP', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(315, 'REP', 'BNB', 'binance', '0.001', '10000000', 1, '3'),
(316, 'TUSD', 'BTC', 'binance', '1', '90000000', 1, '0'),
(317, 'TUSD', 'ETH', 'binance', '1', '90000000', 1, '0'),
(318, 'TUSD', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(319, 'ZEN', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(320, 'ZEN', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(321, 'ZEN', 'BNB', 'binance', '0.001', '10000000', 1, '3'),
(322, 'SKY', 'BTC', 'binance', '0.001', '10000000', 1, '3'),
(323, 'SKY', 'ETH', 'binance', '0.001', '10000000', 1, '3'),
(324, 'SKY', 'BNB', 'binance', '0.001', '10000000', 1, '3'),
(325, 'EOS', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(326, 'EOS', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(327, 'CVC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(328, 'CVC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(329, 'CVC', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(330, 'THETA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(331, 'THETA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(332, 'THETA', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(333, 'XRP', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(334, 'TUSD', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(335, 'IOTA', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(336, 'XLM', 'USDT', 'binance', '0.1', '90000000', 1, '1'),
(337, 'IOTX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(338, 'IOTX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(339, 'QKC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(340, 'QKC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(341, 'AGI', 'BTC', 'binance', '1', '90000000', 1, '0'),
(342, 'AGI', 'ETH', 'binance', '1', '90000000', 1, '0'),
(343, 'AGI', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(344, 'NXS', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(345, 'NXS', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(346, 'NXS', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(347, 'ENJ', 'BNB', 'binance', '1', '90000000', 1, '0'),
(348, 'DATA', 'BTC', 'binance', '1', '90000000', 1, '0'),
(349, 'DATA', 'ETH', 'binance', '1', '90000000', 1, '0'),
(350, 'ONT', 'USDT', 'binance', '0.001', '10000000', 1, '3'),
(351, 'TRX', 'USDT', 'binance', '0.1', '90000000', 1, '1'),
(352, 'ETC', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(353, 'ETC', 'BNB', 'binance', '0.01', '10000000', 1, '2'),
(354, 'ICX', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(355, 'SC', 'BTC', 'binance', '1', '90000000', 1, '0'),
(356, 'SC', 'ETH', 'binance', '1', '90000000', 1, '0'),
(357, 'SC', 'BNB', 'binance', '1', '90000000', 1, '0'),
(358, 'NPXS', 'BTC', 'binance', '1', '90000000', 1, '0'),
(359, 'NPXS', 'ETH', 'binance', '1', '90000000', 1, '0'),
(360, 'VEN', 'USDT', 'binance', '0.01', '10000000', 0, '2'),
(361, 'KEY', 'BTC', 'binance', '1', '90000000', 1, '0'),
(362, 'KEY', 'ETH', 'binance', '1', '90000000', 1, '0'),
(363, 'NAS', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(364, 'NAS', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(365, 'NAS', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(366, 'MFT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(367, 'MFT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(368, 'MFT', 'BNB', 'binance', '1', '90000000', 1, '0'),
(369, 'DENT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(370, 'DENT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(371, 'ARDR', 'BTC', 'binance', '1', '90000000', 1, '0'),
(372, 'ARDR', 'ETH', 'binance', '1', '90000000', 1, '0'),
(373, 'ARDR', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(374, 'NULS', 'USDT', 'binance', '0.01', '10000000', 1, '2'),
(375, 'HOT', 'BTC', 'binance', '1', '90000000', 1, '0'),
(376, 'HOT', 'ETH', 'binance', '1', '90000000', 1, '0'),
(377, 'VET', 'BTC', 'binance', '1', '90000000', 1, '0'),
(378, 'VET', 'ETH', 'binance', '1', '90000000', 1, '0'),
(379, 'VET', 'USDT', 'binance', '0.1', '90000000', 1, '1'),
(380, 'VET', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(381, 'DOCK', 'BTC', 'binance', '1', '90000000', 1, '0'),
(382, 'DOCK', 'ETH', 'binance', '1', '90000000', 1, '0'),
(383, 'POLY', 'BTC', 'binance', '1', '90000000', 1, '0'),
(384, 'POLY', 'BNB', 'binance', '0.1', '90000000', 1, '1'),
(385, 'BCH', 'BTC', 'gdax', '0.01', '200', 1, '8'),
(386, 'BCH', 'USD', 'gdax', '0.01', '350', 1, '8'),
(387, 'BTC', 'EUR', 'gdax', '0.001', '50', 1, '8'),
(388, 'BTC', 'GBP', 'gdax', '0.001', '20', 1, '8'),
(389, 'BTC', 'USD', 'gdax', '0.001', '70', 1, '8'),
(390, 'ETH', 'BTC', 'gdax', '0.01', '600', 1, '8'),
(391, 'ETH', 'EUR', 'gdax', '0.01', '400', 1, '8'),
(392, 'ETH', 'USD', 'gdax', '0.01', '700', 1, '8'),
(393, 'LTC', 'BTC', 'gdax', '0.1', '2000', 1, '8'),
(394, 'LTC', 'EUR', 'gdax', '0.1', '1000', 1, '8'),
(395, 'LTC', 'USD', 'gdax', '0.1', '4000', 1, '8'),
(396, 'BCH', 'EUR', 'gdax', '0.01', '120', 1, '8'),
(397, 'ETC', 'USD', 'gdax', '0.1', '5000', 1, '8'),
(398, 'ETC', 'EUR', 'gdax', '0.1', '5000', 1, '8'),
(399, 'ETC', 'BTC', 'gdax', '0.1', '5000', 1, '8'),
(400, 'BTC', 'USD', 'gemini', '0.001', '0.001', 1, '3'),
(401, 'ETH', 'BTC', 'gemini', '0.001', '0.001', 1, '3'),
(402, 'ETH', 'USD', 'gemini', '0.001', '0.001', 1, '3'),
(403, 'ZEC', 'USD', 'gemini', '0.001', '0.001', 1, '3'),
(404, 'ZEC', 'BTC', 'gemini', '0.001', '0.001', 1, '3'),
(405, 'ZEC', 'ETH', 'gemini', '0.001', '0.001', 1, '3'),
(406, 'BCN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(407, 'BTC', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(408, 'DASH', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(409, 'DOGE', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(410, 'DOGE', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(411, 'DSH', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(412, 'EMC', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(413, 'ETH', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(414, 'FCN', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(415, 'LSK', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(416, 'LTC', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(417, 'LTC', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(418, 'NXT', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(419, 'SBD', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(420, 'SC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(421, 'STEEM', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(422, 'XDN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(423, 'XEM', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(424, 'XMR', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(425, 'ARDR', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(426, 'ZEC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(427, 'WAVES', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(428, 'MAID', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(429, 'AMP', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(430, 'BUS', 'BTC', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(431, 'DGD', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(432, 'ICN', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(433, 'SNGLS', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(434, '1ST', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(435, 'TRST', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(436, 'TIME', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(437, 'GNO', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(438, 'REP', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(439, 'XMR', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(440, 'DASH', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(441, 'ETH', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(442, 'NXT', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(443, 'ZRC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(444, 'BOS', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(445, 'DCT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(446, 'ANT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(447, 'AEON', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(448, 'GUP', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(449, 'PLU', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(450, 'LUN', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(451, 'TAAS', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(452, 'NXC', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(453, 'EDG', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(454, 'RLC', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(455, 'SWT', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(456, 'TKN', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(457, 'WINGS', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(458, 'XAUR', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(459, 'AE', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(460, 'PTOY', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(461, 'ZEC', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(462, 'XEM', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(463, 'BCN', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(464, 'XDN', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(465, 'MAID', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(466, 'ETC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(467, 'ETC', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(468, 'CFI', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(469, 'PLBT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(470, 'BNT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(471, 'FYN', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(472, 'SNM', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(473, 'SNM', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(474, 'SNT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(475, 'CVC', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(476, 'PAY', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(477, 'OAX', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(478, 'OMG', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(479, 'BQX', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(480, 'XTZ', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(481, 'DICE', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(482, 'CFI', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(483, 'PTOY', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(484, '1ST', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(485, 'XAUR', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(486, 'TAAS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(487, 'TIME', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(488, 'DICE', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(489, 'SWT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(490, 'XMR', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(491, 'ETC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(492, 'DASH', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(493, 'ZEC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(494, 'PLU', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(495, 'GNO', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(496, 'XRP', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(497, 'NET', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(498, 'STRAT', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(499, 'STRAT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(500, 'SNC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(501, 'ADX', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(502, 'DAO.CASINO', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(503, 'EOS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(504, 'DENT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(505, 'SAN', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(506, 'EOS', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(507, 'EOS', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(508, 'MNE', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(509, 'MSP', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(510, 'DDF', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(511, 'XTZ', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(512, 'XTZ', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(513, 'UET', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(514, 'MYB', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(515, 'SUR', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(516, 'IXT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(517, 'PLR', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(518, 'TIX', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(519, 'NDC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(520, 'PRO', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(521, 'AVT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(522, 'COSS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(523, 'EVX', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(524, 'DLT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(525, 'BNT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(526, 'BNT', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(527, 'QAU', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(528, 'QAU', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(529, 'MANA', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(530, 'DNT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(531, 'FYP', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(532, 'OPT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(533, 'TNT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(534, 'IFT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(535, 'STX', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(536, 'STX', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(537, 'STX', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(538, 'TNT', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(539, 'TNT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(540, 'BITCLAVE', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(541, 'BITCLAVE', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(542, 'BITCLAVE', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(543, 'BCH', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(544, 'BCH', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(545, 'BCH', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(546, 'ENG', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(547, 'XUC', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(548, 'SNC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(549, 'SNC', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(550, 'OAX', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(551, 'OAX', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(552, 'BAS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(553, 'ZRX', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(554, 'ZRX', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(555, 'ZRX', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(556, 'RVT', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(557, 'ICOS', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(558, 'ICOS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(559, 'ICOS', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(560, 'PPC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(561, 'PPC', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(562, 'QTUM', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(563, 'VERI', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(564, 'VERI', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(565, 'VERI', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(566, 'IGNIS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(567, 'PRG', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(568, 'PRG', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(569, 'PRG', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(570, 'BMC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(571, 'BMC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(572, 'BMC', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(573, 'CND', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(574, 'CND', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(575, 'CND', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(576, 'SKIN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(577, 'MGO', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(578, 'MGO', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(579, 'CDT', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(580, 'CDT', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(581, 'FUN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(582, 'FUN', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(583, 'FUN', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(584, 'HVN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(585, 'HVN', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(586, 'FUEL', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(587, 'FUEL', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(588, 'FUEL', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(589, 'POE', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(590, 'POE', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(591, 'MCAP', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(592, 'AIR', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(593, 'AIR', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(594, 'AIR', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(595, 'AMB', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(596, 'AMB', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(597, 'AMB', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(598, 'NTO', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(599, 'ICO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(600, 'PING', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(601, 'GAME', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(602, 'TKR', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(603, 'HPC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(604, 'PPT', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(605, 'MTH', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(606, 'MTH', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(607, 'WMGO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(608, 'WMGO', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(609, 'LRC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(610, 'LRC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(611, 'ICX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(612, 'ICX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(613, 'NEO', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(614, 'NEO', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(615, 'NEO', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(616, 'CSNO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(617, 'ORME', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(618, 'ICX', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(619, 'PIX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(620, 'PIX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(621, 'IND', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(622, 'KICK', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(623, 'YOYOW', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(624, 'MIPS', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(625, 'CDT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(626, 'XVG', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(627, 'XVG', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(628, 'XVG', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(629, 'DGB', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(630, 'DGB', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(631, 'DGB', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(632, 'DCN', 'BTC', 'hitbtc2', '10000', '0.001', 1, '4'),
(633, 'DCN', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(634, 'DCN', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(635, 'CCT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(636, 'EBET', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(637, 'VIBE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(638, 'VOISE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(639, 'ENJ', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(640, 'ENJ', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(641, 'ENJ', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(642, 'ZSC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(643, 'ZSC', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(644, 'ZSC', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(645, 'ETBS', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(646, 'TRX', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(647, 'TRX', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(648, 'TRX', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(649, 'VEN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(650, 'VEN', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(651, 'VEN', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(652, 'ART', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(653, 'EVX', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(654, 'EVX', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(655, 'QVT', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(656, 'EBTCOLD', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(657, 'EBTCOLD', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(658, 'EBTCOLD', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(659, 'BKB', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(660, 'EXN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(661, 'TGT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(662, 'ATS', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(663, 'BMT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(664, 'BMT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(665, 'SUB', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(666, 'SUB', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(667, 'SUB', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(668, 'WTC', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(669, 'CNX', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(670, 'ATB', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(671, 'ATB', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(672, 'ATB', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(673, 'ODN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(674, 'BTM', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(675, 'BTM', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(676, 'BTM', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(677, 'B2X', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(678, 'B2X', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(679, 'B2X', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(680, 'ATM', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(681, 'ATM', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(682, 'ATM', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(683, 'LIFE', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(684, 'VIB', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(685, 'VIB', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(686, 'VIB', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(687, 'DRT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(688, 'STU', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(689, 'OMG', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(690, 'PAY', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(691, 'COSS', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(692, 'PPT', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(693, 'SNT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(694, 'BTG', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(695, 'BTG', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(696, 'BTG', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(697, 'SMART', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(698, 'SMART', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(699, 'SMART', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(700, 'XUC', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(701, 'XUC', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(702, 'LA', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(703, 'CLD', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(704, 'CLD', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(705, 'CLD', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(706, 'EDO', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(707, 'EDO', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(708, 'EDO', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(709, 'HGT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(710, 'POLL', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(711, 'IXT', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(712, 'ATS', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(713, 'SCL', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(714, 'ATL', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(715, 'EBTC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(716, 'EBTC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(717, 'EBTC', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(718, 'ETP', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(719, 'ETP', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(720, 'ETP', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(721, 'OTX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(722, 'CDX', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(723, 'DRPU', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(724, 'NEBL', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(725, 'NEBL', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(726, 'HAC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(727, 'CTX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(728, 'CTX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(729, 'ELE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(730, 'ARN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(731, 'ARN', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(732, 'STU', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(733, 'STU', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(734, 'GVT', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(735, 'INDI', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(736, 'BTX', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(737, 'LTC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(738, 'BCN', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(739, 'MAID', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(740, 'NXT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(741, 'STRAT', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(742, 'XDN', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(743, 'XEM', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(744, 'PLR', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(745, 'SUR', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(746, 'BQX', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(747, 'DOGE', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(748, 'ITS', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(749, 'AMM', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(750, 'AMM', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(751, 'AMM', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(752, 'DBIX', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(753, 'PRE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(754, 'KBR', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(755, 'TBT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(756, 'ERO', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(757, 'SMS', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(758, 'SMS', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(759, 'SMS', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(760, 'ZAP', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(761, 'DOV', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(762, 'DOV', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(763, 'DRPU', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(764, 'OTN', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(765, 'XRP', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(766, 'XRP', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(767, 'HSR', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(768, 'LEND', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(769, 'LEND', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(770, 'SPF', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(771, 'SPF', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(772, 'SBTC', 'BTC', 'hitbtc2', '0.001', '0.001', 1, '3'),
(773, 'SBTC', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(774, 'WRC', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(775, 'WRC', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(776, 'WRC', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(777, 'LOC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(778, 'LOC', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(779, 'LOC', 'USDT', 'hitbtc2', '0.001', '0.001', 1, '3'),
(780, 'SWFTC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(781, 'SWFTC', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(782, 'SWFTC', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(783, 'STAR', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(784, 'SBTC', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(785, 'STORM', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(786, 'DIM', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(787, 'DIM', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(788, 'DIM', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(789, 'NGC', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(790, 'NGC', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(791, 'NGC', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(792, 'EMC', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(793, 'EMC', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(794, 'MCO', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(795, 'MCO', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(796, 'MCO', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(797, 'MANA', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(798, 'MANA', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(799, 'ECH', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(800, 'CPAY', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(801, 'DATA', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(802, 'DATA', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(803, 'DATA', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(804, 'UTT', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(805, 'UTT', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(806, 'UTT', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(807, 'KMD', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(808, 'KMD', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(809, 'KMD', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(810, 'QTUM', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(811, 'QTUM', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(812, 'SNT', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(813, 'OMG', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(814, 'EKO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(815, 'EKO', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(816, 'ADX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(817, 'ADX', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(818, 'LSK', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(819, 'LSK', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(820, 'PLR', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(821, 'SUR', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(822, 'BQX', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(823, 'DRT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(824, 'REP', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(825, 'REP', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(826, 'TIO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(827, 'TIO', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(828, 'TIO', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(829, 'WAX', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(830, 'WAX', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(831, 'WAX', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(832, 'EET', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(833, 'EET', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(834, 'EET', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(835, 'C20', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(836, 'C20', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(837, 'IDH', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(838, 'IDH', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(839, 'IPL', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(840, 'COV', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(841, 'COV', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(842, 'SENT', 'BTC', 'hitbtc2', '10000', '0.001', 1, '4'),
(843, 'SENT', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(844, 'SENT', 'USDT', 'hitbtc2', '10000', '0.001', 1, '4'),
(845, 'SMT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(846, 'SMT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(847, 'SMT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(848, 'CAS', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(849, 'CAS', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(850, 'CAS', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(851, 'CHAT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(852, 'CHAT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(853, 'CHAT', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(854, 'GRMD', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(855, 'AVH', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(856, 'TRAC', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(857, 'JNT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(858, 'PCL', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(859, 'PCL', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(860, 'CLOUT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(861, 'UTK', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(862, 'UTK', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(863, 'UTK', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(864, 'GNX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(865, 'CHSB', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(866, 'CHSB', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(867, 'AVH', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(868, 'DAY', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(869, 'DAY', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(870, 'DAY', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(871, 'NEU', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(872, 'NEU', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(873, 'NEU', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(874, 'AVH', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(875, 'CLOUT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(876, 'CLOUT', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(877, 'TAU', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(878, 'MEK', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(879, 'FLP', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(880, 'FLP', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(881, 'FLP', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(882, 'R', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(883, 'R', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(884, 'EKO', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(885, 'BCPT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(886, 'BCPT', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(887, 'PKT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(888, 'PKT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(889, 'WLK', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(890, 'WLK', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(891, 'WLK', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(892, 'CPG', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(893, 'CPG', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(894, 'BPTN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(895, 'BPTN', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(896, 'BPTN', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(897, 'BETR', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(898, 'BETR', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(899, 'ARCT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(900, 'ARCT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(901, 'DBET', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(902, 'DBET', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(903, 'DBET', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(904, 'RNTB', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(905, 'HAND', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(906, 'HAND', 'USDT', 'hitbtc2', '10000', '0.001', 1, '4'),
(907, 'ACO', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(908, 'CTE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(909, 'CTE', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(910, 'CTE', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(911, 'CPY', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(912, 'CPY', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(913, 'CHP', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(914, 'BCPT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(915, 'ACT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(916, 'ACT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(917, 'ACT', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(918, 'HIRE', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(919, 'ADA', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(920, 'ADA', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(921, 'ADA', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(922, 'SIG', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(923, 'RPM', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(924, 'RPM', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(925, 'MTX', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(926, 'MTX', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(927, 'MTX', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(928, 'BGG', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(929, 'BGG', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(930, 'BGG', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(931, 'SETH', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(932, 'WIZ', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(933, 'WIZ', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(934, 'WIZ', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(935, 'DADI', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(936, 'DADI', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(937, 'BDG', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(938, 'DATX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(939, 'DATX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(940, 'TRUE', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(941, 'DRG', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(942, 'DRG', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(943, 'BANCA', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(944, 'BANCA', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(945, 'ZAP', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(946, 'ZAP', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(947, 'AUTO', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(948, 'NOAH', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(949, 'SOC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(950, 'WILD', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(951, 'INSUR', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(952, 'INSUR', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(953, 'OCN', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(954, 'OCN', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(955, 'STQ', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(956, 'STQ', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(957, 'XLM', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(958, 'XLM', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(959, 'XLM', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(960, 'IOTA', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(961, 'IOTA', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(962, 'IOTA', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(963, 'DRT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(964, 'MLD', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(965, 'MLD', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(966, 'MLD', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(967, 'BETR', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(968, 'CGC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(969, 'CRPT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(970, 'CRPT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(971, 'MESH', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(972, 'MESH', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(973, 'MESH', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(974, 'HLW', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(975, 'IHT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(976, 'IHT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(977, 'IHT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(978, 'SCC', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(979, 'YCC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(980, 'DAN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(981, 'TEL', 'BTC', 'hitbtc2', '10000', '0.001', 1, '4'),
(982, 'TEL', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(983, 'BUBO', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(984, 'BUBO', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(985, 'BUBO', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(986, 'VIT', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(987, 'VIT', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(988, 'VIT', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(989, 'NCT', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(990, 'NCT', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(991, 'NCT', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(992, 'AXP', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(993, 'AXP', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(994, 'BMH', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(995, 'BANCA', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(996, 'NOAH', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(997, 'NOAH', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(998, 'HQX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(999, 'LDC', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1000, 'XMO', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1001, 'XMO', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1002, 'XMO', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1003, 'BERRY', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1004, 'BERRY', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1005, 'BERRY', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1006, 'BSTN', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1007, 'BSTN', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1008, 'BSTN', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1009, 'GBX', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1010, 'GBX', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1011, 'GBX', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1012, 'SHIP', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1013, 'SHIP', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1014, 'NANO', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1015, 'NANO', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1016, 'NANO', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1017, 'LINKERCOIN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1018, 'UNIGAME', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1019, 'UNIGAME', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1020, 'RPX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1021, 'RPX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1022, 'RPX', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1023, 'KIN', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(1024, 'ARDR', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1025, 'DAXT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1026, 'DAXT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1027, 'FOTA', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1028, 'FOTA', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1029, 'SETH', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1030, 'CVT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1031, 'CVT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1032, 'CVT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1033, 'STQ', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1034, 'GNT', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1035, 'GNT', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1036, 'GNT', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1037, 'ADH', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1038, 'ADH', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1039, 'BBC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1040, 'BBC', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1041, 'THEMIS', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1042, 'MITH', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1043, 'MITH', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1044, 'MITH', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1045, 'SUNC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1046, 'DADI', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1047, 'TKY', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1048, 'ACAT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1049, 'ACAT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1050, 'ACAT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1051, 'BTX', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1052, 'TCN', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1053, 'VIO', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1054, 'WIKI', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1055, 'WIKI', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1056, 'WIKI', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1057, 'ONT', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(1058, 'ONT', 'ETH', 'hitbtc2', '0.1', '0.001', 1, '1'),
(1059, 'ONT', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(1060, 'CVCOIN', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1061, 'CVCOIN', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1062, 'CVCOIN', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1063, 'FTX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1064, 'FTX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1065, 'FREC', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1066, 'NAVI', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1067, 'FREC', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1068, 'FREC', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1069, 'VME', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1070, 'NAVI', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1071, 'BTCP', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(1072, 'LND', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1073, 'CSM', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1074, 'NANJ', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1075, 'NTK', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1076, 'NTK', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1077, 'NTK', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1078, 'AUC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1079, 'AUC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1080, 'CMCT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1081, 'CMCT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1082, 'CMCT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1083, 'MAN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1084, 'MAN', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1085, 'MAN', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1086, 'HIRE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1087, 'TKA', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1088, 'TKA', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1089, 'TKA', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1090, 'PNT', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1091, 'PNT', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1092, 'FXT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1093, 'NEXO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1094, 'CHX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1095, 'CHX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1096, 'CHX', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1097, 'PAT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1098, 'PAT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1099, 'XMC', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1100, 'EJOY', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1101, 'EJOY', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1102, 'EJOY', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1103, 'FXT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1104, 'HERO', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1105, 'HERO', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1106, 'XMC', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1107, 'XMC', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1108, 'STAK', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1109, 'STAK', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1110, 'FDZ', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1111, 'FDZ', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1112, 'FDZ', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1113, 'SPD', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1114, 'SPD', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1115, 'LUC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1116, 'MITX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1117, 'TIV', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1118, 'B2G', 'BTC', 'hitbtc2', '0.1', '0.001', 1, '1'),
(1119, 'B2G', 'USDT', 'hitbtc2', '0.1', '0.001', 1, '1'),
(1120, 'ZPT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1121, 'ZPT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1122, 'HBZ', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1123, 'FACE', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1124, 'FACE', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1125, 'HBZ', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1126, 'HBZ', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1127, 'ZPT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1128, 'MORPH', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1129, 'MORPH', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1130, 'MORPH', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1131, 'EBKC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1132, 'CPT', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1133, 'PAT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1134, 'HTML', 'BTC', 'hitbtc2', '10000', '0.001', 1, '4'),
(1135, 'HTML', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(1136, 'MITX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1137, 'JOT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1138, 'JBC', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1139, 'JBC', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1140, 'BTS', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1141, 'BNK', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1142, 'KBC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1143, 'KBC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1144, 'BNK', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1145, 'BNK', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1146, 'TIV', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1147, 'TIV', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1148, 'LUC', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1149, 'LUC', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1150, 'CSM', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1151, 'CSM', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1152, 'INK', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1153, 'SPC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1154, 'IOST', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1155, 'INK', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1156, 'INK', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1157, 'SPC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1158, 'SPC', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1159, 'CBC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1160, 'IOST', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1161, 'COIN', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1162, 'ZIL', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1163, 'COIN', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1164, 'COIN', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1165, 'PMNT', 'BTC', 'hitbtc2', '10000', '0.001', 1, '4'),
(1166, 'ABYSS', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1167, 'ABYSS', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1168, 'ZIL', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1169, 'BCI', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1170, 'CBC', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1171, 'CBC', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1172, 'PITCH', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1173, 'PITCH', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1174, 'HTML', 'USDT', 'hitbtc2', '10000', '0.001', 1, '4'),
(1175, 'TDS', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1176, 'TDS', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1177, 'TDS', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1178, 'SBD', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1179, 'SBD', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1180, 'DPN', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1181, 'UUU', 'BTC', 'hitbtc2', '10000', '0.001', 1, '4'),
(1182, 'UUU', 'ETH', 'hitbtc2', '10000', '0.001', 1, '4'),
(1183, 'XBP', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1184, 'KRM', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1185, 'CLN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1186, 'IVY', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1187, 'IVY', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1188, 'TTU', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1189, 'TTU', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1190, 'TTU', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1191, 'CLN', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1192, 'DOR', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1193, 'DOR', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1194, 'DOR', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1195, 'ELEC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1196, 'ELEC', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1197, 'ELEC', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1198, 'QNTU', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1199, 'QNTU', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1200, 'QNTU', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1201, 'IPL', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1202, 'IPL', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1203, 'CENNZ', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1204, 'BTCP', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1205, 'BTCP', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1206, 'CENNZ', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1207, 'SWM', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1208, 'MXM', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1209, 'MXM', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1210, 'SPF', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1211, 'LCC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1212, 'HGT', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1213, 'BTC', 'DAI', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1214, 'ETH', 'DAI', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1215, 'MKR', 'DAI', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1216, 'EOS', 'DAI', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1217, 'USDT', 'DAI', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1218, 'ETH', 'TUSD', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1219, 'BTC', 'TUSD', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1220, 'LTC', 'TUSD', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1221, 'XMR', 'TUSD', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1222, 'ZRX', 'TUSD', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1223, 'NEO', 'TUSD', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1224, 'BCH', 'TUSD', 'hitbtc2', '0.001', '0.001', 1, '3'),
(1225, 'USDT', 'TUSD', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1226, 'MKR', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1227, 'MKR', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1228, 'MKR', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1229, 'TUSD', 'DAI', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1230, 'NEO', 'DAI', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1231, 'LTC', 'DAI', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1232, 'XMR', 'DAI', 'hitbtc2', '0.001', '0.001', 1, '3'),
(1233, 'BCH', 'DAI', 'hitbtc2', '0.001', '0.001', 1, '3'),
(1234, 'XRP', 'DAI', 'hitbtc2', '1', '0.001', 1, '0'),
(1235, 'NEXO', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1236, 'NEXO', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1237, 'DWS', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1238, 'DWS', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1239, 'DWS', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1240, 'APPC', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1241, 'APPC', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1242, 'APPC', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1243, 'BIT', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1244, 'DASH', 'EURS', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1245, 'ZEC', 'EURS', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1246, 'BTC', 'EURS', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1247, 'EOS', 'EURS', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1248, 'ETH', 'EURS', 'hitbtc2', '0.0001', '0.001', 1, '4'),
(1249, 'LTC', 'EURS', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1250, 'BCH', 'EURS', 'hitbtc2', '0.001', '0.001', 1, '3'),
(1251, 'NEO', 'EURS', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1252, 'XMR', 'EURS', 'hitbtc2', '0.001', '0.001', 1, '3'),
(1253, 'XRP', 'EURS', 'hitbtc2', '1', '0.001', 1, '0'),
(1254, 'REX', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1255, 'REX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1256, 'REX', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(1257, 'BCD', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1258, 'ELF', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1259, 'ELF', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1260, 'BCD', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1261, 'HQX', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1262, 'HQX', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1263, 'EBKC', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1264, 'EBKC', 'USDT', 'hitbtc2', '1000', '0.001', 1, '3'),
(1265, 'EDG', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1266, 'EDG', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(1267, 'COSM', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(1268, 'COSM', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1269, 'DCNT', 'BTC', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1270, 'DCNT', 'ETH', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1271, 'DCNT', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1272, 'EURS', 'USDT', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1273, 'EURS', 'TUSD', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1274, 'EURS', 'DAI', 'hitbtc2', '0.01', '0.001', 1, '2'),
(1275, 'MNX', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1276, 'ROX', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(1277, 'ZPR', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1278, 'MNX', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1279, 'MNX', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1280, 'KIND', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(1281, 'KIND', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(1282, 'ENGT', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1283, 'ENGT', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1284, 'PMA', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(1285, 'PMA', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(1286, 'TV', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(1287, 'TV', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(1288, 'TV', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(1289, 'BCH', 'EUR', 'kraken', '0.002', '100000000', 1, '8'),
(1290, 'BCH', 'USD', 'kraken', '0.002', '100000000', 1, '8'),
(1291, 'BCH', 'BTC', 'kraken', '0.002', '100000000', 1, '8'),
(1292, 'DASH', 'EUR', 'kraken', '0.03', '100000000', 1, '8'),
(1293, 'DASH', 'USD', 'kraken', '0.03', '100000000', 1, '8'),
(1294, 'DASH', 'BTC', 'kraken', '0.03', '100000000', 1, '8'),
(1295, 'EOS', 'ETH', 'kraken', '3', '100000000', 1, '8'),
(1296, 'EOS', 'EUR', 'kraken', '3', '100000000', 1, '8'),
(1297, 'EOS', 'USD', 'kraken', '3', '100000000', 1, '8'),
(1298, 'EOS', 'BTC', 'kraken', '3', '100000000', 1, '8'),
(1299, 'GNO', 'ETH', 'kraken', '0.03', '100000000', 1, '8'),
(1300, 'GNO', 'EUR', 'kraken', '0.03', '100000000', 1, '8'),
(1301, 'GNO', 'USD', 'kraken', '0.03', '100000000', 1, '8'),
(1302, 'GNO', 'BTC', 'kraken', '0.03', '100000000', 1, '8'),
(1303, 'USDT', 'USD', 'kraken', '5', '100000000', 1, '8'),
(1304, 'ETC', 'ETH', 'kraken', '0.3', '100000000', 1, '8'),
(1305, 'ETC', 'BTC', 'kraken', '0.3', '100000000', 1, '8'),
(1306, 'ETC', 'EUR', 'kraken', '0.3', '100000000', 1, '8'),
(1307, 'ETC', 'USD', 'kraken', '0.3', '100000000', 1, '8'),
(1308, 'ETH', 'BTC', 'kraken', '0.02', '100000000', 1, '8'),
(1310, 'ETH', 'CAD', 'kraken', '0.02', '100000000', 1, '8'),
(1312, 'ETH', 'EUR', 'kraken', '0.02', '100000000', 1, '8'),
(1314, 'ETH', 'GBP', 'kraken', '0.02', '100000000', 1, '8'),
(1316, 'ETH', 'JPY', 'kraken', '0.02', '100000000', 1, '8'),
(1318, 'ETH', 'USD', 'kraken', '0.02', '100000000', 1, '8'),
(1320, 'ICN', 'ETH', 'kraken', '2', '100000000', 1, '8'),
(1321, 'ICN', 'BTC', 'kraken', '2', '100000000', 1, '8'),
(1322, 'LTC', 'BTC', 'kraken', '0.1', '100000000', 1, '8'),
(1323, 'LTC', 'EUR', 'kraken', '0.1', '100000000', 1, '8'),
(1324, 'LTC', 'USD', 'kraken', '0.1', '100000000', 1, '8'),
(1325, 'MLN', 'ETH', 'kraken', '0.1', '100000000', 1, '8'),
(1326, 'MLN', 'BTC', 'kraken', '0.1', '100000000', 1, '8'),
(1327, 'REP', 'ETH', 'kraken', '0.3', '100000000', 1, '8'),
(1328, 'REP', 'BTC', 'kraken', '0.3', '100000000', 1, '8'),
(1329, 'REP', 'EUR', 'kraken', '0.3', '100000000', 1, '8'),
(1330, 'REP', 'USD', 'kraken', '0.3', '100000000', 1, '8'),
(1331, 'BTC', 'CAD', 'kraken', '1.0E-8', '100000000', 1, '8'),
(1333, 'BTC', 'EUR', 'kraken', '1.0E-8', '100000000', 1, '8'),
(1335, 'BTC', 'GBP', 'kraken', '1.0E-8', '100000000', 1, '8'),
(1337, 'BTC', 'JPY', 'kraken', '1.0E-8', '100000000', 1, '8'),
(1339, 'BTC', 'USD', 'kraken', '1.0E-8', '100000000', 1, '8'),
(1341, 'XDG', 'BTC', 'kraken', '1.0E-8', '100000000', 1, '8'),
(1342, 'XLM', 'BTC', 'kraken', '30', '100000000', 1, '8'),
(1343, 'XLM', 'EUR', 'kraken', '30', '100000000', 1, '8'),
(1344, 'XLM', 'USD', 'kraken', '30', '100000000', 1, '8'),
(1345, 'XMR', 'BTC', 'kraken', '0.1', '100000000', 1, '8'),
(1346, 'XMR', 'EUR', 'kraken', '0.1', '100000000', 1, '8'),
(1347, 'XMR', 'USD', 'kraken', '0.1', '100000000', 1, '8'),
(1348, 'XRP', 'BTC', 'kraken', '30', '100000000', 1, '8'),
(1349, 'XRP', 'CAD', 'kraken', '30', '100000000', 1, '8'),
(1350, 'XRP', 'EUR', 'kraken', '30', '100000000', 1, '8'),
(1351, 'XRP', 'JPY', 'kraken', '30', '100000000', 1, '8'),
(1352, 'XRP', 'USD', 'kraken', '30', '100000000', 1, '8'),
(1353, 'ZEC', 'BTC', 'kraken', '0.03', '100000000', 1, '8'),
(1354, 'ZEC', 'EUR', 'kraken', '0.03', '100000000', 1, '8'),
(1355, 'ZEC', 'JPY', 'kraken', '0.03', '100000000', 1, '8'),
(1356, 'ZEC', 'USD', 'kraken', '0.03', '100000000', 1, '8'),
(1357, 'ETH', 'BTC', 'kucoin', '1.0E-5', '0.001', 1, '8'),
(1358, 'BTC', 'USDT', 'kucoin', '1.0E-5', '0.001', 1, '8'),
(1359, 'ETH', 'USDT', 'kucoin', '1.0E-5', '0.001', 1, '8'),
(1360, 'BCH', 'USDT', 'kucoin', '1.0E-5', '0.001', 1, '8'),
(1361, 'GAS', 'NEO', 'kucoin', '0.1', '0.001', 1, '8'),
(1362, 'NEO', 'KCS', 'kucoin', '0.01', '0.001', 1, '8'),
(1363, 'NEO', 'USDT', 'kucoin', '0.01', '0.001', 1, '8'),
(1364, 'NEO', 'BTC', 'kucoin', '0.01', '0.001', 1, '8'),
(1365, 'NEO', 'ETH', 'kucoin', '0.01', '0.001', 1, '8'),
(1366, 'VET', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1367, 'VET', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1368, 'KCS', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1369, 'KCS', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1370, 'KCS', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1371, 'TMT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1372, 'TMT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1373, 'OLT', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1374, 'OLT', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1375, 'TFD', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1376, 'TFD', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1377, 'ZINC', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1378, 'ZINC', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1379, 'CBC', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1380, 'CBC', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1381, 'CPC', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1382, 'CPC', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1383, 'DAG', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1384, 'DAG', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1385, 'DCC', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1386, 'DCC', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1387, 'EDR', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1388, 'EDR', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1389, 'EGT', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1390, 'EGT', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1391, 'ELA', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1392, 'ELA', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1393, 'XLM', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1394, 'XLM', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1395, 'LALA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1396, 'LALA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1397, 'NUSD', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1398, 'NUSD', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1399, 'NUSD', 'USDT', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1400, 'CS', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1401, 'CS', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1402, 'AOA', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1403, 'AOA', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1404, 'CS', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1405, 'ETN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1406, 'ETN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1407, 'IHT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1408, 'IHT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1409, 'WAN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1410, 'WAN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1411, 'DACC', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1412, 'DACC', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1413, 'DOCK', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1414, 'DOCK', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1415, 'KICK', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1416, 'KICK', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1417, 'GO', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1418, 'GO', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1419, 'APH', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1420, 'APH', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1421, 'BAX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1422, 'BAX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1423, 'DEB', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1424, 'DEB', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1425, 'LYM', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1426, 'LYM', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1427, 'OMX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1428, 'OMX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1429, 'ONT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1430, 'ONT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1431, 'QKC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1432, 'QKC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1433, 'SHL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1434, 'SHL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1435, 'SRN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1436, 'SRN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1437, 'ACT', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1438, 'DATX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1439, 'DATX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1440, 'ELEC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1441, 'ELEC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1442, 'IOTX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1443, 'IOTX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1444, 'LOOM', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1445, 'LOOM', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1446, 'MOBI', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1447, 'MOBI', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1448, 'OPEN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1449, 'OPEN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1450, 'SOUL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1451, 'SOUL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1452, 'SOUL', 'NEO', 'kucoin', '1', '0.001', 1, '8'),
(1453, 'TKY', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1454, 'TOMO', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1455, 'TOMO', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1456, 'TRAC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1457, 'TRAC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1458, 'SPHTX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1459, 'SPHTX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1460, 'COV', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1461, 'COV', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1462, 'ELF', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1463, 'ELF', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1464, 'LTC', 'KCS', 'kucoin', '1', '0.001', 1, '8'),
(1465, 'MAN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1466, 'MAN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1467, 'PRL', 'KCS', 'kucoin', '1', '0.001', 1, '8'),
(1468, 'STK', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1469, 'STK', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1470, 'TKY', 'KCS', 'kucoin', '1', '0.001', 1, '8'),
(1471, 'ZIL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1472, 'ZIL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1473, 'ZPT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1474, 'ZPT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1475, 'DADI', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1476, 'DADI', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1477, 'PRL', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1478, 'BPT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1479, 'BPT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1480, 'TKY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1481, 'TKY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1482, 'TKY', 'NEO', 'kucoin', '1', '0.001', 1, '8'),
(1483, 'TNC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1484, 'TNC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1485, 'TNC', 'NEO', 'kucoin', '1', '0.001', 1, '8'),
(1486, 'CAPP', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1487, 'CAPP', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1488, 'NANO', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1489, 'NANO', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1490, 'POLY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1491, 'POLY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1492, 'NANO', 'USDT', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1493, 'CS', 'KCS', 'kucoin', '1', '0.001', 1, '8'),
(1494, 'CXO', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1495, 'CXO', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1496, 'DTA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1497, 'DTA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1498, 'ING', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1499, 'ING', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1500, 'MTN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1501, 'MTN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1502, 'OCN', 'BTC', 'kucoin', '10', '0.001', 1, '8'),
(1503, 'OCN', 'ETH', 'kucoin', '10', '0.001', 1, '8'),
(1504, 'SNC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1505, 'SNC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1506, 'TEL', 'BTC', 'kucoin', '10', '0.001', 1, '8'),
(1507, 'TEL', 'ETH', 'kucoin', '10', '0.001', 1, '8'),
(1508, 'WAX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1509, 'WAX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1510, 'COFI', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1511, 'COFI', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1512, 'DRGN', 'KCS', 'kucoin', '1', '0.001', 1, '8'),
(1513, 'PARETO', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1514, 'PARETO', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1515, 'ADB', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1516, 'ADB', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1517, 'BOS', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1518, 'BOS', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1519, 'HKN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1520, 'HKN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1521, 'HPB', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1522, 'HPB', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1523, 'IOST', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1524, 'IOST', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1525, 'ARY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1526, 'ARY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1527, 'DBC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1528, 'DBC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1529, 'KEY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1530, 'KEY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1531, 'GAT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1532, 'GAT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1533, 'RPX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1534, 'RPX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1535, 'R', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1536, 'R', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1537, 'CV', 'BTC', 'kucoin', '10', '0.001', 1, '8'),
(1538, 'CV', 'ETH', 'kucoin', '10', '0.001', 1, '8'),
(1539, 'LTC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1540, 'LTC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1541, 'QLC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1542, 'QLC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1543, 'TIO', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1544, 'TIO', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1545, 'ACAT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1546, 'ACAT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1547, 'DRGN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1548, 'DRGN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1549, 'DRGN', 'NEO', 'kucoin', '1', '0.001', 1, '8'),
(1550, 'LTC', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1551, 'DRGN', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1552, 'ITC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1553, 'ITC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1554, 'AGI', 'ETH', 'kucoin', '10', '0.001', 1, '8'),
(1555, 'EXY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1556, 'EXY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1557, 'MWAT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1558, 'MWAT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1559, 'AGI', 'BTC', 'kucoin', '10', '0.001', 1, '8'),
(1560, 'J8T', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1561, 'J8T', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1562, 'DENT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1563, 'DENT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1564, 'DENT', 'NEO', 'kucoin', '1', '0.001', 1, '8'),
(1565, 'LOCI', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1566, 'LOCI', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1567, 'LOOM', 'NEO', 'kucoin', '1', '0.001', 1, '8'),
(1568, 'OCN', 'USDT', 'kucoin', '10', '0.001', 1, '8'),
(1569, 'DENT', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1570, 'LOOM', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1571, 'CAT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1572, 'CAT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1573, 'ACT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1574, 'ACT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1575, 'ARN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1576, 'ARN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1577, 'BCH', 'BTC', 'kucoin', '1.0E-5', '0.001', 1, '8'),
(1578, 'BCH', 'ETH', 'kucoin', '1.0E-5', '0.001', 1, '8'),
(1579, 'CANYA', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1580, 'CANYA', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1581, 'EOS', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1582, 'EOS', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1583, 'EOS', 'NEO', 'kucoin', '0.1', '0.001', 1, '8'),
(1584, 'ETC', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1585, 'ETC', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1586, 'ETC', 'KCS', 'kucoin', '0.1', '0.001', 1, '8'),
(1587, 'GAS', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1588, 'GAS', 'KCS', 'kucoin', '0.1', '0.001', 1, '8'),
(1589, 'JNT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1590, 'JNT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1591, 'AXPR', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1592, 'AXPR', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(1593, 'EOS', 'USDT', 'kucoin', '0.1', '0.001', 1, '8'),
(1594, 'PLAY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1595, 'PLAY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1596, 'CHP', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1597, 'CHP', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1598, 'DNA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1599, 'DNA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1600, 'PRL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1601, 'PRL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1602, 'UTK', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1603, 'UTK', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1604, 'DASH', 'BTC', 'kucoin', '0.01', '0.001', 1, '8'),
(1605, 'DASH', 'ETH', 'kucoin', '0.01', '0.001', 1, '8'),
(1606, 'EBTC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1607, 'EBTC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1608, 'FOTA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1609, 'FOTA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1610, 'PURA', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1611, 'PURA', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1612, 'CAG', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1613, 'CAG', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1614, 'GLA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1615, 'GLA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1616, 'HAV', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1617, 'HAV', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1618, 'SPF', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1619, 'SPF', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1620, 'HAV', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(1621, 'TIME', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1622, 'TIME', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1623, 'ABT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1624, 'ABT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1625, 'ENJ', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1626, 'ENJ', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1627, 'BNTY', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1628, 'BNTY', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1629, 'ELIX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1630, 'ELIX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1631, 'AIX', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1632, 'AIX', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1633, 'DAT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1634, 'DAT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1635, 'WTC', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1636, 'AION', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1637, 'AION', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1638, 'QTUM', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1639, 'DGB', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1640, 'DGB', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1641, 'SNOV', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1642, 'SNOV', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1643, 'BRD', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1644, 'BRD', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1645, 'AMB', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1646, 'AMB', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1647, 'BTM', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1648, 'BTM', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1649, 'XLR', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1650, 'XLR', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1651, 'MANA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1652, 'MANA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1653, 'RHOC', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1654, 'RHOC', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1655, 'XAS', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1656, 'XAS', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1657, 'UKG', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1658, 'UKG', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1659, 'CHSB', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1660, 'CHSB', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1661, 'POLL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1662, 'POLL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1663, 'INS', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1664, 'INS', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1665, 'OMG', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1666, 'OMG', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1667, 'TFL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1668, 'TFL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1669, 'WPR', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1670, 'WPR', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1671, 'FLIXX', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1672, 'FLIXX', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1673, 'LEND', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1674, 'LEND', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1675, 'KNC', 'BTC', 'kucoin', '0.001', '0.001', 1, '8'),
(1676, 'KNC', 'ETH', 'kucoin', '0.001', '0.001', 1, '8'),
(1677, 'LA', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1678, 'LA', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1679, 'BCD', 'BTC', 'kucoin', '0.001', '0.001', 1, '8'),
(1680, 'BCD', 'ETH', 'kucoin', '0.001', '0.001', 1, '8'),
(1681, 'SNM', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1682, 'SNM', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1683, 'POWR', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1684, 'POWR', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1685, 'ONION', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1686, 'ONION', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1687, 'BTG', 'BTC', 'kucoin', '0.001', '0.001', 1, '8'),
(1688, 'BTG', 'ETH', 'kucoin', '0.001', '0.001', 1, '8'),
(1689, 'HSR', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1690, 'HSR', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1691, 'PBL', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1692, 'PBL', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1693, 'MOD', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1694, 'MOD', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1695, 'PPT', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1696, 'PPT', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1697, 'GVT', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1698, 'GVT', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1699, 'HST', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1700, 'HST', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1701, 'SNT', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1702, 'SNT', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1703, 'SUB', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1704, 'SUB', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1705, 'BCPT', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1706, 'BCPT', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1707, 'NEBL', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1708, 'NEBL', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1709, 'CVC', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1710, 'CVC', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1711, 'MTH', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1712, 'MTH', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1713, 'NULS', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1714, 'NULS', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1715, 'PAY', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1716, 'PAY', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1717, 'RDN', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1718, 'RDN', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1719, 'REQ', 'BTC', 'kucoin', '1', '0.001', 1, '8'),
(1720, 'REQ', 'ETH', 'kucoin', '1', '0.001', 1, '8'),
(1721, 'QSP', 'BTC', 'kucoin', '0.1', '0.001', 1, '8'),
(1722, 'QSP', 'ETH', 'kucoin', '0.1', '0.001', 1, '8'),
(1723, 'BCN', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1724, 'BTCD', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1725, 'BITMARK', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1726, 'BTS', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1727, 'BURST', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1728, 'CLAM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1729, 'DASH', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1730, 'DGB', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1731, 'DOGE', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1732, 'EMC2', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1733, 'GAME', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1734, 'GRC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1735, 'HUC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1736, 'LTC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1737, 'MAID', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1738, 'OMNI', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1739, 'NAV', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1740, 'NEOS', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1741, 'NMC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1742, 'NXT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1743, 'POT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1744, 'PPC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1745, 'XLM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1746, 'SYS', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1747, 'VIA', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1748, 'VRC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1749, 'VTC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1750, 'XBC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1751, 'XCP', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1752, 'XEM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1753, 'XMR', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1754, 'XPM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1755, 'XRP', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1756, 'BTC', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1757, 'DASH', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1758, 'LTC', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1759, 'NXT', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1760, 'XLM', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1761, 'XMR', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1762, 'XRP', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1763, 'BCN', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1764, 'BTCD', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1765, 'DASH', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1766, 'LTC', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1767, 'MAID', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1768, 'NXT', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1769, 'ETH', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1770, 'ETH', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1771, 'SC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1772, 'EXP', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1773, 'FCT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1774, 'AMP', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1775, 'DCR', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1776, 'LSK', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1777, 'LSK', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1778, 'LBC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1779, 'STEEM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1780, 'STEEM', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1781, 'SBD', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1782, 'ETC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1783, 'ETC', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1784, 'ETC', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1785, 'REP', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1786, 'REP', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1787, 'REP', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1788, 'ARDR', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1789, 'ZEC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1790, 'ZEC', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1791, 'ZEC', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1792, 'ZEC', 'XMR', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1793, 'STRAT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1794, 'PASC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1795, 'GNT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1796, 'GNT', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1797, 'GNO', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1798, 'GNO', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1799, 'BCH', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1800, 'BCH', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1801, 'BCH', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1802, 'ZRX', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1803, 'ZRX', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1804, 'CVC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(1805, 'CVC', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1806, 'OMG', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1807, 'OMG', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1808, 'GAS', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1809, 'GAS', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1810, 'STORJ', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1811, 'EOS', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1812, 'EOS', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1813, 'EOS', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(1814, '2GIVE', 'BTC', 'bittrex', '221.23893805', '0.001', 1, '8'),
(1815, 'ABY', 'BTC', 'bittrex', '233.64485981', '0.001', 1, '8'),
(1816, 'ADA', 'BTC', 'bittrex', '7.82962731', '0.001', 1, '8'),
(1817, 'ADT', 'BTC', 'bittrex', '33.60215054', '0.001', 1, '8'),
(1818, 'ADX', 'BTC', 'bittrex', '2.19029262', '0.001', 1, '8'),
(1819, 'AEON', 'BTC', 'bittrex', '1.03919857', '0.001', 1, '8'),
(1820, 'AID', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1821, 'AMP', 'BTC', 'bittrex', '7.10227273', '0.001', 1, '8'),
(1822, 'ANT', 'BTC', 'bittrex', '0.54221702', '0.001', 1, '8'),
(1823, 'ARDR', 'BTC', 'bittrex', '5.62556256', '0.001', 1, '8'),
(1824, 'ARK', 'BTC', 'bittrex', '0.65189048', '0.001', 1, '8'),
(1825, 'AUR', 'BTC', 'bittrex', '1.55811779', '0.001', 1, '8'),
(1826, 'BAT', 'BTC', 'bittrex', '5.08233381', '0.001', 1, '8'),
(1827, 'BAY', 'BTC', 'bittrex', '30.26634383', '0.001', 1, '8'),
(1828, 'BCH', 'BTC', 'bittrex', '0.0015704', '0.001', 1, '8'),
(1829, 'BCPT', 'BTC', 'bittrex', '3.77757631', '0.001', 1, '8'),
(1830, 'BCY', 'BTC', 'bittrex', '5.36711035', '0.001', 1, '8'),
(1831, 'BITB', 'BTC', 'bittrex', '206.61157025', '0.001', 1, '8'),
(1832, 'SWIFT', 'BTC', 'bittrex', '2.41662639', '0.001', 1, '8'),
(1833, 'BKX', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1834, 'BLK', 'BTC', 'bittrex', '7.20046083', '0.001', 1, '8'),
(1835, 'BLOCK', 'BTC', 'bittrex', '0.11052215', '0.001', 1, '8'),
(1836, 'BLT', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1837, 'BNT', 'BTC', 'bittrex', '0.51444563', '0.001', 1, '8'),
(1838, 'BRK', 'BTC', 'bittrex', '8.26446281', '0.001', 1, '8'),
(1839, 'BRX', 'BTC', 'bittrex', '1.76978621', '0.001', 1, '8'),
(1840, 'BSD', 'BTC', 'bittrex', '2.76548673', '0.001', 1, '8'),
(1841, 'BTG', 'BTC', 'bittrex', '0.02793293', '0.001', 1, '8'),
(1842, 'BURST', 'BTC', 'bittrex', '86.20689655', '0.001', 1, '8'),
(1843, 'BYC', 'BTC', 'bittrex', '3.65070093', '0.001', 1, '8'),
(1844, 'CANN', 'BTC', 'bittrex', '32.46753247', '0.001', 1, '8'),
(1845, 'CBC', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1846, 'CFI', 'BTC', 'bittrex', '20.49180328', '0.001', 1, '8'),
(1847, 'CLAM', 'BTC', 'bittrex', '0.48923679', '0.001', 1, '8'),
(1848, 'CLOAK', 'BTC', 'bittrex', '0.15339117', '0.001', 1, '8'),
(1849, 'CMCT', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1850, 'COVAL', 'BTC', 'bittrex', '233.64485981', '0.001', 1, '8'),
(1851, 'CRB', 'BTC', 'bittrex', '8.18866689', '0.001', 1, '8'),
(1852, 'CRW', 'BTC', 'bittrex', '1.35596898', '0.001', 1, '8'),
(1853, 'CURE', 'BTC', 'bittrex', '5.70645971', '0.001', 1, '8'),
(1854, 'CVC', 'BTC', 'bittrex', '5.40540541', '0.001', 1, '8'),
(1855, 'DASH', 'BTC', 'bittrex', '0.00437054', '0.001', 1, '8'),
(1856, 'DCR', 'BTC', 'bittrex', '0.03381646', '0.001', 1, '8'),
(1857, 'DCT', 'BTC', 'bittrex', '2.53369819', '0.001', 1, '8'),
(1858, 'DGB', 'BTC', 'bittrex', '63.29113924', '0.001', 1, '8'),
(1859, 'DMD', 'BTC', 'bittrex', '0.25208728', '0.001', 1, '8'),
(1860, 'DMT', 'BTC', 'bittrex', '3.60854503', '0.001', 1, '8'),
(1861, 'DNT', 'BTC', 'bittrex', '21.15059222', '0.001', 1, '8'),
(1862, 'DOGE', 'BTC', 'bittrex', '396.82539683', '0.001', 1, '8'),
(1863, 'DOPE', 'BTC', 'bittrex', '33.6473755', '0.001', 1, '8'),
(1864, 'DTB', 'BTC', 'bittrex', '3.25182102', '0.001', 1, '8'),
(1865, 'DYN', 'BTC', 'bittrex', '0.98386462', '0.001', 1, '8'),
(1866, 'EBST', 'BTC', 'bittrex', '4.28522455', '0.001', 1, '8'),
(1867, 'EDG', 'BTC', 'bittrex', '3.13479624', '0.001', 1, '8'),
(1868, 'EFL', 'BTC', 'bittrex', '11.60631383', '0.001', 1, '8'),
(1869, 'EGC', 'BTC', 'bittrex', '7.45823389', '0.001', 1, '8'),
(1870, 'EMC', 'BTC', 'bittrex', '0.65269039', '0.001', 1, '8'),
(1871, 'EMC2', 'BTC', 'bittrex', '6.74763833', '0.001', 1, '8'),
(1872, 'ENG', 'BTC', 'bittrex', '0.90031691', '0.001', 1, '8'),
(1873, 'ENRG', 'BTC', 'bittrex', '18.89644747', '0.001', 1, '8'),
(1874, 'ERC', 'BTC', 'bittrex', '3.80401704', '0.001', 1, '8'),
(1875, 'ETC', 'BTC', 'bittrex', '0.10775862', '0.001', 1, '8'),
(1876, 'ETH', 'BTC', 'bittrex', '0.00346548', '0.001', 1, '8'),
(1877, 'EXCL', 'BTC', 'bittrex', '1.69894665', '0.001', 1, '8'),
(1878, 'EXP', 'BTC', 'bittrex', '0.9061911', '0.001', 1, '8'),
(1879, 'FCT', 'BTC', 'bittrex', '0.07386856', '0.001', 1, '8'),
(1880, 'FLDC', 'BTC', 'bittrex', '105.93220339', '0.001', 1, '8'),
(1881, 'FLO', 'BTC', 'bittrex', '19.3498452', '0.001', 1, '8'),
(1882, 'FTC', 'BTC', 'bittrex', '8.8028169', '0.001', 1, '8'),
(1883, 'GAM', 'BTC', 'bittrex', '0.24271845', '0.001', 1, '8'),
(1884, 'GAME', 'BTC', 'bittrex', '1.21424061', '0.001', 1, '8'),
(1885, 'GBG', 'BTC', 'bittrex', '29.55082742', '0.001', 1, '8'),
(1886, 'GBYTE', 'BTC', 'bittrex', '0.00792858', '0.001', 1, '8'),
(1887, 'GEO', 'BTC', 'bittrex', '0.75718569', '0.001', 1, '8'),
(1888, 'GLD', 'BTC', 'bittrex', '13.74381528', '0.001', 1, '8'),
(1889, 'GNO', 'BTC', 'bittrex', '0.02066037', '0.001', 1, '8'),
(1890, 'GNT', 'BTC', 'bittrex', '3.81679389', '0.001', 1, '8'),
(1891, 'GOLOS', 'BTC', 'bittrex', '20.8855472', '0.001', 1, '8'),
(1892, 'GRC', 'BTC', 'bittrex', '38.46153846', '0.001', 1, '8'),
(1893, 'GRS', 'BTC', 'bittrex', '1.51048275', '0.001', 1, '8'),
(1894, 'GTO', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1895, 'GUP', 'BTC', 'bittrex', '4.58547322', '0.001', 1, '8'),
(1896, 'HMQ', 'BTC', 'bittrex', '11.24606388', '0.001', 1, '8'),
(1897, 'IGNIS', 'BTC', 'bittrex', '19.57713391', '0.001', 1, '8'),
(1898, 'INCNT', 'BTC', 'bittrex', '5.69087184', '0.001', 1, '8'),
(1899, 'IOC', 'BTC', 'bittrex', '1.35113225', '0.001', 1, '8'),
(1900, 'ION', 'BTC', 'bittrex', '0.72212594', '0.001', 1, '8'),
(1901, 'IOP', 'BTC', 'bittrex', '0.81969901', '0.001', 1, '8'),
(1902, 'KMD', 'BTC', 'bittrex', '0.54835384', '0.001', 1, '8'),
(1903, 'KORE', 'BTC', 'bittrex', '0.63053293', '0.001', 1, '8'),
(1904, 'LBC', 'BTC', 'bittrex', '7.28226041', '0.001', 1, '8'),
(1905, 'LMC', 'BTC', 'bittrex', '30.33980583', '0.001', 1, '8'),
(1906, 'LOOM', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1907, 'LRC', 'BTC', 'bittrex', '2.76946937', '0.001', 1, '8'),
(1908, 'LSK', 'BTC', 'bittrex', '0.18243115', '0.001', 1, '8'),
(1909, 'LTC', 'BTC', 'bittrex', '0.01435906', '0.001', 1, '8'),
(1910, 'LUN', 'BTC', 'bittrex', '0.16367362', '0.001', 1, '8'),
(1911, 'MANA', 'BTC', 'bittrex', '15.26251526', '0.001', 1, '8'),
(1912, 'MCO', 'BTC', 'bittrex', '0.17028001', '0.001', 1, '8'),
(1913, 'MEME', 'BTC', 'bittrex', '6.9213732', '0.001', 1, '8'),
(1914, 'MER', 'BTC', 'bittrex', '7.53012048', '0.001', 1, '8'),
(1915, 'MFT', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1916, 'MLN', 'BTC', 'bittrex', '0.03410213', '0.001', 1, '8'),
(1917, 'MONA', 'BTC', 'bittrex', '0.55545681', '0.001', 1, '8'),
(1918, 'MORE', 'BTC', 'bittrex', '3.17258883', '0.001', 1, '8'),
(1919, 'MUE', 'BTC', 'bittrex', '16.11863314', '0.001', 1, '8'),
(1920, 'MUSIC', 'BTC', 'bittrex', '121.3592233', '0.001', 1, '8'),
(1921, 'NAV', 'BTC', 'bittrex', '1.54933069', '0.001', 1, '8'),
(1922, 'NBT', 'BTC', 'bittrex', '3.89044507', '0.001', 1, '8'),
(1923, 'NEO', 'BTC', 'bittrex', '0.02926862', '0.001', 1, '8'),
(1924, 'NEOS', 'BTC', 'bittrex', '0.60839093', '0.001', 1, '8'),
(1925, 'NGC', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1926, 'NLC2', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1927, 'NLG', 'BTC', 'bittrex', '18.32844575', '0.001', 1, '8'),
(1928, 'NMR', 'BTC', 'bittrex', '0.12189057', '0.001', 1, '8'),
(1929, 'NXC', 'BTC', 'bittrex', '10.41666667', '0.001', 1, '8'),
(1930, 'NXS', 'BTC', 'bittrex', '0.93019795', '0.001', 1, '8'),
(1931, 'NXT', 'BTC', 'bittrex', '11.03752759', '0.001', 1, '8'),
(1932, 'OCN', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1933, 'OK', 'BTC', 'bittrex', '11.27649977', '0.001', 1, '8'),
(1934, 'OMG', 'BTC', 'bittrex', '0.14224508', '0.001', 1, '8'),
(1935, 'OMNI', 'BTC', 'bittrex', '0.05636979', '0.001', 1, '8'),
(1936, 'PART', 'BTC', 'bittrex', '0.13450695', '0.001', 1, '8'),
(1937, 'PAY', 'BTC', 'bittrex', '1.39136242', '0.001', 1, '8'),
(1938, 'PINK', 'BTC', 'bittrex', '89.28571429', '0.001', 1, '8'),
(1939, 'PIVX', 'BTC', 'bittrex', '0.39782311', '0.001', 1, '8'),
(1940, 'POLY', 'BTC', 'bittrex', '4.47227191', '0.001', 1, '8'),
(1941, 'POT', 'BTC', 'bittrex', '15.84283904', '0.001', 1, '8'),
(1942, 'POWR', 'BTC', 'bittrex', '4.41384181', '0.001', 1, '8'),
(1943, 'PPC', 'BTC', 'bittrex', '0.84745763', '0.001', 1, '8'),
(1944, 'PRO', 'BTC', 'bittrex', '1.13352981', '0.001', 1, '8'),
(1945, 'PTC', 'BTC', 'bittrex', '41.59733777', '0.001', 1, '8'),
(1946, 'PTOY', 'BTC', 'bittrex', '10.92657343', '0.001', 1, '8'),
(1947, 'QRL', 'BTC', 'bittrex', '1.74800727', '0.001', 1, '8'),
(1948, 'QTUM', 'BTC', 'bittrex', '0.10783485', '0.001', 1, '8'),
(1949, 'QWARK', 'BTC', 'bittrex', '19.11314985', '0.001', 1, '8'),
(1950, 'RADS', 'BTC', 'bittrex', '0.36759841', '0.001', 1, '8'),
(1951, 'RBY', 'BTC', 'bittrex', '3.40182338', '0.001', 1, '8'),
(1952, 'RCN', 'BTC', 'bittrex', '15.16990291', '0.001', 1, '8'),
(1953, 'RDD', 'BTC', 'bittrex', '287.35632184', '0.001', 1, '8'),
(1954, 'REP', 'BTC', 'bittrex', '0.05283089', '0.001', 1, '8'),
(1955, 'RFR', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1956, 'RLC', 'BTC', 'bittrex', '1.49584156', '0.001', 1, '8'),
(1957, 'RVR', 'BTC', 'bittrex', '20.29220779', '0.001', 1, '8'),
(1958, 'SALT', 'BTC', 'bittrex', '0.6127451', '0.001', 1, '8'),
(1959, 'SBD', 'BTC', 'bittrex', '0.67383628', '0.001', 1, '8'),
(1960, 'SC', 'BTC', 'bittrex', '109.17030568', '0.001', 1, '8'),
(1961, 'SEQ', 'BTC', 'bittrex', '10.63377286', '0.001', 1, '8'),
(1962, 'SHIFT', 'BTC', 'bittrex', '0.83333333', '0.001', 1, '8'),
(1963, 'SIB', 'BTC', 'bittrex', '1.66489078', '0.001', 1, '8'),
(1964, 'SLR', 'BTC', 'bittrex', '5.65482922', '0.001', 1, '8'),
(1965, 'SLS', 'BTC', 'bittrex', '0.03571408', '0.001', 1, '8'),
(1966, 'SNT', 'BTC', 'bittrex', '15.03307276', '0.001', 1, '8'),
(1967, 'SPHR', 'BTC', 'bittrex', '0.68466889', '0.001', 1, '8'),
(1968, 'SPR', 'BTC', 'bittrex', '3.53007625', '0.001', 1, '8'),
(1969, 'SRN', 'BTC', 'bittrex', '5.71297989', '0.001', 1, '8'),
(1970, 'STEEM', 'BTC', 'bittrex', '0.681366', '0.001', 1, '8'),
(1971, 'STORJ', 'BTC', 'bittrex', '1.98145359', '0.001', 1, '8'),
(1972, 'STORM', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1973, 'STRAT', 'BTC', 'bittrex', '0.3624344', '0.001', 1, '8'),
(1974, 'SWT', 'BTC', 'bittrex', '1.16474096', '0.001', 1, '8'),
(1975, 'SYNX', 'BTC', 'bittrex', '4.03551251', '0.001', 1, '8'),
(1976, 'SYS', 'BTC', 'bittrex', '4.35767823', '0.001', 1, '8'),
(1977, 'THC', 'BTC', 'bittrex', '19.56181534', '0.001', 1, '8'),
(1978, 'TIX', 'BTC', 'bittrex', '3.73134328', '0.001', 1, '8'),
(1979, 'TKS', 'BTC', 'bittrex', '0.87062511', '0.001', 1, '8'),
(1980, 'TRUST', 'BTC', 'bittrex', '20.97315436', '0.001', 1, '8'),
(1981, 'TRX', 'BTC', 'bittrex', '39.0625', '0.001', 1, '8'),
(1982, 'TUBE', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(1983, 'TUSD', 'BTC', 'bittrex', '2.24921278', '0.001', 1, '8'),
(1984, 'TX', 'BTC', 'bittrex', '1.2500625', '0.001', 1, '8'),
(1985, 'UBQ', 'BTC', 'bittrex', '0.88283071', '0.001', 1, '8'),
(1986, 'UKG', 'BTC', 'bittrex', '8.54408749', '0.001', 1, '8'),
(1987, 'UNB', 'BTC', 'bittrex', '2.59956327', '0.001', 1, '8'),
(1988, 'UP', 'BTC', 'bittrex', '9.39849624', '0.001', 1, '8'),
(1989, 'VEE', 'BTC', 'bittrex', '39.61965135', '0.001', 1, '8'),
(1990, 'VIA', 'BTC', 'bittrex', '0.91790278', '0.001', 1, '8'),
(1991, 'VIB', 'BTC', 'bittrex', '11.19068935', '0.001', 1, '8'),
(1992, 'VRC', 'BTC', 'bittrex', '3.13008639', '0.001', 1, '8'),
(1993, 'VRM', 'BTC', 'bittrex', '0.64452924', '0.001', 1, '8'),
(1994, 'VTC', 'BTC', 'bittrex', '0.84217618', '0.001', 1, '8'),
(1995, 'WAVES', 'BTC', 'bittrex', '0.40176778', '0.001', 1, '8'),
(1996, 'WAX', 'BTC', 'bittrex', '6.19732276', '0.001', 1, '8'),
(1997, 'WINGS', 'BTC', 'bittrex', '3.49993', '0.001', 1, '8'),
(1998, 'XCP', 'BTC', 'bittrex', '0.10869565', '0.001', 1, '8'),
(1999, 'XDN', 'BTC', 'bittrex', '162.33766234', '0.001', 1, '8'),
(2000, 'XEL', 'BTC', 'bittrex', '6.33713561', '0.001', 1, '8'),
(2001, 'XEM', 'BTC', 'bittrex', '5.62936276', '0.001', 1, '8'),
(2002, 'XLM', 'BTC', 'bittrex', '6.02119461', '0.001', 1, '8'),
(2003, 'XMG', 'BTC', 'bittrex', '6.11097531', '0.001', 1, '8'),
(2004, 'XMR', 'BTC', 'bittrex', '0.00799564', '0.001', 1, '8'),
(2005, 'XMY', 'BTC', 'bittrex', '225.22522523', '0.001', 1, '8'),
(2006, 'XRP', 'BTC', 'bittrex', '2.56383961', '0.001', 1, '8'),
(2007, 'XST', 'BTC', 'bittrex', '6.49013499', '0.001', 1, '8'),
(2008, 'XVG', 'BTC', 'bittrex', '32.76539974', '0.001', 1, '8'),
(2009, 'XWC', 'BTC', 'bittrex', '31.25', '0.001', 1, '8'),
(2010, 'XZC', 'BTC', 'bittrex', '0.04781934', '0.001', 1, '8'),
(2011, 'ZCL', 'BTC', 'bittrex', '0.14792987', '0.001', 1, '8'),
(2012, 'ZEC', 'BTC', 'bittrex', '0.00748989', '0.001', 1, '8'),
(2013, 'ZEN', 'BTC', 'bittrex', '0.0653482', '0.001', 1, '8'),
(2014, 'ZRX', 'BTC', 'bittrex', '2.23713647', '0.001', 1, '8'),
(2015, 'ADA', 'ETH', 'bittrex', '11.29943503', '0.001', 1, '8'),
(2016, 'ADX', 'ETH', 'bittrex', '3.15318156', '0.001', 1, '8'),
(2017, 'AID', 'ETH', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2018, 'ANT', 'ETH', 'bittrex', '0.78012978', '0.001', 1, '8'),
(2019, 'BAT', 'ETH', 'bittrex', '7.31635938', '0.001', 1, '8'),
(2020, 'BCH', 'ETH', 'bittrex', '0.00218614', '0.001', 1, '8'),
(2021, 'BCPT', 'ETH', 'bittrex', '5.47573156', '0.001', 0, '8'),
(2022, 'BLT', 'ETH', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2023, 'BNT', 'ETH', 'bittrex', '0.74850299', '0.001', 1, '8'),
(2024, 'BTG', 'ETH', 'bittrex', '0.04081633', '0.001', 1, '8'),
(2025, 'CVC', 'ETH', 'bittrex', '7.75374118', '0.001', 1, '8'),
(2026, 'DASH', 'ETH', 'bittrex', '0.00643036', '0.001', 1, '8'),
(2027, 'DGB', 'ETH', 'bittrex', '90.92562284', '0.001', 1, '8'),
(2028, 'DMT', 'ETH', 'bittrex', '5.18817511', '0.001', 1, '8'),
(2029, 'ENG', 'ETH', 'bittrex', '1.30303346', '0.001', 1, '8'),
(2030, 'ETC', 'ETH', 'bittrex', '0.1561864', '0.001', 1, '8'),
(2031, 'FCT', 'ETH', 'bittrex', '0.10776222', '0.001', 1, '8'),
(2032, 'GNO', 'ETH', 'bittrex', '0.02995681', '0.001', 1, '8'),
(2033, 'GNT', 'ETH', 'bittrex', '5.48769111', '0.001', 1, '8'),
(2034, 'GTO', 'ETH', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2035, 'LRC', 'ETH', 'bittrex', '4.06309169', '0.001', 1, '8'),
(2036, 'LTC', 'ETH', 'bittrex', '0.020704', '0.001', 1, '8'),
(2037, 'LUN', 'ETH', 'bittrex', '0.23810658', '0.001', 1, '8'),
(2038, 'MANA', 'ETH', 'bittrex', '21.95196909', '0.001', 1, '8'),
(2039, 'MCO', 'ETH', 'bittrex', '0.24923522', '0.001', 1, '8'),
(2040, 'MORE', 'ETH', 'bittrex', '4.61650678', '0.001', 1, '8'),
(2041, 'NEO', 'ETH', 'bittrex', '0.04246609', '0.001', 1, '8'),
(2042, 'NGC', 'ETH', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2043, 'OCN', 'ETH', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2044, 'OMG', 'ETH', 'bittrex', '0.20338787', '0.001', 1, '8'),
(2045, 'PAY', 'ETH', 'bittrex', '2.01508899', '0.001', 1, '8'),
(2046, 'POLY', 'ETH', 'bittrex', '6.41617904', '0.001', 1, '8'),
(2047, 'POWR', 'ETH', 'bittrex', '6.41025641', '0.001', 1, '8'),
(2048, 'PRO', 'ETH', 'bittrex', '1.61290323', '0.001', 1, '8'),
(2049, 'QTUM', 'ETH', 'bittrex', '0.15619841', '0.001', 1, '8'),
(2050, 'RCN', 'ETH', 'bittrex', '21.602938', '0.001', 0, '8'),
(2051, 'REP', 'ETH', 'bittrex', '0.07710338', '0.001', 1, '8'),
(2052, 'RLC', 'ETH', 'bittrex', '2.16582416', '0.001', 1, '8'),
(2053, 'SALT', 'ETH', 'bittrex', '0.88099828', '0.001', 1, '8'),
(2054, 'SC', 'ETH', 'bittrex', '156.69069257', '0.001', 1, '8'),
(2055, 'SNT', 'ETH', 'bittrex', '21.6938563', '0.001', 1, '8'),
(2056, 'SRN', 'ETH', 'bittrex', '8.15620769', '0.001', 1, '8'),
(2057, 'STORM', 'ETH', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2058, 'STRAT', 'ETH', 'bittrex', '0.52966102', '0.001', 1, '8'),
(2059, 'TRX', 'ETH', 'bittrex', '56.6957705', '0.001', 1, '8'),
(2060, 'TUSD', 'ETH', 'bittrex', '3.23825808', '0.001', 1, '8'),
(2061, 'UKG', 'ETH', 'bittrex', '12.23421175', '0.001', 1, '8'),
(2062, 'UP', 'ETH', 'bittrex', '13.51351351', '0.001', 1, '8'),
(2063, 'VEE', 'ETH', 'bittrex', '55.75379126', '0.001', 1, '8'),
(2064, 'VIB', 'ETH', 'bittrex', '16.07613658', '0.001', 1, '8'),
(2065, 'WAVES', 'ETH', 'bittrex', '0.58207285', '0.001', 1, '8'),
(2066, 'WAX', 'ETH', 'bittrex', '8.92124326', '0.001', 1, '8'),
(2067, 'XEM', 'ETH', 'bittrex', '8.23709659', '0.001', 1, '8'),
(2068, 'XLM', 'ETH', 'bittrex', '8.77731941', '0.001', 1, '8'),
(2069, 'XMR', 'ETH', 'bittrex', '0.01159747', '0.001', 1, '8'),
(2070, 'XRP', 'ETH', 'bittrex', '3.73449252', '0.001', 1, '8'),
(2071, 'ZEC', 'ETH', 'bittrex', '0.01072884', '0.001', 1, '8'),
(2072, 'ZRX', 'ETH', 'bittrex', '3.19394938', '0.001', 1, '8'),
(2073, 'BTC', 'USD', 'bittrex', '0.001', '0.001', 1, '8'),
(2074, 'ETH', 'USD', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2075, 'TUSD', 'USD', 'bittrex', '1', '0.001', 1, '8'),
(2076, 'USDT', 'USD', 'bittrex', '1', '0.001', 1, '8'),
(2077, 'ADA', 'USDT', 'bittrex', '10.54116218', '0.001', 1, '8'),
(2078, 'BCH', 'USDT', 'bittrex', '0.00202703', '0.001', 1, '8'),
(2079, 'BTC', 'USDT', 'bittrex', '0.0003358', '0.001', 1, '8'),
(2080, 'BTG', 'USDT', 'bittrex', '0.03759398', '0.001', 1, '8'),
(2081, 'DASH', 'USDT', 'bittrex', '0.00590621', '0.001', 1, '8'),
(2082, 'DCR', 'USDT', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2083, 'DGB', 'USDT', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(2084, 'ETC', 'USDT', 'bittrex', '0.14523924', '0.001', 1, '8'),
(2085, 'ETH', 'USDT', 'bittrex', '0.00464218', '0.001', 1, '8'),
(2086, 'LTC', 'USDT', 'bittrex', '0.01928167', '0.001', 1, '8'),
(2087, 'NEO', 'USDT', 'bittrex', '0.03931848', '0.001', 1, '8'),
(2088, 'NXT', 'USDT', 'bittrex', '14.77832585', '0.001', 1, '8'),
(2089, 'OMG', 'USDT', 'bittrex', '0.19083969', '0.001', 1, '8'),
(2090, 'SC', 'USDT', 'bittrex', '145.77252392', '0.001', 1, '8'),
(2091, 'TRX', 'USDT', 'bittrex', '52.55785963', '0.001', 1, '8'),
(2092, 'TUSD', 'USDT', 'bittrex', '3.00025937', '0.001', 1, '8'),
(2093, 'XMR', 'USDT', 'bittrex', '0.01079137', '0.001', 1, '8'),
(2094, 'XRP', 'USDT', 'bittrex', '3.47988748', '0.001', 1, '8'),
(2095, 'XVG', 'USDT', 'bittrex', '44.06580494', '0.001', 1, '8'),
(2096, 'ZEC', 'USDT', 'bittrex', '0.01001703', '0.001', 1, '8'),
(2097, 'BTC', 'USD', 'cex', '0.002', '30', 1, '2.698970004'),
(2098, 'ETH', 'USD', 'cex', '0.05', '1000', 1, '1.301029995'),
(2099, 'BCH', 'USD', 'cex', '0.02', '30', 1, '1.698970004'),
(2100, 'BTG', 'USD', 'cex', '0.03', '0.001', 1, '1.522878745'),
(2101, 'DASH', 'USD', 'cex', '0.03', '0.001', 1, '1.522878745'),
(2102, 'XRP', 'USD', 'cex', '40', '0.001', 1, '1.602059991'),
(2103, 'XLM', 'USD', 'cex', '70', '0.001', 1, '1.845098040'),
(2104, 'ZEC', 'USD', 'cex', '0.07', '0.001', 1, '1.154901959'),
(2105, 'BTC', 'EUR', 'cex', '0.002', '30', 1, '2.698970004'),
(2106, 'ETH', 'EUR', 'cex', '0.05', '0.001', 1, '1.301029995'),
(2107, 'BCH', 'EUR', 'cex', '0.02', '0.001', 1, '1.698970004'),
(2108, 'BTG', 'EUR', 'cex', '0.03', '0.001', 1, '1.522878745'),
(2109, 'DASH', 'EUR', 'cex', '0.03', '0.001', 1, '1.522878745'),
(2110, 'XRP', 'EUR', 'cex', '40', '0.001', 1, '1.602059991'),
(2111, 'XLM', 'EUR', 'cex', '70', '0.001', 1, '1.845098040'),
(2112, 'ZEC', 'EUR', 'cex', '0.07', '0.001', 1, '1.154901959'),
(2113, 'BTC', 'GBP', 'cex', '0.002', '0.001', 1, '2.698970004'),
(2114, 'ETH', 'GBP', 'cex', '0.05', '0.001', 1, '1.301029995'),
(2115, 'BCH', 'GBP', 'cex', '0.02', '0.001', 1, '1.698970004'),
(2116, 'DASH', 'GBP', 'cex', '0.03', '0.001', 1, '1.522878745'),
(2117, 'ZEC', 'GBP', 'cex', '0.07', '0.001', 1, '1.154901959'),
(2118, 'BTC', 'RUB', 'cex', '0.001', '0.001', 1, '3'),
(2119, 'ETH', 'BTC', 'cex', '0.025', '1000', 1, '1.602059991'),
(2120, 'BCH', 'BTC', 'cex', '0.007', '30', 1, '2.154901959'),
(2121, 'BTG', 'BTC', 'cex', '0.01', '0.001', 1, '2'),
(2122, 'DASH', 'BTC', 'cex', '0.015', '0.001', 1, '1.823908740'),
(2123, 'XRP', 'BTC', 'cex', '40', '0.001', 1, '1.602059991'),
(2124, 'XLM', 'BTC', 'cex', '70', '0.001', 1, '1.845098040'),
(2125, 'ZEC', 'BTC', 'cex', '0.03', '0.001', 1, '1.522878745'),
(2126, 'GHS', 'BTC', 'cex', '100', '0.001', 1, '2'),
(2127, 'LTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2128, 'NMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2129, 'PPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2130, 'DASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2131, 'DOGE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2132, 'CAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2133, 'CANN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2134, 'URO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2135, 'OPAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2136, 'VIA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2137, 'SDC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2138, 'START', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2139, 'GSX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2140, 'VTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2141, 'SMBR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2142, 'ETCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2143, 'XQN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2144, 'GML', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2145, 'XPY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2146, 'DGMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2147, 'NOO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2148, 'NAVAJOCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2149, 'NKT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2150, 'EAGS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2151, 'DARKGOLDCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2152, 'SYS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2153, 'TES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2154, 'SBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2155, 'PND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2156, 'XSP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2157, 'XPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2158, 'ZEIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2159, 'MOTO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2160, 'OK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2161, 'SPR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2162, 'FIND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2163, 'NKA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2164, 'CCB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2165, 'CON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2166, 'GP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2167, 'BLU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2168, 'OZC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2169, 'STAKECOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2170, '2015', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2171, 'AM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2172, 'XBS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2173, 'VPN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2174, 'DECR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2175, 'OBS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2176, 'RICE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2177, 'BSTY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2178, 'GIG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2179, 'OMA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2180, 'ICOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2181, 'DGORE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2182, 'AMBER', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2183, 'GEO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2184, 'DGB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2185, 'KOBO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2186, 'YBC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2187, 'KTK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2188, 'CBX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2189, 'NVC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2190, 'SIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2191, 'XVG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2192, 'LTS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2193, 'PEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2194, 'CRIME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2195, 'BTCR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2196, 'BOOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2197, 'GSM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2198, 'PTY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2199, 'VOYA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2200, 'BITB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2201, 'XCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2202, 'EPAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2203, 'BITZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2204, 'TWIST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2205, 'MTLMC3', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2206, 'SLFI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2207, 'STP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2208, 'NXE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2209, 'XAU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2210, 'PXL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2211, 'AECC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2212, 'BTCRY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2213, 'PLANET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2214, 'FIRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2215, 'ANAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2216, 'LDOGE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2217, 'TEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2218, 'ZIRK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2219, 'XDB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2220, 'TAB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2221, 'NDOGE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2222, 'CRAVE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2223, 'ICASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2224, '256', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2225, 'GIFT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2226, 'BBCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2227, 'URC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2228, 'TRICK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2229, 'U', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2230, 'CC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2231, 'METAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2232, 'CLAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2233, 'KARMA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2234, 'CRY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2235, 'MRP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2236, 'TCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2237, 'NOTE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2238, 'RDD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2239, 'CYP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2240, 'GIZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2241, 'XPRO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2242, 'TRON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2243, 'ETRUST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2244, 'FONZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2245, 'EGG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2246, 'LEA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2247, 'HZT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2248, 'P7C', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2249, '8BIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2250, 'TP1', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2251, 'CF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2252, 'CTK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2253, 'NTRN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2254, 'COVEN COIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2255, 'LUX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2256, 'DRZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2257, '007', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2258, 'GRAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2259, 'SIGU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2260, 'QTZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2261, 'DOX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2262, 'XNX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2263, 'XMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2264, 'GUM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2265, 'TDFB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2266, 'BUB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2267, 'UNIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2268, 'GRAV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2269, 'EPY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2270, 'GOAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2271, 'PNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2272, 'UTLE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2273, 'ISL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2274, 'PKB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2275, 'VTN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2276, 'FSN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2277, 'MCAR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2278, 'SHELL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2279, 'BIT16', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2280, 'TB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2281, 'M1', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2282, 'KRAK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2283, 'BA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2284, 'ASTRAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2285, 'MRB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2286, 'BTA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2287, 'EDWARDSNOWDE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2288, 'PTA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2289, 'DCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2290, 'ARB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2291, 'TWERK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2292, 'EQM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2293, 'NICE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2294, 'DB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2295, 'TNG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2296, 'CRYPTOSPOTS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2297, 'SKB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2298, 'GENIUS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2299, 'SED', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2300, 'PRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2301, '32BIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2302, 'FADE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2303, 'SNRG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2304, 'RAD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2305, 'PSY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2306, 'VCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2307, 'MOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2308, 'GREED', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2309, 'EXB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2310, 'OPTION', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2311, 'GLUCK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2312, 'DRA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2313, 'SEEDS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2314, 'NANAS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2315, 'BNBX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2316, 'ARPA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2317, 'VAPOR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2318, 'DUB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2319, 'FIST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2320, 'EOC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2321, 'XCE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2322, 'DRKT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2323, 'TRANSF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2324, 'ILM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2325, 'GENSTAKE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2326, 'FURY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2327, 'SEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2328, 'NODX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2329, 'HEDG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2330, 'SMSR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2331, 'BOD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2332, 'GTFO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2333, 'TENNET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2334, 'KC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2335, 'BLUS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2336, 'XRA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2337, 'LIFEEXTENSIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2338, 'SPX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2339, 'GMCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2340, 'VTX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2341, 'POLY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2342, 'HXX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2343, 'SPKTR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2344, 'GENESISCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2345, 'CRPS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2346, 'BAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2347, 'SJW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2348, 'SPEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2349, 'EA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2350, 'TAGR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2351, 'HAZE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2352, 'NUKE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2353, '2BACCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2354, 'CYC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2355, 'ERR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2356, 'SANDG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2357, 'NOC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2358, 'SHRM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2359, 'ASCENSION', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2360, 'GREXIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2361, 'MIDNIGHT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2362, 'NEBU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2363, 'GE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2364, 'IBITS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2365, 'WEALTH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2366, 'BIOS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2367, 'CURVES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2368, 'AXIOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2369, 'CHIP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2370, 'IEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2371, 'SPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2372, 'CAPT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2373, 'SAK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2374, 'ROS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2375, 'ACP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2376, 'TAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2377, 'HIFUN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2378, 'NRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2379, 'SQL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2380, 'XFCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2381, 'CIRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2382, 'SOLO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2383, 'ARE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2384, 'BEEZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2385, 'NETC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2386, 'ZOOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2387, 'PAK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2388, 'PEO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2389, 'STRP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2390, 'DETH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2391, 'IOC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2392, 'MYSTIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2393, 'AUM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2394, 'DIRTY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2395, 'SDP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2396, 'L7S', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2397, 'FCASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2398, 'TX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2399, 'AMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2400, 'MAD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2401, 'GLOBALCRYPTO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2402, 'GRF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2403, 'VOL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2404, 'GSY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2405, 'HEEL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2406, 'RBT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2407, 'LHC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2408, 'CLICK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2409, 'PURE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2410, 'PARA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2411, 'N2O', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2412, 'ODNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2413, 'POWER', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2414, 'DCRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2415, 'TWO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2416, 'SCRT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2417, 'LGBTQ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2418, 'TUR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2419, 'EMP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2420, 'XMINE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2421, 'VEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2422, 'NAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2423, 'BTZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2424, 'CME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2425, 'SPACE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2426, 'DOGETH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2427, 'SRND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2428, 'SWING', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2429, 'BRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2430, 'BOLI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2431, 'CAID', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2432, 'STHR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2433, 'MAPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2434, 'FLY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2435, 'BOTCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2436, 'SIB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2437, 'PHR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2438, 'LTD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2439, 'SCITW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2440, 'PSI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2441, 'CYT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2442, 'XSSX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2443, 'INFX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2444, 'STEPS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2445, 'FRDC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2446, 'BSTK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2447, 'TIA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2448, 'XUP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2449, 'HSP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2450, 'SWEET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2451, 'DTT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2452, 'NODES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2453, 'BAN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2454, 'RONIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2455, 'FUZZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2456, 'AUTUMNCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2457, 'XLTCG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2458, 'CV2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2459, 'CB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2460, 'PLNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2461, 'MAZE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2462, 'BSH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2463, 'SMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2464, 'EXPERIENCECO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2465, 'DEM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2466, 'IVZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2467, 'ZUR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2468, 'XDE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2469, 'RMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2470, 'OS76', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2471, 'ADC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2472, 'CUBE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2473, 'DCYP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2474, 'GCR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2475, 'REPUBLICOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2476, 'DISCOUNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2477, 'ANTI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2478, 'EMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2479, 'MONETA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2480, 'LUNARCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2481, 'BSC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2482, 'DEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2483, 'FAUCETCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2484, 'DUO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2485, 'WBB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2486, 'ECLI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2487, 'FRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2488, 'XMT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2489, 'NUBIS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2490, '1337', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2491, 'DGCS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2492, 'MUE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2493, 'BTTF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2494, 'STV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2495, 'RUBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2496, 'LVG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2497, 'MM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2498, 'XSY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2499, 'PXI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2500, 'DFT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2501, 'BST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2502, 'LIMX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2503, 'BDC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2504, 'EVO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2505, 'VEG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2506, 'RNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2507, 'CREVA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2508, 'EVIL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2509, 'JUPITERCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2510, 'X2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2511, 'RATIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2512, 'ZET2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2513, 'DC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2514, 'AV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2515, 'BUCKS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2516, 'BRONZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2517, 'ADZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2518, 'PNK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2519, 'BITON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2520, 'MIS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2521, 'SSC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2522, 'CD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2523, 'RICHX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2524, 'MND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2525, 'EGC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2526, 'C0C0', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2527, 'KGC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2528, 'SXC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2529, 'BAC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2530, 'LTCR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2531, 'SLS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2532, 'HTML', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2533, 'BTP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2534, 'OPES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2535, 'STRB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2536, 'BUZZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2537, 'XDE2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2538, 'JIF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2539, 'NLG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2540, 'BTCU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2541, 'CAPRICOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2542, 'FRN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2543, 'KAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2544, 'SPT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2545, 'LUCKY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2546, 'DUST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2547, 'WARP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2548, 'DRACO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2549, 'LKC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2550, 'MOOND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2551, 'DRM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2552, 'DARKNET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2553, 'ZET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2554, 'NKC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2555, 'BRDD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2556, 'GBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2557, 'STS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2558, 'HIRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2559, 'SIX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2560, 'PEX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2561, 'SUPER', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2562, 'CREDIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2563, 'NPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2564, 'DIME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2565, 'TTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2566, 'ZMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2567, 'FRK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2568, 'CRW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2569, 'TIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2570, 'CLOAK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2571, 'FFC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2572, 'CLUB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2573, 'RBIES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2574, 'TEK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2575, 'DBLK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2576, 'CYG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2577, 'DBIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2578, 'DCR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2579, 'SPEX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2580, 'TRUMP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2581, 'BIGUP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2582, 'ACLR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2583, 'VAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2584, 'LEAF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2585, 'XJO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2586, 'ARCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2587, 'INC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2588, 'VIP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2589, 'EURC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2590, 'CFC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2591, 'BERN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2592, 'HODL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2593, 'HMP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2594, 'NEVA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2595, 'PAYP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2596, 'UNF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2597, 'ALTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2598, 'PULSE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2599, 'IMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2600, 'IXC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2601, 'PCM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2602, 'CORG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2603, 'TBCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2604, 'HAWK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2605, 'XBU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2606, 'POST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2607, '888', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2608, 'ENE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2609, 'YAC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2610, 'SONG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2611, 'AIB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2612, 'ELCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2613, 'LOOT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2614, 'CZECO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2615, 'EDRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2616, 'JACK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2617, 'ADCN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2618, 'BILL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2619, 'XAV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2620, 'DXC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2621, 'MOJO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2622, 'GBT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2623, 'COXST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2624, 'XNG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2625, 'TCR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2626, 'PINKX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2627, 'BLRY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2628, 'ORLY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2629, 'TKN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2630, 'N7', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2631, 'CLINT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2632, 'BRAIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2633, 'GROW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2634, 'ACID', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2635, 'ESP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2636, 'DISK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2637, 'BOMB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2638, 'TRAP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2639, 'SUBSCRIPTIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2640, 'XBTC21', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2641, 'OP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2642, 'TAK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2643, 'NUM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2644, 'GOTX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2645, 'EDC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2646, 'CHRG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2647, 'APT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2648, 'RCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(2649, 'PONZI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2650, 'XPTX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2651, 'LOCOCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2652, 'GRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2653, 'CARBON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2654, 'CST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2655, 'TOOL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2656, 'TECH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2657, 'ACOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2658, 'QBC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2659, 'OCOW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2660, 'LTH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2661, '2GIVE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2662, 'SOUL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2663, 'LANA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2664, 'UAE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2665, 'BOSS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2666, 'WMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2667, 'SPM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2668, 'BVC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2669, 'COMETCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2670, 'UIS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2671, 'SSTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2672, 'PRM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2673, 'MXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2674, 'IONX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2675, 'GHS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2676, 'EKOCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2677, 'B2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2678, 'AUR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2679, 'PONZ2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2680, 'MMXVI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2681, 'GO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2682, 'EUC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2683, 'ETHS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2684, 'EMPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2685, 'CLUD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2686, 'CAB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2687, 'GLC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2688, 'GPU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2689, 'COIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2690, 'PWR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2691, 'VPRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2692, 'SFE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2693, 'INV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2694, 'HCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2695, 'DBTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2696, 'BTCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2697, 'TRA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2698, 'REE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2699, 'MNM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2700, 'FLVR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2701, 'DBG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2702, 'STAR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2703, 'KUBO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2704, 'INCP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2705, 'HVCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2706, 'GB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2707, 'EXIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2708, 'ECCHI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2709, 'BONES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2710, 'MPRO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2711, 'FLX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2712, '404', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2713, 'SHREK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2714, 'COX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2715, 'STA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2716, 'SCAN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2717, 'HTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2718, 'TALK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2719, 'SLING', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2720, 'SP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2721, 'RIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2722, 'XPD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2723, 'ENTRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2724, 'CSMIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2725, 'CHESS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2726, 'NIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2727, 'MARV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2728, 'CHEMX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2729, 'ALC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2730, 'DCK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2731, 'PUT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2732, 'LIR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2733, 'TOKEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2734, 'YAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2735, 'VENE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2736, 'RADI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2737, 'GT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2738, 'CTL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2739, 'AIRCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2740, 'SCRPT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2741, 'IBANK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2742, 'ARTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2743, 'CJ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2744, 'NZC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2745, 'TAJ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2746, 'XT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2747, 'CRAFT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2748, 'RUST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2749, 'FRWC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2750, 'RPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2751, 'POKE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2752, 'GAKH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2753, 'TODAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2754, 'TPG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2755, 'GAIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2756, 'GOON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2757, 'BPOK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2758, 'YMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2759, 'ZNE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2760, 'SCT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2761, 'PAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2762, 'OLYMP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2763, 'PX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2764, 'LC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2765, 'ACES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2766, 'CCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2767, 'CRX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2768, 'WAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2769, 'SYNX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2770, 'SH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2771, 'CRNK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2772, 'B3', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2773, 'XOC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2774, 'XHI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2775, 'BXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2776, 'JWL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2777, 'FX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2778, 'BTD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2779, 'VTY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2780, 'STO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2781, 'VLT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2782, 'TOT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2783, 'TELL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2784, 'TAO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2785, 'RCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2786, 'MST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2787, 'PIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2788, 'ZYD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2789, 'UBIQ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2790, 'DLC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2791, 'RING', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2792, 'ARM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2793, 'SPORT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2794, 'OMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2795, 'XBTS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2796, 'EGO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2797, 'XPO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2798, 'HALLO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2799, 'ATOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2800, 'DPAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2801, 'JOBS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2802, 'PSB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2803, 'BS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2804, 'CRAB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2805, 'FOREX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2806, 'TEAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2807, 'COC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2808, 'CHOOF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2809, 'ROYAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2810, 'DKC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2811, 'EQUAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2812, 'WINE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2813, 'JW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2814, 'ENT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2815, 'BEEP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2816, 'WASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2817, 'RBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2818, 'IMPS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2819, 'BASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2820, 'ZEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2821, 'INSN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2822, 'ASAFE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2823, 'ZLQ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2824, 'ZECD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2825, 'LIV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2826, 'IFLT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2827, 'CBD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2828, 'NBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2829, 'UXC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2830, 'LSD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2831, 'TMRW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2832, 'GAME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2833, 'EMB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2834, '365', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2835, 'NLC2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2836, 'IW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2837, 'FGZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2838, 'BOSON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2839, 'ACPR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2840, 'SCASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2841, 'KURT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2842, 'XCRE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2843, 'SHORTY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2844, 'NODC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2845, 'ICON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2846, 'CORAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2847, 'ARH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2848, 'MONEY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2849, 'BSTAR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2850, 'LOOK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2851, 'JANE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2852, 'IN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2853, 'VIDZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2854, 'YES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2855, 'CG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2856, 'LENIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2857, 'ABY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2858, 'JOK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2859, 'BITCOINPREMI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2860, 'RIDE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2861, 'SMF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2862, 'LEPEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2863, 'CWXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2864, 'POSW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2865, 'PRX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2866, 'ICOB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2867, 'NIXON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2868, 'ALEX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2869, 'MARX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2870, 'VISIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2871, 'NEF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2872, 'MCRN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2873, 'LIZI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2874, 'TSE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2875, 'WISC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2876, 'BIOB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2877, 'ARGUS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2878, 'LUNA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2879, 'STALIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2880, 'MLITE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2881, 'ARCX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2882, 'UNITS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2883, 'CHAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2884, 'MILO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2885, 'GOT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2886, 'VOLT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2887, 'MAVRO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2888, 'ZENI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2889, 'MLNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2890, 'MBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2891, 'TLEX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2892, 'CXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2893, 'CONX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2894, 'NANOX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2895, 'CJC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2896, 'VTL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2897, 'THOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2898, 'CCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2899, 'ALL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2900, 'MCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2901, 'ITI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2902, 'SEV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2903, 'HPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2904, 'ARTA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2905, 'SCS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2906, 'BEST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2907, 'ECO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2908, 'FAZZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2909, 'KUSH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2910, 'BLAZR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2911, 'XVE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2912, 'TAKE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2913, 'STONK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2914, 'VNTX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2915, 'USC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2916, 'ECN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2917, 'UNI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2918, 'KIDS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2919, 'CNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2920, 'FRST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2921, 'XBY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2922, 'AL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2923, 'XVS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2924, 'CKS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2925, 'C2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2926, 'ECA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2927, 'MENTAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2928, 'DASHS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2929, 'MVR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2930, 'DEA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2931, 'PROC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2932, 'MAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2933, 'TLE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2934, 'NETKO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2935, 'XINCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2936, 'TIDE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2937, 'VEC2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2938, 'CNNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2939, 'BAB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2940, 'GLO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2941, 'EVA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2942, 'DUX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2943, 'PARTY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2944, 'PUPA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2945, 'XPS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2946, 'TAP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2947, 'BATL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2948, 'MUU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2949, 'CTIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2950, 'ALIEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2951, 'BITOK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2952, 'GREENF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2953, 'MAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2954, 'MERGEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2955, 'BITS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2956, 'TCN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2957, 'WITCH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2958, 'LUMI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2959, 'XTR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2960, 'CMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2961, 'BHC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2962, 'KASHH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2963, 'VERS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2964, 'F16', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2965, 'FJC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2966, 'PIPR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2967, 'HAMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2968, 'ONX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2969, 'OMGAME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2970, 'JOINTCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2971, 'SKULL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2972, 'XMG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2973, 'WOK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2974, 'HON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2975, 'EGAME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2976, 'PIE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2977, 'FIDGT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2978, 'UDOWN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2979, 'WEEK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2980, 'KINGN COIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2981, 'MAX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2982, 'SLCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2983, 'XNM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2984, 'KISS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2985, 'PROFIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2986, 'TAG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2987, 'SHRP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2988, 'ELC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2989, 'RBY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2990, 'QTM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2991, 'TLOSH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2992, '420G', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2993, 'RBBT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2994, 'SOLAR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2995, 'HYPER', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2996, 'OCEAN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2997, 'ACRN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2998, 'LITEBITCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(2999, 'EUROP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3000, 'SOCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3001, 'ROCKET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3002, 'MAO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3003, 'CDO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3004, '700', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3005, 'WOMEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3006, 'MULTI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3007, 'RH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3008, 'WAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3009, 'HMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3010, 'FPC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3011, 'LINDA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3012, 'KGB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3013, 'RSGP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3014, 'RUP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3015, 'DXO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3016, 'PRIMU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3017, 'XGTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3018, 'FIDEL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3019, 'DUR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3020, 'CTIC2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3021, 'INGT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3022, 'GER', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3023, 'ANTSCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3024, 'GSR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3025, 'WINK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3026, 'BCH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3027, 'POPPY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3028, 'DOTA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3029, 'ADAM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3030, 'EDIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3031, 'OLIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3032, 'CIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3033, 'JOCKER', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3034, 'WRT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3035, 'VRP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3036, 'FUNKCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3037, 'BBH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3038, 'PLAYCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3039, 'LTCU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3040, 'USDE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3041, 'RUPX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3042, 'BENJI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3043, 'CRM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3044, 'SBT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3045, 'RID', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3046, 'RAI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3047, 'SLEEP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3048, 'KARMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3049, 'BCM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3050, 'AGRI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3051, 'SEL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3052, 'CHILL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3053, 'SHDW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3054, 'WCASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3055, 'ANICOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3056, 'WGO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3057, 'WGR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3058, 'VK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3059, 'SIGT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3060, 'EQT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3061, 'LITE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3062, 'NTM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3063, 'RUC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3064, 'HOPE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3065, 'CNX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3066, 'CROC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3067, 'ATB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3068, 'IXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3069, 'IFT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3070, 'DLT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3071, 'IND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3072, 'LUN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3073, 'WHO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3074, 'POM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3075, 'BAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3076, 'EOS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3077, 'GNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3078, 'TNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3079, 'TIME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3080, 'HAC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3081, 'GNO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3082, 'STORJ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3083, 'BNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3084, 'SCL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(3085, 'LTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3086, 'NMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3087, 'PPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3088, 'DASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3089, 'DOGE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3090, 'CAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3091, 'CANN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3092, 'URO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3093, 'OPAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3094, 'VIA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3095, 'SDC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3096, 'START', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3097, 'GSX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3098, 'VTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3099, 'SMBR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3100, 'ETCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3101, 'XQN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3102, 'GML', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3103, 'XPY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3104, 'DGMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3105, 'NOO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3106, 'NAVAJOCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3107, 'NKT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3108, 'EAGS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3109, 'DARKGOLDCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3110, 'SYS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3111, 'TES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3112, 'SBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3113, 'PND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3114, 'XSP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3115, 'XPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3116, 'ZEIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3117, 'MOTO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3118, 'OK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3119, 'SPR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3120, 'FIND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3121, 'NKA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3122, 'CCB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3123, 'CON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3124, 'GP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3125, 'BLU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3126, 'OZC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3127, 'STAKECOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3128, '2015', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3129, 'AM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3130, 'XBS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3131, 'VPN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3132, 'DECR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3133, 'OBS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3134, 'RICE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3135, 'BSTY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3136, 'GIG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3137, 'OMA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3138, 'ICOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3139, 'DGORE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3140, 'AMBER', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3141, 'GEO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3142, 'DGB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3143, 'KOBO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3144, 'YBC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3145, 'KTK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3146, 'CBX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3147, 'NVC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3148, 'SIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3149, 'XVG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3150, 'LTS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3151, 'PEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3152, 'CRIME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3153, 'BTCR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3154, 'BOOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3155, 'GSM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3156, 'PTY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3157, 'VOYA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3158, 'BITB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3159, 'XCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3160, 'EPAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3161, 'BITZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3162, 'TWIST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3163, 'MTLMC3', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3164, 'SLFI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3165, 'STP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3166, 'NXE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3167, 'XAU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3168, 'PXL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3169, 'AECC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3170, 'BTCRY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3171, 'PLANET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3172, 'FIRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3173, 'ANAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3174, 'LDOGE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3175, 'TEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3176, 'ZIRK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3177, 'XDB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3178, 'TAB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3179, 'NDOGE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3180, 'CRAVE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3181, 'ICASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3182, '256', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3183, 'GIFT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3184, 'BBCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3185, 'URC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3186, 'TRICK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3187, 'U', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3188, 'CC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3189, 'METAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3190, 'CLAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3191, 'KARMA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3192, 'CRY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3193, 'MRP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3194, 'TCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3195, 'NOTE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3196, 'RDD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3197, 'CYP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3198, 'GIZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3199, 'XPRO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3200, 'TRON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3201, 'ETRUST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3202, 'FONZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3203, 'EGG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3204, 'LEA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3205, 'HZT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3206, 'P7C', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3207, '8BIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3208, 'TP1', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3209, 'CF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3210, 'CTK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3211, 'NTRN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3212, 'COVEN COIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3213, 'LUX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3214, 'DRZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3215, '007', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3216, 'GRAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3217, 'SIGU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3218, 'QTZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3219, 'DOX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3220, 'XNX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3221, 'XMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3222, 'GUM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3223, 'TDFB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3224, 'BUB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3225, 'UNIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3226, 'GRAV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3227, 'EPY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3228, 'GOAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3229, 'PNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3230, 'UTLE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3231, 'ISL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3232, 'PKB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3233, 'VTN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3234, 'FSN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3235, 'MCAR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3236, 'SHELL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3237, 'BIT16', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3238, 'TB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3239, 'M1', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3240, 'KRAK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3241, 'BA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3242, 'ASTRAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3243, 'MRB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3244, 'BTA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3245, 'EDWARDSNOWDE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3246, 'PTA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3247, 'DCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3248, 'ARB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3249, 'TWERK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3250, 'EQM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3251, 'NICE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3252, 'DB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3253, 'TNG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3254, 'CRYPTOSPOTS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3255, 'SKB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3256, 'GENIUS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3257, 'SED', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3258, 'PRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3259, '32BIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3260, 'FADE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3261, 'SNRG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3262, 'RAD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3263, 'PSY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3264, 'VCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3265, 'MOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3266, 'GREED', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3267, 'EXB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3268, 'OPTION', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3269, 'GLUCK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3270, 'DRA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3271, 'SEEDS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3272, 'NANAS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3273, 'BNBX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3274, 'ARPA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3275, 'VAPOR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3276, 'DUB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3277, 'FIST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3278, 'EOC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3279, 'XCE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3280, 'DRKT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3281, 'TRANSF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3282, 'ILM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3283, 'GENSTAKE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3284, 'FURY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3285, 'SEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3286, 'NODX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3287, 'HEDG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3288, 'SMSR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3289, 'BOD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3290, 'GTFO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3291, 'TENNET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3292, 'KC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3293, 'BLUS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3294, 'XRA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3295, 'LIFEEXTENSIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3296, 'SPX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3297, 'GMCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3298, 'VTX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3299, 'POLY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3300, 'HXX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3301, 'SPKTR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3302, 'GENESISCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3303, 'CRPS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3304, 'BAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3305, 'SJW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3306, 'SPEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3307, 'EA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3308, 'TAGR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3309, 'HAZE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3310, 'NUKE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3311, '2BACCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3312, 'CYC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3313, 'ERR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3314, 'SANDG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3315, 'NOC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3316, 'SHRM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3317, 'ASCENSION', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3318, 'GREXIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3319, 'MIDNIGHT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3320, 'NEBU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3321, 'GE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3322, 'IBITS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3323, 'BIOS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3324, 'CURVES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3325, 'AXIOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3326, 'CHIP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3327, 'IEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3328, 'SPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3329, 'CAPT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3330, 'SAK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3331, 'ROS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3332, 'ACP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3333, 'TAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3334, 'HIFUN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3335, 'NRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3336, 'SQL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3337, 'XFCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3338, 'CIRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3339, 'SOLO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3340, 'ARE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3341, 'BEEZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3342, 'NETC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3343, 'ZOOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3344, 'PAK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3345, 'PEO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3346, 'STRP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3347, 'DETH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3348, 'IOC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3349, 'MYSTIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3350, 'AUM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3351, 'DIRTY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3352, 'SDP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3353, 'L7S', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3354, 'FCASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3355, 'TX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3356, 'AMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3357, 'MAD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3358, 'GLOBALCRYPTO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3359, 'GRF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3360, 'VOL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3361, 'GSY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3362, 'HEEL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3363, 'RBT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3364, 'LHC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3365, 'CLICK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3366, 'PURE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3367, 'PARA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3368, 'N2O', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3369, 'ODNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3370, 'POWER', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3371, 'DCRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3372, 'TWO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3373, 'SCRT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3374, 'LGBTQ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3375, 'TUR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3376, 'EMP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3377, 'XMINE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3378, 'VEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3379, 'NAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3380, 'BTZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3381, 'CME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3382, 'SPACE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3383, 'DOGETH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3384, 'SRND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3385, 'SWING', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3386, 'BRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3387, 'BOLI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3388, 'CAID', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3389, 'STHR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3390, 'MAPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3391, 'FLY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3392, 'BOTCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3393, 'SIB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3394, 'PHR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3395, 'LTD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3396, 'SCITW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3397, 'PSI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3398, 'CYT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3399, 'XSSX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3400, 'INFX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3401, 'STEPS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3402, 'FRDC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3403, 'BSTK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3404, 'TIA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3405, 'XUP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3406, 'HSP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3407, 'SWEET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3408, 'DTT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3409, 'NODES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3410, 'BAN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3411, 'RONIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3412, 'FUZZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3413, 'AUTUMNCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3414, 'XLTCG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3415, 'CV2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3416, 'CB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3417, 'PLNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3418, 'MAZE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3419, 'BSH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3420, 'SMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3421, 'EXPERIENCECO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3422, 'DEM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3423, 'IVZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3424, 'ZUR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3425, 'XDE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3426, 'RMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3427, 'OS76', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3428, 'ADC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3429, 'CUBE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3430, 'DCYP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3431, 'GCR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3432, 'REPUBLICOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3433, 'DISCOUNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3434, 'ANTI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3435, 'EMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3436, 'MONETA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3437, 'LUNARCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3438, 'BSC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3439, 'DEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3440, 'FAUCETCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3441, 'DUO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3442, 'WBB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3443, 'ECLI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3444, 'FRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3445, 'XMT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3446, 'NUBIS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3447, '1337', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3448, 'DGCS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3449, 'MUE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3450, 'BTTF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3451, 'STV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3452, 'RUBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3453, 'LVG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3454, 'MM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3455, 'XSY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3456, 'PXI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3457, 'DFT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3458, 'BST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3459, 'LIMX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3460, 'BDC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3461, 'EVO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3462, 'VEG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3463, 'RNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3464, 'CREVA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3465, 'EVIL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3466, 'JUPITERCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3467, 'X2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3468, 'RATIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3469, 'ZET2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3470, 'DC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3471, 'AV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3472, 'BUCKS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3473, 'BRONZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3474, 'ADZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3475, 'PNK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3476, 'BITON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3477, 'MIS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3478, 'SSC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3479, 'CD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3480, 'RICHX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3481, 'MND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3482, 'EGC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3483, 'C0C0', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3484, 'KGC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3485, 'SXC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3486, 'BAC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3487, 'LTCR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3488, 'SLS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3489, 'HTML', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3490, 'BTP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3491, 'OPES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3492, 'STRB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3493, 'BUZZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3494, 'XDE2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3495, 'JIF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3496, 'NLG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3497, 'BTCU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3498, 'CAPRICOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3499, 'FRN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3500, 'KAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3501, 'SPT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3502, 'LUCKY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3503, 'DUST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3504, 'WARP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3505, 'DRACO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3506, 'LKC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3507, 'MOOND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3508, 'DRM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3509, 'DARKNET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3510, 'ZET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3511, 'NKC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3512, 'BRDD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3513, 'GBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3514, 'STS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3515, 'HIRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3516, 'SIX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3517, 'PEX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3518, 'SUPER', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3519, 'CREDIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3520, 'NPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3521, 'DIME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3522, 'TTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(3523, 'ZMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3524, 'FRK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3525, 'CRW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3526, 'TIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3527, 'CLOAK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3528, 'FFC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3529, 'CLUB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3530, 'RBIES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3531, 'TEK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3532, 'DBLK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3533, 'CYG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3534, 'DBIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3535, 'DCR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3536, 'SPEX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3537, 'TRUMP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3538, 'BIGUP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3539, 'ACLR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3540, 'VAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3541, 'LEAF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3542, 'XJO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3543, 'ARCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3544, 'INC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3545, 'VIP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3546, 'EURC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3547, 'CFC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3548, 'BERN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3549, 'HODL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3550, 'HMP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3551, 'NEVA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3552, 'PAYP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3553, 'UNF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3554, 'ALTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3555, 'PULSE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3556, 'IMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3557, 'IXC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3558, 'PCM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3559, 'CORG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3560, 'TBCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3561, 'HAWK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3562, 'XBU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3563, 'POST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3564, '888', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3565, 'ENE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3566, 'YAC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3567, 'SONG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3568, 'AIB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3569, 'ELCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3570, 'LOOT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3571, 'CZECO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3572, 'EDRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3573, 'JACK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3574, 'ADCN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3575, 'BILL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3576, 'XAV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3577, 'DXC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3578, 'MOJO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3579, 'GBT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3580, 'COXST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3581, 'XNG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3582, 'TCR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3583, 'PINKX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3584, 'BLRY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3585, 'ORLY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3586, 'TKN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3587, 'N7', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3588, 'CLINT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3589, 'BRAIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3590, 'GROW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3591, 'ACID', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3592, 'ESP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3593, 'DISK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3594, 'BOMB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3595, 'TRAP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3596, 'SUBSCRIPTIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3597, 'XBTC21', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3598, 'OP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3599, 'TAK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3600, 'NUM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3601, 'GOTX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3602, 'EDC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3603, 'CHRG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3604, 'APT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3605, 'RCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3606, 'PONZI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3607, 'XPTX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3608, 'LOCOCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3609, 'GRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3610, 'CARBON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3611, 'CST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3612, 'TOOL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3613, 'TECH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3614, 'ACOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3615, 'QBC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3616, 'OCOW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3617, 'LTH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3618, '2GIVE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3619, 'SOUL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3620, 'LANA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3621, 'UAE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3622, 'BOSS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3623, 'WMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3624, 'SPM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3625, 'BVC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3626, 'COMETCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3627, 'UIS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3628, 'SSTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3629, 'PRM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3630, 'MXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3631, 'IONX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3632, 'GHS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3633, 'EKOCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3634, 'B2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3635, 'AUR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3636, 'PONZ2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3637, 'MMXVI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3638, 'GO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3639, 'EUC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3640, 'ETHS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3641, 'EMPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3642, 'CLUD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3643, 'CAB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3644, 'GLC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3645, 'GPU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3646, 'COIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3647, 'PWR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3648, 'VPRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3649, 'SFE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3650, 'INV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3651, 'HCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3652, 'DBTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3653, 'BTCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3654, 'TRA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3655, 'REE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3656, 'MNM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3657, 'FLVR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3658, 'DBG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3659, 'STAR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3660, 'KUBO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3661, 'INCP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3662, 'HVCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3663, 'GB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3664, 'EXIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3665, 'ECCHI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3666, 'BONES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3667, 'MPRO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3668, 'FLX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3669, '404', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3670, 'SHREK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3671, 'COX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3672, 'STA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3673, 'SCAN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3674, 'HTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3675, 'TALK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3676, 'SLING', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3677, 'SP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3678, 'RIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3679, 'XPD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3680, 'ENTRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3681, 'CSMIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3682, 'CHESS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3683, 'NIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3684, 'MARV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3685, 'CHEMX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3686, 'ALC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3687, 'DCK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3688, 'PUT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3689, 'LIR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3690, 'TOKEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3691, 'YAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3692, 'VENE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3693, 'RADI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3694, 'GT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3695, 'CTL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3696, 'AIRCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3697, 'SCRPT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3698, 'IBANK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3699, 'ARTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3700, 'CJ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3701, 'NZC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3702, 'TAJ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3703, 'XT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3704, 'CRAFT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3705, 'RUST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3706, 'FRWC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3707, 'RPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3708, 'POKE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3709, 'GAKH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3710, 'TODAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3711, 'TPG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3712, 'GAIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3713, 'GOON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3714, 'BPOK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3715, 'YMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3716, 'ZNE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3717, 'SCT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3718, 'PAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3719, 'OLYMP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3720, 'PX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3721, 'LC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3722, 'ACES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3723, 'CCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3724, 'CRX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3725, 'WAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3726, 'SYNX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3727, 'SH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3728, 'CRNK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3729, 'B3', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3730, 'XOC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3731, 'XHI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3732, 'BXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3733, 'JWL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3734, 'FX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3735, 'BTD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3736, 'VTY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3737, 'STO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3738, 'VLT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3739, 'TOT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3740, 'TELL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3741, 'TAO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3742, 'RCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3743, 'MST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3744, 'PIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3745, 'ZYD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3746, 'UBIQ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3747, 'DLC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3748, 'RING', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3749, 'ARM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3750, 'SPORT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3751, 'OMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3752, 'XBTS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3753, 'EGO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3754, 'XPO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3755, 'HALLO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3756, 'ATOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3757, 'DPAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3758, 'JOBS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3759, 'PSB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3760, 'BS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3761, 'CRAB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3762, 'FOREX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3763, 'TEAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3764, 'COC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3765, 'CHOOF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3766, 'ROYAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3767, 'DKC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3768, 'EQUAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3769, 'WINE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3770, 'JW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3771, 'ENT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3772, 'BEEP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3773, 'WASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3774, 'RBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3775, 'IMPS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3776, 'BASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3777, 'ZEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3778, 'INSN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3779, 'ASAFE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3780, 'ZLQ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3781, 'ZECD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3782, 'LIV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3783, 'IFLT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3784, 'CBD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3785, 'NBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3786, 'UXC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3787, 'LSD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3788, 'TMRW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3789, 'GAME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3790, 'EMB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3791, '365', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3792, 'NLC2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3793, 'IW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3794, 'FGZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3795, 'BOSON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3796, 'ACPR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3797, 'SCASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3798, 'KURT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3799, 'XCRE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3800, 'SHORTY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3801, 'NODC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3802, 'ICON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3803, 'CORAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3804, 'ARH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3805, 'MONEY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3806, 'BSTAR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3807, 'LOOK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3808, 'JANE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3809, 'IN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3810, 'VIDZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3811, 'YES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3812, 'CG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3813, 'LENIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3814, 'ABY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3815, 'JOK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3816, 'BITCOINPREMI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3817, 'RIDE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3818, 'SMF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3819, 'LEPEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3820, 'CWXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3821, 'POSW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3822, 'PRX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3823, 'ICOB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3824, 'NIXON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3825, 'ALEX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3826, 'MARX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3827, 'VISIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3828, 'NEF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3829, 'MCRN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3830, 'LIZI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3831, 'TSE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3832, 'WISC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3833, 'BIOB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3834, 'ARGUS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3835, 'LUNA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3836, 'STALIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3837, 'MLITE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3838, 'ARCX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3839, 'UNITS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3840, 'CHAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3841, 'MILO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3842, 'GOT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3843, 'VOLT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3844, 'MAVRO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3845, 'ZENI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3846, 'MLNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3847, 'MBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3848, 'TLEX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3849, 'CXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3850, 'CONX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3851, 'NANOX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3852, 'CJC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3853, 'VTL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3854, 'THOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3855, 'CCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3856, 'ALL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3857, 'MCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3858, 'ITI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3859, 'SEV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3860, 'HPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3861, 'ARTA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3862, 'SCS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3863, 'BEST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3864, 'ECO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3865, 'FAZZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3866, 'KUSH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3867, 'BLAZR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3868, 'XVE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3869, 'TAKE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3870, 'STONK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3871, 'VNTX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3872, 'USC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3873, 'ECN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3874, 'UNI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3875, 'KIDS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3876, 'CNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3877, 'FRST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3878, 'XBY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3879, 'AL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3880, 'XVS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3881, 'CKS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3882, 'C2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3883, 'MENTAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3884, 'DASHS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3885, 'MVR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3886, 'DEA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3887, 'PROC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3888, 'MAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3889, 'TLE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3890, 'NETKO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3891, 'XINCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3892, 'TIDE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3893, 'VEC2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3894, 'CNNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3895, 'BAB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3896, 'GLO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3897, 'EVA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3898, 'DUX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3899, 'PARTY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3900, 'PUPA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3901, 'XPS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3902, 'TAP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3903, 'BATL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3904, 'MUU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3905, 'CTIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3906, 'ALIEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3907, 'BITOK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3908, 'GREENF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3909, 'MAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3910, 'MERGEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3911, 'BITS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3912, 'TCN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3913, 'WITCH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3914, 'LUMI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3915, 'XTR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3916, 'CMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3917, 'BHC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3918, 'KASHH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3919, 'VERS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3920, 'F16', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3921, 'FJC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3922, 'PIPR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3923, 'HAMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3924, 'ONX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3925, 'OMGAME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3926, 'JOINTCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3927, 'SKULL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3928, 'XMG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3929, 'WOK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3930, 'HON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3931, 'EGAME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3932, 'PIE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3933, 'FIDGT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3934, 'UDOWN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3935, 'WEEK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3936, 'KINGN COIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3937, 'MAX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3938, 'SLCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3939, 'XNM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3940, 'KISS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3941, 'PROFIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3942, 'TAG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3943, 'SHRP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3944, 'ELC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3945, 'RBY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3946, 'QTM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3947, 'TLOSH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3948, '420G', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3949, 'RBBT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3950, 'SOLAR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3951, 'HYPER', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3952, 'OCEAN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3953, 'ACRN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3954, 'LITEBITCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3955, 'EUROP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3956, 'SOCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3957, 'ROCKET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3958, 'MAO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3959, 'CDO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3960, '700', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3961, 'WOMEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3962, 'MULTI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3963, 'RH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3964, 'WAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3965, 'HMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3966, 'FPC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3967, 'LINDA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3968, 'KGB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3969, 'RSGP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3970, 'RUP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3971, 'DXO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3972, 'PRIMU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3973, 'XGTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3974, 'FIDEL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3975, 'DUR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3976, 'CTIC2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3977, 'INGT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3978, 'GER', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3979, 'ANTSCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3980, 'GSR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3981, 'WINK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3982, 'BCH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3983, 'POPPY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3984, 'DOTA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3985, 'ADAM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3986, 'EDIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3987, 'OLIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3988, 'CIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3989, 'JOCKER', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3990, 'WRT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3991, 'VRP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3992, 'FUNKCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3993, 'BBH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3994, 'PLAYCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3995, 'LTCU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3996, 'USDE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3997, 'RUPX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3998, 'BENJI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(3999, 'CRM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4000, 'SBT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4001, 'RID', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4002, 'RAI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4003, 'SLEEP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4004, 'KARMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4005, 'BCM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4006, 'AGRI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4007, 'SEL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4008, 'CHILL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4009, 'SHDW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4010, 'WCASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4011, 'ANICOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4012, 'WGO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4013, 'WGR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4014, 'VK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4015, 'SIGT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4016, 'EQT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4017, 'LITE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4018, 'NTM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4019, 'RUC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4020, 'HOPE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4021, 'CNX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4022, 'CROC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4023, 'ATB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4024, 'IXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4025, 'IFT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4026, 'DLT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4027, 'IND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4028, 'LUN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4029, 'WHO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4030, 'POM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4031, 'BAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4032, 'EOS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4033, 'GNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4034, 'TNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4035, 'TIME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4036, 'HAC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4037, 'GNO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4038, 'STORJ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4039, 'BNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4040, 'SCL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4041, 'KR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4042, 'EXP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4043, 'DES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4044, 'LSK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4045, 'WAVES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4046, 'RISE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4047, 'DLISK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4048, 'ETC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4049, 'BITSHARES2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4050, 'EBONUS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4051, 'ELE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4052, 'LAZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4053, 'HMQ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4054, 'MCO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4055, 'SNM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4056, 'PING', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4057, 'PLBT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4058, 'INPAY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4059, 'XEM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4060, 'ECOB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4061, 'ZRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4062, 'MGO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(4063, 'LTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4064, 'NMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4065, 'PPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4066, 'DASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4067, 'CAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4068, 'CANN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4069, 'URO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4070, 'OPAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4071, 'VIA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4072, 'SDC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4073, 'START', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4074, 'GSX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4075, 'VTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4076, 'SMBR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4077, 'ETCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4078, 'XQN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4079, 'GML', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4080, 'XPY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4081, 'DGMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4082, 'NOO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4083, 'NAVAJOCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4084, 'NKT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4085, 'EAGS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4086, 'DARKGOLDCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4087, 'SYS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4088, 'TES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4089, 'SBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4090, 'PND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4091, 'XSP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4092, 'XPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4093, 'ZEIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4094, 'MOTO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4095, 'OK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4096, 'SPR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4097, 'FIND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4098, 'NKA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4099, 'CCB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4100, 'CON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4101, 'GP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4102, 'BLU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4103, 'OZC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4104, 'STAKECOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4105, '2015', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4106, 'AM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4107, 'XBS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4108, 'VPN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4109, 'DECR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4110, 'OBS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4111, 'RICE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4112, 'BSTY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4113, 'GIG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4114, 'OMA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4115, 'ICOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4116, 'DGORE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4117, 'AMBER', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4118, 'GEO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4119, 'DGB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4120, 'KOBO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4121, 'YBC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4122, 'KTK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4123, 'CBX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4124, 'NVC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4125, 'SIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4126, 'XVG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4127, 'LTS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4128, 'PEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4129, 'CRIME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4130, 'BTCR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4131, 'BOOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4132, 'GSM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4133, 'PTY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4134, 'VOYA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4135, 'BITB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4136, 'XCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4137, 'EPAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4138, 'BITZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4139, 'TWIST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4140, 'MTLMC3', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4141, 'SLFI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4142, 'STP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4143, 'NXE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4144, 'XAU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4145, 'PXL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4146, 'AECC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4147, 'BTCRY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4148, 'PLANET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4149, 'FIRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4150, 'ANAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4151, 'LDOGE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4152, 'TEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4153, 'ZIRK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4154, 'XDB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4155, 'TAB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4156, 'NDOGE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4157, 'CRAVE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4158, 'ICASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4159, '256', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4160, 'GIFT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4161, 'BBCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4162, 'URC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4163, 'TRICK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4164, 'U', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4165, 'CC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4166, 'METAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4167, 'CLAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4168, 'KARMA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4169, 'CRY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4170, 'MRP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4171, 'TCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4172, 'NOTE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4173, 'RDD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4174, 'CYP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4175, 'GIZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4176, 'XPRO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4177, 'TRON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4178, 'ETRUST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4179, 'FONZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4180, 'EGG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4181, 'LEA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4182, 'HZT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4183, 'P7C', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4184, '8BIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4185, 'TP1', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4186, 'CF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4187, 'CTK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4188, 'NTRN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4189, 'COVEN COIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4190, 'LUX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4191, 'DRZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4192, '007', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4193, 'GRAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4194, 'SIGU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4195, 'QTZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4196, 'DOX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4197, 'XNX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4198, 'XMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4199, 'GUM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4200, 'TDFB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4201, 'BUB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4202, 'UNIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4203, 'GRAV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4204, 'EPY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4205, 'GOAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4206, 'PNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4207, 'UTLE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4208, 'ISL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4209, 'PKB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4210, 'VTN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4211, 'FSN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4212, 'MCAR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4213, 'SHELL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4214, 'BIT16', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4215, 'TB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4216, 'M1', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4217, 'KRAK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4218, 'BA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4219, 'ASTRAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4220, 'MRB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4221, 'BTA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4222, 'EDWARDSNOWDE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4223, 'PTA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4224, 'DCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4225, 'ARB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4226, 'TWERK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4227, 'EQM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4228, 'NICE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4229, 'DB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4230, 'TNG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4231, 'CRYPTOSPOTS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4232, 'SKB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4233, 'GENIUS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4234, 'SED', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4235, 'PRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4236, '32BIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4237, 'FADE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4238, 'SNRG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4239, 'RAD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4240, 'PSY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4241, 'VCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4242, 'MOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4243, 'GREED', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4244, 'EXB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4245, 'OPTION', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4246, 'GLUCK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4247, 'DRA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4248, 'SEEDS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4249, 'NANAS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4250, 'BNBX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4251, 'ARPA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4252, 'VAPOR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4253, 'DUB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4254, 'FIST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4255, 'EOC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4256, 'XCE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4257, 'DRKT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4258, 'TRANSF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4259, 'ILM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4260, 'GENSTAKE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4261, 'FURY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4262, 'SEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4263, 'NODX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4264, 'HEDG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4265, 'SMSR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4266, 'BOD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4267, 'GTFO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4268, 'TENNET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4269, 'KC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4270, 'BLUS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4271, 'XRA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4272, 'LIFEEXTENSIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4273, 'SPX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4274, 'GMCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4275, 'VTX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4276, 'POLY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4277, 'HXX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4278, 'SPKTR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4279, 'GENESISCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4280, 'CRPS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4281, 'BAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4282, 'SJW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4283, 'SPEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4284, 'EA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4285, 'TAGR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4286, 'HAZE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4287, 'NUKE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4288, '2BACCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4289, 'CYC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4290, 'ERR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4291, 'SANDG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4292, 'NOC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4293, 'SHRM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4294, 'ASCENSION', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4295, 'GREXIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4296, 'MIDNIGHT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4297, 'NEBU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4298, 'GE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4299, 'IBITS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4300, 'BIOS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4301, 'CURVES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4302, 'AXIOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4303, 'CHIP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4304, 'IEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4305, 'SPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4306, 'CAPT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4307, 'SAK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4308, 'ROS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4309, 'ACP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4310, 'TAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4311, 'HIFUN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4312, 'NRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4313, 'SQL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4314, 'XFCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4315, 'CIRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4316, 'SOLO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4317, 'ARE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4318, 'BEEZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4319, 'NETC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4320, 'ZOOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4321, 'PAK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4322, 'PEO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4323, 'STRP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4324, 'DETH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4325, 'IOC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4326, 'MYSTIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4327, 'AUM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4328, 'DIRTY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4329, 'SDP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4330, 'L7S', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4331, 'FCASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4332, 'TX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4333, 'AMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4334, 'MAD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4335, 'GLOBALCRYPTO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4336, 'GRF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4337, 'VOL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4338, 'GSY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4339, 'HEEL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4340, 'RBT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4341, 'LHC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4342, 'CLICK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4343, 'PURE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4344, 'PARA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4345, 'N2O', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4346, 'ODNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4347, 'POWER', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4348, 'DCRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4349, 'TWO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4350, 'SCRT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4351, 'LGBTQ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4352, 'TUR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4353, 'EMP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4354, 'XMINE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4355, 'VEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4356, 'NAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4357, 'BTZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4358, 'CME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4359, 'SPACE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4360, 'DOGETH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4361, 'SRND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4362, 'SWING', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4363, 'BRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4364, 'BOLI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4365, 'CAID', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4366, 'STHR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4367, 'MAPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4368, 'FLY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4369, 'BOTCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4370, 'SIB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4371, 'PHR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4372, 'LTD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4373, 'SCITW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4374, 'PSI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4375, 'CYT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4376, 'XSSX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4377, 'INFX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4378, 'STEPS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4379, 'FRDC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4380, 'BSTK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4381, 'TIA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4382, 'XUP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4383, 'HSP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4384, 'SWEET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4385, 'DTT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4386, 'NODES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4387, 'BAN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4388, 'RONIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4389, 'FUZZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4390, 'AUTUMNCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(4391, 'XLTCG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4392, 'CV2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4393, 'CB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4394, 'PLNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4395, 'MAZE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4396, 'BSH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4397, 'SMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4398, 'EXPERIENCECO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4399, 'DEM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4400, 'IVZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4401, 'ZUR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4402, 'XDE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4403, 'RMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4404, 'OS76', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4405, 'ADC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4406, 'CUBE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4407, 'DCYP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4408, 'GCR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4409, 'REPUBLICOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4410, 'DISCOUNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4411, 'ANTI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4412, 'EMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4413, 'MONETA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4414, 'LUNARCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4415, 'BSC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4416, 'DEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4417, 'FAUCETCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4418, 'DUO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4419, 'WBB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4420, 'ECLI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4421, 'FRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4422, 'XMT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4423, 'NUBIS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4424, '1337', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4425, 'DGCS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4426, 'MUE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4427, 'BTTF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4428, 'STV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4429, 'RUBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4430, 'LVG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4431, 'MM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4432, 'XSY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4433, 'PXI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4434, 'DFT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4435, 'BST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4436, 'LIMX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4437, 'BDC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4438, 'EVO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4439, 'VEG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4440, 'RNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4441, 'CREVA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4442, 'EVIL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4443, 'JUPITERCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4444, 'X2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4445, 'RATIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4446, 'ZET2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4447, 'DC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4448, 'AV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4449, 'BUCKS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4450, 'BRONZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4451, 'ADZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4452, 'PNK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4453, 'BITON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4454, 'MIS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4455, 'SSC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4456, 'CD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4457, 'RICHX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4458, 'MND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4459, 'EGC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4460, 'C0C0', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4461, 'KGC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4462, 'SXC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4463, 'BAC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4464, 'LTCR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4465, 'SLS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4466, 'HTML', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4467, 'BTP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4468, 'OPES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4469, 'STRB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4470, 'BUZZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4471, 'XDE2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4472, 'JIF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4473, 'NLG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4474, 'BTCU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4475, 'CAPRICOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4476, 'FRN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4477, 'KAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4478, 'SPT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4479, 'LUCKY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4480, 'DUST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4481, 'WARP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4482, 'DRACO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4483, 'LKC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4484, 'MOOND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4485, 'DRM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4486, 'DARKNET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4487, 'ZET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4488, 'NKC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4489, 'BRDD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4490, 'GBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4491, 'STS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4492, 'HIRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4493, 'SIX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4494, 'PEX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4495, 'SUPER', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4496, 'CREDIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4497, 'NPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4498, 'DIME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4499, 'TTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4500, 'ZMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4501, 'FRK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4502, 'CRW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4503, 'TIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4504, 'CLOAK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4505, 'FFC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4506, 'CLUB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4507, 'RBIES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4508, 'TEK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4509, 'DBLK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4510, 'CYG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4511, 'DBIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4512, 'DCR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4513, 'SPEX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4514, 'TRUMP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4515, 'BIGUP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4516, 'ACLR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4517, 'VAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4518, 'LEAF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4519, 'XJO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4520, 'ARCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4521, 'INC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4522, 'VIP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4523, 'EURC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4524, 'CFC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4525, 'BERN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4526, 'HODL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4527, 'HMP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4528, 'NEVA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4529, 'PAYP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4530, 'UNF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4531, 'ALTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4532, 'PULSE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4533, 'IMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4534, 'IXC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4535, 'PCM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4536, 'CORG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4537, 'TBCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4538, 'HAWK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4539, 'XBU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4540, 'POST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4541, '888', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4542, 'ENE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4543, 'YAC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4544, 'SONG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4545, 'AIB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4546, 'ELCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4547, 'LOOT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4548, 'CZECO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4549, 'EDRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4550, 'JACK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4551, 'ADCN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4552, 'BILL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4553, 'XAV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4554, 'DXC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4555, 'MOJO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4556, 'GBT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4557, 'COXST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4558, 'XNG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4559, 'TCR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4560, 'PINKX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4561, 'BLRY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4562, 'ORLY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4563, 'TKN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4564, 'N7', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4565, 'CLINT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4566, 'BRAIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4567, 'GROW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4568, 'ACID', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4569, 'ESP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4570, 'DISK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4571, 'BOMB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4572, 'TRAP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4573, 'SUBSCRIPTIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4574, 'XBTC21', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4575, 'OP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4576, 'TAK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4577, 'NUM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4578, 'GOTX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4579, 'EDC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4580, 'CHRG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4581, 'APT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4582, 'RCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4583, 'PONZI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4584, 'XPTX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4585, 'LOCOCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4586, 'GRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4587, 'CARBON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4588, 'CST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4589, 'TOOL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4590, 'TECH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4591, 'ACOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4592, 'QBC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4593, 'OCOW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4594, 'LTH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4595, '2GIVE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4596, 'SOUL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4597, 'LANA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4598, 'UAE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4599, 'BOSS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4600, 'WMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4601, 'SPM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4602, 'BVC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4603, 'COMETCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4604, 'UIS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4605, 'SSTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4606, 'PRM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4607, 'MXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4608, 'IONX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4609, 'GHS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4610, 'EKOCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4611, 'B2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4612, 'AUR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4613, 'PONZ2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4614, 'MMXVI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4615, 'GO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4616, 'EUC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4617, 'ETHS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4618, 'EMPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4619, 'CLUD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4620, 'CAB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4621, 'GLC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4622, 'GPU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4623, 'COIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4624, 'PWR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4625, 'VPRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4626, 'SFE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4627, 'INV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4628, 'HCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4629, 'DBTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4630, 'BTCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4631, 'TRA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4632, 'REE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4633, 'MNM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4634, 'FLVR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4635, 'DBG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4636, 'STAR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4637, 'KUBO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4638, 'INCP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4639, 'HVCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4640, 'GB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4641, 'EXIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4642, 'ECCHI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4643, 'BONES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4644, 'MPRO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4645, 'FLX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4646, '404', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4647, 'SHREK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4648, 'COX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4649, 'STA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4650, 'SCAN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4651, 'HTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4652, 'TALK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4653, 'SLING', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4654, 'SP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4655, 'RIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4656, 'XPD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4657, 'ENTRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4658, 'CSMIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4659, 'CHESS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4660, 'NIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4661, 'MARV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4662, 'CHEMX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4663, 'ALC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4664, 'DCK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4665, 'PUT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4666, 'LIR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4667, 'TOKEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4668, 'YAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4669, 'VENE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4670, 'RADI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4671, 'GT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4672, 'CTL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4673, 'AIRCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4674, 'SCRPT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4675, 'IBANK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4676, 'ARTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4677, 'CJ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4678, 'NZC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4679, 'TAJ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4680, 'XT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4681, 'CRAFT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4682, 'RUST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4683, 'FRWC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4684, 'RPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4685, 'POKE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4686, 'GAKH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4687, 'TODAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4688, 'TPG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4689, 'GAIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4690, 'GOON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4691, 'BPOK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4692, 'YMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4693, 'ZNE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4694, 'SCT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4695, 'PAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4696, 'OLYMP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4697, 'PX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4698, 'LC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4699, 'ACES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4700, 'CCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4701, 'CRX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4702, 'WAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4703, 'SYNX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4704, 'SH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4705, 'CRNK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4706, 'B3', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4707, 'XOC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4708, 'XHI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4709, 'BXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4710, 'JWL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4711, 'FX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4712, 'BTD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4713, 'VTY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4714, 'STO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4715, 'VLT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4716, 'TOT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4717, 'TELL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4718, 'TAO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4719, 'RCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4720, 'MST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4721, 'PIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4722, 'ZYD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4723, 'UBIQ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4724, 'DLC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4725, 'RING', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4726, 'ARM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4727, 'SPORT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4728, 'OMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4729, 'XBTS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4730, 'EGO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4731, 'XPO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4732, 'HALLO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4733, 'ATOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4734, 'DPAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4735, 'JOBS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4736, 'PSB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4737, 'BS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4738, 'CRAB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4739, 'FOREX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4740, 'TEAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4741, 'COC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4742, 'CHOOF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4743, 'ROYAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4744, 'DKC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4745, 'EQUAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4746, 'WINE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4747, 'JW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4748, 'ENT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4749, 'BEEP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4750, 'WASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4751, 'RBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4752, 'IMPS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4753, 'BASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4754, 'ZEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4755, 'INSN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4756, 'ASAFE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4757, 'ZLQ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4758, 'ZECD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4759, 'LIV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4760, 'IFLT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4761, 'CBD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4762, 'NBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4763, 'UXC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4764, 'LSD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4765, 'TMRW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4766, 'GAME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4767, 'EMB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4768, '365', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4769, 'NLC2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4770, 'IW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4771, 'FGZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4772, 'BOSON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4773, 'ACPR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4774, 'SCASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4775, 'KURT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4776, 'XCRE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4777, 'SHORTY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4778, 'NODC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4779, 'ICON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4780, 'CORAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4781, 'ARH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4782, 'MONEY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4783, 'BSTAR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4784, 'LOOK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4785, 'JANE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4786, 'IN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4787, 'VIDZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4788, 'YES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4789, 'CG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4790, 'LENIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4791, 'ABY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4792, 'JOK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4793, 'BITCOINPREMI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4794, 'RIDE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4795, 'SMF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4796, 'LEPEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4797, 'CWXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4798, 'POSW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4799, 'PRX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4800, 'ICOB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4801, 'NIXON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4802, 'ALEX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4803, 'MARX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4804, 'VISIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4805, 'NEF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4806, 'MCRN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4807, 'LIZI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4808, 'TSE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4809, 'WISC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4810, 'BIOB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4811, 'ARGUS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4812, 'LUNA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4813, 'STALIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4814, 'MLITE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4815, 'ARCX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4816, 'UNITS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4817, 'CHAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4818, 'MILO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4819, 'GOT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4820, 'VOLT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4821, 'MAVRO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4822, 'ZENI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4823, 'MLNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4824, 'MBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4825, 'TLEX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4826, 'CXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4827, 'CONX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4828, 'NANOX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4829, 'CJC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4830, 'VTL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4831, 'THOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4832, 'CCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4833, 'ALL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4834, 'MCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4835, 'ITI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4836, 'SEV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4837, 'HPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4838, 'ARTA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4839, 'SCS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4840, 'BEST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4841, 'ECO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4842, 'FAZZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4843, 'KUSH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4844, 'BLAZR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4845, 'XVE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4846, 'TAKE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4847, 'STONK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4848, 'VNTX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4849, 'USC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4850, 'ECN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4851, 'UNI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4852, 'KIDS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4853, 'CNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4854, 'FRST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4855, 'XBY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4856, 'AL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4857, 'XVS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4858, 'CKS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4859, 'C2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4860, 'MENTAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4861, 'DASHS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4862, 'MVR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4863, 'DEA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4864, 'PROC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4865, 'MAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4866, 'TLE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4867, 'NETKO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4868, 'XINCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4869, 'TIDE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4870, 'VEC2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4871, 'CNNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4872, 'BAB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4873, 'GLO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4874, 'EVA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4875, 'DUX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4876, 'PARTY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4877, 'PUPA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4878, 'XPS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4879, 'TAP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4880, 'BATL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4881, 'MUU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4882, 'CTIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4883, 'ALIEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4884, 'BITOK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4885, 'GREENF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4886, 'MAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4887, 'MERGEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4888, 'BITS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4889, 'TCN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4890, 'WITCH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4891, 'LUMI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4892, 'XTR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4893, 'CMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4894, 'BHC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4895, 'KASHH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4896, 'VERS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4897, 'F16', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4898, 'FJC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4899, 'PIPR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4900, 'HAMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4901, 'ONX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4902, 'OMGAME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4903, 'JOINTCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4904, 'SKULL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4905, 'XMG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4906, 'WOK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4907, 'HON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4908, 'EGAME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4909, 'PIE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4910, 'FIDGT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4911, 'UDOWN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4912, 'WEEK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4913, 'KINGN COIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4914, 'MAX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4915, 'SLCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4916, 'XNM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4917, 'KISS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4918, 'PROFIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4919, 'TAG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4920, 'SHRP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4921, 'ELC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4922, 'RBY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4923, 'QTM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4924, 'TLOSH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4925, '420G', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4926, 'RBBT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4927, 'SOLAR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4928, 'HYPER', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4929, 'OCEAN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4930, 'ACRN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4931, 'LITEBITCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4932, 'EUROP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4933, 'SOCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4934, 'ROCKET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4935, 'MAO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4936, 'CDO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4937, '700', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4938, 'WOMEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4939, 'MULTI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4940, 'RH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4941, 'WAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4942, 'HMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4943, 'FPC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4944, 'LINDA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4945, 'KGB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4946, 'RSGP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4947, 'RUP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4948, 'DXO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4949, 'PRIMU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4950, 'XGTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4951, 'FIDEL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4952, 'DUR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4953, 'CTIC2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4954, 'INGT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4955, 'GER', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4956, 'ANTSCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4957, 'GSR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4958, 'WINK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4959, 'BCH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4960, 'POPPY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4961, 'DOTA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4962, 'ADAM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4963, 'EDIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4964, 'OLIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4965, 'CIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4966, 'JOCKER', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4967, 'WRT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4968, 'VRP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4969, 'FUNKCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4970, 'BBH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4971, 'PLAYCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4972, 'LTCU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4973, 'USDE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4974, 'RUPX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4975, 'BENJI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4976, 'CRM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4977, 'SBT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4978, 'RID', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4979, 'RAI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4980, 'SLEEP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4981, 'KARMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4982, 'BCM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4983, 'AGRI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4984, 'SEL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4985, 'CHILL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4986, 'SHDW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4987, 'WCASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4988, 'ANICOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4989, 'WGO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4990, 'WGR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4991, 'VK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4992, 'SIGT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4993, 'EQT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4994, 'LITE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4995, 'NTM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4996, 'RUC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4997, 'HOPE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4998, 'CNX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(4999, 'CROC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5000, 'ATB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5001, 'IXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5002, 'IFT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5003, 'DLT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5004, 'IND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5005, 'LUN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5006, 'WHO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5007, 'POM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5008, 'BAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5009, 'EOS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5010, 'GNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5011, 'TNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5012, 'TIME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5013, 'HAC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5014, 'GNO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5015, 'STORJ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5016, 'BNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5017, 'SCL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5018, 'ETH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5019, 'KR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5020, 'EXP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5021, 'DES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5022, 'LSK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5023, 'WAVES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5024, 'RISE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5025, 'DLISK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5026, 'ETC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5027, 'BITSHARES2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5028, 'EBONUS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5029, 'ELE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5030, 'LAZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5031, 'HMQ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5032, 'MCO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5033, 'SNM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5034, 'PING', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5035, 'PLBT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5036, 'INPAY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5037, 'XEM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5038, 'ECOB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5039, 'ZRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5040, 'MGO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(5041, 'LTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5042, 'NMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5043, 'PPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5044, 'DASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5045, 'DOGE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5046, 'CAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5047, 'CANN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5048, 'URO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5049, 'OPAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5050, 'VIA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5051, 'SDC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5052, 'START', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5053, 'GSX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5054, 'VTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5055, 'SMBR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5056, 'ETCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5057, 'XQN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5058, 'GML', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5059, 'XPY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5060, 'DGMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5061, 'NOO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5062, 'NAVAJOCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5063, 'NKT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5064, 'EAGS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5065, 'DARKGOLDCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5066, 'SYS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5067, 'TES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5068, 'SBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5069, 'PND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5070, 'XSP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5071, 'XPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5072, 'ZEIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5073, 'MOTO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5074, 'OK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5075, 'SPR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5076, 'FIND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5077, 'NKA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5078, 'CCB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5079, 'CON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5080, 'GP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5081, 'BLU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5082, 'OZC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5083, 'STAKECOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5084, '2015', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5085, 'AM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5086, 'XBS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5087, 'VPN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5088, 'DECR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5089, 'OBS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5090, 'RICE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5091, 'BSTY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5092, 'GIG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5093, 'OMA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5094, 'ICOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5095, 'DGORE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5096, 'AMBER', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5097, 'GEO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5098, 'DGB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5099, 'KOBO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5100, 'YBC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5101, 'KTK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5102, 'CBX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5103, 'NVC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5104, 'SIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5105, 'XVG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5106, 'LTS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5107, 'PEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5108, 'CRIME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5109, 'BTCR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5110, 'BOOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5111, 'GSM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5112, 'PTY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5113, 'VOYA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5114, 'BITB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5115, 'XCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5116, 'EPAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5117, 'BITZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5118, 'TWIST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5119, 'MTLMC3', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5120, 'SLFI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5121, 'STP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5122, 'NXE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5123, 'XAU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5124, 'PXL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5125, 'AECC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5126, 'BTCRY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5127, 'PLANET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5128, 'FIRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5129, 'ANAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5130, 'LDOGE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5131, 'TEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5132, 'ZIRK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5133, 'XDB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5134, 'TAB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5135, 'NDOGE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5136, 'CRAVE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5137, 'ICASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5138, '256', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5139, 'GIFT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5140, 'BBCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5141, 'URC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5142, 'TRICK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5143, 'U', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5144, 'CC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5145, 'METAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5146, 'CLAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5147, 'KARMA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5148, 'CRY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5149, 'MRP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5150, 'TCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5151, 'NOTE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5152, 'RDD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5153, 'CYP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5154, 'GIZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5155, 'XPRO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5156, 'TRON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5157, 'ETRUST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5158, 'FONZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5159, 'EGG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5160, 'LEA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5161, 'HZT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5162, 'P7C', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5163, '8BIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5164, 'TP1', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5165, 'CF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5166, 'CTK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5167, 'NTRN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5168, 'COVEN COIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5169, 'LUX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5170, 'DRZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5171, '007', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5172, 'GRAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5173, 'SIGU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5174, 'QTZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5175, 'DOX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5176, 'XNX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5177, 'XMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5178, 'GUM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5179, 'TDFB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5180, 'BUB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5181, 'UNIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5182, 'GRAV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5183, 'EPY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5184, 'GOAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5185, 'PNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5186, 'UTLE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5187, 'ISL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5188, 'PKB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5189, 'VTN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5190, 'FSN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5191, 'MCAR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5192, 'SHELL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5193, 'BIT16', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5194, 'TB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5195, 'M1', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5196, 'KRAK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5197, 'BA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5198, 'ASTRAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5199, 'MRB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5200, 'BTA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5201, 'EDWARDSNOWDE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5202, 'PTA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5203, 'DCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5204, 'ARB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5205, 'TWERK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5206, 'EQM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5207, 'NICE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5208, 'DB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5209, 'TNG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5210, 'CRYPTOSPOTS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5211, 'SKB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5212, 'GENIUS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5213, 'SED', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5214, 'PRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5215, '32BIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5216, 'FADE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5217, 'SNRG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5218, 'RAD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5219, 'PSY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5220, 'VCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5221, 'MOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5222, 'GREED', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5223, 'EXB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5224, 'OPTION', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5225, 'GLUCK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5226, 'DRA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5227, 'SEEDS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5228, 'NANAS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5229, 'BNBX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5230, 'ARPA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5231, 'VAPOR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5232, 'DUB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5233, 'FIST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5234, 'EOC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5235, 'XCE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5236, 'DRKT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5237, 'TRANSF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5238, 'ILM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5239, 'GENSTAKE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5240, 'FURY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5241, 'SEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5242, 'NODX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5243, 'HEDG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5244, 'SMSR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5245, 'BOD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5246, 'GTFO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(5247, 'TENNET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5248, 'KC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5249, 'BLUS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5250, 'XRA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5251, 'LIFEEXTENSIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5252, 'SPX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5253, 'GMCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5254, 'VTX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5255, 'POLY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5256, 'HXX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5257, 'SPKTR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5258, 'GENESISCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5259, 'CRPS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5260, 'BAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5261, 'SJW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5262, 'SPEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5263, 'EA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5264, 'TAGR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5265, 'HAZE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5266, 'NUKE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5267, '2BACCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5268, 'CYC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5269, 'ERR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5270, 'SANDG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5271, 'NOC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5272, 'SHRM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5273, 'ASCENSION', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5274, 'GREXIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5275, 'MIDNIGHT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5276, 'NEBU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5277, 'GE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5278, 'IBITS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5279, 'BIOS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5280, 'CURVES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5281, 'AXIOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5282, 'CHIP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5283, 'IEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5284, 'SPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5285, 'CAPT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5286, 'SAK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5287, 'ROS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5288, 'ACP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5289, 'TAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5290, 'HIFUN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5291, 'NRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5292, 'SQL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5293, 'XFCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5294, 'CIRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5295, 'SOLO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5296, 'ARE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5297, 'BEEZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5298, 'NETC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5299, 'ZOOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5300, 'PAK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5301, 'PEO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5302, 'STRP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5303, 'DETH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5304, 'IOC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5305, 'MYSTIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5306, 'AUM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5307, 'DIRTY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5308, 'SDP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5309, 'L7S', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5310, 'FCASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5311, 'TX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5312, 'AMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5313, 'MAD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5314, 'GLOBALCRYPTO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5315, 'GRF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5316, 'VOL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5317, 'GSY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5318, 'HEEL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5319, 'RBT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5320, 'LHC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5321, 'CLICK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5322, 'PURE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5323, 'PARA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5324, 'N2O', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5325, 'ODNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5326, 'POWER', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5327, 'DCRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5328, 'TWO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5329, 'SCRT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5330, 'LGBTQ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5331, 'TUR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5332, 'EMP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5333, 'XMINE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5334, 'VEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5335, 'NAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5336, 'BTZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5337, 'CME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5338, 'SPACE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5339, 'DOGETH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5340, 'SRND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5341, 'SWING', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5342, 'BRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5343, 'BOLI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5344, 'CAID', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5345, 'STHR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5346, 'MAPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5347, 'FLY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5348, 'BOTCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5349, 'SIB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5350, 'PHR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5351, 'LTD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5352, 'SCITW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5353, 'PSI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5354, 'CYT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5355, 'XSSX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5356, 'INFX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5357, 'STEPS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5358, 'FRDC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5359, 'BSTK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5360, 'TIA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5361, 'XUP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5362, 'HSP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5363, 'SWEET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5364, 'DTT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5365, 'NODES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5366, 'BAN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5367, 'RONIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5368, 'FUZZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5369, 'AUTUMNCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5370, 'XLTCG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5371, 'CV2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5372, 'CB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5373, 'PLNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5374, 'MAZE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5375, 'BSH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5376, 'SMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5377, 'EXPERIENCECO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5378, 'DEM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5379, 'IVZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5380, 'ZUR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5381, 'XDE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5382, 'RMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5383, 'OS76', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5384, 'ADC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5385, 'CUBE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5386, 'DCYP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5387, 'GCR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5388, 'REPUBLICOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5389, 'DISCOUNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5390, 'ANTI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5391, 'EMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5392, 'MONETA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5393, 'LUNARCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5394, 'BSC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5395, 'DEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5396, 'FAUCETCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5397, 'DUO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5398, 'WBB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5399, 'ECLI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5400, 'FRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5401, 'XMT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5402, 'NUBIS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5403, '1337', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5404, 'DGCS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5405, 'MUE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5406, 'BTTF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5407, 'STV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5408, 'RUBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5409, 'LVG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5410, 'MM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5411, 'XSY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5412, 'PXI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5413, 'DFT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5414, 'BST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5415, 'LIMX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5416, 'BDC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5417, 'EVO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5418, 'VEG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5419, 'RNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5420, 'CREVA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5421, 'EVIL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5422, 'JUPITERCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5423, 'X2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5424, 'RATIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5425, 'ZET2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5426, 'DC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5427, 'AV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5428, 'BUCKS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5429, 'BRONZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5430, 'ADZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5431, 'PNK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5432, 'BITON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5433, 'MIS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5434, 'SSC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5435, 'CD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5436, 'RICHX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5437, 'MND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5438, 'EGC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5439, 'C0C0', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5440, 'KGC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5441, 'SXC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5442, 'BAC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5443, 'LTCR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5444, 'SLS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5445, 'HTML', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5446, 'BTP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5447, 'OPES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5448, 'STRB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5449, 'BUZZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5450, 'XDE2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5451, 'JIF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5452, 'NLG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5453, 'BTCU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5454, 'CAPRICOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5455, 'FRN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5456, 'KAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5457, 'SPT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5458, 'LUCKY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5459, 'DUST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5460, 'WARP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5461, 'DRACO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5462, 'LKC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5463, 'MOOND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5464, 'DRM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5465, 'DARKNET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5466, 'ZET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5467, 'NKC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5468, 'BRDD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5469, 'GBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5470, 'STS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5471, 'HIRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5472, 'SIX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5473, 'PEX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5474, 'SUPER', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5475, 'CREDIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5476, 'NPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5477, 'DIME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5478, 'TTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5479, 'ZMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5480, 'FRK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5481, 'CRW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5482, 'TIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5483, 'CLOAK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5484, 'FFC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5485, 'CLUB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5486, 'RBIES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5487, 'TEK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5488, 'DBLK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5489, 'CYG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5490, 'DBIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5491, 'DCR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5492, 'SPEX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5493, 'TRUMP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5494, 'BIGUP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5495, 'ACLR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5496, 'VAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5497, 'LEAF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5498, 'XJO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5499, 'ARCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5500, 'INC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5501, 'VIP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5502, 'EURC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5503, 'CFC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5504, 'BERN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5505, 'HODL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5506, 'HMP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5507, 'NEVA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5508, 'PAYP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5509, 'UNF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5510, 'ALTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5511, 'PULSE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5512, 'IMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5513, 'IXC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5514, 'PCM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5515, 'CORG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5516, 'TBCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5517, 'HAWK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5518, 'XBU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5519, 'POST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5520, '888', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5521, 'ENE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5522, 'YAC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5523, 'SONG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5524, 'AIB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5525, 'ELCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5526, 'LOOT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5527, 'CZECO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5528, 'EDRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5529, 'JACK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5530, 'ADCN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5531, 'BILL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5532, 'XAV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5533, 'DXC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5534, 'MOJO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5535, 'GBT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5536, 'COXST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5537, 'XNG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5538, 'TCR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5539, 'PINKX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5540, 'BLRY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5541, 'ORLY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5542, 'TKN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5543, 'N7', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5544, 'CLINT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5545, 'BRAIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5546, 'GROW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5547, 'ACID', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5548, 'ESP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5549, 'DISK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5550, 'BOMB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5551, 'TRAP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5552, 'SUBSCRIPTIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5553, 'XBTC21', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5554, 'OP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5555, 'TAK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5556, 'NUM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5557, 'GOTX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5558, 'EDC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5559, 'CHRG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5560, 'APT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5561, 'RCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5562, 'PONZI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5563, 'XPTX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5564, 'LOCOCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5565, 'GRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5566, 'CARBON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5567, 'CST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5568, 'TOOL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5569, 'TECH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5570, 'ACOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5571, 'QBC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5572, 'OCOW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5573, 'LTH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5574, '2GIVE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5575, 'SOUL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5576, 'LANA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5577, 'UAE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5578, 'BOSS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5579, 'WMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5580, 'SPM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5581, 'BVC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5582, 'COMETCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5583, 'UIS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5584, 'SSTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5585, 'PRM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5586, 'MXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5587, 'IONX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5588, 'GHS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5589, 'EKOCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5590, 'B2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5591, 'AUR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5592, 'PONZ2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5593, 'MMXVI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5594, 'GO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5595, 'EUC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5596, 'ETHS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5597, 'EMPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5598, 'CLUD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5599, 'CAB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5600, 'GLC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5601, 'GPU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5602, 'COIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5603, 'PWR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5604, 'VPRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5605, 'SFE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5606, 'INV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5607, 'HCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5608, 'DBTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5609, 'BTCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5610, 'TRA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5611, 'REE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5612, 'MNM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5613, 'FLVR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5614, 'DBG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5615, 'STAR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5616, 'KUBO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5617, 'INCP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5618, 'HVCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5619, 'GB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5620, 'EXIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5621, 'ECCHI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5622, 'BONES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5623, 'MPRO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5624, 'FLX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5625, '404', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5626, 'SHREK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5627, 'COX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5628, 'STA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5629, 'SCAN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5630, 'HTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5631, 'TALK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5632, 'SLING', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5633, 'SP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5634, 'RIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5635, 'XPD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5636, 'ENTRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5637, 'CSMIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5638, 'CHESS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5639, 'NIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5640, 'MARV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5641, 'CHEMX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5642, 'ALC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5643, 'DCK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5644, 'PUT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5645, 'LIR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5646, 'TOKEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5647, 'YAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5648, 'VENE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5649, 'RADI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5650, 'GT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5651, 'CTL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5652, 'AIRCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5653, 'SCRPT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5654, 'IBANK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5655, 'ARTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5656, 'CJ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5657, 'NZC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5658, 'TAJ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5659, 'XT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5660, 'CRAFT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5661, 'RUST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5662, 'FRWC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5663, 'RPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5664, 'POKE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5665, 'GAKH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5666, 'TODAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5667, 'TPG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5668, 'GAIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5669, 'GOON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5670, 'BPOK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5671, 'YMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5672, 'ZNE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5673, 'SCT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5674, 'PAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5675, 'OLYMP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5676, 'PX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5677, 'LC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5678, 'ACES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5679, 'CCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5680, 'CRX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5681, 'WAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5682, 'SYNX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5683, 'SH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5684, 'CRNK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5685, 'B3', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5686, 'XOC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5687, 'XHI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5688, 'BXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5689, 'JWL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5690, 'FX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5691, 'BTD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5692, 'VTY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5693, 'STO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5694, 'VLT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5695, 'TOT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5696, 'TELL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5697, 'TAO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5698, 'RCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5699, 'MST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5700, 'PIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5701, 'ZYD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5702, 'UBIQ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5703, 'DLC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5704, 'RING', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5705, 'ARM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5706, 'SPORT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5707, 'OMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5708, 'XBTS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5709, 'EGO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5710, 'XPO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5711, 'HALLO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5712, 'ATOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5713, 'DPAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5714, 'JOBS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5715, 'PSB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5716, 'BS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5717, 'CRAB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5718, 'FOREX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5719, 'TEAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5720, 'COC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5721, 'CHOOF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5722, 'ROYAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5723, 'DKC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5724, 'EQUAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5725, 'WINE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5726, 'JW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5727, 'ENT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5728, 'BEEP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5729, 'WASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5730, 'RBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5731, 'IMPS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5732, 'BASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5733, 'ZEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5734, 'INSN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5735, 'ASAFE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5736, 'ZLQ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5737, 'ZECD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5738, 'LIV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5739, 'IFLT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5740, 'CBD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5741, 'NBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5742, 'UXC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5743, 'LSD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5744, 'TMRW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5745, 'GAME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5746, 'EMB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5747, '365', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5748, 'NLC2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5749, 'IW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5750, 'FGZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5751, 'BOSON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5752, 'ACPR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5753, 'SCASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5754, 'KURT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5755, 'XCRE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5756, 'SHORTY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5757, 'NODC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5758, 'ICON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5759, 'CORAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5760, 'ARH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5761, 'MONEY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5762, 'BSTAR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5763, 'LOOK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5764, 'JANE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5765, 'IN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5766, 'VIDZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5767, 'YES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5768, 'CG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5769, 'LENIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5770, 'ABY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5771, 'JOK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5772, 'BITCOINPREMI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5773, 'RIDE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5774, 'SMF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5775, 'LEPEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5776, 'CWXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5777, 'POSW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5778, 'PRX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5779, 'ICOB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5780, 'NIXON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5781, 'ALEX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5782, 'MARX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5783, 'VISIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5784, 'NEF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5785, 'MCRN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5786, 'LIZI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5787, 'TSE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5788, 'WISC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5789, 'BIOB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5790, 'ARGUS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5791, 'LUNA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5792, 'STALIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5793, 'MLITE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5794, 'ARCX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5795, 'UNITS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5796, 'CHAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5797, 'MILO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5798, 'GOT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5799, 'VOLT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5800, 'MAVRO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5801, 'ZENI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5802, 'MLNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5803, 'MBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5804, 'TLEX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5805, 'CXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5806, 'CONX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5807, 'NANOX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5808, 'CJC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5809, 'VTL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5810, 'THOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5811, 'CCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5812, 'ALL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5813, 'MCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5814, 'ITI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5815, 'SEV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5816, 'HPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5817, 'ARTA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5818, 'SCS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5819, 'BEST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5820, 'ECO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5821, 'FAZZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5822, 'KUSH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5823, 'BLAZR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5824, 'XVE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5825, 'TAKE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5826, 'STONK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5827, 'VNTX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5828, 'USC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5829, 'ECN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5830, 'UNI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5831, 'KIDS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5832, 'CNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5833, 'FRST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5834, 'XBY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5835, 'AL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5836, 'XVS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5837, 'CKS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5838, 'C2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5839, 'MENTAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5840, 'DASHS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5841, 'MVR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5842, 'DEA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5843, 'PROC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5844, 'MAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5845, 'TLE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5846, 'NETKO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5847, 'XINCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5848, 'TIDE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5849, 'VEC2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5850, 'CNNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5851, 'BAB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5852, 'GLO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5853, 'EVA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5854, 'DUX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5855, 'PARTY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5856, 'PUPA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5857, 'XPS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5858, 'TAP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5859, 'BATL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5860, 'MUU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5861, 'CTIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5862, 'ALIEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5863, 'BITOK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5864, 'GREENF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5865, 'MAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5866, 'MERGEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5867, 'BITS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5868, 'TCN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5869, 'WITCH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5870, 'LUMI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5871, 'XTR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5872, 'CMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5873, 'BHC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5874, 'KASHH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5875, 'VERS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5876, 'F16', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5877, 'FJC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5878, 'PIPR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5879, 'HAMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5880, 'ONX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5881, 'OMGAME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5882, 'JOINTCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5883, 'SKULL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5884, 'XMG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5885, 'WOK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5886, 'HON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5887, 'EGAME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5888, 'PIE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5889, 'FIDGT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5890, 'UDOWN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5891, 'WEEK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5892, 'KINGN COIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5893, 'MAX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5894, 'SLCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5895, 'XNM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5896, 'KISS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5897, 'PROFIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5898, 'TAG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5899, 'SHRP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5900, 'ELC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5901, 'RBY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5902, 'QTM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5903, 'TLOSH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5904, '420G', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5905, 'RBBT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5906, 'SOLAR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5907, 'HYPER', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5908, 'OCEAN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5909, 'ACRN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5910, 'LITEBITCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5911, 'EUROP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5912, 'SOCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5913, 'ROCKET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5914, 'MAO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5915, 'CDO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5916, '700', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5917, 'WOMEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5918, 'MULTI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5919, 'RH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5920, 'WAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5921, 'HMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5922, 'FPC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5923, 'LINDA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5924, 'KGB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5925, 'RSGP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5926, 'RUP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5927, 'DXO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5928, 'PRIMU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5929, 'XGTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5930, 'FIDEL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5931, 'DUR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5932, 'CTIC2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5933, 'INGT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5934, 'GER', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5935, 'ANTSCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5936, 'GSR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5937, 'WINK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5938, 'BCH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5939, 'POPPY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5940, 'DOTA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5941, 'ADAM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5942, 'EDIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5943, 'OLIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5944, 'CIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5945, 'JOCKER', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5946, 'WRT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5947, 'VRP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5948, 'FUNKCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5949, 'BBH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5950, 'PLAYCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5951, 'LTCU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5952, 'USDE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5953, 'RUPX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5954, 'BENJI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5955, 'CRM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5956, 'SBT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5957, 'RID', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5958, 'RAI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5959, 'SLEEP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5960, 'KARMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5961, 'BCM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5962, 'AGRI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5963, 'SEL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5964, 'CHILL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5965, 'SHDW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5966, 'WCASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5967, 'ANICOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5968, 'WGO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5969, 'WGR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5970, 'VK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5971, 'SIGT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5972, 'EQT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5973, 'LITE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5974, 'NTM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5975, 'RUC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5976, 'HOPE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5977, 'CNX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5978, 'CROC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5979, 'ATB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5980, 'IXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5981, 'IFT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5982, 'DLT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5983, 'IND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5984, 'LUN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5985, 'WHO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5986, 'POM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5987, 'BAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5988, 'EOS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5989, 'GNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5990, 'TNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5991, 'TIME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5992, 'HAC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5993, 'GNO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5994, 'STORJ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5995, 'BNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5996, 'SCL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5997, 'ETH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5998, 'KR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(5999, 'EXP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6000, 'DES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6001, 'LSK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6002, 'RISE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6003, 'DLISK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6004, 'ETC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6005, 'BITSHARES2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6006, 'EBONUS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6007, 'ELE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6008, 'LAZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6009, 'HMQ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6010, 'EDR2', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6011, 'MCO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6012, 'SNM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6013, 'PING', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6014, 'PLBT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6015, 'INPAY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6016, 'XEM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6017, 'ECOB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6018, 'ZRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6019, 'MGO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(6020, 'NMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6021, 'PPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6022, 'CAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6023, 'CANN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6024, 'URO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6025, 'OPAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6026, 'VIA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6027, 'SDC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6028, 'START', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6029, 'GSX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6030, 'VTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6031, 'SMBR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6032, 'ETCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6033, 'XQN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6034, 'GML', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6035, 'XPY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6036, 'DGMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6037, 'NOO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6038, 'NAVAJOCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6039, 'NKT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6040, 'EAGS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6041, 'DARKGOLDCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6042, 'SYS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6043, 'TES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6044, 'SBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6045, 'PND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6046, 'XSP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6047, 'XPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6048, 'ZEIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6049, 'MOTO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6050, 'OK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6051, 'SPR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6052, 'FIND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6053, 'NKA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6054, 'CCB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6055, 'CON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6056, 'GP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6057, 'BLU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6058, 'OZC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6059, 'STAKECOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6060, '2015', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6061, 'AM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6062, 'XBS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6063, 'VPN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6064, 'DECR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6065, 'OBS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6066, 'RICE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6067, 'BSTY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6068, 'GIG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6069, 'OMA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6070, 'ICOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6071, 'DGORE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6072, 'AMBER', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6073, 'GEO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6074, 'DGB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6075, 'KOBO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6076, 'YBC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6077, 'KTK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6078, 'CBX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6079, 'NVC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6080, 'SIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6081, 'XVG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6082, 'LTS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6083, 'PEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6084, 'CRIME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6085, 'BTCR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6086, 'BOOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6087, 'GSM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6088, 'PTY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6089, 'VOYA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6090, 'BITB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6091, 'XCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6092, 'EPAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6093, 'BITZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(6094, 'TWIST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6095, 'MTLMC3', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6096, 'SLFI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6097, 'STP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6098, 'NXE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6099, 'XAU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6100, 'PXL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6101, 'AECC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6102, 'BTCRY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6103, 'PLANET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6104, 'FIRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6105, 'ANAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6106, 'LDOGE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6107, 'TEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6108, 'ZIRK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6109, 'XDB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6110, 'TAB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6111, 'NDOGE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6112, 'CRAVE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6113, 'ICASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6114, '256', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6115, 'GIFT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6116, 'BBCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6117, 'URC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6118, 'TRICK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6119, 'U', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6120, 'CC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6121, 'METAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6122, 'CLAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6123, 'KARMA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6124, 'CRY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6125, 'MRP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6126, 'TCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6127, 'NOTE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6128, 'RDD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6129, 'CYP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6130, 'GIZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6131, 'XPRO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6132, 'TRON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6133, 'ETRUST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6134, 'FONZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6135, 'EGG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6136, 'LEA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6137, 'HZT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6138, 'P7C', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6139, '8BIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6140, 'TP1', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6141, 'CF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6142, 'CTK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6143, 'NTRN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6144, 'COVEN COIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6145, 'LUX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6146, 'DRZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6147, '007', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6148, 'GRAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6149, 'SIGU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6150, 'QTZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6151, 'DOX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6152, 'XNX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6153, 'XMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6154, 'GUM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6155, 'TDFB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6156, 'BUB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6157, 'UNIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6158, 'GRAV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6159, 'EPY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6160, 'GOAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6161, 'PNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6162, 'UTLE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6163, 'ISL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6164, 'PKB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6165, 'VTN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6166, 'FSN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6167, 'MCAR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6168, 'SHELL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6169, 'BIT16', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6170, 'TB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6171, 'M1', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6172, 'KRAK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6173, 'BA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6174, 'ASTRAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6175, 'MRB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6176, 'BTA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6177, 'EDWARDSNOWDE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6178, 'PTA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6179, 'DCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6180, 'ARB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6181, 'TWERK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6182, 'EQM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6183, 'NICE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6184, 'DB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6185, 'TNG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6186, 'CRYPTOSPOTS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6187, 'SKB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6188, 'GENIUS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6189, 'SED', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6190, 'PRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6191, '32BIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6192, 'FADE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6193, 'SNRG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6194, 'RAD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6195, 'PSY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6196, 'VCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6197, 'MOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6198, 'GREED', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6199, 'EXB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6200, 'OPTION', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6201, 'GLUCK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6202, 'DRA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6203, 'SEEDS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6204, 'NANAS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6205, 'BNBX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6206, 'ARPA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6207, 'VAPOR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6208, 'DUB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6209, 'FIST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6210, 'EOC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6211, 'XCE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6212, 'DRKT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6213, 'TRANSF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6214, 'ILM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6215, 'GENSTAKE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6216, 'FURY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6217, 'SEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6218, 'NODX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6219, 'HEDG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6220, 'SMSR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6221, 'BOD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6222, 'GTFO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6223, 'TENNET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6224, 'KC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6225, 'BLUS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6226, 'XRA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6227, 'LIFEEXTENSIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6228, 'SPX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6229, 'GMCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6230, 'VTX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6231, 'POLY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6232, 'HXX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6233, 'SPKTR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6234, 'GENESISCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6235, 'CRPS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6236, 'BAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6237, 'SJW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6238, 'SPEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6239, 'EA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6240, 'TAGR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6241, 'HAZE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6242, 'NUKE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6243, '2BACCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6244, 'CYC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6245, 'ERR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6246, 'SANDG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6247, 'NOC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6248, 'SHRM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6249, 'ASCENSION', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6250, 'GREXIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6251, 'MIDNIGHT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6252, 'NEBU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6253, 'GE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6254, 'IBITS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6255, 'BIOS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6256, 'CURVES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6257, 'AXIOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6258, 'CHIP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6259, 'IEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6260, 'SPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6261, 'CAPT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6262, 'SAK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6263, 'ROS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6264, 'ACP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6265, 'TAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6266, 'HIFUN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6267, 'NRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6268, 'SQL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6269, 'XFCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6270, 'CIRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6271, 'SOLO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6272, 'ARE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6273, 'BEEZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6274, 'NETC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6275, 'ZOOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6276, 'PAK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6277, 'PEO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6278, 'STRP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6279, 'DETH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6280, 'IOC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6281, 'MYSTIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6282, 'AUM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6283, 'DIRTY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6284, 'SDP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6285, 'L7S', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6286, 'FCASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6287, 'TX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6288, 'AMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6289, 'MAD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6290, 'GLOBALCRYPTO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6291, 'GRF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6292, 'VOL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6293, 'GSY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6294, 'HEEL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6295, 'RBT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6296, 'LHC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6297, 'CLICK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6298, 'PURE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6299, 'PARA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6300, 'N2O', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6301, 'ODNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6302, 'POWER', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6303, 'DCRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6304, 'TWO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6305, 'SCRT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6306, 'LGBTQ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6307, 'TUR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6308, 'EMP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6309, 'XMINE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6310, 'VEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6311, 'NAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6312, 'BTZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6313, 'CME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6314, 'SPACE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6315, 'DOGETH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6316, 'SRND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6317, 'SWING', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6318, 'BRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6319, 'BOLI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6320, 'CAID', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6321, 'STHR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6322, 'MAPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6323, 'FLY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6324, 'BOTCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6325, 'SIB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6326, 'PHR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6327, 'LTD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6328, 'SCITW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6329, 'PSI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6330, 'CYT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6331, 'XSSX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6332, 'INFX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6333, 'STEPS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6334, 'FRDC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6335, 'BSTK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6336, 'TIA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6337, 'XUP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6338, 'HSP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6339, 'SWEET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6340, 'DTT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6341, 'NODES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6342, 'BAN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6343, 'RONIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6344, 'FUZZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6345, 'AUTUMNCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6346, 'XLTCG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6347, 'CV2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6348, 'CB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6349, 'PLNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6350, 'MAZE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6351, 'BSH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6352, 'SMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6353, 'EXPERIENCECO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6354, 'DEM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6355, 'IVZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6356, 'ZUR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6357, 'XDE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6358, 'RMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6359, 'OS76', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6360, 'ADC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6361, 'CUBE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6362, 'DCYP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6363, 'GCR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6364, 'REPUBLICOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6365, 'DISCOUNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6366, 'ANTI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6367, 'EMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6368, 'MONETA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6369, 'LUNARCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6370, 'BSC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6371, 'DEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6372, 'FAUCETCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6373, 'DUO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6374, 'WBB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6375, 'ECLI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6376, 'FRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6377, 'XMT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6378, 'NUBIS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6379, '1337', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6380, 'DGCS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6381, 'MUE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6382, 'BTTF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6383, 'STV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6384, 'RUBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6385, 'LVG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6386, 'MM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6387, 'XSY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6388, 'PXI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6389, 'DFT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6390, 'BST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6391, 'LIMX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6392, 'BDC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6393, 'EVO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6394, 'VEG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6395, 'RNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6396, 'CREVA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6397, 'EVIL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6398, 'JUPITERCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6399, 'X2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6400, 'RATIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6401, 'ZET2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6402, 'DC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6403, 'AV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6404, 'BUCKS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6405, 'BRONZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6406, 'ADZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6407, 'PNK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6408, 'BITON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6409, 'MIS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6410, 'SSC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6411, 'CD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6412, 'RICHX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6413, 'MND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6414, 'EGC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6415, 'C0C0', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6416, 'KGC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6417, 'SXC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6418, 'BAC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6419, 'LTCR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6420, 'SLS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6421, 'HTML', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6422, 'BTP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6423, 'OPES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6424, 'STRB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6425, 'BUZZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6426, 'XDE2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6427, 'JIF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6428, 'NLG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6429, 'BTCU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6430, 'CAPRICOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6431, 'FRN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6432, 'KAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6433, 'SPT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6434, 'LUCKY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6435, 'DUST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6436, 'WARP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6437, 'DRACO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6438, 'LKC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6439, 'MOOND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6440, 'DRM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6441, 'DARKNET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6442, 'ZET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6443, 'NKC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6444, 'BRDD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6445, 'GBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6446, 'STS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6447, 'HIRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6448, 'SIX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6449, 'PEX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6450, 'SUPER', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6451, 'CREDIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6452, 'NPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6453, 'DIME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6454, 'TTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6455, 'ZMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6456, 'FRK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6457, 'CRW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6458, 'TIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6459, 'CLOAK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6460, 'FFC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6461, 'CLUB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6462, 'RBIES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6463, 'TEK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6464, 'DBLK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6465, 'CYG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6466, 'DBIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6467, 'DCR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6468, 'SPEX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6469, 'TRUMP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6470, 'BIGUP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6471, 'ACLR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6472, 'VAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6473, 'LEAF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6474, 'XJO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6475, 'ARCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6476, 'INC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6477, 'VIP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6478, 'EURC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6479, 'CFC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6480, 'BERN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6481, 'HODL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6482, 'HMP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6483, 'NEVA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6484, 'PAYP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6485, 'UNF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6486, 'ALTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6487, 'PULSE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6488, 'IMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6489, 'IXC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6490, 'PCM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6491, 'CORG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6492, 'TBCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6493, 'HAWK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6494, 'XBU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6495, 'POST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6496, '888', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6497, 'ENE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6498, 'YAC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6499, 'SONG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6500, 'AIB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6501, 'ELCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6502, 'LOOT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6503, 'CZECO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6504, 'EDRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6505, 'JACK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6506, 'ADCN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6507, 'BILL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6508, 'XAV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6509, 'DXC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6510, 'MOJO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6511, 'GBT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6512, 'COXST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6513, 'XNG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6514, 'TCR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6515, 'PINKX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6516, 'BLRY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6517, 'ORLY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6518, 'TKN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6519, 'N7', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6520, 'CLINT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6521, 'BRAIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6522, 'GROW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6523, 'ACID', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6524, 'ESP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6525, 'DISK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6526, 'BOMB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6527, 'TRAP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6528, 'SUBSCRIPTIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6529, 'XBTC21', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6530, 'OP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6531, 'TAK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6532, 'NUM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6533, 'GOTX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6534, 'EDC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6535, 'CHRG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6536, 'APT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6537, 'RCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6538, 'PONZI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6539, 'XPTX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6540, 'LOCOCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6541, 'GRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6542, 'CARBON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6543, 'CST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6544, 'TOOL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6545, 'TECH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6546, 'ACOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6547, 'QBC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6548, 'OCOW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6549, 'LTH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6550, '2GIVE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6551, 'SOUL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6552, 'LANA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6553, 'UAE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6554, 'BOSS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6555, 'WMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6556, 'SPM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6557, 'BVC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6558, 'COMETCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6559, 'UIS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6560, 'SSTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6561, 'PRM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6562, 'MXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6563, 'IONX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6564, 'GHS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6565, 'EKOCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6566, 'B2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6567, 'AUR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6568, 'PONZ2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6569, 'MMXVI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6570, 'GO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6571, 'EUC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6572, 'ETHS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6573, 'EMPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6574, 'CLUD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6575, 'CAB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6576, 'GLC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6577, 'GPU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6578, 'COIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6579, 'PWR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6580, 'VPRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6581, 'SFE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6582, 'INV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6583, 'HCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6584, 'DBTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6585, 'BTCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6586, 'TRA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6587, 'REE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6588, 'MNM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6589, 'FLVR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6590, 'DBG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6591, 'STAR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6592, 'KUBO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6593, 'INCP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6594, 'HVCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6595, 'GB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6596, 'EXIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6597, 'ECCHI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6598, 'BONES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6599, 'MPRO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6600, 'FLX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6601, '404', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6602, 'SHREK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6603, 'COX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6604, 'STA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6605, 'SCAN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6606, 'HTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6607, 'TALK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6608, 'SLING', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6609, 'SP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6610, 'RIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6611, 'XPD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6612, 'ENTRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6613, 'CSMIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6614, 'CHESS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6615, 'NIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6616, 'MARV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6617, 'CHEMX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6618, 'ALC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6619, 'DCK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6620, 'PUT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6621, 'LIR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6622, 'TOKEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6623, 'YAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6624, 'VENE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6625, 'RADI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6626, 'GT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6627, 'CTL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6628, 'AIRCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6629, 'SCRPT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6630, 'IBANK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6631, 'ARTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6632, 'CJ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6633, 'NZC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6634, 'TAJ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6635, 'XT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6636, 'CRAFT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6637, 'RUST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6638, 'FRWC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6639, 'RPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6640, 'POKE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6641, 'GAKH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6642, 'TODAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6643, 'TPG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6644, 'GAIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6645, 'GOON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6646, 'BPOK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6647, 'YMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6648, 'ZNE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6649, 'SCT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6650, 'PAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6651, 'OLYMP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6652, 'PX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6653, 'LC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6654, 'ACES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6655, 'CCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6656, 'CRX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6657, 'WAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6658, 'SYNX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6659, 'SH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6660, 'CRNK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6661, 'B3', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6662, 'XOC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6663, 'XHI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6664, 'BXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6665, 'JWL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6666, 'FX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6667, 'BTD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6668, 'VTY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6669, 'STO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6670, 'VLT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6671, 'TOT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6672, 'TELL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6673, 'TAO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6674, 'RCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6675, 'MST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6676, 'PIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6677, 'ZYD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6678, 'UBIQ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6679, 'DLC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6680, 'RING', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6681, 'ARM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6682, 'SPORT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6683, 'OMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6684, 'XBTS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6685, 'EGO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6686, 'XPO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6687, 'HALLO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6688, 'ATOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6689, 'DPAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6690, 'JOBS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6691, 'PSB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6692, 'BS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6693, 'CRAB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6694, 'FOREX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6695, 'TEAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6696, 'COC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6697, 'CHOOF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6698, 'ROYAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6699, 'DKC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6700, 'EQUAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6701, 'WINE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6702, 'JW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6703, 'ENT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6704, 'BEEP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6705, 'WASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6706, 'RBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6707, 'IMPS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6708, 'BASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6709, 'ZEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6710, 'INSN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6711, 'ASAFE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6712, 'ZLQ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6713, 'ZECD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6714, 'LIV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6715, 'IFLT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6716, 'CBD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6717, 'NBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6718, 'UXC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6719, 'LSD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6720, 'TMRW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6721, 'GAME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6722, 'EMB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6723, '365', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6724, 'NLC2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6725, 'IW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6726, 'FGZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6727, 'BOSON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6728, 'ACPR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6729, 'SCASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6730, 'KURT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6731, 'XCRE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6732, 'SHORTY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6733, 'NODC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6734, 'ICON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6735, 'CORAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6736, 'ARH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6737, 'MONEY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6738, 'BSTAR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6739, 'LOOK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6740, 'JANE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6741, 'IN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6742, 'VIDZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6743, 'YES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6744, 'CG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6745, 'LENIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6746, 'ABY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6747, 'JOK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6748, 'BITCOINPREMI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6749, 'RIDE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6750, 'SMF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6751, 'LEPEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6752, 'CWXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6753, 'POSW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6754, 'PRX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6755, 'ICOB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6756, 'NIXON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6757, 'ALEX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6758, 'MARX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6759, 'VISIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6760, 'NEF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6761, 'MCRN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6762, 'LIZI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6763, 'TSE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6764, 'WISC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6765, 'BIOB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6766, 'ARGUS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6767, 'LUNA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6768, 'STALIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6769, 'MLITE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6770, 'ARCX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6771, 'UNITS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6772, 'CHAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6773, 'MILO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6774, 'GOT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6775, 'VOLT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6776, 'MAVRO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6777, 'ZENI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6778, 'MLNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6779, 'MBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6780, 'TLEX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6781, 'CXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6782, 'CONX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6783, 'NANOX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6784, 'CJC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6785, 'VTL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6786, 'THOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6787, 'CCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6788, 'ALL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6789, 'MCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6790, 'ITI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6791, 'SEV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6792, 'HPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6793, 'ARTA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6794, 'SCS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6795, 'BEST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6796, 'ECO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6797, 'FAZZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6798, 'KUSH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6799, 'BLAZR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6800, 'XVE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6801, 'TAKE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6802, 'STONK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6803, 'VNTX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6804, 'USC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6805, 'ECN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6806, 'UNI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6807, 'KIDS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6808, 'CNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6809, 'FRST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6810, 'XBY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6811, 'AL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6812, 'XVS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6813, 'CKS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6814, 'C2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6815, 'MENTAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6816, 'DASHS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6817, 'MVR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6818, 'DEA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6819, 'PROC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6820, 'MAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6821, 'TLE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6822, 'NETKO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6823, 'XINCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6824, 'TIDE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6825, 'VEC2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6826, 'CNNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6827, 'BAB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6828, 'GLO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6829, 'EVA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6830, 'DUX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6831, 'PARTY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6832, 'PUPA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6833, 'XPS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6834, 'TAP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6835, 'BATL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6836, 'MUU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6837, 'CTIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6838, 'ALIEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6839, 'BITOK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6840, 'GREENF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6841, 'MAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6842, 'MERGEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6843, 'BITS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6844, 'TCN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6845, 'WITCH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6846, 'LUMI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6847, 'XTR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6848, 'CMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6849, 'BHC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6850, 'KASHH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6851, 'VERS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6852, 'F16', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6853, 'FJC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6854, 'PIPR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6855, 'HAMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6856, 'ONX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6857, 'OMGAME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6858, 'JOINTCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6859, 'SKULL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6860, 'XMG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6861, 'WOK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6862, 'HON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6863, 'EGAME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6864, 'PIE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6865, 'FIDGT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6866, 'UDOWN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6867, 'WEEK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6868, 'KINGN COIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6869, 'MAX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6870, 'SLCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6871, 'XNM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6872, 'KISS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6873, 'PROFIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6874, 'TAG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6875, 'SHRP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6876, 'ELC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6877, 'RBY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6878, 'QTM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6879, 'TLOSH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6880, '420G', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6881, 'RBBT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6882, 'SOLAR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6883, 'HYPER', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6884, 'OCEAN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6885, 'ACRN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6886, 'LITEBITCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6887, 'EUROP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6888, 'SOCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6889, 'ROCKET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6890, 'MAO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6891, 'CDO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6892, '700', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6893, 'WOMEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6894, 'MULTI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6895, 'RH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6896, 'WAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6897, 'HMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6898, 'FPC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6899, 'LINDA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6900, 'KGB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6901, 'RSGP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6902, 'RUP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6903, 'DXO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6904, 'PRIMU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6905, 'XGTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6906, 'FIDEL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6907, 'DUR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6908, 'CTIC2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6909, 'INGT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6910, 'GER', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6911, 'ANTSCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6912, 'GSR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6913, 'WINK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6914, 'POPPY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6915, 'DOTA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6916, 'ADAM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6917, 'EDIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6918, 'OLIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6919, 'CIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6920, 'JOCKER', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6921, 'WRT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6922, 'VRP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6923, 'FUNKCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6924, 'BBH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6925, 'PLAYCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6926, 'LTCU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6927, 'USDE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6928, 'RUPX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6929, 'BENJI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6930, 'CRM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6931, 'SBT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6932, 'RID', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6933, 'RAI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6934, 'SLEEP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6935, 'KARMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6936, 'BCM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6937, 'AGRI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6938, 'SEL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6939, 'CHILL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6940, 'SHDW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6941, 'WCASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6942, 'ANICOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6943, 'WGO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6944, 'WGR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6945, 'VK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6946, 'SIGT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6947, 'EQT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6948, 'LITE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6949, 'NTM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6950, 'RUC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6951, 'HOPE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6952, 'CNX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6953, 'CROC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6954, 'ATB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6955, 'IXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6956, 'IFT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6957, 'DLT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6958, 'IND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6959, 'LUN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6960, 'WHO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6961, 'POM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6962, 'BAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6963, 'EOS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6964, 'GNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6965, 'TNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6966, 'TIME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6967, 'HAC', 'USD', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(6968, 'GNO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6969, 'STORJ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6970, 'BNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6971, 'SCL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6972, 'KR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6973, 'EXP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6974, 'DES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6975, 'LSK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6976, 'WAVES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6977, 'RISE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6978, 'DLISK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6979, 'ETC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6980, 'BITSHARES2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6981, 'ELE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6982, 'LAZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6983, 'HMQ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6984, 'MCO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6985, 'SNM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6986, 'PING', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6987, 'PLBT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6988, 'INPAY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6989, 'XEM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6990, 'ECOB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6991, 'ZRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6992, 'MGO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(6993, 'NMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(6994, 'PPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(6995, 'CAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(6996, 'CANN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(6997, 'URO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(6998, 'OPAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(6999, 'VIA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7000, 'SDC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7001, 'START', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7002, 'GSX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7003, 'VTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7004, 'SMBR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7005, 'ETCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7006, 'XQN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7007, 'GML', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7008, 'XPY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7009, 'DGMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7010, 'NOO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7011, 'NAVAJOCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7012, 'NKT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7013, 'EAGS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7014, 'DARKGOLDCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7015, 'SYS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7016, 'TES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7017, 'SBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7018, 'PND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7019, 'XSP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7020, 'XPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7021, 'ZEIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7022, 'MOTO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7023, 'OK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7024, 'SPR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7025, 'FIND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7026, 'NKA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7027, 'CCB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7028, 'CON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7029, 'GP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7030, 'BLU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7031, 'OZC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7032, 'STAKECOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7033, '2015', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7034, 'AM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7035, 'XBS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7036, 'VPN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7037, 'DECR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7038, 'OBS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7039, 'RICE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7040, 'BSTY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7041, 'GIG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7042, 'OMA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7043, 'ICOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7044, 'DGORE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7045, 'AMBER', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7046, 'GEO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7047, 'DGB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7048, 'KOBO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7049, 'YBC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7050, 'KTK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7051, 'CBX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7052, 'NVC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7053, 'SIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7054, 'XVG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7055, 'LTS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7056, 'PEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7057, 'CRIME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7058, 'BTCR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7059, 'BOOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7060, 'GSM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7061, 'PTY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7062, 'VOYA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7063, 'BITB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7064, 'XCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7065, 'EPAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7066, 'BITZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7067, 'TWIST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7068, 'MTLMC3', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7069, 'SLFI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7070, 'STP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7071, 'NXE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7072, 'XAU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7073, 'PXL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7074, 'AECC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7075, 'BTCRY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7076, 'PLANET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7077, 'FIRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7078, 'ANAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7079, 'LDOGE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7080, 'TEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7081, 'ZIRK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7082, 'XDB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7083, 'TAB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7084, 'NDOGE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7085, 'CRAVE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7086, 'ICASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7087, '256', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7088, 'GIFT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7089, 'BBCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7090, 'URC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7091, 'TRICK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7092, 'U', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7093, 'CC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7094, 'METAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7095, 'CLAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7096, 'KARMA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7097, 'CRY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7098, 'MRP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7099, 'TCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7100, 'NOTE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7101, 'RDD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7102, 'CYP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7103, 'GIZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7104, 'XPRO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7105, 'TRON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7106, 'ETRUST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7107, 'FONZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7108, 'EGG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7109, 'LEA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7110, 'HZT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7111, 'P7C', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7112, '8BIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7113, 'TP1', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7114, 'CF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7115, 'CTK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7116, 'NTRN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7117, 'COVEN COIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7118, 'LUX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7119, 'DRZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7120, '007', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7121, 'GRAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7122, 'SIGU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7123, 'QTZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7124, 'DOX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7125, 'XNX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7126, 'XMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7127, 'GUM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7128, 'TDFB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7129, 'BUB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7130, 'UNIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7131, 'GRAV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7132, 'EPY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7133, 'GOAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7134, 'PNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7135, 'UTLE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7136, 'ISL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7137, 'PKB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7138, 'VTN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7139, 'FSN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7140, 'MCAR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7141, 'SHELL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7142, 'BIT16', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7143, 'TB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7144, 'M1', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7145, 'KRAK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7146, 'BA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7147, 'ASTRAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7148, 'MRB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7149, 'BTA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7150, 'EDWARDSNOWDE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7151, 'PTA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7152, 'DCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7153, 'ARB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7154, 'TWERK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7155, 'EQM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7156, 'NICE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7157, 'DB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7158, 'TNG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7159, 'CRYPTOSPOTS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7160, 'SKB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7161, 'GENIUS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7162, 'SED', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7163, 'PRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7164, '32BIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7165, 'FADE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7166, 'SNRG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7167, 'RAD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7168, 'PSY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7169, 'VCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7170, 'MOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7171, 'GREED', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7172, 'EXB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7173, 'OPTION', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7174, 'GLUCK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7175, 'DRA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7176, 'SEEDS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7177, 'NANAS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7178, 'BNBX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7179, 'ARPA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7180, 'VAPOR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7181, 'DUB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7182, 'FIST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7183, 'EOC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7184, 'XCE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7185, 'DRKT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7186, 'TRANSF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7187, 'ILM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7188, 'GENSTAKE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7189, 'FURY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7190, 'SEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7191, 'NODX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7192, 'HEDG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7193, 'SMSR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7194, 'BOD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7195, 'GTFO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7196, 'TENNET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7197, 'KC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7198, 'BLUS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7199, 'XRA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7200, 'LIFEEXTENSIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7201, 'SPX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7202, 'GMCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7203, 'VTX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7204, 'POLY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7205, 'HXX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7206, 'SPKTR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7207, 'GENESISCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7208, 'CRPS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7209, 'BAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7210, 'SJW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7211, 'SPEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7212, 'EA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7213, 'TAGR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7214, 'HAZE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7215, 'NUKE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7216, '2BACCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7217, 'CYC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7218, 'ERR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7219, 'SANDG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7220, 'NOC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7221, 'SHRM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7222, 'ASCENSION', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7223, 'GREXIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7224, 'MIDNIGHT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7225, 'NEBU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7226, 'GE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7227, 'IBITS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7228, 'BIOS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7229, 'CURVES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7230, 'AXIOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7231, 'CHIP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7232, 'IEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7233, 'SPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7234, 'CAPT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7235, 'SAK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7236, 'ROS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7237, 'ACP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7238, 'TAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7239, 'HIFUN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7240, 'NRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7241, 'SQL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7242, 'XFCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7243, 'CIRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7244, 'SOLO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7245, 'ARE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7246, 'BEEZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7247, 'NETC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7248, 'ZOOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7249, 'PAK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7250, 'PEO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7251, 'STRP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7252, 'DETH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7253, 'IOC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7254, 'MYSTIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7255, 'AUM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7256, 'DIRTY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7257, 'SDP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7258, 'L7S', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7259, 'FCASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7260, 'TX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7261, 'AMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7262, 'MAD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7263, 'GLOBALCRYPTO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7264, 'GRF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7265, 'VOL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7266, 'GSY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7267, 'HEEL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7268, 'RBT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7269, 'LHC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7270, 'CLICK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7271, 'PURE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7272, 'PARA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7273, 'N2O', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7274, 'ODNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7275, 'POWER', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7276, 'DCRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7277, 'TWO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7278, 'SCRT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7279, 'LGBTQ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7280, 'TUR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7281, 'EMP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7282, 'XMINE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7283, 'VEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7284, 'NAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7285, 'BTZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7286, 'CME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7287, 'SPACE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7288, 'DOGETH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7289, 'SRND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7290, 'SWING', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7291, 'BRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7292, 'BOLI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7293, 'CAID', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7294, 'STHR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7295, 'MAPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7296, 'FLY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7297, 'BOTCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7298, 'PHR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7299, 'LTD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7300, 'SCITW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7301, 'PSI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7302, 'CYT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7303, 'XSSX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7304, 'INFX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7305, 'STEPS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7306, 'FRDC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7307, 'BSTK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7308, 'TIA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7309, 'XUP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7310, 'HSP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7311, 'SWEET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7312, 'DTT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7313, 'NODES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7314, 'BAN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7315, 'RONIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7316, 'FUZZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7317, 'AUTUMNCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7318, 'XLTCG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7319, 'CV2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7320, 'CB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7321, 'PLNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7322, 'MAZE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7323, 'BSH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7324, 'SMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7325, 'EXPERIENCECO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7326, 'DEM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7327, 'IVZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7328, 'ZUR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7329, 'XDE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7330, 'RMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7331, 'OS76', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7332, 'ADC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7333, 'CUBE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7334, 'DCYP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7335, 'GCR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7336, 'REPUBLICOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7337, 'DISCOUNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7338, 'ANTI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7339, 'EMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7340, 'MONETA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7341, 'LUNARCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7342, 'BSC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7343, 'DEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7344, 'FAUCETCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7345, 'DUO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7346, 'WBB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7347, 'ECLI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7348, 'FRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7349, 'XMT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7350, 'NUBIS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7351, '1337', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7352, 'DGCS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7353, 'MUE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7354, 'BTTF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7355, 'STV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7356, 'RUBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7357, 'LVG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7358, 'MM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7359, 'XSY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7360, 'PXI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7361, 'DFT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7362, 'BST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7363, 'LIMX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7364, 'BDC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7365, 'EVO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7366, 'VEG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7367, 'RNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7368, 'CREVA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7369, 'EVIL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7370, 'JUPITERCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7371, 'X2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7372, 'RATIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7373, 'ZET2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7374, 'DC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7375, 'AV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7376, 'BUCKS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7377, 'BRONZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7378, 'ADZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7379, 'PNK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7380, 'BITON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7381, 'MIS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7382, 'SSC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7383, 'CD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7384, 'RICHX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7385, 'MND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7386, 'EGC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7387, 'C0C0', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7388, 'KGC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7389, 'SXC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7390, 'BAC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7391, 'LTCR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7392, 'SLS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7393, 'HTML', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7394, 'BTP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7395, 'OPES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7396, 'STRB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7397, 'BUZZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7398, 'XDE2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7399, 'JIF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7400, 'NLG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7401, 'BTCU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7402, 'CAPRICOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7403, 'FRN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7404, 'KAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7405, 'SPT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7406, 'LUCKY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7407, 'DUST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7408, 'WARP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7409, 'DRACO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7410, 'LKC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7411, 'MOOND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7412, 'DRM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7413, 'DARKNET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7414, 'ZET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7415, 'NKC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7416, 'BRDD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7417, 'GBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7418, 'STS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7419, 'HIRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7420, 'SIX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7421, 'PEX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7422, 'SUPER', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7423, 'CREDIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7424, 'NPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7425, 'DIME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7426, 'TTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7427, 'ZMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7428, 'FRK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7429, 'CRW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7430, 'TIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7431, 'CLOAK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7432, 'FFC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7433, 'CLUB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7434, 'RBIES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7435, 'TEK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7436, 'DBLK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7437, 'CYG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7438, 'DBIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7439, 'DCR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7440, 'SPEX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7441, 'TRUMP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7442, 'BIGUP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7443, 'ACLR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7444, 'VAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7445, 'LEAF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7446, 'XJO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7447, 'ARCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7448, 'INC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7449, 'VIP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7450, 'EURC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7451, 'CFC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7452, 'BERN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7453, 'HODL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7454, 'HMP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7455, 'NEVA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7456, 'PAYP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7457, 'UNF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7458, 'ALTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7459, 'PULSE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7460, 'IMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7461, 'IXC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7462, 'PCM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7463, 'CORG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7464, 'TBCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7465, 'HAWK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7466, 'XBU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7467, 'POST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7468, '888', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7469, 'ENE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7470, 'YAC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7471, 'SONG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7472, 'AIB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7473, 'ELCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7474, 'LOOT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7475, 'CZECO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7476, 'EDRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7477, 'JACK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7478, 'ADCN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7479, 'BILL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7480, 'XAV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7481, 'DXC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7482, 'MOJO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7483, 'GBT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7484, 'COXST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7485, 'XNG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7486, 'TCR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7487, 'PINKX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7488, 'BLRY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7489, 'ORLY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7490, 'TKN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7491, 'N7', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7492, 'CLINT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7493, 'BRAIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7494, 'GROW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7495, 'ACID', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7496, 'ESP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7497, 'DISK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7498, 'BOMB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7499, 'TRAP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7500, 'SUBSCRIPTIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7501, 'XBTC21', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7502, 'OP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7503, 'TAK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7504, 'NUM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7505, 'GOTX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7506, 'EDC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7507, 'CHRG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7508, 'APT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7509, 'RCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7510, 'PONZI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7511, 'XPTX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7512, 'LOCOCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7513, 'GRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7514, 'CARBON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7515, 'CST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7516, 'TOOL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7517, 'TECH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7518, 'ACOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7519, 'QBC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7520, 'OCOW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7521, 'LTH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7522, '2GIVE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7523, 'SOUL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7524, 'LANA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7525, 'UAE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7526, 'BOSS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7527, 'WMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7528, 'SPM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7529, 'BVC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7530, 'COMETCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7531, 'UIS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7532, 'SSTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7533, 'PRM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7534, 'MXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7535, 'IONX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7536, 'GHS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7537, 'EKOCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7538, 'B2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7539, 'AUR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7540, 'PONZ2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7541, 'MMXVI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7542, 'GO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7543, 'EUC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7544, 'ETHS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7545, 'EMPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7546, 'CLUD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7547, 'CAB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7548, 'GLC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7549, 'GPU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7550, 'COIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7551, 'PWR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7552, 'VPRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7553, 'SFE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7554, 'INV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7555, 'HCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7556, 'DBTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7557, 'BTCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7558, 'TRA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7559, 'REE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7560, 'MNM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7561, 'FLVR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7562, 'DBG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7563, 'STAR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7564, 'KUBO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7565, 'INCP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7566, 'HVCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7567, 'GB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7568, 'EXIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7569, 'ECCHI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7570, 'BONES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7571, 'MPRO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7572, 'FLX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7573, '404', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7574, 'SHREK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7575, 'COX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7576, 'STA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7577, 'SCAN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7578, 'HTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7579, 'TALK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7580, 'SLING', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7581, 'SP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7582, 'RIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7583, 'XPD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7584, 'ENTRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7585, 'CSMIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7586, 'CHESS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7587, 'NIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7588, 'MARV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7589, 'CHEMX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7590, 'ALC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7591, 'DCK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7592, 'PUT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7593, 'LIR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7594, 'TOKEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7595, 'YAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7596, 'VENE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7597, 'RADI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7598, 'GT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7599, 'CTL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7600, 'AIRCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7601, 'SCRPT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7602, 'IBANK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7603, 'ARTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7604, 'CJ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7605, 'NZC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7606, 'TAJ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7607, 'XT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7608, 'CRAFT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7609, 'RUST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7610, 'FRWC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7611, 'RPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7612, 'POKE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7613, 'GAKH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7614, 'TODAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7615, 'TPG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7616, 'GAIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7617, 'GOON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7618, 'BPOK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7619, 'YMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7620, 'ZNE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7621, 'SCT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7622, 'PAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7623, 'OLYMP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7624, 'PX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7625, 'LC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7626, 'ACES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7627, 'CCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7628, 'CRX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7629, 'WAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7630, 'SYNX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7631, 'SH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7632, 'CRNK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7633, 'B3', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7634, 'XOC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7635, 'XHI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7636, 'BXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7637, 'JWL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7638, 'FX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7639, 'BTD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7640, 'VTY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7641, 'STO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7642, 'VLT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7643, 'TOT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7644, 'TELL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7645, 'TAO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7646, 'RCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7647, 'MST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7648, 'PIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7649, 'ZYD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7650, 'UBIQ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7651, 'DLC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7652, 'RING', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7653, 'ARM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7654, 'SPORT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7655, 'OMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7656, 'XBTS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7657, 'EGO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7658, 'XPO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7659, 'HALLO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7660, 'ATOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7661, 'DPAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7662, 'JOBS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7663, 'PSB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7664, 'BS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7665, 'CRAB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7666, 'FOREX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7667, 'TEAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7668, 'COC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7669, 'CHOOF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7670, 'ROYAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7671, 'DKC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7672, 'EQUAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7673, 'WINE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7674, 'JW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7675, 'ENT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7676, 'BEEP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7677, 'WASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7678, 'RBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7679, 'IMPS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7680, 'BASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7681, 'ZEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7682, 'INSN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7683, 'ASAFE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7684, 'ZLQ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7685, 'ZECD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7686, 'LIV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7687, 'IFLT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7688, 'CBD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7689, 'NBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7690, 'UXC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7691, 'LSD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7692, 'TMRW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7693, 'GAME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7694, 'EMB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7695, '365', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7696, 'NLC2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7697, 'IW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7698, 'FGZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7699, 'BOSON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7700, 'ACPR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7701, 'SCASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7702, 'KURT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7703, 'XCRE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7704, 'SHORTY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7705, 'NODC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7706, 'ICON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7707, 'CORAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7708, 'ARH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7709, 'MONEY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7710, 'BSTAR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7711, 'LOOK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7712, 'JANE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7713, 'IN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7714, 'VIDZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7715, 'YES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7716, 'CG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7717, 'LENIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7718, 'ABY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7719, 'JOK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7720, 'BITCOINPREMI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7721, 'RIDE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7722, 'SMF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7723, 'LEPEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7724, 'CWXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7725, 'POSW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7726, 'PRX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7727, 'ICOB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7728, 'NIXON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7729, 'ALEX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7730, 'MARX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7731, 'VISIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7732, 'NEF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7733, 'MCRN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7734, 'LIZI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7735, 'TSE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7736, 'WISC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7737, 'BIOB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7738, 'ARGUS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7739, 'LUNA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7740, 'STALIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7741, 'MLITE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7742, 'ARCX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7743, 'UNITS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7744, 'CHAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7745, 'MILO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7746, 'GOT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7747, 'VOLT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7748, 'MAVRO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7749, 'ZENI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7750, 'MLNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7751, 'MBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7752, 'TLEX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7753, 'CXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7754, 'CONX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7755, 'NANOX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7756, 'CJC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7757, 'VTL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7758, 'THOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7759, 'CCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7760, 'ALL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7761, 'MCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7762, 'ITI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7763, 'SEV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7764, 'HPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7765, 'ARTA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7766, 'SCS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7767, 'BEST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7768, 'ECO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7769, 'FAZZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7770, 'KUSH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7771, 'BLAZR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7772, 'XVE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7773, 'TAKE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7774, 'STONK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7775, 'VNTX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7776, 'USC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7777, 'ECN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7778, 'UNI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7779, 'KIDS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7780, 'CNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7781, 'FRST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7782, 'XBY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7783, 'AL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7784, 'XVS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7785, 'CKS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7786, 'C2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7787, 'MENTAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7788, 'DASHS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7789, 'MVR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7790, 'DEA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7791, 'PROC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7792, 'MAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7793, 'TLE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7794, 'NETKO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7795, 'XINCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7796, 'TIDE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7797, 'VEC2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7798, 'CNNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7799, 'BAB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7800, 'GLO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7801, 'EVA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7802, 'DUX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7803, 'PARTY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7804, 'PUPA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7805, 'XPS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7806, 'TAP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7807, 'BATL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7808, 'MUU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7809, 'CTIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7810, 'ALIEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7811, 'BITOK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7812, 'GREENF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7813, 'MAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7814, 'MERGEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7815, 'BITS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7816, 'TCN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7817, 'WITCH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7818, 'LUMI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7819, 'XTR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7820, 'CMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7821, 'BHC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7822, 'KASHH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7823, 'VERS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7824, 'F16', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7825, 'FJC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7826, 'PIPR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7827, 'HAMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7828, 'ONX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7829, 'OMGAME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7830, 'JOINTCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7831, 'SKULL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7832, 'XMG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7833, 'WOK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7834, 'HON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7835, 'EGAME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7836, 'PIE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7837, 'FIDGT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7838, 'UDOWN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7839, 'WEEK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7840, 'KINGN COIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7841, 'MAX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(7842, 'SLCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7843, 'XNM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7844, 'KISS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7845, 'PROFIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7846, 'TAG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7847, 'SHRP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7848, 'ELC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7849, 'RBY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7850, 'QTM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7851, 'TLOSH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7852, '420G', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7853, 'RBBT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7854, 'SOLAR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7855, 'HYPER', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7856, 'OCEAN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7857, 'ACRN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7858, 'LITEBITCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7859, 'EUROP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7860, 'SOCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7861, 'ROCKET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7862, 'MAO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7863, 'CDO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7864, '700', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7865, 'WOMEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7866, 'MULTI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7867, 'RH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7868, 'WAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7869, 'HMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7870, 'FPC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7871, 'LINDA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7872, 'KGB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7873, 'RSGP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7874, 'RUP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7875, 'DXO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7876, 'PRIMU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7877, 'XGTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7878, 'FIDEL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7879, 'DUR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7880, 'CTIC2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7881, 'INGT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7882, 'GER', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7883, 'ANTSCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7884, 'GSR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7885, 'WINK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7886, 'BCH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7887, 'POPPY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7888, 'DOTA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7889, 'ADAM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7890, 'EDIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7891, 'OLIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7892, 'CIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7893, 'JOCKER', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7894, 'WRT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7895, 'VRP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7896, 'FUNKCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7897, 'BBH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7898, 'PLAYCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7899, 'LTCU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7900, 'USDE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7901, 'RUPX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7902, 'BENJI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7903, 'CRM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7904, 'SBT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7905, 'RID', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7906, 'RAI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7907, 'SLEEP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7908, 'KARMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7909, 'BCM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7910, 'AGRI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7911, 'SEL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7912, 'CHILL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7913, 'SHDW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7914, 'WCASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7915, 'ANICOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7916, 'WGO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7917, 'WGR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7918, 'VK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7919, 'SIGT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7920, 'EQT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7921, 'LITE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7922, 'NTM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7923, 'RUC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7924, 'HOPE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7925, 'CNX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7926, 'CROC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7927, 'ATB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7928, 'IXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7929, 'IFT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7930, 'DLT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7931, 'IND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7932, 'LUN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7933, 'WHO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7934, 'POM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7935, 'BAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7936, 'EOS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7937, 'GNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7938, 'TNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7939, 'TIME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7940, 'HAC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7941, 'GNO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7942, 'STORJ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7943, 'BNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7944, 'SCL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7945, 'KR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7946, 'EXP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7947, 'DES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7948, 'LSK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7949, 'WAVES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7950, 'RISE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7951, 'DLISK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7952, 'ETC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7953, 'BITSHARES2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7954, 'ELE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7955, 'LAZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7956, 'HMQ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7957, 'MCO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7958, 'SNM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7959, 'PING', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7960, 'PLBT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7961, 'INPAY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7962, 'XEM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7963, 'ECOB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7964, 'ZRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7965, 'MGO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7966, 'UNIFY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7967, 'UNIFY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(7968, 'UNIFY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(7969, 'UNIFY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(7970, 'UNIFY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(7971, 'UNIFY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7972, 'MINH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7973, 'MINH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(7974, 'MINH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(7975, 'MINH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(7976, 'MINH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(7977, 'MINH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7978, 'REC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7979, 'REC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(7980, 'REC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(7981, 'REC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(7982, 'REC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(7983, 'REC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7984, 'VULC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7985, 'VULC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(7986, 'VULC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(7987, 'VULC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(7988, 'VULC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(7989, 'VULC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7990, 'BUY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7991, 'ALTCOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7992, 'ALTCOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(7993, 'ALTCOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(7994, 'ALTCOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(7995, 'ALTCOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(7996, 'ALTCOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(7997, 'COMP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(7998, 'COMP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(7999, 'COMP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8000, 'COMP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8001, 'COMP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8002, 'COMP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8003, 'SW', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8004, 'SW', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8005, 'SW', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8006, 'SW', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8007, 'SW', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8008, 'SW', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8009, 'BITCOINSTAKE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8010, 'BITCOINSTAKE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8011, 'BITCOINSTAKE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8012, 'BITCOINSTAKE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8013, 'BITCOINSTAKE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8014, 'BITCOINSTAKE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8015, 'AGT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8016, 'AGT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8017, 'AGT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8018, 'AGT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8019, 'AGT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8020, 'AGT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8021, 'GFL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8022, 'GFL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8023, 'GFL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8024, 'GFL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8025, 'GFL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8026, 'GFL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8027, 'GELD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8028, 'GELD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8029, 'GELD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8030, 'GELD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8031, 'GELD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8032, 'GELD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8033, 'ALIS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8034, 'ALIS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8035, 'ALIS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8036, 'ALIS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8037, 'ALIS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8038, 'ALIS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8039, 'ELITE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8040, 'ELITE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8041, 'ELITE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8042, 'ELITE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8043, 'ELITE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8044, 'ELITE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8045, 'FIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8046, 'FIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8047, 'FIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8048, 'FIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8049, 'FIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8050, 'FIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8051, 'WIC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8052, 'WIC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8053, 'WIC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8054, 'WIC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8055, 'WIC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8056, 'WIC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8057, 'CCT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8058, 'CCT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8059, 'CCT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8060, 'CCT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8061, 'CCT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8062, 'CCT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8063, 'ZONTO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8064, 'ZONTO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8065, 'ZONTO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8066, 'ZONTO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8067, 'ZONTO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8068, 'ZONTO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8069, 'MVC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8070, 'MVC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8071, 'MVC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8072, 'MVC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8073, 'MVC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8074, 'MVC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8075, 'LDM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8076, 'LDM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8077, 'LDM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8078, 'LDM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8079, 'LDM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8080, 'LDM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8081, 'LRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8082, 'LRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8083, 'LRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8084, 'LRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8085, 'LRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8086, 'LRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8087, 'PLU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8088, 'PLU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8089, 'PLU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8090, 'PLU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8091, 'PLU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8092, 'PLU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8093, 'NET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8094, 'NET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8095, 'NET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8096, 'NET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8097, 'NET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8098, 'NET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8099, 'VSLICE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8100, 'VSLICE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8101, 'VSLICE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8102, 'VSLICE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8103, 'VSLICE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8104, 'VSLICE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8105, 'GUP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8106, 'GUP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8107, 'GUP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8108, 'GUP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8109, 'GUP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8110, 'GUP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8111, 'SWT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8112, 'SWT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8113, 'SWT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8114, 'SWT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8115, 'SWT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8116, 'SWT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8117, 'SAN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8118, 'SAN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8119, 'SAN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8120, 'SAN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8121, 'SAN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8122, 'SAN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8123, 'NMR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8124, 'NMR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8125, 'NMR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8126, 'NMR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8127, 'NMR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8128, 'NMR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8129, 'ADT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8130, 'ADT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8131, 'ADT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8132, 'ADT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8133, 'ADT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8134, 'ADT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8135, 'BGF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8136, 'BGF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8137, 'BGF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8138, 'BGF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8139, 'BGF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8140, 'BGF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8141, 'TOKC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8142, 'TOKC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8143, 'TOKC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8144, 'TOKC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8145, 'TOKC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8146, 'TOKC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8147, 'XIOS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8148, 'XIOS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8149, 'XIOS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8150, 'XIOS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8151, 'XIOS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8152, 'XIOS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8153, 'NYC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8154, 'NYC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8155, 'NYC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8156, 'NYC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8157, 'NYC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8158, 'NYC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8159, 'BTG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8160, 'BTG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8161, 'BTG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8162, 'BTG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8163, 'BTG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8164, 'BTG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8165, 'KICK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8166, 'KICK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8167, 'KICK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8168, 'KICK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8169, 'KICK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8170, 'KICK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8171, 'SOMA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8172, 'SOMA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8173, 'SOMA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8174, 'SOMA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8175, 'SOMA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8176, 'SOMA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8177, 'ONEK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8178, 'ONEK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8179, 'ONEK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8180, 'ONEK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8181, 'ONEK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8182, 'ONEK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8183, 'ATM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8184, 'ATM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8185, 'ATM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8186, 'ATM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8187, 'ATM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8188, 'ATM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8189, 'BTCRED', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8190, 'BTCRED', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8191, 'BTCRED', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8192, 'BTCRED', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8193, 'BTCRED', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8194, 'BTCRED', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8195, 'UMC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8196, 'UMC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8197, 'UMC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8198, 'UMC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8199, 'UMC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8200, 'UMC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8201, 'BTCM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8202, 'BTCM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8203, 'BTCM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8204, 'BTCM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8205, 'BTCM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8206, 'BTCM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8207, 'DRT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8208, 'DRT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8209, 'DRT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8210, 'DRT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8211, 'DRT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8212, 'DRT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8213, 'IETH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8214, 'IETH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8215, 'IETH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8216, 'IETH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8217, 'IETH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8218, 'IETH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8219, 'ECASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8220, 'ECASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8221, 'ECASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8222, 'ECASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8223, 'ECASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8224, 'ECASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8225, 'BIO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8226, 'BIO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8227, 'BIO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8228, 'BIO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8229, 'BIO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8230, 'BIO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8231, 'HDG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8232, 'HDG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8233, 'HDG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8234, 'HDG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8235, 'HDG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8236, 'HDG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8237, 'DALC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8238, 'DALC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8239, 'DALC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8240, 'DALC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8241, 'DALC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8242, 'DALC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8243, 'ATL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8244, 'ATL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8245, 'ATL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8246, 'ATL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8247, 'ATL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8248, 'ATL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8249, 'OTN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8250, 'OTN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8251, 'OTN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8252, 'OTN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8253, 'OTN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8254, 'OTN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8255, 'AMM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8256, 'AMM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8257, 'AMM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8258, 'AMM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8259, 'AMM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8260, 'AMM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8261, 'R', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8262, 'R', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8263, 'R', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8264, 'R', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8265, 'R', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8266, 'R', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8267, 'YOB2X', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8268, 'YOB2X', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8269, 'YOB2X', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8270, 'YOB2X', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8271, 'YOB2X', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8272, 'YOB2X', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8273, 'XRL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8274, 'XRL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8275, 'XRL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8276, 'XRL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8277, 'XRL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8278, 'XRL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8279, 'BCD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8280, 'BCD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8281, 'BCD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8282, 'BCD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8283, 'BCD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8284, 'BCD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8285, 'ETL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8286, 'ETL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8287, 'ETL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8288, 'ETL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8289, 'ETL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8290, 'ETL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8291, 'DVD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8292, 'DVD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8293, 'DVD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8294, 'DVD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8295, 'DVD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8296, 'DVD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8297, 'CAG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8298, 'CAG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8299, 'CAG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8300, 'CAG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8301, 'CAG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8302, 'CAG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8303, 'SNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8304, 'SNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8305, 'SNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8306, 'SNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8307, 'SNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8308, 'SNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8309, 'LIZA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8310, 'LIZA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8311, 'LIZA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8312, 'LIZA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8313, 'LIZA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8314, 'LIZA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8315, 'STU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8316, 'STU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8317, 'STU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8318, 'STU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8319, 'STU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8320, 'STU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8321, 'HKN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8322, 'HKN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8323, 'HKN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8324, 'HKN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8325, 'HKN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8326, 'HKN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8327, 'UBTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8328, 'UBTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8329, 'UBTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8330, 'UBTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8331, 'UBTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8332, 'UBTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8333, 'BTH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8334, 'BTH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8335, 'BTH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8336, 'BTH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8337, 'BTH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8338, 'BTH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8339, 'SBTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8340, 'SBTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8341, 'SBTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8342, 'SBTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8343, 'SBTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8344, 'SBTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8345, 'TFL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8346, 'TFL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8347, 'TFL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8348, 'TFL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8349, 'TFL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8350, 'TFL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8351, 'B2B', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8352, 'B2B', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8353, 'B2B', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8354, 'B2B', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8355, 'B2B', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8356, 'B2B', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8357, 'TRX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8358, 'TRX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8359, 'TRX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8360, 'TRX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8361, 'TRX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8362, 'TRX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8363, 'WTT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8364, 'WTT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8365, 'WTT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8366, 'WTT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8367, 'WTT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8368, 'WTT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8369, 'MIRO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8370, 'MIRO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8371, 'MIRO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8372, 'MIRO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8373, 'MIRO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8374, 'MIRO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8375, 'MNTP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8376, 'MNTP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8377, 'MNTP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8378, 'MNTP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8379, 'MNTP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8380, 'MNTP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8381, 'LBTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8382, 'LBTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8383, 'LBTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8384, 'LBTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8385, 'LBTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8386, 'LBTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8387, 'B2X', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8388, 'B2X', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8389, 'B2X', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8390, 'B2X', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8391, 'B2X', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8392, 'B2X', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8399, 'CMS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8400, 'CMS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8401, 'CMS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8402, 'CMS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8403, 'CMS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8404, 'CMS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8405, 'SDAO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8406, 'SDAO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8407, 'SDAO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8408, 'SDAO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8409, 'SDAO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8410, 'SDAO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8411, 'REQ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8412, 'REQ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8413, 'REQ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8414, 'REQ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8415, 'REQ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8416, 'REQ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8417, 'GOD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8418, 'GOD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8419, 'GOD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8420, 'GOD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8421, 'GOD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8422, 'GOD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8423, 'BCP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8424, 'BCP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8425, 'BCP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8426, 'BCP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8427, 'BCP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8428, 'BCP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8429, 'BUM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8430, 'BUM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8431, 'BUM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8432, 'BUM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8433, 'BUM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8434, 'BUM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8435, 'BTCS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8436, 'BTCS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8437, 'BTCS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8438, 'BTCS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8439, 'BTCS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8440, 'BTCS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8441, 'PYN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8442, 'PYN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8443, 'PYN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8444, 'PYN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8445, 'PYN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8446, 'PYN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8447, 'TBX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8448, 'TBX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8449, 'TBX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8450, 'TBX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8451, 'TBX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8452, 'TBX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8453, 'TKTX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8454, 'TKTX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8455, 'TKTX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8456, 'TKTX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8457, 'TKTX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8458, 'TKTX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8459, 'DBET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8460, 'DBET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8461, 'DBET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8462, 'DBET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8463, 'DBET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8464, 'DBET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8465, 'CRED', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8466, 'CRED', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8467, 'CRED', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8468, 'CRED', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8469, 'CRED', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8470, 'CRED', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8471, 'PRIX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8472, 'PRIX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8473, 'PRIX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8474, 'PRIX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8475, 'PRIX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8476, 'PRIX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8477, 'BBT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8478, 'BBT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8479, 'BBT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8480, 'BBT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8481, 'BBT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8482, 'BBT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8483, 'BCA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8484, 'BCA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8485, 'BCA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8486, 'BCA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8487, 'BCA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8488, 'BCA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8489, 'BITCLAVE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8490, 'BITCLAVE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8491, 'BITCLAVE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8492, 'BITCLAVE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8493, 'BITCLAVE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8494, 'BITCLAVE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8495, 'GUESS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8496, 'GUESS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8497, 'GUESS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8498, 'GUESS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8499, 'GUESS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8500, 'GUESS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8501, 'SMART', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8502, 'SMART', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8503, 'SMART', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8504, 'SMART', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8505, 'SMART', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8506, 'SMART', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8507, 'BTV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8508, 'BTV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8509, 'BTV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8510, 'BTV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8511, 'BTV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8512, 'BTV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8513, 'SRNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8514, 'SRNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8515, 'SRNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8516, 'SRNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8517, 'SRNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8518, 'SRNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8519, 'ENAU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8520, 'ENAU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8521, 'ENAU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8522, 'ENAU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8523, 'ENAU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8524, 'ENAU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8525, 'INXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8526, 'INXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8527, 'INXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8528, 'INXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8529, 'INXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8530, 'INXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8531, 'EET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8532, 'EET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8533, 'EET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8534, 'EET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8535, 'EET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8536, 'EET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8537, 'OCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8538, 'OCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8539, 'OCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8540, 'OCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8541, 'OCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8542, 'OCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8543, 'CHATX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8544, 'CHATX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8545, 'CHATX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8546, 'CHATX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8547, 'CHATX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8548, 'CHATX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8549, 'SENT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8550, 'SENT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8551, 'SENT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8552, 'SENT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8553, 'SENT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8554, 'SENT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8555, 'LOC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8556, 'LOC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8557, 'LOC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8558, 'LOC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8559, 'LOC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8560, 'LOC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8561, 'COV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8562, 'COV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8563, 'COV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8564, 'COV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8565, 'COV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8566, 'COV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8567, 'BTCA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8568, 'BTCA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8569, 'BTCA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8570, 'BTCA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8571, 'BTCA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8572, 'BTCA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8573, 'ETZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8574, 'ETZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8575, 'ETZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8576, 'ETZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8577, 'ETZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8578, 'ETZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8579, 'RNTB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8580, 'RNTB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8581, 'RNTB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8582, 'RNTB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8583, 'RNTB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8584, 'RNTB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8585, 'SPHTX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8586, 'SPHTX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8587, 'SPHTX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8588, 'SPHTX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8589, 'SPHTX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8590, 'SPHTX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8591, 'SMT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8592, 'SMT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8593, 'SMT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8594, 'SMT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8595, 'SMT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8596, 'SMT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8597, 'ARCT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8598, 'ARCT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8599, 'ARCT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8600, 'ARCT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8601, 'ARCT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8602, 'ARCT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8603, 'STY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8604, 'STY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8605, 'STY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8606, 'STY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8607, 'STY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8608, 'STY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8609, 'WRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8610, 'WRC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8611, 'WRC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8612, 'WRC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8613, 'WRC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8614, 'WRC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8615, 'LHCOIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8616, 'LHCOIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8617, 'LHCOIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8618, 'LHCOIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8619, 'LHCOIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8620, 'LHCOIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8621, 'BMT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8622, 'BMT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8623, 'BMT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8624, 'BMT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8625, 'BMT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8626, 'BMT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8627, 'NTK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8628, 'NTK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8629, 'NTK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8630, 'NTK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8631, 'NTK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8632, 'NTK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8633, 'CRYCASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8634, 'CRYCASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8635, 'CRYCASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8636, 'CRYCASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8637, 'CRYCASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8638, 'CRYCASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8639, 'FTO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8640, 'FTO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8641, 'FTO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8642, 'FTO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8643, 'FTO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8644, 'FTO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8645, 'PEXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8646, 'PEXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8647, 'PEXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8648, 'PEXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8649, 'PEXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8650, 'PEXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8651, 'CLR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8652, 'CLR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8653, 'CLR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8654, 'CLR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8655, 'CLR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8656, 'CLR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8657, 'WISH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8658, 'WISH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8659, 'WISH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8660, 'WISH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8661, 'WISH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8662, 'WISH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8663, 'TLX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8664, 'TLX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8665, 'TLX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8666, 'TLX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8667, 'TLX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8668, 'TLX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8669, 'REA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8670, 'REA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8671, 'REA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8672, 'REA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8673, 'REA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8674, 'REA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8675, 'TDS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8676, 'TDS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8677, 'TDS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8678, 'TDS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8679, 'TDS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8680, 'TDS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8681, 'BM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8682, 'BM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8683, 'BM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8684, 'BM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8685, 'BM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8686, 'BM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8687, 'HPS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8688, 'HPS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8689, 'HPS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8690, 'HPS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8691, 'HPS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8692, 'HPS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8693, 'LCC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8694, 'LCC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8695, 'LCC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8696, 'LCC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8697, 'LCC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8698, 'LCC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8699, 'TAXI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8700, 'TAXI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8701, 'TAXI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8702, 'TAXI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8703, 'TAXI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8704, 'TAXI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8705, 'TGS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8706, 'TGS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8707, 'TGS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8708, 'TGS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8709, 'TGS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8710, 'TGS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8711, 'UCASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8712, 'UCASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8713, 'UCASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8714, 'UCASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8715, 'UCASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8716, 'UCASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8717, 'RAC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(8718, 'RAC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8719, 'RAC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8720, 'RAC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8721, 'RAC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8722, 'RAC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8723, 'TIE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8724, 'TIE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8725, 'TIE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8726, 'TIE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8727, 'TIE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8728, 'TIE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8729, 'ARNA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8730, 'ARNA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8731, 'ARNA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8732, 'ARNA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8733, 'ARNA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8734, 'ARNA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8735, '$PAC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8736, '$PAC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8737, '$PAC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8738, '$PAC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8739, '$PAC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8740, '$PAC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8741, 'BTDOLL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8742, 'BTDOLL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8743, 'BTDOLL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8744, 'BTDOLL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8745, 'BTDOLL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8746, 'BTDOLL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8747, 'CLO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8748, 'CLO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8749, 'CLO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8750, 'CLO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8751, 'CLO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8752, 'CLO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8753, 'BRH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8754, 'BRH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8755, 'BRH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8756, 'BRH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8757, 'BRH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8758, 'BRH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8759, 'ING', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8760, 'ING', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8761, 'ING', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8762, 'ING', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8763, 'ING', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8764, 'ING', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8765, 'UKG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8766, 'UKG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8767, 'UKG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8768, 'UKG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8769, 'UKG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8770, 'UKG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8771, 'DMT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8772, 'DMT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8773, 'DMT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8774, 'DMT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8775, 'DMT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8776, 'DMT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8777, 'CHP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8778, 'CHP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8779, 'CHP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8780, 'CHP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8781, 'CHP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8782, 'CHP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8783, 'DTCN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8784, 'DTCN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8785, 'DTCN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8786, 'DTCN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8787, 'DTCN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8788, 'DTCN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8789, 'TORQ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8790, 'TORQ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8791, 'TORQ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8792, 'TORQ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8793, 'TORQ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8794, 'TORQ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8795, 'LTCP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8796, 'LTCP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8797, 'LTCP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8798, 'LTCP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8799, 'LTCP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8800, 'LTCP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8801, 'LIF', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8802, 'LIF', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8803, 'LIF', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8804, 'LIF', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8805, 'LIF', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8806, 'LIF', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8807, 'NBC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8808, 'NBC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8809, 'NBC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8810, 'NBC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8811, 'NBC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8812, 'NBC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8813, 'BULLEON', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8814, 'BULLEON', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8815, 'BULLEON', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8816, 'BULLEON', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8817, 'BULLEON', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8818, 'BULLEON', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8819, 'LATX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8820, 'LATX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8821, 'LATX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8822, 'LATX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8823, 'LATX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8824, 'LATX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8825, 'FAITH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8826, 'FAITH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8827, 'FAITH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8828, 'FAITH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8829, 'FAITH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8830, 'FAITH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8831, 'POLL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8832, 'POLL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8833, 'POLL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8834, 'POLL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8835, 'POLL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8836, 'POLL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8837, 'UST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8838, 'UST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8839, 'UST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8840, 'UST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8841, 'UST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8842, 'UST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8843, 'LION', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8844, 'LION', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8845, 'LION', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8846, 'LION', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8847, 'LION', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8848, 'LION', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8849, 'BPTN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8850, 'BPTN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8851, 'BPTN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8852, 'BPTN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8853, 'BPTN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8854, 'BPTN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8855, 'CHSB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8856, 'CHSB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8857, 'CHSB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8858, 'CHSB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8859, 'CHSB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8860, 'CHSB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8861, 'KIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8862, 'KIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8863, 'KIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8864, 'KIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8865, 'KIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8866, 'KIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8867, 'TRNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8868, 'TRNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8869, 'TRNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8870, 'TRNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8871, 'TRNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8872, 'TRNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8873, 'MZI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8874, 'MZI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8875, 'MZI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8876, 'MZI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8877, 'MZI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8878, 'MZI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8879, 'VVI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8880, 'VVI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8881, 'VVI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8882, 'VVI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8883, 'VVI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8884, 'VVI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8885, 'CL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8886, 'CL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8887, 'CL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8888, 'CL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8889, 'CL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8890, 'CL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8891, 'STORM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8892, 'STORM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8893, 'STORM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8894, 'STORM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8895, 'STORM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8896, 'STORM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8897, 'EMT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8898, 'EMT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8899, 'EMT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8900, 'EMT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8901, 'EMT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8902, 'EMT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8903, 'AE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8904, 'AE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8905, 'AE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8906, 'AE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8907, 'AE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8908, 'AE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8909, 'LGR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8910, 'LGR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8911, 'LGR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8912, 'LGR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8913, 'LGR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8914, 'LGR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8915, 'HQX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8916, 'HQX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8917, 'HQX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8918, 'HQX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8919, 'HQX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8920, 'HQX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8921, 'BRAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8922, 'BRAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8923, 'BRAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8924, 'BRAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8925, 'BRAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8926, 'BRAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8927, 'QTG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8928, 'QTG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8929, 'QTG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8930, 'QTG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8931, 'QTG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8932, 'QTG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8933, 'ASTR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8934, 'ASTR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8935, 'ASTR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8936, 'ASTR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8937, 'ASTR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8938, 'ASTR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8939, 'LUC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8940, 'LUC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8941, 'LUC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8942, 'LUC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8943, 'LUC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8944, 'LUC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8945, 'IQN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8946, 'IQN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8947, 'IQN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8948, 'IQN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8949, 'IQN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8950, 'IQN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8951, 'PPT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8952, 'PPT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8953, 'PPT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8954, 'PPT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8955, 'PPT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8956, 'PPT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8957, 'SNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8958, 'SNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8959, 'SNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8960, 'SNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8961, 'SNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8962, 'SNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8963, 'NEU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8964, 'NEU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8965, 'NEU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8966, 'NEU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8967, 'NEU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8968, 'NEU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8969, 'NBTK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8970, 'NBTK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8971, 'NBTK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8972, 'NBTK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8973, 'NBTK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8974, 'NBTK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8975, 'UFR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8976, 'UFR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8977, 'UFR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8978, 'UFR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8979, 'UFR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8980, 'UFR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8981, 'MDZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8982, 'MDZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8983, 'MDZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8984, 'MDZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8985, 'MDZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8986, 'MDZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8987, 'BLUE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8988, 'BLUE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8989, 'BLUE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8990, 'BLUE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8991, 'BLUE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8992, 'BLUE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8993, 'PLATIN COIN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(8994, 'PLATIN COIN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(8995, 'PLATIN COIN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(8996, 'PLATIN COIN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(8997, 'PLATIN COIN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(8998, 'PLATIN COIN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(8999, 'MART', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9000, 'MART', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9001, 'MART', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9002, 'MART', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9003, 'MART', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9004, 'MART', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9005, 'YRX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9006, 'YRX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9007, 'YRX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9008, 'YRX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9009, 'YRX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9010, 'YRX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9011, 'VEGA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9012, 'VEGA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9013, 'VEGA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9014, 'VEGA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9015, 'VEGA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9016, 'VEGA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9017, 'LCWP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9018, 'LCWP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9019, 'LCWP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9020, 'LCWP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9021, 'LCWP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9022, 'LCWP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9023, 'RR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9024, 'RR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9025, 'RR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9026, 'RR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9027, 'RR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9028, 'RR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9029, 'ECHT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9030, 'ECHT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9031, 'ECHT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9032, 'ECHT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9033, 'ECHT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9034, 'ECHT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9035, 'BNS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9036, 'BNS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9037, 'BNS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9038, 'BNS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9039, 'BNS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9040, 'BNS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9041, 'BOUTS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9042, 'BOUTS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9043, 'BOUTS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9044, 'BOUTS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9045, 'BOUTS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9046, 'BOUTS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9047, 'SSH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9048, 'SSH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9049, 'SSH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9050, 'SSH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9051, 'SSH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9052, 'SSH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9053, 'TNS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9054, 'TNS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9055, 'TNS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9056, 'TNS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9057, 'TNS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9058, 'TNS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9059, 'MTH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9060, 'MTH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9061, 'MTH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9062, 'MTH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9063, 'MTH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9064, 'MTH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9065, 'ARBIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9066, 'ARBIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9067, 'ARBIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9068, 'ARBIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9069, 'ARBIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9070, 'ARBIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9071, 'EVN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9072, 'EVN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9073, 'EVN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9074, 'EVN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9075, 'EVN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9076, 'EVN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9077, 'HAND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9078, 'HAND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9079, 'HAND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9080, 'HAND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9081, 'HAND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9082, 'HAND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9083, 'FNTB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9084, 'FNTB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9085, 'FNTB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9086, 'FNTB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9087, 'FNTB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9088, 'FNTB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9089, 'ASCS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9090, 'ASCS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9091, 'ASCS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9092, 'ASCS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9093, 'ASCS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9094, 'ASCS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9095, 'PKT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9096, 'PKT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9097, 'PKT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9098, 'PKT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9099, 'PKT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9100, 'PKT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9101, 'VEN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9102, 'VEN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9103, 'VEN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9104, 'VEN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9105, 'VEN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9106, 'VEN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9107, 'BTM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9108, 'BTM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9109, 'BTM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9110, 'BTM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9111, 'BTM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9112, 'BTM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9113, 'ZRX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9114, 'ZRX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9115, 'ZRX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9116, 'ZRX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9117, 'ZRX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9118, 'ZRX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9119, 'IOST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9120, 'IOST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9121, 'IOST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9122, 'IOST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9123, 'IOST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9124, 'IOST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9125, 'SKRP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9126, 'SKRP', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9127, 'SKRP', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9128, 'SKRP', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9129, 'SKRP', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9130, 'SKRP', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9131, 'WTL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9132, 'WTL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9133, 'WTL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9134, 'WTL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9135, 'WTL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9136, 'WTL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9137, 'ERISTICA TOK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9138, 'ERISTICA TOK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9139, 'ERISTICA TOK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9140, 'ERISTICA TOK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9141, 'ERISTICA TOK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9142, 'ERISTICA TOK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9143, 'TYV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9144, 'TYV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9145, 'TYV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9146, 'TYV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9147, 'TYV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9148, 'TYV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9149, 'GOLDMINT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9150, 'GOLDMINT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9151, 'GOLDMINT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9152, 'GOLDMINT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9153, 'GOLDMINT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9154, 'GOLDMINT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9155, 'HEAL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9156, 'HEAL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9157, 'HEAL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9158, 'HEAL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9159, 'HEAL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9160, 'HEAL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9161, 'SNPT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9162, 'SNPT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9163, 'SNPT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9164, 'SNPT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9165, 'SNPT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9166, 'SNPT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9167, 'DAI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9168, 'DAI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9169, 'DAI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9170, 'DAI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9171, 'DAI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9172, 'DAI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9173, 'GET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9174, 'GET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9175, 'GET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9176, 'GET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9177, 'GET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9178, 'GET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9179, 'THUG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9180, 'THUG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9181, 'THUG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9182, 'THUG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9183, 'THUG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9184, 'THUG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9185, 'SAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9186, 'SAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9187, 'SAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9188, 'SAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9189, 'SAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9190, 'SAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9191, 'PREX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9192, 'PREX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9193, 'PREX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9194, 'PREX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9195, 'PREX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9196, 'PREX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9197, 'USDT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9198, 'USDT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9199, 'USDT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9200, 'USDT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9201, 'USDT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9202, 'USDT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9203, 'BCL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9204, 'BCL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9205, 'BCL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9206, 'BCL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9207, 'BCL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9208, 'BCL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9209, 'FLOT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9210, 'FLOT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9211, 'FLOT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9212, 'FLOT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9213, 'FLOT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9214, 'FLOT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9215, 'MNZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9216, 'MNZ', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9217, 'MNZ', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9218, 'MNZ', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9219, 'MNZ', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9220, 'MNZ', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9221, 'SRN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9222, 'SRN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9223, 'SRN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9224, 'SRN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9225, 'SRN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9226, 'SRN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9227, 'KBC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9228, 'KBC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9229, 'KBC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9230, 'KBC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9231, 'KBC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9232, 'KBC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9233, 'WIT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9234, 'WIT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9235, 'WIT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9236, 'WIT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9237, 'WIT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9238, 'WIT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9239, 'LOOM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9240, 'LOOM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9241, 'LOOM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9242, 'LOOM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9243, 'LOOM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9244, 'LOOM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9245, 'TKLN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9246, 'TKLN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9247, 'TKLN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9248, 'TKLN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9249, 'TKLN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9250, 'TKLN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9251, 'BNB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9252, 'BNB', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9253, 'BNB', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9254, 'BNB', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9255, 'BNB', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9256, 'BNB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9257, 'CJT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9258, 'CJT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9259, 'CJT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9260, 'CJT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9261, 'CJT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9262, 'CJT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9263, 'PMT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9264, 'PMT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9265, 'PMT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9266, 'PMT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9267, 'PMT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9268, 'PMT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9269, 'LAMBO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9270, 'LAMBO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9271, 'LAMBO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9272, 'LAMBO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9273, 'LAMBO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9274, 'LAMBO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9275, 'VRTM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9276, 'VRTM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9277, 'VRTM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9278, 'VRTM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9279, 'VRTM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9280, 'VRTM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9281, 'OKO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9282, 'OKO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9283, 'OKO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9284, 'OKO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9285, 'OKO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9286, 'OKO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9287, 'ZIPT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9288, 'ZIPT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9289, 'ZIPT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9290, 'ZIPT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9291, 'ZIPT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9292, 'ZIPT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9293, 'PMNT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9294, 'PMNT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9295, 'PMNT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9296, 'PMNT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9297, 'PMNT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9298, 'PMNT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9299, 'AICYO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9300, 'AICYO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9301, 'AICYO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9302, 'AICYO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9303, 'AICYO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9304, 'AICYO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9305, 'LCD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9306, 'LCD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9307, 'LCD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9308, 'LCD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9309, 'LCD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9310, 'NICEBYTES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9311, 'NICEBYTES', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9312, 'NICEBYTES', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9313, 'NICEBYTES', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9314, 'NICEBYTES', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9315, 'NICEBYTES', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9316, 'LIZUN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9317, 'LIZUN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9318, 'LIZUN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9319, 'LIZUN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9320, 'LIZUN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9321, 'LIZUN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9322, 'SPD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9323, 'SPD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9324, 'SPD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9325, 'SPD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9326, 'SPD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9327, 'SPD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9328, 'KRL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9329, 'KRL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9330, 'KRL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9331, 'KRL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9332, 'KRL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9333, 'KRL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9334, 'ML', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9335, 'ML', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9336, 'ML', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9337, 'ML', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9338, 'ML', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9339, 'ML', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9340, 'LIMBO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9341, 'LIMBO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9342, 'LIMBO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9343, 'LIMBO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9344, 'LIMBO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9345, 'LIMBO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9346, 'ABYSS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9347, 'ABYSS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9348, 'ABYSS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9349, 'ABYSS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9350, 'ABYSS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9351, 'ABYSS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9352, 'NOAH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9353, 'NOAH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9354, 'NOAH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9355, 'NOAH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9356, 'NOAH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9357, 'NOAH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9358, 'STUD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9359, 'STUD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9360, 'STUD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9361, 'STUD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9362, 'STUD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9363, 'STUD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9364, 'INK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9365, 'INK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9366, 'INK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9367, 'INK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9368, 'INK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9369, 'INK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9370, 'ZDR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9371, 'ZDR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9372, 'ZDR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9373, 'ZDR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9374, 'ZDR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9375, 'ZDR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9376, 'RLT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9377, 'RLT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9378, 'RLT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9379, 'RLT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9380, 'RLT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9381, 'RLT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9382, 'DTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9383, 'DTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9384, 'DTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9385, 'DTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9386, 'DTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9387, 'DTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9388, 'LINA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9389, 'LINA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9390, 'LINA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9391, 'LINA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9392, 'LINA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9393, 'LINA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9394, 'MOLK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9395, 'MOLK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9396, 'MOLK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9397, 'MOLK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9398, 'MOLK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9399, 'MOLK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9400, 'SIG', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9401, 'SIG', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9402, 'SIG', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9403, 'SIG', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9404, 'SIG', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9405, 'SIG', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9406, 'CHT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9407, 'CHT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9408, 'CHT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9409, 'CHT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9410, 'CHT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9411, 'CHT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9412, 'BUDDY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9413, 'BUDDY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9414, 'BUDDY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9415, 'BUDDY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9416, 'BUDDY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9417, 'BUDDY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9418, 'CLT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9419, 'CLT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9420, 'CLT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9421, 'CLT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9422, 'CLT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9423, 'CLT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9424, 'GMR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9425, 'GMR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9426, 'GMR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9427, 'GMR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9428, 'GMR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9429, 'GMR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9430, 'BUNNY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9431, 'BUNNY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9432, 'BUNNY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9433, 'BUNNY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9434, 'BUNNY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9435, 'BUNNY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9436, 'SWM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9437, 'SWM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9438, 'SWM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9439, 'SWM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9440, 'SWM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9441, 'SWM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9442, 'HORSE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9443, 'HORSE', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9444, 'HORSE', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9445, 'HORSE', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9446, 'HORSE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9447, 'HORSE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9448, 'RCT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9449, 'RCT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9450, 'RCT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9451, 'RCT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9452, 'RCT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9453, 'RCT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9454, 'LEDU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9455, 'LEDU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9456, 'LEDU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9457, 'LEDU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9458, 'LEDU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9459, 'LEDU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9460, 'QWS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9461, 'QWS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9462, 'QWS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9463, 'QWS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9464, 'QWS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9465, 'QWS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9466, 'MTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9467, 'MTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9468, 'MTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9469, 'MTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9470, 'MTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9471, 'MTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9472, 'SNTR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9473, 'SNTR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9474, 'SNTR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9475, 'SNTR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9476, 'SNTR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9477, 'SNTR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9478, 'AGR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9479, 'AGR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9480, 'AGR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9481, 'AGR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9482, 'AGR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9483, 'AGR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9484, 'COINV', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9485, 'COINV', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9486, 'COINV', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9487, 'COINV', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9488, 'COINV', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9489, 'COINV', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9490, 'BEATX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9491, 'BEATX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9492, 'BEATX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9493, 'BEATX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9494, 'BEATX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9495, 'BEATX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9496, 'YOTRA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9497, 'YOTRA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9498, 'YOTRA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9499, 'YOTRA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9500, 'YOTRA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9501, 'YOTRA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9502, 'TUSD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9503, 'TUSD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9504, 'TUSD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9505, 'TUSD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9506, 'TUSD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9507, 'TUSD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9508, 'ZIL', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9509, 'ZIL', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9510, 'ZIL', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9511, 'ZIL', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9512, 'ZIL', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9513, 'ZIL', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9514, 'DISC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9515, 'DISC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9516, 'DISC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9517, 'DISC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9518, 'DISC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9519, 'DISC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9520, 'BTRM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9521, 'BTRM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9522, 'BTRM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9523, 'BTRM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9524, 'BTRM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9525, 'BTRM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9526, 'GST', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9527, 'GST', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9528, 'GST', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9529, 'GST', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9530, 'GST', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9531, 'GST', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9532, 'FTEC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9533, 'FTEC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9534, 'FTEC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9535, 'FTEC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9536, 'FTEC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9537, 'FTEC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9538, 'GALAX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9539, 'GALAX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9540, 'GALAX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9541, 'GALAX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9542, 'GALAX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9543, 'GALAX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9544, 'THETA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9545, 'THETA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9546, 'THETA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9547, 'THETA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9548, 'THETA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9549, 'THETA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9550, 'NPXS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9551, 'NPXS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9552, 'NPXS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9553, 'NPXS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9554, 'NPXS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9555, 'NPXS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9556, 'WTC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9557, 'WTC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9558, 'WTC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9559, 'WTC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9560, 'WTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9561, 'WTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9562, 'MET', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9563, 'MET', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9564, 'MET', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9565, 'MET', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9566, 'MET', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9567, 'MET', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9568, 'FTM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9569, 'FTM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9570, 'FTM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9571, 'FTM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9572, 'FTM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9573, 'FTM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9574, 'REN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9575, 'REN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9576, 'REN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9577, 'REN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9578, 'REN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9579, 'REN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9580, 'TFD', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9581, 'TFD', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9582, 'TFD', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9583, 'TFD', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9584, 'TFD', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9585, 'TFD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(9586, 'PRO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9587, 'PRO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9588, 'PRO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9589, 'PRO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9590, 'PRO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9591, 'PRO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9592, 'HOT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9593, 'HOT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9594, 'HOT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9595, 'HOT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9596, 'HOT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9597, 'HOT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9598, 'PAI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9599, 'PAI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9600, 'PAI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9601, 'PAI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9602, 'PAI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9603, 'PAI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9604, 'QKC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9605, 'QKC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9606, 'QKC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9607, 'QKC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9608, 'QKC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9609, 'QKC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9610, 'FC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9611, 'FC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9612, 'FC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9613, 'FC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9614, 'FC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9615, 'FC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9616, 'QASH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9617, 'QASH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9618, 'QASH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9619, 'QASH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9620, 'QASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9621, 'QASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9622, 'DRGN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9623, 'DRGN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9624, 'DRGN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9625, 'DRGN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9626, 'DRGN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9627, 'DRGN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9628, 'MAN', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9629, 'MAN', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9630, 'MAN', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9631, 'MAN', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9632, 'MAN', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9633, 'MAN', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9634, 'TOMO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9635, 'TOMO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9636, 'TOMO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9637, 'TOMO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9638, 'TOMO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9639, 'TOMO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9640, 'TDH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9641, 'TDH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9642, 'TDH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9643, 'TDH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9644, 'TDH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9645, 'TDH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9646, 'HUR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9647, 'HUR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9648, 'HUR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9649, 'HUR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9650, 'HUR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9651, 'HUR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9652, 'SETH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9653, 'SETH', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9654, 'SETH', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9655, 'SETH', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9656, 'SETH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9657, 'SETH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9658, 'MODX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9659, 'MODX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9660, 'MODX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9661, 'MODX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9662, 'MODX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9663, 'MODX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9664, 'FUND', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9665, 'FUND', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9666, 'FUND', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9667, 'FUND', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9668, 'FUND', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9669, 'FUND', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9670, 'HT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9671, 'HT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9672, 'HT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9673, 'HT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9674, 'HT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9675, 'HT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9676, 'AOA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9677, 'AOA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9678, 'AOA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9679, 'AOA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9680, 'AOA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9681, 'AOA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9682, 'NULS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9683, 'NULS', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9684, 'NULS', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9685, 'NULS', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9686, 'NULS', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9687, 'NULS', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9688, 'NEXO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9689, 'NEXO', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9690, 'NEXO', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9691, 'NEXO', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(9692, 'NEXO', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9693, 'NEXO', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9694, 'ETH', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9695, 'KR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9696, 'EXP', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9697, 'DES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9698, 'LSK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9699, 'WAVES', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9700, 'RISE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9701, 'DLISK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9702, 'ETC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9703, 'BITSHARES2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9704, 'EBONUS', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9705, 'ELE', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9706, 'LAZ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9707, 'HMQ', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9708, 'EDR2', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9709, 'MCO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9710, 'SNM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9711, 'PING', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9712, 'PLBT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9713, 'INPAY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9714, 'XEM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9715, 'ECOB', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9716, 'ZRC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9717, 'MGO', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9718, 'LTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9719, 'USD', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9720, 'DOGE', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9721, 'SIB', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9722, 'ETH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9723, 'ETH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9724, 'DASH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9725, 'DASH', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9726, 'EDR2', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9727, 'EDR2', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9728, 'EDR2', 'LTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9729, 'EDR2', 'DASH', 'yobit', '0.0001', '0.001', 1, '8'),
(9730, 'EDR2', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(9731, 'EDR2', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(9732, 'BCH', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9733, 'DOGE', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9734, 'LTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9735, 'BTC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(9736, 'BTC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(9737, 'YOVI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(9738, 'BTC', 'USDT', 'okex', '0.001', '0.001', 1, '8'),
(9739, 'BTC', 'USD', 'okex', '0.001', '0.001', 1, '8'),
(9740, 'BTC', 'CNY', 'okex', '0.001', '0.001', 1, '8'),
(9741, 'LTC', 'USDT', 'okex', '0.001', '0.001', 1, '6'),
(9742, 'LTC', 'USD', 'okex', '0.001', '0.001', 1, '6'),
(9743, 'LTC', 'CNY', 'okex', '0.001', '0.001', 1, '6'),
(9744, 'ETH', 'USDT', 'okex', '0.001', '0.001', 1, '6'),
(9745, 'ETH', 'USD', 'okex', '0.001', '0.001', 1, '6'),
(9746, 'ETH', 'CNY', 'okex', '0.001', '0.001', 1, '6'),
(9747, 'OKB', 'USDT', 'okex', '1', '0.001', 1, '4'),
(9748, 'ETC', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9749, 'ETC', 'USD', 'okex', '0.01', '0.001', 1, '5'),
(9750, 'ETC', 'CNY', 'okex', '0.01', '0.001', 1, '5'),
(9751, 'BCH', 'USDT', 'okex', '0.001', '0.001', 1, '8'),
(9752, 'BCH', 'USD', 'okex', '0.001', '0.001', 1, '8'),
(9753, 'BCH', 'CNY', 'okex', '0.001', '0.001', 1, '8'),
(9754, '1ST', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9755, 'AAC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9756, 'ABT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9757, 'ACE', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9758, 'ACT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9759, 'ADA', 'USDT', 'okex', '1', '0.001', 1, '8'),
(9760, 'AE', 'USDT', 'okex', '0.01', '0.001', 1, '4'),
(9761, 'AIDOC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9762, 'AMM', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9763, 'ARK', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9764, 'AST', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9765, 'ATL', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9766, 'AUTO', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9767, 'AVT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9768, 'BCD', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9769, 'BCN', 'USDT', 'okex', '10', '0.001', 1, '8'),
(9770, 'BEC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9771, 'BKX', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9772, 'BNT', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9773, 'BRD', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9774, 'BTG', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9775, 'BTG', 'USD', 'okex', '0.01', '0.001', 1, '5'),
(9776, 'BTG', 'CNY', 'okex', '0.01', '0.001', 1, '5'),
(9777, 'BTM', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9778, 'CAG', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9779, 'CAI', 'USDT', 'okex', '10', '0.001', 1, '4'),
(9780, 'CONTENT AND ', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9781, 'CBT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9782, 'CHAT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9783, 'CIC', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9784, 'CMT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9785, 'CTXC', 'USDT', 'okex', '0.01', '0.001', 1, '3'),
(9786, 'CVC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9787, 'CVT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9788, 'DADI', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9789, 'DASH', 'USDT', 'okex', '0.001', '0.001', 1, '6'),
(9790, 'DAT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9791, 'DCR', 'USDT', 'okex', '0.01', '0.001', 1, '8'),
(9792, 'DENT', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9793, 'DGB', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9794, 'DGD', 'USDT', 'okex', '0.001', '0.001', 1, '6'),
(9795, 'DNA', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9796, 'DNT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9797, 'DPY', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9798, 'EDO', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9799, 'EGT', 'USDT', 'okex', '1', '0.001', 1, '4'),
(9800, 'ELF', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9801, 'ENG', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9802, 'ENJ', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9803, 'EOS', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9804, 'EOS', 'USD', 'okex', '0.1', '0.001', 1, '4'),
(9805, 'EOS', 'CNY', 'okex', '0.1', '0.001', 1, '4'),
(9806, 'EVX', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9807, 'FAIRGAME', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9808, 'FUN', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9809, 'GAS', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9810, 'GNT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9811, 'GNX', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9812, 'GSC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9813, 'GTO', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9814, 'HMC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9815, 'HOT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9816, 'HPB', 'USDT', 'okex', '1', '0.001', 1, '8'),
(9817, 'HSR', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9818, 'HYC', 'USDT', 'okex', '1', '0.001', 1, '8'),
(9819, 'ICN', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9820, 'ICX', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9821, 'INS', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9822, 'INSUR', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9823, 'INT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9824, 'IOST', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9825, 'IOTA', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9826, 'IPC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9827, 'ITC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9828, 'KAN', 'USDT', 'okex', '10', '0.001', 1, '4'),
(9829, 'KCASH', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9830, 'KEY', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9831, 'KNC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9832, 'LA', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9833, 'LBA', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9834, 'LEND', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9835, 'LET', 'USDT', 'okex', '1', '0.001', 1, '8'),
(9836, 'LEV', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9837, 'LIGHT', 'USDT', 'okex', '10', '0.001', 1, '0'),
(9838, 'LINK', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9839, 'LRC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9840, 'LSK', 'USDT', 'okex', '0.01', '0.001', 1, '8'),
(9841, 'MAGGIE', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9842, 'MANA', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9843, 'MCO', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9844, 'MDA', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9845, 'MDT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9846, 'MITH', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9847, 'MKR', 'USDT', 'okex', '0.001', '0.001', 1, '8'),
(9848, 'MOF', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9849, 'MOT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9850, 'MTH', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9851, 'MTL', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9852, 'MVP', 'USDT', 'okex', '10', '0.001', 1, '8'),
(9853, 'NANO', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9854, 'NAS', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9855, 'NEO', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9856, 'NEO', 'USD', 'okex', '0.01', '0.001', 1, '5'),
(9857, 'NEO', 'CNY', 'okex', '0.01', '0.001', 1, '5'),
(9858, 'NGC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9859, 'NULS', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9860, 'OAX', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9861, 'OF', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9862, 'OK06ETT', 'USDT', 'okex', '0.01', '0.001', 1, '8'),
(9863, 'OMG', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9864, 'ONT', 'USDT', 'okex', '0.1', '0.001', 1, '3'),
(9865, 'ORS', 'USDT', 'okex', '1', '0.001', 1, '8'),
(9866, 'OST', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9867, 'PAY', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9868, 'POE', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9869, 'PPT', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9870, 'PRA', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9871, 'PST', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9872, 'QTUM', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9873, 'QTUM', 'USD', 'okex', '0.01', '0.001', 1, '5'),
(9874, 'QTUM', 'CNY', 'okex', '0.01', '0.001', 1, '5'),
(9875, 'QUN', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9876, 'QVT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9877, 'R', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9878, 'RCN', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9879, 'RCT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9880, 'RDN', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9881, 'READ', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9882, 'REF', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9883, 'REN', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9884, 'REQ', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9885, 'RFR', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9886, 'RNT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9887, 'SALT', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9888, 'SAN', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9889, 'SC', 'USDT', 'okex', '10', '0.001', 1, '4'),
(9890, 'SHOW', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9891, 'SMT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9892, 'SNC', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9893, 'SNGLS', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9894, 'SNM', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9895, 'SNT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9896, 'SOC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9897, 'SPF', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9898, 'SSC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9899, 'STC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9900, 'STORJ', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9901, 'SUB', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9902, 'SWFTC', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9903, 'TCT', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9904, 'THETA', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9905, 'TIO', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9906, 'TNB', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9907, 'TOPC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9908, 'TRA', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9909, 'TRIO', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9910, 'TRUE', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9911, 'TRX', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9912, 'UBTC', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9913, 'UCT', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9914, 'UGC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9915, 'UKG', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9916, 'UTK', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9917, 'VEE', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9918, 'VIB', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9919, 'VIU', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9920, 'WAVES', 'USDT', 'okex', '0.01', '0.001', 1, '8'),
(9921, 'WFEE', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9922, 'WIN', 'USDT', 'okex', '10', '0.001', 1, '3'),
(9923, 'WRC', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9924, 'WTC', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9925, 'XAS', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9926, 'XEM', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9927, 'XLM', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9928, 'XMR', 'USDT', 'okex', '0.001', '0.001', 1, '6'),
(9929, 'XRP', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9930, 'XUC', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9931, 'XUC', 'USD', 'okex', '0.1', '0.001', 1, '4'),
(9932, 'XUC', 'CNY', 'okex', '0.1', '0.001', 1, '4'),
(9933, 'YEE', 'USDT', 'okex', '10', '0.001', 1, '1'),
(9934, 'YOU', 'USDT', 'okex', '0.1', '0.001', 1, '4'),
(9935, 'YOYOW', 'USDT', 'okex', '10', '0.001', 1, '2'),
(9936, 'ZEC', 'USDT', 'okex', '0.001', '0.001', 1, '6'),
(9937, 'ZEN', 'USDT', 'okex', '0.01', '0.001', 1, '5'),
(9938, 'ZIL', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9939, 'ZIP', 'USDT', 'okex', '10', '0.001', 1, '0'),
(9940, 'ZRX', 'USDT', 'okex', '1', '0.001', 1, '3'),
(9941, 'LTC', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(9944, 'ETH', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(9947, 'OKB', 'BTC', 'okex', '1', '0.001', 1, '4'),
(9948, 'ETC', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(9951, 'BCH', 'BTC', 'okex', '0.001', '0.001', 1, '8'),
(9954, '1ST', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9955, 'AAC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9956, 'ABT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9957, 'ACE', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9958, 'ACT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9959, 'ADA', 'BTC', 'okex', '1', '0.001', 1, '8'),
(9960, 'AE', 'BTC', 'okex', '0.01', '0.001', 1, '8'),
(9961, 'AIDOC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9962, 'AMM', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9963, 'ARDR', 'BTC', 'okex', '1', '0.001', 1, '4'),
(9964, 'ARK', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(9965, 'AST', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9966, 'ATL', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9967, 'AUTO', 'BTC', 'okex', '10', '0.001', 1, '1'),
(9968, 'AVT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9969, 'BCD', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(9970, 'BCN', 'BTC', 'okex', '10', '0.001', 1, '8'),
(9971, 'BCX', 'BTC', 'okex', '10', '0.001', 1, '1'),
(9972, 'BEC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9973, 'BKX', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9974, 'BNT', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(9975, 'BRD', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9976, 'BT2', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(9977, 'BTG', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(9980, 'BTM', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9981, 'CAG', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9982, 'CAI', 'BTC', 'okex', '10', '0.001', 1, '4'),
(9983, 'CONTENT AND ', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9984, 'CBT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9985, 'CHAT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9986, 'CIC', 'BTC', 'okex', '10', '0.001', 1, '1'),
(9987, 'CIT', 'BTC', 'okex', '1', '0.001', 1, '8'),
(9988, 'CMT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9989, 'CTXC', 'BTC', 'okex', '0.01', '0.001', 1, '3'),
(9990, 'CVC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9991, 'CVT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9992, 'DADI', 'BTC', 'okex', '1', '0.001', 1, '3'),
(9993, 'DASH', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(9994, 'DAT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9995, 'DCR', 'BTC', 'okex', '0.01', '0.001', 1, '8'),
(9996, 'DENT', 'BTC', 'okex', '10', '0.001', 1, '1'),
(9997, 'DGB', 'BTC', 'okex', '10', '0.001', 1, '2'),
(9998, 'DGD', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(9999, 'DNA', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10000, 'DNT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10001, 'DPY', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10002, 'EDO', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10003, 'EGT', 'BTC', 'okex', '1', '0.001', 1, '4'),
(10004, 'ELF', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10005, 'ENG', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10006, 'ENJ', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10007, 'EOS', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10010, 'EVX', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10011, 'FAIRGAME', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10012, 'FUN', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10013, 'GAS', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(10014, 'GNT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10015, 'GNX', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10016, 'GSC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10017, 'GTO', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10018, 'HIT', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10019, 'HMC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10020, 'HOT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10021, 'HPB', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10022, 'HSR', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10023, 'HYC', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10024, 'ICN', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10025, 'ICX', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10026, 'INS', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10027, 'INSUR', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10028, 'INT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10029, 'IOST', 'BTC', 'okex', '0.1', '0.001', 1, '2'),
(10030, 'IOTA', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10031, 'IPC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10032, 'ITC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10033, 'KAN', 'BTC', 'okex', '10', '0.001', 1, '8'),
(10034, 'KCASH', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10035, 'KEY', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10036, 'KNC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10037, 'LA', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10038, 'LBA', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10039, 'LEND', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10040, 'LET', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10041, 'LEV', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10042, 'LIGHT', 'BTC', 'okex', '10', '0.001', 1, '0'),
(10043, 'LINK', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10044, 'LRC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10045, 'LSK', 'BTC', 'okex', '0.01', '0.001', 1, '8'),
(10046, 'MAGGIE', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10047, 'MANA', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10048, 'MCO', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10049, 'MDA', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10050, 'MDT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10051, 'MITH', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10052, 'MKR', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(10053, 'MOF', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10054, 'MOT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10055, 'MTH', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10056, 'MTL', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10057, 'MVP', 'BTC', 'okex', '10', '0.001', 1, '8'),
(10058, 'NANO', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10059, 'NAS', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10060, 'NEO', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(10063, 'NGC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10064, 'NULS', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10065, 'NXT', 'BTC', 'okex', '1', '0.001', 1, '4'),
(10066, 'OAX', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10067, 'OF', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10068, 'OMG', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10069, 'ONT', 'BTC', 'okex', '0.1', '0.001', 1, '3'),
(10070, 'ORS', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10071, 'OST', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10072, 'PAY', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10073, 'POE', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10074, 'PPT', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(10075, 'PRA', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10076, 'PST', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10077, 'QTUM', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(10080, 'QUN', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10081, 'QVT', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10082, 'R', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10083, 'RCN', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10084, 'RCT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10085, 'RDN', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10086, 'READ', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10087, 'REF', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(10088, 'REN', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10089, 'REQ', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10090, 'RFR', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10091, 'RNT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10092, 'SALT', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10093, 'SAN', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10094, 'SBTC', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10095, 'SC', 'BTC', 'okex', '10', '0.001', 1, '8'),
(10096, 'SDA', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10097, 'SHOW', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10098, 'SNC', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10099, 'SNGLS', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10100, 'SNM', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10101, 'SNT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10102, 'SOC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10103, 'SPF', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10104, 'SSC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10105, 'STC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10106, 'STORJ', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10107, 'SUB', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10108, 'SWFTC', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10109, 'TCT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10110, 'THETA', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10111, 'TIO', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10112, 'TNB', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10113, 'TOPC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10114, 'TRA', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10115, 'TRIO', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10116, 'TRUE', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10117, 'TRX', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10118, 'UBTC', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10119, 'UCT', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10120, 'UGC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10121, 'UKG', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10122, 'UTK', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10123, 'VEE', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10124, 'VIB', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10125, 'VITE', 'BTC', 'okex', '1', '0.001', 1, '8'),
(10126, 'VIU', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10127, 'WAVES', 'BTC', 'okex', '0.01', '0.001', 1, '8'),
(10128, 'WBTC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10129, 'WFEE', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10130, 'WIN', 'BTC', 'okex', '10', '0.001', 1, '3'),
(10131, 'WRC', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10132, 'WTC', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10133, 'XAS', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10134, 'XEM', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10135, 'XLM', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10136, 'XMR', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(10137, 'XRP', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10138, 'XUC', 'BTC', 'okex', '0.1', '0.001', 1, '4'),
(10141, 'YEE', 'BTC', 'okex', '10', '0.001', 1, '1'),
(10142, 'YOU', 'BTC', 'okex', '0.1', '0.001', 1, '8'),
(10143, 'YOYOW', 'BTC', 'okex', '10', '0.001', 1, '2'),
(10144, 'ZCO', 'BTC', 'okex', '1', '0.001', 1, '4'),
(10145, 'ZEC', 'BTC', 'okex', '0.001', '0.001', 1, '6'),
(10146, 'ZEN', 'BTC', 'okex', '0.01', '0.001', 1, '5'),
(10147, 'ZIL', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10148, 'ZIP', 'BTC', 'okex', '10', '0.001', 1, '0'),
(10149, 'ZRX', 'BTC', 'okex', '1', '0.001', 1, '3'),
(10150, 'LTC', 'ETH', 'okex', '0.001', '0.001', 1, '6'),
(10153, 'OKB', 'ETH', 'okex', '1', '0.001', 1, '4'),
(10154, 'ETC', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10157, 'BCH', 'ETH', 'okex', '0.001', '0.001', 1, '8'),
(10160, '1ST', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10161, 'AAC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10162, 'ABT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10163, 'ACE', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10164, 'ACT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10165, 'ADA', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10166, 'AE', 'ETH', 'okex', '0.01', '0.001', 1, '8'),
(10167, 'AIDOC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10168, 'AMM', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10169, 'ARK', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10170, 'AST', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10171, 'ATL', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10172, 'AUTO', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10173, 'AVT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10174, 'BEC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10175, 'BKX', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10176, 'BNT', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10177, 'BRD', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10178, 'BTM', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10179, 'CAG', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10180, 'CAI', 'ETH', 'okex', '10', '0.001', 1, '4'),
(10181, 'CONTENT AND ', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10182, 'CBT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10183, 'CHAT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10184, 'CIC', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10185, 'CIT', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10186, 'CMT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10187, 'CTXC', 'ETH', 'okex', '0.01', '0.001', 1, '3'),
(10188, 'CVC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10189, 'CVT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10190, 'DADI', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10191, 'DASH', 'ETH', 'okex', '0.001', '0.001', 1, '6'),
(10192, 'DAT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10193, 'DCR', 'ETH', 'okex', '0.01', '0.001', 1, '8'),
(10194, 'DENT', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10195, 'DGB', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10196, 'DGD', 'ETH', 'okex', '0.001', '0.001', 1, '6'),
(10197, 'DNA', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10198, 'DNT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10199, 'DPY', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10200, 'EDO', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10201, 'EGT', 'ETH', 'okex', '1', '0.001', 1, '4'),
(10202, 'ELF', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10203, 'ENG', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10204, 'ENJ', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10205, 'EOS', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10208, 'EVX', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10209, 'FAIRGAME', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10210, 'FUN', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10211, 'GAS', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10212, 'GNT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10213, 'GNX', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10214, 'GSC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10215, 'GTO', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10216, 'HIT', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10217, 'HMC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10218, 'HOT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10219, 'HPB', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10220, 'HSR', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10221, 'HYC', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10222, 'ICN', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10223, 'ICX', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10224, 'INS', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10225, 'INSUR', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10226, 'INT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10227, 'IOST', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10228, 'IOTA', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10229, 'IPC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10230, 'ITC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10231, 'KAN', 'ETH', 'okex', '10', '0.001', 1, '8'),
(10232, 'KCASH', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10233, 'KEY', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10234, 'KNC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10235, 'LA', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10236, 'LBA', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10237, 'LEND', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10238, 'LET', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10239, 'LEV', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10240, 'LIGHT', 'ETH', 'okex', '10', '0.001', 1, '0'),
(10241, 'LINK', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10242, 'LRC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10243, 'LSK', 'ETH', 'okex', '0.01', '0.001', 1, '8'),
(10244, 'MAGGIE', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10245, 'MANA', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10246, 'MCO', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10247, 'MDA', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10248, 'MDT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10249, 'MITH', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10250, 'MKR', 'ETH', 'okex', '0.001', '0.001', 1, '6'),
(10251, 'MOF', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10252, 'MOT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10253, 'MTH', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10254, 'MTL', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10255, 'MVP', 'ETH', 'okex', '10', '0.001', 1, '8'),
(10256, 'NANO', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10257, 'NAS', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10258, 'NEO', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10261, 'NGC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10262, 'NULS', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10263, 'OAX', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10264, 'OF', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10265, 'OMG', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10266, 'ONT', 'ETH', 'okex', '0.1', '0.001', 1, '3'),
(10267, 'ORS', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10268, 'OST', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10269, 'PAY', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10270, 'POE', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10271, 'PPT', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10272, 'PRA', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10273, 'PST', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10274, 'QTUM', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10277, 'QUN', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10278, 'QVT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10279, 'R', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10280, 'RCN', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10281, 'RCT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10282, 'RDN', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10283, 'READ', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10284, 'REF', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10285, 'REN', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10286, 'REQ', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10287, 'RFR', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10288, 'RNT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10289, 'SALT', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10290, 'SAN', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10291, 'SC', 'ETH', 'okex', '10', '0.001', 1, '8'),
(10292, 'SDA', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10293, 'SHOW', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10294, 'SNC', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10295, 'SNGLS', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10296, 'SNM', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10297, 'SNT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10298, 'SOC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10299, 'SPF', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10300, 'SSC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10301, 'STC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10302, 'STORJ', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10303, 'SUB', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10304, 'SWFTC', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10305, 'TCT', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10306, 'THETA', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10307, 'TIO', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10308, 'TNB', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10309, 'TOPC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10310, 'TRA', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10311, 'TRIO', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10312, 'TRUE', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10313, 'TRX', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10314, 'UBTC', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10315, 'UCT', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10316, 'UGC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10317, 'UKG', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10318, 'UTK', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10319, 'VEE', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10320, 'VIB', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10321, 'VITE', 'ETH', 'okex', '1', '0.001', 1, '8'),
(10322, 'VIU', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10323, 'WAVES', 'ETH', 'okex', '0.01', '0.001', 1, '8'),
(10324, 'WFEE', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10325, 'WIN', 'ETH', 'okex', '10', '0.001', 1, '3'),
(10326, 'WRC', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10327, 'WTC', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10328, 'XAS', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10329, 'XEM', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10330, 'XLM', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10331, 'XMR', 'ETH', 'okex', '0.001', '0.001', 1, '6'),
(10332, 'XRP', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10333, 'XUC', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10336, 'YEE', 'ETH', 'okex', '10', '0.001', 1, '1'),
(10337, 'YOU', 'ETH', 'okex', '0.1', '0.001', 1, '4'),
(10338, 'YOYOW', 'ETH', 'okex', '10', '0.001', 1, '2'),
(10339, 'ZCO', 'ETH', 'okex', '1', '0.001', 1, '4'),
(10340, 'ZEC', 'ETH', 'okex', '0.001', '0.001', 1, '6'),
(10341, 'ZEN', 'ETH', 'okex', '0.01', '0.001', 1, '5'),
(10342, 'ZIL', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10343, 'ZIP', 'ETH', 'okex', '10', '0.001', 1, '0'),
(10344, 'ZRX', 'ETH', 'okex', '1', '0.001', 1, '3'),
(10345, 'LTC', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10348, 'ETC', 'OKB', 'okex', '0.01', '0.001', 1, '5'),
(10351, 'BCH', 'OKB', 'okex', '0.001', '0.001', 1, '6'),
(10354, 'ADA', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10355, 'AE', 'OKB', 'okex', '0.01', '0.001', 1, '8'),
(10356, 'BCN', 'OKB', 'okex', '10', '0.001', 1, '8'),
(10357, 'CAI', 'OKB', 'okex', '10', '0.001', 1, '3'),
(10358, 'CIT', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10359, 'CVT', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10360, 'DASH', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10361, 'DCR', 'OKB', 'okex', '0.01', '0.001', 1, '4'),
(10362, 'EGT', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10363, 'EOS', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10366, 'HPB', 'OKB', 'okex', '0.1', '0.001', 1, '8'),
(10367, 'IOTA', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10368, 'KAN', 'OKB', 'okex', '10', '0.001', 1, '8'),
(10369, 'LBA', 'OKB', 'okex', '0.1', '0.001', 1, '3'),
(10370, 'LET', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10371, 'MVP', 'OKB', 'okex', '10', '0.001', 1, '4'),
(10372, 'NAS', 'OKB', 'okex', '0.1', '0.001', 1, '8'),
(10373, 'NEO', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10376, 'ORS', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10377, 'QTUM', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10380, 'SC', 'OKB', 'okex', '10', '0.001', 1, '8'),
(10381, 'SDA', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10382, 'VITE', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10383, 'WAVES', 'OKB', 'okex', '0.01', '0.001', 1, '4'),
(10384, 'WIN', 'OKB', 'okex', '10', '0.001', 1, '3'),
(10385, 'XAS', 'OKB', 'okex', '0.1', '0.001', 1, '8'),
(10386, 'XRP', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10387, 'YOU', 'OKB', 'okex', '10', '0.001', 1, '8'),
(10388, 'ZCO', 'OKB', 'okex', '1', '0.001', 1, '8'),
(10389, 'ZEC', 'OKB', 'okex', '0.01', '0.001', 1, '6'),
(10390, 'TESTA', 'TESTB', 'okex', '0.001', '0.001', 1, '8'),
(10391, 'TESTC', 'TESTB', 'okex', '0.001', '0.001', 1, '8'),
(10392, 'BTC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10393, 'BCH', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10394, 'ETH', 'USDT', 'gateio', '0.001', '0.001', 1, '8'),
(10395, 'ETC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10396, 'QTUM', 'USDT', 'gateio', '0.01', '0.001', 1, '8'),
(10397, 'LTC', 'USDT', 'gateio', '0.003', '0.001', 1, '8'),
(10398, 'DASH', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10399, 'ZEC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10400, 'BTM', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10401, 'EOS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10402, 'REQ', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10403, 'SNT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10404, 'OMG', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10405, 'PAY', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10406, 'CVC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10407, 'ZRX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10408, 'TNT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10409, 'XMR', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10410, 'XRP', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10411, 'DOGE', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10412, 'BAT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10413, 'PST', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10414, 'BTG', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10415, 'DPY', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10416, 'LRC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10417, 'STORJ', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10418, 'RDN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10419, 'STX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10420, 'KNC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10421, 'LINK', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10422, 'CDT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10423, 'AE', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10424, 'AE', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10425, 'AE', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10426, 'CDT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10427, 'RDN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10428, 'STX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10429, 'KNC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10430, 'LINK', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10431, 'REQ', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10432, 'RCN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10433, 'TRX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10434, 'ARN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10435, 'KICK', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10436, 'BNT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10437, 'VET', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10438, 'MCO', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10439, 'FUN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10440, 'DATA', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10441, 'RLC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10442, 'RLC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10443, 'ZSC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10444, 'WINGS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10445, 'MDA', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10446, 'RCN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10447, 'TRX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10448, 'KICK', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10449, 'VET', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10450, 'MCO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10451, 'FUN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10452, 'DATA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10453, 'ZSC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10454, 'MDA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10455, 'XTZ', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10456, 'XTZ', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10457, 'XTZ', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10458, 'GNT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10459, 'GNT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10460, 'GEM', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10461, 'GEM', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10462, 'RFR', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10463, 'RFR', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10464, 'DADI', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10465, 'DADI', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10466, 'ABT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10467, 'ABT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10468, 'LEDU', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10469, 'LEDU', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10470, 'OST', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10471, 'OST', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10472, 'XLM', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10473, 'XLM', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10474, 'XLM', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10475, 'MOBI', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10476, 'MOBI', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10477, 'MOBI', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10478, 'OCN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10479, 'OCN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10480, 'OCN', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10481, 'ZPT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10482, 'ZPT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10483, 'ZPT', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10484, 'COFI', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10485, 'COFI', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10486, 'JNT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10487, 'JNT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10488, 'JNT', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10489, 'BLZ', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10490, 'BLZ', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10491, 'GXS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10492, 'GXS', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10493, 'MTN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10494, 'MTN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10495, 'RUFF', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10496, 'RUFF', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10497, 'RUFF', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10498, 'TNC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10499, 'TNC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10500, 'TNC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10501, 'ZIL', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10502, 'ZIL', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10503, 'TIO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10504, 'TIO', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10505, 'BTO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10506, 'BTO', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10507, 'THETA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10508, 'THETA', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10509, 'DDD', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10510, 'DDD', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10511, 'DDD', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10512, 'MKR', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10513, 'MKR', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10514, 'DAI', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10515, 'SMT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10516, 'SMT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10517, 'MDT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10518, 'MDT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10519, 'MDT', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10520, 'MANA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10521, 'MANA', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10522, 'LUN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10523, 'LUN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10524, 'SALT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10525, 'SALT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10526, 'FUEL', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10527, 'FUEL', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10528, 'ELF', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10529, 'ELF', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10530, 'DRGN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10531, 'DRGN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10532, 'GTC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10533, 'GTC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10534, 'GTC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10535, 'QLC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10536, 'QLC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10537, 'QLC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10538, 'DBC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10539, 'DBC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10540, 'DBC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10541, 'BNTY', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10542, 'BNTY', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10543, 'LEND', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10544, 'LEND', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10545, 'ICX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10546, 'ICX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10547, 'BTF', 'USDT', 'gateio', '0.0001', '0.001', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(10548, 'BTF', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10549, 'ADA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10550, 'ADA', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10551, 'LSK', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10552, 'LSK', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10553, 'WAVES', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10554, 'WAVES', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10555, 'BIFI', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10556, 'BIFI', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10557, 'MDS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10558, 'MDS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10559, 'DGD', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10560, 'DGD', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10561, 'QASH', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10562, 'QASH', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10563, 'QASH', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10564, 'POWR', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10565, 'POWR', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10566, 'POWR', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10567, 'FIL', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10568, 'BCD', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10569, 'BCD', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10570, 'SBTC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10571, 'SBTC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10572, 'GOD', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10573, 'GOD', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10574, 'BCX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10575, 'BCX', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10576, 'HSR', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10577, 'HSR', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10578, 'HSR', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10579, 'QSP', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10580, 'QSP', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10581, 'INK', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10582, 'INK', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10583, 'INK', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10584, 'INK', 'QTUM', 'gateio', '0.0001', '0.001', 1, '8'),
(10585, 'MED', 'QTUM', 'gateio', '0.0001', '0.001', 1, '8'),
(10586, 'MED', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10587, 'MED', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10588, 'BOT', 'QTUM', 'gateio', '0.0001', '0.001', 1, '8'),
(10589, 'BOT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10590, 'BOT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10591, 'QBT', 'QTUM', 'gateio', '0.0001', '0.001', 1, '8'),
(10592, 'QBT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10593, 'QBT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10594, 'TSL', 'QTUM', 'gateio', '0.0001', '0.001', 1, '8'),
(10595, 'TSL', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10596, 'GNX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10597, 'GNX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10598, 'NEO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10599, 'GAS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10600, 'NEO', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10601, 'GAS', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10602, 'IOTA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10603, 'IOTA', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10604, 'NAS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10605, 'NAS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10606, 'NAS', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10607, 'ETH', 'BTC', 'gateio', '0.001', '0.001', 1, '8'),
(10608, 'ETC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10609, 'ETC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10610, 'ZEC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10611, 'DASH', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10612, 'LTC', 'BTC', 'gateio', '0.003', '0.001', 1, '8'),
(10613, 'BCH', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10614, 'BTG', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10615, 'QTUM', 'BTC', 'gateio', '0.01', '0.001', 1, '8'),
(10616, 'QTUM', 'ETH', 'gateio', '0.01', '0.001', 1, '8'),
(10617, 'XRP', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10618, 'DOGE', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10619, 'XMR', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10620, 'ZRX', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10621, 'ZRX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10622, 'DNT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10623, 'DPY', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10624, 'OAX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10625, 'REP', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10626, 'LRC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10627, 'LRC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10628, 'PST', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10629, 'BCDN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10630, 'BCDN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10631, 'TNT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10632, 'SNT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10633, 'SNT', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10634, 'BTM', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10635, 'BTM', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10636, 'LLT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10637, 'SNET', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10638, 'SNET', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10639, 'LLT', 'SNET', 'gateio', '0.0001', '0.001', 1, '8'),
(10640, 'OMG', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10641, 'OMG', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10642, 'PAY', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10643, 'PAY', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10644, 'BAT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10645, 'BAT', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10646, 'CVC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10647, 'STORJ', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10648, 'STORJ', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10649, 'EOS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10650, 'EOS', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10651, 'BTS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10652, 'BTS', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10653, 'TIPS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10654, 'BU', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10655, 'BU', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10656, 'BU', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10657, 'XMC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10658, 'XMC', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10659, 'PPS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10660, 'BOE', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10661, 'BOE', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10662, 'PLY', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10663, 'MEDX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10664, 'MEDX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10665, 'CS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10666, 'CS', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10667, 'MAN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10668, 'MAN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10669, 'REM', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10670, 'REM', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10671, 'LYM', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10672, 'LYM', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10673, 'LYM', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10674, 'ONT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10675, 'ONT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10676, 'BFT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10677, 'BFT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10678, 'IHT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10679, 'IHT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10680, 'SENC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10681, 'SENC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10682, 'TOMO', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10683, 'TOMO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10684, 'ELEC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10685, 'ELEC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10686, 'HAV', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10687, 'HAV', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10688, 'SWTH', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10689, 'SWTH', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10690, 'NKN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10691, 'NKN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10692, 'SOUL', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10693, 'SOUL', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10694, 'LRN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10695, 'LRN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10696, 'EOSDAC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10697, 'EOSDAC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10698, 'ADD', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10699, 'IQ', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10700, 'MEETONE', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10701, 'DOCK', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10702, 'DOCK', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10703, 'GSE', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10704, 'GSE', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10705, 'RATING', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10706, 'RATING', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10707, 'HSC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10708, 'HSC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10709, 'HIT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10710, 'HIT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10711, 'DX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10712, 'DX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10713, 'GARD', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10714, 'GARD', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10715, 'FTI', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10716, 'FTI', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10717, 'SOP', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10718, 'SOP', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10719, 'LEMO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10720, 'LEMO', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10721, 'EON', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10722, 'NPXS', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10723, 'QKC', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10724, 'QKC', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10725, 'IOTX', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10726, 'IOTX', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10727, 'RED', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10728, 'RED', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10729, 'LBA', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10730, 'LBA', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10731, 'OPEN', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10732, 'OPEN', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10733, 'MITH', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10734, 'MITH', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10735, 'SKM', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10736, 'SKM', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10737, 'XVG', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10738, 'XVG', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10739, 'NANO', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10740, 'NANO', 'BTC', 'gateio', '0.0001', '0.001', 1, '8'),
(10741, 'NBAI', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10742, 'UPP', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10743, 'ATMI', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10744, 'TMT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10745, 'HT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10746, 'BNB', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10747, 'BBK', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10748, 'EDR', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10749, 'MET', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10750, 'MET', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10751, 'TCT', 'ETH', 'gateio', '0.0001', '0.001', 1, '8'),
(10752, 'TCT', 'USDT', 'gateio', '0.0001', '0.001', 1, '8'),
(10753, 'BTC', 'AUD', 'coinspot', '0.001', '0.001', 1, '3'),
(10754, 'LTC', 'AUD', 'coinspot', '0.001', '0.001', 1, '3'),
(10755, 'DOGE', 'AUD', 'coinspot', '0.001', '0.001', 1, '3'),
(10756, 'BTC', 'USD', 'exmo', '0.001', '100', 1, '8'),
(10757, 'BTC', 'EUR', 'exmo', '0.001', '100', 1, '8'),
(10758, 'BTC', 'RUB', 'exmo', '0.001', '100', 1, '8'),
(10759, 'BTC', 'UAH', 'exmo', '0.001', '100', 1, '8'),
(10760, 'BTC', 'PLN', 'exmo', '0.001', '1000', 1, '8'),
(10761, 'TRX', 'BTC', 'exmo', '0.01', '200000', 1, '8'),
(10762, 'TRX', 'USD', 'exmo', '0.01', '200000', 1, '8'),
(10763, 'TRX', 'RUB', 'exmo', '0.01', '200000', 1, '8'),
(10764, 'MNX', 'BTC', 'exmo', '0.01', '100000', 1, '8'),
(10765, 'MNX', 'ETH', 'exmo', '0.01', '100000', 1, '8'),
(10766, 'MNX', 'USD', 'exmo', '0.01', '100000', 1, '8'),
(10767, 'OMG', 'BTC', 'exmo', '0.01', '100000', 1, '8'),
(10768, 'OMG', 'ETH', 'exmo', '0.01', '100000', 1, '8'),
(10769, 'OMG', 'USD', 'exmo', '0.01', '100000', 1, '8'),
(10770, 'XLM', 'BTC', 'exmo', '0.01', '200000', 1, '8'),
(10771, 'XLM', 'USD', 'exmo', '0.01', '200000', 1, '8'),
(10772, 'XLM', 'RUB', 'exmo', '0.01', '200000', 1, '8'),
(10773, 'BTCZ', 'BTC', 'exmo', '100', '500000', 1, '8'),
(10774, 'EOS', 'BTC', 'exmo', '0.01', '100000', 1, '8'),
(10775, 'EOS', 'USD', 'exmo', '0.01', '100000', 1, '8'),
(10776, 'STQ', 'BTC', 'exmo', '100', '200000', 1, '8'),
(10777, 'STQ', 'USD', 'exmo', '100', '200000', 1, '8'),
(10778, 'STQ', 'EUR', 'exmo', '100', '200000', 1, '8'),
(10779, 'STQ', 'RUB', 'exmo', '100', '200000', 1, '8'),
(10780, 'BTG', 'BTC', 'exmo', '0.01', '100000', 1, '8'),
(10781, 'BTG', 'USD', 'exmo', '0.01', '100000', 1, '8'),
(10782, 'HBZ', 'BTC', 'exmo', '100', '300000', 1, '8'),
(10783, 'HBZ', 'ETH', 'exmo', '100', '300000', 1, '8'),
(10784, 'HBZ', 'USD', 'exmo', '100', '300000', 1, '8'),
(10785, 'DXT', 'BTC', 'exmo', '100', '200000', 1, '8'),
(10786, 'DXT', 'USD', 'exmo', '100', '200000', 1, '8'),
(10787, 'BCH', 'BTC', 'exmo', '0.003', '10000', 1, '8'),
(10788, 'BCH', 'USD', 'exmo', '0.003', '10000', 1, '8'),
(10789, 'BCH', 'RUB', 'exmo', '0.003', '10000', 1, '8'),
(10790, 'BCH', 'ETH', 'exmo', '0.003', '10000', 1, '8'),
(10791, 'DASH', 'BTC', 'exmo', '0.01', '500', 1, '8'),
(10792, 'DASH', 'USD', 'exmo', '0.01', '1000', 1, '8'),
(10793, 'DASH', 'RUB', 'exmo', '0.01', '1000', 1, '8'),
(10794, 'ETH', 'BTC', 'exmo', '0.01', '1000', 1, '8'),
(10795, 'ETH', 'LTC', 'exmo', '0.01', '1000', 1, '8'),
(10796, 'ETH', 'USD', 'exmo', '0.01', '1000', 1, '8'),
(10797, 'ETH', 'EUR', 'exmo', '0.01', '1000', 1, '8'),
(10798, 'ETH', 'RUB', 'exmo', '0.01', '1000', 1, '8'),
(10799, 'ETH', 'UAH', 'exmo', '0.01', '1000', 1, '8'),
(10800, 'ETH', 'PLN', 'exmo', '0.001', '1000', 1, '8'),
(10801, 'ETC', 'BTC', 'exmo', '0.2', '1000', 1, '8'),
(10802, 'ETC', 'USD', 'exmo', '0.2', '1000', 1, '8'),
(10803, 'ETC', 'RUB', 'exmo', '0.2', '1000', 1, '8'),
(10804, 'LTC', 'BTC', 'exmo', '0.05', '1000', 1, '8'),
(10805, 'LTC', 'USD', 'exmo', '0.05', '1000', 1, '8'),
(10806, 'LTC', 'EUR', 'exmo', '0.05', '1000', 1, '8'),
(10807, 'LTC', 'RUB', 'exmo', '0.05', '1000', 1, '8'),
(10808, 'ZEC', 'BTC', 'exmo', '0.01', '500', 1, '8'),
(10809, 'ZEC', 'USD', 'exmo', '0.01', '500', 1, '8'),
(10810, 'ZEC', 'EUR', 'exmo', '0.01', '500', 1, '8'),
(10811, 'ZEC', 'RUB', 'exmo', '0.01', '500', 1, '8'),
(10812, 'XRP', 'BTC', 'exmo', '0.1', '50000', 1, '8'),
(10813, 'XRP', 'USD', 'exmo', '15', '20000', 1, '8'),
(10814, 'XRP', 'RUB', 'exmo', '15', '20000', 1, '8'),
(10815, 'XMR', 'BTC', 'exmo', '0.03', '500', 1, '8'),
(10816, 'XMR', 'USD', 'exmo', '0.03', '500', 1, '8'),
(10817, 'XMR', 'EUR', 'exmo', '0.03', '500', 1, '8'),
(10818, 'BTC', 'USDT', 'exmo', '0.001', '100', 1, '8'),
(10819, 'ETH', 'USDT', 'exmo', '0.01', '1000', 1, '8'),
(10820, 'USDT', 'USD', 'exmo', '3', '100000', 1, '8'),
(10821, 'USDT', 'RUB', 'exmo', '3', '25000', 1, '8'),
(10822, 'USD', 'RUB', 'exmo', '3', '25000', 1, '8'),
(10823, 'DOGE', 'BTC', 'exmo', '100', '100000000', 1, '8'),
(10824, 'WAVES', 'BTC', 'exmo', '0.5', '1000', 1, '8'),
(10825, 'WAVES', 'RUB', 'exmo', '0.5', '5000', 1, '8'),
(10826, 'KICK', 'BTC', 'exmo', '100', '200000', 1, '8'),
(10827, 'KICK', 'ETH', 'exmo', '100', '200000', 1, '8'),
(10828, 'UBTC', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(10829, 'ETH', 'CNY', 'quoinex', '0.01', '0.001', 0, '2'),
(10830, 'ETH', 'INR', 'quoinex', '0.01', '0.001', 0, '2'),
(10831, 'DASH', 'SGD', 'quoinex', '0.001', '0.001', 0, '3'),
(10832, 'DASH', 'JPY', 'quoinex', '0.001', '0.001', 0, '3'),
(10833, 'DASH', 'EUR', 'quoinex', '0.001', '0.001', 0, '3'),
(10834, 'XRP', 'SGD', 'quoinex', '0.001', '0.001', 0, '3'),
(10835, 'XRP', 'IDR', 'quoinex', '0.001', '0.001', 0, '3'),
(10836, 'RKT', 'AUD', 'quoinex', '0.001', '0.001', 1, '3'),
(10837, 'QTUM', 'JPY', 'quoinex', '0.001', '0.001', 0, '3'),
(10838, 'QASH', 'IDR', 'quoinex', '0.001', '0.001', 0, '3'),
(10839, 'DASH', 'USD', 'quoinex', '0.001', '0.001', 0, '3'),
(10840, 'ETH', 'SGD', 'quoinex', '0.01', '0.001', 1, '2'),
(10841, 'UBTC', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(10842, 'QTUM', 'EUR', 'quoinex', '0.001', '0.001', 0, '3'),
(10843, 'BTC', 'INR', 'quoinex', '0.001', '0.001', 0, '3'),
(10844, 'NEO', 'EUR', 'quoinex', '0.001', '0.001', 0, '3'),
(10845, 'QASH', 'HKD', 'quoinex', '0.001', '0.001', 0, '3'),
(10846, 'QASH', 'PHP', 'quoinex', '0.001', '0.001', 0, '3'),
(10847, 'QASH', 'CNY', 'quoinex', '0.001', '0.001', 0, '3'),
(10848, 'QASH', 'INR', 'quoinex', '0.001', '0.001', 0, '3'),
(10849, 'RKT', 'EUR', 'quoinex', '0.001', '0.001', 0, '3'),
(10850, 'UBTC', 'QASH', 'quoinex', '0.001', '0.001', 0, '3'),
(10851, 'XRP', 'EUR', 'quoinex', '0.001', '0.001', 0, '3'),
(10852, 'NEO', 'SGD', 'quoinex', '0.001', '0.001', 1, '3'),
(10853, 'XRP', 'JPY', 'quoinex', '0.001', '0.001', 1, '3'),
(10854, 'ETH', 'JPY', 'quoinex', '0.01', '0.001', 1, '2'),
(10855, 'QASH', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(10856, 'BTC', 'SGD', 'quoinex', '0.001', '0.001', 1, '3'),
(10857, 'BCH', 'JPY', 'quoinex', '0.001', '0.001', 1, '3'),
(10858, 'BTC', 'JPY', 'quoinex', '0.001', '0.001', 1, '3'),
(10859, 'RKT', 'SGD', 'quoinex', '0.001', '0.001', 0, '3'),
(10860, 'BTC', 'IDR', 'quoinex', '0.001', '0.001', 0, '3'),
(10861, 'UBTC', 'SGD', 'quoinex', '0.001', '0.001', 0, '3'),
(10862, 'BTC', 'CNY', 'quoinex', '0.001', '0.001', 0, '3'),
(10863, 'XRP', 'QASH', 'quoinex', '0.001', '0.001', 0, '3'),
(10864, 'XRP', 'USD', 'quoinex', '0.001', '0.001', 0, '3'),
(10865, 'RKT', 'JPY', 'quoinex', '0.001', '0.001', 0, '3'),
(10866, 'BTC', 'USD', 'quoinex', '0.001', '0.001', 1, '3'),
(10867, 'QASH', 'SGD', 'quoinex', '0.001', '0.001', 1, '3'),
(10868, 'QASH', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(10869, 'QASH', 'JPY', 'quoinex', '0.001', '0.001', 1, '3'),
(10870, 'BCH', 'USD', 'quoinex', '0.001', '0.001', 1, '3'),
(10871, 'ETH', 'USD', 'quoinex', '0.01', '0.001', 1, '2'),
(10872, 'BTC', 'AUD', 'quoinex', '0.001', '0.001', 1, '3'),
(10873, 'ETH', 'EUR', 'quoinex', '0.01', '0.001', 1, '2'),
(10874, 'BTC', 'EUR', 'quoinex', '0.001', '0.001', 1, '3'),
(10875, 'BCH', 'SGD', 'quoinex', '0.001', '0.001', 1, '3'),
(10876, 'ETH', 'PHP', 'quoinex', '0.01', '0.001', 1, '2'),
(10877, 'ETH', 'IDR', 'quoinex', '0.01', '0.001', 1, '2'),
(10878, 'ETH', 'AUD', 'quoinex', '0.01', '0.001', 1, '2'),
(10879, 'BTC', 'PHP', 'quoinex', '0.001', '0.001', 1, '3'),
(10880, 'UBTC', 'USD', 'quoinex', '0.001', '0.001', 0, '3'),
(10881, 'QTUM', 'USD', 'quoinex', '0.001', '0.001', 0, '3'),
(10882, 'BTC', 'HKD', 'quoinex', '0.001', '0.001', 1, '3'),
(10883, 'NEO', 'USD', 'quoinex', '0.001', '0.001', 1, '3'),
(10884, 'QTUM', 'SGD', 'quoinex', '0.001', '0.001', 0, '3'),
(10885, 'ETH', 'BTC', 'quoinex', '0.01', '0.001', 1, '2'),
(10886, 'QASH', 'AUD', 'quoinex', '0.001', '0.001', 1, '3'),
(10887, 'NEO', 'JPY', 'quoinex', '0.001', '0.001', 0, '3'),
(10888, 'QASH', 'USD', 'quoinex', '0.001', '0.001', 1, '3'),
(10889, 'UBTC', 'JPY', 'quoinex', '0.001', '0.001', 0, '3'),
(10890, 'ETH', 'HKD', 'quoinex', '0.01', '0.001', 1, '2'),
(10891, 'RKT', 'USD', 'quoinex', '0.001', '0.001', 1, '3'),
(10892, 'QASH', 'EUR', 'quoinex', '0.001', '0.001', 1, '3'),
(10893, 'BNT', 'BTC', 'livecoin', '0.3635', '100000000', 1, '8'),
(10894, 'LEDU', 'ETH', 'livecoin', '63.6364', '100000000', 1, '8'),
(10895, 'GRS', 'BTC', 'livecoin', '1.3855', '100000000', 1, '8'),
(10896, 'VIU', 'BTC', 'livecoin', '807.6924', '100000000', 1, '8'),
(10897, 'PPY', 'BTC', 'livecoin', '0.2766', '100000000', 1, '8'),
(10898, 'SPACECOIN', 'BTC', 'livecoin', '0.5562', '100000000', 1, '8'),
(10899, 'HVN', 'ETH', 'livecoin', '17.5586', '100000000', 1, '8'),
(10900, 'HST', 'ETH', 'livecoin', '2.6429', '100000000', 1, '8'),
(10901, 'SNBL', 'BTC', 'livecoin', '65.625', '100000000', 1, '8'),
(10902, 'BTA', 'BTC', 'livecoin', '12.181', '100000000', 1, '8'),
(10903, 'FU', 'ETH', 'livecoin', '1050', '100000000', 1, '8'),
(10904, 'SNT', 'BTC', 'livecoin', '14.8515', '100000000', 1, '8'),
(10905, 'DAY', 'BTC', 'livecoin', '0.8546', '100000000', 1, '8'),
(10906, 'AMB', 'ETH', 'livecoin', '4.2271', '100000000', 1, '8'),
(10907, 'USC', 'ETH', 'livecoin', '45.6522', '100000000', 1, '8'),
(10908, 'HST', 'USD', 'livecoin', '2.6429', '100000000', 1, '8'),
(10909, 'EETT', 'ETH', 'livecoin', '33.7621', '100000000', 1, '8'),
(10910, 'NEO', 'USD', 'livecoin', '0.0296', '100000000', 1, '8'),
(10911, 'CBR', 'EUR', 'livecoin', '308.8236', '100000000', 1, '8'),
(10912, 'RLT', 'RUB', 'livecoin', '21.605', '100000000', 1, '8'),
(10913, 'LEO', 'BTC', 'livecoin', '3.6021', '100000000', 1, '8'),
(10914, 'ARTE', 'BTC', 'livecoin', '28.6886', '100000000', 1, '8'),
(10915, 'VRC', 'BTC', 'livecoin', '3.7287', '100000000', 1, '8'),
(10916, 'W3C', 'BTC', 'livecoin', '5250', '100000000', 1, '8'),
(10917, 'ADL', 'USD', 'livecoin', '25.1799', '100000000', 1, '8'),
(10918, 'EETT', 'USD', 'livecoin', '33.7621', '100000000', 1, '8'),
(10919, 'OBITS', 'BTC', 'livecoin', '3.8875', '100000000', 1, '8'),
(10920, 'ESP', 'BTC', 'livecoin', '5250', '100000000', 1, '8'),
(10921, 'SIG', 'ETH', 'livecoin', '116.6667', '100000000', 1, '8'),
(10922, 'WAVES', 'BTC', 'livecoin', '0.395', '100000000', 1, '8'),
(10923, 'ADL', 'ETH', 'livecoin', '25.1799', '100000000', 1, '8'),
(10924, 'CLOAK', 'EUR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(10925, 'HVN', 'USD', 'livecoin', '17.5586', '100000000', 1, '8'),
(10926, 'NEO', 'ETH', 'livecoin', '0.0296', '100000000', 1, '8'),
(10927, 'XRC', 'USD', 'livecoin', '134.6154', '100000000', 1, '8'),
(10928, 'ITI', 'BTC', 'livecoin', '0.1455', '100000000', 1, '8'),
(10929, 'EOSDAC', 'BTC', 'livecoin', '9.0674', '100000000', 1, '8'),
(10930, 'FLOT', 'BTC', 'livecoin', '28.1502', '100000000', 1, '8'),
(10931, 'SOAR', 'BTC', 'livecoin', '41.6667', '100000000', 1, '8'),
(10932, 'RST', 'BTC', 'livecoin', '0.2545', '100000000', 1, '8'),
(10933, 'HB', 'USD', 'livecoin', '6.5421', '100000000', 1, '8'),
(10934, 'WIC', 'BTC', 'livecoin', '1500.0001', '100000000', 1, '8'),
(10935, 'CBR', 'ETH', 'livecoin', '308.8236', '100000000', 1, '8'),
(10936, 'ITI', 'RUB', 'livecoin', '0.1455', '100000000', 1, '8'),
(10937, 'LATX', 'BTC', 'livecoin', '14.3247', '100000000', 1, '8'),
(10938, 'POST', 'ETH', 'livecoin', '60.3449', '100000000', 1, '8'),
(10939, 'OXY', 'ETH', 'livecoin', '16.2791', '100000000', 1, '8'),
(10940, 'EDG', 'USD', 'livecoin', '2.3475', '100000000', 1, '8'),
(10941, 'VOISE', 'ETH', 'livecoin', '362.069', '100000000', 1, '8'),
(10942, 'CNB', 'BTC', 'livecoin', '0.9422', '100000000', 1, '8'),
(10943, 'MNTP', 'BTC', 'livecoin', '2.0001', '100000000', 1, '8'),
(10944, 'ICN', 'BTC', 'livecoin', '1.2686', '100000000', 1, '8'),
(10945, 'PISH', 'ETH', 'livecoin', '3500.0001', '100000000', 1, '8'),
(10946, 'SHIFT', 'BTC', 'livecoin', '0.881', '100000000', 1, '8'),
(10947, 'PIVX', 'ETH', 'livecoin', '0.525', '100000000', 1, '8'),
(10948, 'CBR', 'USD', 'livecoin', '308.8236', '100000000', 1, '8'),
(10949, 'LEO', 'RUB', 'livecoin', '3.6021', '100000000', 1, '8'),
(10950, 'CHSB', 'ETH', 'livecoin', '80.7693', '100000000', 1, '8'),
(10951, 'OXY', 'USD', 'livecoin', '16.2791', '100000000', 1, '8'),
(10952, 'OD', 'BTC', 'livecoin', '0.3', '100000000', 1, '8'),
(10953, 'TWC', 'TER', 'livecoin', '750.0001', '100000000', 1, '8'),
(10954, 'PPC', 'BTC', 'livecoin', '0.7447', '100000000', 1, '8'),
(10955, 'TRX', 'BTC', 'livecoin', '27.1318', '100000000', 1, '8'),
(10956, 'DGD', 'USD', 'livecoin', '0.0105', '100000000', 1, '8'),
(10957, 'CLPC', 'USD', 'livecoin', '119.3182', '100000000', 1, '8'),
(10958, 'TX', 'BTC', 'livecoin', '1.6169', '100000000', 1, '8'),
(10959, 'SIB', 'RUB', 'livecoin', '1.9067', '100000000', 1, '8'),
(10960, 'XRL', 'BTC', 'livecoin', '6.6121', '100000000', 1, '8'),
(10961, 'EDG', 'ETH', 'livecoin', '2.3475', '100000000', 1, '8'),
(10962, 'PIVX', 'USD', 'livecoin', '0.525', '100000000', 1, '8'),
(10963, 'ADZ', 'USD', 'livecoin', '60.3449', '100000000', 1, '8'),
(10964, 'TAAS', 'BTC', 'livecoin', '0.4601', '100000000', 1, '8'),
(10965, 'HB', 'ETH', 'livecoin', '6.5421', '100000000', 1, '8'),
(10966, 'CLOAK', 'USD', 'livecoin', '0.3099', '100000000', 1, '8'),
(10967, 'PIVX', 'DASH', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(10968, 'ECHO', 'BTC', 'livecoin', '0.0105', '100000000', 1, '8'),
(10969, 'PRG', 'BTC', 'livecoin', '7.3069', '100000000', 1, '8'),
(10970, 'ENJ', 'ETH', 'livecoin', '14.1892', '100000000', 1, '8'),
(10971, 'TRST', 'BTC', 'livecoin', '24.3056', '100000000', 1, '8'),
(10972, 'MTL', 'BTC', 'livecoin', '0.9434', '100000000', 1, '8'),
(10973, 'RBM', 'LTC', 'livecoin', '350.0001', '100000000', 1, '8'),
(10974, 'NVC', 'USD', 'livecoin', '0.469', '100000000', 1, '8'),
(10975, 'VOISE', 'USD', 'livecoin', '362.069', '100000000', 1, '8'),
(10976, 'FUNC', 'BTC', 'livecoin', '88.2353', '100000000', 1, '8'),
(10977, 'EOSDAC', 'ETH', 'livecoin', '9.0674', '100000000', 1, '8'),
(10978, 'PAY', 'USD', 'livecoin', '1.1288', '100000000', 1, '8'),
(10979, 'GOAL', 'BTC', 'livecoin', '1312.5', '100000000', 1, '8'),
(10980, 'RLC', 'ETH', 'livecoin', '1.8512', '100000000', 1, '8'),
(10981, 'MGO', 'ETH', 'livecoin', '3.7354', '100000000', 1, '8'),
(10982, 'WIC', 'ETH', 'livecoin', '1500.0001', '100000000', 1, '8'),
(10983, 'ETHP', 'BTC', 'livecoin', '53.2995', '100000000', 1, '8'),
(10984, 'CBR', 'BTC', 'livecoin', '308.8236', '100000000', 1, '8'),
(10985, 'EL', 'UNRC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(10986, 'CASH', 'ETH', 'livecoin', '76.6424', '100000000', 1, '8'),
(10987, 'BIO', 'RUB', 'livecoin', '318.1819', '100000000', 1, '8'),
(10988, 'RLC', 'USD', 'livecoin', '1.8512', '100000000', 1, '8'),
(10989, 'SHPING', 'ETH', 'livecoin', '1750.0001', '100000000', 1, '8'),
(10990, 'MCO', 'BTC', 'livecoin', '0.1236', '100000000', 1, '8'),
(10991, 'SIB', 'BTC', 'livecoin', '1.9067', '100000000', 1, '8'),
(10992, 'CRYCASH', 'BTC', 'livecoin', '4.7044', '100000000', 1, '8'),
(10993, 'THS', 'USD', 'livecoin', '11.5895', '100000000', 1, '8'),
(10994, 'FUN', 'ETH', 'livecoin', '31.8182', '100000000', 1, '8'),
(10995, 'PAY', 'ETH', 'livecoin', '1.1288', '100000000', 1, '8'),
(10996, 'BTC', 'EURN', 'livecoin', '0.0001', '100000000', 1, '8'),
(10997, 'RBIES', 'BTC', 'livecoin', '34.4263', '100000000', 1, '8'),
(10998, 'DGD', 'ETH', 'livecoin', '0.0105', '100000000', 1, '8'),
(10999, 'LATX', 'ETH', 'livecoin', '14.3247', '100000000', 1, '8'),
(11000, 'ARTE', 'MNE', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11001, 'ENJ', 'BTC', 'livecoin', '14.1892', '100000000', 1, '8'),
(11002, 'ESR', 'BCH', 'livecoin', '0.6563', '100000000', 1, '8'),
(11003, 'COV', 'ETH', 'livecoin', '0.8711', '100000000', 1, '8'),
(11004, 'OBITS', 'EUR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11005, 'SPA', 'ETH', 'livecoin', '5250', '100000000', 1, '8'),
(11006, 'HNC', 'BTC', 'livecoin', '525', '100000000', 1, '8'),
(11007, 'EVC', 'BTC', 'livecoin', '8.1522', '100000000', 1, '8'),
(11008, 'GNT', 'BTC', 'livecoin', '3.6345', '100000000', 1, '8'),
(11009, 'FU', 'BTC', 'livecoin', '1050', '100000000', 1, '8'),
(11010, 'MRP', 'BTC', 'livecoin', '45.4546', '100000000', 1, '8'),
(11011, 'XSPEC', 'BTC', 'livecoin', '1.7437', '100000000', 1, '8'),
(11012, 'EMC', 'USD', 'livecoin', '0.327', '100000000', 1, '8'),
(11013, 'EUR', 'USD', 'livecoin', '0.6127', '100000000', 1, '8'),
(11014, 'ASAFE2', 'BTC', 'livecoin', '57.6924', '100000000', 1, '8'),
(11015, 'LTT', 'ETH', 'livecoin', '30.1725', '100000000', 1, '8'),
(11016, 'B2B', 'BTC', 'livecoin', '4.037', '100000000', 1, '8'),
(11017, 'HST', 'BTC', 'livecoin', '2.6429', '100000000', 1, '8'),
(11018, 'MOIN', 'BTC', 'livecoin', '19.6999', '100000000', 1, '8'),
(11019, 'VRS', 'BTC', 'livecoin', '57.0653', '100000000', 1, '8'),
(11020, 'SLR', 'BTC', 'livecoin', '6.9491', '100000000', 1, '8'),
(11021, 'VEN', 'BTC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11022, 'BIO', 'BTC', 'livecoin', '318.1819', '100000000', 1, '8'),
(11023, 'FUN', 'USD', 'livecoin', '31.8182', '100000000', 1, '8'),
(11024, 'THS', 'ETH', 'livecoin', '11.5895', '100000000', 1, '8'),
(11025, 'XEM', 'ETH', 'livecoin', '5.5235', '100000000', 1, '8'),
(11026, 'XEM', 'USD', 'livecoin', '5.5235', '100000000', 1, '8'),
(11027, 'THS', 'EUR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11028, 'ARC', 'BCH', 'livecoin', '45.0644', '100000000', 1, '8'),
(11029, 'SYS', 'BTC', 'livecoin', '6.0484', '100000000', 1, '8'),
(11030, 'SIG', 'BTC', 'livecoin', '116.6667', '100000000', 1, '8'),
(11031, 'BSD', 'BTC', 'livecoin', '4.0588', '100000000', 1, '8'),
(11032, 'SPF', 'ETH', 'livecoin', '43.7501', '100000000', 1, '8'),
(11033, 'BRICKTOX', 'ETH', 'livecoin', '21.0421', '100000000', 1, '8'),
(11034, 'OBITS', 'ETH', 'livecoin', '3.8875', '100000000', 1, '8'),
(11035, 'OTN', 'BTC', 'livecoin', '0.6342', '100000000', 1, '8'),
(11036, 'CARB', 'ETH', 'livecoin', '11.5512', '100000000', 1, '8'),
(11037, 'MNTP', 'ETH', 'livecoin', '2.0001', '100000000', 1, '8'),
(11038, 'XMR', 'EURN', 'livecoin', '0.0068', '100000000', 1, '8'),
(11039, 'TRUMP', 'BTC', 'livecoin', '16.0551', '100000000', 1, '8'),
(11040, 'ELI', 'BTC', 'livecoin', '31.3433', '100000000', 1, '8'),
(11041, 'OBITS', 'USD', 'livecoin', '3.8875', '100000000', 1, '8'),
(11042, 'AMB', 'USD', 'livecoin', '4.2271', '100000000', 1, '8'),
(11043, 'EURN', 'BTC', 'livecoin', '0.7478', '100000000', 1, '8'),
(11044, 'CDX', 'BTC', 'livecoin', '70.4698', '100000000', 1, '8'),
(11045, 'OXY', 'BTC', 'livecoin', '16.2791', '100000000', 1, '8'),
(11046, 'ESC', 'BTC', 'livecoin', '31.5316', '100000000', 1, '8'),
(11047, 'VOISE', 'BTC', 'livecoin', '362.069', '100000000', 1, '8'),
(11048, 'KRB', 'RUB', 'livecoin', '3.8378', '100000000', 1, '8'),
(11049, 'PRG', 'USD', 'livecoin', '7.3069', '100000000', 1, '8'),
(11050, 'DOLLAR', 'BTC', 'livecoin', '75.0001', '100000000', 1, '8'),
(11051, 'LTT', 'BTC', 'livecoin', '30.1725', '100000000', 1, '8'),
(11052, 'ECO', 'ETH', 'livecoin', '1.0605', '100000000', 1, '8'),
(11053, 'HB', 'BTC', 'livecoin', '6.5421', '100000000', 1, '8'),
(11054, 'MNX', 'ETH', 'livecoin', '0.1065', '100000000', 1, '8'),
(11055, 'ETHOS', 'ETH', 'livecoin', '1.231', '100000000', 1, '8'),
(11056, 'GNT', 'USD', 'livecoin', '3.6345', '100000000', 1, '8'),
(11057, 'ETH', 'EURN', 'livecoin', '0.0019', '100000000', 1, '8'),
(11058, '1ST', 'BTC', 'livecoin', '6.0001', '100000000', 1, '8'),
(11059, 'SHIFT', 'ETH', 'livecoin', '0.881', '100000000', 1, '8'),
(11060, 'CHSB', 'BTC', 'livecoin', '80.7693', '100000000', 1, '8'),
(11061, 'NOKU', 'EURN', 'livecoin', '2.5247', '100000000', 1, '8'),
(11062, 'ATX', 'BTC', 'livecoin', '1050', '100000000', 1, '8'),
(11063, 'GNT', 'ETH', 'livecoin', '3.6345', '100000000', 1, '8'),
(11064, 'MRP', 'ETH', 'livecoin', '45.4546', '100000000', 1, '8'),
(11065, 'BLK', 'BTC', 'livecoin', '8.7647', '100000000', 1, '8'),
(11066, 'UTNP', 'BTC', 'livecoin', '80.7693', '100000000', 1, '8'),
(11067, 'XRL', 'ETH', 'livecoin', '6.6121', '100000000', 1, '8'),
(11068, 'CLPC', 'BTC', 'livecoin', '119.3182', '100000000', 1, '8'),
(11069, 'ZBC', 'RUB', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11070, 'RTB', 'BTC', 'livecoin', '21.9666', '100000000', 1, '8'),
(11071, 'EL', 'DANC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11072, 'NVC', 'BTC', 'livecoin', '0.469', '100000000', 1, '8'),
(11073, 'PRG', 'ETH', 'livecoin', '7.3069', '100000000', 1, '8'),
(11074, 'HNC', 'EUR', 'livecoin', '525', '100000000', 1, '8'),
(11075, 'CRYCASH', 'EUR', 'livecoin', '4.7044', '100000000', 1, '8'),
(11076, 'TRST', 'ETH', 'livecoin', '24.3056', '100000000', 1, '8'),
(11077, 'ENT', 'BTC', 'livecoin', '43.7501', '100000000', 1, '8'),
(11078, 'BRICKTOX', 'BTC', 'livecoin', '21.0421', '100000000', 1, '8'),
(11079, 'DIG', 'LTC', 'livecoin', '7.1332', '100000000', 1, '8'),
(11080, 'QTUM', 'BTC', 'livecoin', '0.1167', '100000000', 1, '8'),
(11081, 'BCH', 'RUB', 'livecoin', '0.0012', '100000000', 1, '8'),
(11082, 'PIN', 'ETH', 'livecoin', '28.7672', '100000000', 1, '8'),
(11083, 'EDG', 'BTC', 'livecoin', '2.3475', '100000000', 1, '8'),
(11084, 'TIME', 'BTC', 'livecoin', '0.0843', '100000000', 1, '8'),
(11085, 'TFL', 'ETH', 'livecoin', '1.3125', '100000000', 1, '8'),
(11086, 'DIME', 'BTC', 'livecoin', '10500', '100000000', 1, '8'),
(11087, 'PHI', 'USD', 'livecoin', '4.7663', '100000000', 1, '8'),
(11088, 'ECHO', 'USD', 'livecoin', '0.0105', '100000000', 1, '8'),
(11089, 'SNBL', 'ETH', 'livecoin', '65.625', '100000000', 1, '8'),
(11090, 'SHPING', 'BTC', 'livecoin', '1750.0001', '100000000', 1, '8'),
(11091, 'CASH', 'BTC', 'livecoin', '76.6424', '100000000', 1, '8'),
(11092, 'ERO', 'ETH', 'livecoin', '26.3158', '100000000', 1, '8'),
(11093, 'KAPU', 'BTC', 'livecoin', '194.4445', '100000000', 1, '8'),
(11094, 'FNC', 'BTC', 'livecoin', '80.1527', '100000000', 1, '8'),
(11095, 'TRST', 'USD', 'livecoin', '24.3056', '100000000', 1, '8'),
(11096, 'TGAME', 'BTC', 'livecoin', '52.5', '100000000', 1, '8'),
(11097, 'NEO', 'BTC', 'livecoin', '0.0296', '100000000', 1, '8'),
(11098, 'HB', 'RUB', 'livecoin', '6.5421', '100000000', 1, '8'),
(11099, 'PHI', 'ETH', 'livecoin', '4.7663', '100000000', 1, '8'),
(11100, 'BPTN', 'BTC', 'livecoin', '21.4724', '100000000', 1, '8'),
(11101, 'NMC', 'BTC', 'livecoin', '0.9743', '100000000', 1, '8'),
(11102, 'BNT', 'ETH', 'livecoin', '0.3635', '100000000', 1, '8'),
(11103, 'GRX', 'BTC', 'livecoin', '262.5', '100000000', 1, '8'),
(11104, 'ANT', 'USD', 'livecoin', '0.6949', '100000000', 1, '8'),
(11105, 'TAAS', 'USD', 'livecoin', '0.4601', '100000000', 1, '8'),
(11106, 'SPACECOIN', 'ETH', 'livecoin', '0.5562', '100000000', 1, '8'),
(11107, 'MNX', 'USD', 'livecoin', '0.1065', '100000000', 1, '8'),
(11108, 'DGD', 'BTC', 'livecoin', '0.0105', '100000000', 1, '8'),
(11109, 'ADL', 'BTC', 'livecoin', '25.1799', '100000000', 1, '8'),
(11110, 'DAY', 'ETH', 'livecoin', '0.8546', '100000000', 1, '8'),
(11111, 'ARTE', 'ETH', 'livecoin', '28.6886', '100000000', 1, '8'),
(11112, 'ZBC', 'BTC', 'livecoin', '0.0012', '100000000', 1, '8'),
(11113, 'CRYCASH', 'ETH', 'livecoin', '4.7044', '100000000', 1, '8'),
(11114, 'SHIFT', 'USD', 'livecoin', '0.881', '100000000', 1, '8'),
(11115, 'LTC', 'RUB', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11116, 'WGR', 'ETH', 'livecoin', '7.83', '100000000', 1, '8'),
(11117, 'ITI', 'ETH', 'livecoin', '0.1455', '100000000', 1, '8'),
(11118, 'BPC', 'BTC', 'livecoin', '92.1053', '100000000', 1, '8'),
(11119, 'XRC', 'BTC', 'livecoin', '134.6154', '100000000', 1, '8'),
(11120, 'BNT', 'USD', 'livecoin', '0.3635', '100000000', 1, '8'),
(11121, 'ANT', 'ETH', 'livecoin', '0.6949', '100000000', 1, '8'),
(11122, 'TNS', 'BTC', 'livecoin', '123.5295', '100000000', 1, '8'),
(11123, 'W3C', 'ETH', 'livecoin', '5250', '100000000', 1, '8'),
(11124, 'MONA', 'BTC', 'livecoin', '1.1404', '100000000', 1, '8'),
(11125, 'DTR', 'BTC', 'livecoin', '27.3438', '100000000', 1, '8'),
(11126, 'EMC', 'DASH', 'livecoin', '0.327', '100000000', 1, '8'),
(11127, 'DGB', 'USD', 'livecoin', '25.1197', '100000000', 1, '8'),
(11128, 'CRYCASH', 'USD', 'livecoin', '4.7044', '100000000', 1, '8'),
(11129, 'DGB', 'ETH', 'livecoin', '25.1197', '100000000', 1, '8'),
(11130, 'GRX', 'ETH', 'livecoin', '262.5', '100000000', 1, '8'),
(11131, 'VRS', 'USD', 'livecoin', '57.0653', '100000000', 1, '8'),
(11132, 'DASH', 'RUB', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11133, 'ITI', 'EUR', 'livecoin', '0.1455', '100000000', 1, '8'),
(11134, 'BPTN', 'ETH', 'livecoin', '21.4724', '100000000', 1, '8'),
(11135, 'DIME', 'USD', 'livecoin', '10500', '100000000', 1, '8'),
(11136, 'TUBE', 'USD', 'livecoin', '12.1952', '100000000', 1, '8'),
(11137, 'BCH', 'ZBC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11138, 'ERO', 'BTC', 'livecoin', '26.3158', '100000000', 1, '8'),
(11139, 'EOS', 'BTC', 'livecoin', '0.1083', '100000000', 1, '8'),
(11140, 'MNE', 'ETH', 'livecoin', '13.5136', '100000000', 1, '8'),
(11141, 'TGAME', 'ETH', 'livecoin', '52.5', '100000000', 1, '8'),
(11142, 'CLPC', 'ETH', 'livecoin', '119.3182', '100000000', 1, '8'),
(11143, 'WETT', 'BTC', 'livecoin', '36.7133', '100000000', 1, '8'),
(11144, 'HB', 'EUR', 'livecoin', '6.5421', '100000000', 1, '8'),
(11145, 'THANECOIN', 'ETH', 'livecoin', '198.1133', '100000000', 1, '8'),
(11146, 'VEN', 'ETH', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11147, 'FLIXX', 'ETH', 'livecoin', '15.1954', '100000000', 1, '8'),
(11148, 'GOLOS', 'BTC', 'livecoin', '16.9355', '100000000', 1, '8'),
(11149, 'CLOAK', 'BTC', 'livecoin', '0.3099', '100000000', 1, '8'),
(11150, 'BITHASH', 'BTC', 'livecoin', '172.1312', '100000000', 1, '8'),
(11151, 'ESR', 'DASH', 'livecoin', '0.6563', '100000000', 1, '8'),
(11152, 'VRM', 'BTC', 'livecoin', '0.9489', '100000000', 1, '8'),
(11153, 'ETH', 'RUB', 'livecoin', '0.0019', '100000000', 1, '8'),
(11154, 'ANT', 'BTC', 'livecoin', '0.6949', '100000000', 1, '8'),
(11155, 'VEN', 'USD', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11156, 'EMC', 'XMR', 'livecoin', '0.327', '100000000', 1, '8'),
(11157, 'FXT', 'BTC', 'livecoin', '17.8876', '100000000', 1, '8'),
(11158, 'ECHO', 'ETH', 'livecoin', '0.0105', '100000000', 1, '8'),
(11159, 'MNX', 'BTC', 'livecoin', '0.1065', '100000000', 1, '8'),
(11160, 'PPY', 'ETH', 'livecoin', '0.2766', '100000000', 1, '8'),
(11161, 'CNB', 'ETH', 'livecoin', '0.9422', '100000000', 1, '8'),
(11162, 'VIB', 'BTC', 'livecoin', '15.0001', '100000000', 1, '8'),
(11163, 'VOISE', 'EUR', 'livecoin', '362.069', '100000000', 1, '8'),
(11164, 'ELI', 'ETH', 'livecoin', '31.3433', '100000000', 1, '8'),
(11165, 'PLN', 'ETH', 'livecoin', '954.5455', '100000000', 1, '8'),
(11166, 'TUBE', 'ETH', 'livecoin', '12.1952', '100000000', 1, '8'),
(11167, 'CARB', 'BTC', 'livecoin', '11.5512', '100000000', 1, '8'),
(11168, 'DGB', 'EUR', 'livecoin', '25.1197', '100000000', 1, '8'),
(11169, 'BPC', 'ETH', 'livecoin', '92.1053', '100000000', 1, '8'),
(11170, 'DASH', 'BTC', 'livecoin', '0.0038', '100000000', 1, '8'),
(11171, 'MGO', 'BTC', 'livecoin', '3.7354', '100000000', 1, '8'),
(11172, 'CAPRICOIN', 'USD', 'livecoin', '0.5672', '100000000', 1, '8'),
(11173, 'PPY', 'USD', 'livecoin', '0.2766', '100000000', 1, '8'),
(11174, 'BEZ', 'ETH', 'livecoin', '13.7615', '100000000', 1, '8'),
(11175, 'HNC', 'ETH', 'livecoin', '525', '100000000', 1, '8'),
(11176, 'GOAL', 'ETH', 'livecoin', '1312.5', '100000000', 1, '8'),
(11177, '1ST', 'ETH', 'livecoin', '6.0001', '100000000', 1, '8'),
(11178, 'DIME', 'EUR', 'livecoin', '10500', '100000000', 1, '8'),
(11179, 'NOAH', 'BTC', 'livecoin', '750.0001', '100000000', 1, '8'),
(11180, 'AMM', 'USD', 'livecoin', '12.9311', '100000000', 1, '8'),
(11181, 'OBITS', 'BTS', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11182, 'GOAL', 'USD', 'livecoin', '1312.5', '100000000', 1, '8'),
(11183, 'IFAN', 'BTC', 'livecoin', '2100', '100000000', 1, '8'),
(11184, 'VLTC', 'BTC', 'livecoin', '10500', '100000000', 1, '8'),
(11185, '1ST', 'USD', 'livecoin', '6.0001', '100000000', 1, '8'),
(11186, 'PIVX', 'XMR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11187, 'MLN', 'BTC', 'livecoin', '0.0479', '100000000', 1, '8'),
(11188, 'FUN', 'BTC', 'livecoin', '31.8182', '100000000', 1, '8'),
(11189, 'CCRB', 'BTC', 'livecoin', '7.0001', '100000000', 1, '8'),
(11190, 'RTB', 'ETH', 'livecoin', '21.9666', '100000000', 1, '8'),
(11191, 'FLOT', 'ETH', 'livecoin', '28.1502', '100000000', 1, '8'),
(11192, 'MTCOIN', 'BTC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11193, 'TIME', 'ETH', 'livecoin', '0.0843', '100000000', 1, '8'),
(11194, 'ETH', 'BTC', 'livecoin', '0.0019', '100000000', 1, '8'),
(11195, 'BEZ', 'USD', 'livecoin', '13.7615', '100000000', 1, '8'),
(11196, 'CAPRICOIN', 'ETH', 'livecoin', '0.5672', '100000000', 1, '8'),
(11197, 'UTNP', 'ETH', 'livecoin', '80.7693', '100000000', 1, '8'),
(11198, 'KAPU', 'ETH', 'livecoin', '194.4445', '100000000', 1, '8'),
(11199, 'TIME', 'USD', 'livecoin', '0.0843', '100000000', 1, '8'),
(11200, 'SPA', 'BTC', 'livecoin', '5250', '100000000', 1, '8'),
(11201, 'HNC', 'USD', 'livecoin', '525', '100000000', 1, '8'),
(11202, 'BCH', 'BTC', 'livecoin', '0.0012', '100000000', 1, '8'),
(11203, 'TFL', 'BTC', 'livecoin', '1.3125', '100000000', 1, '8'),
(11204, 'ETHOS', 'USD', 'livecoin', '1.231', '100000000', 1, '8'),
(11205, 'DIME', 'ETH', 'livecoin', '10500', '100000000', 1, '8'),
(11206, 'EL', 'USD', 'livecoin', '19.1606', '100000000', 1, '8'),
(11207, 'EUR', 'EURN', 'livecoin', '0.6127', '100000000', 1, '8'),
(11208, 'IPL', 'ETH', 'livecoin', '34.7683', '100000000', 1, '8'),
(11209, 'RBM', 'EUR', 'livecoin', '350.0001', '100000000', 1, '8'),
(11210, 'ESR', 'ETH', 'livecoin', '0.6563', '100000000', 1, '8'),
(11211, 'TWC', 'BTC', 'livecoin', '750.0001', '100000000', 1, '8'),
(11212, 'FNC', 'USD', 'livecoin', '80.1527', '100000000', 1, '8'),
(11213, 'PPT', 'USD', 'livecoin', '0.2094', '100000000', 1, '8'),
(11214, 'SKCH', 'BTC', 'livecoin', '2.2601', '100000000', 1, '8'),
(11215, 'KRB', 'USD', 'livecoin', '3.8378', '100000000', 1, '8'),
(11216, 'SPD', 'ETH', 'livecoin', '194.4445', '100000000', 1, '8'),
(11217, 'ZRX', 'BTC', 'livecoin', '0.7554', '100000000', 1, '8'),
(11218, 'UQC', 'USD', 'livecoin', '1.3101', '100000000', 1, '8'),
(11219, 'IDH', 'BTC', 'livecoin', '60.0001', '100000000', 1, '8'),
(11220, 'PPT', 'ETH', 'livecoin', '0.2094', '100000000', 1, '8'),
(11221, 'PIPL', 'BTC', 'livecoin', '403.8462', '100000000', 1, '8'),
(11222, 'GB', 'BTC', 'livecoin', '87.5001', '100000000', 1, '8'),
(11223, 'ARC', 'USD', 'livecoin', '45.0644', '100000000', 1, '8'),
(11224, 'DMD', 'ETH', 'livecoin', '0.2702', '100000000', 1, '8'),
(11225, 'WGR', 'BTC', 'livecoin', '7.83', '100000000', 1, '8'),
(11226, 'ZBC', 'USD', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11227, 'SUMO', 'ETH', 'livecoin', '3.6046', '100000000', 1, '8'),
(11228, 'AMM', 'ETH', 'livecoin', '12.9311', '100000000', 1, '8'),
(11229, 'EURN', 'XMR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11230, 'CRBIT', 'LEO', 'livecoin', '22.8261', '100000000', 1, '8'),
(11231, 'VIEW', 'BTC', 'livecoin', '16.1539', '100000000', 1, '8'),
(11232, 'BCH', 'ETH', 'livecoin', '0.0012', '100000000', 1, '8'),
(11233, 'DOGE', 'BTC', 'livecoin', '276.3158', '100000000', 1, '8'),
(11234, 'MTCOIN', 'USD', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11235, 'FNC', 'ETH', 'livecoin', '80.1527', '100000000', 1, '8'),
(11236, 'NOKU', 'ETH', 'livecoin', '2.5247', '100000000', 1, '8'),
(11237, 'RBM', 'ETH', 'livecoin', '350.0001', '100000000', 1, '8'),
(11238, 'ARC', 'ETH', 'livecoin', '45.0644', '100000000', 1, '8'),
(11239, 'BTS', 'BTC', 'livecoin', '5.1801', '100000000', 1, '8'),
(11240, 'LTC', 'EUR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11241, 'XMR', 'BTC', 'livecoin', '0.0068', '100000000', 1, '8'),
(11242, 'UNC', 'BTC', 'livecoin', '10500', '100000000', 1, '8'),
(11243, 'ECO', 'BTC', 'livecoin', '1.0605', '100000000', 1, '8'),
(11244, 'WETT', 'USD', 'livecoin', '36.7133', '100000000', 1, '8'),
(11245, 'KNC', 'USD', 'livecoin', '1.0718', '100000000', 1, '8'),
(11246, 'ARK', 'BTC', 'livecoin', '0.8841', '100000000', 1, '8'),
(11247, 'THANECOIN', 'BTC', 'livecoin', '198.1133', '100000000', 1, '8'),
(11248, 'ORECTIC', 'USD', 'livecoin', '0.021', '100000000', 1, '8'),
(11249, 'INSN', 'USD', 'livecoin', '48.1652', '100000000', 1, '8'),
(11250, 'MCR', 'ETH', 'livecoin', '9.7857', '100000000', 1, '8'),
(11251, 'LSK', 'USD', 'livecoin', '0.1837', '100000000', 1, '8'),
(11252, 'DGB', 'BTC', 'livecoin', '25.1197', '100000000', 1, '8'),
(11253, 'QTUM', 'ETH', 'livecoin', '0.1167', '100000000', 1, '8'),
(11254, 'DMD', 'USD', 'livecoin', '0.2702', '100000000', 1, '8'),
(11255, 'GNO', 'ETH', 'livecoin', '0.0145', '100000000', 1, '8'),
(11256, 'PLBT', 'EMC', 'livecoin', '0.3182', '100000000', 1, '8'),
(11257, 'MNE', 'BTC', 'livecoin', '13.5136', '100000000', 1, '8'),
(11258, 'E-DINAR COIN', 'USD', 'livecoin', '75.0001', '100000000', 1, '8'),
(11259, 'DANC', 'ZBC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11260, 'BITHASH', 'ETH', 'livecoin', '172.1312', '100000000', 1, '8'),
(11261, 'MTCOIN', 'ETH', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11262, 'STORJ', 'BTC', 'livecoin', '1.753', '100000000', 1, '8'),
(11263, 'WETT', 'ETH', 'livecoin', '36.7133', '100000000', 1, '8'),
(11264, 'ONT', 'ETH', 'livecoin', '0.0292', '100000000', 1, '8'),
(11265, 'REP', 'BTC', 'livecoin', '0.0292', '100000000', 1, '8'),
(11266, 'LTC', 'USD', 'livecoin', '0.0108', '100000000', 1, '8'),
(11267, 'MTRC', 'BTC', 'livecoin', '4.9953', '100000000', 1, '8'),
(11268, 'GUP', 'ETH', 'livecoin', '7.4416', '100000000', 1, '8'),
(11269, 'XAUR', 'BTC', 'livecoin', '20.4281', '100000000', 1, '8'),
(11270, 'CRBIT', 'BTC', 'livecoin', '22.8261', '100000000', 1, '8'),
(11271, 'VSL', 'BTC', 'livecoin', '11.5895', '100000000', 1, '8'),
(11272, 'PLN', 'BTC', 'livecoin', '954.5455', '100000000', 1, '8'),
(11273, 'ONT', 'USD', 'livecoin', '0.0292', '100000000', 1, '8'),
(11274, 'ORECTIC', 'ETH', 'livecoin', '0.021', '100000000', 1, '8'),
(11275, 'PIN', 'BTC', 'livecoin', '28.7672', '100000000', 1, '8'),
(11276, 'INSN', 'ETH', 'livecoin', '48.1652', '100000000', 1, '8'),
(11277, 'DGB', 'RUB', 'livecoin', '25.1197', '100000000', 1, '8'),
(11278, 'QTUM', 'USD', 'livecoin', '0.1167', '100000000', 1, '8'),
(11279, 'FXT', 'ETH', 'livecoin', '17.8876', '100000000', 1, '8'),
(11280, 'KNC', 'ETH', 'livecoin', '1.0718', '100000000', 1, '8'),
(11281, 'ATM', 'ETH', 'livecoin', '1312.5', '100000000', 1, '8'),
(11282, 'GNO', 'USD', 'livecoin', '0.0145', '100000000', 1, '8'),
(11283, 'CREVA', 'BTC', 'livecoin', '10500', '100000000', 1, '8'),
(11284, 'HNR', 'ETH', 'livecoin', '0.0025', '100000000', 1, '8'),
(11285, 'IFAN', 'ETH', 'livecoin', '2100', '100000000', 1, '8'),
(11286, 'DIME', 'RUB', 'livecoin', '10500', '100000000', 1, '8'),
(11287, 'ICOS', 'ETH', 'livecoin', '0.0593', '100000000', 1, '8'),
(11288, 'ARK', 'USD', 'livecoin', '0.8841', '100000000', 1, '8'),
(11289, 'GNO', 'BTC', 'livecoin', '0.0145', '100000000', 1, '8'),
(11290, '42', 'USD', 'livecoin', '0.0001', '100000000', 1, '8'),
(11291, 'VRM', 'VRC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11292, 'LUNA', 'BTC', 'livecoin', '47.7273', '100000000', 1, '8'),
(11293, 'CAPRICOIN', 'BTC', 'livecoin', '0.5672', '100000000', 1, '8'),
(11294, 'HNR', 'USD', 'livecoin', '0.0025', '100000000', 1, '8'),
(11295, 'PHI', 'BTC', 'livecoin', '4.7663', '100000000', 1, '8'),
(11296, 'DMD', 'BTC', 'livecoin', '0.2702', '100000000', 1, '8'),
(11297, 'DASH', 'USD', 'livecoin', '0.0038', '100000000', 1, '8'),
(11298, 'MTRC', 'ETH', 'livecoin', '4.9953', '100000000', 1, '8'),
(11299, 'GUP', 'BTC', 'livecoin', '7.4416', '100000000', 1, '8'),
(11300, 'BLU', 'BTC', 'livecoin', '262.5', '100000000', 1, '8'),
(11301, 'ETH', 'USD', 'livecoin', '0.0019', '100000000', 1, '8'),
(11302, 'RUB', 'USD', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11303, 'BAT', 'ETH', 'livecoin', '3.0382', '100000000', 1, '8'),
(11304, 'CRBIT', 'ETH', 'livecoin', '22.8261', '100000000', 1, '8'),
(11305, 'PUT', 'BTC', 'livecoin', '362.069', '100000000', 1, '8'),
(11306, 'MLN', 'ETH', 'livecoin', '0.0479', '100000000', 1, '8'),
(11307, 'LTC', 'BTC', 'livecoin', '0.0108', '100000000', 1, '8'),
(11308, 'PRO', 'USD', 'livecoin', '1.2223', '100000000', 1, '8'),
(11309, 'BIT', 'BTC', 'livecoin', '80.1527', '100000000', 1, '8'),
(11310, 'CCRB', 'ETH', 'livecoin', '7.0001', '100000000', 1, '8'),
(11311, 'BAT', 'USD', 'livecoin', '3.0382', '100000000', 1, '8'),
(11312, 'UNRC', 'BTC', 'livecoin', '3500.0001', '100000000', 1, '8'),
(11313, 'KNC', 'BTC', 'livecoin', '1.0718', '100000000', 1, '8'),
(11314, 'DANC', 'BTC', 'livecoin', '1750.0001', '100000000', 1, '8'),
(11315, '42', 'ETH', 'livecoin', '0.0001', '100000000', 1, '8'),
(11316, 'MTRC', 'USD', 'livecoin', '4.9953', '100000000', 1, '8'),
(11317, 'ETHOS', 'BTC', 'livecoin', '1.231', '100000000', 1, '8'),
(11318, 'DTR', 'ETH', 'livecoin', '27.3438', '100000000', 1, '8'),
(11319, 'MLN', 'USD', 'livecoin', '0.0479', '100000000', 1, '8'),
(11320, 'EL', 'ZBC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11321, 'PRO', 'ETH', 'livecoin', '1.2223', '100000000', 1, '8'),
(11322, 'CDX', 'ETH', 'livecoin', '70.4698', '100000000', 1, '8'),
(11323, 'ICOS', 'USD', 'livecoin', '0.0593', '100000000', 1, '8'),
(11324, 'BTC', 'EUR', 'livecoin', '0.0001', '100000000', 1, '8'),
(11325, 'DIG', 'BTC', 'livecoin', '7.1332', '100000000', 1, '8'),
(11326, 'INSN', 'BTC', 'livecoin', '48.1652', '100000000', 1, '8'),
(11327, 'BEZ', 'BTC', 'livecoin', '13.7615', '100000000', 1, '8'),
(11328, 'ARK', 'ETH', 'livecoin', '0.8841', '100000000', 1, '8'),
(11329, 'TER', 'BTC', 'livecoin', '0.852', '100000000', 1, '8'),
(11330, 'BCH', 'USD', 'livecoin', '0.0012', '100000000', 1, '8'),
(11331, 'ELI', 'BCH', 'livecoin', '31.3433', '100000000', 1, '8'),
(11332, 'KRB', 'BTC', 'livecoin', '3.8378', '100000000', 1, '8'),
(11333, 'EOS', 'USD', 'livecoin', '0.1083', '100000000', 1, '8'),
(11334, 'ZRX', 'ETH', 'livecoin', '0.7554', '100000000', 1, '8'),
(11335, 'JOY', 'ETH', 'livecoin', '22.7766', '100000000', 1, '8'),
(11336, 'RBM', 'USD', 'livecoin', '350.0001', '100000000', 1, '8'),
(11337, 'ESC', 'ETH', 'livecoin', '31.5316', '100000000', 1, '8'),
(11338, 'EL', 'BTC', 'livecoin', '19.1606', '100000000', 1, '8'),
(11339, 'KPL', 'ETH', 'livecoin', '49.7631', '100000000', 1, '8'),
(11340, 'TWC', 'ETH', 'livecoin', '750.0001', '100000000', 1, '8'),
(11341, 'TNS', 'ETH', 'livecoin', '123.5295', '100000000', 1, '8'),
(11342, 'PIPL', 'ETH', 'livecoin', '403.8462', '100000000', 1, '8'),
(11343, 'ZBC', 'ETH', 'livecoin', '0.0012', '100000000', 1, '8'),
(11344, 'STRAT', 'BTC', 'livecoin', '0.3974', '100000000', 1, '8'),
(11345, 'EOS', 'ETH', 'livecoin', '0.1083', '100000000', 1, '8'),
(11346, 'PPT', 'BTC', 'livecoin', '0.2094', '100000000', 1, '8'),
(11347, 'CLD', 'BTC', 'livecoin', '43.0328', '100000000', 1, '8'),
(11348, 'ONL', 'ETH', 'livecoin', '14.7888', '100000000', 1, '8'),
(11349, 'USD', 'EURN', 'livecoin', '0.6839', '100000000', 1, '8'),
(11350, 'UQC', 'ETH', 'livecoin', '1.3101', '100000000', 1, '8'),
(11351, 'KPL', 'USD', 'livecoin', '49.7631', '100000000', 1, '8'),
(11352, 'DMC', 'USD', 'livecoin', '5250', '100000000', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(11353, 'OMG', 'ETH', 'livecoin', '0.1464', '100000000', 1, '8'),
(11354, 'YOC', 'USD', 'livecoin', '39.1792', '100000000', 1, '8'),
(11355, 'VIB', 'USD', 'livecoin', '15.0001', '100000000', 1, '8'),
(11356, 'VIEW', 'ETH', 'livecoin', '16.1539', '100000000', 1, '8'),
(11357, 'DOGE', 'USD', 'livecoin', '276.3158', '100000000', 1, '8'),
(11358, 'FLIXX', 'BTC', 'livecoin', '15.1954', '100000000', 1, '8'),
(11359, 'AMM', 'BTC', 'livecoin', '12.9311', '100000000', 1, '8'),
(11360, 'MSCN', 'ETH', 'livecoin', '525', '100000000', 1, '8'),
(11361, 'OMG', 'USD', 'livecoin', '0.1464', '100000000', 1, '8'),
(11362, 'TUBE', 'BTC', 'livecoin', '12.1952', '100000000', 1, '8'),
(11363, 'SKCH', 'ETH', 'livecoin', '2.2601', '100000000', 1, '8'),
(11364, 'BTC', 'USD', 'livecoin', '0.0001', '100000000', 1, '8'),
(11365, 'MOJO', 'BTC', 'livecoin', '49.0655', '100000000', 1, '8'),
(11366, 'YOC', 'ETH', 'livecoin', '39.1792', '100000000', 1, '8'),
(11367, 'NAM', 'BTC', 'livecoin', '0.0059', '100000000', 1, '8'),
(11368, 'ZBC', 'EUR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11369, 'PUT', 'RUB', 'livecoin', '362.069', '100000000', 1, '8'),
(11370, 'VIB', 'ETH', 'livecoin', '15.0001', '100000000', 1, '8'),
(11371, 'ARC', 'BTC', 'livecoin', '45.0644', '100000000', 1, '8'),
(11372, 'MSCN', 'USD', 'livecoin', '525', '100000000', 1, '8'),
(11373, 'WINGS', 'ETH', 'livecoin', '4.2701', '100000000', 1, '8'),
(11374, 'MTL', 'USD', 'livecoin', '0.9434', '100000000', 1, '8'),
(11375, 'ATM', 'BTC', 'livecoin', '1312.5', '100000000', 1, '8'),
(11376, 'EL', 'RUB', 'livecoin', '19.1606', '100000000', 1, '8'),
(11377, 'ONL', 'BTC', 'livecoin', '14.7888', '100000000', 1, '8'),
(11378, 'PISH', 'BTC', 'livecoin', '3500.0001', '100000000', 1, '8'),
(11379, 'E-DINAR COIN', 'BTC', 'livecoin', '75.0001', '100000000', 1, '8'),
(11380, 'EVC', 'ETH', 'livecoin', '8.1522', '100000000', 1, '8'),
(11381, 'SNGLS', 'BTC', 'livecoin', '28.2259', '100000000', 1, '8'),
(11382, 'JOY', 'BTC', 'livecoin', '22.7766', '100000000', 1, '8'),
(11383, 'RLT', 'USD', 'livecoin', '21.605', '100000000', 1, '8'),
(11384, 'ECIO', 'BTC', 'livecoin', '1750.0001', '100000000', 1, '8'),
(11385, 'FLP', 'ETH', 'livecoin', '14.0187', '100000000', 1, '8'),
(11386, 'TRX', 'USD', 'livecoin', '27.1318', '100000000', 1, '8'),
(11387, 'CVC', 'BTC', 'livecoin', '5.2032', '100000000', 1, '8'),
(11388, 'REP', 'ETH', 'livecoin', '0.0292', '100000000', 1, '8'),
(11389, 'ACN', 'BTC', 'livecoin', '10500', '100000000', 1, '8'),
(11390, 'TUBE', 'XMR', 'livecoin', '12.1952', '100000000', 1, '8'),
(11391, 'WINGS', 'BTC', 'livecoin', '4.2701', '100000000', 1, '8'),
(11392, 'PLBT', 'USD', 'livecoin', '0.3182', '100000000', 1, '8'),
(11393, 'PIVX', 'BTC', 'livecoin', '0.525', '100000000', 1, '8'),
(11394, 'DMC', 'BTC', 'livecoin', '5250', '100000000', 1, '8'),
(11395, 'REP', 'USD', 'livecoin', '0.0292', '100000000', 1, '8'),
(11396, 'ADZ', 'BTC', 'livecoin', '60.3449', '100000000', 1, '8'),
(11397, 'TWC', 'USD', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11398, 'MCR', 'BTC', 'livecoin', '9.7857', '100000000', 1, '8'),
(11399, 'MSCN', 'EUR', 'livecoin', '525', '100000000', 1, '8'),
(11400, 'TKN', 'BTC', 'livecoin', '1.0669', '100000000', 1, '8'),
(11401, 'HXX', 'BTC', 'livecoin', '0.2153', '100000000', 1, '8'),
(11402, 'MTL', 'ETH', 'livecoin', '0.9434', '100000000', 1, '8'),
(11403, 'GYC', 'BTC', 'livecoin', '269.2308', '100000000', 1, '8'),
(11404, 'PLBT', 'ETH', 'livecoin', '0.3182', '100000000', 1, '8'),
(11405, 'UQC', 'BTC', 'livecoin', '1.3101', '100000000', 1, '8'),
(11406, 'NOX', 'BTC', 'livecoin', '25.6724', '100000000', 1, '8'),
(11407, 'OMG', 'BTC', 'livecoin', '0.1464', '100000000', 1, '8'),
(11408, 'ARC', 'RUB', 'livecoin', '45.0644', '100000000', 1, '8'),
(11409, 'ZRX', 'USD', 'livecoin', '0.7554', '100000000', 1, '8'),
(11410, 'EMC', 'ETH', 'livecoin', '0.327', '100000000', 1, '8'),
(11411, 'EETT', 'WETT', 'livecoin', '33.7621', '100000000', 1, '8'),
(11412, 'HVN', 'BTC', 'livecoin', '17.5586', '100000000', 1, '8'),
(11413, 'VIU', 'ETH', 'livecoin', '807.6924', '100000000', 1, '8'),
(11414, 'E-DINAR COIN', 'RUB', 'livecoin', '75.0001', '100000000', 1, '8'),
(11415, 'IPL', 'BTC', 'livecoin', '34.7683', '100000000', 1, '8'),
(11416, 'LEO', 'USD', 'livecoin', '3.6021', '100000000', 1, '8'),
(11417, 'IDH', 'ETH', 'livecoin', '60.0001', '100000000', 1, '8'),
(11418, 'FUNC', 'ETH', 'livecoin', '88.2353', '100000000', 1, '8'),
(11419, 'ESR', 'BTC', 'livecoin', '0.6563', '100000000', 1, '8'),
(11420, 'PELO', 'BTC', 'livecoin', '61.4036', '100000000', 1, '8'),
(11421, 'PRES', 'BTC', 'livecoin', '92.1053', '100000000', 1, '8'),
(11422, 'EETT', 'BTC', 'livecoin', '33.7621', '100000000', 1, '8'),
(11423, 'SPD', 'BTC', 'livecoin', '194.4445', '100000000', 1, '8'),
(11424, 'USC', 'BTC', 'livecoin', '45.6522', '100000000', 1, '8'),
(11425, 'ZBC', 'XMR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11426, 'RLC', 'BTC', 'livecoin', '1.8512', '100000000', 1, '8'),
(11427, 'ORME', 'BTC', 'livecoin', '1.2577', '100000000', 1, '8'),
(11428, 'RLT', 'ETH', 'livecoin', '21.605', '100000000', 1, '8'),
(11429, 'ESP', 'ETH', 'livecoin', '5250', '100000000', 1, '8'),
(11430, 'SOAR', 'ETH', 'livecoin', '41.6667', '100000000', 1, '8'),
(11431, 'LEO', 'ETH', 'livecoin', '3.6021', '100000000', 1, '8'),
(11432, 'NOKU', 'BTC', 'livecoin', '2.5247', '100000000', 1, '8'),
(11433, 'NXT', 'BTC', 'livecoin', '9.0988', '100000000', 1, '8'),
(11434, 'SUMO', 'BTC', 'livecoin', '3.6046', '100000000', 1, '8'),
(11435, 'PIVX', 'RUB', 'livecoin', '0.525', '100000000', 1, '8'),
(11436, 'BTB', 'ETH', 'livecoin', '0.1049', '100000000', 1, '8'),
(11437, 'BLU', 'USD', 'livecoin', '262.5', '100000000', 1, '8'),
(11438, 'LSK', 'BTC', 'livecoin', '0.1837', '100000000', 1, '8'),
(11439, 'CURE', 'BTC', 'livecoin', '6.1911', '100000000', 1, '8'),
(11440, 'XMR', 'USD', 'livecoin', '0.0068', '100000000', 1, '8'),
(11441, 'FUNC', 'USD', 'livecoin', '88.2353', '100000000', 1, '8'),
(11442, 'NAM', 'ETH', 'livecoin', '0.0059', '100000000', 1, '8'),
(11443, 'POST', 'BTC', 'livecoin', '60.3449', '100000000', 1, '8'),
(11444, 'DIG', 'USD', 'livecoin', '7.1332', '100000000', 1, '8'),
(11445, 'PELO', 'USD', 'livecoin', '61.4036', '100000000', 1, '8'),
(11446, 'EMC', 'BTC', 'livecoin', '0.327', '100000000', 1, '8'),
(11447, 'STORJ', 'ETH', 'livecoin', '1.753', '100000000', 1, '8'),
(11448, 'TER', 'ETH', 'livecoin', '0.852', '100000000', 1, '8'),
(11449, 'RST', 'ETH', 'livecoin', '0.2545', '100000000', 1, '8'),
(11450, 'RBM', 'BTC', 'livecoin', '350.0001', '100000000', 1, '8'),
(11451, 'TRUMP', 'ETH', 'livecoin', '16.0551', '100000000', 1, '8'),
(11452, 'EURN', 'EUR', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11453, 'BIO', 'ETH', 'livecoin', '318.1819', '100000000', 1, '8'),
(11454, 'YOC', 'BTC', 'livecoin', '39.1792', '100000000', 1, '8'),
(11455, 'ORME', 'USD', 'livecoin', '1.2577', '100000000', 1, '8'),
(11456, 'XMS', 'BTC', 'livecoin', '5250', '100000000', 1, '8'),
(11457, 'THS', 'BTC', 'livecoin', '11.5895', '100000000', 1, '8'),
(11458, 'XEM', 'BTC', 'livecoin', '5.5235', '100000000', 1, '8'),
(11459, 'KPL', 'BTC', 'livecoin', '49.7631', '100000000', 1, '8'),
(11460, 'INCNT', 'BTC', 'livecoin', '3.7866', '100000000', 1, '8'),
(11461, 'B2B', 'ETH', 'livecoin', '4.037', '100000000', 1, '8'),
(11462, 'STRAT', 'ETH', 'livecoin', '0.3974', '100000000', 1, '8'),
(11463, 'CLD', 'ETH', 'livecoin', '43.0328', '100000000', 1, '8'),
(11464, 'GAME', 'BTC', 'livecoin', '3.7893', '100000000', 1, '8'),
(11465, 'OTN', 'USD', 'livecoin', '0.6342', '100000000', 1, '8'),
(11466, 'ORME', 'ETH', 'livecoin', '1.2577', '100000000', 1, '8'),
(11467, 'MSCN', 'BTC', 'livecoin', '525', '100000000', 1, '8'),
(11468, 'PPC', 'USD', 'livecoin', '0.7447', '100000000', 1, '8'),
(11469, 'EURN', 'ETH', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11470, 'STORJ', 'USD', 'livecoin', '1.753', '100000000', 1, '8'),
(11471, 'STRAT', 'USD', 'livecoin', '0.3974', '100000000', 1, '8'),
(11472, 'PELO', 'ETH', 'livecoin', '61.4036', '100000000', 1, '8'),
(11473, 'AMB', 'BTC', 'livecoin', '4.2271', '100000000', 1, '8'),
(11474, 'ONT', 'BTC', 'livecoin', '0.0292', '100000000', 1, '8'),
(11475, 'USD', 'RUB', 'livecoin', '0.6839', '100000000', 1, '8'),
(11476, 'THS', 'RUB', 'livecoin', '11.5895', '100000000', 1, '8'),
(11477, 'EURN', 'USD', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11478, 'SPF', 'BTC', 'livecoin', '43.7501', '100000000', 1, '8'),
(11479, 'NAM', 'USD', 'livecoin', '0.0059', '100000000', 1, '8'),
(11480, 'SNT', 'ETH', 'livecoin', '14.8515', '100000000', 1, '8'),
(11481, 'SXC', 'BTC', 'livecoin', '64.0244', '100000000', 1, '8'),
(11482, 'OTN', 'ETH', 'livecoin', '0.6342', '100000000', 1, '8'),
(11483, 'ORECTIC', 'BTC', 'livecoin', '0.021', '100000000', 1, '8'),
(11484, 'BTB', 'BTC', 'livecoin', '0.1049', '100000000', 1, '8'),
(11485, 'PIVX', 'EUR', 'livecoin', '0.525', '100000000', 1, '8'),
(11486, 'NOX', 'ETH', 'livecoin', '25.6724', '100000000', 1, '8'),
(11487, 'EMC', 'RUB', 'livecoin', '0.327', '100000000', 1, '8'),
(11488, 'SNGLS', 'ETH', 'livecoin', '28.2259', '100000000', 1, '8'),
(11489, 'LDC', 'BTC', 'livecoin', '700.0001', '100000000', 1, '8'),
(11490, 'SNT', 'USD', 'livecoin', '14.8515', '100000000', 1, '8'),
(11491, 'TKN', 'ETH', 'livecoin', '1.0669', '100000000', 1, '8'),
(11492, 'CVC', 'USD', 'livecoin', '5.2032', '100000000', 1, '8'),
(11493, 'ICOS', 'BTC', 'livecoin', '0.0593', '100000000', 1, '8'),
(11494, 'FLP', 'BTC', 'livecoin', '14.0187', '100000000', 1, '8'),
(11495, 'CVC', 'ETH', 'livecoin', '5.2032', '100000000', 1, '8'),
(11496, 'SNGLS', 'USD', 'livecoin', '28.2259', '100000000', 1, '8'),
(11497, 'MCO', 'USD', 'livecoin', '0.1236', '100000000', 1, '8'),
(11498, 'LEDU', 'BTC', 'livecoin', '63.6364', '100000000', 1, '8'),
(11499, 'RLT', 'BTC', 'livecoin', '21.605', '100000000', 1, '8'),
(11500, 'ECIO', 'ETH', 'livecoin', '1750.0001', '100000000', 1, '8'),
(11501, 'HNR', 'BTC', 'livecoin', '0.0025', '100000000', 1, '8'),
(11502, 'GRS', 'ETH', 'livecoin', '1.3855', '100000000', 1, '8'),
(11503, 'BURST', 'BTC', 'livecoin', '75.5396', '100000000', 1, '8'),
(11504, 'PRO', 'BTC', 'livecoin', '1.2223', '100000000', 1, '8'),
(11505, 'TRX', 'ETH', 'livecoin', '27.1318', '100000000', 1, '8'),
(11506, 'BIO', 'USD', 'livecoin', '318.1819', '100000000', 1, '8'),
(11507, 'AMB', 'RUB', 'livecoin', '4.2271', '100000000', 1, '8'),
(11508, 'TKN', 'USD', 'livecoin', '1.0669', '100000000', 1, '8'),
(11509, 'MSCN', 'RUB', 'livecoin', '525', '100000000', 1, '8'),
(11510, 'MCO', 'ETH', 'livecoin', '0.1236', '100000000', 1, '8'),
(11511, 'BTC', 'RUB', 'livecoin', '0.0001', '100000000', 1, '8'),
(11512, 'ZBC', 'DANC', 'livecoin', '1.0E-8', '100000000', 1, '8'),
(11513, 'BAT', 'BTC', 'livecoin', '3.0382', '100000000', 1, '8'),
(11514, 'DANC', 'USD', 'livecoin', '1750.0001', '100000000', 1, '8'),
(11515, 'PUT', 'ETH', 'livecoin', '362.069', '100000000', 1, '8'),
(11516, 'YOC', 'RUB', 'livecoin', '39.1792', '100000000', 1, '8'),
(11517, 'COV', 'BTC', 'livecoin', '0.8711', '100000000', 1, '8'),
(11518, 'GRS', 'USD', 'livecoin', '1.3855', '100000000', 1, '8'),
(11519, 'ASAFE2', 'USD', 'livecoin', '57.6924', '100000000', 1, '8'),
(11520, 'PAY', 'BTC', 'livecoin', '1.1288', '100000000', 1, '8'),
(11521, 'PUT', 'USD', 'livecoin', '362.069', '100000000', 1, '8'),
(11522, 'DIG', 'ETH', 'livecoin', '7.1332', '100000000', 1, '8'),
(11523, 'ETHP', 'ETH', 'livecoin', '53.2995', '100000000', 1, '8'),
(11524, 'WETT', 'WAVES', 'livecoin', '36.7133', '100000000', 1, '8'),
(11525, '42', 'BTC', 'livecoin', '0.0001', '100000000', 1, '8'),
(11526, 'PLBT', 'BTC', 'livecoin', '0.3182', '100000000', 1, '8'),
(11527, 'UNRC', 'USD', 'livecoin', '3500.0001', '100000000', 1, '8'),
(11528, 'BTC', 'AUD', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11529, 'LTC', 'AUD', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11530, 'ETH', 'AUD', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11531, 'ETC', 'AUD', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11532, 'XRP', 'AUD', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11533, 'BCH', 'AUD', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11534, 'LTC', 'BTC', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11535, 'ETH', 'BTC', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11536, 'ETC', 'BTC', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11537, 'XRP', 'BTC', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11538, 'BCH', 'BTC', 'btcmarkets', '0.001', '0.001', 1, '3'),
(11539, 'BBN', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11540, 'BBN', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11541, 'BBN', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11542, 'BCH', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11543, 'BTC', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11544, 'BTC', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11545, 'BTM', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11546, 'BTM', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11547, 'BTM', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11548, 'BTV', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11549, 'CARD', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11550, 'CARD', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11551, 'CARD', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11552, 'CDY', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11553, 'CET', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11554, 'CET', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11555, 'CET', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11556, 'CET', 'USDT', 'coinex', '1', '0.001', 1, '8'),
(11557, 'CODY', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11558, 'CODY', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11559, 'CTXC', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11560, 'CTXC', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11561, 'CTXC', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11562, 'DACC', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11563, 'DACC', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11564, 'DACC', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11565, 'DASH', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11566, 'DASH', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11567, 'DASH', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11568, 'DCR', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11569, 'DCR', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11570, 'DOGE', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11571, 'DOGE', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11572, 'EGT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11573, 'EGT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11574, 'EGT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11575, 'EOS', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11576, 'EOS', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11577, 'EOSDAC', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11578, 'EOSDAC', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11579, 'EOS', 'ETH', 'coinex', '0.001', '0.001', 1, '8'),
(11580, 'EOS', 'USDT', 'coinex', '0.01', '0.001', 1, '8'),
(11581, 'ETC', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11582, 'ETC', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11583, 'ETC', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11584, 'ETH', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11585, 'ETH', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11586, 'ETH', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11587, 'HOT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11588, 'HOT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11589, 'HOT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11590, 'HSR', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11591, 'HSR', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11592, 'HYDRO', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11593, 'HYDRO', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11594, 'HYDRO', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11595, 'ICX', 'BCH', 'coinex', '1', '0.001', 0, '8'),
(11596, 'ICX', 'BTC', 'coinex', '1', '0.001', 0, '8'),
(11597, 'ICX', 'ETH', 'coinex', '1', '0.001', 0, '8'),
(11598, 'KAN', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11599, 'KAN', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11600, 'KAN', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11601, 'LFT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11602, 'LFT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11603, 'LFT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11604, 'LFT', 'USDT', 'coinex', '1', '0.001', 1, '8'),
(11605, 'LOOM', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11606, 'LOOM', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11607, 'LOOM', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11608, 'LTC', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11609, 'LTC', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11610, 'LTC', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11611, 'MGD', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11612, 'MGD', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11613, 'MT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11614, 'MT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11615, 'MT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11616, 'NANO', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11617, 'NANO', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11618, 'NASH', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11619, 'NASH', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11620, 'NASH', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11621, 'NEO', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11622, 'NEO', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11623, 'NOBS', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11624, 'NOBS', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11625, 'NOBS', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11626, 'OLT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11627, 'OLT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11628, 'OLT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11629, 'OLT', 'USDT', 'coinex', '1', '0.001', 1, '8'),
(11630, 'OMG', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11631, 'OMG', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11632, 'OMG', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11633, 'QTUM', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11634, 'QTUM', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11635, 'RHOC', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11636, 'RHOC', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11637, 'SC', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11638, 'SC', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11639, 'SC', 'USDT', 'coinex', '1', '0.001', 1, '8'),
(11640, 'SEELE', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11641, 'SEELE', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11642, 'SEELE', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11643, 'SEER', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11644, 'SEER', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11645, 'SEER', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11646, 'SOP', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11647, 'SOP', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11648, 'SOP', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11649, 'TCT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11650, 'TCT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11651, 'TCT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11652, 'THPC', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11653, 'THPC', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11654, 'THPC', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11655, 'TRX', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11656, 'TRX', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11657, 'TRX', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11658, 'USCA', 'BTC', 'coinex', '0.001', '0.001', 0, '8'),
(11659, 'USCB', 'BTC', 'coinex', '0.001', '0.001', 0, '8'),
(11660, 'USHA', 'BCH', 'coinex', '0.001', '0.001', 0, '8'),
(11661, 'USHB', 'BCH', 'coinex', '0.001', '0.001', 0, '8'),
(11662, 'VEN', 'BCH', 'coinex', '0.001', '0.001', 0, '8'),
(11663, 'VEN', 'BTC', 'coinex', '0.001', '0.001', 0, '8'),
(11664, 'VET', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11665, 'VET', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11666, 'VET', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11667, 'VITE', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11668, 'VITE', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11669, 'VITE', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11670, 'WHC', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11671, 'WINGS', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11672, 'WINGS', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11673, 'WINGS', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11674, 'XMC', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11675, 'XMC', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11676, 'XMR', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11677, 'XMR', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11678, 'XMR', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11679, 'XMV', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11680, 'XMV', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11681, 'XRP', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11682, 'XRP', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11683, 'XRP', 'USDT', 'coinex', '1', '0.001', 1, '8'),
(11684, 'ZEC', 'BCH', 'coinex', '0.001', '0.001', 1, '8'),
(11685, 'ZEC', 'BTC', 'coinex', '0.001', '0.001', 1, '8'),
(11686, 'ZEC', 'USDT', 'coinex', '0.001', '0.001', 1, '8'),
(11687, 'ZIL', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11688, 'ZIL', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11689, 'ZIL', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11690, 'ZRX', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(11691, 'ZRX', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(11692, 'ZRX', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(11693, 'BTC', 'IDR', 'luno', '0.001', '0.001', 1, '3'),
(11694, 'BTC', 'MYR', 'luno', '0.001', '0.001', 1, '3'),
(11695, 'BTC', 'NGN', 'luno', '0.001', '0.001', 1, '3'),
(11696, 'BTC', 'ZAR', 'luno', '0.001', '0.001', 1, '3'),
(11697, 'ETH', 'BTC', 'luno', '0.001', '0.001', 1, '3'),
(11698, 'BTC', 'EUR', 'luno', '0.001', '0.001', 1, '3'),
(11699, 'BCH', 'BTC', 'bitbank', '0.001', '0.001', 1, '8'),
(11700, 'BCH', 'JPY', 'bitbank', '0.001', '0.001', 1, '8'),
(11701, 'MONA', 'BTC', 'bitbank', '0.001', '0.001', 1, '8'),
(11702, 'MONA', 'JPY', 'bitbank', '0.001', '0.001', 1, '8'),
(11703, 'ETH', 'BTC', 'bitbank', '0.001', '0.001', 1, '8'),
(11704, 'LTC', 'BTC', 'bitbank', '0.001', '0.001', 1, '8'),
(11705, 'XRP', 'JPY', 'bitbank', '0.001', '0.001', 1, '8'),
(11706, 'BTC', 'JPY', 'bitbank', '0.001', '0.001', 1, '8'),
(11707, 'XRP', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11709, 'ETH', 'XXX', 'bitmex', '0.001', '0.001', 0, '3'),
(11710, 'EOS', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11712, 'BCH', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11714, 'ADA', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11716, 'TRX', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11723, 'BTC', 'USD', 'bitmex', '0.001', '0.001', 0, '3'),
(11725, 'BTC', 'XXX', 'bitmex', '0.001', '0.001', 0, '3'),
(11733, 'BTC', 'JPY', 'bitmex', '0.001', '0.001', 0, '3'),
(11740, 'ETH', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11748, 'ETH', 'USD', 'bitmex', '0.001', '0.001', 0, '3'),
(11750, 'LTC', 'BTC', 'bitmex', '0.001', '0.001', 0, '3'),
(11752, 'USD', 'XXX', 'bitmex', '0.001', '0.001', 0, '3'),
(11756, 'BTC', 'BTC', 'bitmex', '1', '10000000', 1, '0'),
(11763, 'BTC', 'USD', 'okcoinusd', '0.001', '0.001', 1, '4'),
(11764, 'LTC', 'USD', 'okcoinusd', '0.1', '0.001', 1, '4'),
(11765, 'ETH', 'USD', 'okcoinusd', '0.01', '0.001', 1, '4'),
(11766, 'ETC', 'USD', 'okcoinusd', '0.1', '0.001', 1, '4'),
(11767, 'BCH', 'USD', 'okcoinusd', '0.001', '0.001', 1, '4'),
(11768, 'TUSD', 'USD', 'okcoinusd', '0.01', '0.001', 1, '8'),
(22532, 'ADA', 'BTC', 'exmo', '0.01', '200000', 1, '8'),
(22533, 'ADA', 'USD', 'exmo', '0.01', '200000', 1, '8'),
(22534, 'ADA', 'ETH', 'exmo', '0.01', '200000', 1, '8'),
(22535, 'INK', 'BTC', 'exmo', '0.01', '200000', 1, '8'),
(22536, 'INK', 'ETH', 'exmo', '0.01', '200000', 1, '8'),
(22537, 'INK', 'USD', 'exmo', '0.01', '200000', 1, '8'),
(23927, 'PHX', 'BTC', 'binance', '1', '90000000', 1, '0'),
(23928, 'PHX', 'ETH', 'binance', '1', '90000000', 1, '0'),
(23929, 'PHX', 'BNB', 'binance', '1', '90000000', 1, '0'),
(23930, 'HC', 'BTC', 'binance', '0.01', '90000000', 1, '2'),
(23931, 'HC', 'ETH', 'binance', '0.01', '90000000', 1, '2'),
(23947, 'ETC', 'GBP', 'gdax', '0.1', '5000', 1, '8'),
(23948, 'ETH', 'GBP', 'gdax', '0.01', '350', 1, '8'),
(23949, 'LTC', 'GBP', 'gdax', '0.1', '1000', 1, '8'),
(23950, 'BCH', 'GBP', 'gdax', '0.01', '120', 1, '8'),
(24517, 'ERT', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(24747, 'NLC2', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24784, 'PROC', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(24837, 'XCLR', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(24838, 'BAT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24839, 'BAT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24840, 'BAT', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(24841, 'SRN', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24842, 'SRN', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24843, 'SRN', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(24844, 'SVD', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24845, 'SVD', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24846, 'SVD', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(24847, 'GST', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24848, 'GST', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24849, 'GST', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(24850, 'BNB', 'BTC', 'hitbtc2', '1', '0.001', 1, '0'),
(24851, 'BNB', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(24852, 'BNB', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(24853, 'DIT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24854, 'DIT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24855, 'UMT', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24856, 'UMT', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24857, 'BCST', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(24858, 'BCST', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(24859, 'BCST', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(24860, 'POA20', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(24861, 'RIK', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(24862, 'RIK', 'ETH', 'hitbtc2', '10', '0.001', 1, '1'),
(24863, 'RIK', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(24864, 'CCL', 'USDT', 'hitbtc2', '10', '0.001', 1, '1'),
(24865, 'POA20', 'ETH', 'hitbtc2', '1', '0.001', 1, '0'),
(24866, 'POA20', 'USDT', 'hitbtc2', '1', '0.001', 1, '0'),
(24867, 'POA20', 'DAI', 'hitbtc2', '1', '0.001', 1, '0'),
(24868, 'NIM', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(24869, 'USE', 'BTC', 'hitbtc2', '1000', '0.001', 1, '3'),
(24870, 'USE', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(24871, 'ABTC', 'BTC', 'hitbtc2', '10', '0.001', 1, '1'),
(24872, 'DAV', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24873, 'DAV', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24874, 'ABA', 'BTC', 'hitbtc2', '100', '0.001', 1, '2'),
(24875, 'ABA', 'ETH', 'hitbtc2', '100', '0.001', 1, '2'),
(24876, 'ABA', 'USDT', 'hitbtc2', '100', '0.001', 1, '2'),
(24877, 'NIM', 'ETH', 'hitbtc2', '1000', '0.001', 1, '3'),
(24968, 'UT', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24969, 'UT', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24984, 'LOC', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24985, 'LOC', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24986, 'MVP', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24987, 'MVP', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24988, 'TRX', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24989, 'TRX', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24992, 'ZRX', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(24993, 'ZRX', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(25130, 'PHX', 'BTC', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(25131, 'PHX', 'ETH', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(25169, 'ETC', 'USDT', 'kucoin', '0.1', '0.001', 1, '8'),
(25190, 'BTG', 'USDT', 'kucoin', '0.001', '0.001', 1, '8'),
(25194, 'DADI', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(25195, 'DASH', 'USDT', 'kucoin', '0.01', '0.001', 1, '8'),
(25196, 'DOCK', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(25197, 'GO', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(25214, 'KICK', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(25215, 'OPEN', 'USDT', 'kucoin', '1', '0.001', 1, '8'),
(25216, 'VET', 'USDT', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(25217, 'XLM', 'USDT', 'kucoin', '1.0E-8', '0.001', 1, '8'),
(25218, 'OMG', 'USDT', 'kucoin', '0.1', '0.001', 1, '8'),
(25230, 'QTUM', 'USDT', 'kucoin', '0.1', '0.001', 1, '8'),
(25422, 'SNT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25423, 'SNT', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25424, 'SNT', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25425, 'KNC', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25426, 'KNC', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25427, 'KNC', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25428, 'BAT', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25429, 'BAT', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25430, 'BAT', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25431, 'LOOM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25432, 'LOOM', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25433, 'LOOM', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25434, 'DOGE', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25435, 'GNT', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25436, 'LSK', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25437, 'SC', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25438, 'ZRX', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25439, 'QTUM', 'BTC', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25440, 'QTUM', 'ETH', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25441, 'QTUM', 'USDT', 'poloniex', '1.0E-8', '1000000000', 1, '8'),
(25459, 'BFT', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25502, 'ENJ', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25521, 'GO', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25528, 'HYDRO', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25589, 'RVN', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25622, 'UPP', 'BTC', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25697, 'ADA', 'USD', 'bittrex', '0.001', '0.001', 1, '8'),
(25699, 'ETC', 'USD', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25703, 'XRP', 'USD', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(25704, 'ZEC', 'USD', 'bittrex', '0.001', '0.001', 1, '8'),
(25712, 'DOGE', 'USDT', 'bittrex', '1.0E-8', '0.001', 1, '8'),
(33323, 'HOMA', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33324, 'HOMA', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33325, 'HOMA', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33326, 'HOMA', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33327, 'HOMA', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33328, 'HOMA', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33329, 'PAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33330, 'PAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33331, 'PAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33332, 'PAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33333, 'PAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33334, 'PAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33335, 'ELY', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33336, 'ELY', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33337, 'ELY', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33338, 'ELY', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33339, 'ELY', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33340, 'ELY', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33341, 'TVT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33342, 'TVT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33343, 'TVT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33344, 'TVT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33345, 'TVT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33346, 'TVT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33347, 'WORK', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33348, 'WORK', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33349, 'WORK', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33350, 'WORK', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33351, 'WORK', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33352, 'WORK', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33353, 'ODEM', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33354, 'ODEM', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33355, 'ODEM', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33356, 'ODEM', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33357, 'ODEM', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33358, 'ODEM', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33359, 'TTU', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33360, 'TTU', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33361, 'TTU', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33362, 'TTU', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33363, 'TTU', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33364, 'TTU', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33365, 'FXT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33366, 'FXT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33367, 'FXT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33368, 'FXT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33369, 'FXT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33370, 'FXT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33371, 'VERI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33372, 'VERI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33373, 'VERI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33374, 'VERI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33375, 'VERI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33376, 'VERI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33377, 'PLR', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33378, 'PLR', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33379, 'PLR', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33380, 'PLR', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33381, 'PLR', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33382, 'PLR', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33383, 'SWAT', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33384, 'SWAT', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33385, 'SWAT', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33386, 'SWAT', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33387, 'SWAT', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33388, 'SWAT', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33389, 'GAI', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33390, 'GAI', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33391, 'GAI', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33392, 'GAI', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33393, 'GAI', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33394, 'GAI', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33395, 'CNC', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33396, 'CNC', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33397, 'CNC', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33398, 'CNC', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33399, 'CNC', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33400, 'CNC', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33401, 'UBEX', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33402, 'UBEX', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33403, 'UBEX', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33404, 'UBEX', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33405, 'UBEX', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33406, 'UBEX', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33407, 'MEME', 'BTC', 'yobit', '0.0001', '0.001', 1, '8'),
(33408, 'MEME', 'ETH', 'yobit', '0.0001', '0.001', 1, '8'),
(33409, 'MEME', 'DOGE', 'yobit', '0.0001', '0.001', 1, '8'),
(33410, 'MEME', 'WAVES', 'yobit', '0.0001', '0.001', 1, '8'),
(33411, 'MEME', 'USD', 'yobit', '0.0001', '0.001', 1, '8'),
(33412, 'MEME', 'RUB', 'yobit', '0.0001', '0.001', 1, '8'),
(33674, 'ABL', 'BTC', 'okex', '1', '0.001', 1, '8'),
(33864, 'ABL', 'ETH', 'okex', '1', '0.001', 1, '8'),
(34074, 'TRX', 'OKB', 'okex', '1', '0.001', 1, '8'),
(34090, 'NEO', 'BTC', 'exmo', '0.01', '200000', 1, '8'),
(34091, 'NEO', 'USD', 'exmo', '0.01', '200000', 1, '8'),
(34092, 'NEO', 'RUB', 'exmo', '0.01', '200000', 1, '8'),
(34096, 'ZRX', 'BTC', 'exmo', '0.01', '500000', 1, '8'),
(34097, 'ZRX', 'ETH', 'exmo', '0.01', '500000', 1, '8'),
(34098, 'GNT', 'BTC', 'exmo', '0.01', '500000', 1, '8'),
(34099, 'GNT', 'ETH', 'exmo', '0.01', '500000', 1, '8'),
(34103, 'GAS', 'BTC', 'exmo', '0.01', '200000', 1, '8'),
(34104, 'GAS', 'USD', 'exmo', '0.01', '200000', 1, '8'),
(34174, 'CRPT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34176, 'VET', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34177, 'SAL', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34178, 'OAX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34185, 'STORJ', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34186, 'UKG', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34187, 'FCT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34193, 'FLUZ', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34196, 'STORJ', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34197, 'DENT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34198, 'REP', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34200, 'SNIP', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34201, 'SPHTX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34202, 'GAT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34204, 'TPT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34205, 'VUU', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34206, 'FDX', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34207, 'ETC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34208, 'MTN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34209, 'ONG', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34210, 'IXT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34211, 'SER', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34214, 'FDX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34216, 'SER', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34217, 'GAT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34218, 'CAN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34219, 'DASH', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34221, 'ONG', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34223, 'FCT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34224, 'VET', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34227, 'FLIXX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34229, 'CAN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34230, 'MCO', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34231, 'IXT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34232, 'SER', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34233, 'DRG', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34234, 'SNIP', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34235, 'HAV', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34237, 'HERO', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34238, 'GET', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34240, 'GZE', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34241, 'TPT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34243, 'BMC', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34244, 'STU', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34245, 'LALA', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34246, 'UKG', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34248, 'LALA', 'QASH', 'quoinex', '0.001', '0.001', 0, '3'),
(34249, '1WO', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34250, 'GZE', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34251, 'ONG', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34252, 'EZT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34253, 'ENJ', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34254, 'XLM', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34255, 'MTN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34256, 'STAC', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34257, 'IXT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34258, 'RBLX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34259, 'IPSX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34260, 'RBLX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34261, 'PAL', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34262, 'TRX', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34263, 'PAL', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34264, 'FTT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34265, 'XES', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34266, 'TPT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34267, 'XNK', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34268, 'PAL', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34269, 'XNK', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34270, 'BTRN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34271, 'FSN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34272, 'ZCO', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34273, 'NEO', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34274, 'MITX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34275, 'FLUZ', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34276, 'FTX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34277, 'FTX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34278, 'FLUZ', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34280, 'SGN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34281, 'FTX', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34282, 'WCOIN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34283, 'WCOIN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34284, 'IND', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34285, 'PLC', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34286, 'KRL', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34287, 'SHP', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34288, 'IDH', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34289, 'IDH', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34290, 'VUU', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34291, 'ECH', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34292, 'VIO', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34293, 'XNK', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34294, 'SHP', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34295, 'VIO', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34297, 'UBT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34298, 'BRC', 'BCH', 'quoinex', '0.001', '0.001', 1, '3'),
(34299, 'DACS', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34300, 'UBT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34301, 'XEM', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34302, 'HAV', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34303, 'MRK', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34304, 'ZPR', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34305, 'BRC', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34306, 'FLP', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34307, 'UBT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34308, 'ALX', 'QASH', 'quoinex', '0.001', '0.001', 0, '3'),
(34310, 'HAV', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34311, 'FLP', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34312, 'BRC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34313, 'VZT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34314, 'FLP', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34315, 'CMCT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34316, 'ELY', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34322, 'VZT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34323, 'MCO', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34324, 'PWV', 'QASH', 'quoinex', '0.001', '0.001', 0, '3'),
(34325, 'CMCT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34326, 'MGO', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34327, 'KRL', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34328, 'ZCO', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34329, 'DENT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34330, 'SHP', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34331, 'RKT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34332, 'MTN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34333, 'ELY', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34334, 'AMLT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34335, 'ETN', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34336, 'EARTH', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34337, 'ADH', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34338, 'EARTH', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34339, 'DENT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34340, 'DRG', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34342, 'ADH', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34343, 'LDC', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34344, 'PWV', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34345, 'CRPT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34346, 'IDH', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34347, 'OAX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34348, 'HERO', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34349, 'LND', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34350, 'MRK', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34351, 'MRK', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34352, 'VIO', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34354, 'LTC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34357, 'RBLX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34358, 'ZEC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34359, 'BMC', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34360, 'LALA', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34364, 'RKT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34365, '1WO', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34366, 'XLM', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34367, 'TPAY', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34368, 'LIKE', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34369, 'CAN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34370, 'SPHTX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34373, 'XRP', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34374, 'PWV', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34375, 'HERO', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34376, 'ELY', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34377, 'WCOIN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34379, 'LDC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34381, 'THRT', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34382, 'NEO', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34383, 'ETN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34388, 'KRL', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34389, 'THRT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34390, 'ENJ', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34391, 'STX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34393, 'SNIP', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34394, 'TPAY', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34395, 'IPSX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34396, 'DRG', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34397, 'VZT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34399, 'QTUM', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34400, 'SPHTX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34401, 'ZPR', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34402, 'BTRN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34403, 'VUU', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34404, 'PLC', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34405, 'LIKE', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34406, 'UKG', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34407, 'GET', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34408, 'DACS', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34409, 'IND', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34411, 'FLIXX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34413, 'XES', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34414, 'ETN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34415, 'MGO', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34416, 'DACS', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34417, 'LIKE', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34418, 'BCH', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34419, 'STX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34420, 'EARTH', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34421, 'ZPR', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34422, 'MITX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34423, 'STU', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34424, 'QTUM', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34425, 'IPSX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34427, 'LND', 'QASH', 'quoinex', '0.001', '0.001', 1, '3'),
(34428, 'XMR', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34429, 'CRPT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34430, 'MITX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34431, 'ALX', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34432, 'STAC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34434, 'ECH', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34435, 'FDX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34436, 'TRX', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34437, 'FTT', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34438, 'ENJ', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34439, 'BTRN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34440, 'RKT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34442, 'EZT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34444, 'AMLT', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34445, 'TPAY', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34446, 'PLC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34447, 'GAT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34448, 'SGN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34449, 'ALX', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34450, 'MCO', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34451, 'BMC', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34452, 'CMCT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34453, 'GZE', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34454, 'FLIXX', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34455, 'ZCO', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34456, 'LDC', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34457, 'ECH', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34459, 'GET', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34460, '1WO', 'BTC', 'quoinex', '0.001', '0.001', 0, '3'),
(34463, 'FSN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34464, 'STU', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34465, 'LND', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34466, 'AMLT', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34467, 'SAL', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34468, 'SGN', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34469, 'STAC', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34470, 'MGO', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34471, 'SAL', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34472, 'FSN', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34473, 'FTT', 'ETH', 'quoinex', '0.001', '0.001', 0, '3'),
(34474, 'BRC', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34475, 'ADH', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34476, 'THRT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34477, 'XES', 'BTC', 'quoinex', '0.001', '0.001', 1, '3'),
(34478, 'EZT', 'ETH', 'quoinex', '0.001', '0.001', 1, '3'),
(34537, 'ZMN', 'ETH', 'livecoin', '23.8096', '100000000', 1, '8'),
(34554, 'WBCC', 'BTC', 'livecoin', '0.0257', '100000000', 1, '8'),
(34600, 'IMP', 'BTC', 'livecoin', '8.5366', '100000000', 1, '8'),
(34611, 'MASH', 'BTC', 'livecoin', '2.3386', '100000000', 1, '8'),
(34615, 'XCEL', 'BTC', 'livecoin', '14.7888', '100000000', 1, '8'),
(34649, 'XCEL', 'ETH', 'livecoin', '14.7888', '100000000', 1, '8'),
(34657, 'IMP', 'ETH', 'livecoin', '8.5366', '100000000', 1, '8'),
(34660, 'SLOPPS', 'BTC', 'livecoin', '256.0976', '100000000', 1, '8');
INSERT INTO `thirdparty_crypto_krypto` (`id_thirdparty_crypto`, `symbol_thirdparty_crypto`, `to_thirdparty_crypto`, `name_thirdparty_crypto`, `min_thirdparty_crypto`, `max_thirdparty_crypto`, `active_thirdparty_crypto`, `precision_amount_thirdparty_crypto`) VALUES
(34662, 'ZMN', 'BTC', 'livecoin', '23.8096', '100000000', 1, '8'),
(34698, 'GIFT', 'ETH', 'livecoin', '583.3334', '100000000', 1, '8'),
(34718, 'XSN', 'LTC', 'livecoin', '3.8182', '100000000', 1, '8'),
(34736, 'GIFT', 'BTC', 'livecoin', '583.3334', '100000000', 1, '8'),
(34856, 'SLOPPS', 'ETH', 'livecoin', '256.0976', '100000000', 1, '8'),
(34990, 'WBCC', 'ETH', 'livecoin', '0.0257', '100000000', 1, '8'),
(35002, 'XSN', 'ETH', 'livecoin', '3.8182', '100000000', 1, '8'),
(35018, 'SONIQ', 'BTC', 'livecoin', '15.2174', '100000000', 1, '8'),
(35049, 'MASH', 'ETH', 'livecoin', '2.3386', '100000000', 1, '8'),
(35120, 'SONIQ', 'ETH', 'livecoin', '15.2174', '100000000', 1, '8'),
(35126, 'XSN', 'BTC', 'livecoin', '3.8182', '100000000', 1, '8'),
(35157, 'CMT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(35158, 'CMT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(35159, 'CMT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(35160, 'CNN', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(35161, 'CNN', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(35162, 'CNN', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(35193, 'GNT', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(35194, 'GNT', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(35195, 'GNT', 'ETH', 'coinex', '1', '0.001', 1, '8'),
(35252, 'SEELE', 'USDT', 'coinex', '1', '0.001', 1, '8'),
(35284, 'WWB', 'BCH', 'coinex', '1', '0.001', 1, '8'),
(35285, 'WWB', 'BTC', 'coinex', '1', '0.001', 1, '8'),
(35380, 'USDT', 'USD', 'okcoinusd', '1', '0.001', 1, '8'),
(35382, 'LTC', 'BTC', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35383, 'ETH', 'BTC', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35384, 'ETC', 'BTC', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35385, 'BCH', 'BTC', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35386, 'USDT', 'BTC', 'okcoinusd', '1', '0.001', 1, '8'),
(35387, 'TUSD', 'BTC', 'okcoinusd', '1', '0.001', 1, '8'),
(35388, 'LTC', 'ETH', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35389, 'ETC', 'ETH', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35390, 'BCH', 'ETH', 'okcoinusd', '0.01', '0.001', 1, '8'),
(35391, 'USDT', 'ETH', 'okcoinusd', '1', '0.001', 1, '8'),
(35392, 'TUSD', 'ETH', 'okcoinusd', '1', '0.001', 1, '8');

CREATE TABLE `top_list_krypto` (
  `id_top_list` int(11) NOT NULL,
  `symbol_top_list` varchar(20) NOT NULL,
  `id_user` int(11) NOT NULL,
  `container_top_list` varchar(100) DEFAULT NULL,
  `control_key_top_list` varchar(50) DEFAULT NULL,
  `currency_top_list` varchar(50) NOT NULL,
  `market_top_list` varchar(50) NOT NULL DEFAULT 'CCCAGG'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_intro_krypto` (
  `id_user_intro` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_user_intro` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_krypto` (
  `id_user` int(11) NOT NULL,
  `email_user` varchar(60) NOT NULL,
  `name_user` varchar(30) NOT NULL,
  `password_user` text NOT NULL,
  `picture_user` text,
  `oauth_user` varchar(20) NOT NULL DEFAULT 'standard',
  `pushbullet_user` text,
  `twostep_user` tinyint(1) NOT NULL DEFAULT '0',
  `currency_user` varchar(10) NOT NULL DEFAULT 'USD',
  `admin_user` int(11) NOT NULL DEFAULT '0',
  `lang_user` varchar(10) DEFAULT 'EN',
  `created_date_user` varchar(12) NOT NULL,
  `reset_token_user` text,
  `status_user` int(11) NOT NULL DEFAULT '1',
  `current_market` varchar(50) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_login_history_krypto` (
  `id_user_login_history` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_user_login_history` varchar(12) NOT NULL,
  `ip_user_login_history` varchar(50) NOT NULL,
  `device_user_login_history` varchar(255) NOT NULL,
  `location_user_login_history` longtext NOT NULL,
  `country_code_user_login_history` varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_newspopup` (
  `id_newspopup` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `last_newspopup` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_room_chat_krypto` (
  `id_user_room_chat` int(11) NOT NULL,
  `id_room_chat` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_user_room_chat` varchar(12) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_settings_krypto` (
  `id_user_settings` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_user_settings` varchar(50) NOT NULL,
  `value_user_settings` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_status_krypto` (
  `id_user_status` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `last_update_user_status` varchar(12) NOT NULL,
  `type_user_status` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_thirdparty_selected_krypto` (
  `id_user_thirdparty_selected` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `name_user_thirdparty_selected` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `user_widthdraw_krypto` (
  `id_user_widthdraw` int(11) NOT NULL,
  `type_user_widthdraw` varchar(50) NOT NULL,
  `value_user_widthdraw` text NOT NULL,
  `date_user_widthdraw` varchar(15) NOT NULL,
  `id_user` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `visits_krypto` (
  `id_visits` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `time_visits` varchar(12) NOT NULL,
  `ip_visits` varchar(25) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `watching_krypto` (
  `id_watching` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `symbol` varchar(11) NOT NULL,
  `currency` varchar(50) NOT NULL DEFAULT 'USD',
  `market` varchar(50) NOT NULL DEFAULT 'CCCAGG'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `widthdraw_history_krypto` (
  `id_widthdraw_history` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `id_balance` int(11) NOT NULL,
  `amount_widthdraw_history` varchar(50) NOT NULL,
  `date_widthdraw_history` varchar(12) NOT NULL,
  `status_widthdraw_history` int(11) NOT NULL DEFAULT '0',
  `paypal_widthdraw_history` varchar(150) NOT NULL,
  `token_widthdraw_history` text NOT NULL,
  `description_widthdraw_history` varchar(150) NOT NULL,
  `symbol_widthdraw_history` varchar(50) NOT NULL DEFAULT 'USD',
  `method_widthdraw_history` int(11) NOT NULL DEFAULT '0',
  `fees_widthdraw_history` varchar(50) NOT NULL DEFAULT '0',
  `ref_widthdraw_history` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE `yobit_krypto` (
  `id_yobit` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `key_yobit` text NOT NULL,
  `secret_yobit` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `identity_step_krypto` (`id_identity_step`, `name_identity_step`, `type_identity_step`, `description_identity_step`, `order_identity_step`, `allow_cam_identity_step`, `document_ratio_identity_step`) VALUES
(1, 'Select your document', 'doclist', '', 1, 1, '1/1'),
(2, 'Identity verification', 'document', 'Recto', 2, 1, '2/3'),
(3, 'Identity verification', 'document', 'Verso', 3, 1, '3/1'),
(4, 'Domicialiation verification', 'document', 'Domiciliation verification', 4, 0, '1/1');

ALTER TABLE `additional_pages_krypto`
  ADD PRIMARY KEY (`id_additional_pages`);

ALTER TABLE `balance_krypto`
  ADD PRIMARY KEY (`id_balance`);

ALTER TABLE `banktransfert_accountavailable_krypto`
  ADD PRIMARY KEY (`id_banktransfert_accountavailable`);

ALTER TABLE `banktransfert_krypto`
  ADD PRIMARY KEY (`id_banktransfert`);

ALTER TABLE `banktransfert_proof_krypto`
  ADD PRIMARY KEY (`id_banktransfert_proof`);

ALTER TABLE `binance_krypto`
  ADD PRIMARY KEY (`id_binance`);

ALTER TABLE `bitbank_krypto`
  ADD PRIMARY KEY (`id_bitbank`);

ALTER TABLE `bitmex_krypto`
  ADD PRIMARY KEY (`id_bitmex`);

ALTER TABLE `bittrex_krypto`
  ADD PRIMARY KEY (`id_bittrex`);

ALTER TABLE `blocked_user_chat_krypto`
  ADD PRIMARY KEY (`id_blocked_user_chat`);

ALTER TABLE `blockfolio_krypto`
  ADD PRIMARY KEY (`id_blockfolio`);

ALTER TABLE `blockonomics_address_krypto`
  ADD PRIMARY KEY (`id_blockonomics_trs`);

ALTER TABLE `blockonomics_transactions_krypto`
  ADD PRIMARY KEY (`id_blockonomics_transactions`);

ALTER TABLE `btcmarket_krypto`
  ADD PRIMARY KEY (`id_btcmarket`);

ALTER TABLE `cache_krypto`
  ADD PRIMARY KEY (`id_cache`);

ALTER TABLE `cex_krypto`
  ADD PRIMARY KEY (`id_cex`);

ALTER TABLE `charges_krypto`
  ADD PRIMARY KEY (`id_charges`);

ALTER TABLE `coinex_krypto`
  ADD PRIMARY KEY (`id_coinex`);

ALTER TABLE `coinlist_krypto`
  ADD PRIMARY KEY (`id_coinlist`);

ALTER TABLE `coinspot_krypto`
  ADD PRIMARY KEY (`id_coinspot`);

ALTER TABLE `converter_krypto`
  ADD PRIMARY KEY (`id_converter`);

ALTER TABLE `country_krypto`
  ADD PRIMARY KEY (`id_country`);

ALTER TABLE `cron_krypto`
  ADD PRIMARY KEY (`id_cron`);

ALTER TABLE `currency_krypto`
  ADD PRIMARY KEY (`id_currency`);

ALTER TABLE `dashboard_krypto`
  ADD PRIMARY KEY (`id_dashboard`);

ALTER TABLE `deposit_history_krypto`
  ADD PRIMARY KEY (`id_deposit_history`);

ALTER TABLE `deposit_history_proof_krypto`
  ADD PRIMARY KEY (`id_deposit_history_proof`);

ALTER TABLE `ethfinex_krypto`
  ADD PRIMARY KEY (`id_ethfinex`);

ALTER TABLE `exchanges_krypto`
  ADD PRIMARY KEY (`id_exchanges`);
ALTER TABLE `exchanges_krypto` ADD FULLTEXT KEY `exchange` (`market_exchanges`);
ALTER TABLE `exchanges_krypto` ADD FULLTEXT KEY `symbol` (`symbol_exchanges`);
ALTER TABLE `exchanges_krypto` ADD FULLTEXT KEY `currency` (`currency_exchanges`);

ALTER TABLE `exmo_krypto`
  ADD PRIMARY KEY (`id_exmo`);

ALTER TABLE `gateio_krypto`
  ADD PRIMARY KEY (`id_gateio`);

ALTER TABLE `gdax_krypto`
  ADD PRIMARY KEY (`id_gdax`);

ALTER TABLE `gemini_krypto`
  ADD PRIMARY KEY (`id_gemini`);

ALTER TABLE `googletfs_krypto`
  ADD PRIMARY KEY (`id_googletfs`);

ALTER TABLE `graph_krypto`
  ADD PRIMARY KEY (`id_graph`),
  ADD KEY `id_graph` (`id_graph`);

ALTER TABLE `histo_krypto`
  ADD PRIMARY KEY (`id_histo`);

ALTER TABLE `hitbtc2_krypto`
  ADD PRIMARY KEY (`id_hitbtc2`);

ALTER TABLE `holding_krypto`
  ADD PRIMARY KEY (`id_holding`);

ALTER TABLE `identity_asset_krypto`
  ADD PRIMARY KEY (`id_identity_asset`);

ALTER TABLE `identity_doclist_krypto`
  ADD PRIMARY KEY (`id_identity_doclist`);

ALTER TABLE `identity_krypto`
  ADD PRIMARY KEY (`id_identity`);

ALTER TABLE `identity_step_krypto`
  ADD PRIMARY KEY (`id_identity_step`),
  ADD UNIQUE KEY `id_identity_step` (`id_identity_step`),
  ADD KEY `id_identity_step_2` (`id_identity_step`);

ALTER TABLE `indicators_krypto`
  ADD PRIMARY KEY (`id_indicators`);

ALTER TABLE `internal_order_krypto`
  ADD PRIMARY KEY (`id_internal_order`);

ALTER TABLE `kraken_krypto`
  ADD PRIMARY KEY (`id_kraken`);

ALTER TABLE `kucoin_krypto`
  ADD PRIMARY KEY (`id_kucoin`);

ALTER TABLE `leader_board_krypto`
  ADD PRIMARY KEY (`id_leader_board`);

ALTER TABLE `livecoin_krypto`
  ADD PRIMARY KEY (`id_livecoin`);

ALTER TABLE `luno_krypto`
  ADD PRIMARY KEY (`id_luno`);

ALTER TABLE `msg_room_chat_krypto`
  ADD PRIMARY KEY (`id_msg_room_chat`);

ALTER TABLE `notification_center_krypto`
  ADD PRIMARY KEY (`id_notification_center`);

ALTER TABLE `notification_krypto`
  ADD PRIMARY KEY (`id_notification`);

ALTER TABLE `okcoinusd_krypto`
  ADD PRIMARY KEY (`id_okcoinusd`);

ALTER TABLE `okex_krypto`
  ADD PRIMARY KEY (`id_okex`);

ALTER TABLE `order_krypto`
  ADD PRIMARY KEY (`id_order`);

ALTER TABLE `paygateway_krypto`
  ADD PRIMARY KEY (`id_paygateway`);

ALTER TABLE `plan_krypto`
  ADD PRIMARY KEY (`id_plan`);

ALTER TABLE `poloniex_krypto`
  ADD PRIMARY KEY (`id_poloniex`);

ALTER TABLE `quoinex_krypto`
  ADD PRIMARY KEY (`id_quoinex`);

ALTER TABLE `referal_histo_krypto`
  ADD PRIMARY KEY (`referal_histo_id`);

ALTER TABLE `referal_krypto`
  ADD PRIMARY KEY (`id_referal`);

ALTER TABLE `room_chat_krypto`
  ADD PRIMARY KEY (`id_room_chat`);

ALTER TABLE `rssfeed_krypto`
  ADD PRIMARY KEY (`id_rssfeed`);

ALTER TABLE `settings_krypto`
  ADD PRIMARY KEY (`id_settings`);

ALTER TABLE `social_krypto`
  ADD PRIMARY KEY (`id_social`);

ALTER TABLE `thirdparty_crypto_krypto`
  ADD PRIMARY KEY (`id_thirdparty_crypto`),
  ADD UNIQUE KEY `name_thirdparty_crypto` (`name_thirdparty_crypto`,`to_thirdparty_crypto`,`symbol_thirdparty_crypto`),
  ADD UNIQUE KEY `symbol_thirdparty_crypto` (`symbol_thirdparty_crypto`,`to_thirdparty_crypto`,`name_thirdparty_crypto`);

ALTER TABLE `top_list_krypto`
  ADD PRIMARY KEY (`id_top_list`);

ALTER TABLE `user_intro_krypto`
  ADD PRIMARY KEY (`id_user_intro`);

ALTER TABLE `user_krypto`
  ADD PRIMARY KEY (`id_user`);

ALTER TABLE `user_login_history_krypto`
  ADD PRIMARY KEY (`id_user_login_history`);

ALTER TABLE `user_newspopup`
  ADD PRIMARY KEY (`id_newspopup`);

ALTER TABLE `user_room_chat_krypto`
  ADD PRIMARY KEY (`id_user_room_chat`);

ALTER TABLE `user_settings_krypto`
  ADD PRIMARY KEY (`id_user_settings`);

ALTER TABLE `user_status_krypto`
  ADD PRIMARY KEY (`id_user_status`);

ALTER TABLE `user_thirdparty_selected_krypto`
  ADD PRIMARY KEY (`id_user_thirdparty_selected`);

ALTER TABLE `user_widthdraw_krypto`
  ADD PRIMARY KEY (`id_user_widthdraw`);

ALTER TABLE `visits_krypto`
  ADD PRIMARY KEY (`id_visits`);

ALTER TABLE `watching_krypto`
  ADD PRIMARY KEY (`id_watching`);

ALTER TABLE `widthdraw_history_krypto`
  ADD PRIMARY KEY (`id_widthdraw_history`);

ALTER TABLE `yobit_krypto`
  ADD PRIMARY KEY (`id_yobit`);


ALTER TABLE `additional_pages_krypto`
  MODIFY `id_additional_pages` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=12;

ALTER TABLE `balance_krypto`
  MODIFY `id_balance` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=223;

ALTER TABLE `banktransfert_accountavailable_krypto`
  MODIFY `id_banktransfert_accountavailable` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;

ALTER TABLE `banktransfert_krypto`
  MODIFY `id_banktransfert` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=40;

ALTER TABLE `banktransfert_proof_krypto`
  MODIFY `id_banktransfert_proof` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=18;

ALTER TABLE `binance_krypto`
  MODIFY `id_binance` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=9;

ALTER TABLE `bitbank_krypto`
  MODIFY `id_bitbank` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `bitmex_krypto`
  MODIFY `id_bitmex` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `bittrex_krypto`
  MODIFY `id_bittrex` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `blocked_user_chat_krypto`
  MODIFY `id_blocked_user_chat` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `blockfolio_krypto`
  MODIFY `id_blockfolio` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=435;

ALTER TABLE `blockonomics_address_krypto`
  MODIFY `id_blockonomics_trs` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=69;

ALTER TABLE `blockonomics_transactions_krypto`
  MODIFY `id_blockonomics_transactions` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;

ALTER TABLE `btcmarket_krypto`
  MODIFY `id_btcmarket` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `cache_krypto`
  MODIFY `id_cache` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=606;

ALTER TABLE `cex_krypto`
  MODIFY `id_cex` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `charges_krypto`
  MODIFY `id_charges` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;

ALTER TABLE `coinex_krypto`
  MODIFY `id_coinex` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `coinlist_krypto`
  MODIFY `id_coinlist` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3079;

ALTER TABLE `coinspot_krypto`
  MODIFY `id_coinspot` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `converter_krypto`
  MODIFY `id_converter` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `country_krypto`
  MODIFY `id_country` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=247;

ALTER TABLE `cron_krypto`
  MODIFY `id_cron` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;

ALTER TABLE `currency_krypto`
  MODIFY `id_currency` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=111;

ALTER TABLE `dashboard_krypto`
  MODIFY `id_dashboard` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3465;

ALTER TABLE `deposit_history_krypto`
  MODIFY `id_deposit_history` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=540;

ALTER TABLE `deposit_history_proof_krypto`
  MODIFY `id_deposit_history_proof` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=23;

ALTER TABLE `ethfinex_krypto`
  MODIFY `id_ethfinex` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `exchanges_krypto`
  MODIFY `id_exchanges` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=94473;

ALTER TABLE `exmo_krypto`
  MODIFY `id_exmo` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `gateio_krypto`
  MODIFY `id_gateio` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `gdax_krypto`
  MODIFY `id_gdax` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=20;

ALTER TABLE `gemini_krypto`
  MODIFY `id_gemini` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `googletfs_krypto`
  MODIFY `id_googletfs` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=725;

ALTER TABLE `graph_krypto`
  MODIFY `id_graph` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=14564;

ALTER TABLE `histo_krypto`
  MODIFY `id_histo` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4154;

ALTER TABLE `hitbtc2_krypto`
  MODIFY `id_hitbtc2` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `holding_krypto`
  MODIFY `id_holding` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `identity_asset_krypto`
  MODIFY `id_identity_asset` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=65;

ALTER TABLE `identity_doclist_krypto`
  MODIFY `id_identity_doclist` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

ALTER TABLE `identity_krypto`
  MODIFY `id_identity` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=83;

ALTER TABLE `identity_step_krypto`
  MODIFY `id_identity_step` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;

ALTER TABLE `indicators_krypto`
  MODIFY `id_indicators` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=77;

ALTER TABLE `internal_order_krypto`
  MODIFY `id_internal_order` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=215;

ALTER TABLE `kraken_krypto`
  MODIFY `id_kraken` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `kucoin_krypto`
  MODIFY `id_kucoin` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `leader_board_krypto`
  MODIFY `id_leader_board` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=331;

ALTER TABLE `livecoin_krypto`
  MODIFY `id_livecoin` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `luno_krypto`
  MODIFY `id_luno` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `msg_room_chat_krypto`
  MODIFY `id_msg_room_chat` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;

ALTER TABLE `notification_center_krypto`
  MODIFY `id_notification_center` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=90;

ALTER TABLE `notification_krypto`
  MODIFY `id_notification` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=11;

ALTER TABLE `okcoinusd_krypto`
  MODIFY `id_okcoinusd` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `okex_krypto`
  MODIFY `id_okex` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `order_krypto`
  MODIFY `id_order` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `paygateway_krypto`
  MODIFY `id_paygateway` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;

ALTER TABLE `plan_krypto`
  MODIFY `id_plan` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6;

ALTER TABLE `poloniex_krypto`
  MODIFY `id_poloniex` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `quoinex_krypto`
  MODIFY `id_quoinex` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `referal_histo_krypto`
  MODIFY `referal_histo_id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `referal_krypto`
  MODIFY `id_referal` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=119;

ALTER TABLE `room_chat_krypto`
  MODIFY `id_room_chat` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `rssfeed_krypto`
  MODIFY `id_rssfeed` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7;

ALTER TABLE `settings_krypto`
  MODIFY `id_settings` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=186;

ALTER TABLE `social_krypto`
  MODIFY `id_social` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=14;

ALTER TABLE `thirdparty_crypto_krypto`
  MODIFY `id_thirdparty_crypto` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=59093;

ALTER TABLE `top_list_krypto`
  MODIFY `id_top_list` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=12547;

ALTER TABLE `user_intro_krypto`
  MODIFY `id_user_intro` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=112;

ALTER TABLE `user_krypto`
  MODIFY `id_user` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6215;

ALTER TABLE `user_login_history_krypto`
  MODIFY `id_user_login_history` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=560;

ALTER TABLE `user_newspopup`
  MODIFY `id_newspopup` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=109;

ALTER TABLE `user_room_chat_krypto`
  MODIFY `id_user_room_chat` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;

ALTER TABLE `user_settings_krypto`
  MODIFY `id_user_settings` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=130;

ALTER TABLE `user_status_krypto`
  MODIFY `id_user_status` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=46;

ALTER TABLE `user_thirdparty_selected_krypto`
  MODIFY `id_user_thirdparty_selected` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=6;

ALTER TABLE `user_widthdraw_krypto`
  MODIFY `id_user_widthdraw` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=34;

ALTER TABLE `visits_krypto`
  MODIFY `id_visits` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4361;

ALTER TABLE `watching_krypto`
  MODIFY `id_watching` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=348;

ALTER TABLE `widthdraw_history_krypto`
  MODIFY `id_widthdraw_history` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=39;

ALTER TABLE `yobit_krypto`
  MODIFY `id_yobit` int(11) NOT NULL AUTO_INCREMENT;



COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
